/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/process","os","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/shellEnv","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(K){for(var e=[],k=0,t=K.length;k<t;k++)e[k]=te[K[k]];return e};define(te[99],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(t,L){if(!t)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=k}),define(te[48],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(R,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=k;class t{constructor(R,b,C){this.id=R,this.definition=b,this.description=C,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function L(A,R){const b=["codicon","codicon-"+A];return R&&b.push("codicon-modifier-"+R),b}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(E){if(E instanceof t)return["codicon","codicon-"+E.id];const f=R.exec(E.id);if(!f)return b(t.error);let[,p,d]=f;const h=["codicon","codicon-"+p];return d&&h.push("codicon-modifier-"+d.substr(1)),h}A.asClassNameArray=b;function C(E){return b(E).join(" ")}A.asClassName=C;function P(E){return"."+b(E).join(".")}A.asCSSSelector=P})(T=e.CSSIcon||(e.CSSIcon={}))}),define(te[68],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function t(P){const E=[];for(let f in P)k.call(P,f)&&E.push(P[f]);return E}e.values=t;function L(P,E){for(let f in P)if(k.call(P,f)&&E({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=L;function T(P,E){const f=Object.create(null);for(const p of P){const d=E(p);let h=f[d];h||(h=f[d]=[]),h.push(p)}return f}e.groupBy=T;function A(P){const E=Object.create(null);return P&&P.forEach((f,p)=>{E[p]=f}),E}e.fromMap=A;function R(P,E){const f=[],p=[];for(let d of P)E.has(d)||f.push(d);for(let d of E)P.has(d)||p.push(d);return{removed:f,added:p}}e.diffSets=R;function b(P,E){const f=[],p=[];for(let[d,h]of P)E.has(d)||f.push(h);for(let[d,h]of E)P.has(d)||p.push(h);return{removed:f,added:p}}e.diffMaps=b;class C{constructor(){this.map=new Map}add(E,f){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(f)}delete(E,f){const p=this.map.get(E);!p||(p.delete(f),p.size===0&&this.map.delete(E))}forEach(E,f){const p=this.map.get(E);!p||p.forEach(f)}}e.SetMap=C}),define(te[54],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(A){return(R,b,C)=>{let P=null,E=null;if(typeof C.value=="function"?(P="value",E=C.value):typeof C.get=="function"&&(P="get",E=C.get),!E)throw new Error("not supported");C[P]=A(E,b)}}e.createDecorator=k;function t(A,R,b){let C=null,P=null;if(typeof b.value=="function"?(C="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(C="get",P=b.get),!P)throw new Error("not supported");const E=`$memoize$${R}`;b[C]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[E]}}e.memoize=t;function L(A,R,b){return k((C,P)=>{const E=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...p){this[f]||(this[f]=b?b():void 0),clearTimeout(this[E]),R&&(this[f]=R(this[f],...p),p=[this[f]]),this[E]=setTimeout(()=>{C.apply(this,p),this[f]=b?b():void 0},A)}})}e.debounce=L;function T(A,R,b){return k((C,P)=>{const E=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...h){if(this[f]||(this[f]=b?b():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...h)),this[d])return;const v=this[p]+A;v<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[f]]),this[f]=b?b():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),C.apply(this,[this[f]]),this[f]=b?b():void 0},v-Date.now()))}})}e.throttle=T}),define(te[9],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(r=>{r(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}e.ErrorHandler=k,e.errorHandler=new k;function t(S){e.errorHandler.setUnexpectedErrorHandler(S)}e.setUnexpectedErrorHandler=t;function L(S){b(S)||e.errorHandler.onUnexpectedError(S)}e.onUnexpectedError=L;function T(S){b(S)||e.errorHandler.onUnexpectedExternalError(S)}e.onUnexpectedExternalError=T;function A(S){if(S instanceof Error){let{name:l,message:r}=S;const c=S.stacktrace||S.stack;return{$isError:!0,name:l,message:r,stack:c}}return S}e.transformErrorForSerialization=A;const R="Canceled";function b(S){return S instanceof C?!0:S instanceof Error&&S.name===R&&S.message===R}e.isCancellationError=b;class C extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=C;function P(){const S=new Error(R);return S.name=S.message,S}e.canceled=P;function E(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}e.illegalArgument=E;function f(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}e.illegalState=f;function p(S){return S?new Error(`readonly property '${S} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(S){const l=new Error(`${S} has been disposed`);return l.name="DISPOSED",l}e.disposed=d;function h(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}e.getErrorMessage=h;class v extends Error{constructor(l){super("NotImplemented");l&&(this.message=l)}}e.NotImplementedError=v;class m extends Error{constructor(l){super("NotSupported");l&&(this.message=l)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;class y extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=y}),define(te[16],ne([0,1,9]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(q,O=0){return q[q.length-(1+O)]}e.tail=t;function L(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=L;function T(q,O,U=(z,H)=>z===H){if(q===O)return!0;if(!q||!O||q.length!==O.length)return!1;for(let z=0,H=q.length;z<H;z++)if(!U(q[z],O[z]))return!1;return!0}e.equals=T;function A(q,O,U){let z=0,H=q.length-1;for(;z<=H;){const ie=(z+H)/2|0,se=U(q[ie],O);if(se<0)z=ie+1;else if(se>0)H=ie-1;else return ie}return-(z+1)}e.binarySearch=A;function R(q,O){let U=0,z=q.length;if(z===0)return 0;for(;U<z;){const H=Math.floor((U+z)/2);O(q[H])?z=H:U=H+1}return U}e.findFirstInSorted=R;function b(q,O,U){if(q=q|0,q>=O.length)throw new TypeError("invalid index");let z=O[Math.floor(O.length*Math.random())],H=[],ie=[],se=[];for(let ue of O){const he=U(ue,z);he<0?H.push(ue):he>0?ie.push(ue):se.push(ue)}return q<H.length?b(q,H,U):q<H.length+se.length?se[0]:b(q-(H.length+se.length),ie,U)}e.quickSelect=b;function C(q,O){const U=[];let z;for(const H of q.slice(0).sort(O))!z||O(z[0],H)!==0?(z=[H],U.push(z)):z.push(H);return U}e.groupBy=C;function P(q,O,U){const z=[];function H(ue,he,we){if(he===0&&we.length===0)return;const pe=z[z.length-1];pe&&pe.start+pe.deleteCount===ue?(pe.deleteCount+=he,pe.toInsert.push(...we)):z.push({start:ue,deleteCount:he,toInsert:we})}let ie=0,se=0;for(;;){if(ie===q.length){H(ie,0,O.slice(se));break}if(se===O.length){H(ie,q.length-ie,[]);break}const ue=q[ie],he=O[se],we=U(ue,he);we===0?(ie+=1,se+=1):we<0?(H(ie,1,[]),ie+=1):we>0&&(H(ie,0,[he]),se+=1)}return z}e.sortedDiff=P;function E(q,O,U){const z=P(q,O,U),H=[],ie=[];for(const se of z)H.push(...q.slice(se.start,se.start+se.deleteCount)),ie.push(...se.toInsert);return{removed:H,added:ie}}e.delta=E;function f(q,O,U){if(U===0)return[];const z=q.slice(0,U).sort(O);return d(q,O,z,U,q.length),z}e.top=f;function p(q,O,U,z,H){return U===0?Promise.resolve([]):new Promise((ie,se)=>{(async()=>{const ue=q.length,he=q.slice(0,U).sort(O);for(let we=U,pe=Math.min(U+z,ue);we<ue;we=pe,pe=Math.min(pe+z,ue)){if(we>U&&await new Promise(ge=>setTimeout(ge)),H&&H.isCancellationRequested)throw(0,k.canceled)();d(q,O,he,we,pe)}return he})().then(ie,se)})}e.topAsync=p;function d(q,O,U,z,H){for(const ie=U.length;z<H;z++){const se=q[z];if(O(se,U[ie-1])<0){U.pop();const ue=R(U,he=>O(se,he)<0);U.splice(ue,0,se)}}}function h(q){return q.filter(O=>!!O)}e.coalesce=h;function v(q){let O=0;for(let U=0;U<q.length;U++)q[U]&&(q[O]=q[U],O+=1);q.length=O}e.coalesceInPlace=v;function m(q,O,U){q.splice(U,0,q.splice(O,1)[0])}e.move=m;function w(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=w;function y(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=y;function S(q,O=U=>U){const U=new Set;return q.filter(z=>{const H=O(z);return U.has(H)?!1:(U.add(H),!0)})}e.distinct=S;function l(q){const O=new Set;return U=>{const z=q(U);return O.has(z)?!1:(O.add(z),!0)}}e.uniqueFilter=l;function r(q,O){const U=c(q,O);if(U!==-1)return q[U]}e.findLast=r;function c(q,O){for(let U=q.length-1;U>=0;U--){const z=q[U];if(O(z))return U}return-1}e.lastIndex=c;function i(q,O){return q.length>0?q[0]:O}e.firstOrDefault=i;function n(q,O,U=(z,H)=>z===H){let z=0;for(let H=0,ie=Math.min(q.length,O.length);H<ie&&U(q[H],O[H]);H++)z++;return z}e.commonPrefixLength=n;function o(q){return[].concat(...q)}e.flatten=o;function s(q,O){let U=typeof O=="number"?q:0;typeof O=="number"?U=q:(U=0,O=q);const z=[];if(U<=O)for(let H=U;H<O;H++)z.push(H);else for(let H=U;H>O;H--)z.push(H);return z}e.range=s;function a(q,O,U){return q.reduce((z,H)=>(z[O(H)]=U?U(H):H,z),Object.create(null))}e.index=a;function u(q,O){return q.push(O),()=>g(q,O)}e.insert=u;function g(q,O){const U=q.indexOf(O);if(U>-1)return q.splice(U,1),O}e.remove=g;function I(q,O,U){const z=q.slice(0,O),H=q.slice(O);return z.concat(U,H)}e.arrayInsert=I;function _(q,O){let U;if(typeof O=="number"){let z=O;U=()=>{const H=Math.sin(z++)*179426549;return H-Math.floor(H)}}else U=Math.random;for(let z=q.length-1;z>0;z-=1){const H=Math.floor(U()*(z+1)),ie=q[z];q[z]=q[H],q[H]=ie}}e.shuffle=_;function M(q,O){const U=q.indexOf(O);U>-1&&(q.splice(U,1),q.unshift(O))}e.pushToStart=M;function F(q,O){const U=q.indexOf(O);U>-1&&(q.splice(U,1),q.push(O))}e.pushToEnd=F;function D(q,O){return Array.isArray(q)?q.map(O):O(q)}e.mapArrayOrNot=D;function N(q){return Array.isArray(q)?q:[q]}e.asArray=N;function $(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=$;function B(q,O){for(const U of q){const z=O(U);if(z!==void 0)return z}}e.mapFind=B;function Z(q,O,U){const z=ee(q,O),H=q.length,ie=U.length;q.length=H+ie;for(let se=H-1;se>=z;se--)q[se+ie]=q[se];for(let se=0;se<ie;se++)q[se+z]=U[se]}e.insertInto=Z;function W(q,O,U,z){const H=ee(q,O),ie=q.splice(H,U);return Z(q,H,z),ie}e.splice=W;function ee(q,O){return O<0?Math.max(O+q.length,0):Math.min(O,q.length)}function x(q,O){return(U,z)=>O(q(U),q(z))}e.compareBy=x;const j=(q,O)=>q-O;e.numberComparator=j;function Y(q,O){if(q.length===0)return;let U=q[0];for(let z=1;z<q.length;z++){const H=q[z];O(H,U)>0&&(U=H)}return U}e.findMaxBy=Y;function V(q,O){if(q.length===0)return;let U=q[0];for(let z=1;z<q.length;z++){const H=q[z];O(H,U)>=0&&(U=H)}return U}e.findLastMaxBy=V;function J(q,O){return Y(q,(U,z)=>-O(U,z))}e.findMinBy=J;class Q{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let U=this.firstIdx;for(;U<this.items.length&&O(this.items[U]);)U++;const z=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,z}takeFromEndWhile(O){let U=this.lastIdx;for(;U>=0&&O(this.items[U]);)U--;const z=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,z}peek(){return this.items[this.firstIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}takeCount(O){const U=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,U}}e.ArrayQueue=Q}),define(te[69],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(t){const L=this;let T=!1,A;return function(){return T||(T=!0,A=t.apply(L,arguments)),A}}e.once=k}),define(te[55],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(t){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}t.is=L;const T=Object.freeze([]);function A(){return T}t.empty=A;function*R(l){yield l}t.single=R;function b(l){return l||T}t.from=b;function C(l){return!l||l[Symbol.iterator]().next().done===!0}t.isEmpty=C;function P(l){return l[Symbol.iterator]().next().value}t.first=P;function E(l,r){for(const c of l)if(r(c))return!0;return!1}t.some=E;function f(l,r){for(const c of l)if(r(c))return c}t.find=f;function*p(l,r){for(const c of l)r(c)&&(yield c)}t.filter=p;function*d(l,r){let c=0;for(const i of l)yield r(i,c++)}t.map=d;function*h(...l){for(const r of l)for(const c of r)yield c}t.concat=h;function*v(l){for(const r of l)for(const c of r)yield c}t.concatNested=v;function m(l,r,c){let i=c;for(const n of l)i=r(i,n);return i}t.reduce=m;function*w(l,r,c=l.length){for(r<0&&(r+=l.length),c<0?c+=l.length:c>l.length&&(c=l.length);r<c;r++)yield l[r]}t.slice=w;function y(l,r=Number.POSITIVE_INFINITY){const c=[];if(r===0)return[c,l];const i=l[Symbol.iterator]();for(let n=0;n<r;n++){const o=i.next();if(o.done)return[c,t.empty()];c.push(o.value)}return[c,{[Symbol.iterator](){return i}}]}t.consume=y;function S(l,r,c=(i,n)=>i===n){const i=l[Symbol.iterator](),n=r[Symbol.iterator]();for(;;){const o=i.next(),s=n.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!c(o.value,s.value))return!1}}t.equals=S})(k=e.Iterable||(e.Iterable={}))}),define(te[35],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(r,c=!1){let i=0,n=r.length,o="",s=0,a=16,u=0;function g($){let B=0,Z=0;for(;B<$;){const W=r.charCodeAt(i);if(W>=48&&W<=57)Z=Z*16+W-48;else if(W>=65&&W<=70)Z=Z*16+W-65+10;else if(W>=97&&W<=102)Z=Z*16+W-97+10;else break;i++,B++}return B<$&&(Z=-1),Z}function I($){i=$,o="",s=0,a=16,u=0}function _(){const $=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&C(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&C(r.charCodeAt(i)))for(i++;i<r.length&&C(r.charCodeAt(i));)i++;else return u=3,r.substring($,i);let B=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&C(r.charCodeAt(i))){for(i++;i<r.length&&C(r.charCodeAt(i));)i++;B=i}else u=3;return r.substring($,B)}function M(){let $="",B=i;for(;;){if(i>=n){$+=r.substring(B,i),u=2;break}const Z=r.charCodeAt(i);if(Z===34){$+=r.substring(B,i),i++;break}if(Z===92){if($+=r.substring(B,i),i++,i>=n){u=2;break}switch(r.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const ee=g(4);ee>=0?$+=String.fromCharCode(ee):u=4;break}default:u=5}B=i;continue}if(Z>=0&&Z<=31)if(b(Z)){$+=r.substring(B,i),u=2;break}else u=6;i++}return $}function F(){if(o="",u=0,s=i,i>=n)return s=n,a=17;let $=r.charCodeAt(i);if(R($)){do i++,o+=String.fromCharCode($),$=r.charCodeAt(i);while(R($));return a=15}if(b($))return i++,o+=String.fromCharCode($),$===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch($){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=M(),a=10;case 47:{const B=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<n&&!b(r.charCodeAt(i));)i++;return o=r.substring(B,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const Z=n-1;let W=!1;for(;i<Z;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,u=1),o=r.substring(B,i),a=13}return o+=String.fromCharCode($),i++,a=16}case 45:if(o+=String.fromCharCode($),i++,i===n||!C(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),a=11;default:for(;i<n&&D($);)i++,$=r.charCodeAt(i);if(s!==i){switch(o=r.substring(s,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode($),i++,a=16}}function D($){if(R($)||b($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let $;do $=F();while($>=12&&$<=15);return $}return{setPosition:I,getPosition:()=>i,scan:c?N:F,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>u}}e.createScanner=A;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function E(r,c){const i=[],n=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(g,I,_,M){s.value=g,s.offset=I,s.length=_,s.type=M,s.colonOffset=void 0,o=s}try{y(r,{onObjectBegin:(g,I)=>{if(c<=g)throw n;o=void 0,a=c>g,i.push("")},onObjectProperty:(g,I,_)=>{if(c<I||(u(g,I,_,"property"),i[i.length-1]=g,c<=I+_))throw n},onObjectEnd:(g,I)=>{if(c<=g)throw n;o=void 0,i.pop()},onArrayBegin:(g,I)=>{if(c<=g)throw n;o=void 0,i.push(0)},onArrayEnd:(g,I)=>{if(c<=g)throw n;o=void 0,i.pop()},onLiteralValue:(g,I,_)=>{if(c<I||(u(g,I,_,l(g)),c<=I+_))throw n},onSeparator:(g,I,_)=>{if(c<=I)throw n;if(g===":"&&o&&o.type==="property")o.colonOffset=I,a=!1,o=void 0;else if(g===","){const M=i[i.length-1];typeof M=="number"?i[i.length-1]=M+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(g){if(g!==n)throw g}return{path:i,previousNode:o,isAtPropertyKey:a,matches:g=>{let I=0;for(let _=0;I<g.length&&_<i.length;_++)if(g[I]===i[_]||g[I]==="*")I++;else if(g[I]!=="**")return!1;return I===g.length}}}e.getLocation=E;function f(r,c=[],i=T.DEFAULT){let n=null,o=[];const s=[];function a(g){Array.isArray(o)?o.push(g):n!==null&&(o[n]=g)}return y(r,{onObjectBegin:()=>{const g={};a(g),s.push(o),o=g,n=null},onObjectProperty:g=>{n=g},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const g=[];a(g),s.push(o),o=g,n=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:a,onError:(g,I,_)=>{c.push({error:g,offset:I,length:_})}},i),o[0]}e.parse=f;function p(r,c=[],i=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(g){n.type==="property"&&(n.length=g-n.offset,n=n.parent)}function s(g){return n.children.push(g),g}y(r,{onObjectBegin:g=>{n=s({type:"object",offset:g,length:-1,parent:n,children:[]})},onObjectProperty:(g,I,_)=>{n=s({type:"property",offset:I,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:g,offset:I,length:_,parent:n})},onObjectEnd:(g,I)=>{n.length=g+I-n.offset,n=n.parent,o(g+I)},onArrayBegin:(g,I)=>{n=s({type:"array",offset:g,length:-1,parent:n,children:[]})},onArrayEnd:(g,I)=>{n.length=g+I-n.offset,n=n.parent,o(g+I)},onLiteralValue:(g,I,_)=>{s({type:l(g),offset:I,length:_,parent:n,value:g}),o(I+_)},onSeparator:(g,I,_)=>{n.type==="property"&&(g===":"?n.colonOffset=I:g===","&&o(I))},onError:(g,I,_)=>{c.push({error:g,offset:I,length:_})}},i);const u=n.children[0];return u&&delete u.parent,u}e.parseTree=p;function d(r,c){if(!r)return;let i=r;for(let n of c)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=d;function h(r){if(!r.parent||!r.parent.children)return[];const c=h(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;c.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&c.push(i)}return c}e.getNodePath=h;function v(r){switch(r.type){case"array":return r.children.map(v);case"object":{const c=Object.create(null);for(let i of r.children){const n=i.children[1];n&&(c[i.children[0].value]=v(n))}return c}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=v;function m(r,c,i=!1){return c>=r.offset&&c<r.offset+r.length||i&&c===r.offset+r.length}e.contains=m;function w(r,c,i=!1){if(m(r,c,i)){const n=r.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=c;o++){const s=w(n[o],c,i);if(s)return s}return r}}e.findNodeAtOffset=w;function y(r,c,i=T.DEFAULT){const n=A(r,!1);function o(Q){return Q?()=>Q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(Q){return Q?q=>Q(q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=o(c.onObjectBegin),u=s(c.onObjectProperty),g=o(c.onObjectEnd),I=o(c.onArrayBegin),_=o(c.onArrayEnd),M=s(c.onLiteralValue),F=s(c.onSeparator),D=o(c.onComment),N=s(c.onError),$=i&&i.disallowComments,B=i&&i.allowTrailingComma;function Z(){for(;;){const Q=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:$||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Q){case 12:case 13:$?W(10):D();break;case 16:W(1);break;case 15:case 14:break;default:return Q}}}function W(Q,q=[],O=[]){if(N(Q),q.length+O.length>0){let U=n.getToken();for(;U!==17;){if(q.indexOf(U)!==-1){Z();break}else if(O.indexOf(U)!==-1)break;U=Z()}}}function ee(Q){const q=n.getTokenValue();return Q?M(q):u(q),Z(),!0}function x(){switch(n.getToken()){case 11:{let Q=0;try{Q=JSON.parse(n.getTokenValue()),typeof Q!="number"&&(W(2),Q=0)}catch{W(2)}M(Q);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return Z(),!0}function j(){return n.getToken()!==10?(W(3,[],[2,5]),!1):(ee(!1),n.getToken()===6?(F(":"),Z(),J()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Y(){a(),Z();let Q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Q||W(4,[],[]),F(","),Z(),n.getToken()===2&&B)break}else Q&&W(6,[],[]);j()||W(4,[],[2,5]),Q=!0}return g(),n.getToken()!==2?W(7,[2],[]):Z(),!0}function V(){I(),Z();let Q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Q||W(4,[],[]),F(","),Z(),n.getToken()===4&&B)break}else Q&&W(6,[],[]);J()||W(4,[],[4,5]),Q=!0}return _(),n.getToken()!==4?W(8,[4],[]):Z(),!0}function J(){switch(n.getToken()){case 3:return V();case 1:return Y();case 10:return ee(!0);default:return x()}}return Z(),n.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):J()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=y;function S(r,c){let i=A(r),n=[],o,s=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:s!==a&&n.push(r.substring(s,a)),c!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,c)),s=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=S;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[49],ne([0,1,35]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(C,P,E){let f,p,d,h,v;if(P){for(h=P.offset,v=h+P.length,d=h;d>0&&!b(C,d-1);)d--;let a=v;for(;a<C.length&&!b(C,a);)a++;p=C.substring(d,a),f=A(p,E)}else p=C,f=0,d=0,h=0,v=C.length;const m=R(E,C);let w=!1,y=0,S;E.insertSpaces?S=T(" ",E.tabSize||4):S="	";const l=(0,k.createScanner)(p,!1);let r=!1;function c(){return m+T(S,f+y)}function i(){let a=l.scan();for(w=!1;a===15||a===14;)w=w||a===14,a=l.scan();return r=a===16||l.getTokenError()!==0,a}const n=[];function o(a,u,g){!r&&u<v&&g>h&&C.substring(u,g)!==a&&n.push({offset:u,length:g-u,content:a})}let s=i();if(s!==17){const a=l.getTokenOffset()+d,u=T(S,f);o(u,d,a)}for(;s!==17;){let a=l.getTokenOffset()+l.getTokenLength()+d,u=i(),g="";for(;!w&&(u===12||u===13);){const _=l.getTokenOffset()+d;o(" ",a,_),a=l.getTokenOffset()+l.getTokenLength()+d,g=u===12?c():"",u=i()}if(u===2)s!==1&&(y--,g=c());else if(u===4)s!==3&&(y--,g=c());else{switch(s){case 3:case 1:y++,g=c();break;case 5:case 12:g=c();break;case 13:w?g=c():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(r=!0);break;case 16:r=!0;break}w&&(u===12||u===13)&&(g=c())}const I=l.getTokenOffset()+d;o(g,a,I),s=u}return n}e.format=t;function L(C,P){const E=JSON.stringify(C,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.toFormattedString=L;function T(C,P){let E="";for(let f=0;f<P;f++)E+=C;return E}function A(C,P){let E=0,f=0;const p=P.tabSize||4;for(;E<C.length;){const d=C.charAt(E);if(d===" ")f++;else if(d==="	")f+=p;else break;E++}return Math.floor(f/p)}function R(C,P){for(let E=0;E<P.length;E++){const f=P.charAt(E);if(f==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=R;function b(C,P){return`\r
`.indexOf(C.charAt(P))!==-1}e.isEOL=b}),define(te[70],ne([0,1,35,49]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(C,P,E){return T(C,P,void 0,E)}e.removeProperty=L;function T(C,P,E,f,p){const d=P.slice(),h=[],v=(0,k.parseTree)(C,h);let m,w;for(;d.length>0&&(w=d.pop(),m=(0,k.findNodeAtLocation)(v,d),m===void 0&&E!==void 0);)typeof w=="string"?E={[w]:E}:E=[E];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const y=(0,k.findNodeAtLocation)(m,[w]);if(y!==void 0)if(E===void 0){if(!y.parent)throw new Error("Malformed AST");const S=m.children.indexOf(y.parent);let l,r=y.parent.offset+y.parent.length;if(S>0){const c=m.children[S-1];l=c.offset+c.length}else l=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return A(C,{offset:l,length:r-l,content:""},f)}else return A(C,{offset:y.offset,length:y.length,content:JSON.stringify(E)},f);else{if(E===void 0)return[];const S=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,l=p?p(m.children.map(c=>c.children[0].value)):m.children.length;let r;if(l>0){const c=m.children[l-1];r={offset:c.offset+c.length,length:0,content:","+S}}else m.children.length===0?r={offset:m.offset+1,length:0,content:S}:r={offset:m.offset+1,length:0,content:S+","};return A(C,r,f)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(E!==void 0){const y=`${JSON.stringify(E)}`;let S;if(m.children.length===0||w===0)S={offset:m.offset+1,length:0,content:m.children.length===0?y:y+","};else{const l=w===-1||w>m.children.length?m.children.length:w,r=m.children[l-1];S={offset:r.offset+r.length,length:0,content:","+y}}return A(C,S,f)}else{const y=w,S=m.children[y];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===y){const r=m.children[y-1],c=r.offset+r.length,i=m.offset+m.length;l={offset:c,length:i-2-c,content:""}}else l={offset:S.offset,length:m.children[y+1].offset-S.offset,content:""};return A(C,l,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},f)}}e.setProperty=T;function A(C,P,E){let f=R(C,P),p=P.offset,d=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,t.isEOL)(f,p-1);)p--;for(;d<f.length&&!(0,t.isEOL)(f,d);)d++}const h=(0,t.format)(f,{offset:p,length:d-p},E);for(let m=h.length-1;m>=0;m--){const w=h[m];f=R(f,w),p=Math.min(p,w.offset),d=Math.max(d,w.offset+w.length),d+=w.content.length-w.length}const v=C.length-(f.length-d)-p;return[{offset:p,length:v,content:f.substring(p,d)}]}e.withFormatting=A;function R(C,P){return C.substring(0,P.offset)+P.content+C.substring(P.offset+P.length)}e.applyEdit=R;function b(C,P){let E=P.slice(0).sort((p,d)=>{const h=p.offset-d.offset;return h===0?p.length-d.length:h}),f=C.length;for(let p=E.length-1;p>=0;p--){let d=E[p];if(d.offset+d.length<=f)C=R(C,d);else throw new Error("Overlapping edit");f=d.offset}return C}e.applyEdits=b}),define(te[100],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new k(()=>L(this.getValue()))}}e.Lazy=k}),define(te[2],ne([0,1,69,55]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(o){T=o}if(e.setDisposableTracker=A,L){const o="__is_disposable_tracked__";A(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==w.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function R(o){return T?.trackDisposable(o),o}function b(o){T?.markAsDisposed(o)}function C(o,s){T?.setParent(o,s)}function P(o,s){if(!!T)for(const a of o)T.setParent(a,s)}function E(o){return T?.markAsSingleton(o),o}e.markAsSingleton=E;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=p;function d(o){if(t.Iterable.is(o)){let s=[];for(const a of o)if(a)try{a.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=d;function h(...o){const s=v(()=>d(o));return P(o,s),s}e.combinedDisposable=h;function v(o){const s=R({dispose:(0,k.once)(()=>{b(s),o()})});return s}e.toDisposable=v;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return C(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,R(this),C(this._store,this)}dispose(){b(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&C(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&C(s,null),s}}e.MutableDisposable=y;class S{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=S;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,b(this))},this}}e.SafeDisposable=l;class r{constructor(){this.references=new Map}acquire(s,...a){let u=this.references.get(s);u||(u={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,u));const{object:g}=u,I=(0,k.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(s,u.object),this.references.delete(s))});return u.counter++,{object:g,dispose:I}}}e.ReferenceCollection=r;class c{constructor(s){this.referenceCollection=s}async acquire(s,...a){const u=this.referenceCollection.acquire(s,...a);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(g){throw u.dispose(),g}}}e.AsyncReferenceCollection=c;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function n(o){const s=new m;try{o(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[101],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(T){this.element=T,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class t{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let T=this._first;for(;T!==k.Undefined;){const A=T.next;T.prev=k.Undefined,T.next=k.Undefined,T=A}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const R=new k(T);if(this._first===k.Undefined)this._first=R,this._last=R;else if(A){const C=this._last;this._last=R,R.prev=C,C.next=R}else{const C=this._first;this._first=R,R.next=C,C.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==k.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==k.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==k.Undefined&&T.next!==k.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===k.Undefined&&T.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):T.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):T.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==k.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),function(){function K(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(b){T.push(b,Date.now())}function R(){const b=[];for(let C=0;C<T.length;C+=2)b.push({name:T[C],startTime:T[C+1]});return b}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function k(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=k(t))}(),define(te[4],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let t=!1,L=!1,T=!1,A=!1,R=!1,b=!1,C=!1,P=!1,E=!1,f,p=k,d,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const m=typeof v?.versions?.electron=="string",w=m&&v?.type==="renderer";if(e.isElectronSandboxed=w&&v?.sandboxed,typeof navigator=="object"&&!w)h=navigator.userAgent,t=h.indexOf("Windows")>=0,L=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=h.indexOf("Linux")>=0,b=!0,f=navigator.language,p=f;else if(typeof v=="object"){t=v.platform==="win32",L=v.platform==="darwin",T=v.platform==="linux",A=T&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,C=m,E=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=k,p=k;const s=v.env.VSCODE_NLS_CONFIG;if(s)try{const a=JSON.parse(s),u=a.availableLanguages["*"];f=a.locale,p=u||k,d=a._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var y;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function S(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let l=0;L?l=1:t?l=3:T&&(l=2),e.isWindows=t,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=A,e.isNative=R,e.isElectron=C,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isCI=E,e.platform=l,e.userAgent=h,e.language=p;var r;(function(s){function a(){return e.language}s.value=a;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function g(){return e.language==="en"}s.isDefault=g})(r=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=d,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let g=0,I=s.length;g<I;g++){const _=s[g];if(_.id===u.data.vscodeScheduleAsyncWork){s.splice(g,1),_.callback();return}}});let a=0;return u=>{const g=++a;s.push({id:g,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return s=>setTimeout(s)})();var c;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||P?2:t?1:3;let i=!0,n=!1;function o(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[33],ne([0,1,4]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const L=k.globals.vscode.process;t={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[10],ne([0,1,33]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,L=97,T=90,A=122,R=46,b=47,C=92,P=58,E=63;class f extends Error{constructor(S,l,r){let c;typeof l=="string"&&l.indexOf("not ")===0?(c="must not be",l=l.replace(/^not /,"")):c="must be";const i=S.indexOf(".")!==-1?"property":"argument";let n=`The "${S}" ${i} ${c} of type ${l}`;n+=`. Received type ${typeof r}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function p(y,S){if(typeof y!="string")throw new f(S,"string",y)}function d(y){return y===b||y===C}function h(y){return y===b}function v(y){return y>=t&&y<=T||y>=L&&y<=A}function m(y,S,l,r){let c="",i=0,n=-1,o=0,s=0;for(let a=0;a<=y.length;++a){if(a<y.length)s=y.charCodeAt(a);else{if(r(s))break;s=b}if(r(s)){if(!(n===a-1||o===1))if(o===2){if(c.length<2||i!==2||c.charCodeAt(c.length-1)!==R||c.charCodeAt(c.length-2)!==R){if(c.length>2){const u=c.lastIndexOf(l);u===-1?(c="",i=0):(c=c.slice(0,u),i=c.length-1-c.lastIndexOf(l)),n=a,o=0;continue}else if(c.length!==0){c="",i=0,n=a,o=0;continue}}S&&(c+=c.length>0?`${l}..`:"..",i=2)}else c.length>0?c+=`${l}${y.slice(n+1,a)}`:c=y.slice(n+1,a),i=a-n-1;n=a,o=0}else s===R&&o!==-1?++o:o=-1}return c}function w(y,S){if(S===null||typeof S!="object")throw new f("pathObject","Object",S);const l=S.dir||S.root,r=S.base||`${S.name||""}${S.ext||""}`;return l?l===S.root?`${l}${r}`:`${l}${y}${r}`:r}e.win32={resolve(...y){let S="",l="",r=!1;for(let c=y.length-1;c>=-1;c--){let i;if(c>=0){if(i=y[c],p(i,"path"),i.length===0)continue}else S.length===0?i=k.cwd():(i=k.env[`=${S}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==S.toLowerCase()&&i.charCodeAt(2)===C)&&(i=`${S}\\`));const n=i.length;let o=0,s="",a=!1;const u=i.charCodeAt(0);if(n===1)d(u)&&(o=1,a=!0);else if(d(u))if(a=!0,d(i.charCodeAt(1))){let g=2,I=g;for(;g<n&&!d(i.charCodeAt(g));)g++;if(g<n&&g!==I){const _=i.slice(I,g);for(I=g;g<n&&d(i.charCodeAt(g));)g++;if(g<n&&g!==I){for(I=g;g<n&&!d(i.charCodeAt(g));)g++;(g===n||g!==I)&&(s=`\\\\${_}\\${i.slice(I,g)}`,o=g)}}}else o=1;else v(u)&&i.charCodeAt(1)===P&&(s=i.slice(0,2),o=2,n>2&&d(i.charCodeAt(2))&&(a=!0,o=3));if(s.length>0)if(S.length>0){if(s.toLowerCase()!==S.toLowerCase())continue}else S=s;if(r){if(S.length>0)break}else if(l=`${i.slice(o)}\\${l}`,r=a,a&&S.length>0)break}return l=m(l,!r,"\\",d),r?`${S}\\${l}`:`${S}${l}`||"."},normalize(y){p(y,"path");const S=y.length;if(S===0)return".";let l=0,r,c=!1;const i=y.charCodeAt(0);if(S===1)return h(i)?"\\":y;if(d(i))if(c=!0,d(y.charCodeAt(1))){let o=2,s=o;for(;o<S&&!d(y.charCodeAt(o));)o++;if(o<S&&o!==s){const a=y.slice(s,o);for(s=o;o<S&&d(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&!d(y.charCodeAt(o));)o++;if(o===S)return`\\\\${a}\\${y.slice(s)}\\`;o!==s&&(r=`\\\\${a}\\${y.slice(s,o)}`,l=o)}}}else l=1;else v(i)&&y.charCodeAt(1)===P&&(r=y.slice(0,2),l=2,S>2&&d(y.charCodeAt(2))&&(c=!0,l=3));let n=l<S?m(y.slice(l),!c,"\\",d):"";return n.length===0&&!c&&(n="."),n.length>0&&d(y.charCodeAt(S-1))&&(n+="\\"),r===void 0?c?`\\${n}`:n:c?`${r}\\${n}`:`${r}${n}`},isAbsolute(y){p(y,"path");const S=y.length;if(S===0)return!1;const l=y.charCodeAt(0);return d(l)||S>2&&v(l)&&y.charCodeAt(1)===P&&d(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let S,l;for(let i=0;i<y.length;++i){const n=y[i];p(n,"path"),n.length>0&&(S===void 0?S=l=n:S+=`\\${n}`)}if(S===void 0)return".";let r=!0,c=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++c;const i=l.length;i>1&&d(l.charCodeAt(1))&&(++c,i>2&&(d(l.charCodeAt(2))?++c:r=!1))}if(r){for(;c<S.length&&d(S.charCodeAt(c));)c++;c>=2&&(S=`\\${S.slice(c)}`)}return e.win32.normalize(S)},relative(y,S){if(p(y,"from"),p(S,"to"),y===S)return"";const l=e.win32.resolve(y),r=e.win32.resolve(S);if(l===r||(y=l.toLowerCase(),S=r.toLowerCase(),y===S))return"";let c=0;for(;c<y.length&&y.charCodeAt(c)===C;)c++;let i=y.length;for(;i-1>c&&y.charCodeAt(i-1)===C;)i--;const n=i-c;let o=0;for(;o<S.length&&S.charCodeAt(o)===C;)o++;let s=S.length;for(;s-1>o&&S.charCodeAt(s-1)===C;)s--;const a=s-o,u=n<a?n:a;let g=-1,I=0;for(;I<u;I++){const M=y.charCodeAt(c+I);if(M!==S.charCodeAt(o+I))break;M===C&&(g=I)}if(I!==u){if(g===-1)return r}else{if(a>u){if(S.charCodeAt(o+I)===C)return r.slice(o+I+1);if(I===2)return r.slice(o+I)}n>u&&(y.charCodeAt(c+I)===C?g=I:I===2&&(g=3)),g===-1&&(g=0)}let _="";for(I=c+g+1;I<=i;++I)(I===i||y.charCodeAt(I)===C)&&(_+=_.length===0?"..":"\\..");return o+=g,_.length>0?`${_}${r.slice(o,s)}`:(r.charCodeAt(o)===C&&++o,r.slice(o,s))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const S=e.win32.resolve(y);if(S.length<=2)return y;if(S.charCodeAt(0)===C){if(S.charCodeAt(1)===C){const l=S.charCodeAt(2);if(l!==E&&l!==R)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(v(S.charCodeAt(0))&&S.charCodeAt(1)===P&&S.charCodeAt(2)===C)return`\\\\?\\${S}`;return y},dirname(y){p(y,"path");const S=y.length;if(S===0)return".";let l=-1,r=0;const c=y.charCodeAt(0);if(S===1)return d(c)?y:".";if(d(c)){if(l=r=1,d(y.charCodeAt(1))){let o=2,s=o;for(;o<S&&!d(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&d(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&!d(y.charCodeAt(o));)o++;if(o===S)return y;o!==s&&(l=r=o+1)}}}}else v(c)&&y.charCodeAt(1)===P&&(l=S>2&&d(y.charCodeAt(2))?3:2,r=l);let i=-1,n=!0;for(let o=S-1;o>=r;--o)if(d(y.charCodeAt(o))){if(!n){i=o;break}}else n=!1;if(i===-1){if(l===-1)return".";i=l}return y.slice(0,i)},basename(y,S){S!==void 0&&p(S,"ext"),p(y,"path");let l=0,r=-1,c=!0,i;if(y.length>=2&&v(y.charCodeAt(0))&&y.charCodeAt(1)===P&&(l=2),S!==void 0&&S.length>0&&S.length<=y.length){if(S===y)return"";let n=S.length-1,o=-1;for(i=y.length-1;i>=l;--i){const s=y.charCodeAt(i);if(d(s)){if(!c){l=i+1;break}}else o===-1&&(c=!1,o=i+1),n>=0&&(s===S.charCodeAt(n)?--n==-1&&(r=i):(n=-1,r=o))}return l===r?r=o:r===-1&&(r=y.length),y.slice(l,r)}for(i=y.length-1;i>=l;--i)if(d(y.charCodeAt(i))){if(!c){l=i+1;break}}else r===-1&&(c=!1,r=i+1);return r===-1?"":y.slice(l,r)},extname(y){p(y,"path");let S=0,l=-1,r=0,c=-1,i=!0,n=0;y.length>=2&&y.charCodeAt(1)===P&&v(y.charCodeAt(0))&&(S=r=2);for(let o=y.length-1;o>=S;--o){const s=y.charCodeAt(o);if(d(s)){if(!i){r=o+1;break}continue}c===-1&&(i=!1,c=o+1),s===R?l===-1?l=o:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||c===-1||n===0||n===1&&l===c-1&&l===r+1?"":y.slice(l,c)},format:w.bind(null,"\\"),parse(y){p(y,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return S;const l=y.length;let r=0,c=y.charCodeAt(0);if(l===1)return d(c)?(S.root=S.dir=y,S):(S.base=S.name=y,S);if(d(c)){if(r=1,d(y.charCodeAt(1))){let g=2,I=g;for(;g<l&&!d(y.charCodeAt(g));)g++;if(g<l&&g!==I){for(I=g;g<l&&d(y.charCodeAt(g));)g++;if(g<l&&g!==I){for(I=g;g<l&&!d(y.charCodeAt(g));)g++;g===l?r=g:g!==I&&(r=g+1)}}}}else if(v(c)&&y.charCodeAt(1)===P){if(l<=2)return S.root=S.dir=y,S;if(r=2,d(y.charCodeAt(2))){if(l===3)return S.root=S.dir=y,S;r=3}}r>0&&(S.root=y.slice(0,r));let i=-1,n=r,o=-1,s=!0,a=y.length-1,u=0;for(;a>=r;--a){if(c=y.charCodeAt(a),d(c)){if(!s){n=a+1;break}continue}o===-1&&(s=!1,o=a+1),c===R?i===-1?i=a:u!==1&&(u=1):i!==-1&&(u=-1)}return o!==-1&&(i===-1||u===0||u===1&&i===o-1&&i===n+1?S.base=S.name=y.slice(n,o):(S.name=y.slice(n,i),S.base=y.slice(n,o),S.ext=y.slice(i,o))),n>0&&n!==r?S.dir=y.slice(0,n-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let S="",l=!1;for(let r=y.length-1;r>=-1&&!l;r--){const c=r>=0?y[r]:k.cwd();p(c,"path"),c.length!==0&&(S=`${c}/${S}`,l=c.charCodeAt(0)===b)}return S=m(S,!l,"/",h),l?`/${S}`:S.length>0?S:"."},normalize(y){if(p(y,"path"),y.length===0)return".";const S=y.charCodeAt(0)===b,l=y.charCodeAt(y.length-1)===b;return y=m(y,!S,"/",h),y.length===0?S?"/":l?"./":".":(l&&(y+="/"),S?`/${y}`:y)},isAbsolute(y){return p(y,"path"),y.length>0&&y.charCodeAt(0)===b},join(...y){if(y.length===0)return".";let S;for(let l=0;l<y.length;++l){const r=y[l];p(r,"path"),r.length>0&&(S===void 0?S=r:S+=`/${r}`)}return S===void 0?".":e.posix.normalize(S)},relative(y,S){if(p(y,"from"),p(S,"to"),y===S||(y=e.posix.resolve(y),S=e.posix.resolve(S),y===S))return"";const l=1,r=y.length,c=r-l,i=1,n=S.length-i,o=c<n?c:n;let s=-1,a=0;for(;a<o;a++){const g=y.charCodeAt(l+a);if(g!==S.charCodeAt(i+a))break;g===b&&(s=a)}if(a===o)if(n>o){if(S.charCodeAt(i+a)===b)return S.slice(i+a+1);if(a===0)return S.slice(i+a)}else c>o&&(y.charCodeAt(l+a)===b?s=a:a===0&&(s=0));let u="";for(a=l+s+1;a<=r;++a)(a===r||y.charCodeAt(a)===b)&&(u+=u.length===0?"..":"/..");return`${u}${S.slice(i+s)}`},toNamespacedPath(y){return y},dirname(y){if(p(y,"path"),y.length===0)return".";const S=y.charCodeAt(0)===b;let l=-1,r=!0;for(let c=y.length-1;c>=1;--c)if(y.charCodeAt(c)===b){if(!r){l=c;break}}else r=!1;return l===-1?S?"/":".":S&&l===1?"//":y.slice(0,l)},basename(y,S){S!==void 0&&p(S,"ext"),p(y,"path");let l=0,r=-1,c=!0,i;if(S!==void 0&&S.length>0&&S.length<=y.length){if(S===y)return"";let n=S.length-1,o=-1;for(i=y.length-1;i>=0;--i){const s=y.charCodeAt(i);if(s===b){if(!c){l=i+1;break}}else o===-1&&(c=!1,o=i+1),n>=0&&(s===S.charCodeAt(n)?--n==-1&&(r=i):(n=-1,r=o))}return l===r?r=o:r===-1&&(r=y.length),y.slice(l,r)}for(i=y.length-1;i>=0;--i)if(y.charCodeAt(i)===b){if(!c){l=i+1;break}}else r===-1&&(c=!1,r=i+1);return r===-1?"":y.slice(l,r)},extname(y){p(y,"path");let S=-1,l=0,r=-1,c=!0,i=0;for(let n=y.length-1;n>=0;--n){const o=y.charCodeAt(n);if(o===b){if(!c){l=n+1;break}continue}r===-1&&(c=!1,r=n+1),o===R?S===-1?S=n:i!==1&&(i=1):S!==-1&&(i=-1)}return S===-1||r===-1||i===0||i===1&&S===r-1&&S===l+1?"":y.slice(S,r)},format:w.bind(null,"/"),parse(y){p(y,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return S;const l=y.charCodeAt(0)===b;let r;l?(S.root="/",r=1):r=0;let c=-1,i=0,n=-1,o=!0,s=y.length-1,a=0;for(;s>=r;--s){const u=y.charCodeAt(s);if(u===b){if(!o){i=s+1;break}continue}n===-1&&(o=!1,n=s+1),u===R?c===-1?c=s:a!==1&&(a=1):c!==-1&&(a=-1)}if(n!==-1){const u=i===0&&l?1:i;c===-1||a===0||a===1&&c===n-1&&c===i+1?S.base=S.name=y.slice(u,n):(S.name=y.slice(u,c),S.base=y.slice(u,n),S.ext=y.slice(c,n))}return i>0?S.dir=y.slice(0,i-1):l&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1,10]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(E){E.text="text/plain",E.binary="application/octet-stream",E.unknown="application/unknown",E.markdown="text/markdown",E.latex="text/latex",E.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const f=(0,k.extname)(E),p=L[f.toLowerCase()];return p!==void 0?p:R(E)}e.getMediaOrTextMime=A;function R(E){const f=(0,k.extname)(E);return T[f.toLowerCase()]}e.getMediaMime=R;function b(E){for(const f in T)if(T[f]===E)return f}e.getExtensionForMimeType=b;const C=/^(.+)\/(.+?)(;.+)?$/;function P(E,f){const p=C.exec(E);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:f?void 0:E}e.normalizeMimeType=P}),define(te[103],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var t;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(T,...A){const R=A.reduce((P,E)=>(P[E]=!0,P),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(P=>!R[P]).forEach(P=>{for(let E=0;E<b.length;E++)if(P.search(b[E])!==-1){delete T[P];break}})}e.sanitizeProcessEnvironment=L}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var t in k)(typeof exports=="object"?exports:K)[t]=k[t]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function k(t){if(e[t])return e[t].exports;var L=e[t]={i:t,l:!1,exports:{}};return K[t].call(L.exports,L,L.exports,k),L.l=!0,L.exports}return k.m=K,k.c=e,k.d=function(t,L,T){k.o(t,L)||Object.defineProperty(t,L,{enumerable:!0,get:T})},k.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},k.t=function(t,L){if(1&L&&(t=k(t)),8&L||4&L&&typeof t=="object"&&t&&t.__esModule)return t;var T=Object.create(null);if(k.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:t}),2&L&&typeof t!="string")for(var A in t)k.d(T,A,function(R){return t[R]}.bind(null,A));return T},k.n=function(t){var L=t&&t.__esModule?function(){return t.default}:function(){return t};return k.d(L,"a",L),L},k.o=function(t,L){return Object.prototype.hasOwnProperty.call(t,L)},k.p="",k(k.s=0)}([function(K,e,k){(function(t){var L;e=K.exports=O,L=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],C=0,P=C++;b[P]="0|[1-9]\\d*";var E=C++;b[E]="[0-9]+";var f=C++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=C++;b[p]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var d=C++;b[d]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var h=C++;b[h]="(?:"+b[P]+"|"+b[f]+")";var v=C++;b[v]="(?:"+b[E]+"|"+b[f]+")";var m=C++;b[m]="(?:-("+b[h]+"(?:\\."+b[h]+")*))";var w=C++;b[w]="(?:-?("+b[v]+"(?:\\."+b[v]+")*))";var y=C++;b[y]="[0-9A-Za-z-]+";var S=C++;b[S]="(?:\\+("+b[y]+"(?:\\."+b[y]+")*))";var l=C++,r="v?"+b[p]+b[m]+"?"+b[S]+"?";b[l]="^"+r+"$";var c="[v=\\s]*"+b[d]+b[w]+"?"+b[S]+"?",i=C++;b[i]="^"+c+"$";var n=C++;b[n]="((?:<|>)?=?)";var o=C++;b[o]=b[E]+"|x|X|\\*";var s=C++;b[s]=b[P]+"|x|X|\\*";var a=C++;b[a]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[m]+")?"+b[S]+"?)?)?";var u=C++;b[u]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[w]+")?"+b[S]+"?)?)?";var g=C++;b[g]="^"+b[n]+"\\s*"+b[a]+"$";var I=C++;b[I]="^"+b[n]+"\\s*"+b[u]+"$";var _=C++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=C++;b[M]="(?:~>?)";var F=C++;b[F]="(\\s*)"+b[M]+"\\s+",R[F]=new RegExp(b[F],"g");var D=C++;b[D]="^"+b[M]+b[a]+"$";var N=C++;b[N]="^"+b[M]+b[u]+"$";var $=C++;b[$]="(?:\\^)";var B=C++;b[B]="(\\s*)"+b[$]+"\\s+",R[B]=new RegExp(b[B],"g");var Z=C++;b[Z]="^"+b[$]+b[a]+"$";var W=C++;b[W]="^"+b[$]+b[u]+"$";var ee=C++;b[ee]="^"+b[n]+"\\s*("+c+")$|^$";var x=C++;b[x]="^"+b[n]+"\\s*("+r+")$|^$";var j=C++;b[j]="(\\s*)"+b[n]+"\\s*("+c+"|"+b[a]+")",R[j]=new RegExp(b[j],"g");var Y=C++;b[Y]="^\\s*("+b[a]+")\\s+-\\s+("+b[a]+")\\s*$";var V=C++;b[V]="^\\s*("+b[u]+")\\s+-\\s+("+b[u]+")\\s*$";var J=C++;b[J]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)L(Q,b[Q]),R[Q]||(R[Q]=new RegExp(b[Q]));function q(re,ae){if(re instanceof O)return re;if(typeof re!="string"||re.length>T||!(ae?R[i]:R[l]).test(re))return null;try{return new O(re,ae)}catch{return null}}function O(re,ae){if(re instanceof O){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof O))return new O(re,ae);L("SemVer",re,ae),this.loose=ae;var le=re.trim().match(ae?R[i]:R[l]);if(!le)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var be=+ye;if(be>=0&&be<A)return be}return ye}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=q,e.valid=function(re,ae){var le=q(re,ae);return le?le.version:null},e.clean=function(re,ae){var le=q(re.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(re){return L("SemVer.compare",this.version,this.loose,re),re instanceof O||(re=new O(re,this.loose)),this.compareMain(re)||this.comparePre(re)},O.prototype.compareMain=function(re){return re instanceof O||(re=new O(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},O.prototype.comparePre=function(re){if(re instanceof O||(re=new O(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],ye=re.prerelease[ae];if(L("prerelease compare",ae,le,ye),le===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(le===void 0)return-1;if(le!==ye)return z(le,ye)}while(++ae)},O.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,le,ye){typeof le=="string"&&(ye=le,le=void 0);try{return new O(re,le).inc(ae,ye).version}catch{return null}},e.diff=function(re,ae){if(ue(re,ae))return null;var le=q(re),ye=q(ae);if(le.prerelease.length||ye.prerelease.length){for(var be in le)if((be==="major"||be==="minor"||be==="patch")&&le[be]!==ye[be])return"pre"+be;return"prerelease"}for(var be in le)if((be==="major"||be==="minor"||be==="patch")&&le[be]!==ye[be])return be},e.compareIdentifiers=z;var U=/^[0-9]+$/;function z(re,ae){var le=U.test(re),ye=U.test(ae);return le&&ye&&(re=+re,ae=+ae),le&&!ye?-1:ye&&!le?1:re<ae?-1:re>ae?1:0}function H(re,ae,le){return new O(re,le).compare(new O(ae,le))}function ie(re,ae,le){return H(re,ae,le)>0}function se(re,ae,le){return H(re,ae,le)<0}function ue(re,ae,le){return H(re,ae,le)===0}function he(re,ae,le){return H(re,ae,le)!==0}function we(re,ae,le){return H(re,ae,le)>=0}function pe(re,ae,le){return H(re,ae,le)<=0}function ge(re,ae,le,ye){var be;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof le=="object"&&(le=le.version),be=re===le;break;case"!==":typeof re=="object"&&(re=re.version),typeof le=="object"&&(le=le.version),be=re!==le;break;case"":case"=":case"==":be=ue(re,le,ye);break;case"!=":be=he(re,le,ye);break;case">":be=ie(re,le,ye);break;case">=":be=we(re,le,ye);break;case"<":be=se(re,le,ye);break;case"<=":be=pe(re,le,ye);break;default:throw new TypeError("Invalid operator: "+ae)}return be}function Ee(re,ae){if(re instanceof Ee){if(re.loose===ae)return re;re=re.value}if(!(this instanceof Ee))return new Ee(re,ae);L("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===Te?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new O(re,ae).major},e.minor=function(re,ae){return new O(re,ae).minor},e.patch=function(re,ae){return new O(re,ae).patch},e.compare=H,e.compareLoose=function(re,ae){return H(re,ae,!0)},e.rcompare=function(re,ae,le){return H(ae,re,le)},e.sort=function(re,ae){return re.sort(function(le,ye){return e.compare(le,ye,ae)})},e.rsort=function(re,ae){return re.sort(function(le,ye){return e.rcompare(le,ye,ae)})},e.gt=ie,e.lt=se,e.eq=ue,e.neq=he,e.gte=we,e.lte=pe,e.cmp=ge,e.Comparator=Ee;var Te={};function Ce(re,ae){if(re instanceof Ce)return re.loose===ae?re:new Ce(re.raw,ae);if(re instanceof Ee)return new Ce(re.value,ae);if(!(this instanceof Ce))return new Ce(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function De(re){return!re||re.toLowerCase()==="x"||re==="*"}function qe(re,ae,le,ye,be,Ue,Le,Oe,_e,X,oe,ce,fe){return((ae=De(le)?"":De(ye)?">="+le+".0.0":De(be)?">="+le+"."+ye+".0":">="+ae)+" "+(Oe=De(_e)?"":De(X)?"<"+(+_e+1)+".0.0":De(oe)?"<"+_e+"."+(+X+1)+".0":ce?"<="+_e+"."+X+"."+oe+"-"+ce:"<="+Oe)).trim()}function Je(re,ae){for(var le=0;le<re.length;le++)if(!re[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<re.length;le++)if(L(re[le].semver),re[le].semver!==Te&&re[le].semver.prerelease.length>0){var ye=re[le].semver;if(ye.major===ae.major&&ye.minor===ae.minor&&ye.patch===ae.patch)return!0}return!1}return!0}function He(re,ae,le){try{ae=new Ce(ae,le)}catch{return!1}return ae.test(re)}function je(re,ae,le,ye){var be,Ue,Le,Oe,_e;switch(re=new O(re,ye),ae=new Ce(ae,ye),le){case">":be=ie,Ue=pe,Le=se,Oe=">",_e=">=";break;case"<":be=se,Ue=we,Le=ie,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(re,ae,ye))return!1;for(var X=0;X<ae.set.length;++X){var oe=ae.set[X],ce=null,fe=null;if(oe.forEach(function(me){me.semver===Te&&(me=new Ee(">=0.0.0")),ce=ce||me,fe=fe||me,be(me.semver,ce.semver,ye)?ce=me:Le(me.semver,fe.semver,ye)&&(fe=me)}),ce.operator===Oe||ce.operator===_e||(!fe.operator||fe.operator===Oe)&&Ue(re,fe.semver)||fe.operator===_e&&Le(re,fe.semver))return!1}return!0}Ee.prototype.parse=function(re){var ae=this.loose?R[ee]:R[x],le=re.match(ae);if(!le)throw new TypeError("Invalid comparator: "+re);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new O(le[2],this.loose):this.semver=Te},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(re){return L("Comparator.test",re,this.loose),this.semver===Te||(typeof re=="string"&&(re=new O(re,this.loose)),ge(re,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(re,ae){if(!(re instanceof Ee))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Ce(re.value,ae),He(this.value,le,ae);if(re.operator==="")return le=new Ce(this.value,ae),He(re.semver,le,ae);var ye=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Ue=this.semver.version===re.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=ge(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=ge(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return ye||be||Ue&&Le||Oe||_e},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),L("range",re,ae);var le=ae?R[V]:R[Y];re=re.replace(le,qe),L("hyphen replace",re),re=re.replace(R[j],"$1$2$3"),L("comparator trim",re,R[j]),re=(re=(re=re.replace(R[F],"$1~")).replace(R[B],"$1^")).split(/\s+/).join(" ");var ye=ae?R[ee]:R[x],be=re.split(" ").map(function(Ue){return function(Le,Oe){return L("comp",Le),Le=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(ce,fe){L("caret",ce,fe);var me=fe?R[W]:R[Z];return ce.replace(me,function(ke,Se,Pe,Re,Ie){var Ae;return L("caret",ce,ke,Se,Pe,Re,Ie),De(Se)?Ae="":De(Pe)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":De(Re)?Ae=Se==="0"?">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+".0 <"+(+Se+1)+".0.0":Ie?(L("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Re+Ie+" <"+Se+"."+Pe+"."+(+Re+1):">="+Se+"."+Pe+"."+Re+Ie+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Re+Ie+" <"+(+Se+1)+".0.0"):(L("no pr"),Ae=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Re+" <"+Se+"."+Pe+"."+(+Re+1):">="+Se+"."+Pe+"."+Re+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Re+" <"+(+Se+1)+".0.0"),L("caret return",Ae),Ae})}(oe,X)}).join(" ")}(Le,Oe),L("caret",Le),Le=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(ce,fe){var me=fe?R[N]:R[D];return ce.replace(me,function(ke,Se,Pe,Re,Ie){var Ae;return L("tilde",ce,ke,Se,Pe,Re,Ie),De(Se)?Ae="":De(Pe)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":De(Re)?Ae=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":Ie?(L("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+Se+"."+Pe+"."+Re+Ie+" <"+Se+"."+(+Pe+1)+".0"):Ae=">="+Se+"."+Pe+"."+Re+" <"+Se+"."+(+Pe+1)+".0",L("tilde return",Ae),Ae})}(oe,X)}).join(" ")}(Le,Oe),L("tildes",Le),Le=function(_e,X){return L("replaceXRanges",_e,X),_e.split(/\s+/).map(function(oe){return function(ce,fe){ce=ce.trim();var me=fe?R[I]:R[g];return ce.replace(me,function(ke,Se,Pe,Re,Ie,Ae){L("xRange",ce,ke,Se,Pe,Re,Ie,Ae);var Fe=De(Pe),ze=Fe||De(Re),We=ze||De(Ie);return Se==="="&&We&&(Se=""),Fe?ke=Se===">"||Se==="<"?"<0.0.0":"*":Se&&We?(ze&&(Re=0),We&&(Ie=0),Se===">"?(Se=">=",ze?(Pe=+Pe+1,Re=0,Ie=0):We&&(Re=+Re+1,Ie=0)):Se==="<="&&(Se="<",ze?Pe=+Pe+1:Re=+Re+1),ke=Se+Pe+"."+Re+"."+Ie):ze?ke=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":We&&(ke=">="+Pe+"."+Re+".0 <"+Pe+"."+(+Re+1)+".0"),L("xRange return",ke),ke})}(oe,X)}).join(" ")}(Le,Oe),L("xrange",Le),Le=function(_e,X){return L("replaceStars",_e,X),_e.trim().replace(R[J],"")}(Le,Oe),L("stars",Le),Le}(Ue,ae)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ue){return!!Ue.match(ye)})),be=be.map(function(Ue){return new Ee(Ue,ae)})},Ce.prototype.intersects=function(re,ae){if(!(re instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(ye){return re.set.some(function(be){return be.every(function(Ue){return ye.intersects(Ue,ae)})})})})},e.toComparators=function(re,ae){return new Ce(re,ae).set.map(function(le){return le.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new O(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Je(this.set[ae],re))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(re,ae,le){var ye=null,be=null;try{var Ue=new Ce(ae,le)}catch{return null}return re.forEach(function(Le){Ue.test(Le)&&(ye&&be.compare(Le)!==-1||(be=new O(ye=Le,le)))}),ye},e.minSatisfying=function(re,ae,le){var ye=null,be=null;try{var Ue=new Ce(ae,le)}catch{return null}return re.forEach(function(Le){Ue.test(Le)&&(ye&&be.compare(Le)!==1||(be=new O(ye=Le,le)))}),ye},e.validRange=function(re,ae){try{return new Ce(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,le){return je(re,ae,"<",le)},e.gtr=function(re,ae,le){return je(re,ae,">",le)},e.outside=je,e.prerelease=function(re,ae){var le=q(re,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(re,ae,le){return re=new Ce(re,le),ae=new Ce(ae,le),re.intersects(ae)},e.coerce=function(re){if(re instanceof O)return re;if(typeof re!="string")return null;var ae=re.match(R[_]);return ae==null?null:q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,k(1))},function(K,e){var k,t,L=K.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(v){if(k===setTimeout)return setTimeout(v,0);if((k===T||!k)&&setTimeout)return k=setTimeout,setTimeout(v,0);try{return k(v,0)}catch{try{return k.call(null,v,0)}catch{return k.call(this,v,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:T}catch{k=T}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var b,C=[],P=!1,E=-1;function f(){P&&b&&(P=!1,b.length?C=b.concat(C):E=-1,C.length&&p())}function p(){if(!P){var v=R(f);P=!0;for(var m=C.length;m;){for(b=C,C=[];++E<m;)b&&b[E].run();E=-1,m=C.length}b=null,P=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(v)}}function d(v,m){this.fun=v,this.array=m}function h(){}L.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];C.push(new d(v,m)),C.length!==1||P||R(p)},d.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=h,L.addListener=h,L.once=h,L.off=h,L.removeListener=h,L.removeAllListeners=h,L.emit=h,L.prependListener=h,L.prependOnceListener=h,L.listeners=function(v){return[]},L.binding=function(v){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(v){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(te[104],ne([0,1]),function(K,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(R,b,C){this.level=R,this.key=b,this.value=C,this.forward=[]}}const L=void 0;class T{constructor(R,b=2**16){this.comparator=R,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new t(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,L,L)}has(R){return Boolean(T._search(this,R,this.comparator))}get(R){return T._search(this,R,this.comparator)?.value}set(R,b){return T._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=T._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let C=this._header.forward[0];for(;C;)R.call(b,C.value,C.key,this),C=C.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,C){let P=R._header;for(let E=R._level-1;E>=0;E--)for(;P.forward[E]&&C(P.forward[E].key,b)<0;)P=P.forward[E];if(P=P.forward[0],P&&C(P.key,b)===0)return P}static _insert(R,b,C,P){let E=[],f=R._header;for(let p=R._level-1;p>=0;p--){for(;f.forward[p]&&P(f.forward[p].key,b)<0;)f=f.forward[p];E[p]=f}if(f=f.forward[0],f&&P(f.key,b)===0)return f.value=C,!1;{let p=T._randomLevel(R);if(p>R._level){for(let d=R._level;d<p;d++)E[d]=R._header;R._level=p}f=new t(p,b,C);for(let d=0;d<p;d++)f.forward[d]=E[d].forward[d],E[d].forward[d]=f;return!0}}static _randomLevel(R,b=.5){let C=1;for(;Math.random()<b&&C<R._maxLevel;)C+=1;return C}static _delete(R,b,C){let P=[],E=R._header;for(let f=R._level-1;f>=0;f--){for(;E.forward[f]&&C(E.forward[f].key,b)<0;)E=E.forward[f];P[f]=E}if(E=E.forward[0],!E||C(E.key,b)!==0)return!1;for(let f=0;f<R._level&&P[f].forward[f]===E;f++)P[f].forward[f]=E.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=T}),define(te[105],ne([0,1,4]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=k.globals.performance&&typeof k.globals.performance.now=="function";class L{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=L}),define(te[3],ne([0,1,9,69,2,101,105]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let R=!1,b=!1;var C;(function(i){i.None=()=>L.Disposable.None;function n(V){if(b){const{onListenerDidAdd:J}=V,Q=d.create();let q=0;V.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),J?.()}}}function o(V){return(J,Q=null,q)=>{let O=!1,U;return U=V(z=>{if(!O)return U?U.dispose():O=!0,J.call(Q,z)},null,q),O&&U.dispose(),U}}i.once=o;function s(V,J,Q){return M((q,O=null,U)=>V(z=>q.call(O,J(z)),null,U),Q)}i.map=s;function a(V,J,Q){return M((q,O=null,U)=>V(z=>{J(z),q.call(O,z)},null,U),Q)}i.forEach=a;function u(V,J,Q){return M((q,O=null,U)=>V(z=>J(z)&&q.call(O,z),null,U),Q)}i.filter=u;function g(V){return V}i.signal=g;function I(...V){return(J,Q=null,q)=>(0,L.combinedDisposable)(...V.map(O=>O(U=>J.call(Q,U),null,q)))}i.any=I;function _(V,J,Q,q){let O=Q;return s(V,U=>(O=J(O,U),O),q)}i.reduce=_;function M(V,J){let Q;const q={onFirstListenerAdd(){Q=V(O.fire,O)},onLastListenerRemove(){Q.dispose()}};J||n(q);const O=new v(q);return J&&J.add(O),O.event}function F(V,J,Q=100,q=!1,O,U){let z,H,ie,se=0;const ue={leakWarningThreshold:O,onFirstListenerAdd(){z=V(we=>{se++,H=J(H,we),q&&!ie&&(he.fire(H),H=void 0),clearTimeout(ie),ie=setTimeout(()=>{const pe=H;H=void 0,ie=void 0,(!q||se>1)&&he.fire(pe),se=0},Q)})},onLastListenerRemove(){z.dispose()}};U||n(ue);const he=new v(ue);return U&&U.add(he),he.event}i.debounce=F;function D(V,J=(q,O)=>q===O,Q){let q=!0,O;return u(V,U=>{const z=q||!J(U,O);return q=!1,O=U,z},Q)}i.latch=D;function N(V,J,Q){return[i.filter(V,J,Q),i.filter(V,q=>!J(q),Q)]}i.split=N;function $(V,J=!1,Q=[]){let q=Q.slice(),O=V(H=>{q?q.push(H):z.fire(H)});const U=()=>{q&&q.forEach(H=>z.fire(H)),q=null},z=new v({onFirstListenerAdd(){O||(O=V(H=>z.fire(H)))},onFirstListenerDidAdd(){q&&(J?setTimeout(U):U())},onLastListenerRemove(){O&&O.dispose(),O=null}});return z.event}i.buffer=$;class B{constructor(J){this.event=J}map(J){return new B(s(this.event,J))}forEach(J){return new B(a(this.event,J))}filter(J){return new B(u(this.event,J))}reduce(J,Q){return new B(_(this.event,J,Q))}latch(){return new B(D(this.event))}debounce(J,Q=100,q=!1,O){return new B(F(this.event,J,Q,q,O))}on(J,Q,q){return this.event(J,Q,q)}once(J,Q,q){return o(this.event)(J,Q,q)}}function Z(V){return new B(V)}i.chain=Z;function W(V,J,Q=q=>q){const q=(...H)=>z.fire(Q(...H)),O=()=>V.on(J,q),U=()=>V.removeListener(J,q),z=new v({onFirstListenerAdd:O,onLastListenerRemove:U});return z.event}i.fromNodeEventEmitter=W;function ee(V,J,Q=q=>q){const q=(...H)=>z.fire(Q(...H)),O=()=>V.addEventListener(J,q),U=()=>V.removeEventListener(J,q),z=new v({onFirstListenerAdd:O,onLastListenerRemove:U});return z.event}i.fromDOMEventEmitter=ee;function x(V){return new Promise(J=>o(V)(J))}i.toPromise=x;function j(V,J){return J(void 0),V(Q=>J(Q))}i.runAndSubscribe=j;function Y(V,J){let Q=null;function q(U){Q?.dispose(),Q=new L.DisposableStore,J(U,Q)}q(void 0);const O=V(U=>q(U));return(0,L.toDisposable)(()=>{O.dispose(),Q?.dispose()})}i.runAndSubscribeWithStore=Y})(C=e.Event||(e.Event={}));class P{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${P._idPool++}`}start(n){this._stopWatch=new A.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}P._idPool=0;let E=-1;function f(i){const n=E;return E=i,{dispose(){E=n}}}e.setGlobalLeakWarningThreshold=f;class p{constructor(n,o=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,o){let s=E;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||o<s)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let u,g=0;for(const[I,_]of this._stacks)(!u||g<_)&&(u=I,g=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${g}):`),console.warn(u)}return()=>{const u=this._stacks.get(n.value)||0;this._stacks.set(n.value,u-1)}}}class d{constructor(n){this.value=n}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(n,o,s){this.callback=n,this.callbackThis=o,this.stack=s,this.subscription=new L.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class v{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=E>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(R){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const o of n)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,o,s)=>{this._listeners||(this._listeners=new T.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let u,g;this._leakageMon&&this._listeners.size>=30&&(g=d.create(),u=this._leakageMon.check(g,this._listeners.size+1)),R&&(g=g??d.create());const I=new h(n,o,g),_=this._listeners.push(I);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,o);const M=I.subscription.set(()=>{u&&u(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof L.DisposableStore?s.add(M):Array.isArray(s)&&s.push(M),M}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,n]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,s]=this._deliveryQueue.shift();try{o.invoke(s)}catch(a){(0,k.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class m extends v{async fireAsync(n,o,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,n]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[a,u]=this._asyncDeliveryQueue.shift(),g=[],I={...u,token:o,waitUntil:_=>{if(Object.isFrozen(g))throw new Error("waitUntil can NOT be called asynchronous");s&&(_=s(_,a.callback)),g.push(_)}};try{a.invoke(I)}catch(_){(0,k.onUnexpectedError)(_);continue}Object.freeze(g),await Promise.allSettled(g).then(_=>{for(const M of _)M.status==="rejected"&&(0,k.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=m;class w extends v{constructor(n){super(n);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=w;class y extends w{constructor(n){super(n);this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=y;class S extends v{constructor(n){super(n);this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=S;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const o={event:n,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const s=()=>{this.hasListeners&&this.unhook(o);const a=this.events.indexOf(o);this.events.splice(a,1)};return(0,L.toDisposable)((0,t.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(o=>this.emitter.fire(o))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class r{constructor(){this.buffers=[]}wrapEvent(n){return(o,s,a)=>n(u=>{const g=this.buffers[this.buffers.length-1];g?g.push(()=>o.call(s,u)):o.call(s,u)},void 0,a)}bufferEvents(n){const o=[];this.buffers.push(o);const s=n();return this.buffers.pop(),o.forEach(a=>a()),s}}e.EventBufferer=r;class c{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=L.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(te[25],ne([0,1,3]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(R,b){const C=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(C)}}});var L;(function(R){function b(C){return C===R.None||C===R.Cancelled||C instanceof T?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(te[106],ne([0,1,25]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new k.CancellationTokenSource,R=this.task(A.token);return this.result={promise:R,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=t;class L{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const R=JSON.stringify(A);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=L}),define(te[40],ne([0,1,9,2]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(y){const S=y;return S?[S.on,S.pause,S.resume,S.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=L;function T(y){const S=y;return S?L(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(y,S){return new R(y,S)}e.newWriteableStream=A;class R{constructor(S,l){this.reducer=S,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S!="undefined"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(l=>l(S))}emitError(S){this.listeners.error.length===0?(0,k.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(l=>l(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,l){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(S,l){if(this.state.destroyed)return;let r;switch(S){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const c=r.indexOf(l);c>=0&&r.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(y,S){const l=[];let r;for(;(r=y.read())!==null;)l.push(r);return S(l)}e.consumeReadable=b;function C(y,S,l){const r=[];let c;for(;(c=y.read())!==null&&r.length<l;)r.push(c);return c===null&&r.length>0?S(r):{read:()=>{if(r.length>0)return r.shift();if(typeof c!="undefined"){const i=c;return c=void 0,i}return y.read()}}}e.peekReadable=C;function P(y,S){return new Promise((l,r)=>{const c=[];E(y,{onData:i=>{S&&c.push(i)},onError:i=>{S?r(i):l(void 0)},onEnd:()=>{l(S?S(c):void 0)}})})}e.consumeStream=P;function E(y,S){let l=!1;return y.on("error",r=>{l||S.onError(r)}),y.on("end",()=>{l||S.onEnd()}),y.on("data",r=>{l||S.onData(r)}),(0,t.toDisposable)(()=>l=!0)}e.listenStream=E;function f(y,S){return new Promise((l,r)=>{const c=new t.DisposableStore,i=[],n=a=>{if(i.push(a),i.length>S)return c.dispose(),y.pause(),l({stream:y,buffer:i,ended:!1})},o=a=>r(a),s=()=>l({stream:y,buffer:i,ended:!0});c.add((0,t.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),c.add((0,t.toDisposable)(()=>y.removeListener("end",s))),y.on("end",s),c.add((0,t.toDisposable)(()=>y.removeListener("data",n))),y.on("data",n)})}e.peekStream=f;function p(y,S){const l=A(S);return l.end(y),l}e.toStream=p;function d(){const y=A(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=d;function h(y){let S=!1;return{read:()=>S?null:(S=!0,y)}}e.toReadable=h;function v(y,S,l){const r=A(l);return E(y,{onData:c=>r.write(S.data(c)),onError:c=>r.error(S.error?S.error(c):c),onEnd:()=>r.end()}),r}e.transform=v;function m(y,S,l){let r=!1;return{read:()=>{const c=S.read();return r?c:(r=!0,c!==null?l([y,c]):y)}}}e.prefixedReadable=m;function w(y,S,l){let r=!1;const c=A(l);return E(S,{onData:i=>r?c.write(i):(r=!0,c.write(l([y,i]))),onError:i=>c.error(i),onEnd:()=>{r||(r=!0,c.write(y)),c.end()}}),c}e.prefixedStream=w}),define(te[17],ne([0,1,40]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let L,T;class A{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return t?new A(Buffer.allocUnsafe(u)):new A(new Uint8Array(u))}static wrap(u){return t&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new A(u)}static fromString(u,g){return!(g?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(u)):(L||(L=new TextEncoder),new A(L.encode(u)))}static fromByteArray(u){const g=A.alloc(u.length);for(let I=0,_=u.length;I<_;I++)g.buffer[I]=u[I];return g}static concat(u,g){if(typeof g=="undefined"){g=0;for(let M=0,F=u.length;M<F;M++)g+=u[M].byteLength}const I=A.alloc(g);let _=0;for(let M=0,F=u.length;M<F;M++){const D=u[M];I.set(D,_),_+=D.byteLength}return I}clone(){const u=A.alloc(this.byteLength);return u.set(this),u}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(u,g){return new A(this.buffer.subarray(u,g))}set(u,g){if(u instanceof A)this.buffer.set(u.buffer,g);else if(u instanceof Uint8Array)this.buffer.set(u,g);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),g);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return C(this.buffer,u)}writeUInt32BE(u,g){P(this.buffer,u,g)}readUInt32LE(u){return E(this.buffer,u)}writeUInt32LE(u,g){f(this.buffer,u,g)}readUInt8(u){return p(this.buffer,u)}writeUInt8(u,g){d(this.buffer,u,g)}}e.VSBuffer=A;function R(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=R;function b(a,u,g){a[g+0]=u&255,u=u>>>8,a[g+1]=u&255}e.writeUInt16LE=b;function C(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=C;function P(a,u,g){a[g+3]=u,u=u>>>8,a[g+2]=u,u=u>>>8,a[g+1]=u,u=u>>>8,a[g]=u}e.writeUInt32BE=P;function E(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=E;function f(a,u,g){a[g+0]=u&255,u=u>>>8,a[g+1]=u&255,u=u>>>8,a[g+2]=u&255,u=u>>>8,a[g+3]=u&255}e.writeUInt32LE=f;function p(a,u){return a[u]}e.readUInt8=p;function d(a,u,g){a[g]=u}e.writeUInt8=d;function h(a){return k.consumeReadable(a,u=>A.concat(u))}e.readableToBuffer=h;function v(a){return k.toReadable(a)}e.bufferToReadable=v;function m(a){return k.consumeStream(a,u=>A.concat(u))}e.streamToBuffer=m;async function w(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await m(a.stream)])}e.bufferedStreamToBuffer=w;function y(a){return k.toStream(a,u=>A.concat(u))}e.bufferToStream=y;function S(a){return k.transform(a,{data:u=>typeof u=="string"?A.fromString(u):A.wrap(u)},u=>A.concat(u))}e.streamToBufferReadableStream=S;function l(a){return k.newWriteableStream(u=>A.concat(u),a)}e.newWriteableBufferStream=l;function r(a,u){return k.prefixedReadable(a,u,g=>A.concat(g))}e.prefixedBufferReadable=r;function c(a,u){return k.prefixedStream(a,u,g=>A.concat(g))}e.prefixedBufferStream=c;function i(a){let u=0,g=0,I=0;const _=new Uint8Array(Math.floor(a.length/4*3)),M=D=>{switch(g){case 3:_[I++]=u|D,g=0;break;case 2:_[I++]=u|D>>>2,u=D<<6,g=3;break;case 1:_[I++]=u|D>>>4,u=D<<4,g=2;break;default:u=D<<2,g=1}};for(let D=0;D<a.length;D++){const N=a.charCodeAt(D);if(N>=65&&N<=90)M(N-65);else if(N>=97&&N<=122)M(N-97+26);else if(N>=48&&N<=57)M(N-48+52);else if(N===43||N===45)M(62);else if(N===47||N===95)M(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[D]}`)}}const F=I;for(;g>0;)M(0);return A.wrap(_).slice(0,F)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},u=!0,g=!1){const I=g?o:n;let _="";const M=a.byteLength%3;let F=0;for(;F<a.byteLength-M;F+=3){const D=a[F+0],N=a[F+1],$=a[F+2];_+=I[D>>>2],_+=I[(D<<4|N>>>4)&63],_+=I[(N<<2|$>>>6)&63],_+=I[$&63]}if(M===1){const D=a[F+0];_+=I[D>>>2],_+=I[D<<4&63],u&&(_+="==")}else if(M===2){const D=a[F+0],N=a[F+1];_+=I[D>>>2],_+=I[(D<<4|N>>>4)&63],_+=I[N<<2&63],u&&(_+="=")}return _}e.encodeBase64=s}),define(te[26],ne([0,1,106,100]),function(K,e,k,t){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function R(X,...oe){return oe.length===0?X:X.replace(A,function(ce,fe){const me=parseInt(fe,10);return isNaN(me)||me<0||me>=oe.length?ce:oe[me]})}e.format=R;const b=/{([^}]+)}/g;function C(X,oe){return X.replace(b,(ce,fe)=>oe[fe]??ce)}e.format2=C;function P(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function E(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function f(X,oe){let ce=0;const fe=oe.charCodeAt(0);for(let me=X.length-1;me>=0;me--)X.charCodeAt(me)===fe&&ce++;return ce}e.count=f;function p(X,oe,ce="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${ce}`}e.truncate=p;function d(X,oe=" "){const ce=h(X,oe);return v(ce,oe)}e.trim=d;function h(X,oe){if(!X||!oe)return X;const ce=oe.length;if(ce===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+ce;return X.substring(fe)}e.ltrim=h;function v(X,oe){if(!X||!oe)return X;const ce=oe.length,fe=X.length;if(ce===0||fe===0)return X;let me=fe,ke=-1;for(;ke=X.lastIndexOf(oe,me-1),!(ke===-1||ke+ce!==me);){if(ke===0)return"";me=ke}return X.substring(0,me)}e.rtrim=v;function m(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function w(X){return X.replace(/\*/g,"")}e.stripWildcards=w;function y(X,oe,ce={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=E(X)),ce.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return ce.global&&(fe+="g"),ce.matchCase||(fe+="i"),ce.multiline&&(fe+="m"),ce.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=y;function S(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function l(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=r;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function i(X){for(let oe=0,ce=X.length;oe<ce;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function n(X,oe=0,ce=X.length){for(let fe=oe;fe<ce;fe++){const me=X.charCodeAt(fe);if(me!==32&&me!==9)return X.substring(oe,fe)}return X.substring(oe,ce)}e.getLeadingWhitespace=n;function o(X,oe=X.length-1){for(let ce=oe;ce>=0;ce--){const fe=X.charCodeAt(ce);if(fe!==32&&fe!==9)return ce}return-1}e.lastNonWhitespaceIndex=o;function s(X,oe){return X<oe?-1:X>oe?1:0}e.compare=s;function a(X,oe,ce=0,fe=X.length,me=0,ke=oe.length){for(;ce<fe&&me<ke;ce++,me++){let Re=X.charCodeAt(ce),Ie=oe.charCodeAt(me);if(Re<Ie)return-1;if(Re>Ie)return 1}const Se=fe-ce,Pe=ke-me;return Se<Pe?-1:Se>Pe?1:0}e.compareSubstring=a;function u(X,oe){return g(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=u;function g(X,oe,ce=0,fe=X.length,me=0,ke=oe.length){for(;ce<fe&&me<ke;ce++,me++){let Re=X.charCodeAt(ce),Ie=oe.charCodeAt(me);if(Re===Ie)continue;if(Re>=128||Ie>=128)return a(X.toLowerCase(),oe.toLowerCase(),ce,fe,me,ke);I(Re)&&(Re-=32),I(Ie)&&(Ie-=32);const Ae=Re-Ie;if(Ae!==0)return Ae}const Se=fe-ce,Pe=ke-me;return Se<Pe?-1:Se>Pe?1:0}e.compareSubstringIgnoreCase=g;function I(X){return X>=97&&X<=122}e.isLowerAsciiLetter=I;function _(X){return X>=65&&X<=90}e.isUpperAsciiLetter=_;function M(X,oe){return X.length===oe.length&&g(X,oe)===0}e.equalsIgnoreCase=M;function F(X,oe){const ce=oe.length;return oe.length>X.length?!1:g(X,oe,0,ce)===0}e.startsWithIgnoreCase=F;function D(X,oe){let ce,fe=Math.min(X.length,oe.length);for(ce=0;ce<fe;ce++)if(X.charCodeAt(ce)!==oe.charCodeAt(ce))return ce;return fe}e.commonPrefixLength=D;function N(X,oe){let ce,fe=Math.min(X.length,oe.length);const me=X.length-1,ke=oe.length-1;for(ce=0;ce<fe;ce++)if(X.charCodeAt(me-ce)!==oe.charCodeAt(ke-ce))return ce;return fe}e.commonSuffixLength=N;function $(X){return 55296<=X&&X<=56319}e.isHighSurrogate=$;function B(X){return 56320<=X&&X<=57343}e.isLowSurrogate=B;function Z(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=Z;function W(X,oe,ce){const fe=X.charCodeAt(ce);if($(fe)&&ce+1<oe){const me=X.charCodeAt(ce+1);if(B(me))return Z(fe,me)}return fe}e.getNextCodePoint=W;function ee(X,oe){const ce=X.charCodeAt(oe-1);if(B(ce)&&oe>1){const fe=X.charCodeAt(oe-2);if($(fe))return Z(fe,ce)}return ce}class x{constructor(oe,ce=0){this._str=oe,this._len=oe.length,this._offset=ce}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=ee(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=W(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class j{constructor(oe,ce=0){this._iterator=new x(oe,ce)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),ce=this._iterator,fe=ce.offset;let me=oe.getGraphemeBreakType(ce.nextCodePoint());for(;!ce.eol();){const ke=ce.offset,Se=oe.getGraphemeBreakType(ce.nextCodePoint());if(je(me,Se)){ce.setOffset(ke);break}me=Se}return ce.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),ce=this._iterator,fe=ce.offset;let me=oe.getGraphemeBreakType(ce.prevCodePoint());for(;ce.offset>0;){const ke=ce.offset,Se=oe.getGraphemeBreakType(ce.prevCodePoint());if(je(Se,me)){ce.setOffset(ke);break}me=Se}return fe-ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function Y(X,oe){return new j(X,oe).nextGraphemeLength()}e.nextCharLength=Y;function V(X,oe){return new j(X,oe).prevGraphemeLength()}e.prevCharLength=V;function J(X,oe){oe>0&&B(X.charCodeAt(oe))&&oe--;const ce=oe+Y(X,oe);return[ce-V(X,ce),ce]}e.getCharContainingOffset=J;const Q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function q(X){return Q.test(X)}e.containsRTL=q;const O=/^[\t\n\r\x20-\x7E]*$/;function U(X){return O.test(X)}e.isBasicASCII=U,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=z;function H(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=H;function ie(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=ie;function se(X,oe){if(X.length<oe)return X;const ce=/\b/g;let fe=0;for(;ce.test(X)&&!(X.length-ce.lastIndex<oe);)fe=ce.lastIndex,ce.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ue=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function pe(X){return X&&(X=X.replace(ue,""),X=X.replace(he,""),X=X.replace(we,"")),X}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function Ee(X){return ge(X)?X.substr(1):X}e.stripUTF8BOM=Ee;function Te(X,oe){if(!X||!oe||X.length<oe.length)return!1;const ce=oe.length,fe=X.toLowerCase();let me=0,ke=-1;for(;me<ce;){const Se=fe.indexOf(oe[me],ke+1);if(Se<0)return!1;ke=Se,me++}return!0}e.fuzzyContains=Te;function Ce(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ce;function De(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=De;function qe(X,oe=1){if(oe===0)return"";let ce=-1;do ce=X.indexOf(`
`,ce+1),oe--;while(oe>0&&ce>=0);return ce===-1?X:(X[ce-1]==="\r"&&ce--,X.substr(0,ce))}e.getNLines=qe;function Je(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Je;function He(X){return ae.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=He;function je(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}var re;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=le()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ce=this._data,fe=ce.length/3;let me=1;for(;me<=fe;)if(oe<ce[3*me])me=2*me;else if(oe>ce[3*me+1])me=2*me+1;else return ce[3*me+2];return 0}}ae._INSTANCE=null;function le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ye(X,oe){if(X===0)return 0;const ce=be(X,oe);if(ce!==void 0)return ce;const fe=new x(oe,X);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=ye;function be(X,oe){const ce=new x(oe,X);let fe=ce.prevCodePoint();for(;Ue(fe)||fe===65039||fe===8419;){if(ce.offset===0)return;fe=ce.prevCodePoint()}if(!ie(fe))return;let me=ce.offset;return me>0&&ce.prevCodePoint()===8205&&(me=ce.offset),me}function Ue(X){return 127995<=X&&X<=127999}var Le;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new k.LRUCachedComputed(X=>{function oe(Ie){const Ae=new Map;for(let Fe=0;Fe<Ie.length;Fe+=2)Ae.set(Ie[Fe],Ie[Fe+1]);return Ae}function ce(Ie,Ae){const Fe=new Map(Ie);for(const[ze,We]of Ae)Fe.set(ze,We);return Fe}function fe(Ie,Ae){if(!Ie)return Ae;const Fe=new Map;for(const[ze,We]of Ie)Ae.has(ze)&&Fe.set(ze,We);return Fe}const me=L.ambiguousCharacterData.getValue();let ke=X.filter(Ie=>!Ie.startsWith("_")&&Ie in me);ke.length===0&&(ke=["_default"]);let Se;for(const Ie of ke){const Ae=oe(me[Ie]);Se=fe(Se,Ae)}const Pe=oe(me._common),Re=ce(Pe,Se);return new Oe(Re)}),Oe._locales=new t.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(te[71],ne([0,1,26]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return L(m,0)}e.hash=t;function L(m,w){switch(typeof m){case"object":return m===null?T(349,w):Array.isArray(m)?b(m,w):C(m,w);case"string":return R(m,w);case"boolean":return A(m,w);case"number":return T(m,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=L;function T(m,w){return(w<<5)-w+m|0}e.numberHash=T;function A(m,w){return T(m?433:863,w)}function R(m,w){w=T(149417,w);for(let y=0,S=m.length;y<S;y++)w=T(m.charCodeAt(y),w);return w}e.stringHash=R;function b(m,w){return w=T(104579,w),m.reduce((y,S)=>L(S,y),w)}function C(m,w){return w=T(181387,w),Object.keys(m).sort().reduce((y,S)=>(y=R(S,y),L(m[S],y)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=P;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function f(m,w,y=32){const S=y-w,l=~((1<<S)-1);return(m<<w|(l&m)>>>S)>>>0}function p(m,w=0,y=m.byteLength,S=0){for(let l=0;l<y;l++)m[w+l]=S}function d(m,w,y="0"){for(;m.length<w;)m=y+m;return m}function h(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(y=>y.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),w/4)}e.toHexString=h;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const y=w.length;if(y===0)return;const S=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,c,i;for(r!==0?(c=r,i=-1,r=0):(c=w.charCodeAt(0),i=0);;){let n=c;if(k.isHighSurrogate(c))if(i+1<y){const o=w.charCodeAt(i+1);k.isLowSurrogate(o)?(i++,n=k.computeCodePoint(c,o)):n=65533}else{r=c;break}else k.isLowSurrogate(c)&&(n=65533);if(l=this._push(S,l,n),i++,i<y)c=w.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,y,S){return S<128?w[y++]=S:S<2048?(w[y++]=192|(S&1984)>>>6,w[y++]=128|(S&63)>>>0):S<65536?(w[y++]=224|(S&61440)>>>12,w[y++]=128|(S&4032)>>>6,w[y++]=128|(S&63)>>>0):(w[y++]=240|(S&1835008)>>>18,w[y++]=128|(S&258048)>>>12,w[y++]=128|(S&4032)>>>6,w[y++]=128|(S&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,y=this._buffDV;for(let a=0;a<64;a+=4)w.setUint32(a,y.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,f(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let S=this._h0,l=this._h1,r=this._h2,c=this._h3,i=this._h4,n,o,s;for(let a=0;a<80;a++)a<20?(n=l&r|~l&c,o=1518500249):a<40?(n=l^r^c,o=1859775393):a<60?(n=l&r|l&c|r&c,o=2400959708):(n=l^r^c,o=3395469782),s=f(S,5)+n+i+o+w.getUint32(a*4,!1)&4294967295,i=c,c=r,r=f(l,30),l=S,S=s;this._h0=this._h0+S&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(K,e,k,t,L){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?L.call(K,k):L?L.value=k:e.set(K,k),k},Ve=this&&this.__classPrivateFieldGet||function(K,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!t:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(K):t?t.value:e.get(K)};define(te[39],ne([0,1,16,26]),function(K,e,k,t){"use strict";var L,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,n,o){let s=i.get(n);return s===void 0&&(s=o,i.set(n,s)),s}e.getOrSet=R;function b(i){const n=[];return i.forEach((o,s)=>{n.push(`${s} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=b;function C(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=C;class P{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=P;class E{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class f{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(p||(p={}));class d{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(v||(v={}));class m{constructor(n){this._iter=n}static forUris(n=()=>!1){return new m(new d(n))}static forPaths(n=!1){return new m(new f(void 0,!n))}static forStrings(){return new m(new P)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(n,o){if(o){const s=o.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a,n)}else{const s=n.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a[0],a[1])}}set(n,o){const s=this._iter.reset(n);let a;this._root||(this._root=new h,this._root.segment=s.value());const u=[];for(a=this._root;;){const I=s.cmp(a.segment);if(I>0)a.left||(a.left=new h,a.left.segment=s.value()),u.push([-1,a]),a=a.left;else if(I<0)a.right||(a.right=new h,a.right.segment=s.value()),u.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new h,a.mid.segment=s.value()),u.push([0,a]),a=a.mid;else break}const g=a.value;a.value=o,a.key=n;for(let I=u.length-1;I>=0;I--){const _=u[I][1];_.updateHeight();const M=_.balanceFactor();if(M<-1||M>1){const F=u[I][0],D=u[I+1][0];if(F===1&&D===1)u[I][1]=_.rotateLeft();else if(F===-1&&D===-1)u[I][1]=_.rotateRight();else if(F===1&&D===-1)_.right=u[I+1][1]=u[I+1][1].rotateRight(),u[I][1]=_.rotateLeft();else if(F===-1&&D===1)_.left=u[I+1][1]=u[I+1][1].rotateLeft(),u[I][1]=_.rotateRight();else throw new Error;if(I>0)switch(u[I-1][0]){case-1:u[I-1][1].left=u[I][1];break;case 1:u[I-1][1].right=u[I][1];break;case 0:u[I-1][1].mid=u[I][1];break}else this._root=u[0][1]}}return g}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const s=this._iter.reset(n),a=[];let u=this._root;for(;u;){const g=s.cmp(u.segment);if(g>0)a.push([-1,u]),u=u.left;else if(g<0)a.push([1,u]),u=u.right;else if(s.hasNext())s.next(),a.push([0,u]),u=u.mid;else break}if(!!u){if(o?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this._min(u.right),{key:I,value:_,segment:M}=g;this._delete(g.key,!1),u.key=I,u.value=_,u.segment=M}else{const g=u.left??u.right;if(a.length>0){const[I,_]=a[a.length-1];switch(I){case-1:_.left=g;break;case 0:_.mid=g;break;case 1:_.right=g;break}}else this._root=g}for(let g=a.length-1;g>=0;g--){const I=a[g][1];I.updateHeight();const _=I.balanceFactor();if(_>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),a[g][1]=I.rotateLeft()):_<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),a[g][1]=I.rotateRight()),g>0)switch(a[g-1][0]){case-1:a[g-1][1].left=a[g][1];break;case 1:a[g-1][1].right=a[g][1];break;case 0:a[g-1][1].mid=a[g][1];break}else this._root=a[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let s=this._root,a;for(;s;){const u=o.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(o.hasNext())o.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(n){const o=this._iter.reset(n);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[o,s]of this)n(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=m;class w{constructor(n,o){this.uri=n,this.value=o}}class y{constructor(n,o){this[L]="ResourceMap",n instanceof y?(this.map=new Map(n.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=n??y.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new w(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[s,a]of this.map)n(a.value,a.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=y,y.defaultToKey=i=>i.toString();var S;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const s=this._map.get(n);if(!!s)return o!==0&&this.touch(s,o),s.value}set(n,o,s=0){let a=this._map.get(n);if(a)a.value=o,s!==0&&this.touch(a,s);else{switch(a={key:n,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const s=this._state;let a=this._head;for(;a;){if(o?n.bind(o)(a.value,a.key,this):n(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.key,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}values(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.value,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}entries(){const n=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:[s.key,s.value],done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>n;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,s=n.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const s=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const s=n.next,a=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,s)=>{n.push([s,o])}),n}fromJSON(n){this.clear();for(const[o,s]of n)this.set(o,s)}}e.LinkedMap=l;class r extends l{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class c{constructor(n){A.set(this,void 0),It(this,A,n,"f")}get size(){return Ve(this,A,"f").size}forEach(n,o){Ve(this,A,"f").forEach(n,o)}get(n){return Ve(this,A,"f").get(n)}has(n){return Ve(this,A,"f").has(n)}entries(){return Ve(this,A,"f").entries()}keys(){return Ve(this,A,"f").keys()}values(){return Ve(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Ve(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(te[72],ne([0,1,39]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new k.LRUCache(1e4);function L(C){return b(C,"NFC",t)}e.normalizeNFC=L;const T=new k.LRUCache(1e4);function A(C){return b(C,"NFD",T)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function b(C,P,E){if(!C)return C;const f=E.get(C);if(f)return f;let p;return R.test(C)?p=C.normalize(P):p=C,E.set(C,p),p}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(P){return A(P).replace(C,"")}}()}),define(te[11],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(s){return Array.isArray(s)}e.isArray=k;function t(s){return typeof s=="string"}e.isString=t;function L(s){return Array.isArray(s)&&s.every(a=>t(a))}e.isStringArray=L;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function R(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=R;function b(s){return s===!0||s===!1}e.isBoolean=b;function C(s){return typeof s=="undefined"}e.isUndefined=C;function P(s){return!E(s)}e.isDefined=P;function E(s){return C(s)||s===null}e.isUndefinedOrNull=E;function f(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=f;function p(s){if(E(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=p;function d(...s){const a=[];for(let u=0;u<s.length;u++){const g=s[u];if(E(g))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);a.push(g)}return a}e.assertAllDefined=d;const h=Object.prototype.hasOwnProperty;function v(s){if(!T(s))return!1;for(let a in s)if(h.call(s,a))return!1;return!0}e.isEmptyObject=v;function m(s){return typeof s=="function"}e.isFunction=m;function w(...s){return s.length>0&&s.every(m)}e.areFunctions=w;function y(s,a){const u=Math.min(s.length,a.length);for(let g=0;g<u;g++)S(s[g],a[g])}e.validateConstraints=y;function S(s,a){if(t(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(m(a)){try{if(s instanceof a)return}catch{}if(!E(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function l(s){let a=[],u=Object.getPrototypeOf(s);for(;Object.prototype!==u;)a=a.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return a}e.getAllPropertyNames=l;function r(s){const a=[];for(const u of l(s))typeof s[u]=="function"&&a.push(u);return a}e.getAllMethodNames=r;function c(s,a){const u=I=>function(){const _=Array.prototype.slice.call(arguments,0);return a(I,_)};let g={};for(const I of s)g[I]=u(I);return g}e.createProxyObject=c;function i(s){return s===null?void 0:s}e.withNullAsUndefined=i;function n(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=n;function o(s,a="Unreachable"){throw new Error(a)}e.assertNever=o}),define(te[41],ne([0,1,10,4,26,11]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function R(o){return o.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function b(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function C(o,s=k.posix.sep){if(!o)return"";const a=o.length,u=o.charCodeAt(0);if(A(u)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let I=3;const _=I;for(;I<a&&!A(o.charCodeAt(I));I++);if(_!==I&&!A(o.charCodeAt(I+1))){for(I+=1;I<a;I++)if(A(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,s)}}return s}else if(m(u)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let g=o.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(A(o.charCodeAt(g)))return o.slice(0,g+1)}return""}e.getRoot=C;function P(o){if(!t.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let a=2;const u=a;for(;a<o.length&&(s=o.charCodeAt(a),s!==92);a++);return!(u===a||(s=o.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=P;const E=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,s=t.isWindows){const a=s?E:f;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||s&&p.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function h(o,s,a){const u=o===s;return!a||u?u:!o||!s?!1:(0,L.equalsIgnoreCase)(o,s)}e.isEqual=h;function v(o,s,a,u=k.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(a){if(!(0,L.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let I=s.length;return s.charAt(s.length-1)===u&&I--,o.charAt(I)===u}return s.charAt(s.length-1)!==u&&(s+=u),o.indexOf(s)===0}e.isEqualOrParent=v;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function w(o,s){return t.isWindows&&o.endsWith(":")&&(o+=k.sep),(0,k.isAbsolute)(o)||(o=(0,k.join)(s,o)),o=(0,k.normalize)(o),t.isWindows?(o=(0,L.rtrim)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,L.rtrim)(o,k.sep),o||(o=k.sep)),o}e.sanitizeFilePath=w;function y(o){const s=(0,k.normalize)(o);return t.isWindows?o.length>3?!1:S(s)&&(o.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=y;function S(o,s){return(s!==void 0?s:t.isWindows)?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function l(o){return S(o)?o[0]:void 0}e.getDriveLetter=l;function r(o,s,a){return s.length>o.length?-1:o===s?0:(a&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=r;function c(o){const s=o.split(":");let a,u,g;for(const I of s){const _=Number(I);(0,T.isNumber)(_)?u===void 0?u=_:g===void 0&&(g=_):a=a?[a,I].join(":"):I}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:g!==void 0?g:u!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,s,a=8){let u="";for(let I=0;I<a;I++)u+=i.charAt(Math.floor(Math.random()*i.length));let g;return s?g=`${s}-${u}`:g=u,o?(0,k.join)(o,g):g}e.randomPath=n}),define(te[28],ne([0,1,11]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.keys(h).forEach(m=>{h[m]&&typeof h[m]=="object"?v[m]=t(h[m]):v[m]=h[m]}),v}e.deepClone=t;function L(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const w in m)if(T.call(m,w)){const y=m[w];typeof y=="object"&&!Object.isFrozen(y)&&v.push(y)}}return h}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(h,v){return R(h,v,new Set)}e.cloneAndChange=A;function R(h,v,m){if((0,k.isUndefinedOrNull)(h))return h;const w=v(h);if(typeof w!="undefined")return w;if((0,k.isArray)(h)){const y=[];for(const S of h)y.push(R(S,v,m));return y}if((0,k.isObject)(h)){if(m.has(h))throw new Error("Cannot clone recursive data-structure");m.add(h);const y={};for(let S in h)T.call(h,S)&&(y[S]=R(h[S],v,m));return m.delete(h),y}return h}function b(h,v,m=!0){return(0,k.isObject)(h)?((0,k.isObject)(v)&&Object.keys(v).forEach(w=>{w in h?m&&((0,k.isObject)(h[w])&&(0,k.isObject)(v[w])?b(h[w],v[w],m):h[w]=v[w]):h[w]=v[w]}),h):v}e.mixin=b;function C(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let m,w;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(m=0;m<h.length;m++)if(!C(h[m],v[m]))return!1}else{const y=[];for(w in h)y.push(w);y.sort();const S=[];for(w in v)S.push(w);if(S.sort(),!C(y,S))return!1;for(m=0;m<y.length;m++)if(!C(h[y[m]],v[y[m]]))return!1}return!0}e.equals=C;function P(h){const v=new Set;return JSON.stringify(h,(m,w)=>{if((0,k.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=P;function E(h,v,m){const w=v(h);return typeof w=="undefined"?m:w}e.getOrDefault=E;function f(h,v){const m=Object.create(null);return!h||!v||Object.keys(v).forEach(y=>{const S=h[y],l=v[y];C(S,l)||(m[y]=l)}),m}e.distinct=f;function p(h,v){const m=v.toLowerCase(),w=Object.keys(h).find(y=>y.toLowerCase()===m);return w?h[w]:h[v]}e.getCaseInsensitive=p;function d(h,v){const m=Object.create(null);for(const[w,y]of Object.entries(h))v(w,y)&&(m[w]=y);return m}e.filter=d}),define(te[7],ne([0,1,10,4]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function R(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,n){return!i&&!n?"file":i}function C(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==E&&(n=E+n):n=E;break}return n}const P="",E="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,o,s,a,u,g=!1){typeof n=="object"?(this.scheme=n.scheme||P,this.authority=n.authority||P,this.path=n.path||P,this.query=n.query||P,this.fragment=n.fragment||P):(this.scheme=b(n,g),this.authority=o||P,this.path=C(this.scheme,s||P),this.query=a||P,this.fragment=u||P,R(this,g))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return y(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:s,path:a,query:u,fragment:g}=n;return o===void 0?o=this.scheme:o===null&&(o=P),s===void 0?s=this.authority:s===null&&(s=P),a===void 0?a=this.path:a===null&&(a=P),u===void 0?u=this.query:u===null&&(u=P),g===void 0?g=this.fragment:g===null&&(g=P),o===this.scheme&&s===this.authority&&a===this.path&&u===this.query&&g===this.fragment?this:new h(o,s,a,u,g)}static parse(n,o=!1){const s=f.exec(n);return s?new h(s[2]||P,c(s[4]||P),c(s[5]||P),c(s[7]||P),c(s[9]||P),o):new h(P,P,P,P,P)}static file(n){let o=P;if(t.isWindows&&(n=n.replace(/\\/g,E)),n[0]===E&&n[1]===E){const s=n.indexOf(E,2);s===-1?(o=n.substring(2),n=E):(o=n.substring(2,s),n=n.substring(s)||E)}return new h("file",o,n,P,P)}static from(n){const o=new h(n.scheme,n.authority,n.path,n.query,n.fragment);return R(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&n.scheme==="file"?s=p.file(k.win32.join(y(n,!0),...o)).path:s=k.posix.join(n.path,...o),n.with({path:s})}toString(n=!1){return S(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const o=new h(n);return o._formatted=n.external,o._fsPath=n._sep===d?n.fsPath:null,o}}else return n}}e.URI=p;const d=t.isWindows?1:void 0;class h extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(n=!1){return n?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(i,n){let o,s=-1;for(let a=0;a<i.length;a++){const u=i.charCodeAt(a);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||n&&u===47)s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o!==void 0&&(o+=i.charAt(a));else{o===void 0&&(o=i.substr(0,a));const g=v[u];g!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o+=g):s===-1&&(s=a)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function w(i){let n;for(let o=0;o<i.length;o++){const s=i.charCodeAt(o);s===35||s===63?(n===void 0&&(n=i.substr(0,o)),n+=v[s]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function y(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function S(i,n){const o=n?w:m;let s="",{scheme:a,authority:u,path:g,query:I,fragment:_}=i;if(a&&(s+=a,s+=":"),(u||a==="file")&&(s+=E,s+=E),u){let M=u.indexOf("@");if(M!==-1){const F=u.substr(0,M);u=u.substr(M+1),M=F.indexOf(":"),M===-1?s+=o(F,!1):(s+=o(F.substr(0,M),!1),s+=":",s+=o(F.substr(M+1),!1)),s+="@"}u=u.toLowerCase(),M=u.indexOf(":"),M===-1?s+=o(u,!1):(s+=o(u.substr(0,M),!1),s+=u.substr(M))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const M=g.charCodeAt(1);M>=65&&M<=90&&(g=`/${String.fromCharCode(M+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const M=g.charCodeAt(0);M>=65&&M<=90&&(g=`${String.fromCharCode(M+32)}:${g.substr(2)}`)}s+=o(g,!0)}return I&&(s+="?",s+=o(I,!1)),_&&(s+="#",s+=n?_:m(_,!1)),s}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(r)?i.replace(r,n=>l(n)):i}}),define(te[107],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(C){const P=C;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=t;function L(C){const P=[];let E;try{const f=JSON.parse(C.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),E=p.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",C.arguments)}return{args:P,stack:E}}e.parse=L;function T(C){if(typeof C!="string")return T(L(C).stack);const P=C;if(P){const E=A(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(f&&f.length===4)return{uri:k.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(C){if(!C)return C;const P=C.indexOf(`
`);return P===-1?C:C.substring(0,P)}function R(C,P){const{args:E,stack:f}=L(C),p=typeof E[0]=="string"&&E.length===1;let d=A(f);d&&(d=`(${d.trim()})`);let h=[];if(typeof E[0]=="string"?d&&p?h=[`%c[${P}] %c${E[0]} %c${d}`,b("blue"),b(""),b("grey")]:h=[`%c[${P}] %c${E[0]}`,b("blue"),b(""),...E.slice(1)]:h=[`%c[${P}]%`,b("blue"),...E],d&&!p&&h.push(d),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,h)}e.log=R;function b(C){return`color: ${C}`}}),define(te[108],ne([0,1,17,26,7]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(C){return JSON.stringify(C,R)}e.stringify=T;function A(C){let P=JSON.parse(C);return P=b(P),P}e.parse=A;function R(C,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,t.regExpFlags)(P)}:P}function b(C,P=0){if(!C||P>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return L.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 14:return new Date(C.source)}if(C instanceof k.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let E=0;E<C.length;++E)C[E]=b(C[E],P+1);else for(const E in C)Object.hasOwnProperty.call(C,E)&&(C[E]=b(C[E],P+1))}return C}e.revive=b}),define(te[19],ne([0,1,4,7]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,C,P){this._hosts[b]=C,this._ports[b]=P}setConnectionToken(b,C){this._connectionTokens[b]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const C=b.authority;let P=this._hosts[C];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const E=this._ports[C],f=this._connectionTokens[C];let p=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:k.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${P}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class A{asBrowserUri(b,C){const P=this.toUri(b,C);return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(b,C){const P=this.toUri(b,C);return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==A.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(b,C){return t.URI.isUri(b)?b:t.URI.parse(C.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(te[20],ne([0,1,41,19,10,4,26,7]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=b;class C{constructor(d){this._ignorePathCasing=d}compare(d,h,v=!1){return d===h?0:(0,A.compare)(this.getComparisonKey(d,v),this.getComparisonKey(h,v))}isEqual(d,h,v=!1){return d===h?!0:!d||!h?!1:this.getComparisonKey(d,v)===this.getComparisonKey(h,v)}getComparisonKey(d,h=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,h,v=!1){if(d.scheme===h.scheme){if(d.scheme===t.Schemas.file)return k.isEqualOrParent(b(d),b(h),this._ignorePathCasing(d))&&d.query===h.query&&(v||d.fragment===h.fragment);if((0,e.isEqualAuthority)(d.authority,h.authority))return k.isEqualOrParent(d.path,h.path,this._ignorePathCasing(d),"/")&&d.query===h.query&&(v||d.fragment===h.fragment)}return!1}joinPath(d,...h){return R.URI.joinPath(d,...h)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return L.posix.basename(d.path)}extname(d){return L.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let h;return d.scheme===t.Schemas.file?h=R.URI.file(L.dirname(b(d))).path:(h=L.posix.dirname(d.path),d.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),h="/")),d.with({path:h})}normalizePath(d){if(!d.path.length)return d;let h;return d.scheme===t.Schemas.file?h=R.URI.file(L.normalize(b(d))).path:h=L.posix.normalize(d.path),d.with({path:h})}relativePath(d,h){if(d.scheme!==h.scheme||!(0,e.isEqualAuthority)(d.authority,h.authority))return;if(d.scheme===t.Schemas.file){const w=L.relative(b(d),b(h));return T.isWindows?k.toSlashes(w):w}let v=d.path||"/",m=h.path||"/";if(this._ignorePathCasing(d)){let w=0;for(const y=Math.min(v.length,m.length);w<y&&!(v.charCodeAt(w)!==m.charCodeAt(w)&&v.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);v=m.substr(0,w)+v.substr(w)}return L.posix.relative(v,m)}resolvePath(d,h){if(d.scheme===t.Schemas.file){const v=R.URI.file(L.resolve(b(d),h));return d.with({authority:v.authority,path:v.path})}return h=k.toPosixPath(h),d.with({path:L.posix.resolve(d.path,h)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,h){return d===h||d!==void 0&&h!==void 0&&(0,A.equalsIgnoreCase)(d,h)}hasTrailingPathSeparator(d,h=L.sep){if(d.scheme===t.Schemas.file){const v=b(d);return v.length>k.getRoot(v).length&&v[v.length-1]===h}else{const v=d.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,h=L.sep){return(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,h=L.sep){let v=!1;if(d.scheme===t.Schemas.file){const m=b(d);v=m!==void 0&&m.length===k.getRoot(m).length&&m[m.length-1]===h}else{h="/";const m=d.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path+"/"}):d}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,d){const h=[];for(let v=0;v<p.length;v++){const m=d(p[v]);p.some((w,y)=>y===v?!1:(0,e.isEqualOrParent)(m,d(w)))||h.push(p[v])}return h}e.distinctParents=P;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(h){const v=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(y=>{const[S,l]=y.split(":");S&&l&&v.set(S,l)});const w=h.path.substring(0,h.path.indexOf(";"));return w&&v.set(p.META_DATA_MIME,w),v}p.parseMetaData=d})(E=e.DataUri||(e.DataUri={}));function f(p,d,h){if(d){let v=p.path;return v&&v[0]!==L.posix.sep&&(v=L.posix.sep+v),p.with({scheme:h,authority:d,path:v})}return p.with({scheme:h})}e.toLocalResource=f}),define(te[5],ne([0,1,25,9,3,2,20,4]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(q){return!!q&&typeof q.then=="function"}e.isThenable=b;function C(q){const O=new k.CancellationTokenSource,U=q(O.token),z=new Promise((H,ie)=>{const se=O.token.onCancellationRequested(()=>{se.dispose(),O.dispose(),ie(new t.CancellationError)});Promise.resolve(U).then(ue=>{se.dispose(),O.dispose(),H(ue)},ue=>{se.dispose(),O.dispose(),ie(ue)})});return new class{cancel(){O.cancel()}then(H,ie){return z.then(H,ie)}catch(H){return this.then(void 0,H)}finally(H){return z.finally(H)}}}e.createCancelablePromise=C;function P(q,O,U){return new Promise((z,H)=>{const ie=O.onCancellationRequested(()=>{ie.dispose(),z(U)});q.then(z,H).finally(()=>ie.dispose())})}e.raceCancellation=P;function E(q,O){return new Promise((U,z)=>{const H=O.onCancellationRequested(()=>{H.dispose(),z(new t.CancellationError)});q.then(U,z).finally(()=>H.dispose())})}e.raceCancellationError=E;async function f(q){let O=-1;const U=q.map((H,ie)=>H.then(se=>(O=ie,se))),z=await Promise.race(U);return q.forEach((H,ie)=>{ie!==O&&H.cancel()}),z}e.raceCancellablePromises=f;function p(q,O,U){let z;const H=setTimeout(()=>{z?.(void 0),U?.()},O);return Promise.race([q.finally(()=>clearTimeout(H)),new Promise(ie=>z=ie)])}e.raceTimeout=p;function d(q){return new Promise((O,U)=>{const z=q();b(z)?z.then(O,U):O(z)})}e.asPromise=d;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(U,U).then(z)})}return new Promise((U,z)=>{this.queuedPromise.then(U,z)})}return this.activePromise=O(),new Promise((U,z)=>{this.activePromise.then(H=>{this.activePromise=null,U(H)},H=>{this.activePromise=null,z(H)})})}}e.Throttler=h;class v{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=v;class m{constructor(){this.promiseMap=new Map}queue(O,U){const H=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(O)===H&&this.promiseMap.delete(O)});return this.promiseMap.set(O,H),H}}e.SequencerByKey=m;const w=(q,O)=>{let U=!0;const z=setTimeout(()=>{U=!1,O()},q);return{isTriggered:()=>U,dispose:()=>{clearTimeout(z),U=!1}}},y=q=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,q())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,U=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,ie)=>{this.doResolve=H,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?y(z):w(U,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=S;class l{constructor(O){this.delayer=new S(O),this.throttler=new h}trigger(O,U){return this.delayer.trigger(()=>this.throttler.queue(O),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise((O,U)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class c extends r{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function i(q,O){return O?new Promise((U,z)=>{const H=setTimeout(()=>{ie.dispose(),U()},q),ie=O.onCancellationRequested(()=>{clearTimeout(H),ie.dispose(),z(new t.CancellationError)})}):C(U=>i(q,U))}e.timeout=i;function n(q,O=0){const U=setTimeout(q,O);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=n;function o(q){const O=[];let U=0;const z=q.length;function H(){return U<z?q[U++]():null}function ie(se){se!=null&&O.push(se);const ue=H();return ue?ue.then(ie):Promise.resolve(O)}return Promise.resolve(null).then(ie)}e.sequence=o;function s(q,O=z=>!!z,U=null){let z=0;const H=q.length,ie=()=>{if(z>=H)return Promise.resolve(U);const se=q[z++];return Promise.resolve(se()).then(he=>O(he)?Promise.resolve(he):ie())};return ie()}e.first=s;function a(q,O=z=>!!z,U=null){if(q.length===0)return Promise.resolve(U);let z=q.length;const H=()=>{z=-1;for(const ie of q)ie.cancel?.()};return new Promise((ie,se)=>{for(const ue of q)ue.then(he=>{--z>=0&&O(he)?(H(),ie(he)):z===0&&ie(U)}).catch(he=>{--z>=0&&(H(),se(he))})})}e.firstParallel=a;class u{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(O){return this._size++,new Promise((U,z)=>{this.outstandingPromises.push({factory:O,c:U,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const U=O.factory();U.then(O.c,O.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class g extends u{constructor(){super(1)}}e.Queue=g;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new x;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,U=A.extUri){const z=U.getComparisonKey(O);let H=this.queues.get(z);return H||(H=new g,L.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(z),this.onDidQueueFinish()}),this.queues.set(z,H)),H}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class _{constructor(O,U){this._token=-1,typeof O=="function"&&typeof U=="number"&&this.setIfNotSet(O,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},U)}setIfNotSet(O,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},U))}}e.TimeoutTimer=_;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,U){this.cancel(),this._token=setInterval(()=>{O()},U)}}e.IntervalTimer=M;class F{constructor(O,U){this.timeoutToken=-1,this.runner=O,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class D{constructor(O,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=D;class N extends F{constructor(O,U){super(O,U);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner&&this.runner(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class $ extends T.Disposable{constructor(O,U){super();this.options=O,this.handler=U,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,R.setTimeout0)(()=>{if(O)return;const U=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(q,O)=>{const U=requestIdleCallback(q,typeof O=="number"?{timeout:O}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(U))}}}}();class B{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function Z(q,O,U){let z;for(let H=0;H<U;H++)try{return await q()}catch(ie){z=ie,await i(O)}throw z}e.retry=Z;class W{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(O,U,z){return this._pending={taskId:O,cancel:()=>z?.(),promise:U},U.then(()=>this.donePending(O),()=>this.donePending(O)),U}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let U,z;const H=new Promise((ie,se)=>{U=ie,z=se});this._next={run:O,promise:H,promiseResolve:U,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=W;class ee{constructor(O,U=()=>Date.now()){this.interval=O,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,U)=>{this.completeCallback=O,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(U=>{this.completeCallback(O),this.resolved=!0,U()})}error(O){return new Promise(U=>{this.errorCallback(O),this.rejected=!0,U()})}cancel(){new Promise(O=>{this.errorCallback(new t.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=x;var j;(function(q){async function O(z){let H;const ie=await Promise.all(z.map(se=>se.then(ue=>ue,ue=>{H||(H=ue)})));if(typeof H!="undefined")throw H;return ie}q.settled=O;function U(z){return new Promise(async(H,ie)=>{try{await z(H,ie)}catch(se){ie(se)}})}q.withAsyncBody=U})(j=e.Promises||(e.Promises={}));var Y;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(Y||(Y={}));class V{constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const U={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(O(U)),this.resolve()}catch(z){this.reject(z)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}static fromArray(O){return new V(U=>{U.emitMany(O)})}static fromPromise(O){return new V(async U=>{U.emitMany(await O)})}static fromPromises(O){return new V(async U=>{await Promise.all(O.map(async z=>U.emitOne(await z)))})}static merge(O){return new V(async U=>{await Promise.all(O.map(async z=>{for await(const H of z)U.emitOne(H)}))})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,U){return new V(async z=>{for await(const H of O)z.emitOne(U(H))})}map(O){return V.map(this,O)}static filter(O,U){return new V(async z=>{for await(const H of O)U(H)&&z.emitOne(H)})}filter(O){return V.filter(this,O)}static coalesce(O){return V.filter(O,U=>!!U)}coalesce(){return V.coalesce(this)}static async toPromise(O){const U=[];for await(const z of O)U.push(z);return U}toPromise(){return V.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class J extends V{constructor(O,U){super(U);this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function Q(q){const O=new k.CancellationTokenSource,U=q(O.token);return new J(O,async z=>{const H=O.token.onCancellationRequested(()=>{H.dispose(),O.dispose(),z.reject(new t.CancellationError)});try{for await(const ie of U){if(O.token.isCancellationRequested)return;z.emitOne(ie)}H.dispose(),O.dispose()}catch(ie){H.dispose(),O.dispose(),z.reject(ie)}})}e.createCancelableAsyncIterable=Q}),define(te[109],ne([0,1,5,41,39,10,4,26]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",P="[^/\\\\]",E=/\//g;function f(x){switch(x){case 0:return"";case 1:return`${P}*?`;default:return`(?:${C}|${P}+${C}|${C}${P}+)*?`}}function p(x,j){if(!x)return[];const Y=[];let V=!1,J=!1,Q="";for(const q of x){switch(q){case j:if(!V&&!J){Y.push(Q),Q="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":J=!0;break;case"]":J=!1;break}Q+=q}return Q&&Y.push(Q),Y}e.splitGlobAware=p;function d(x){if(!x)return"";let j="";const Y=p(x,e.GLOB_SPLIT);if(Y.every(V=>V===e.GLOBSTAR))j=".*";else{let V=!1;Y.forEach((J,Q)=>{if(J===e.GLOBSTAR){V||(j+=f(2),V=!0);return}let q=!1,O="",U=!1,z="";for(const H of J){if(H!=="}"&&q){O+=H;continue}if(U&&(H!=="]"||!z)){let ie;H==="-"?ie=H:(H==="^"||H==="!")&&!z?ie="^":H===e.GLOB_SPLIT?ie="":ie=(0,R.escapeRegExpCharacters)(H),z+=ie;continue}switch(H){case"{":q=!0;continue;case"[":U=!0;continue;case"}":{j+=`(?:${p(O,",").map(ue=>d(ue)).join("|")})`,q=!1,O="";break}case"]":j+="["+z+"]",U=!1,z="";break;case"?":j+=P;continue;case"*":j+=f(1);continue;default:j+=(0,R.escapeRegExpCharacters)(H)}}Q<Y.length-1&&(Y[Q+1]!==e.GLOBSTAR||Q+2<Y.length)&&(j+=C),V=!1})}return j}const h=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new L.LRUCache(1e4),r=function(){return!1},c=function(){return null};function i(x,j){if(!x)return c;let Y;typeof x!="string"?Y=x.pattern:Y=x,Y=Y.trim();const V=`${Y}_${!!j.trimForExclusions}`;let J=l.get(V);if(J)return n(J,x);let Q;if(h.test(Y)){const q=Y.substr(4);J=function(O,U){return typeof O=="string"&&O.endsWith(q)?Y:null}}else(Q=v.exec(o(Y,j)))?J=s(Q[1],Y):(j.trimForExclusions?w:m).test(Y)?J=a(Y,j):(Q=y.exec(o(Y,j)))?J=u(Q[1].substr(1),Y,!0):(Q=S.exec(o(Y,j)))?J=u(Q[1],Y,!1):J=g(Y);return l.set(V,J),n(J,x)}function n(x,j){return typeof j=="string"?x:function(Y,V){return(0,t.isEqualOrParent)(Y,j.base,!A.isLinux)?x(Y.substr(j.base.length+1),V):null}}function o(x,j){return j.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function s(x,j){const Y=`/${x}`,V=`\\${x}`,J=function(q,O){return typeof q!="string"?null:O?O===x?j:null:q===x||q.endsWith(Y)||q.endsWith(V)?j:null},Q=[x];return J.basenames=Q,J.patterns=[j],J.allBasenames=Q,J}function a(x,j){const Y=ee(x.slice(1,-1).split(",").map(O=>i(O,j)).filter(O=>O!==c),x),V=Y.length;if(!V)return c;if(V===1)return Y[0];const J=function(O,U){for(let z=0,H=Y.length;z<H;z++)if(Y[z](O,U))return x;return null},Q=Y.find(O=>!!O.allBasenames);Q&&(J.allBasenames=Q.allBasenames);const q=Y.reduce((O,U)=>U.allPaths?O.concat(U.allPaths):O,[]);return q.length&&(J.allPaths=q),J}function u(x,j,Y){const V=T.sep===T.posix.sep,J=V?x:x.replace(E,T.sep),Q=T.sep+J,q=T.posix.sep+x,O=Y?function(U,z){return typeof U=="string"&&(U===J||U.endsWith(Q)||!V&&(U===x||U.endsWith(q)))?j:null}:function(U,z){return typeof U=="string"&&(U===J||!V&&U===x)?j:null};return O.allPaths=[(Y?"*/":"./")+x],O}function g(x){try{const j=new RegExp(`^${d(x)}$`);return function(Y){return j.lastIndex=0,typeof Y=="string"&&j.test(Y)?x:null}}catch{return c}}function I(x,j,Y){return!x||typeof j!="string"?!1:_(x)(j,void 0,Y)}e.match=I;function _(x,j={}){if(!x)return r;if(typeof x=="string"||N(x)){const Y=i(x,j);if(Y===c)return r;const V=function(J,Q){return!!Y(J,Q)};return Y.allBasenames&&(V.allBasenames=Y.allBasenames),Y.allPaths&&(V.allPaths=Y.allPaths),V}return Z(x,j)}e.parse=_;function M(x){if(!x)return;let j;return Y=>(j||(j=(x()||Promise.resolve([])).then(V=>V?D(V):{})),j.then(V=>!!V[Y]))}e.hasSiblingPromiseFn=M;function F(x){if(!x)return;let j;return Y=>{if(!j){const V=x();j=V?D(V):{}}return!!j[Y]}}e.hasSiblingFn=F;function D(x){const j={};for(const Y of x)j[Y]=!0;return j}function N(x){const j=x;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=N;function $(x){return x.allBasenames||[]}e.getBasenameTerms=$;function B(x){return x.allPaths||[]}e.getPathTerms=B;function Z(x,j){const Y=ee(Object.getOwnPropertyNames(x).map(O=>W(O,x[O],j)).filter(O=>O!==c)),V=Y.length;if(!V)return c;if(!Y.some(O=>!!O.requiresSiblings)){if(V===1)return Y[0];const O=function(H,ie){for(let se=0,ue=Y.length;se<ue;se++){const he=Y[se](H,ie);if(he)return he}return null},U=Y.find(H=>!!H.allBasenames);U&&(O.allBasenames=U.allBasenames);const z=Y.reduce((H,ie)=>ie.allPaths?H.concat(ie.allPaths):H,[]);return z.length&&(O.allPaths=z),O}const J=function(O,U,z){let H;for(let ie=0,se=Y.length;ie<se;ie++){const ue=Y[ie];ue.requiresSiblings&&z&&(U||(U=(0,T.basename)(O)),H||(H=U.substr(0,U.length-(0,T.extname)(O).length)));const he=ue(O,U,H,z);if(he)return he}return null},Q=Y.find(O=>!!O.allBasenames);Q&&(J.allBasenames=Q.allBasenames);const q=Y.reduce((O,U)=>U.allPaths?O.concat(U.allPaths):O,[]);return q.length&&(J.allPaths=q),J}function W(x,j,Y){if(j===!1)return c;const V=i(x,Y);if(V===c)return c;if(typeof j=="boolean")return V;if(j){const J=j.when;if(typeof J=="string"){const Q=(q,O,U,z)=>{if(!z||!V(q,O))return null;const H=J.replace("$(basename)",U),ie=z(H);return(0,k.isThenable)(ie)?ie.then(se=>se?x:null):ie?x:null};return Q.requiresSiblings=!0,Q}}return V}function ee(x,j){const Y=x.filter(O=>!!O.basenames);if(Y.length<2)return x;const V=Y.reduce((O,U)=>{const z=U.basenames;return z?O.concat(z):O},[]);let J;if(j){J=[];for(let O=0,U=V.length;O<U;O++)J.push(j)}else J=Y.reduce((O,U)=>{const z=U.patterns;return z?O.concat(z):O},[]);const Q=function(O,U){if(typeof O!="string")return null;if(!U){let H;for(H=O.length;H>0;H--){const ie=O.charCodeAt(H-1);if(ie===47||ie===92)break}U=O.substr(H)}const z=V.indexOf(U);return z!==-1?J[z]:null};Q.basenames=V,Q.patterns=J,Q.allBasenames=V;const q=x.filter(O=>!O.basenames);return q.push(Q),q}}),define(te[110],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(P){return P.toJSON()}class L{constructor(E){this._uriTransformer=E}transformIncoming(E){const f=this._uriTransformer.transformIncoming(E);return f===E?E:t(k.URI.from(f))}transformOutgoing(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:t(k.URI.from(f))}transformOutgoingURI(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:k.URI.from(f)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function T(P,E,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof k.URI)return E.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const d=T(P[p],E,f+1);d!==null&&(P[p]=d)}}return null}function A(P,E){const f=T(P,E,0);return f===null?P:f}e.transformOutgoingURIs=A;function R(P,E,f,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?k.URI.revive(E.transformIncoming(P)):E.transformIncoming(P);for(let d in P)if(Object.hasOwnProperty.call(P,d)){const h=R(P[d],E,f,p+1);h!==null&&(P[d]=h)}}return null}function b(P,E){const f=R(P,E,!1,0);return f===null?P:f}e.transformIncomingURIs=b;function C(P,E){const f=R(P,E,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=C}),define(te[29],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(b){return k.test(b)}e.isUUID=t;const L=new Uint8Array(16),T=[];for(let b=0;b<256;b++)T.push(b.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(b){for(let C=0;C<b.length;C++)b[C]=Math.floor(Math.random()*256);return b};function R(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,C="";return C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+="-",C+=T[L[b++]],C+=T[L[b++]],C+="-",C+=T[L[b++]],C+=T[L[b++]],C+="-",C+=T[L[b++]],C+=T[L[b++]],C+="-",C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C+=T[L[b++]],C}e.generateUuid=R}),define(te[111],ne([0,1,252]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(T="utf8"){this.stringDecoder=new k.StringDecoder(T),this.remaining=null}write(T){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(R.length<1)return A;let b=0,C,P=b;for(;P<R.length;)if(C=R.charCodeAt(P),C===13||C===10){if(A.push(R.substring(b,P)),P++,P<R.length){const E=C;C=R.charCodeAt(P),(E===13&&C===10||E===10&&C===13)&&P++}b=P}else P++;return this.remaining=b<R.length?R.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=t}),define(te[112],ne([0,1,34]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const R=A.replace(/\-/g,":").toLowerCase();return!t.has(R)}function T(){const A=(0,k.networkInterfaces)();for(let R in A){const b=A[R];if(b){for(const{mac:C}of b)if(L(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(te[113],ne([0,1,34,9,39,29,112]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,E=0;const f=(0,k.networkInterfaces)();for(let p in f){const d=f[p];if(d)for(const{mac:h,internal:v}of d)v||(E+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(P+=1))}this._value=E>0?P/E:0}return this._value}};let R;async function b(){return R||(R=(async()=>await C()||T.generateUuid())()),R}e.getMachineId=b;async function C(){try{const P=await new Promise((f,p)=>{K(["crypto"],f,p)}),E=(0,A.getMac)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){t.onUnexpectedError(P);return}}}),define(te[22],ne([0,1,50,34,253,5,41,72,10,4,20,7]),function(K,e,k,t,L,T,A,R,b,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function p($,B=f.UNLINK){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return B===f.UNLINK?h($):d($)}async function d($){try{const B=(0,A.randomPath)((0,t.tmpdir)());try{await k.promises.rename($,B)}catch{return h($)}h(B).catch(Z=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function h($){return(0,L.promisify)(k.rm)($,{recursive:!0,force:!0,maxRetries:3})}function v($){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function m($,B){return S(await(B?w($):(0,L.promisify)(k.readdir)($)))}async function w($){try{return await(0,L.promisify)(k.readdir)($,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const B=[],Z=await m($);for(const W of Z){let ee=!1,x=!1,j=!1;try{const Y=await e.Promises.lstat((0,b.join)($,W));ee=Y.isFile(),x=Y.isDirectory(),j=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}B.push({name:W,isFile:()=>ee,isDirectory:()=>x,isSymbolicLink:()=>j})}return B}function y($){return S(k.readdirSync($))}e.readdirSync=y;function S($){return $.map(B=>typeof B=="string"?C.isMacintosh?(0,R.normalizeNFC)(B):B:(B.name=C.isMacintosh?(0,R.normalizeNFC)(B.name):B.name,B))}async function l($){const B=await m($),Z=[];for(const W of B)await c.existsDirectory((0,b.join)($,W))&&Z.push(W);return Z}function r($,B=1e3){return new Promise(Z=>{let W=!1;const ee=setInterval(()=>{W||(W=!0,k.access($,x=>{W=!1,x&&(clearInterval(ee),Z(void 0))}))},B)})}e.whenDeleted=r;var c;(function($){async function B(ee){let x;try{if(x=await e.Promises.lstat(ee),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(C.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw Y}throw j}}$.stat=B;async function Z(ee){try{const{stat:x,symbolicLink:j}=await $.stat(ee);return x.isFile()&&j?.dangling!==!0}catch{}return!1}$.existsFile=Z;async function W(ee){try{const{stat:x,symbolicLink:j}=await $.stat(ee);return x.isDirectory()&&j?.dangling!==!0}catch{}return!1}$.existsDirectory=W})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function n($,B,Z){return i.queueFor(E.URI.file($),P.extUriBiasedIgnorePathCase).queue(()=>{const W=u(Z);return new Promise((ee,x)=>s($,B,W,j=>j?x(j):ee()))})}let o=!0;function s($,B,Z,W){if(!o)return k.writeFile($,B,{mode:Z.mode,flag:Z.flag},W);k.open($,Z.flag,Z.mode,(ee,x)=>{if(ee)return W(ee);k.writeFile(x,B,j=>{if(j)return k.close(x,()=>W(j));k.fdatasync(x,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),o=!1),k.close(x,V=>W(V))))})})}function a($,B,Z){const W=u(Z);if(!o)return k.writeFileSync($,B,{mode:W.mode,flag:W.flag});const ee=k.openSync($,W.flag,W.mode);try{k.writeFileSync(ee,B);try{k.fdatasyncSync(ee)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),o=!1}}finally{k.closeSync(ee)}}e.writeFileSync=a;function u($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function g($,B){if($!==B)try{await e.Promises.rename($,B)}catch(Z){if($.toLowerCase()!==B.toLowerCase()&&Z.code==="EXDEV"||$.endsWith("."))await I($,B,{preserveSymlinks:!1}),await p($,f.MOVE);else throw Z}}async function I($,B,Z){return M($,B,{root:{source:$,target:B},options:Z,handledSourcePaths:new Set})}const _=511;async function M($,B,Z){if(Z.handledSourcePaths.has($))return;Z.handledSourcePaths.add($);const{stat:W,symbolicLink:ee}=await c.stat($);if(ee){if(Z.options.preserveSymlinks)try{return await N($,B,Z)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(ee.dangling)return}return W.isDirectory()?F($,B,W.mode&_,Z):D($,B,W.mode&_)}async function F($,B,Z,W){await e.Promises.mkdir(B,{recursive:!0,mode:Z});const ee=await m($);for(const x of ee)await M((0,b.join)($,x),(0,b.join)(B,x),W)}async function D($,B,Z){await e.Promises.copyFile($,B),await e.Promises.chmod(B,Z)}async function N($,B,Z){let W=await e.Promises.readlink($);(0,A.isEqualOrParent)(W,Z.root.source,!C.isLinux)&&(W=(0,b.join)(Z.root.target,W.substr(Z.root.source.length+1))),await e.Promises.symlink(W,B)}e.Promises=new class{get access(){return(0,L.promisify)(k.access)}get stat(){return(0,L.promisify)(k.stat)}get lstat(){return(0,L.promisify)(k.lstat)}get utimes(){return(0,L.promisify)(k.utimes)}get read(){return($,B,Z,W,ee)=>new Promise((x,j)=>{k.read($,B,Z,W,ee,(Y,V,J)=>Y?j(Y):x({bytesRead:V,buffer:J}))})}get readFile(){return(0,L.promisify)(k.readFile)}get write(){return($,B,Z,W,ee)=>new Promise((x,j)=>{k.write($,B,Z,W,ee,(Y,V,J)=>Y?j(Y):x({bytesWritten:V,buffer:J}))})}get appendFile(){return(0,L.promisify)(k.appendFile)}get fdatasync(){return(0,L.promisify)(k.fdatasync)}get truncate(){return(0,L.promisify)(k.truncate)}get rename(){return(0,L.promisify)(k.rename)}get copyFile(){return(0,L.promisify)(k.copyFile)}get open(){return(0,L.promisify)(k.open)}get close(){return(0,L.promisify)(k.close)}get symlink(){return(0,L.promisify)(k.symlink)}get readlink(){return(0,L.promisify)(k.readlink)}get chmod(){return(0,L.promisify)(k.chmod)}get mkdir(){return(0,L.promisify)(k.mkdir)}get unlink(){return(0,L.promisify)(k.unlink)}get rmdir(){return(0,L.promisify)(k.rmdir)}get realpath(){return(0,L.promisify)(k.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return l}get writeFile(){return n}get rm(){return p}get move(){return g}get copy(){return I}}}),define(te[114],ne([0,1,50,10,4,26,22]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(L.isLinux)return f;const p=(0,t.dirname)(f);if(f===p)return f;const d=((0,t.basename)(f)||f).toLowerCase();try{const v=(0,A.readdirSync)(p).filter(m=>m.toLowerCase()===d);if(v.length===1){const m=R(p);if(m)return(0,t.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(d);if(m>=0){const w=R(p);if(w)return(0,t.join)(w,v[m])}}}catch{}return null}e.realcaseSync=R;async function b(f){if(L.isLinux)return f;const p=(0,t.dirname)(f);if(f===p)return f;const d=((0,t.basename)(f)||f).toLowerCase();try{const v=(await A.Promises.readdir(p)).filter(m=>m.toLowerCase()===d);if(v.length===1){const m=await b(p);if(m)return(0,t.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(d);if(m>=0){const w=await b(p);if(w)return(0,t.join)(w,v[m])}}}catch{}return null}e.realcase=b;async function C(f){try{return await A.Promises.realpath(f)}catch{const d=E(f);return await A.Promises.access(d,k.constants.R_OK),d}}e.realpath=C;function P(f){try{return k.realpathSync(f)}catch{const d=E(f);return k.accessSync(d,k.constants.R_OK),d}}e.realpathSync=P;function E(f){return(0,T.rtrim)((0,t.normalize)(f),t.sep)}}),define(te[115],ne([0,1,56]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(R,b,C,P=1){let E=!1;return new Promise(f=>{const p=setTimeout(()=>{if(!E)return E=!0,f(0)},C);L(R,b,P,d=>{if(!E)return E=!0,clearTimeout(p),f(d)})})}e.findFreePort=t;function L(R,b,C,P){if(b===0)return P(0);const E=new k.Socket;E.once("connect",()=>(A(E),L(R+C,b-1,C,P))),E.once("data",()=>{}),E.once("error",f=>(A(E),f.code!=="ECONNREFUSED"?L(R+C,b-1,C,P):P(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,b,C){let P=!1,E,f=1;const p=k.createServer({pauseOnConnect:!0});function d(h,v){P||(P=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),v(h))}return new Promise(h=>{E=setTimeout(()=>{d(0,h)},C),p.on("listening",()=>{d(R,h)}),p.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&f<b?(R++,f++,p.listen(R,"127.0.0.1")):d(0,h)}),p.on("close",()=>{d(0,h)}),p.listen(R,"127.0.0.1")})}e.findFreePortFaster=T;function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(te[73],ne([0,1,34,10,22]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(b||(b={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class E{constructor(l,r,c){this.exePath=l,this.displayName=r,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:S=!1}={}){return S?C===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:S=!1,findPreview:l=!1}={}){const r=f({useAlternateBitness:S});if(!r)return null;const c=t.join(r,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(c))return null;let i=-1,n=null;for(const a of await L.Promises.readdir(c)){let u=-1;if(l){const I=a.indexOf("-");if(I<0)continue;const _=a.substring(0,I);if(!T.test(_)||a.substring(I+1)!=="preview")continue;u=parseInt(_,10)}else{if(!T.test(a))continue;u=parseInt(a,10)}if(u<=i)continue;const g=t.join(c,a,"pwsh.exe");!await L.SymlinkSupport.existsFile(g)||(n=g,i=u)}if(!n)return null;const o=r.includes("x86")?" (x86)":"",s=l?" Preview":"";return new E(n,`PowerShell${s}${o}`,!0)}async function d({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:c}=S?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(l))if(r.test(i)){const n=t.join(l,i,"pwsh.exe");return new E(n,c)}return null}function h(){const S=t.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(S,".NET Core PowerShell Global Tool")}function v(){const S=t.join(process.env.windir,C===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(S,"Windows PowerShell",!0)}async function*m(){let S=await p();S&&(yield S),S=await p({useAlternateBitness:!0}),S&&(yield S),S=await d(),S&&(yield S),S=h(),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await d({findPreview:!0}),S&&(yield S),S=await p({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=v(),S&&(yield S)}async function*w(){for await(const S of m())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=w;async function y(){for await(const S of w())return S;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[116],ne([0,1,46,19]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((R,b)=>{let C;const P=new Map;function E(p,d,h,v,m){const w=P.get(d);if(p===A||w){const y={name:f(h),cmd:h,pid:p,ppid:d,load:v,mem:m};P.set(p,y),p===A&&(C=y),w&&(w.children||(w.children=[]),w.children.push(y),w.children.length>1&&(w.children=w.children.sort((S,l)=>S.pid-l.pid)))}}function f(p){const d=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,y=/\\pipe\\winpty-control/,S=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"electron-crash-reporter";if(y.exec(p))return"winpty-process";if(S.exec(p))return"console-window-host (Windows internal process)";let r=l.exec(p);if(r&&r.length===2)return r[1]==="renderer"?d.exec(p)?"shared-process":h.exec(p)?"issue-reporter":v.exec(p)?"process-explorer":"window":r[1]==="utility"&&m.exec(p)?"utility-network-service":r[1];const c=/[a-zA-Z-]+\.js/g;let i="";do r=c.exec(p),r&&(i+=r+" ");while(r);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,h)=>{K(["windows-process-tree"],d,h)}).then(d=>{d.getProcessList(A,h=>{d.getProcessCpuUsage(h,v=>{const m=new Map;v.forEach(w=>{const y=p(w.commandLine||"");m.set(w.pid,{name:f(y),cmd:y,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),C=m.get(A),C?(m.forEach(w=>{const y=m.get(w.ppid);y&&(y.children||(y.children=[]),y.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((y,S)=>y.pid-S.pid))}),R(C)):b(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[C];const h=[];for(;d.length;){const m=d.shift();m&&(h.push(m.pid),m.children&&(d=d.concat(m.children)))}let v=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);v+=" "+h.join(" "),(0,k.exec)(v,{},(m,w,y)=>{if(m||y)b(m||new Error(y.toString()));else{const S=w.toString().split(`
`);for(let l=0;l<h.length;l++){const r=P.get(h[l]);r.load=parseFloat(S[l])}if(!C){b(new Error(`Root process ${A} not found`));return}R(C)}})};(0,k.exec)("which ps",{},(d,h,v)=>{if(d||v)if(process.platform!=="linux")b(d||new Error(v.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,k.exec)(m,{},(w,y,S)=>{w||S?b(w||new Error(S.toString())):(T(y,E),p())})}else{const m=h.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,S,l)=>{y||l&&!l.includes("screen size is bogus")?b(y||new Error(l.toString())):(T(S,E),process.platform==="linux"?p():C?R(C):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=A.toString().split(`
`);for(const P of C){const E=b.exec(P.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var de=this&&this.__decorate||function(K,e,k,t){var L=arguments.length,T=L<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,k):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,k,t);else for(var R=K.length-1;R>=0;R--)(A=K[R])&&(T=(L<3?A(T):L>3?A(e,k,T):A(e,k))||T);return L>3&&T&&Object.defineProperty(e,k,T),T};define(te[36],ne([0,1,16,5,17,25,54,9,3,2,108,26,11]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function d(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function v(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const Y=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Y.byteLength,Y}}class y{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var S;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(S||(S={}));function l(x){const j=L.VSBuffer.alloc(4);return j.writeUInt32BE(x,0),j}function r(x){return x.read(4).readUInt32BE(0)}function c(x){const j=L.VSBuffer.alloc(1);return j.writeUInt8(x,0),j}const i={Undefined:c(S.Undefined),String:c(S.String),Buffer:c(S.Buffer),VSBuffer:c(S.VSBuffer),Array:c(S.Array),Object:c(S.Object)},n=typeof Buffer!="undefined";function o(x,j){if(typeof j=="undefined")x.write(i.Undefined);else if(typeof j=="string"){const Y=L.VSBuffer.fromString(j);x.write(i.String),x.write(l(Y.byteLength)),x.write(Y)}else if(n&&Buffer.isBuffer(j)){const Y=L.VSBuffer.wrap(j);x.write(i.Buffer),x.write(l(Y.byteLength)),x.write(Y)}else if(j instanceof L.VSBuffer)x.write(i.VSBuffer),x.write(l(j.byteLength)),x.write(j);else if(Array.isArray(j)){x.write(i.Array),x.write(l(j.length));for(const Y of j)o(x,Y)}else{const Y=L.VSBuffer.fromString(JSON.stringify(j));x.write(i.Object),x.write(l(Y.byteLength)),x.write(Y)}}function s(x){switch(x.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return x.read(r(x)).toString();case S.Buffer:return x.read(r(x)).buffer;case S.VSBuffer:return x.read(r(x));case S.Array:{const Y=r(x),V=[];for(let J=0;J<Y;J++)V.push(s(x));return V}case S.Object:return JSON.parse(x.read(r(x)).toString())}}class a{constructor(j,Y,V=null,J=1e3){this.protocol=j,this.ctx=Y,this.logger=V,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(j,Y){this.channels.set(j,Y),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Y=this.send([j.type]);this.logger?.logOutgoing(Y,0,1,v(j.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(Y,j.id,1,v(j.type),j.data);return}}}send(j,Y=void 0){const V=new y;return o(V,j),o(V,Y),this.sendBuffer(V.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const Y=new w(j),V=s(Y),J=s(Y),Q=V[0];switch(Q){case 100:return this.logger?.logIncoming(j.byteLength,V[1],1,`${d(Q)}: ${V[2]}.${V[3]}`,J),this.onPromise({type:Q,id:V[1],channelName:V[2],name:V[3],arg:J});case 102:return this.logger?.logIncoming(j.byteLength,V[1],1,`${d(Q)}: ${V[2]}.${V[3]}`,J),this.onEventListen({type:Q,id:V[1],channelName:V[2],name:V[3],arg:J});case 101:return this.logger?.logIncoming(j.byteLength,V[1],1,`${d(Q)}`),this.disposeActiveRequest({type:Q,id:V[1]});case 103:return this.logger?.logIncoming(j.byteLength,V[1],1,`${d(Q)}`),this.disposeActiveRequest({type:Q,id:V[1]})}}onPromise(j){const Y=this.channels.get(j.channelName);if(!Y){this.collectPendingRequest(j);return}const V=new T.CancellationTokenSource;let J;try{J=Y.call(this.ctx,j.name,j.arg,V.token)}catch(O){J=Promise.reject(O)}const Q=j.id;J.then(O=>{this.sendResponse({id:Q,data:O,type:201}),this.activeRequests.delete(j.id)},O=>{O instanceof Error?this.sendResponse({id:Q,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:Q,data:O,type:203}),this.activeRequests.delete(j.id)});const q=(0,C.toDisposable)(()=>V.cancel());this.activeRequests.set(j.id,q)}onEventListen(j){const Y=this.channels.get(j.channelName);if(!Y){this.collectPendingRequest(j);return}const V=j.id,Q=Y.listen(this.ctx,j.name,j.arg)(q=>this.sendResponse({id:V,data:q,type:204}));this.activeRequests.set(j.id,Q)}disposeActiveRequest(j){const Y=this.activeRequests.get(j.id);Y&&(Y.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Y=this.pendingRequests.get(j.channelName);Y||(Y=[],this.pendingRequests.set(j.channelName,Y));const V=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:j,timeoutTimer:V})}flushPendingRequests(j){const Y=this.pendingRequests.get(j);if(Y){for(const V of Y)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var u;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(j,Y=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=Y}getChannel(j){const Y=this;return{call(V,J,Q){return Y.isDisposed?Promise.reject(R.canceled()):Y.requestPromise(j,V,J,Q)},listen(V,J){return Y.isDisposed?b.Event.None:Y.requestEvent(j,V,J)}}}requestPromise(j,Y,V,J=T.CancellationToken.None){const Q=this.lastRequestId++,O={id:Q,type:100,channelName:j,name:Y,arg:V};if(J.isCancellationRequested)return Promise.reject(R.canceled());let U;return new Promise((H,ie)=>{if(J.isCancellationRequested)return ie(R.canceled());const se=()=>{const pe=ge=>{switch(ge.type){case 201:this.handlers.delete(Q),H(ge.data);break;case 202:{this.handlers.delete(Q);const Ee=new Error(ge.data.message);Ee.stack=ge.data.stack,Ee.name=ge.data.name,ie(Ee);break}case 203:this.handlers.delete(Q),ie(ge.data);break}};this.handlers.set(Q,pe),this.sendRequest(O)};let ue=null;this.state===m.Idle?se():(ue=(0,t.createCancelablePromise)(pe=>this.whenInitialized()),ue.then(()=>{ue=null,se()}));const he=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:Q,type:101}),ie(R.canceled())},we=J.onCancellationRequested(he);U=(0,C.combinedDisposable)((0,C.toDisposable)(he),we),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(j,Y,V){const J=this.lastRequestId++,q={id:J,type:102,channelName:j,name:Y,arg:V};let O=null;const U=new b.Emitter({onFirstListenerAdd:()=>{O=(0,t.createCancelablePromise)(H=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(U),this.sendRequest(q)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(U),this.sendRequest({id:J,type:103}))}}),z=H=>U.fire(H.data);return this.handlers.set(J,z),U.event}sendRequest(j){switch(j.type){case 100:case 102:{const Y=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(Y,j.id,0,`${d(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Y=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(Y,j.id,0,d(j.type));return}}}send(j,Y=void 0){const V=new y;return o(V,j),o(V,Y),this.sendBuffer(V.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const Y=new w(j),V=s(Y),J=s(Y),Q=V[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,v(Q)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,V[1],0,v(Q),J),this.onResponse({type:V[0],id:V[1],data:J})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(j.id);Y&&Y(j)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([A.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class I{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Y,onDidClientDisconnect:V})=>{b.Event.once(Y.onMessage)(Q=>{const q=new w(Q),O=s(q),U=new a(Y,O),z=new g(Y);this.channels.forEach((ie,se)=>U.registerChannel(se,ie));const H={channelServer:U,channelClient:z,ctx:O};this._connections.add(H),this._onDidAddConnection.fire(H),V(()=>{U.dispose(),z.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}get connections(){const j=[];return this._connections.forEach(Y=>j.push(Y)),j}getChannel(j,Y){const V=this;return{call(J,Q,q){let O;if((0,f.isFunction)(Y)){let z=(0,k.getRandomElement)(V.connections.filter(Y));O=z?Promise.resolve(z):b.Event.toPromise(b.Event.filter(V.onDidAddConnection,Y))}else O=Y.routeCall(V,J,Q);const U=O.then(z=>z.channelClient.getChannel(j));return M(U).call(J,Q,q)},listen(J,Q){if((0,f.isFunction)(Y))return V.getMulticastEvent(j,Y,J,Q);const q=Y.routeEvent(V,J,Q).then(O=>O.channelClient.getChannel(j));return M(q).listen(J,Q)}}}getMulticastEvent(j,Y,V,J){const Q=this;let q=new C.DisposableStore;const O=new b.Emitter({onFirstListenerAdd:()=>{q=new C.DisposableStore;const U=new b.EventMultiplexer,z=new Map,H=se=>{const he=se.channelClient.getChannel(j).listen(V,J),we=U.add(he);z.set(se,we)},ie=se=>{const ue=z.get(se);!ue||(ue.dispose(),z.delete(se))};Q.connections.filter(Y).forEach(H),b.Event.filter(Q.onDidAddConnection,Y)(H,void 0,q),Q.onDidRemoveConnection(ie,void 0,q),U.event(O.fire,O,q),q.add(U)},onLastListenerRemove:()=>{q.dispose()}});return O.event}registerChannel(j,Y){this.channels.set(j,Y),this._connections.forEach(V=>{V.channelServer.registerChannel(j,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class _{constructor(j,Y,V=null){const J=new y;o(J,Y),j.send(J.buffer),this.channelClient=new g(j,V),this.channelServer=new a(j,Y,V)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Y){this.channelServer.registerChannel(j,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function M(x){return{call(j,Y,V){return x.then(J=>J.call(j,Y,V))},listen(j,Y){const V=new b.Relay;return x.then(J=>V.input=J.listen(j,Y)),V.event}}}e.getDelayedChannel=M;function F(x){let j=!1;return{call(Y,V,J){return j?x.call(Y,V,J):(0,t.timeout)(0).then(()=>j=!0).then(()=>x.call(Y,V,J))},listen(Y,V){if(j)return x.listen(Y,V);const J=new b.Relay;return(0,t.timeout)(0).then(()=>j=!0).then(()=>J.input=x.listen(Y,V)),J.event}}}e.getNextTickChannel=F;class D{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Y of j.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await b.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=D;var N;(function(x){function j(Q,q){const O=Q,U=q&&q.disableMarshalling,z=new Map;for(const H in O)V(H)&&z.set(H,b.Event.buffer(O[H],!0));return new class{listen(H,ie,se){const ue=z.get(ie);if(ue)return ue;if(J(ie)){const he=O[ie];if(typeof he=="function")return he.call(O,se)}throw new Error(`Event not found: ${ie}`)}call(H,ie,se){const ue=O[ie];if(typeof ue=="function"){if(!U&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ue.apply(O,se)}throw new Error(`Method not found: ${ie}`)}}}x.fromService=j;function Y(Q,q){const O=q&&q.disableMarshalling;return new Proxy({},{get(U,z){if(typeof z=="string")return q?.properties?.has(z)?q.properties.get(z):J(z)?function(H){return Q.listen(z,H)}:V(z)?Q.listen(z):async function(...H){let ie;q&&!(0,f.isUndefinedOrNull)(q.context)?ie=[q.context,...H]:ie=H;const se=await Q.call(z,ie);return O?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}x.toService=Y;function V(Q){return Q[0]==="o"&&Q[1]==="n"&&E.isUpperAsciiLetter(Q.charCodeAt(2))}function J(Q){return/^onDynamic/.test(Q)&&E.isUpperAsciiLetter(Q.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let j=x.toString();if(j!=="[object Object]")return j}return x}function Z(x){return Array.isArray(x)?x.map(B):B(x)}function W(x,j,Y,V,J,Q,q){q=Z(q);const O=$[J],U=O[V%O.length];let z=[`%c[${x}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(Q)?(z=z.concat(q),z.push(")")):z.push(q),console.log.apply(console,z)}e.logWithColors=W;class ee{constructor(j,Y){this._outgoingPrefix=j,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Y,V,J,Q){this._totalOutgoing+=j,W(this._outgoingPrefix,this._totalOutgoing,j,Y,V,J,Q)}logIncoming(j,Y,V,J,Q){this._totalIncoming+=j,W(this._incomingPrefix,this._totalIncoming,j,Y,V,J,Q)}}e.IPCLogger=ee}),define(te[117],ne([0,1,17,3,36]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(b){this.port=b,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",C=>k.VSBuffer.wrap(C.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(b,C){const P=new T(b);super(P,C);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[74],ne([0,1,17,3,2,36]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let s=0;function a(g,I){if(!o.has(g)){const _=String(++s);o.set(g,_)}return o.get(g)}function u(g,I,_,M){if(!n.enableDiagnostics)return;const F=a(g,I);if(M instanceof k.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const D=k.VSBuffer.alloc(M.byteLength);D.set(M),n.records.push({timestamp:Date.now(),id:F,label:I,type:_,buff:D})}else n.records.push({timestamp:Date.now(),id:F,label:I,type:_,data:M})}n.traceSocketEvent=u})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function P(){return C||(C=k.VSBuffer.alloc(0)),C}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return P();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const I=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),I}if(this._chunks[0].byteLength>o){const I=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),I}let a=k.VSBuffer.alloc(o),u=0,g=0;for(;o>0;){const I=this._chunks[g];if(I.byteLength>o){const _=I.slice(0,o);a.set(_,u),u+=o,s&&(this._chunks[g]=I.slice(o),this._totalLength-=o),o-=o}else a.set(I,u),u+=I.byteLength,s?(this._chunks.shift(),this._totalLength-=I.byteLength):g++,o-=I.byteLength}return a}}e.ChunkStream=E;var f;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(f||(f={}));function p(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(o,s,a,u){this.type=o,this.id=s,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends L.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,u=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new h(a,u,g,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=k.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const a=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,a}_bufferTake(){const o=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends L.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new h(1,0,0,o))}}e.Protocol=w;class y extends T.IPCClient{constructor(o,s,a=null){super(o,s,a);this.protocol=o}static fromSocket(o,s){return new y(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=y;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class l{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,a=this._first;for(;a;)o[s++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new l(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class c{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<c._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=c._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const o=Date.now(),s=(1+c._HISTORY_LENGTH)*1e3;let a=0;for(let u=0;u<c._HISTORY_LENGTH;u++)o-this.lastRuns[u]<=s&&a++;return 1-a/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class i{constructor(o,s=null,a=c.getInstance()){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new h(5,0,0,P());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new h(7,0,0,P());this._socketWriter.write(o)}sendResume(){const o=new h(8,0,0,P());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,P());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let a=0,u=s.length;a<u;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new h(6,0,0,P())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,u=s.length;a<u;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const s=new h(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const g=Math.max(2e4-s,2e4-a,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},g)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,P());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(te[118],ne([0,1,75,3,36,117]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const b=t.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(C,P)=>P);return t.Event.map(b,C=>{const{port1:P,port2:E}=new MessageChannel,p={protocol:new T.Protocol(P),onDidClientDisconnect:t.Event.fromDOMEventEmitter(P,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[E]),p})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[119],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function t(T){return T instanceof L?!0:T instanceof Error&&T.name===k&&T.message===k}e.isOfflineError=t;class L extends Error{constructor(){super(k);this.name=this.message}}e.OfflineError=L}),define(te[120],ne([0,1,17,9,119]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(b,C){if(!navigator.onLine)throw new L.OfflineError;b.proxyAuthorization&&(b.headers={...b.headers||{},"Proxy-Authorization":b.proxyAuthorization});const P=new XMLHttpRequest;return new Promise((E,f)=>{P.open(b.type||"GET",b.url||"",!0,b.user,b.password),A(P,b),P.responseType="arraybuffer",P.onerror=p=>f(new Error(P.statusText&&"XHR failed: "+P.statusText||"XHR failed")),P.onload=p=>{E({res:{statusCode:P.status,headers:R(P)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(P.response)))})},P.ontimeout=p=>f(new Error(`XHR timeout: ${b.timeout}ms`)),b.timeout&&(P.timeout=b.timeout),P.send(b.data),C.onCancellationRequested(()=>{P.abort(),f((0,t.canceled)())})})}e.request=T;function A(b,C){if(C.headers){e:for(let P in C.headers){switch(P){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}b.setRequestHeader(P,C.headers[P])}}}function R(b){const C=Object.create(null);for(const P of b.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(P){const E=P.indexOf(":");C[P.substr(0,E).trim().toLowerCase()]=P.substr(E+1).trim()}return C}}),define(te[76],ne([0,1,5,3,2,11]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function R(E){const f=E;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(b=e.StorageState||(e.StorageState={}));class C extends L.Disposable{constructor(f,p=Object.create(null)){super();this.database=f,this.options=p,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((p,d)=>this.accept(d,p)),f.deleted?.forEach(p=>this.accept(p,void 0))}accept(f,p){if(this.state===b.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(p)?d=this.cache.delete(f):this.cache.get(f)!==p&&(this.cache.set(f,p),d=!0),d&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,p){const d=this.cache.get(f);return(0,T.isUndefinedOrNull)(d)?p:d}getBoolean(f,p){const d=this.get(f);return(0,T.isUndefinedOrNull)(d)?p:d==="true"}getNumber(f,p){const d=this.get(f);return(0,T.isUndefinedOrNull)(d)?p:parseInt(d,10)}async set(f,p){if(this.state===b.Closed)return;if((0,T.isUndefinedOrNull)(p))return this.delete(f);const d=String(p);if(this.cache.get(f)!==d)return this.cache.set(f,d),this.pendingInserts.set(f,d),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((p,d)=>this.items.set(d,p)),f.delete&&f.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(te[121],ne([12,13]),function(K,e){return K.create("vs/base/common/date",e)}),define(te[57],ne([0,1,121]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,L=t*60,T=L*24,A=T*7,R=T*30,b=T*365;function C(E,f,p){typeof E!="number"&&(E=E.getTime());const d=Math.round((new Date().getTime()-E)/1e3);if(d<-30)return(0,k.localize)(0,null,C(new Date().getTime()+d*1e3,!1));if(d<30)return(0,k.localize)(1,null);let h;return d<t?(h=d,f?h===1?p?(0,k.localize)(2,null,h):(0,k.localize)(3,null,h):p?(0,k.localize)(4,null,h):(0,k.localize)(5,null,h):h===1?p?(0,k.localize)(6,null,h):(0,k.localize)(7,null,h):p?(0,k.localize)(8,null,h):(0,k.localize)(9,null,h)):d<L?(h=Math.floor(d/t),f?h===1?p?(0,k.localize)(10,null,h):(0,k.localize)(11,null,h):p?(0,k.localize)(12,null,h):(0,k.localize)(13,null,h):h===1?p?(0,k.localize)(14,null,h):(0,k.localize)(15,null,h):p?(0,k.localize)(16,null,h):(0,k.localize)(17,null,h)):d<T?(h=Math.floor(d/L),f?h===1?p?(0,k.localize)(18,null,h):(0,k.localize)(19,null,h):p?(0,k.localize)(20,null,h):(0,k.localize)(21,null,h):h===1?p?(0,k.localize)(22,null,h):(0,k.localize)(23,null,h):p?(0,k.localize)(24,null,h):(0,k.localize)(25,null,h)):d<A?(h=Math.floor(d/T),f?h===1?(0,k.localize)(26,null,h):(0,k.localize)(27,null,h):h===1?(0,k.localize)(28,null,h):(0,k.localize)(29,null,h)):d<R?(h=Math.floor(d/A),f?h===1?p?(0,k.localize)(30,null,h):(0,k.localize)(31,null,h):p?(0,k.localize)(32,null,h):(0,k.localize)(33,null,h):h===1?p?(0,k.localize)(34,null,h):(0,k.localize)(35,null,h):p?(0,k.localize)(36,null,h):(0,k.localize)(37,null,h)):d<b?(h=Math.floor(d/R),f?h===1?p?(0,k.localize)(38,null,h):(0,k.localize)(39,null,h):p?(0,k.localize)(40,null,h):(0,k.localize)(41,null,h):h===1?p?(0,k.localize)(42,null,h):(0,k.localize)(43,null,h):p?(0,k.localize)(44,null,h):(0,k.localize)(45,null,h)):(h=Math.floor(d/b),f?h===1?p?(0,k.localize)(46,null,h):(0,k.localize)(47,null,h):p?(0,k.localize)(48,null,h):(0,k.localize)(49,null,h):h===1?p?(0,k.localize)(50,null,h):(0,k.localize)(51,null,h):p?(0,k.localize)(52,null,h):(0,k.localize)(53,null,h))}e.fromNow=C;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(te[122],ne([12,13]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,16,11,122]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(E,f){return f&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),A(E.stack)||A(E.stacktrace)):R(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function b(E=null,f=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const p=k.coalesce(E),d=b(p[0],f);return p.length>1?L.localize(4,null,d,p.length):d}if(t.isString(E))return E;if(E.detail){const p=E.detail;if(p.error)return T(p.error,f);if(p.exception)return T(p.exception,f)}return E.stack?T(E,f):E.message?E.message:L.localize(5,null)}e.toErrorMessage=b;function C(E){const f=E;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=C;function P(E,f=Object.create(null)){const p=new Error(E);return f.actions&&(p.actions=f.actions),p}e.createErrorWithActions=P}),define(te[123],ne([12,13]),function(K,e){return K.create("vs/base/node/processes",e)}),define(te[77],ne([0,1,46,41,19,28,10,4,33,103,11,111,22,123]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function d(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(r,c){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const n=k.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{n.once("error",s=>{o({success:!1,error:s})}),n.once("exit",(s,a)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?d(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{k.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,s,a)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function v(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function m(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(c,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=c,this.args=i,this.shell=n,this.options=o;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(b.env).forEach(a=>{s[a]=b.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(A.sep);return i!==-1&&(c=c.substring(i+1)),w.WellKnowCommands[c]?c:"other"}start(c){return R.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(b.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(i=>{let n,o;const s=new Promise((a,u)=>{n=a,o=u});if(i){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(u,g,I)=>{this.childProcess=null;const _=u;_&&_.killed?o({killed:this.terminateRequested,stdout:g.toString(),stderr:I.toString()}):this.handleExec(n,c,u,g,I)})}else{let a=null;const u=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,n,c,o);const I={terminated:this.terminateRequested};P.isNumber(g)&&(I.cmdCode=g),n(I)};if(this.shell&&R.isWindows){const g=T.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let I=!1,_=!1;const M=[];let F=this.ensureQuotes(this.cmd);M.push(F.value),I=F.quoted,this.args&&this.args.forEach(N=>{F=this.ensureQuotes(N),M.push(F.value),_=_&&F.quoted});const D=["/s","/c"];I?_?D.push('"'+M.join(" ")+'"'):M.length>1?D.push('"'+M[0]+'" '+M.slice(1).join(" ")):D.push('"'+M[0]+'"'):D.push(M.join(" ")),a=k.spawn(m(),D,g)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(P.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",g=>{this.childProcess=null,o({terminated:this.terminateRequested,error:g})}),a.pid&&(this.childProcess.on("close",u),this.handleSpawn(a,n,c,o,!0)))}return s})}handleClose(c,i,n,o){}ensureQuotes(c){return w.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,h(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!R.isWindows)return c(!1);const i=k.spawn(m(),["/s","/c"]);i.on("error",n=>c(!0)),i.on("exit",n=>c(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class y extends w{constructor(c,i,n,o){super(c,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,n,o,s){[o,s].forEach((a,u)=>{const g=new E.LineDecoder;g.write(a).forEach(M=>{i({line:M,source:u===0?0:1})});const _=g.end();_&&i({line:_,source:u===0?0:1})}),c({terminated:this.terminateRequested,error:n})}handleSpawn(c,i,n,o,s){const a=new E.LineDecoder,u=new E.LineDecoder;c.stdout.on("data",g=>{a.write(g).forEach(_=>n({line:_,source:0}))}),c.stderr.on("data",g=>{u.write(g).forEach(_=>n({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=u}handleClose(c,i,n,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&n({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}e.LineProcess=y;function S(r){let c=[],i=!1;const n=function(o){if(i){c.push(o);return}(!r.send(o,a=>{if(a&&console.error(a),i=!1,c.length>0){const u=c.slice(0);c=[],u.forEach(g=>n(g))}})||R.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=S;var l;(function(r){async function c(i,n,o){if(A.isAbsolute(i))return i;if(n===void 0&&(n=b.cwd()),A.dirname(i)!=="."||(o===void 0&&P.isString(b.env.PATH)&&(o=b.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(n,i);async function a(u){if(await f.Promises.exists(u)){let g;try{g=await f.Promises.stat(u)}catch(I){I.message.startsWith("EACCES")&&(g=await f.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(let u of o){let g;if(A.isAbsolute(u)?g=A.join(u,i):g=A.join(n,u,i),await a(g))return g;let I=g+".com";if(await a(I)||(I=g+".exe",await a(I)))return I}return A.join(n,i)}r.findExecutable=c})(l=e.win32||(e.win32={}))}),define(te[124],ne([0,1,34,4,73,77]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(p,d){return p===1?t.isWindows?E():T.getWindowsShell(d):C(p,d)}e.getSystemShell=A;function R(p,d){return p===1?t.isWindows?f(d):T.getWindowsShell(d):C(p,d)}e.getSystemShellSync=R;let b=null;function C(p,d){if(t.isLinux&&p===2||t.isMacintosh&&p===3)return"/bin/bash";if(!b){let h;if(t.isWindows)h="/bin/bash";else{if(h=d.SHELL,!h)try{h=(0,k.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}b=h}return b}let P=null;async function E(){return P||(P=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(p){if(P)return P;const d=t.isWindows&&parseFloat((0,k.release)())>=10,h=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${p.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?v:T.getWindowsShell(p)}}),define(te[58],ne([0,1,46,5,17,25,107,9,3,2,28,77,36]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>L.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=p;class d{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(w),this.child=null,this._client=null}getChannel(v){const m=this;return{call(w,y,S){return m.requestPromise(v,w,y,S)},listen(w,y){return m.requestEvent(v,w,y)}}}requestPromise(v,m,w,y=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(v),l=(0,t.createCancelablePromise)(i=>S.call(m,w,i)),r=y.onCancellationRequested(()=>l.cancel()),c=(0,C.toDisposable)(()=>l.cancel());return this.activeRequests.add(c),l.finally(()=>{r.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(v,m,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let y;const S=new b.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(v).listen(m,w)(S.fire,S),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,k.fork)(this.modulePath,v,m);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,A.isRemoteConsoleLog)(n)){(0,A.log)(n,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(n,"base64")))});const S=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=n=>this.child&&this.child.connected&&S.send(n.buffer.toString("base64")),r=w.event,c={send:l,onMessage:r};this._client=new f.ChannelClient(c);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,C.dispose)(s)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=d}),define(te[125],ne([12,13]),function(K,e){return K.create("vs/base/node/zip",e)}),define(te[126],ne([12,13]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([12,13]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([12,13]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([12,13]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(te[138],ne([12,13]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(te[139],ne([12,13]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([12,13]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(te[141],ne([12,13]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([12,13]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([12,13]),function(K,e){return K.create("vs/platform/terminal/node/shellEnv",e)}),define(te[144],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[150],ne([0,1,4]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var t;(function(A){A.Team="team",A.Internal="internal",A.Insiders="insider",A.Public="public"})(t=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(A){A.Market="X-MSEdge-Market",A.CorpNet="X-FD-Corpnet",A.ApplicationVersion="X-VSCode-AppVersion",A.Build="X-VSCode-Build",A.ClientId="X-MSEdge-ClientId",A.ExtensionName="X-VSCode-ExtensionName",A.Language="X-VSCode-Language",A.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class T{constructor(R,b,C,P){this.version=R,this.appName=b,this.machineId=C,this.targetPopulation=P}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return k.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(L);for(let C of b)R.set(C,this.getFilterValue(C));return R}}e.AssignmentFilterProvider=T}),define(te[78],ne([0,1,57,54,19,10,33,20,7]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(h,v,m){this._args=h,this.paths=v,this.productService=m}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",K).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=A.env.VSCODE_PORTABLE;return h?b.URI.file((0,T.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,T.resolve)(h):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,T.resolve)(h):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,T.resolve)(h);const v=A.env.VSCODE_EXTENSIONS;if(v)return v;const m=A.env.VSCODE_PORTABLE;return m?(0,T.join)(m,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(v=>/^[^:/?#]+?:\/\//.test(v)?b.URI.parse(v):b.URI.file((0,T.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?b.URI.parse(h):b.URI.file((0,T.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([t.memoize],C.prototype,"appRoot",null),de([t.memoize],C.prototype,"userHome",null),de([t.memoize],C.prototype,"userDataPath",null),de([t.memoize],C.prototype,"appSettingsHome",null),de([t.memoize],C.prototype,"tmpDir",null),de([t.memoize],C.prototype,"cacheHome",null),de([t.memoize],C.prototype,"userRoamingDataHome",null),de([t.memoize],C.prototype,"settingsResource",null),de([t.memoize],C.prototype,"userDataSyncHome",null),de([t.memoize],C.prototype,"userDataSyncLogResource",null),de([t.memoize],C.prototype,"sync",null),de([t.memoize],C.prototype,"machineSettingsResource",null),de([t.memoize],C.prototype,"globalStorageHome",null),de([t.memoize],C.prototype,"workspaceStorageHome",null),de([t.memoize],C.prototype,"keybindingsResource",null),de([t.memoize],C.prototype,"keyboardLayoutResource",null),de([t.memoize],C.prototype,"argvResource",null),de([t.memoize],C.prototype,"snippetsHome",null),de([t.memoize],C.prototype,"isExtensionDevelopment",null),de([t.memoize],C.prototype,"untitledWorkspacesHome",null),de([t.memoize],C.prototype,"installSourcePath",null),de([t.memoize],C.prototype,"builtinExtensionsPath",null),de([t.memoize],C.prototype,"extensionsPath",null),de([t.memoize],C.prototype,"extensionDevelopmentLocationURI",null),de([t.memoize],C.prototype,"extensionDevelopmentKind",null),de([t.memoize],C.prototype,"extensionTestsLocationURI",null),de([t.memoize],C.prototype,"debugExtensionHost",null),de([t.memoize],C.prototype,"serviceMachineIdResource",null),de([t.memoize],C.prototype,"telemetryLogResource",null),de([t.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function P(d,h){return p(d["inspect-extensions"],d["inspect-brk-extensions"],5870,h,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=P;function E(d,h){return p(d["inspect-search"],d["inspect-brk-search"],5876,h,d.extensionEnvironment)}e.parseSearchPort=E;function f(d,h){return p(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,h,d.extensionEnvironment)}e.parsePtyHostPort=f;function p(d,h,v,m,w,y){const l=Number(h||d)||(m?null:v),r=l?Boolean(!!h):!1;let c;if(y)try{c=JSON.parse(y)}catch{}return{port:l,break:r,debugId:w,env:c}}}),define(te[151],ne([0,1,254,4,127]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(d,h,v=A){const m={},w=[],y=[];for(let c in h){const i=h[c];i.alias&&(m[c]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(c),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(y.push(c),i.deprecates&&y.push(...i.deprecates))}const S=k(d,{string:w,boolean:y,alias:m}),l={},r=S;l._=S._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(let c in h){const i=h[c];i.alias&&delete r[i.alias];let n=r[c];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(n||(n=r[o],n&&v.onDeprecatedOption(o,i.deprecationMessage||(0,L.localize)(33,null))),delete r[o]);typeof n!="undefined"&&(i.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):i.type==="string"&&Array.isArray(n)&&(n=n.pop(),v.onMultipleValues(c,n)),l[c]=n,i.deprecationMessage&&v.onDeprecatedOption(c,i.deprecationMessage)),delete r[c]}for(let c in r)v.onUnknownOption(c);return l}e.parseArgs=R;function b(d,h){let v="";return h.args&&(Array.isArray(h.args)?v=` <${h.args.join("> <")}>`:v=` <${h.args}>`),h.alias?`-${h.alias} --${d}${v}`:`--${d}${v}`}function C(d,h){let v=0,m=[];for(const l in d){const r=d[l],c=b(l,r);v=Math.max(v,c.length),m.push([c,r.description])}let w=v+2+1;if(h-w<25)return m.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let y=h-w-1,S=[];for(const l of m){let r=l[0],c=E(l[1],y),i=P(w-r.length-2);S.push("  "+r+i+c[0]);for(let n=1;n<c.length;n++)S.push(P(w)+c[n])}return S}e.formatOptions=C;function P(d){return" ".repeat(d)}function E(d,h){let v=[];for(;d.length;){let m=d.length<h?d.length:d.lastIndexOf(" ",h),w=d.slice(0,m).trim();d=d.slice(m),v.push(w)}return v}function f(d,h,v,m,w){const y=process.stdout.isTTY&&process.stdout.columns||80,S=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",l=[`${d} ${v}`];l.push(""),l.push(`${(0,L.localize)(35,null)}: ${h} [${(0,L.localize)(36,null)}]${S}`),l.push(""),w?.noPipe!==!0&&(t.isWindows?l.push((0,L.localize)(37,null,h)):l.push((0,L.localize)(38,null,h)),l.push(""));const r={};for(const c in m){const i=m[c];if(i.description&&i.cat){let n=r[i.cat];n||(r[i.cat]=n={}),n[c]=i}}for(let c in r){const i=c;let n=r[i];n&&(l.push(T[i]),l.push(...C(n,y)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function p(d,h){return`${d||(0,L.localize)(39,null)}
${h||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),define(te[152],ne([0,1,255,128,151]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(f,p){const d={onUnknownOption:v=>{console.warn((0,t.localize)(0,null,v))},onMultipleValues:(v,m)=>{console.warn((0,t.localize)(1,null,v,m))},onDeprecatedOption:(v,m)=>{console.warn((0,t.localize)(2,null,v,m))}},h=(0,L.parseArgs)(f,L.OPTIONS,p?d:void 0);return h.goto&&h._.forEach(v=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,t.localize)(3,null))),h["max-memory"]&&k(parseInt(h["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),h}function R(f){const p=f.findIndex(d=>!/^-/.test(d));if(p>-1)return[...f.slice(0,p),...f.slice(p+1)]}function b(f){let[,...p]=f;process.env.VSCODE_DEV&&(p=R(p)||[]);const d=!E(process.env);return A(p,d)}e.parseMainProcessArgv=b;function C(f){const[,,...p]=f;return A(p,!0)}e.parseCLIProcessArgv=C;function P(f,...p){const d=f.indexOf("--");return d===-1?f.push(...p):f.splice(d,0,...p),f}e.addArg=P;function E(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function K(e,k,t,L){function T(R){const b=A(R),C=[b];return e.isAbsolute(b)||C.unshift(L),e.resolve(...C)}function A(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,t);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(E,"AppData","Roaming")}break;case"darwin":C=e.join(k.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,t)}return{getUserDataPath:T}}if(typeof define=="function")define(te[153],ne([0,256,34,19,20,33]),function(e,k,t,L,T,A){const R=T.dirname(L.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);return K(k,t,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),t=require("os");module.exports=K(k,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[154],ne([0,1,34,78,153]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends t.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=T}),define(te[155],ne([0,1,7]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(v){const m=v.match(A);return m?m[1]:null}function P(v){if(v.indexOf("://")===-1){const m=v.match(t);return m?C(m[2]):null}try{const m=k.URI.parse(v);if(m.authority)return C(m.authority)}catch{}return null}function E(v,m){const w=new Set;let y;for(;y=R.exec(v);){const l=P(y[1]);l&&w.add(l)}const S=new Set(m);return Array.from(w).map(l=>S.has(l)?l:l.replace(b,"a"))}e.getDomainsOfRemotes=E;function f(v){const m=v.match(T);return m?m[2]:null}function p(v,m,w){return v&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${v}${m}`:`${v}/${m}`):null}function d(v,m){if(v.indexOf("://")===-1){const w=v.match(L);if(w)return p(w[2],w[3],m)}try{const w=k.URI.parse(v);if(w.authority)return p(f(w.authority),w.path,m)}catch{}return null}function h(v,m=!1){const w=[];let y;for(;y=R.exec(v);){const S=d(y[1],m);S&&w.push(S)}return w}e.getRemotes=h}),define(te[156],ne([0,1,28]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const t=/^%([\w\d.-]+)%$/i;function L(T,A){const R=b=>{if(typeof b!="string")return;const C=t.exec(b);if(!C)return;const P=A[C[1]]??b;return typeof P=="string"?P:typeof P.message=="string"?P.message:b};return(0,k.cloneAndChange)(T,R)}e.localizeManifest=L}),define(te[157],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,R,b])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class t{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(te[79],ne([0,1,135]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||t.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=f.match(t);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=A;function R(f){if(!f)return null;let p=f.majorBase,d=f.majorMustEqual,h=f.minorBase,v=f.minorMustEqual,m=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(p===0||(v=!1),w=!1);let y=0;if(f.preRelease){const S=L.exec(f.preRelease);if(S){const[,l,r,c]=S;y=Date.UTC(Number(l),Number(r)-1,Number(c))}}return{majorBase:p,majorMustEqual:d,minorBase:h,minorMustEqual:v,patchBase:m,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:y}}e.normalizeVersion=R;function b(f,p,d){let h;typeof f=="string"?h=R(A(f)):h=f;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let m;if(typeof d=="string"?m=R(A(d)):m=d,!h||!m)return!1;let w=h.majorBase,y=h.minorBase,S=h.patchBase,l=m.majorBase,r=m.minorBase,c=m.patchBase,i=m.notBefore,n=m.majorMustEqual,o=m.minorMustEqual,s=m.patchMustEqual;return m.isMinimum?w>l?!0:w<l?!1:y>r?!0:y<r||v&&v<i?!1:S>=c:(w===1&&l===0&&(!n||!o||!s)&&(l=1,r=0,c=0,n=!0,o=!1,s=!1),w<l?!1:w>l?!n:y<r?!1:y>r?!o:S<c?!1:S>c?!s:!(v&&v<i))}e.isValidVersion=b;function C(f,p,d,h){return d.isBuiltin||typeof d.main=="undefined"?!0:E(f,p,d.engines.vscode,h)}e.isValidExtensionVersion=C;function P(f,p,d){return f==="*"||E(p,d,f)}e.isEngineValid=P;function E(f,p,d,h=[]){let v=R(A(d));if(!v)return h.push(k.localize(0,null,d)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return h.push(k.localize(1,null,d)),!1}else if(!v.majorMustEqual)return h.push(k.localize(2,null,d)),!1;return b(f,p,v)?!0:(h.push(k.localize(3,null,f,d)),!1)}}),define(te[47],ne([0,1,17,29]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const P=(await A.readFile(T.serviceMachineIdResource)).value.toString();b=(0,t.isUUID)(P)?P:null}catch{b=null}if(!b){b=(0,t.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,k.VSBuffer.fromString(b))}catch{}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=L}),define(te[51],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=k}),define(te[80],ne([0,1,51]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function L(A,R,b){R instanceof k.SyncDescriptor||(R=new k.SyncDescriptor(R,[],b)),t.push([A,R])}e.registerSingleton=L;function T(){return t}e.getSingletonServiceDescriptors=T}),define(te[158],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=k;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const R=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(T),R)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let R=this._nodes.get(A);return R||(R=new k(T),this._nodes.set(A,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,R]of this._nodes)T.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const R=new Set([T]),b=this._findCycle(A,R);if(b)return b}}_findCycle(T,A){for(let[R,b]of T.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const C=this._findCycle(b,A);if(C)return C;A.delete(R)}}}e.Graph=t}),define(te[6],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function t(A,R,b){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:A,index:b}):(R[k.DI_DEPENDENCIES]=[{id:A,index:b}],R[k.DI_TARGET]=R)}function L(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const R=function(b,C,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(R,b,P)};return R.toString=()=>A,k.serviceIds.set(A,R),R}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(te[159],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(te[18],ne([0,1,11,7,6]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationOverrides=T;function A(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||k.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var R;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function C(v,m){const w=Object.create(null);for(let y in v)P(w,y,v[y],m);return w}e.toValuesTree=C;function P(v,m,w,y){const S=m.split("."),l=S.pop();let r=v;for(let c=0;c<S.length;c++){let i=S[c],n=r[i];switch(typeof n){case"undefined":n=r[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${m} as ${S.slice(0,c+1).join(".")} is ${JSON.stringify(n)}`);return}r=n}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{y(`Ignoring ${m} as ${S.join(".")} is ${JSON.stringify(r)}`)}else y(`Ignoring ${m} as ${S.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function E(v,m){const w=m.split(".");f(v,w)}e.removeFromValueTree=E;function f(v,m){const w=m.shift();if(m.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const y=v[w];typeof y=="object"&&!Array.isArray(y)&&(f(y,m),Object.keys(y).length===0&&delete v[w])}}function p(v,m,w){function y(r,c){let i=r;for(const n of c){if(typeof i!="object"||i===null)return;i=i[n]}return i}const S=m.split("."),l=y(v,S);return typeof l=="undefined"?w:l}e.getConfigurationValue=p;function d(v,m,w){Object.keys(m).forEach(y=>{y!=="__proto__"&&(y in v?k.isObject(v[y])&&k.isObject(m[y])?d(v[y],m[y],w):w&&(v[y]=m[y]):v[y]=m[y])})}e.merge=d;function h(v,m,w){const y=v.inspect(m),S=v.inspect(w);return typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:y.defaultValue}e.getMigratedSettingValue=h}),define(te[160],ne([0,1,4,26,6]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",k.isMacintosh),T.set("isLinux",k.isLinux),T.set("isWindows",k.isWindows),T.set("isWeb",k.isWeb),T.set("isMacNative",k.isMacintosh&&!k.isWeb),T.set("isEdge",k.isEdge),T.set("isFirefox",k.isFirefox),T.set("isChrome",k.isChrome),T.set("isSafari",k.isSafari);const A=Object.prototype.hasOwnProperty;var R;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return E.INSTANCE}static true(){return f.INSTANCE}static has(D){return p.create(D)}static equals(D,N){return d.create(D,N)}static notEquals(D,N){return m.create(D,N)}static regex(D,N){return i.create(D,N)}static in(D,N){return h.create(D,N)}static not(D){return w.create(D)}static and(...D){return s.create(D,null)}static or(...D){return a.create(D,null,!0)}static greater(D,N){return S.create(D,N)}static greaterEquals(D,N){return l.create(D,N)}static smaller(D,N){return r.create(D,N)}static smallerEquals(D,N){return c.create(D,N)}static deserialize(D,N=!1){if(!!D)return this._deserializeOrExpression(D,N)}static _deserializeOrExpression(D,N){let $=D.split("||");return a.create($.map(B=>this._deserializeAndExpression(B,N)),null,!0)}static _deserializeAndExpression(D,N){let $=D.split("&&");return s.create($.map(B=>this._deserializeOne(B,N)),null)}static _deserializeOne(D,N){if(D=D.trim(),D.indexOf("!=")>=0){let $=D.split("!=");return m.create($[0].trim(),this._deserializeValue($[1],N))}if(D.indexOf("==")>=0){let $=D.split("==");return d.create($[0].trim(),this._deserializeValue($[1],N))}if(D.indexOf("=~")>=0){let $=D.split("=~");return i.create($[0].trim(),this._deserializeRegexValue($[1],N))}if(D.indexOf(" in ")>=0){let $=D.split(" in ");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const $=D.split(">=");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const $=D.split(">");return S.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const $=D.split("<=");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const $=D.split("<");return r.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(D)?w.create(D.substr(1).trim()):p.create(D)}static _deserializeValue(D,N){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let $=/^'([^']*)'$/.exec(D);return $?$[1].trim():D}static _deserializeRegexValue(D,N){if((0,t.isFalsyOrWhitespace)(D)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=D.indexOf("/"),B=D.lastIndexOf("/");if($===B||$<0){if(N)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let Z=D.slice($+1,B),W=D[B+1]==="i"?"i":"";try{return new RegExp(Z,W)}catch(ee){if(N)throw new Error(`bad regexp-value '${D}', parse error: ${ee}`);return console.warn(`bad regexp-value '${D}', parse error: ${ee}`),null}}}e.ContextKeyExpr=b;function C(F,D){const N=F?F.substituteConstants():void 0,$=D?D.substituteConstants():void 0;return!N&&!$?!0:!N||!$?!1:N.equals($)}e.expressionsAreEqualWithConstantSubstitution=C;function P(F,D){return F.cmp(D)}class E{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class f{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class p{constructor(D,N){this.key=D,this.negated=N,this.type=2}static create(D,N=null){const $=T.get(D);return typeof $=="boolean"?$?f.INSTANCE:E.INSTANCE:new p(D,N)}cmp(D){return D.type!==this.type?this.type-D.type:g(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?f.INSTANCE:E.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class d{constructor(D,N,$){this.key=D,this.value=N,this.negated=$,this.type=4}static create(D,N,$=null){if(typeof N=="boolean")return N?p.create(D,$):w.create(D,$);const B=T.get(D);return typeof B=="boolean"?N===(B?"true":"false")?f.INSTANCE:E.INSTANCE:new d(D,N,$)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const N=D?"true":"false";return this.value===N?f.INSTANCE:E.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class h{constructor(D,N){this.key=D,this.valueKey=N,this.type=10,this.negated=null}static create(D,N){return new h(D,N)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const N=D.getValue(this.valueKey),$=D.getValue(this.key);return Array.isArray(N)?N.indexOf($)>=0:typeof $=="string"&&typeof N=="object"&&N!==null?A.call(N,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=h;class v{constructor(D){this._actual=D,this.type=11}static create(D){return new v(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new v(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class m{constructor(D,N,$){this.key=D,this.value=N,this.negated=$,this.type=5}static create(D,N,$=null){if(typeof N=="boolean")return N?w.create(D,$):p.create(D,$);const B=T.get(D);return typeof B=="boolean"?N===(B?"true":"false")?E.INSTANCE:f.INSTANCE:new m(D,N,$)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const N=D?"true":"false";return this.value===N?E.INSTANCE:f.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class w{constructor(D,N){this.key=D,this.negated=N,this.type=3}static create(D,N=null){const $=T.get(D);return typeof $=="boolean"?$?E.INSTANCE:f.INSTANCE:new w(D,N)}cmp(D){return D.type!==this.type?this.type-D.type:g(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?E.INSTANCE:f.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;function y(F,D){if(typeof F=="string"){const N=parseFloat(F);isNaN(N)||(F=N)}return typeof F=="string"||typeof F=="number"?D(F):E.INSTANCE}class S{constructor(D,N,$){this.key=D,this.value=N,this.negated=$,this.type=12}static create(D,N,$=null){return y(N,B=>new S(D,B,$))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class l{constructor(D,N,$){this.key=D,this.value=N,this.negated=$,this.type=13}static create(D,N,$=null){return y(N,B=>new l(D,B,$))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class r{constructor(D,N,$){this.key=D,this.value=N,this.negated=$,this.type=14}static create(D,N,$=null){return y(N,B=>new r(D,B,$))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class c{constructor(D,N,$){this.key=D,this.value=N,this.negated=$,this.type=15}static create(D,N,$=null){return y(N,B=>new c(D,B,$))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class i{constructor(D,N){this.key=D,this.regexp=N,this.type=7,this.negated=null}static create(D,N){return new i(D,N)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const N=this.regexp?this.regexp.source:"",$=D.regexp?D.regexp.source:"";return N<$?-1:N>$?1:0}equals(D){if(D.type===this.type){const N=this.regexp?this.regexp.source:"",$=D.regexp?D.regexp.source:"";return this.key===D.key&&N===$}return!1}substituteConstants(){return this}evaluate(D){let N=D.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{constructor(D){this._actual=D,this.type=8}static create(D){return new n(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(F){let D=null;for(let N=0,$=F.length;N<$;N++){const B=F[N].substituteConstants();if(F[N]!==B&&D===null){D=[];for(let Z=0;Z<N;Z++)D[Z]=F[Z]}D!==null&&(D[N]=B)}return D===null?F:D}class s{constructor(D,N){this.expr=D,this.negated=N,this.type=6}static create(D,N){return s._normalizeArr(D,N)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let N=0,$=this.expr.length;N<$;N++){const B=P(this.expr[N],D.expr[N]);if(B!==0)return B}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].equals(D.expr[N]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:s.create(D,this.negated)}evaluate(D){for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].evaluate(D))return!1;return!0}static _normalizeArr(D,N){const $=[];let B=!1;for(const Z of D)if(!!Z){if(Z.type===1){B=!0;continue}if(Z.type===0)return E.INSTANCE;if(Z.type===6){$.push(...Z.expr);continue}$.push(Z)}if($.length===0&&B)return f.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(P);for(let Z=1;Z<$.length;Z++)$[Z-1].equals($[Z])&&($.splice(Z,1),Z--);if($.length===1)return $[0];for(;$.length>1;){const Z=$[$.length-1];if(Z.type!==9)break;$.pop();const W=$.pop(),ee=$.length===0,x=a.create(Z.expr.map(j=>s.create([j,W],null)),null,ee);x&&($.push(x),$.sort(P))}return $.length===1?$[0]:new s($,N)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let N of this.expr)D.push(...N.keys());return D}map(D){return new s(this.expr.map(N=>N.map(D)),null)}negate(){if(!this.negated){const D=[];for(let N of this.expr)D.push(N.negate());this.negated=a.create(D,this,!0)}return this.negated}}class a{constructor(D,N){this.expr=D,this.negated=N,this.type=9}static create(D,N,$){return a._normalizeArr(D,N,$)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let N=0,$=this.expr.length;N<$;N++){const B=P(this.expr[N],D.expr[N]);if(B!==0)return B}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].equals(D.expr[N]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:a.create(D,this.negated,!1)}evaluate(D){for(let N=0,$=this.expr.length;N<$;N++)if(this.expr[N].evaluate(D))return!0;return!1}static _normalizeArr(D,N,$){let B=[],Z=!1;if(D){for(let W=0,ee=D.length;W<ee;W++){const x=D[W];if(!!x){if(x.type===0){Z=!0;continue}if(x.type===1)return f.INSTANCE;if(x.type===9){B=B.concat(x.expr);continue}B.push(x)}}if(B.length===0&&Z)return E.INSTANCE;B.sort(P)}if(B.length!==0){if(B.length===1)return B[0];for(let W=1;W<B.length;W++)B[W-1].equals(B[W])&&(B.splice(W,1),W--);if(B.length===1)return B[0];if($){for(let W=0;W<B.length;W++)for(let ee=W+1;ee<B.length;ee++)_(B[W],B[ee])&&(B.splice(ee,1),ee--);if(B.length===1)return B[0]}return new a(B,N)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let N of this.expr)D.push(...N.keys());return D}map(D){return new a(this.expr.map(N=>N.map(D)),null)}negate(){if(!this.negated){let D=[];for(let N of this.expr)D.push(N.negate());for(;D.length>1;){const N=D.shift(),$=D.shift(),B=[];for(const W of M(N))for(const ee of M($))B.push(s.create([W,ee],null));const Z=D.length===0;D.unshift(a.create(B,null,Z))}this.negated=D[0]}return this.negated}}class u extends p{constructor(D,N,$){super(D,null);this._defaultValue=N,typeof $=="object"?u._info.push({...$,key:D}):$!==!0&&u._info.push({key:D,description:$,type:N!=null?typeof N:void 0})}static all(){return u._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return d.create(this.key,D)}notEqualsTo(D){return m.create(this.key,D)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(F,D){return F<D?-1:F>D?1:0}function I(F,D,N,$){return F<N?-1:F>N?1:D<$?-1:D>$?1:0}function _(F,D){if(D.type===6&&F.type!==9&&F.type!==6){for(const B of D.expr)if(F.equals(B))return!0}const N=F.negate(),$=M(N).concat(M(D));$.sort(P);for(let B=0;B<$.length;B++){const W=$[B].negate();for(let ee=B+1;ee<$.length;ee++){const x=$[ee];if(W.equals(x))return!0}}return!1}e.implies=_;function M(F){return F.type===9?F.expr:[F]}}),define(te[81],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function t(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=t;class L{async getPerformanceInfo(A,R){return{}}async getSystemInfo(A,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,R){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=L}),define(te[82],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(te[14],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(te[83],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[15],ne([0,1,9,39,10,26,11,7,137,6]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var E;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var f;(function(W){W[W.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var p;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=d;function h(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=h;function v(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function m(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=m;function w(W){return d(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var y;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(ee,x){super(ee);this.code=x}}e.FileSystemProviderError=S;function l(W,ee){const x=new S(W.toString(),ee);return c(x,ee),x}e.createFileSystemProviderError=l;function r(W){return W||l((0,b.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=r;function c(W,ee){return W.name=ee?`${ee} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=c;function i(W){if(!W)return y.Unknown;if(W instanceof S)return W.code;const ee=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ee)return y.Unknown;switch(ee[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=i;function n(W){if(W instanceof I)return W.fileOperationResult;switch(i(W)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class s{constructor(ee,x,j){this.resource=ee,this.operation=x,this.target=j}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=s;var a;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class u{constructor(ee,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ee;const j=new Map;for(const Y of ee){const V=j.get(Y.type);switch(V?V.push([Y.resource,Y]):j.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,V]of j)switch(Y){case 1:this.added=t.TernarySearchTree.forUris(()=>x),this.added.fill(V);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>x),this.updated.fill(V);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>x),this.deleted.fill(V);break}}contains(ee,...x){return this.doContains(ee,{includeChildren:!1},...x)}affects(ee,...x){return this.doContains(ee,{includeChildren:!0},...x)}doContains(ee,x,...j){if(!ee)return!1;const Y=j.length>0;return!!((!Y||j.includes(1))&&(this.added?.get(ee)||x.includeChildren&&this.added?.findSuperstr(ee))||(!Y||j.includes(0))&&(this.updated?.get(ee)||x.includeChildren&&this.updated?.findSuperstr(ee))||(!Y||j.includes(2))&&(this.deleted?.findSubstr(ee)||x.includeChildren&&this.deleted?.findSuperstr(ee)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=u;function g(W,ee,x){return!W||!ee||W===ee||ee.length>W.length?!1:(ee.charAt(ee.length-1)!==L.sep&&(ee+=L.sep),x?(0,T.startsWithIgnoreCase)(W,ee):W.indexOf(ee)===0)}e.isParent=g;class I extends k.ErrorNoTelemetry{constructor(ee,x,j){super(ee);this.fileOperationResult=x,this.options=j}}e.FileOperationError=I;class _ extends I{constructor(ee,x,j){super(ee,2,j);this.stat=x}}e.NotModifiedSinceFileOperationError=_;var M;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=D;async function N(W,ee){if(!ee.hasProvider(R.URI.from({scheme:W.scheme})))return new Promise(x=>{const j=ee.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===W.scheme&&Y.added&&(j.dispose(),x())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(ee){return(0,A.isNumber)(ee)||(ee=0),ee<$.KB?(0,b.localize)(1,null,ee.toFixed(0)):ee<$.MB?(0,b.localize)(2,null,(ee/$.KB).toFixed(2)):ee<$.GB?(0,b.localize)(3,null,(ee/$.MB).toFixed(2)):ee<$.TB?(0,b.localize)(4,null,(ee/$.GB).toFixed(2)):(0,b.localize)(5,null,(ee/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var B;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function Z(W){return{maxFileSize:W===0?300*$.MB:16*$.GB,maxHeapSize:W===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=Z});var G=this&&this.__param||function(K,e){return function(k,t){e(k,t,K)}};define(te[161],ne([0,1,84,40,15]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((C,P)=>{const E=(0,k.createHash)("md5");(0,t.listenStream)(b,{onData:f=>E.update(f.buffer),onError:f=>P(f),onEnd:()=>C(E.digest("base64").replace(/=+$/,""))})})}};T=de([G(0,L.IFileService)],T),e.ChecksumService=T}),define(te[162],ne([0,1,17,37,9,3,2,40,7,29,15]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends A.Disposable{constructor(p,d){super();this.channel=p,this.extraCapabilities=d,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,C.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,d){const{buffer:h}=await this.channel.call("readFile",[p,d]);return h}readFileStream(p,d,h){const v=(0,R.newWriteableStream)(w=>k.VSBuffer.concat(w.map(y=>k.VSBuffer.wrap(y))).buffer),m=this.channel.listen("readFileStream",[p,d])(w=>{if(w instanceof k.VSBuffer)v.write(w.buffer);else{if(w==="end")v.end();else{let y=w;y instanceof Error||(y=(0,P.createFileSystemProviderError)((0,t.toErrorMessage)(y),P.FileSystemProviderErrorCode.Unknown)),v.error(y),v.end()}m.dispose()}});return h.onCancellationRequested(()=>{v.error((0,L.canceled)()),v.end(),m.dispose()}),v}writeFile(p,d,h){return this.channel.call("writeFile",[p,k.VSBuffer.wrap(d),h])}open(p,d){return this.channel.call("open",[p,d])}close(p){return this.channel.call("close",[p])}async read(p,d,h,v,m){const[w,y]=await this.channel.call("read",[p,d,m]);return h.set(w.buffer.slice(0,y),v),y}write(p,d,h,v,m){return this.channel.call("write",[p,d,k.VSBuffer.wrap(h),v,m])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,d){return this.channel.call("delete",[p,d])}rename(p,d,h){return this.channel.call("rename",[p,d,h])}copy(p,d,h){return this.channel.call("copy",[p,d,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const d=p;this._onDidChange.fire(d.map(h=>({resource:b.URI.revive(h.resource),type:h.type})))}else{const d=p;this._onDidWatchError.fire(d)}}))}watch(p,d){const h=(0,C.generateUuid)();return this.channel.call("watch",[this.sessionId,h,p,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=E}),define(te[85],ne([0,1,17,9,138,15]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(P,E,f,p,d,h){let v;try{await R(P,E,f,p,d,h)}catch(m){v=m}finally{v&&d.errorTransformer&&(v=d.errorTransformer(v)),typeof v!="undefined"&&f.error(v),f.end()}}e.readFileIntoStream=A;async function R(P,E,f,p,d,h){b(h);const v=await P.open(E,{create:!1});try{b(h);let m=0,w=0,y=d&&typeof d.length=="number"?d.length:void 0,S=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof y=="number"?y:d.bufferSize)),l=d&&typeof d.position=="number"?d.position:0,r=0;do w=await P.read(v,l,S.buffer,r,S.byteLength-r),l+=w,r+=w,m+=w,typeof y=="number"&&(y-=w),r===S.byteLength&&(await f.write(p(S)),S=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof y=="number"?y:d.bufferSize)),r=0);while(w>0&&(typeof y!="number"||y>0)&&b(h)&&C(m,d));if(r>0){let c=r;typeof y=="number"&&(c=Math.min(r,y)),f.write(p(S.slice(0,c)))}}catch(m){throw(0,T.ensureFileSystemProviderError)(m)}finally{await P.close(v)}}function b(P){if(P.isCancellationRequested)throw(0,t.canceled)();return!0}function C(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[52],ne([0,1,2,4,7,15]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(p){return p.recursive===!0}e.isRecursiveWatchRequest=A;class R extends k.Disposable{constructor(d,h,v,m){super();this.onFileChanges=d,this.onLogMessage=h,this.verboseLogging=v,this.options=m,this.watcherDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new k.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),d.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),d.add(this.watcher.onDidError(h=>this.onError(h)))}onError(d){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class b extends R{constructor(d,h,v){super(d,h,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class C extends R{constructor(d,h,v){super(d,h,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function P(p){return p.map(d=>({type:d.type,resource:L.URI.file(d.path)}))}e.toFileChanges=P;function E(p){const d=new f;for(const h of p)d.processEvent(h);return d.coalesce()}e.coalesceEvents=E;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return t.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const h=this.mapPathToChange.get(this.toKey(d));let v=!1;if(h){const m=h.type,w=d.type;h.path!==d.path&&(d.type===2||d.type===1)?v=!0:m===1&&w===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(h)):m===2&&w===1?h.type=0:m===1&&w===0||(h.type=w)}else v=!0;v&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],h=[];return Array.from(this.coalesced).filter(v=>v.type!==2?(d.push(v),!1):!0).sort((v,m)=>v.path.length-m.path.length).filter(v=>h.some(m=>(0,T.isParent)(v.path,m,!t.isLinux))?!1:(h.push(v.path),!0)).concat(d)}}}),define(te[163],ne([0,1,50,5,25,41,109,2,72,10,4,114,22,52]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends R.Disposable{constructor(m,w,y,S){super();this.request=m,this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=S,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,A.parse)(l)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(m);this._register(await this.doWatch(m,w.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let w=m.path;try{w=await f.Promises.realpath(m.path),m.path===w&&(w=await(0,E.realcase)(m.path)??m.path),m.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${w})`)}catch{}return w}async doWatch(m,w){if(P.isMacintosh&&(0,T.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const y=new L.CancellationTokenSource(this.cts.token);let S=new R.DisposableStore;try{const l=(0,C.basename)(m),r=(0,k.watch)(m);S.add((0,R.toDisposable)(()=>{r.removeAllListeners(),r.close()})),this.trace(`Started watching: '${m}'`);const c=new Set;if(w)try{for(const n of await f.Promises.readdir(m))c.add(n)}catch(n){this.error(n)}const i=new Map;S.add((0,R.toDisposable)(()=>{for(const[,n]of i)n.dispose();i.clear()})),r.on("error",(n,o)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),r.on("change",(n,o)=>{if(y.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${o}`);let s="";if(o&&(s=o.toString(),P.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(w)if(n==="rename"){i.get(s)?.dispose();const a=setTimeout(async()=>{if(i.delete(s),s===l&&!await f.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,C.join)(m,s));if(y.token.isCancellationRequested)return;let g;u?c.has(s)?g=0:(g=1,c.add(s)):(c.delete(s),g=2),this.onFileChange({path:(0,C.join)(this.request.path,s),type:g})},d.FILE_DELETE_HANDLER_DELAY);i.set(s,(0,R.toDisposable)(()=>clearTimeout(a)))}else{let a;c.has(s)?a=0:(a=1,c.add(s)),this.onFileChange({path:(0,C.join)(this.request.path,s),type:a})}else if(n==="rename"||s!==l){const a=setTimeout(async()=>{const u=await f.Promises.exists(m);y.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),S.add(await this.doWatch(m,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);S.clear(),S.add((0,R.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await f.Promises.exists(m)&&!y.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${l.toString()})`)}return(0,R.toDisposable)(()=>{y.dispose(!0),S.dispose()})}async onFileChange(m,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!w&&this.excludes.some(y=>y(m.path))?this.verboseLogging&&this.trace(` >> ignored ${m.path}`):this.fileChangesBuffer.push(m);try{await this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,p.coalesceEvents)(y);if(S.length>0){if(this.verboseLogging)for(const r of S)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(S)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${S.length}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(m){if(P.isLinux)return f.Promises.exists(m);try{const w=(0,C.basename)(m);return(await f.Promises.readdir((0,C.dirname)(m))).some(S=>S===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=50;async function h(v,m,w,y,S=512){const l=await f.Promises.open(v,"r"),r=Buffer.allocUnsafe(S),c=new L.CancellationTokenSource(y);let i,n=!1;const o={path:v,excludes:[],recursive:!1},s=new d(o,a=>{(async()=>{for(const{type:u}of a)if(u===0){if(n)return;n=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:g}=await f.Promises.read(l,r,0,S,null);if(!g||c.token.isCancellationRequested)break;m(r.slice(0,g))}}catch(g){i=new Error(g),c.dispose(!0)}finally{n=!1}}})()});return await s.ready,w(),new Promise((a,u)=>{c.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(l)}catch(g){i=new Error(g)}i?u(i):a()})})}e.watchFileContents=h}),define(te[164],ne([0,1,16,3,2,4,163]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new t.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=t.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(C){const P=this.normalizeRequests(C),E=P.filter(p=>{const d=this.watchers.get(p.path);return d?!(0,k.equals)(d.request.excludes,p.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:p})=>!P.find(d=>d.path===p.path&&(0,k.equals)(d.excludes,p.excludes))).map(({request:p})=>p.path);E.length&&this.trace(`Request to start watching: ${E.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const p of f)this.stopWatching(p);for(const p of E)this.startWatching(p)}startWatching(C){const P=new A.NodeJSFileWatcherLibrary(C,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),E={request:C,instance:P};this.watchers.set(C.path,E)}async stop(){for(const[C]of this.watchers)this.stopWatching(C);this.watchers.clear()}stopWatching(C){const P=this.watchers.get(C);P&&(this.watchers.delete(C),P.instance.dispose())}normalizeRequests(C){const P=new Map;for(const E of C){const f=T.isLinux?E.path:E.path.toLowerCase();P.set(f,E)}return Array.from(P.values())}async setVerboseLogging(C){this.verboseLogging=C;for(const[,P]of this.watchers)P.instance.setVerboseLogging(C)}trace(C){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C)})}toMessage(C,P){return P?`[File Watcher (node.js)] ${C} (path: ${P.request.path})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=R}),define(te[165],ne([0,1,52,164]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends k.AbstractNonRecursiveWatcherClient{constructor(A,R,b){super(A,R,b);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(te[166],ne([0,1,19,36,58,52]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(b,C,P){super(b,C,P);this.init()}createWatcher(b){const C=b.add(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(C.onDidProcessExit(({code:P,signal:E})=>this.onError(`terminated by itself with code ${P}, signal: ${E}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(C.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(te[86],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...L){this._entries=new Map;for(let[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=k}),define(te[167],ne([0,1,5,9,51,158,6,86]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class P{constructor(d=new R.ServiceCollection,h=!1,v){this._activeInstantiations=new Set,this._services=d,this._strict=h,this._parent=v,this._services.set(A.IInstantiationService,this)}createChild(d){return new P(d,this._strict,this)}invokeFunction(d,...h){let v=f.traceInvocation(d),m=!1;try{return d({get:y=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(y,v);if(!S)throw new Error(`[invokeFunction] unknown service '${y}'`);return S}},...h)}finally{m=!0,v.stop()}}createInstance(d,...h){let v,m;return d instanceof L.SyncDescriptor?(v=f.traceCreation(d.ctor),m=this._createInstance(d.ctor,d.staticArguments.concat(h),v)):(v=f.traceCreation(d),m=this._createInstance(d,h,v)),v.stop(),m}_createInstance(d,h=[],v){let m=A._util.getServiceDependencies(d).sort((S,l)=>S.index-l.index),w=[];for(const S of m){let l=this._getOrCreateServiceInstance(S.id,v);l||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${S.id}.`,!1),w.push(l)}let y=m.length>0?m[0].index:h.length;if(h.length!==y){console.warn(`[createInstance] First service dependency of ${d.name} at position ${y+1} conflicts with ${h.length} static arguments`);let S=y-h.length;S>0?h=h.concat(new Array(S)):h=h.slice(0,y)}return new d(...[...h,...w])}_setServiceInstance(d,h){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,h);else if(this._parent)this._parent._setServiceInstance(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let h=this._services.get(d);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):h}_getOrCreateServiceInstance(d,h){let v=this._getServiceInstanceOrDescriptor(d);return v instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,v,h.branch(d,!0)):(h.branch(d,!1),v)}_safeCreateAndCacheServiceInstance(d,h,v){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,h,v)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,h,v){const m=new T.Graph(S=>S.id.toString());let w=0;const y=[{id:d,desc:h,_trace:v}];for(;y.length;){const S=y.pop();if(m.lookupOrInsertNode(S),w++>1e3)throw new C(m);for(let l of A._util.getServiceDependencies(S.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(r||this._throwIfStrict(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`,!0),r instanceof L.SyncDescriptor){const c={id:l.id,desc:r,_trace:S._trace.branch(l.id,!0)};m.insertEdge(S,c),y.push(c)}}}for(;;){const S=m.roots();if(S.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:l}of S){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const c=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,c)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,h,v=[],m,w){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(h,v,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,h,v,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(d,h=[],v,m){if(v){const w=new k.IdleValue(()=>this._createInstance(d,h,m));return new Proxy(Object.create(null),{get(y,S){if(S in y)return y[S];let l=w.value,r=l[S];return typeof r!="function"||(r=r.bind(l),y[S]=r),r},set(y,S,l){return w.value[S]=l,!0}})}else return this._createInstance(d,h,m)}_throwIfStrict(d,h){if(h&&console.warn(h),this._strict)throw new Error(d)}}e.InstantiationService=P;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class f{constructor(d,h){this.type=d,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return b?new f(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(d){return b?new f(0,d.name):f._None}branch(d,h){let v=new f(2,d.toString());return this._dep.push([d,h,v]),v}stop(){let d=Date.now()-this._start;f._totals+=d;let h=!1;function v(w,y){let S=[],l=new Array(w+1).join("	");for(const[r,c,i]of y._dep)if(c&&i){h=!0,S.push(`${l}CREATES -> ${r}`);let n=v(w+1,i);n&&S.push(n)}else S.push(`${l}uses -> ${r}`);return S.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(d>2||h)&&console.log(m.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[168],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=k}),define(te[169],ne([0,1,36,51,80,6]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(p,d,h){const v=h.getChannel(p);return R(d)?new d.channelClientCtor(v):k.ProxyChannel.toService(v,d?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let b=class extends A{constructor(p,d,h){super(p,d,h)}};b=de([G(2,e.IMainProcessService)],b);function C(f,p,d){(0,L.registerSingleton)(f,new t.SyncDescriptor(b,[p,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let P=class extends A{constructor(p,d,h){super(p,d,h)}};P=de([G(2,e.ISharedProcessService)],P);function E(f,p,d){(0,L.registerSingleton)(f,new t.SyncDescriptor(P,[p,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[59],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function t(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const T of L.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=t}),define(te[170],ne([0,1,2,59]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends k.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([G(0,t.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(te[8],ne([0,1,37,3,2,4,6]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function C(c,i,n){switch(i){case b.Trace:c.trace(n);break;case b.Debug:c.debug(n);break;case b.Info:c.info(n);break;case b.Warning:c.warn(n);break;case b.Error:c.error(n);break;case b.Critical:c.critical(n);break;default:throw new Error("Invalid log level")}}e.log=C;function P(c){let i="";for(let n=0;n<c.length;n++){let o=c[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=P;class E extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class f extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(b.Trace)&&this.log(b.Trace,P([i,...n]))}debug(i,...n){this.checkLogLevel(b.Debug)&&this.log(b.Debug,P([i,...n]))}info(i,...n){this.checkLogLevel(b.Info)&&this.log(b.Info,P([i,...n]))}warn(i,...n){this.checkLogLevel(b.Warning)&&this.log(b.Warning,P([i,...n]))}error(i,...n){if(this.checkLogLevel(b.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(b.Error,P(o))}else this.log(b.Error,P([i,...n]))}critical(i,...n){this.checkLogLevel(b.Critical)&&this.log(b.Critical,P([i,...n]))}flush(){}}e.AbstractMessageLogger=f;class p extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...n){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...n):console.log(`[main ${R()}]`,i,...n))}debug(i,...n){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...n):console.log(`[main ${R()}]`,i,...n))}info(i,...n){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...n):console.log(`[main ${R()}]`,i,...n))}warn(i,...n){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...n):console.warn(`[main ${R()}]`,i,...n))}error(i,...n){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...n):console.error(`[main ${R()}]`,i,...n))}critical(i,...n){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...n):console.error(`[main ${R()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class d extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends E{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class v extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=v;class m extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=m;class w extends L.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?b.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class y{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=y;function S(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const i=l(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function l(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=l;function r(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(te[171],ne([0,1,5,9,2,10,22,14,8]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends L.Disposable{constructor(E,f){super();this.environmentService=E,this.logService=f,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),h=(await A.Promises.readdir(f)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),v=h.slice(0,Math.max(0,h.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(m=>A.Promises.rm((0,T.join)(f,m)))))}catch(E){(0,t.onUnexpectedError)(E)}}};C=de([G(0,R.IEnvironmentService),G(1,b.ILogService)],C),e.LogsDataCleaner=C}),define(te[172],ne([0,1,5,9,2,10,22,14,8]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class gt extends L.Disposable{constructor(E,f,p){super();this.backupWorkspacesPath=E,this.environmentService=f,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(h=>h.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async h=>{h.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||h===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(h)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${h}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,h)))}))}catch(E){(0,t.onUnexpectedError)(E)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=de([G(1,R.INativeEnvironmentService),G(2,b.ILogService)],C),e.StorageDataCleaner=C}),define(te[173],ne([0,1,46,5,37,3,2,19,10,22,14,8]),function(K,e,k,t,L,T,A,R,b,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(d,h){super();this.environmentService=d,this.logService=h,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const h=this.parseScript(d,"uninstall");return h&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${v}`)))),C.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(d,h){const v=`vscode:${h}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[v]=="string"){const m=d.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${v} should be a node script`),null):{script:(0,b.join)(d.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(d,h,v,m,w){return new Promise((y,S)=>{const l=this.start(d,h,v,w);let r;const c=i=>{r&&(clearTimeout(r),r=null),i?S(i):y(void 0)};l.on("error",i=>{c((0,L.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,n)=>{c(i?`post-${h} process exited with code ${i}`:void 0)}),m&&(r=setTimeout(()=>{r=null,l.kill(),S("timed out")},5e3))})}start(d,h,v,m){const w={silent:!0,execArgv:void 0},y=(0,k.fork)(d,[`--type=extension-post-${h}`,...v],w);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const S=T.Event.fromNodeEventEmitter(y.stdout,"data"),l=T.Event.fromNodeEventEmitter(y.stderr,"data");S(i=>this.logService.info(m.identifier.id,m.manifest.version,`post-${h}`,i)),l(i=>this.logService.error(m.identifier.id,m.manifest.version,`post-${h}`,i));const r=T.Event.any(T.Event.map(S,i=>({data:`%c${i}`,format:[""]})),T.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(r,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(m.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}getExtensionStoragePath(d){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};f=de([G(0,P.IEnvironmentService),G(1,E.ILogService)],f),e.ExtensionsLifecycle=f}),define(te[174],ne([0,1,16,5,9,3,2,10,52,8]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends A.Disposable{constructor(f,p){super();this.logService=f,this.options=p,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(f,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,p):this.watchNonRecursive(f,p)}watchUniversal(f,p){const d={path:this.toFilePath(f),excludes:p.excludes,recursive:p.recursive},h=(0,k.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,b.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const p of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const p of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(p)&&f.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,p){const d={path:this.toFilePath(f),excludes:p.excludes,recursive:!1},h=(0,k.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(te[175],ne([0,1,16,5,17,25,3,71,55,2,39,19,176,20,40,136,15,85,8]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends C.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${l}`);const c=new C.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),c.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new v.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&c.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),c.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,C.dispose)(c)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(c){r.push(c)}}),!this.provider.has(l)&&await t.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const c=this.provider.get(l.scheme);return!!(c&&c.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,p.isAbsolutePath)(l))throw new v.FileOperationError((0,h.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const c=new Error;throw c.name="ENOPRO",c.message=(0,h.localize)(1,null,l.toString()),c}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,v.hasOpenReadWriteCloseCapability)(r)||(0,v.hasReadWriteCapability)(r)||(0,v.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,v.hasOpenReadWriteCloseCapability)(r)||(0,v.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(c){throw(0,v.toFileSystemProviderErrorCode)(c)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,h.localize)(2,null,this.resourceForError(l)),1):(0,v.ensureFileSystemProviderError)(c)}}async doResolveFile(l,r){const c=await this.withProvider(l),i=this.isPathCaseSensitive(c),n=r?.resolveTo,o=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,a=await c.stat(l);let u;return this.toFileStat(c,l,a,void 0,!!s,(g,I)=>(u||(u=P.TernarySearchTree.forUris(()=>!i),u.set(l,!0),n&&u.fill(!0,n)),u.get(g.resource)||u.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&o?I===1:!1))}async toFileStat(l,r,c,i,n,o){const{providerExtUri:s}=this.getExtUri(l),a={resource:r,name:s.basename(r),isFile:(c.type&v.FileType.File)!=0,isDirectory:(c.type&v.FileType.Directory)!=0,isSymbolicLink:(c.type&v.FileType.SymbolicLink)!=0,mtime:c.mtime,ctime:c.ctime,size:c.size,readonly:Boolean((c.permissions??0)&v.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,v.etag)({mtime:c.mtime,size:c.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const u=await l.readdir(r),g=await t.Promises.settled(u.map(async([I,_])=>{try{const M=s.joinPath(r,I),F=n?await l.stat(M):{type:_};return await this.toFileStat(l,M,F,u.length,n,o)}catch(M){return this.logService.trace(M),null}}));a.children=(0,k.coalesce)(g)}catch(u){this.logService.trace(u),a.children=[]}return a}return a}async resolveAll(l){return t.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(c){return this.logService.trace(c),{stat:void 0,success:!1}}}))}async stat(l){const r=await this.withProvider(l),c=await r.stat(l);return this.toFileStat(r,l,c,void 0,!0,()=>!1)}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(c){return c}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new v.FileOperationError((0,h.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=L.VSBuffer.fromString(""),c){await this.doValidateCreateFile(l,c);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new v.FileOperationEvent(l,0,i)),i}async writeFile(l,r,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,l,c)||await this.mkdirp(i,n.dirname(l));let s;if((0,v.hasReadWriteCapability)(i)&&!(r instanceof L.VSBuffer))if((0,d.isReadableStream)(r)){const a=await(0,d.peekStream)(r,3);a.ended?s=L.VSBuffer.concat(a.buffer):s=a}else s=(0,d.peekReadable)(r,a=>L.VSBuffer.concat(a),3);else s=r;!(0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(i,l,c,s):await this.doWriteBuffered(i,l,c,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s),this._onDidRunOperation.fire(new v.FileOperationEvent(l,4))}catch(o){throw new v.FileOperationError((0,h.localize)(4,null,this.resourceForError(l),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),c)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,c){if(!!c?.unlock&&!(l.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(r)));let n;try{n=await l.stat(r)}catch{return}if((n.type&v.FileType.Directory)!=0)throw new v.FileOperationError((0,h.localize)(6,null,this.resourceForError(r)),0,c);if(this.throwIfFileIsReadonly(r,n),typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==v.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&c.mtime<n.mtime&&c.etag!==(0,v.etag)({mtime:c.mtime,size:n.size}))throw new v.FileOperationError((0,h.localize)(7,null),3,c);return n}async readFile(l,r,c){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,c):this.doReadFile(i,l,r,c)}async doReadFileAtomic(l,r,c,i){return new Promise((n,o)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,r,c,i);n(s)}catch(s){o(s)}})})}async doReadFile(l,r,c,i){const n=await this.doReadFileStream(l,r,{...c,preferUnbuffered:!0},i);return{...n,value:await(0,L.streamToBuffer)(n.value)}}async readFileStream(l,r,c){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,c)}async doReadFileStream(l,r,c,i){const n=new T.CancellationTokenSource(i),o=this.validateReadFile(r,c).then(a=>a,a=>{throw n.cancel(),a});let s;try{return typeof c?.etag=="string"&&c.etag!==v.ETAG_DISABLED&&await o,c?.atomic&&(0,v.hasFileAtomicReadCapability)(l)||!((0,v.hasOpenReadWriteCloseCapability)(l)||(0,v.hasFileReadStreamCapability)(l))||(0,v.hasReadWriteCapability)(l)&&c?.preferUnbuffered?s=this.readFileUnbuffered(l,r,c):(0,v.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,r,n.token,c):s=this.readFileBuffered(l,r,n.token,c),{...await o,value:s}}catch(a){s&&await(0,d.consumeStream)(s);const u=(0,h.localize)(8,null,this.resourceForError(r),(0,v.ensureFileSystemProviderError)(a).toString());throw a instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(u,a.stat,c):new v.FileOperationError(u,(0,v.toFileOperationResult)(a),c)}}readFileStreamed(l,r,c,i=Object.create(null)){const n=l.readFileStream(r,i,c);return(0,d.transform)(n,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new v.FileOperationError((0,h.localize)(9,null,this.resourceForError(r),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),i)},o=>L.VSBuffer.concat(o))}readFileBuffered(l,r,c,i=Object.create(null)){const n=(0,L.newWriteableBufferStream)();return(0,m.readFileIntoStream)(l,r,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new v.FileOperationError((0,h.localize)(10,null,this.resourceForError(r),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),i)},c),n}readFileUnbuffered(l,r,c){const i=(0,d.newWriteableStream)(n=>L.VSBuffer.concat(n));return(async()=>{try{let n;c?.atomic&&(0,v.hasFileAtomicReadCapability)(l)?n=await l.readFile(r,{atomic:!0}):n=await l.readFile(r),typeof c?.position=="number"&&(n=n.slice(c.position)),typeof c?.length=="number"&&(n=n.slice(0,c.length)),this.validateReadFileLimits(r,n.byteLength,c),i.end(L.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(l,r){const c=await this.resolve(l,{resolveMetadata:!0});if(c.isDirectory)throw new v.FileOperationError((0,h.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==v.ETAG_DISABLED&&r.etag===c.etag)throw new v.NotModifiedSinceFileOperationError((0,h.localize)(12,null),c,r);return this.validateReadFileLimits(l,c.size,r),c}validateReadFileLimits(l,r,c){if(c?.limits){let i;if(typeof c.limits.memory=="number"&&r>c.limits.memory&&(i=9),typeof c.limits.size=="number"&&r>c.limits.size&&(i=7),typeof i=="number")throw new v.FileOperationError((0,h.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,c){return this.doCanMoveCopy(l,r,"move",c)}async canCopy(l,r,c){return this.doCanMoveCopy(l,r,"copy",c)}async doCanMoveCopy(l,r,c,i){if(l.toString()!==r.toString())try{const n=c==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,l,o,r,c,i)}catch(n){return n}return!0}async move(l,r,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,n,r,"move",!!c),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(l,o==="move"?2:3,s)),s}async copy(l,r,c){const i=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,n,r,"copy",!!c),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(l,o==="copy"?3:2,s)),s}async doMoveCopy(l,r,c,i,n,o){if(r.toString()===i.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,r,c,i,n,o);if(s&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(i)),n==="copy"){if(l===c&&(0,v.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:o});else{const u=await this.resolve(r);u.isDirectory?await this.doCopyFolder(l,u,c,i):await this.doCopyFile(l,r,c,i)}return n}else return l===c?(await l.rename(r,i,{overwrite:o}),n):(await this.doMoveCopy(l,r,c,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,c,i){if((0,v.hasOpenReadWriteCloseCapability)(l)&&(0,v.hasOpenReadWriteCloseCapability)(c))return this.doPipeBuffered(l,r,c,i);if((0,v.hasOpenReadWriteCloseCapability)(l)&&(0,v.hasReadWriteCapability)(c))return this.doPipeBufferedToUnbuffered(l,r,c,i);if((0,v.hasReadWriteCapability)(l)&&(0,v.hasOpenReadWriteCloseCapability)(c))return this.doPipeUnbufferedToBuffered(l,r,c,i);if((0,v.hasReadWriteCapability)(l)&&(0,v.hasReadWriteCapability)(c))return this.doPipeUnbuffered(l,r,c,i)}async doCopyFolder(l,r,c,i){await c.mkdir(i),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async n=>{const o=this.getExtUri(c).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),c,o):this.doCopyFile(l,n.resource,c,o)}))}async doValidateMoveCopy(l,r,c,i,n,o){let s=!1;if(l===c){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(l);if(g||(s=u.isEqual(r,i)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&u.isEqualOrParent(i,r))throw new Error((0,h.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!s){if(!o)throw new v.FileOperationError((0,h.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===c){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(r,i))throw new Error((0,h.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const c=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(l,0,c)),c}async mkdirp(l,r){const c=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&v.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,v.toFileSystemProviderErrorCode)(n)!==v.FileSystemProviderErrorCode.FileNotFound)throw n;c.push(i.basename(r)),r=i.dirname(r)}for(let n=c.length-1;n>=0;n--){r=i.joinPath(r,c[n]);try{await l.mkdir(r)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(c){return c}return!0}async doValidateDelete(l,r){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(c.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(l)));let n;try{n=await c.stat(l)}catch{}if(n)this.throwIfFileIsReadonly(l,n);else throw new v.FileOperationError((0,h.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(l)))}return c}async del(l,r){const c=await this.doValidateDelete(l,r),i=!!r?.useTrash,n=!!r?.recursive;await c.delete(l,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new v.FileOperationEvent(l,1))}watch(l,r={recursive:!1,excludes:[]}){const c=new C.DisposableStore;let i=!1,n=()=>{i=!0};return c.add((0,C.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(l,r);i?(0,C.dispose)(o):n=()=>(0,C.dispose)(o)}catch(o){this.logService.error(o)}})(),c}async doWatch(l,r){const c=await this.withProvider(l),i=(0,R.hash)([this.getExtUri(c).providerExtUri.getComparisonKey(l),r]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:c.watch(l,r)},this.activeWatchers.set(i,n)),n.count+=1,(0,C.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,C.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,C.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,c,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const n=await l.open(r,{create:!0,unlock:c?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,n,i):await this.doWriteReadableBufferedQueued(l,n,i)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await l.close(n)}})}async doWriteStreamBufferedQueued(l,r,c){let i=0,n;if((0,d.isReadableBufferedStream)(c)){if(c.buffer.length>0){const o=L.VSBuffer.concat(c.buffer);await this.doWriteBuffer(l,r,o,o.byteLength,i,0),i+=o.byteLength}if(c.ended)return;n=c.stream}else n=c;return new Promise((o,s)=>{(0,d.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(l,r,a,a.byteLength,i,0)}catch(u){return s(u)}i+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>s(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,r,c){let i=0,n;for(;(n=c.read())!==null;)await this.doWriteBuffer(l,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(l,r,c,i,n,o){let s=0;for(;s<i;)s+=await l.write(r,n+s,c.buffer,o+s,i-s)}async doWriteUnbuffered(l,r,c,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,c,i))}async doWriteUnbufferedQueued(l,r,c,i){let n;i instanceof L.VSBuffer?n=i:(0,d.isReadableStream)(i)?n=await(0,L.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?n=await(0,L.bufferedStreamToBuffer)(i):n=(0,L.readableToBuffer)(i),await l.writeFile(r,n.buffer,{create:!0,overwrite:!0,unlock:c?.unlock??!1})}async doPipeBuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,c,i))}async doPipeBufferedQueued(l,r,c,i){let n,o;try{n=await l.open(r,{create:!1}),o=await c.open(i,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,u=0,g=0;do g=await l.read(n,a,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(c,o,s,g,a,u),a+=g,u+=g,u===s.byteLength&&(u=0);while(g>0)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof o=="number"?c.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,c,i))}async doPipeUnbufferedQueued(l,r,c,i){return c.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,c,i))}async doPipeUnbufferedToBufferedQueued(l,r,c,i){const n=await c.open(i,{create:!0,unlock:!1});try{const o=await l.readFile(r);await this.doWriteBuffer(c,n,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await c.close(n)}}async doPipeBufferedToUnbuffered(l,r,c,i){const n=await(0,L.streamToBuffer)(this.readFileBuffered(l,r,T.CancellationToken.None));await this.doWriteUnbuffered(c,i,void 0,n)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new v.FileOperationError((0,h.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,h.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===E.Schemas.file?l.fsPath:l.toString(!0)}};y=de([G(0,w.ILogService)],y),e.FileService=y}),define(te[177],ne([0,1,50,257,5,39,17,3,41,2,10,4,20,40,22,139,15,85,174,37,166,165]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(k)}catch(c){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(c)}`)}})();class r extends w.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new T.ResourceMap(o=>f.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,f.joinPath)(i,s.name))).type:a=this.toType(s),o.push([s.name,a])}catch(a){this.logService.trace(a)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=v.FileType.Unknown:i.isFile()?o=v.FileType.File:i.isDirectory()?o=v.FileType.Directory:o=v.FileType.Unknown,n&&(o|=v.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const s=new L.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,C.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),s.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const s=this.toFilePath(i);return await d.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(i,n,o){const s=(0,p.newWriteableStream)(a=>A.VSBuffer.concat(a.map(u=>A.VSBuffer.wrap(u))).buffer);return(0,m.readFileIntoStream)(this,i,s,a=>a.buffer,{...n,bufferSize:256*1024},o),s}async writeFile(i,n,o){let s;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await d.Promises.exists(a)){if(!o.overwrite)throw(0,v.createFileSystemProviderError)((0,h.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,v.createFileSystemProviderError)((0,h.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(s,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof s=="number"&&await this.close(s)}}async open(i,n){const o=this.toFilePath(i);let s;(0,v.isFileOpenForWriteOptions)(n)&&(s=await this.createResourceLock(i));let a;try{if((0,v.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:g}=await d.SymlinkSupport.stat(o);g.mode&128||await d.Promises.chmod(o,g.mode|128)}catch(g){this.logService.trace(g)}let u;if((0,v.isFileOpenForWriteOptions)(n)){if(E.isWindows)try{await d.Promises.truncate(o,0),u="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}u||(u="w")}else u="r";a=await d.Promises.open(o,u)}catch(u){throw s?.dispose(),(0,v.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}if(this.mapHandleToPos.set(a,0),(0,v.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,i),s){const u=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,s),u&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),u.dispose())}return a}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await d.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,s,a){const u=this.normalizePos(i,n);let g=null;try{g=(await d.Promises.read(i,o,s,a,u)).bytesRead}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(i,u,g)}return g}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,s+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,s,a){return(0,L.retry)(()=>this.doWrite(i,n,o,s,a),100,3)}async doWrite(i,n,o,s,a){const u=this.normalizePos(i,n);let g=null;try{g=(await d.Promises.write(i,o,s,a,u)).bytesWritten}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),I)}finally{this.updatePos(i,u,g)}return g}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const s=this.toFilePath(i),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await d.Promises.move(s,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,h.localize)(2,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(i,n,o){const s=this.toFilePath(i),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await d.Promises.copy(s,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,h.localize)(3,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(i,n,o,s){const a=this.toFilePath(i),u=this.toFilePath(n);let g=!1;if(!!(this.capabilities&1024)||(g=(0,b.isEqual)(a,u,!0)),g&&o==="copy")throw(0,v.createFileSystemProviderError)((0,h.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!g&&await d.Promises.exists(u)){if(!s)throw(0,v.createFileSystemProviderError)((0,h.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,n,o){return new S.UniversalWatcherClient(s=>i(s),s=>n(s),o)}createNonRecursiveWatcher(i,n,o){return new l.NodeJSWatcherClient(s=>i(s),s=>n(s),o)}toFileSystemProviderError(i){if(i instanceof v.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=v.FileSystemProviderErrorCode.NoPermissions;break;default:n=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await d.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(o=(0,v.createFileSystemProviderError)(n,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=r}),define(te[87],ne([0,1,3,7,8]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=k.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(f,p,d){switch(p){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,p){return f.call("setLevel",p)}}e.LogLevelChannelClient=A;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,p){throw new Error(`Event not found: ${p}`)}async call(f,p,d){switch(p){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${p}`)}createLogger(f,p){this.loggers.set(f.toString(),this.loggerService.createLogger(f,p))}consoleLog(f,p){let d=console.log;switch(f){case L.LogLevel.Error:d=console.error;break;case L.LogLevel.Warning:d=console.warn;break;case L.LogLevel.Info:d=console.info;break}d.call(console,...p)}log(f,p){const d=this.loggers.get(f.toString());if(!d)throw new Error("Create the logger before logging");for(const[h,v]of p)(0,L.log)(d,h,v)}}e.LoggerChannel=R;class b extends L.AbstractLoggerService{constructor(f,p,d){super(f,p);this.channel=d}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,p)=>{this.channel.call("consoleLog",[f,p])}})}doCreateLogger(f,p,d){return new C(this.channel,f,p,d)}}e.LoggerChannelClient=b;class C extends L.AbstractMessageLogger{constructor(f,p,d,h){super(h?.always);this.channel=f,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[p,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,p){const d=[[f,p]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends L.LogService{constructor(f,p){super(p);this.parent=f,this._register(f.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(te[60],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(te[88],ne([0,1,19,4,33,20]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const R=t.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const R=(0,T.dirname)(k.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,T.joinPath)(R,"product.json").fsPath);const b=K.__$__nodeRequire((0,T.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(te[27],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[178],ne([0,1,5,9,2,10,22,8,27]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends L.Disposable{constructor(E,f,p){super();this.productService=f,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),p=(0,T.dirname)(E),d=(0,T.basename)(E),h=await A.Promises.readdir(p);await Promise.all(h.map(async v=>{if(v===d)return;const m=(0,T.join)(p,v),w=await A.Promises.stat(m);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),A.Promises.rm(m)}))}catch(f){(0,t.onUnexpectedError)(f)}}};C=de([G(1,b.IProductService),G(2,R.ILogService)],C),e.CodeCacheCleaner=C}),define(te[179],ne([0,1,5,9,2,10,22,14,8,27]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends L.Disposable{constructor(f,p,d){super();this.environmentService=f,this.logService=p,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),p=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(p)){const y=p[w];f[`${y.hash}.${w}`]=!0}const d=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const v=await A.Promises.readdir(d);for(const w of v){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await A.Promises.rm((0,T.join)(d,w))}const m=Date.now();for(const w of Object.keys(f)){const y=(0,T.join)(d,w),S=await A.Promises.readdir(y);for(const l of S){if(l==="tcf.json")continue;const r=(0,T.join)(y,l),c=await A.Promises.stat(r);c.isDirectory()&&m-c.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(w,l)}`),await A.Promises.rm(r))}}}catch(f){(0,t.onUnexpectedError)(f)}}};P=de([G(0,R.INativeEnvironmentService),G(1,b.ILogService),G(2,C.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(te[180],ne([0,1,10,6]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(R,b="noAbsolutePaths"){for(const C of R.nodes)C.callFrame&&C.callFrame.url&&((0,k.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(C.callFrame.url))&&(C.callFrame.url=(0,k.join)(b,(0,k.basename)(C.callFrame.url)));return R}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(te[181],ne([0,1,29]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(T){const R=await(await new Promise((C,P)=>{K(["v8-inspect-profiler"],C,P)})).startProfiling({port:T.port,checkForPaused:!0}),b=(0,k.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const R=await A.stop();return this._sessions.delete(T),R.profile}}e.InspectProfilingService=t}),define(te[38],ne([0,1,99,11]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,R){k.ok(t.isString(A)),k.ok(t.isObject(R)),k.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(te[89],ne([0,1,3,38]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,C){this.schemasById[L(b)]=C,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;t.Registry.add(e.Extensions.JSONContribution,A)}),define(te[42],ne([0,1,16,3,11,126,89,38]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(A.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const c=this.doRegisterConfigurations(l,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const c=[];c.push(...this.doDeregisterConfigurations(r)),c.push(...this.doRegisterConfigurations(l,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(c)})}registerDefaultConfigurations(l){const r=[],c=[];for(const{overrides:i,source:n}of l)for(const o in i)if(r.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:s});const a={type:"object",default:s,description:T.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:L.isString(n)?void 0:n};c.push(...d(o)),this.configurationProperties[o]=a,this.defaultLanguageConfigurationOverridesNode.properties[o]=a}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:n});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:c,source:i}of l)for(const n in c){const o=this.configurationDefaultsOverrides.get(n),s=L.isString(i)?i:i?.id,a=L.isString(o?.source)?o?.source:o?.source?.id;if(s===a)if(r.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const u=this.configurationProperties[n];u&&(this.updatePropertyDefaultValue(n,u),this.updateSchema(n,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const c=[];return l.forEach(i=>{c.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),c}doDeregisterConfigurations(l){const r=[],c=i=>{if(i.properties)for(const n in i.properties)r.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n]);i.allOf&&i.allOf.forEach(n=>c(n))};for(const i of l){c(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}return r}validateAndRegisterProperties(l,r=!0,c,i,n=3){n=L.isUndefinedOrNull(l.scope)?n:l.scope;let o=[],s=l.properties;if(s)for(let u in s){if(r&&w(u)){delete s[u];continue}const g=s[u];if(g.source=c,g.defaultDefaultValue=s[u].default,this.updatePropertyDefaultValue(u,g),e.OVERRIDE_PROPERTY_REGEX.test(u)?g.scope=void 0:(g.scope=L.isUndefinedOrNull(g.scope)?n:g.scope,g.restricted=L.isUndefinedOrNull(g.restricted)?!!i?.includes(u):g.restricted),s[u].hasOwnProperty("included")&&!s[u].included){this.excludedConfigurationProperties[u]=s[u],delete s[u];continue}else this.configurationProperties[u]=s[u];!s[u].deprecationMessage&&s[u].markdownDeprecationMessage&&(s[u].deprecationMessage=s[u].markdownDeprecationMessage),o.push(u)}let a=l.allOf;if(a)for(let u of a)o.push(...this.validateAndRegisterProperties(u,r,c,i,n));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=c=>{let i=c.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);let n=c.allOf;n&&n.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,c={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,c),e.allSettings.properties[r]=c,e.applicationSettings.properties[r]=c,e.machineSettings.properties[r]=c,e.machineOverridableSettings.properties[r]=c,e.windowSettings.properties[r]=c,e.resourceSettings.properties[r]=c}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const c=this.configurationDefaultsOverrides.get(l);let i=c?.value,n=c?.source;L.isUndefined(i)&&(i=r.defaultDefaultValue,n=void 0),L.isUndefined(i)&&(i=v(r.type)),r.default=i,r.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(S){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let r=p.exec(S);for(;r?.length;){const c=r[1].trim();c&&l.push(c),r=p.exec(S)}}return(0,k.distinct)(l)}e.overrideIdentifiersFromKey=d;function h(S){return S.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=h;function v(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const m=new E;R.Registry.add(e.Extensions.Configuration,m);function w(S){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?T.localize(7,null,S):m.getConfigurationProperties()[S]!==void 0?T.localize(8,null,S):null:T.localize(6,null)}e.validateProperty=w;function y(){const S=[],l=m.getConfigurationProperties();for(const r of Object.keys(l))S.push([r,l[r].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=y}),define(te[90],ne([0,1,16,3,35,2,39,28,11,7,18,42,38]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},n=[],o=[]){this._contents=i,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const o=this.getContentsForOverrideIdentifer(n);return o?i?(0,P.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return k.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return k.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=R.deepClone(this.contents),o=R.deepClone(this.overrides),s=[...this.keys];for(const a of i){this.mergeContents(n,a.contents);for(const u of a.overrides){const[g]=o.filter(I=>k.equals(I.identifiers,u.identifiers));g?(this.mergeContents(g.contents,u.contents),g.keys.push(...u.keys),g.keys=k.distinct(g.keys)):o.push(R.deepClone(u))}for(const u of a.keys)s.indexOf(u)===-1&&s.push(u)}return new p(n,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const s of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[s],u=n[s];u&&(typeof a=="object"&&typeof u=="object"?(a=R.deepClone(a),this.mergeContents(a,u)):a=u),o[s]=a}return new p(o,this.keys,this.overrides)}mergeContents(i,n){for(const o of Object.keys(n)){if(o in i&&b.isObject(i[o])&&b.isObject(n[o])){this.mergeContents(i[o],n[o]);continue}i[o]=R.deepClone(n[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,o=null;const s=a=>{a&&(o?this.mergeContents(o,a):o=R.deepClone(a))};for(const a of this.overrides)k.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&s(a.contents);return s(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,P.addToValueTree)(this.contents,i,n,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let o=0;o<n;o++)i.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class d extends p{constructor(i={}){const n=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n),s=Object.create(null),a=[];for(const u in n){const g=i[u],I=g!==void 0?g:n[u].default;(0,P.addToValueTree)(s,u,I,_=>console.error(`Conflict in default settings: ${_}`))}for(const u of Object.keys(s))E.OVERRIDE_PROPERTY_REGEX.test(u)&&a.push({identifiers:(0,E.overrideIdentifiersFromKey)(u),keys:Object.keys(s[u]),contents:(0,P.toValuesTree)(s[u],g=>console.error(`Conflict in default settings file: ${g}`))});super(s,o,a)}}e.DefaultConfigurationModel=d;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!b.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:o,keys:s,overrides:a,restricted:u}=this.doParseRaw(i,n);this._configurationModel=new p(o,s,a),this._restrictedConfigurations=u||[]}doParseContent(i){let n={},o=null,s=[],a=[],u=[];function g(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let I={onObjectBegin:()=>{let _={};g(_),a.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let _=[];g(_),a.push(s),s=_,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:g,onError:(_,M,F)=>{u.push({error:_,offset:M,length:F})}};if(i)try{L.visit(i,I),n=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return n}doParseRaw(i,n){const o=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,o,!0,n);i=s.raw;const a=(0,P.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),u=Object.keys(i),g=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:a,keys:u,overrides:g,restricted:s.restricted}}filter(i,n,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const a={},u=[];for(let g in i)if(E.OVERRIDE_PROPERTY_REGEX.test(g)&&o){const I=this.filter(i[g],n,!1,s);a[g]=I.raw,u.push(...I.restricted)}else{const I=n[g],_=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&u.push(g),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&I?.restricted||(a[g]=i[g]))}return{raw:a,restricted:u}}toOverrides(i,n){const o=[];for(const s of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const u in i[s])a[u]=i[s][u];o.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,n)})}return o}}e.ConfigurationModelParser=h;class v extends T.Disposable{constructor(i,n,o,s){super();this.userSettingsResource=i,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class m{constructor(i,n,o=new p,s=new p,a=new A.ResourceMap,u=new p,g=new A.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=u,this._memoryConfigurationByResource=g,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(i)}updateValue(i,n,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new p,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(i):s.setValue(i,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,o){const s=this.getConsolidateConfigurationModel(n,o),a=this.getFolderConfigurationModelForResource(n.resource,o),u=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,g=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),M=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),F=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,D=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,N=n.overrideIdentifier?u.override(n.overrideIdentifier).getValue(i):u.getValue(i),$=s.getValue(i),B=k.distinct(k.flatten(s.overrides.map(Z=>Z.identifiers))).filter(Z=>s.getOverrideValue(i,Z)!==void 0);return{defaultValue:g,userValue:I,userLocalValue:_,userRemoteValue:M,workspaceValue:F,workspaceFolderValue:D,memoryValue:N,value:$,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:a?.freeze().getValue(i),override:n.overrideIdentifier?a?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:u.getValue(i),override:n.overrideIdentifier?u.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:s,updated:a,removed:u}=l(this._defaultConfiguration,i);n=[...s,...a,...u]}for(const s of n)for(const a of(0,E.overrideIdentifiersFromKey)(s)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(a),g=i.getKeysForOverrideIdentifier(a),I=[...g.filter(_=>u.indexOf(_)===-1),...u.filter(_=>g.indexOf(_)===-1),...u.filter(_=>!R.equals(this._defaultConfiguration.override(a).getValue(_),i.override(a).getValue(_)))];o.push([a,I])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:s,overrides:a}=l(this.localUserConfiguration,i),u=[...n,...o,...s];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:s,overrides:a}=l(this.remoteUserConfiguration,i);let u=[...n,...o,...s];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:s,overrides:a}=l(this.workspaceConfiguration,i);let u=[...n,...o,...s];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:s,updated:a,removed:u,overrides:g}=l(o,n);let I=[...s,...a,...u];return(I.length||!o)&&this.updateFolderConfiguration(i,n),{keys:I,overrides:g}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:s,removed:a,overrides:u}=l(n,void 0);return{keys:[...o,...s,...a],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const s=n.getFolder(i);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const a=this._memoryConfigurationByResource.get(i);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(n=o.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=o}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:o,overrides:s,keys:a}=this._folderConfigurations.get(n);return i.push([n,{contents:o,overrides:s,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((u,g)=>(u.set(C.URI.revive(g[0]),this.parseConfigurationModel(g[1])),u),new A.ResourceMap);return new m(n,o,new p,s,a,new p,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=m;function w(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,n=new Map;for(const s of c)s.keys.forEach(a=>i.add(a)),s.overrides.forEach(([a,u])=>{const g=(0,A.getOrSet)(n,a,new Set);u.forEach(I=>g.add(I))});const o=[];return n.forEach((s,a)=>o.push([a,[...s.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=w;class y{constructor(i,n,o,s){this.change=i,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(g=>a.add(g)),i.overrides.forEach(([,g])=>g.forEach(I=>a.add(I))),this.affectedKeys=[...a.values()];const u=new p;this.affectedKeys.forEach(g=>u.setValue(g,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!R.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let o=(0,P.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(i=i[s],!i)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=y;class S extends y{constructor(i,n,o,s){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=S;function l(c,i){const{added:n,removed:o,updated:s}=r(i,c),a=[],u=c?.getAllOverrideIdentifiers()||[],g=i?.getAllOverrideIdentifiers()||[];if(i){const I=g.filter(_=>!u.includes(_));for(const _ of I)a.push([_,i.getKeysForOverrideIdentifier(_)])}if(c){const I=u.filter(_=>!g.includes(_));for(const _ of I)a.push([_,c.getKeysForOverrideIdentifier(_)])}if(i&&c){for(const I of u)if(g.includes(I)){const _=r({contents:c.getOverrideValue(void 0,I)||{},keys:c.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});a.push([I,[..._.added,..._.removed,..._.updated]])}}return{added:n,removed:o,updated:s,overrides:a}}function r(c,i){const n=c?i?c.keys.filter(a=>i.keys.indexOf(a)===-1):[...c.keys]:[],o=i?c?i.keys.filter(a=>c.keys.indexOf(a)===-1):[...i.keys]:[],s=[];if(c&&i){for(const a of i.keys)if(c.keys.indexOf(a)!==-1){const u=(0,P.getConfigurationValue)(i.contents,a),g=(0,P.getConfigurationValue)(c.contents,a);R.equals(u,g)||s.push(a)}}return{added:n,removed:o,updated:s}}}),define(te[182],ne([0,1,5,3,2,20,18,90,42,38]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends L.Disposable{constructor(f,p){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,p)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,p){const d=typeof f=="string"?f:void 0,h=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(d,h,void 0)}updateValue(f,p,d,h){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(d,p,1)}onDidDefaultConfigurationChange(f){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(d,p,6)}trigger(f,p,d){const h=new R.ConfigurationChangeEvent(f,{data:p},this.configuration);h.source=d,h.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(te[183],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(A,R=t.Unknown,b){super(A);this._message=A,this._code=R,this._detail=b,this.isHandled=R===t.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===t.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===t.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}}e.RemoteAuthorityResolverError=L}),define(te[184],ne([0,1,5,17,25,9,3,2,29,74,183]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var f;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(V){const J=new L.CancellationTokenSource;return setTimeout(()=>J.cancel(),V),J.token}function h(V,J){if(V.isCancellationRequested||J.isCancellationRequested)return L.CancellationToken.Cancelled;const Q=new L.CancellationTokenSource;return V.onCancellationRequested(()=>Q.cancel()),J.onCancellationRequested(()=>Q.cancel()),Q.token}class v{constructor(J){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((Q,q)=>{this._resolvePromise=Q,this._rejectPromise=q}),J.isCancellationRequested?this._timeout():this._disposables.add(J.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(J){this._state==="pending"?this._disposables.add(J):J.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(J))}reject(J){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(J))}}function m(V,J){const Q=new v(J);return Q.registerDisposable(V.onControlMessage(q=>{const O=JSON.parse(q.toString()),U=W(O);U?Q.reject(U):Q.resolve(O)})),Q.promise}function w(V,J,Q,q,O,U,z){const H=new v(z);return J.connect(Q,q,O,U,(ie,se)=>{H.didTimeout?(ie&&V.error(ie),se?.dispose()):ie||!se?H.reject(ie):H.resolve(se)}),H.promise}function y(V,J){const Q=new v(J);return V.then(q=>{Q.didTimeout||Q.resolve(q)},q=>{Q.didTimeout||Q.reject(q)}),Q.promise}async function S(V,J,Q,q){const O=j(V,J);V.logService.trace(`${O} 1/6. invoking socketFactory.connect().`);let U;try{U=await w(V.logService,V.socketFactory,V.host,V.port,`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,`renderer-${p(J)}-${V.reconnectionToken}`,q)}catch(ue){throw V.logService.error(`${O} socketFactory.connect() failed or timed out. Error:`),V.logService.error(ue),ue}V.logService.trace(`${O} 2/6. socketFactory.connect() was successful.`);let z,H;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection(U,null),z=V.reconnectionProtocol,H=!1):(z=new C.PersistentProtocol(U,null),H=!0),V.logService.trace(`${O} 3/6. sending AuthRequest control message.`);const ie=await y(V.signService.createNewMessage((0,b.generateUuid)()),q),se={type:"auth",auth:V.connectionToken||"00000000000000000000",data:ie.data};z.sendControl(t.VSBuffer.fromString(JSON.stringify(se)));try{const ue=await m(z,h(q,d(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(V.logService.trace(`${O} 4/6. received SignRequest control message.`),!await y(V.signService.validate(ie,ue.signedData),q)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const we=await y(V.signService.sign(ue.data),q),pe={type:"connectionType",commit:V.commit,signedData:we,desiredConnectionType:J};return Q&&(pe.args=Q),V.logService.trace(`${O} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(t.VSBuffer.fromString(JSON.stringify(pe))),{protocol:z,ownsProtocol:H}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(V.logService.error(`${O} the handshake timed out. Error:`),V.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${O} received error control message when negotiating connection. Error:`),V.logService.error(ue)),H&&Z(z),ue}}async function l(V,J,Q,q){const O=Date.now(),U=j(V,J),{protocol:z,ownsProtocol:H}=await S(V,J,Q,q),ie=new v(q);return ie.registerDisposable(z.onControlMessage(se=>{const ue=JSON.parse(se.toString()),he=W(ue);he?(V.logService.error(`${U} received error control message when negotiating connection. Error:`),V.logService.error(he),H&&Z(z),ie.reject(he)):(V.reconnectionProtocol&&V.reconnectionProtocol.endAcceptReconnection(),V.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${Y(O)}!`),ie.resolve({protocol:z,firstMessage:ue}))})),ie.promise}async function r(V,J){const{protocol:Q}=await l(V,1,void 0,J);return{protocol:Q}}async function c(V,J,Q){const{protocol:q,firstMessage:O}=await l(V,2,J,Q),U=O&&O.debugPort;return{protocol:q,debugPort:U}}async function i(V,J,Q){const q=Date.now(),O=j(V,3),{protocol:U}=await S(V,3,J,Q);return V.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${Y(q)}!`),U}async function n(V,J,Q){const{host:q,port:O,connectionToken:U}=await V.addressProvider.getAddress();return{commit:V.commit,host:q,port:O,connectionToken:U,reconnectionToken:J,reconnectionProtocol:Q,socketFactory:V.socketFactory,signService:V.signService,logService:V.logService}}async function o(V,J,Q){try{const q=(0,b.generateUuid)(),O=await n(V,q,null),{protocol:U}=await r(O,L.CancellationToken.None);return new $(V,J,Q,q,U)}catch(q){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(q),N.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=o;async function s(V,J){try{const Q=(0,b.generateUuid)(),q=await n(V,Q,null),{protocol:O,debugPort:U}=await c(q,J,L.CancellationToken.None);return new B(V,J,Q,O,U)}catch(Q){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(Q),N.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentExtensionHost=s;async function a(V,J,Q){const q=await n(V,(0,b.generateUuid)(),null);return await i(q,{host:J,port:Q},L.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function u(V){return(0,k.createCancelablePromise)(J=>new Promise((Q,q)=>{const O=setTimeout(Q,V*1e3);J.onCancellationRequested(()=>{clearTimeout(O),Q()})}))}var g;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(g=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(J,Q){this.reconnectionToken=J,this.millisSinceLastIncomingData=Q,this.type=0}}e.ConnectionLostEvent=I;class _{constructor(J,Q,q,O){this.reconnectionToken=J,this.millisSinceLastIncomingData=Q,this.durationSeconds=q,this.cancellableTimer=O,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class M{constructor(J,Q,q){this.reconnectionToken=J,this.millisSinceLastIncomingData=Q,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=M;class F{constructor(J,Q,q){this.reconnectionToken=J,this.millisSinceLastIncomingData=Q,this.attempt=q,this.type=4}}e.ConnectionGainEvent=F;class D{constructor(J,Q,q,O){this.reconnectionToken=J,this.millisSinceLastIncomingData=Q,this.attempt=q,this.handled=O,this.type=3}}e.ReconnectionPermanentFailureEvent=D;class N extends R.Disposable{constructor(J,Q,q,O){super();this._connectionType=J,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=Q,this.reconnectionToken=q,this.protocol=O,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(O.onSocketClose(U=>{const z=x(this._connectionType,this.reconnectionToken,!0);U?U.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${U.hadError}).`),U.error&&this._options.logService.error(U.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${U.wasClean}, code: ${U.code}, reason: ${U.reason}).`),U.event&&this._options.logService.error(U.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(O.onSocketTimeout(()=>{const U=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${U} received socket timeout event.`),this._beginReconnecting()})),N._instances.push(this),N._permanentFailure&&this._gotoPermanentFailure(N._permanentFailureMillisSinceLastIncomingData,N._permanentFailureAttempt,N._permanentFailureHandled)}static triggerPermanentFailure(J,Q,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=J,this._permanentFailureAttempt=Q,this._permanentFailureHandled=q,this._instances.forEach(O=>O._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(J=>J._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(J=>J._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(N._permanentFailure)return;const J=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Q=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const O=q<Q.length?Q[q]:Q[Q.length-1];try{if(O>0){const z=u(O);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O,z)),this._options.logService.info(`${J} waiting for ${O} seconds before reconnecting...`);try{await z}catch{}}if(N._permanentFailure){this._options.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${J} resolving connection...`);const U=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${J} connecting to ${U.host}:${U.port}...`),await this._reconnect(U,d(E)),this._options.logService.info(`${J} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,T.isCancellationError)(U)){this._options.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,P.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!N._permanentFailure)}_gotoPermanentFailure(J,Q,q){this._onDidStateChange.fire(new D(this.reconnectionToken,J,Q,q)),Z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=N,N._permanentFailure=!1,N._permanentFailureMillisSinceLastIncomingData=0,N._permanentFailureAttempt=0,N._permanentFailureHandled=!1,N._instances=[];class $ extends N{constructor(J,Q,q,O,U){super(1,J,O,U);this.client=this._register(new C.Client(U,{remoteAuthority:Q,clientId:q},J.ipcLogger))}async _reconnect(J,Q){await r(J,Q)}}e.ManagementPersistentConnection=$;class B extends N{constructor(J,Q,q,O,U){super(2,J,q,O);this._startArguments=Q,this.debugPort=U}async _reconnect(J,Q){await c(J,this._startArguments,Q)}}e.ExtensionHostPersistentConnection=B;function Z(V){try{V.acceptDisconnect();const J=V.getSocket();V.dispose(),J.dispose()}catch(J){(0,T.onUnexpectedError)(J)}}function W(V){if(V&&V.type==="error"){const J=new Error(`Connection error: ${V.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function ee(V,J){for(;V.length<J;)V+=" ";return V}function x(V,J,Q){return`[remote-connection][${ee(p(V),13)}][${J.substr(0,5)}\u2026][${Q?"reconnect":"initial"}]`}function j(V,J){return`${x(J,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.host}:${V.port}]`}function Y(V){return`${Date.now()-V} ms`}}),define(te[185],ne([0,1,19]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===k.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function L(T){if(!T)return;const A=T.indexOf("+");return A<0?T:T.substr(0,A)}e.getRemoteName=L}),define(te[61],ne([0,1,26,6,185]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,d){if(typeof p=="undefined"||p===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof p=="string"||typeof d=="string"){let h=typeof p=="string"?p:p.value,v=typeof d=="string"?d:d.value;return k.equalsIgnoreCase(h,v)}return p._lower===d._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=b;function C(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function E(f,p){if(p){const d=`onResolveRemoteAuthority:${(0,L.getRemoteName)(p)}`;return f.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,26,61]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(d,h){return d.uuid&&h.uuid?d.uuid===h.uuid:d.id===h.id?!0:(0,k.compareIgnoreCase)(d.id,h.id)===0}e.areSameExtensions=L;class T{constructor(h,v){this.version=v,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof T?L(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(d,h){return`${d}.${h}`}e.getExtensionId=A;function R(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(d,h){return R(A(d,h))}e.getGalleryExtensionId=b;function C(d,h){const v=[],m=w=>{for(const y of v)if(y.some(S=>L(h(S),h(w))))return y;return null};for(const w of d){const y=m(w);y?y.push(w):v.push([w])}return v}e.groupByExtension=C;function P(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function E(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function f(d){const h=new Set;if(d.malicious)for(const v of d.malicious)h.add(v.id);return h}e.getMaliciousExtensionsSet=f;function p(d,h){const v=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&v.every(y=>!L(y.identifier,{id:w}))){const y=d.filter(S=>L(S.identifier,{id:w}));y.length===1&&(v.push(y[0]),m.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=p}),define(te[30],ne([0,1,130,31,6]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const T=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function A(l){const r=T.exec(l);return r&&r[1]?[(0,t.adoptToGalleryExtensionId)(r[1]),r[2]]:[(0,t.adoptToGalleryExtensionId)(l),void 0]}e.getIdAndVersion=A;var R;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));function b(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function C(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function P(l,r){switch(l){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=P;function E(l,r){return r==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function f(l,r,c){return E(r,c)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===c?!0:p(c).includes(l)}e.isTargetPlatformCompatible=f;function p(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function d(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=d;var h;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(h=e.SortBy||(e.SortBy={}));var v;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var w;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var y;(function(l){l.Unsupported="Unsupported",l.UnsupportedPreRelease="UnsupportedPreRelease",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class S extends Error{constructor(r,c){super(r);this.code=c,this.name=c}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(te[186],ne([0,1,3,2,28,7,110,30]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(h,v){return T.URI.revive(v?v.transformIncoming(h):h)}function C(h,v){return v?v.transformOutgoingURI(h):h}function P(h,v){v=v||A.DefaultURITransformer;const m=h.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...h,manifest:void 0},v),manifest:m}}function E(h,v){return v?(0,L.cloneAndChange)(h,m=>m instanceof T.URI?v.transformOutgoingURI(m):void 0):h}class f{constructor(v,m){this.service=v,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,m){const w=this.getUriTransformer(v);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,y=>y.map(S=>({...S,local:S.local?E(S.local,w):S.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,m,w){const y=this.getUriTransformer(v);switch(m){case"zip":return this.service.zip(P(w[0],y)).then(S=>C(S,y));case"unzip":return this.service.unzip(b(w[0],y));case"install":return this.service.install(b(w[0],y),w[1]);case"getManifest":return this.service.getManifest(b(w[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],y),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],y));case"getInstalled":return this.service.getInstalled(w[0]).then(S=>S.map(l=>E(l,y)));case"updateMetadata":return this.service.updateMetadata(P(w[0],y),w[1]).then(S=>E(S,y));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],y),w[1]).then(S=>E(S,y));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends t.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const m=await this.getTargetPlatform();return v.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,v.allTargetPlatforms,m))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(m=>T.URI.revive(m)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,m){return Promise.resolve(this.channel.call("install",[v,m])).then(w=>P(w,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,m){return Promise.resolve(this.channel.call("installFromGallery",[v,m])).then(w=>P(w,null))}uninstall(v,m){return Promise.resolve(this.channel.call("uninstall",[v,m]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(m=>m.map(w=>P(w,null)))}updateMetadata(v,m){return Promise.resolve(this.channel.call("updateMetadata",[v,m])).then(w=>P(w,null))}updateExtensionScope(v,m){return Promise.resolve(this.channel.call("updateExtensionScope",[v,m])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class d{constructor(v){this.service=v}listen(v,m){throw new Error("Invalid listen")}call(v,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(te[187],ne([0,1,25,31]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,R,b,C){try{const P=await T.getExtensionsControlManifest();if(!P.unsupportedPreReleaseExtensions)return;const E=await T.getInstalled(1);for(const[f,{id:p,migrateStorage:d}]of Object.entries(P.unsupportedPreReleaseExtensions)){const h=E.find(m=>(0,t.areSameExtensions)(m.identifier,{id:f}));if(!h)continue;const v=(await A.getExtensions([{id:p,preRelease:!0}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!v){C.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{C.info(`Migrating '${h.identifier.id}' extension to '${p}' extension...`);const m=!b.getDisabledExtensions().some(y=>(0,t.areSameExtensions)(y,h.identifier));await T.uninstall(h),C.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let w=E.find(y=>(0,t.areSameExtensions)(y.identifier,{id:p}));(!w||!w.isPreReleaseVersion&&m)&&(w=await T.installFromGallery(v,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),C.info(`Installed the pre-release extension '${w.identifier.id}'`),m||(await b.disableExtension(w.identifier),C.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),d&&(R.addToMigrationList((0,t.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,t.getExtensionId)(w.manifest.publisher,w.manifest.name)),C.info("Added pre-release extension to the storage migration list"))),C.info(`Migrated '${h.identifier.id}' extension to '${p}' extension.`)}catch(m){C.error(m)}}}catch(P){C.error(P)}}e.migrateUnsupportedExtensions=L}),define(te[188],ne([0,1,5,9,2,4,20,62,7,29,22,14,30,31,15,8]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends L.Disposable{constructor(y,S,l,r){super();this.fileService=S,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=b.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,S){await this.cleanUpPromise;const l=this.getName(y),r=(0,A.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const c=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(c)||await this.extensionGalleryService.download(y,c,S);try{await this.rename(c,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(c)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,c.path),i}}return r}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,S,l){try{await P.Promises.rename(y.fsPath,S.fsPath)}catch(r){if(T.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${y} to ${S} with 'EPERM' error. Trying again...`),this.rename(y,S,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const S=[],l=[];for(const i of y.children){const n=this.parse(i.name);n&&l.push([n,i])}const r=(0,p.groupByExtension)(l,([i])=>i),c=[];for(const i of r)i.sort((n,o)=>R.rcompare(n[0].version,o[0].version)),S.push(...i.slice(1).map(n=>n[1].resource)),c.push(i[0][1]);c.sort((i,n)=>i.mtime-n.mtime),S.push(...c.slice(0,Math.max(0,c.length-this.cache)).map(i=>i.resource)),await k.Promises.settled(S.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new p.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,C.generateUuid)()}parse(y){const S=v.exec(y);return S&&S[1]&&S[2]?new p.ExtensionIdentifierWithVersion({id:S[1]},S[2]):null}};m=de([G(0,E.INativeEnvironmentService),G(1,d.IFileService),G(2,f.IExtensionGalleryService),G(3,h.ILogService)],m),e.ExtensionsDownloader=m}),define(te[189],ne([0,1,2,10,22,61]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(b,C){super();this.environmentService=b,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(C.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(b){b.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[190],ne([0,1,84,16,5,2,19,10,22,14,30,31,59,8]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let d=class extends T.Disposable{constructor(m,w,y){super();this.extensionManagementService=m,this.logService=y,this.cache=this._register(new h(w,y)),this.extensionManagementService.registerParticipant({postInstall:async S=>this.postInstallExtension(S),postUninstall:async S=>this.postUninstallExtension(S)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,t.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(y=>w[y]&&w[y].extensions.some(S=>(0,E.areSameExtensions)(S.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(w);return!(0,t.equals)(Object.keys(m),Object.keys(y))}};d=de([G(0,P.IExtensionManagementService),G(1,C.INativeEnvironmentService),G(2,p.ILogService)],d),e.LocalizationsService=d;let h=class extends T.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(y=>delete w[y]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const y of w)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,y);Object.keys(m).forEach(y=>this.updateHash(m[y]))}createLanguagePacksFromExtension(m,w){const y=w.identifier,S=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of S)if(w.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(l)){let r=m[l.languageId];r||(r={hash:"",extensions:[],translations:{}},m[l.languageId]=r);let c=r.extensions.filter(i=>(0,E.areSameExtensions)(i.extensionIdentifier,y))[0];c?c.version=w.manifest.version:r.extensions.push({extensionIdentifier:y,version:w.manifest.version});for(const i of l.translations)r.translations[i.id]=(0,R.join)(w.location.fsPath,i.path)}}updateHash(m){if(m){const w=(0,k.createHash)("md5");for(const y of m.extensions)w.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(w=m(y),y)).then(y=>{for(const l of Object.keys(y))y[l]||delete y[l];this.languagePacks=y,this.initializedCache=!0;const S=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",S),b.Promises.writeFile(this.languagePacksFilePath,S)}).then(()=>w,y=>this.logService.error(y))})}};h=de([G(0,C.INativeEnvironmentService),G(1,p.ILogService)],h)}),define(te[191],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[192],ne([0,1,120,18,8]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(R,b)}async resolveProxy(R){}};T=de([G(0,t.IConfigurationService),G(1,L.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,17,140,42,6,38]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function R(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=R;function b(d){return d.res.statusCode===204}async function C(d){if(!R(d))throw new Error("Server returned "+d.res.statusCode);return b(d)?null:(await(0,k.streamToBuffer)(d.stream)).toString()}e.asText=C;async function P(d){if(!R(d))throw new Error("Server returned "+d.res.statusCode);if(b(d))return null;const v=(await(0,k.streamToBuffer)(d.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}e.asJson=P;function E(d){p(d)}e.updateProxyConfigurationsScope=E;let f;function p(d){const h=A.Registry.as(L.Extensions.Configuration),v=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[f],remove:v?[v]:[]})}p(2)}),define(te[193],ne([0,1,25,19,15,43]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,C){this.requestService=b,this.fileService=C}async download(b,C,P=k.CancellationToken.None){if(b.scheme===t.Schemas.file||b.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(b,C);return}const E={type:"GET",url:b.toString()},f=await this.requestService.request(E,P);if(f.res.statusCode===200)await this.fileService.writeFile(C,f.stream);else{const p=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};A=de([G(0,T.IRequestService),G(1,L.IFileService)],A),e.DownloadService=A}),define(te[194],ne([0,1,16,25,68,2,20,155,15,8,27,43]),function(K,e,k,t,L,T,A,R,b,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(d,h,v,m){super();this.fileService=d,this.productService=h,this.requestService=v,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(d){return this.getValidConfigBasedTips(d)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(d){const h=[];for(const[v,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==d.scheme))try{const w=await this.fileService.readFile((0,A.joinPath)(d,v)),y=new Map;(0,L.forEach)(m.recommendations,({key:l,value:r})=>{if((0,k.isNonEmptyArray)(r.remotes))for(const c of r.remotes)y.set(c,{extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled});else h.push({extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled})});const S=(0,R.getDomainsOfRemotes)(w.value.toString(),[...y.keys()]);for(const l of S){const r=y.get(l);r&&h.push(r)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const d=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(d.res.statusCode!==200)return[];const h=await(0,E.asJson)(d);return h?h.workspaceRecommendations||[]:[]}catch(d){return this.logService.error(d),[]}}};f=de([G(0,b.IFileService),G(1,P.IProductService),G(2,E.IRequestService),G(3,C.ILogService)],f),e.ExtensionTipsService=f}),define(te[91],ne([0,1,71,6]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,k.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[195],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[196],ne([0,1,75,5,25,3,2,19,29,8,91,195]),function(K,e,k,t,L,T,A,R,b,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let f=class{constructor(h){this.logService=h,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(h){const v=`window: ${h.reply.windowId}, moduleId: ${h.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${v})`);const m=(0,P.hash)(h);this.processeDisposables.has(m)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.doDisposeWorker(h));const w=new L.CancellationTokenSource;let y,S,l;this.processeDisposables.set(m,n=>{w.dispose(!0),y?.terminate(h,L.CancellationToken.None),S?.close(),l?.close(),this.processeDisposables.delete(m);const o=this.processResolvers.get(m);o&&(this.processResolvers.delete(m),o({reason:n}))}),y=await this.getOrCreateWebWorker(h);const r=new Promise(n=>{this.processResolvers.set(m,n)});if(w.token.isCancellationRequested)return r;const{port1:c,port2:i}=new MessageChannel;return S=c,l=i,await y.spawn(h,l,w.token),w.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${v})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",h,[S])),r}getOrCreateWebWorker(h){let v=this.workers.get(h.process.moduleId);if(!v){this.logService.trace(`SharedProcess: creating new web worker (${h.process.moduleId})`);const m=new p(h.process.type,this.logService);v=m.init(),m.onDidProcessSelfTerminate(({configuration:w,reason:y})=>{this.doDisposeWorker(w,y)}),this.workers.set(h.process.moduleId,v)}return v}async disposeWorker(h){return this.doDisposeWorker(h)}doDisposeWorker(h,v){const m=this.processeDisposables.get((0,P.hash)(h));m&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${h.reply.windowId}, moduleId: ${h.process.moduleId})`),m(v))}};f=de([G(0,C.ILogService)],f),e.SharedProcessWorkerService=f;class p extends A.Disposable{constructor(h,v){super();this.type=h,this.logService=v,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const h=new t.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return v.onerror=m=>{this.logService.error(`SharedProcess: worker error (${this.type})`,m.message)},v.onmessageerror=m=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,m)},v.onmessage=m=>{const{id:w,message:y,configuration:S,nonce:l}=m.data;switch(w){case E.SharedProcessWorkerMessages.Ready:h.complete(v);break;case E.SharedProcessWorkerMessages.Ack:if(l){const r=this.mapMessageNonceToPendingMessageResolve.get(l);r&&(this.mapMessageNonceToPendingMessageResolve.delete(l),r())}break;case E.SharedProcessWorkerMessages.SelfTerminated:S&&y&&this._onDidProcessSelfTerminate.fire({configuration:S,reason:JSON.parse(y)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,y);break;case E.SharedProcessWorkerMessages.Info:y&&this.logService.info(y);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,y);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,y);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,m)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),h.p}async send(h,v,m){const w=await this.workerReady;if(!v.isCancellationRequested)return new Promise(y=>{const S=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(S,y);const l={...h,nonce:S};m?w.postMessage(l,[m]):w.postMessage(l),v.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(S)&&y()})})}spawn(h,v,m){const w={id:E.SharedProcessWorkerMessages.Spawn,configuration:h,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",K).fsPath}};return this.send(w,m,v)}terminate(h,v){const m={id:E.SharedProcessWorkerMessages.Terminate,configuration:h};return this.send(m,v)}}}),define(te[197],ne([0,1,54,19,154]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.userData})}}de([k.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(te[92],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[198],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>K(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const R=String(k._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=k,k._nextId=1}),define(te[23],ne([0,1,5,3,2,176,11,76,6]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var P;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var f;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class p extends L.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===C?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,y){return this.getStorage(w)?.get(m,y)}getBoolean(m,w,y){return this.getStorage(w)?.getBoolean(m,y)}getNumber(m,w,y){return this.getStorage(w)?.getNumber(m,y)}store(m,w,y,S){if((0,A.isUndefinedOrNull)(w)){this.remove(m,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,y,S),this.getStorage(y)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const y=[],S=this.getKeyTargets(m);for(const l of Object.keys(S))S[l]===w&&y.push(l);return y}updateKeyTarget(m,w,y){const S=this.getKeyTargets(w);typeof y=="number"?S[m]!==y&&(S[m]=y,this.getStorage(w)?.set(C,JSON.stringify(S))):typeof S[m]=="number"&&(delete S[m],this.getStorage(w)?.set(C,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(C,m);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=P.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),y=this.getStorage(1);switch(m){case P.NONE:await k.Promises.settled([w?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await k.Promises.settled([w?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return h(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends p{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=d;async function h(v,m,w,y){const S=s=>{try{return JSON.parse(s)}catch{return s}},l=new Map,r=new Map;v.forEach((s,a)=>{l.set(a,s),r.set(a,S(s))});const c=new Map,i=new Map;m.forEach((s,a)=>{c.set(a,s),i.set(a,S(s))}),console.group(`Storage: Global (path: ${w})`);let n=[];l.forEach((s,a)=>{n.push({key:a,value:s})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${y})`);let o=[];c.forEach((s,a)=>{o.push({key:a,value:s})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=h}),define(te[199],ne([0,1,3,2,11,30,31,23]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends t.Disposable{constructor(E,f){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(E)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(f.onDidInstallExtensions(p=>p.forEach(({local:d,operation:h})=>{d&&h===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(E,f){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}async disableExtension(E,f){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let f=this.getDisabledExtensions();return f.every(p=>!(0,A.areSameExtensions)(p,E))?(f.push(E),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(E){let f=this.getDisabledExtensions();for(let p=0;p<f.length;p++){const d=f[p];if((0,A.areSameExtensions)(d,E))return f.splice(p,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(E){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,f){this.storageManger.set(E,f,0)}};b=de([G(0,R.IStorageService),G(1,T.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class C extends t.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(E,f){let p;return f===0?((0,L.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,f)),p=this.storage[E]):p=this._get(E,f),JSON.parse(p)}set(E,f,p){let d=JSON.stringify(f.map(({id:v,uuid:m})=>({id:v,uuid:m})));this._get(E,p)!==d&&(p===0&&(f.length?this.storage[E]=d:delete this.storage[E]),this._set(E,f.length?d:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const d=this.get(E.key,E.scope),h=p.filter(m=>!d.some(w=>(0,A.areSameExtensions)(m,w))),v=d.filter(m=>!p.some(w=>(0,A.areSameExtensions)(w,m)));(h.length||v.length)&&this._onDidChange.fire([...h,...v])}}_get(E,f){return this.storageService.get(E,f,"[]")}_set(E,f,p){f?this.storageService.store(E,f,p,1):this.storageService.remove(E,p)}}e.StorageManager=C}),define(te[63],ne([0,1,6,3,2,23,31,27,16,8,11]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class tt extends L.Disposable{constructor(d,h,v){super();this.storageService=d,this.productService=h,this.logService=v,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const h=E.exec(d);if(h&&h[1])return{id:h[1],version:h[2]}}initialize(){const d=this.storageService.keys(0,1);for(const h of d){const v=tt.fromKey(h);v&&this.extensionsWithKeysForSync.add(v.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const h=tt.fromKey(d.key);if(h){this.extensionsWithKeysForSync.add(h.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(d){if((0,P.isString)(d))return d;const h=d.manifest?d.manifest.publisher:d.publisher,v=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(h,v)}getExtensionState(d,h){const v=this.getExtensionId(d),m=this.storageService.get(v,h?0:1);if(m)try{return JSON.parse(m)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${h}): ${w}`)}}setExtensionState(d,h,v){const m=this.getExtensionId(d);h===void 0?this.storageService.remove(m,v?0:1):this.storageService.store(m,JSON.stringify(h),v?0:1,1)}setKeysForSync(d,h){this.storageService.store(tt.toKey(d),JSON.stringify(h),0,1)}getKeysForSync(d){const h=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],v=this.storageService.get(tt.toKey(d),0),m=v?JSON.parse(v):void 0;return m&&h?(0,b.distinct)([...m,...h]):m||h}addToMigrationList(d,h){if(d!==h){const v=this.migrationList.filter(m=>!m.includes(d)&&!m.includes(h));v.push([d,h]),this.migrationList=v}}getSourceExtensionToMigrate(d){const h=this.migrationList.find(([,v])=>d===v);return h?h[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const h=JSON.parse(d);if((0,P.isArray)(h))return h}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=de([G(0,T.IStorageService),G(1,R.IProductService),G(2,C.ILogService)],f),e.ExtensionStorageService=f}),define(te[200],ne([0,1,2,30,63,187,8]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends k.Disposable{constructor(C,P,E,f,p){super();C.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(C,P,E,f,p)}};R=de([G(0,t.IExtensionManagementService),G(1,t.IExtensionGalleryService),G(2,L.IExtensionStorageService),G(3,t.IGlobalExtensionEnablementService),G(4,A.ILogService)],R),e.ExtensionsCleaner=R}),define(te[201],ne([0,1,3,2]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends t.Disposable{constructor(C,P){super();this.channel=C,this.workspace=P}async getItems(){const C={workspace:this.workspace},P=await this.channel.call("getItems",C);return new Map(P)}updateItems(C){const P={workspace:this.workspace};return C.insert&&(P.insert=Array.from(C.insert.entries())),C.delete&&(P.delete=Array.from(C.delete.values())),this.channel.call("updateItems",P)}}class T extends L{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(C,P){super(C,P);this.onDidChangeItemsExternal=k.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class R extends t.Disposable{constructor(C,P){super();this.channel=C,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[202],ne([0,1,5,2,20,76,23,201]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(P,E,f){super();this.mainProcessService=E,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new t.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new T.Storage(P.globalStorage);return this._register(E.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),E}createWorkspaceStorage(P){const E=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(E.workspaceStorage){const f=new T.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const E=this.workspaceStorage,f=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[p,d]of f)this.workspaceStorage.set(p,d)}}e.NativeStorageService=b}),define(te[203],ne([0,1,4,33,7,29]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(C){if(k.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function R(C,P,E,f,p,d,h,v,m,w){const y=Object.create(null);y["common.machineId"]=h,y.sessionID=(0,T.generateUuid)()+Date.now(),y.commitHash=p,y.version=d,y["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,k.PlatformToString)(k.platform),y["common.nodePlatform"]=t.platform,y["common.nodeArch"]=f,y["common.product"]=w||"desktop";const S=b(v||[]);S&&(y["common.msftInternal"]=S);let l=0;const r=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),k.isLinuxSnap&&(y["common.snap"]="true");const c=A(E);c&&(y["common.platformDetail"]=c);try{const i=await C.readFile(L.URI.file(m));y["common.source"]=i.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=R;function b(C){const P=t.env.USERDNSDOMAIN;if(!P)return!1;const E=P.toLowerCase();return C.some(f=>E===f)}e.verifyMicrosoftInternalDomain=b}),define(te[21],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[204],ne([0,1,34,55,5,35,19,10,4,7,113,22,116,81,15,27,21]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function w(c,i){const n=`${c}::${i.join(":")}`,o=m.get(n);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,u=new Map,g=2e4;function I(M,F,D,N){const $=F.substring(M.length+1);return L.Promises.withAsyncBody(async B=>{let Z;try{Z=await E.Promises.readdir(F,{withFileTypes:!0})}catch{B();return}if(N.count>=g){N.count+=Z.length,N.maxReached=!0,B();return}let W=Z.length;if(W===0){B();return}let ee=Z;N.count+Z.length>g&&(N.maxReached=!0,W=g-N.count,ee=Z.slice(0,W)),N.count+=Z.length;for(const x of ee)if(x.isDirectory()){if(D.includes(x.name)||await I(M,(0,R.join)(F,x.name),D,N),--W==0){B();return}}else{const j=x.name.lastIndexOf(".");if(j>=0){const Y=x.name.substring(j+1);Y&&a.set(Y,(a.get(Y)??0)+1)}for(const Y of s)Y.relativePathPattern?.test($)!==!1&&Y.filePattern.test(x.name)&&u.set(Y.tag,(u.get(Y.tag)??0)+1);if(--W==0){B();return}}})}const _=L.Promises.withAsyncBody(async M=>{const F={count:0,maxReached:!1};await I(c,c,i,F);const D=await l(c);M({configFiles:y(u),fileTypes:y(a),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:D})});return m.set(n,_),_}e.collectWorkspaceStats=w;function y(c){return[...t.Iterable.map(c.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function S(){const c={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},i=k.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=S;async function l(c){try{const i=new Map,n=(0,R.join)(c,".vscode","launch.json"),o=await E.Promises.readFile(n),s=[],a=(0,T.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,T.getNodeType)(a)==="object"&&a.configurations)for(const u of a.configurations){const g=u.type;g&&(i.has(g)?i.set(g,i.get(g)+1):i.set(g,1))}return y(i)}catch{return[]}}e.collectLaunchConfigs=l;let r=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const o=k.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||n.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,f.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[s,a]=o,u=this.formatProcessList(i,s);return n.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))u+=`
${g.errorMessage}`,a+=`
${g.errorMessage}`;else if(u+=`

Remote: ${g.hostName}`,g.processes&&(u+=`
${this.formatProcessList(i,g.processes)}`),g.workspaceMetadata){a+=`
|  Remote: ${g.hostName}`;for(const I of Object.keys(g.workspaceMetadata)){const _=g.workspaceMetadata[I];let M=`${_.fileCount} files`;_.maxFilesReached&&(M=`more than ${M}`),a+=`|    Folder (${I}): ${M}`,a+=this.formatWorkspaceStats(_)}}}),{processInfo:u,workspaceInfo:a}})}async getSystemInfo(i,n){const{memory:o,vmHint:s,os:a,cpus:u}=S(),g={os:a,memory:o,cpus:u,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return b.isWindows||(g.load=`${k.loadavg().map(I=>Math.round(I)).join(", ")}`),b.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(i,n){const o=[];return(0,f.listProcesses)(i.mainPID).then(async s=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,s)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const u of Object.keys(a.workspaceMetadata)){const g=a.workspaceMetadata[u];let I=`${g.fileCount} files`;g.maxFilesReached&&(I=`more than ${I}`),o.push(`Folder (${u}): ${I}`),o.push(this.formatWorkspaceStats(g))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let s=0;const a=(_,M)=>{const F=` ${_}(${M})`;s+F.length>o?(n.push(u),u="|                 ",s=u.length):s+=F.length,u+=F};let u="|      File types:";const g=10;let I=i.fileTypes.length>g?g:i.fileTypes.length;for(let _=0;_<I;_++){const M=i.fileTypes[_];a(M.name,M.count)}if(n.push(u),i.configFiles.length>=0&&(u="|      Conf files:",s=0,i.configFiles.forEach(_=>{a(_.name,_.count)}),n.push(u)),i.launchConfigFiles.length>0){let _="|      Launch Configs:";i.launchConfigFiles.forEach(M=>{_+=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`}),n.push(_)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const u=C.URI.revive(a);if(u.scheme===A.Schemas.file){const g=u.fsPath;o.push(w(g,["node_modules",".git"]).then(I=>{let _=`${I.fileCount} files`;I.maxFilesReached&&(_=`more than ${_}`),n.push(`|    Folder (${(0,R.basename)(g)}): ${_}`),n.push(this.formatWorkspaceStats(I))}).catch(I=>{n.push(`|      Error: Unable to collect workspace stats for folder ${g} (${I.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(a=>o.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,s,n,0),s.join(`
`)}formatProcessItem(i,n,o,s,a){const u=a===0;let g;u?g=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(g=`${g} (${n.get(s.pid)})`));const I=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(I/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(_=>this.formatProcessItem(i,n,o,_,a+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:o}of i.folders){const s=C.URI.revive(o);if(s.scheme!==A.Schemas.file)continue;const a=s.fsPath;try{(await w(a,["node_modules",".git"])).fileTypes.forEach(g=>n.add(g.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=C.URI.revive(n);if(o.scheme!==A.Schemas.file)continue;const s=o.fsPath;try{const a=await w(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),a.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),a.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};r=de([G(0,v.ITelemetryService),G(1,h.IProductService)],r),e.DiagnosticsService=r}),define(te[205],ne([0,1,16,5,25,9,3,2,4,11,7,129,30,31,8,27,21]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends R.Disposable{constructor(c,i,n,o){super();this.galleryService=c,this.telemetryService=i,this.logService=n,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const i=await this.getTargetPlatform();return c.allTargetPlatforms.some(n=>(0,f.isTargetPlatformCompatible)(n,c.allTargetPlatforms,i))}async installFromGallery(c,i={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(E.localize(0,null),f.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(c,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,i)}catch(n){throw S(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(c),void 0,n),this.logService.error("Failed to install extension.",c.identifier.id),this.logService.error(n),y(n)}}async uninstall(c,i={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,i)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const i=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...c.identifier,preRelease:c.preRelease}],{targetPlatform:i,compatible:!0},L.CancellationToken.None);if(!n)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.extensionsControlManifest||c-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=c),this.extensionsControlManifest}registerParticipant(c){this.participants.push(c)}async installExtension(c,i,n){if(!P.URI.isUri(i)){let g=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(g)return this.logService.info("Extensions is already requested to install",i.identifier.id),g.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],a=this.createInstallExtensionTask(c,i,n);P.URI.isUri(i)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:i}),this.logService.info("Installing extension:",a.identifier.id),o.push({task:a,manifest:c});let u=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:_,manifest:M}of I)if(u=u||!!M.extensionDependencies?.some(F=>(0,p.areSameExtensions)({id:F},a.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const F=this.createInstallExtensionTask(M,_,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(F.identifier,M.version).key(),F),this._onInstallExtension.fire({identifier:F.identifier,source:_}),this.logService.info("Installing extension:",F.identifier.id),o.push({task:F,manifest:M})}}catch(I){if(P.URI.isUri(a.source))(0,k.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,I.message),(0,k.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),I}const g=o.reduce((I,{task:_,manifest:M})=>(I.set(_.identifier.id.toLowerCase(),{task:_,manifest:M}),I),new Map);for(;g.size;){let I;const _=[...g.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(F=>g.has(F.toLowerCase())));_.length?I=g.size===1?_:_.filter(({task:M})=>!(M===a&&!u)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:M})=>M.identifier.id)),I=[...g.values()]),await this.joinAllSettled(I.map(async({task:M})=>{const F=new Date().getTime(),D=(0,C.isUndefined)(n.operation)?M.operation:n.operation;try{const N=await M.run();if(await this.joinAllSettled(this.participants.map($=>$.postInstall(N,M.source,n,L.CancellationToken.None))),!P.URI.isUri(M.source)&&(S(this.telemetryService,D===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(M.source),new Date().getTime()-F,void 0),b.isWeb&&D!==3))try{await this.galleryService.reportStatistic(N.manifest.publisher,N.manifest.name,N.manifest.version,"install")}catch{}s.push({local:N,identifier:M.identifier,operation:D,source:M.source})}catch(N){throw P.URI.isUri(M.source)||S(this.telemetryService,D===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(M.source),new Date().getTime()-F,N),this.logService.error("Error while installing the extension:",M.identifier.id),N}finally{g.delete(M.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:I})=>(0,p.areSameExtensions)(I,a.identifier))[0].local}catch(g){if(o.forEach(({task:I})=>I.cancel()),s.length)try{const I=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<I.length;_++){const M=I[_],{identifier:F}=s[_];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,T.getErrorMessage)(M.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(I),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),g}finally{for(const{task:g,manifest:I}of o)if(!P.URI.isUri(g.source)){const _=new p.ExtensionIdentifierWithVersion(g.identifier,I.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(c){const i=[],n=[],o=await Promise.allSettled(c);for(const s of o)s.status==="fulfilled"?i.push(s.value):n.push(s.reason);if(n.length)throw w(n);return i}async getAllDepsAndPackExtensionsToInstall(c,i,n,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const a=[c,...s.map(I=>I.identifier)],u=[],g=async(I,_)=>{const M=_.extensionDependencies||[],F=[...M];if(_.extensionPack){const D=n?s.find(N=>(0,p.areSameExtensions)(N.identifier,I)):void 0;for(const N of _.extensionPack)D&&D.manifest.extensionPack&&D.manifest.extensionPack.some($=>(0,p.areSameExtensions)({id:$},{id:N}))||F.every($=>!(0,p.areSameExtensions)({id:$},{id:N}))&&F.push(N)}if(F.length){const D=[...a,...u.map($=>$.gallery.identifier)],N=F.filter($=>D.every(B=>!(0,p.areSameExtensions)(B,{id:$})));if(N.length){const $=await this.galleryService.getExtensions(N.map(B=>({id:B,preRelease:o})),L.CancellationToken.None);for(const B of $){if(D.find(ee=>(0,p.areSameExtensions)(ee,B.identifier)))continue;const Z=M.some(ee=>(0,p.areSameExtensions)({id:ee},B.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(B,!0,o)}catch(ee){if(ee instanceof f.ExtensionManagementError&&ee.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Z){this.logService.info("Skipping the packed extension as it cannot be installed",B.identifier.id);continue}else throw ee}u.push({gallery:W.extension,manifest:W.manifest}),await g(W.extension.identifier,W.manifest)}}}};return await g(c,i),s=await this.getInstalled(),u.filter(I=>!s.some(_=>(0,p.areSameExtensions)(_.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(c,i,n){const o=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(o).has(c.identifier.id))throw new f.ExtensionManagementError(E.localize(3,null,c.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[c.identifier.id])throw new f.ExtensionManagementError(E.localize(4,null,c.identifier.id,o.unsupportedPreReleaseExtensions[c.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(c)){const u=await this.getTargetPlatform();throw new f.ExtensionManagementError(E.localize(5,null,c.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(u)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(c,i,n);if(s){if(n&&i&&c.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(E.localize(6,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&c.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([c.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(E.localize(7,null,c.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(E.localize(8,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const a=await this.galleryService.getManifest(s,L.CancellationToken.None);if(a===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(a.version!==s.version)throw new f.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:a}}async getCompatibleVersion(c,i,n){const o=await this.getTargetPlatform();let s=null;return i&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==n&&(s=(await this.galleryService.getExtensions([{...c.identifier,preRelease:n}],{targetPlatform:o,compatible:!0},L.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(c,n,o)&&(s=c),!s&&i&&(s=await this.galleryService.getCompatibleExtension(c,n,o)),s}async unininstallExtension(c,i){const n=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),n.waitUntilTaskIsFinished();const o=(g,I)=>{const _=this.createUninstallExtensionTask(g,I);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",g.identifier.id),this._onUninstallExtension.fire(g.identifier),_},s=(g,I)=>{I?this.logService.error("Failed to uninstall extension:",g.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",g.identifier.id),S(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(g),void 0,I),this._onDidUninstallExtension.fire({identifier:g.identifier,error:I?.code})},a=[],u=[];try{a.push(o(c,{}));const g=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(c,g);for(const _ of I)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):a.push(o(_,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(I=>I.extension),g,c),await this.joinAllSettled(a.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(I.extension,i,L.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}s(I.extension)}catch(_){const M=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,T.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw s(I.extension,M),M}finally{u.push(I)}}))}catch(g){const I=g instanceof f.ExtensionManagementError?g:new f.ExtensionManagementError((0,T.getErrorMessage)(g),f.ExtensionManagementErrorCode.Internal);for(const _ of a){try{_.cancel()}catch{}u.includes(_)||s(_.extension,I)}throw I}finally{for(const g of a)this.uninstallingExtensions.delete(g.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",g.extension.identifier.id)}}checkForDependents(c,i,n){for(const o of c){const s=this.getDependents(o,i);if(s.length){const a=s.filter(u=>!c.some(g=>(0,p.areSameExtensions)(g.identifier,u.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(o,a,n))}}}getDependentsErrorMessage(c,i,n){return n===c?i.length===1?E.localize(9,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(10,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(11,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?E.localize(12,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(13,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(14,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(c,i,n=[]){if(n.indexOf(c)!==-1)return[];n.push(c);const o=c.manifest.extensionPack?c.manifest.extensionPack:[];if(o.length){const s=i.filter(u=>!u.isBuiltin&&o.some(g=>(0,p.areSameExtensions)({id:g},u.identifier))),a=[];for(const u of s)a.push(...this.getAllPackExtensionsToUninstall(u,i,n));return[...s,...a]}return[]}getDependents(c,i){return i.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(o=>(0,p.areSameExtensions)({id:o},c.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",c),c}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=de([G(0,f.IExtensionGalleryService),G(1,v.ITelemetryService),G(2,d.ILogService),G(3,h.IProductService)],m),e.AbstractExtensionManagementService=m;function w(r){const c=Array.isArray(r)?r:[r];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((i,n)=>new Error(`${i.message}${i.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=w;function y(r){if(r instanceof f.ExtensionManagementError)return r;const c=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return c.stack=r.stack,c}function S(r,c,i,n,o){const s=o?o instanceof f.ExtensionManagementError?o.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(c,{...i,success:!o,duration:n,errorcode:s})}e.reportTelemetry=S;class l{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(c=>new Promise((i,n)=>{const o=c.onCancellationRequested(()=>{o.dispose(),n((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(te[206],ne([0,1,16,5,68,3,10,4,33,7,131,14,30,31,194,83,15,8,60,27,43,23,21]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const c="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let n=class extends d.ExtensionTipsService{constructor(s,a,u,g,I,_,M,F,D,N){super(M,F,D,N);this.environmentService=s,this.telemetryService=a,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=I,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&(0,L.forEach)(F.exeBasedExtensionTips,({key:$,value:B})=>{const Z=[],W=[],ee=[];(0,L.forEach)(B.recommendations,({key:x,value:j})=>{j.important?B.important?Z.push({extensionId:x,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):W.push({extensionId:x,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):ee.push({extensionId:x,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),Z.length&&this.highImportanceExecutableTips.set($,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:Z}),W.length&&this.mediumImportanceExecutableTips.set($,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:W}),ee.length&&this.allOtherExecutableTips.set($,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:ee})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...a]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(a,u)}groupImportantTipsByExe(s,a){const u=new Map;s.forEach(F=>u.set(F.extensionId.toLowerCase(),F));const{installed:g,uninstalled:I}=this.groupByInstalled([...u.keys()],a);for(const F of g){const D=u.get(F);D&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:D.exeName})}for(const F of I){const D=u.get(F);D&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:D.exeName})}const _=this.getPromptedExecutableTips(),M=new Map;for(const F of I){const D=u.get(F);if(D&&(!_[D.exeName]||!_[D.exeName].includes(D.extensionId))){let N=M.get(D.exeName);N||(N=[],M.set(D.exeName,N)),N.push(D)}}return M}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,a]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(a[0].exeName,a);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const g=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const g=this._register((0,t.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),a=Date.now()-s,u=7*24*60*60*1e3;if(a<u){const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u-a));return}const[g,I]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(I).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(I[0].exeName,I);const M=this._register((0,t.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},u));break}case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const M=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(M(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const M=this._register((0,t.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(s){const a=await this.extensionManagementService.getInstalled(1),u=s.filter(I=>!I.whenNotInstalled||I.whenNotInstalled.every(_=>a.every(M=>!(0,p.areSameExtensions)(M.identifier,{id:_})))).map(({extensionId:I})=>I.toLowerCase()),g=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(u,g,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(i,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(i,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(c,0,"{}"))}addToRecommendedExecutables(s,a){const u=this.getPromptedExecutableTips();u[s]=a.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(c,JSON.stringify(u),0,0)}groupByInstalled(s,a){const u=[],g=[],I=a.reduce((_,M)=>(_.add(M.identifier.id.toLowerCase()),_),new Set);return s.forEach(_=>{I.has(_.toLowerCase())?u.push(_):g.push(_)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(s){const a=[],u=new Map;for(const g of s.keys()){const I=s.get(g);if(!I||!(0,k.isNonEmptyArray)(I.recommendations))continue;const _=[];R.isWindows?I.windowsPath&&_.push(I.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(_.push((0,A.join)("/usr/local/bin",g)),_.push((0,A.join)("/usr/bin",g)),_.push((0,A.join)(this.environmentService.userHome.fsPath,g)));for(const M of _){let F=u.get(M);if(F===void 0&&(F=await this.fileService.exists(C.URI.file(M)),u.set(M,F)),F)for(const{extensionId:D,extensionName:N,isExtensionPack:$,whenNotInstalled:B}of I.recommendations)a.push({extensionId:D,extensionName:N,isExtensionPack:$,exeName:g,exeFriendlyName:I.exeFriendlyName,windowsPath:I.windowsPath,whenNotInstalled:B})}}return a}};n=de([G(0,E.INativeEnvironmentService),G(1,r.ITelemetryService),G(2,f.IExtensionManagementService),G(3,l.IStorageService),G(4,w.INativeHostService),G(5,h.IExtensionRecommendationNotificationService),G(6,v.IFileService),G(7,y.IProductService),G(8,S.IRequestService),G(9,m.ILogService)],n),e.ExtensionTipsService=n}),define(te[93],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:R,data:b}){return this.appenders.forEach(C=>C.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class t{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[44],ne([0,1,28,11,18,21]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(w,y){return Promise.resolve(void 0)}publicLog2(w,y){return this.publicLog(w,y)}publicLogError(w,y){return Promise.resolve(void 0)}publicLogError2(w,y){return this.publicLogError(w,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class R{async publicLog(w,y,S){}async publicLogError(w,y,S){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(m,w){return w.onDidChangeConfiguration(y=>{y.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(y.source),configurationKeys:d(y.sourceConfig)})})}e.configurationTelemetry=b;function C(m,w){return!(w.disableTelemetry||!m.enableTelemetry||w.extensionTestsLocationURI)}e.supportsTelemetry=C;function P(m){const w=m.getValue(T.TELEMETRY_SETTING_ID),y=m.getValue("telemetry.enableCrashReporter");if(m.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function E(m){const w=Object.create(null),y=Object.create(null),S=Object.create(null);p(m,S);for(let l in S){l=l.length>150?l.substr(l.length-149):l;const r=S[l];typeof r=="number"?y[l]=r:typeof r=="boolean"?y[l]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${r.length}`),w[l]=r.substring(0,8191)):typeof r!="undefined"&&r!==null&&(w[l]=r)}return{properties:w,measurements:y}}e.validateTelemetryData=E;function f(m){if(!m)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(S=>{m.indexOf(`${S}+`)===0&&(w=S)}),w}e.cleanRemoteAuthority=f;function p(m,w,y=0,S){if(!!m)for(let l of Object.getOwnPropertyNames(m)){const r=m[l],c=S?S+l:l;Array.isArray(r)?w[c]=(0,k.safeStringify)(r):r instanceof Date?w[c]=r.toISOString():(0,t.isObject)(r)?y<2?p(r,w,y+1,c+"."):w[c]=(0,k.safeStringify)(r):w[c]=r}}function d(m){if(!m)return[];const w=[];return h(w,"",m),w}function h(m,w,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(S=>h(m,w?`${w}.${S}`:S,y[S])):m.push(w)}function v(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=v}),define(te[207],ne([0,1,44,150]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(b,C){}postEvent(b,C){}}class T{constructor(b,C,P,E,f){this.getMachineId=b,this.configurationService=C,this.productService=P,this.telemetry=E,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,k.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),d=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(h=>setTimeout(h,d))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const C=this.configurationService.getValue("experiments.override."+b);if(C!==void 0)return C;if(!this.tasClient||!this.experimentsEnabled)return;let P;const E=await this.tasClient;return this.networkInitialized?P=E.getTreatmentVariable("vscode",b):P=await E.getTreatmentVariableAsync("vscode",b,!0),P=E.getTreatmentVariable("vscode",b),P}async setupTASClient(){const b=this.productService.quality==="stable"?t.TargetPopulation.Public:t.TargetPopulation.Insiders,C=await this.getMachineId(),P=new t.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,C,b),E=this.productService.tasConfig,f=new(await new Promise((p,d)=>{K(["tas-client-umd"],p,d)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:t.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:t.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=T;class A extends T{constructor(b,C,P){super(()=>Promise.resolve(b),C,P,new L)}}e.AssignmentService=A}),define(te[208],ne([0,1,47,44]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(T,A,R,b,C,P){const E={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},f=await(0,k.getServiceMachineId)(R,C,P);return(0,t.supportsTelemetry)(A,R)&&(0,t.getTelemetryLevel)(b)===3&&(E["X-Market-User-Id"]=f),E}e.resolveMarketplaceHeaders=L}),define(te[209],ne([0,1,16,25,9,28,4,33,11,7,18,14,30,31,79,15,8,27,43,208,23,21]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=A.isWeb?"web":(0,f.getTargetPlatform)(A.platform,R.arch);var c;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(c||(c={}));function i(...O){return String(O.reduce((U,z)=>U|z,0))}var n;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class g{constructor(U=u){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,z=this.state.pageSize){return new g({...this.state,pageNumber:U,pageSize:z})}withFilter(U,...z){const H=[...this.state.criteria,...z.length?z.map(ie=>({filterType:U,value:ie})):[{filterType:U}]];return new g({...this.state,criteria:H})}withSortBy(U){return new g({...this.state,sortBy:U})}withSortOrder(U){return new g({...this.state,sortOrder:U})}withFlags(...U){return new g({...this.state,flags:U.reduce((z,H)=>z|H,0)})}withAssetTypes(...U){return new g({...this.state,assetTypes:U})}get raw(){const{criteria:U,pageNumber:z,pageSize:H,sortBy:ie,sortOrder:se,flags:ue,assetTypes:he}=this.state;return{filters:[{criteria:U,pageNumber:z,pageSize:H,sortBy:ie,sortOrder:se}],assetTypes:he,flags:ue}}get searchText(){const U=this.state.criteria.filter(z=>z.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function I(O,U){const z=(O||[]).filter(H=>H.statisticName===U)[0];return z?z.value:0}function _(O){const U="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(H=>H.assetType.indexOf(U)===0).reduce((H,ie)=>{const se=D(O,ie.assetType);return se&&H.push([ie.assetType.substring(U.length),se]),H},[])}function M(O){if(O.properties){const U=O.properties.filter(ie=>ie.key===o.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=U.filter(ie=>z.test(ie.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return D(O,o.Repository)}function F(O){return{uri:`${O.fallbackAssetUri}/${o.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${o.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function D(O,U){return O.files.filter(H=>H.assetType===U)[0]?{uri:`${O.assetUri}/${U}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${U}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function N(O,U){const z=O.properties?O.properties.filter(ie=>ie.key===U):[],H=z.length>0&&z[0].value;return H?H.split(",").map(ie=>(0,p.adoptToGalleryExtensionId)(ie)):[]}function $(O){const U=O.properties?O.properties.filter(z=>z.key===s.Engine):[];return U.length>0&&U[0].value||""}function B(O){const U=O.properties?O.properties.filter(z=>z.key===s.PreRelease):[];return U.length>0&&U[0].value==="true"}function Z(O){const U=O.properties?O.properties.filter(H=>H.key===s.LocalizedLanguages):[],z=U.length>0&&U[0].value||"";return z?z.split(","):[]}function W(O){return O.indexOf("preview")!==-1}function ee(O){return O.targetPlatform?(0,f.toTargetPlatform)(O.targetPlatform):"undefined"}function x(O){const U=(0,k.distinct)(O.versions.map(ee)),z=!!O.tags?.includes(f.WEB_EXTENSION_TAG),H=U.indexOf("web");return z?H===-1&&U.push("web"):H!==-1&&U.splice(H,1),U}function j(O,U){const z=(0,f.getFallbackTargetPlarforms)(U);for(let H=0;H<O.length;H++){const ie=O[H];if(ie.version===O[H-1]?.version){let se=H;const ue=ee(ie);if(ue===U)for(;se>0&&O[se-1].version===ie.version;)se--;else if(z.includes(ue))for(;se>0&&O[se-1].version===ie.version&&ee(O[se-1])!==U;)se--;se!==H&&(O.splice(H,1),O.splice(se,0,ie))}}return O}e.sortExtensionVersions=j;function Y(O,U,z){O.telemetryData={index:U,querySource:z}}function V(O,U,z){const H=O.versions[0],ie={manifest:D(U,o.Manifest),readme:D(U,o.Details),changelog:D(U,o.Changelog),license:D(U,o.License),repository:M(U),download:F(U),icon:D(U,o.Icon),coreTranslations:_(U)};return{identifier:{id:(0,p.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:U.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,description:O.shortDescription||"",installCount:I(O.statistics,"install"),rating:I(O.statistics,"averagerating"),ratingCount:I(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:z,assets:ie,properties:{dependencies:N(U,s.Dependency),extensionPack:N(U,s.ExtensionPack),engine:$(U),localizedLanguages:Z(U),targetPlatform:ee(U),isPreReleaseVersion:B(U)},hasPreReleaseVersion:B(H),hasReleaseVersion:!0,preview:W(O.flags)}}let J=class{constructor(U,z,H,ie,se,ue,he,we){this.requestService=z,this.logService=H,this.environmentService=ie,this.telemetryService=se,this.fileService=ue,this.productService=he,this.configurationService=we;const pe=he.extensionsGallery;this.extensionsGalleryUrl=pe&&pe.serviceUrl,this.extensionsControlUrl=pe&&pe.controlUrl,this.commonHeadersPromise=(0,y.resolveMarketplaceHeaders)(he.version,he,this.environmentService,this.configurationService,this.fileService,U)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,z,H){const ie=t.CancellationToken.isCancellationToken(z)?{}:z,se=t.CancellationToken.isCancellationToken(z)?z:H,ue=[],he=[],we=[],pe=[];let ge=!0;for(const Ce of U){Ce.uuid?he.push(Ce.uuid):ue.push(Ce.id);const De=!!(Ce.version||Ce.preRelease);we.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:De}),Ce.version&&pe.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),ge=ge&&!!Ce.hasPreRelease&&!De}if(!he.length&&!ue.length)return[];let Ee=new g().withPage(1,U.length);he.length&&(Ee=Ee.withFilter(n.ExtensionId,...he)),ue.length&&(Ee=Ee.withFilter(n.ExtensionName,...ue)),(ie.queryAllVersions||ge)&&(Ee=Ee.withFlags(Ee.flags,c.IncludeVersions));const{extensions:Te}=await this.queryGalleryExtensions(Ee,{targetPlatform:ie.targetPlatform??r,includePreRelease:we,versions:pe,compatible:!!ie.compatible},se);return ie.source&&Te.forEach((Ce,De)=>Y(Ce,De,ie.source)),Te}async getCompatibleExtension(U,z,H){if((0,f.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(U,z,H))return U;const ie=new g().withFlags(c.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:se}=await this.queryGalleryExtensions(ie,{targetPlatform:H,compatible:!0,includePreRelease:z},t.CancellationToken.None);return se[0]||null}async isExtensionCompatible(U,z,H){if(!(0,f.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,H)||!z&&U.properties.isPreReleaseVersion)return!1;let ie=U.properties.engine;if(!ie){const se=await this.getManifest(U,t.CancellationToken.None);if(!se)throw new Error("Manifest was not found");ie=se.engines.vscode}return(0,d.isEngineValid)(ie,this.productService.version,this.productService.date)}async isValidVersion(U,z,H,ie,se){if(!(0,f.isTargetPlatformCompatible)(ee(U),ie,se)||z!=="any"&&B(U)!==(z==="prerelease"))return!1;if(H){const ue=await this.getEngine(U);if(!(0,d.isEngineValid)(ue,this.productService.version,this.productService.date))return!1}return!0}async query(U,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let H=U.text||"";const ie=(0,T.getOrDefault)(U,ge=>ge.pageSize,50);let se=new g().withPage(1,ie);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Te)=>(se=se.withFilter(n.Category,Te||Ee),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Te)=>(se=se.withFilter(n.Tag,Te||Ee),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(n.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),se=se.withFilter(n.SearchText,H)),se=se.withSortBy(0)):U.ids?se=se.withFilter(n.ExtensionId,...U.ids):U.names?se=se.withFilter(n.ExtensionName,...U.names):se=se.withSortBy(4),typeof U.sortBy=="number"&&(se=se.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(se=se.withSortOrder(U.sortOrder));const ue=async(ge,Ee)=>{const{extensions:Te,total:Ce}=await this.queryGalleryExtensions(ge,{targetPlatform:r,compatible:!1,includePreRelease:!!U.includePreRelease},Ee);return Te.forEach((De,qe)=>Y(De,(ge.pageNumber-1)*ge.pageSize+qe,U.source)),{extensions:Te,total:Ce}},{extensions:he,total:we}=await ue(se,z),pe=async(ge,Ee)=>{if(Ee.isCancellationRequested)throw new L.CancellationError;const{extensions:Te}=await ue(se.withPage(ge+1),Ee);return Te};return{firstPage:he,total:we,pageSize:se.pageSize,getPage:pe}}async queryGalleryExtensions(U,z,H){const ie=U.flags;!!(U.flags&c.IncludeLatestVersionOnly)&&!!(U.flags&c.IncludeVersions)&&(U=U.withFlags(U.flags&~c.IncludeVersions,c.IncludeLatestVersionOnly)),!(U.flags&c.IncludeLatestVersionOnly)&&!(U.flags&c.IncludeVersions)&&(U=U.withFlags(U.flags,c.IncludeLatestVersionOnly)),z.versions?.length&&(U=U.withFlags(U.flags&~c.IncludeLatestVersionOnly,c.IncludeVersions)),U=U.withFlags(U.flags,c.IncludeAssetUri,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeStatistics,c.IncludeVersionProperties);const{galleryExtensions:se,total:ue}=await this.queryRawGalleryExtensions(U,H);if(!(U.flags&c.IncludeLatestVersionOnly)){const ge=[];for(const Ee of se){const Te=await this.toGalleryExtensionWithCriteria(Ee,z,!0);Te&&ge.push(Te)}return{extensions:ge,total:ue}}const we=[],pe=new Map;for(let ge=0;ge<se.length;ge++){const Ee=se[ge],Te={id:(0,p.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Ce=(0,b.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(qe=>(0,p.areSameExtensions)(qe,Te))?.includePreRelease;let De=await this.toGalleryExtensionWithCriteria(Ee,z,!1);!De||De.properties.isPreReleaseVersion&&(!Ce||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==z.targetPlatform&&De.hasPreReleaseVersion?pe.set(Ee.extensionId,ge):we.push([ge,De])}if(pe.size){const ge=new Date().getTime(),Ee=new g().withFlags(ie&~c.IncludeLatestVersionOnly,c.IncludeVersions).withPage(1,pe.size).withFilter(n.ExtensionId,...pe.keys()),{extensions:Te}=await this.queryGalleryExtensions(Ee,z,H);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:pe.size});for(const Ce of Te){const De=pe.get(Ce.identifier.uuid);we.push([De,Ce])}}return{extensions:we.sort((ge,Ee)=>ge[0]-Ee[0]).map(([,ge])=>ge),total:ue}}async toGalleryExtensionWithCriteria(U,z,H){const ie={id:(0,p.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},se=z.versions?.find(pe=>(0,p.areSameExtensions)(pe,ie))?.version,ue=(0,b.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(pe=>(0,p.areSameExtensions)(pe,ie))?.includePreRelease,he=x(U),we=j(U.versions,z.targetPlatform);if(z.compatible&&H&&(0,f.isNotWebExtensionInWebTargetPlatform)(he,z.targetPlatform))return null;for(let pe=0;pe<we.length;pe++){const ge=we[pe];if(!(se&&ge.version!==se)){if(await this.isValidVersion(ge,ue?"any":"release",z.compatible,he,z.targetPlatform))return V(U,ge,he);if(se&&ge.version===se)return null}}return se||z.compatible?null:V(U,U.versions[0],he)}async queryRawGalleryExtensions(U,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,c.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(c.Unpublished));const H=await this.commonHeadersPromise,ie=JSON.stringify(U.raw),se={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ie.length)},ue=new Date().getTime();let he,we,pe=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ie,headers:se},z),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:pe};const ge=await(0,w.asJson)(he);if(ge){const Ee=ge.results[0],Te=Ee.extensions,Ce=Ee.resultMetadata&&Ee.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return pe=Ce&&Ce.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:pe}}return{galleryExtensions:[],total:pe}}catch(ge){throw we=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ie.length),duration:new Date().getTime()-ue,success:!!he&&(0,w.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:we?(0,L.isCancellationError)(we)?"canceled":(0,L.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(U,z,H,ie){if(!this.isEnabled())return;const se=A.isWeb?this.api(`/itemName/${U}.${z}/version/${H}/statType/${ie==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${z}/${H}/stats?statType=${ie}`),ue=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:ue};try{await this.requestService.request({type:"POST",url:se,headers:we},t.CancellationToken.None)}catch{}}async download(U,z,H){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const ie=(0,p.getGalleryExtensionTelemetryData)(U),se=new Date().getTime(),ue=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ie,duration:ge}),he=H===2?"install":H===3?"update":"",we=he?{uri:`${U.assets.download.uri}${C.URI.parse(U.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${U.assets.download.fallbackUri}${C.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:U.assets.download,pe=await this.getAsset(we);await this.fileService.writeFile(z,pe.stream),ue(new Date().getTime()-se)}async getReadme(U,z){if(U.assets.readme){const H=await this.getAsset(U.assets.readme,{},z);return await(0,w.asText)(H)||""}return""}async getManifest(U,z){if(U.assets.manifest){const H=await this.getAsset(U.assets.manifest,{},z),ie=await(0,w.asText)(H);return ie?JSON.parse(ie):null}return null}async getManifestFromRawExtensionVersion(U,z){const H=D(U,o.Manifest);if(!H)throw new Error("Manifest was not found");const ie={"Accept-Encoding":"gzip"},se=await this.getAsset(H,{headers:ie});return await(0,w.asJson)(se)}async getCoreTranslation(U,z){const H=U.assets.coreTranslations.filter(ie=>ie[0]===z.toUpperCase())[0];if(H){const ie=await this.getAsset(H[1]),se=await(0,w.asText)(ie);return se?JSON.parse(se):null}return null}async getChangelog(U,z){if(U.assets.changelog){const H=await this.getAsset(U.assets.changelog,{},z);return await(0,w.asText)(H)||""}return""}async getAllCompatibleVersions(U,z,H){let ie=new g().withFlags(c.IncludeVersions,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?ie=ie.withFilter(n.ExtensionId,U.identifier.uuid):ie=ie.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:se}=await this.queryRawGalleryExtensions(ie,t.CancellationToken.None);if(!se.length)return[];const ue=x(se[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(ue,H))return[];const he=[],we=new Set;return await Promise.all(se[0].versions.map(async pe=>{try{if(we.has(pe.version))return;await this.isValidVersion(pe,z?"any":"release",!0,ue,H)&&(he.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:B(pe)}),we.add(pe.version))}catch{}})),he}async getAsset(U,z={},H=t.CancellationToken.None){const ie=await this.commonHeadersPromise,se={type:"GET"},ue={...ie,...z.headers||{}};z={...z,...se,headers:ue};const he=U.uri,we=U.fallbackUri,pe={...z,url:he};try{const ge=await this.requestService.request(pe,H);if(ge.res.statusCode===200)return ge;const Ee=await(0,w.asText)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${Ee}`)}catch(ge){if((0,L.isCancellationError)(ge))throw ge;const Ee=(0,L.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:he,message:Ee});const Te={...z,url:we};return this.requestService.request(Te,H)}}async getEngine(U){let z=$(U);if(!z){const H=await this.getManifestFromRawExtensionVersion(U,t.CancellationToken.None);if(!H)throw new Error("Manifest was not found");z=H.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,w.asJson)(U),H=[],ie={};if(z){for(const se of z.malicious)H.push({id:se});if(z.unsupported)for(const se of Object.keys(z.unsupported)){const ue=z.unsupported[se];(0,b.isBoolean)(ue)||(ie[se.toLowerCase()]=ue.preReleaseExtension)}if(z.migrateToPreRelease)for(const[se,ue]of Object.entries(z.migrateToPreRelease))(!ue.engine||(0,d.isEngineValid)(ue.engine,this.productService.version,this.productService.date))&&(ie[se.toLowerCase()]=ue)}return{malicious:H,unsupportedPreReleaseExtensions:ie}}};J=de([G(1,w.IRequestService),G(2,v.ILogService),G(3,E.IEnvironmentService),G(4,l.ITelemetryService),G(5,h.IFileService),G(6,m.IProductService),G(7,P.IConfigurationService)],J);let Q=class extends J{constructor(U,z,H,ie,se,ue,he,we){super(U,z,H,ie,se,ue,he,we)}};Q=de([G(0,S.IStorageService),G(1,w.IRequestService),G(2,v.ILogService),G(3,E.IEnvironmentService),G(4,l.ITelemetryService),G(5,h.IFileService),G(6,m.IProductService),G(7,P.IConfigurationService)],Q),e.ExtensionGalleryService=Q;let q=class extends J{constructor(U,z,H,ie,se,ue,he){super(void 0,U,z,H,ie,se,ue,he)}};q=de([G(0,w.IRequestService),G(1,v.ILogService),G(2,E.IEnvironmentService),G(3,l.ITelemetryService),G(4,h.IFileService),G(5,m.IProductService),G(6,P.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q}),define(te[94],ne([0,1,2,14,8,44]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends k.Disposable{constructor(b,C,P=""){super();this.prefix=P;const E=b.getLogger(C.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(b.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,C){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,T.validateTelemetryData)(C))}};A=de([G(0,L.ILoggerService),G(1,t.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[95],ne([0,1,2,28,4,26,141,18,42,88,38,21,44]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(v,m){this._configurationService=m,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let m=v.sessionID,w=v["common.machineId"],y=v["common.firstSessionDate"],S=v["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:y,msftInternal:S}}dispose(){this._disposables.dispose()}_log(v,m,w,y){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(S=>{w=(0,t.mixin)(w,S),w=(0,t.mixin)(w,this._experimentProperties),w=(0,t.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,y)}),this._appenders.forEach(l=>l.log(v,w))},S=>{console.error(S)})}publicLog(v,m,w){return this._log(v,3,m,w)}publicLog2(v,m,w){return this.publicLog(v,m,w)}publicLogError(v,m){return this.sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const w=[];for(let r of this._cleanupPatterns)for(;;){const c=r.exec(v);if(!c)break;w.push([c.index,r.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const r=S.exec(v);if(!r)break;!y.test(r[0])&&w.every(([c,i])=>r.index<c||r.index>=i)&&(m+=v.substring(l,r.index)+"<REDACTED: user-file-path>",l=S.lastIndex)}return l<v.length&&(m+=v.substr(l)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,y=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,S=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return y.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":S.test(m)?"<REDACTED: token>":v}_cleanupInfo(v,m){let w=v;m&&(w=this._anonymizeFilePaths(w));for(let y of this._cleanupPatterns)w=w.replace(y,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=de([G(1,R.IConfigurationService)],p),e.TelemetryService=p;function d(){const h=(0,A.localize)(0,null,C.default.nameLong),v=C.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=L.isWeb?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),y=(0,A.localize)(5,null),S=(0,A.localize)(6,null),l=(0,A.localize)(7,null),r=`
|       | ${w} | ${y} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,A.localize)(8,null);return`
${h} ${v} ${m}

&nbsp;

${l}
${r}

&nbsp;

${c}
`}P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,A.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,A.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[210],ne([0,1,9,28,44]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(R,b){const C=await new Promise((E,f)=>{K(["applicationinsights"],E,f)});let P;return C.defaultClient?(P=new C.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(C.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=C.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class A{constructor(b,C,P,E,f){this._eventPrefix=b,this._defaultData=C,this.testCollector=E,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(C=>{b(C)},C=>{(0,k.onUnexpectedError)(C),console.error(C)})}}log(b,C){if(!!this._aiClient){C=(0,t.mixin)(C,this._defaultData),C=(0,L.validateTelemetryData)(C),this.testCollector&&(C.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+b,properties:C.properties,measurements:C.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(C=>{try{C.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[211],ne([0,1,19,58,18,14,8,21,93,94,95]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,d,h,v){this.configurationService=p,this.telemetryService=d,this.loggerService=h,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:d,sessionId:h}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=d,v["common.vscodesessionid"]=h;const m=[p.id,JSON.stringify(v),p.aiKey],y=new t.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),S=[new b.TelemetryAppenderClient(y),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new P.TelemetryService({appenders:S,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,d,h){await(await this.getCustomTelemetryService(p)).publicLog(d,h)}async publicLogError(p,d,h){await(await this.getCustomTelemetryService(p)).publicLogError(d,h)}};E=de([G(0,L.IConfigurationService),G(1,R.ITelemetryService),G(2,A.ILoggerService),G(3,T.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[212],ne([0,1,5,25,3,2,8]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends T.Disposable{constructor(C,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((P,E)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...C});const p=new t.CancellationTokenSource;(0,k.timeout)(this._timeout,p.token).then(()=>E(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>p.cancel())])})}acceptReply(C,P){const E=this._pendingRequests.get(C);E?(this._pendingRequests.delete(C),(0,T.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),E(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};R=de([G(1,A.ILogService)],R),e.RequestStore=R}),define(te[96],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",h.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",h.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var b;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(h){h.TerminalView="view",h.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var d;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(d=e.ProfileSource||(e.ProfileSource={}))}),define(te[213],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(te[214],ne([0,1,46,10,143,25,37,9,4,29,124,152,5]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let d;async function h(m,w,y){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(y)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(y)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=f.Promises.withAsyncBody(async(S,l)=>{const r=new T.CancellationTokenSource,c=setTimeout(()=>{r.dispose(!0),l(new Error((0,L.localize)(0,null)))},p);try{S(await v(m,r.token))}catch(i){!(0,R.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(i)))):S({})}finally{clearTimeout(c),r.dispose()}})),d)}e.getResolvedShellEnv=h;async function v(m,w){const y=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",y);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",S);const l=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",c);const i=await(0,P.getSystemShell)(b.OS,c);return m.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(w.isCancellationRequested)return o((0,R.canceled)());const s=(0,t.basename)(i);let a,u;const g=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${g} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,u=["-Login","-Command"]):(a=`'${process.execPath}' ${g} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,s==="tcsh"?u=["-ic"]:u=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),a);const I=(0,k.spawn)(i,[...u,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});w.onCancellationRequested(()=>(I.kill(),o((0,R.canceled)()))),I.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),o(F)});const _=[];I.stdout.on("data",F=>_.push(F));const M=[];I.stderr.on("data",F=>M.push(F)),I.on("close",(F,D)=>{const N=Buffer.concat(_).toString("utf8");m.trace("getUnixShellEnvironment#raw",N);const $=Buffer.concat(M).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),F||D)return o(new Error((0,L.localize)(2,null,F,D)));const B=r.exec(N),Z=B?B[1]:"{}";try{const W=JSON.parse(Z);y?W.ELECTRON_RUN_AS_NODE=y:delete W.ELECTRON_RUN_AS_NODE,S?W.ELECTRON_NO_ATTACH_CONSOLE=S:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",W),n(W)}catch(W){m.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(W)),o(W)}})})}}),define(te[215],ne([0,1,34,28,10,4,33,11,22]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let f=0;return E&&E.length===4&&(f=parseInt(E[3])),f}e.getWindowsBuildNumber=C;async function P(E,f,p,d=A.env,h=b.Promises.exists){if(L.isAbsolute(E))return await h(E)?E:void 0;if(f===void 0&&(f=A.cwd()),L.dirname(E)!=="."){const y=L.join(f,E);return await h(y)?y:void 0}const m=(0,t.getCaseInsensitive)(d,"PATH");if(p===void 0&&(0,R.isString)(m)&&(p=m.split(L.delimiter)),p===void 0||p.length===0){const y=L.join(f,E);return await h(y)?y:void 0}for(let y of p){let S;if(L.isAbsolute(y)?S=L.join(y,E):S=L.join(f,y,E),await h(S))return S;if(T.isWindows){let l=S+".com";if(await h(l)||(l=S+".exe",await h(l)))return l}}const w=L.join(f,E);return await h(w)?w:void 0}e.findExecutable=P}),define(te[216],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var k;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(k=e.ColorScheme||(e.ColorScheme={}))}),define(te[97],ne([0,1,48,3,2,6,38,216]),function(K,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var b;(function(v){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=m})(b=e.ThemeColor||(e.ThemeColor={}));function C(v){return{id:v}}e.themeColorFromId=C;var P;(function(v){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||b.isThemeColor(n.color))}v.isThemeIcon=m;const w=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function y(n){const o=w.exec(n);if(!o)return;let[,s]=o;return{id:s}}v.fromString=y;function S(n){return{id:n}}v.fromId=S;function l(n,o){let s=n.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),o&&(s=`${s}~${o}`),{id:s}}v.modify=l;function r(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}v.getModifier=r;function c(n,o){return n.id===o.id&&n.color?.id===o.color?.id}v.isEqual=c;function i(n,o){return{id:n.id,color:o?C(o):void 0}}v.asThemeIcon=i,v.asClassNameArray=k.CSSIcon.asClassNameArray,v.asClassName=k.CSSIcon.asClassName,v.asCSSSelector=k.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(v){switch(v){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;A.Registry.add(e.Extensions.ThemingContribution,p);function d(v){return p.onColorThemeChange(v)}e.registerThemingParticipant=d;class h extends L.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let y=this.theme.getColor(m);return y&&w&&(y=w(y,this.theme)),y?y.toString():null}}e.Themable=h}),define(te[217],ne([0,1,48,7,97]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(E,f){const p=E.map(d=>({name:d.profileName,description:A(d)}));return f&&p.push(...f.map(d=>({name:d.title,description:R(d)}))),{values:p.map(d=>d.name),markdownDescriptions:p.map(d=>d.description)}}e.createProfileSchemaEnums=T;function A(E){let f=`$(${L.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?f+=`
- args: "${E.args}"`:f+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(f+=`
- overrideName: ${E.overrideName}`),E.color&&(f+=`
- color: ${E.color}`),E.env&&(f+=`
- env: ${JSON.stringify(E.env)}`),f}function R(E){return`$(${L.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function b(E,f){if(!E&&!f)return!0;if(typeof E=="string"&&typeof f=="string")return E===f;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function C(E,f){if(!E&&!f)return!0;if(!E||!f)return!1;if(L.ThemeIcon.isThemeIcon(E)&&L.ThemeIcon.isThemeIcon(f))return E.id===f.id&&E.color===f.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const p=E,d=f;if((t.URI.isUri(p.light)||P(p.light))&&(t.URI.isUri(p.dark)||P(p.dark))&&(t.URI.isUri(d.light)||P(d.light))&&(t.URI.isUri(d.dark)||P(d.dark)))return p.light.path===d.light.path&&p.dark.path===d.dark.path}if(t.URI.isUri(E)&&t.URI.isUri(f)||P(E)||P(f)){const p=E,d=f;return p.path===d.path&&p.scheme===d.scheme}return!1}e.terminalIconsEqual=C;function P(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=P}),define(te[218],ne([0,1,48,142,42,38,217]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),S=>S.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),S=>`$(${S.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},C={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,t.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,t.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(v),y()}e.registerTerminalPlatformConfiguration=m;let w;function y(S,l){const r=T.Registry.as(L.Extensions.Configuration);let c;S&&(c=(0,A.createProfileSchemaEnums)(S?.profiles,l));const i=w;w={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?c?.values:void 0,markdownEnumDescriptions:S?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?c?.values:void 0,markdownEnumDescriptions:S?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?c?.values:void 0,markdownEnumDescriptions:S?.os===1?c?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(te[219],ne([0,1,46,48,10,4,22,73,215,97]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,E=!0;function f(c,i,n,o,s=process.env,a,u,g,I){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?p(n,a,s,u,o.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:o.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:o.getValue("terminal.integrated.defaultProfile.windows"),I,g):S(a,u,n,c&&typeof c=="object"?{...c}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,g,s)}e.detectAvailableProfiles=f;async function p(c,i,n,o,s,a,u,g,I){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),M=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let F=!1;(0,b.getWindowsBuildNumber)()>=16299&&(F=!0),await v(g);const D=new Map;c&&(D.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Windows PowerShell",{path:`${M}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),D.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),D.set("Command Prompt",{path:`${M}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),l(a,D);const N=await d(D.entries(),u,i,n,o,I);if(c||!c&&s)try{const $=await w(`${M}\\${F?"wsl":"bash"}.exe`,u);for(const B of $)(!a||!(B.profileName in a))&&N.push(B)}catch{E&&(o?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return N}async function d(c,i,n,o=process.env,s,a){const u=[];for(const[g,I]of c){if(I===null)continue;let _,M,F;if("source"in I){const $=P?.get(I.source);if(!$)continue;_=$.paths,M=I.args||$.args,I.icon?F=h(I.icon):$.icon&&(F=$.icon)}else _=Array.isArray(I.path)?I.path:[I.path],M=T.isWindows||Array.isArray(I.args)?I.args:void 0,F=h(I.icon);const D=await a?.(_)||_.slice(),N=await r(g,i,D,n,o,M,I.env,I.overrideName,I.isAutoDetected,s);N?(N.isAutoDetected=I.isAutoDetected,N.icon=F,N.color=I.color,u.push(N)):s?.trace("profile not validated",g,_)}return u}function h(c){return typeof c=="string"?{id:c}:c}async function v(c){P&&!c||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:c||await m(),icon:C.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function m(){const c=[];for await(const i of(0,R.enumeratePowerShellInstallations)())c.push(i.exePath);return c}async function w(c,i){const n=[],o=await new Promise((u,g)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,_)=>{if(I)return g("Problem occurred when getting wsl distros");u(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),a=o.split(s).filter(u=>u.trim().length>0&&u!=="");for(const u of a){if(u===""||u.startsWith("docker-desktop"))continue;const g=`${u} (WSL)`,I={profileName:g,path:c,args:["-d",`${u}`],isDefault:g===i,icon:y(u),isAutoDetected:!1};n.push(I)}return n}function y(c){return c.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):c.includes("Debian")?C.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function S(c,i,n,o,s,a,u,g){const I=new Map;if(n){const _=(await c.readFile("/etc/shells")).toString(),M=a||_.split(`
`).filter(D=>D.trim().indexOf("#")!==0&&D.trim().length>0),F=new Map;for(const D of M){let N=(0,L.basename)(D),$=F.get(N)||0;$++,$>1&&(N=`${N} (${$})`),F.set(N,$),I.set(N,{path:D,isAutoDetected:!0})}}return l(o,I),await d(I.entries(),s,c,g,i,u)}function l(c,i){if(!!c)for(const[n,o]of Object.entries(c))o===null||!("path"in o)&&!("source"in o)?i.delete(n):(o.icon=o.icon||i.get(n)?.icon,i.set(n,o))}async function r(c,i,n,o,s,a,u,g,I,_){if(n.length===0)return Promise.resolve(void 0);const M=n.shift();if(M==="")return r(c,i,n,o,s,a,u,g,I);const F={profileName:c,path:M,args:a,env:u,overrideName:g,isAutoDetected:I,isDefault:c===i};if((0,L.basename)(M)===M){const N=s.PATH?s.PATH.split(L.delimiter):void 0,$=await(0,b.findExecutable)(M,void 0,N,void 0,o.existsFile);return $?(F.path=$,F.isFromPath=!0,F):r(c,i,n,o,s,a)}return await o.existsFile((0,L.normalize)(M))?F:r(c,i,n,o,s,a,u,g,I)}}),define(te[220],ne([0,1,3,2,19,4,36,58,18,14,78,214,8,87,212,96,218,219]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let y=0,S=class extends t.Disposable{constructor(r,c,i,n){super();this._reconnectConstants=r,this._configurationService=c,this._environmentService=i,this._logService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:y,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},c=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);c&&(c.break&&c.port?r.debugBrk=c.port:!c.break&&c.port&&(r.debug=c.port));const i=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,r);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=i.getChannel(h.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const s=A.ProxyChannel.toService(i.getChannel(h.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(a=>this._onProcessData.fire(a))),this._register(s.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(s.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(s.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(s.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(s.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(s.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[i,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,c,i,n,o,s,a,u,g,I,_){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),h.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(r,c,i,n,o,s,a,u,g,I,_);return clearTimeout(M),y=Math.max(y,F),F}updateTitle(r,c,i){return this._proxy.updateTitle(r,c,i)}updateIcon(r,c,i){return this._proxy.updateIcon(r,c,i)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r){return this._proxy.detachFromProcess(r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,c){return this._proxy.shutdown(r,c)}input(r,c){return this._proxy.input(r,c)}processBinary(r,c){return this._proxy.processBinary(r,c)}resize(r,c,i){return this._proxy.resize(r,c,i)}acknowledgeDataEvent(r,c){return this._proxy.acknowledgeDataEvent(r,c)}setUnicodeVersion(r,c){return this._proxy.setUnicodeVersion(r,c)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,c){return this._proxy.installAutoReply(r,c)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,c,i,n=!1){const o=await this._shellEnv;return(0,m.detectAvailableProfiles)(c,i,n,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,c){return this._proxy.requestDetachInstance(r,c)}async acceptDetachInstanceReply(r,c){return this._proxy.acceptDetachInstanceReply(r,c)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,c){return this._proxy.reviveTerminalProcesses(r,c)}async refreshProperty(r,c){return this._proxy.refreshProperty(r,c)}async updateProperty(r,c,i){return this._proxy.updateProperty(r,c,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,c){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:c})}async acceptPtyHostResolvedVariables(r,c){this._resolveVariablesRequestStore.acceptReply(r,c)}};S=de([G(1,b.IConfigurationService),G(2,C.IEnvironmentService),G(3,f.ILogService)],S),e.PtyHostService=S}),define(te[64],ne([0,1,3,4,6,8]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=E;function f(d,h){return h?h!==1&&d<1024:!t.isWindows&&d<1024}e.isPortPrivileged=f;let p=class{constructor(h){this.logService=h,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],v=Array.from(this._tunnels.values());for(let m of v){const w=Array.from(m.values());for(let y of w){const S=await y.value;S&&h.push(S)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:v}of h.values())await v.then(m=>m?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,v,m,w,y=!1,S=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${m} on local port ${w}.`),!h)return;v||(v="localhost");const r=this.retainOrCreateTunnel(h,v,m,w,y,S,l);return r?r.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(c);return(c.tunnelRemoteHost!==v||c.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const v=this._tunnels.get(h.tunnelRemoteHost);if(v){const m=v.get(h.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,m))}}}}async tryDisposeTunnel(h,v,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${v}.`);const w=m.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(v),w}}async closeTunnel(h,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${v} `);const m=this._tunnels.get(h);if(m&&m.has(v)){const w=m.get(v);w.refcount=0,await this.tryDisposeTunnel(h,v,w)}}addTunnelToMap(h,v,m){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(v,{refcount:1,value:m})}async removeEmptyTunnelFromMap(h,v){const m=this._tunnels.get(h);m&&(await m.get(v)||m.delete(v),m.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,v){let m=[h];P(h)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(h)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(y=>this._tunnels.get(y));for(const y of w){const S=y?.get(v);if(S)return S}}canTunnel(h){return!!C(h)}createWithProvider(h,v,m,w,y,S,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${m} on local port ${w}.`);const c={elevationRequired:y?f(w===void 0?m:w):!1},i={remoteAddress:{host:v,port:m},localAddressPort:w,privacy:S,public:S!==R.Private,protocol:l},n=h.forwardPort(i,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(v,m,n),n}};p=de([G(0,T.ILogService)],p),e.AbstractTunnelService=p}),define(te[221],ne([0,1,8,64,2,9,5]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let b=class Ct extends L.Disposable{constructor(P,E){super();this._tunnelService=P,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,E,f,p,d,h){const v=new R,m=await Promise.resolve(this._tunnelService.openTunnel(P,v,f,p,d,h));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${p} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),v.dispose(),await m.dispose(),(0,T.canceled)();return v.setTunnel(m),this._tunnels.set(E,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${f}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(P,E){const f=this._tunnels.get(P);!f||f.setAddress(E)}async destroyTunnel(P){const E=this._tunnels.get(P);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await E.dispose();return}this._disposedTunnels.add(P)}};b._lastId=0,b=de([G(0,t.ISharedTunnelsService),G(1,k.ILogService)],b),e.SharedProcessTunnelService=b}),define(te[32],ne([0,1,6]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(te[222],ne([0,1,3,2,7,14,31,15,8,32]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends t.Disposable{constructor(f,p,d,h,v){super();this.extensionsManagementService=f,this.logService=h,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=L.URI.file(d.extensionsPath);this._register(p.watch(m)),this._register(k.Event.filter(p.onDidFilesChange,w=>w.rawChanges.some(y=>this.doesChangeAffects(y,m)))(()=>this.onDidChange()))}doesChangeAffects(f,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),p)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const p of f)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(p=>!(0,A.areSameExtensions)(p,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,A.areSameExtensions)(p,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),p=f.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,A.areSameExtensions)(v,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),d=this.installedExtensions.filter(h=>this.installingExtensions.some(v=>(0,A.areSameExtensions)(v,h))?!1:f.every(v=>!(0,A.areSameExtensions)(v.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=f.map(h=>h.identifier),(p.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:d})}}};P=de([G(1,R.IFileService),G(2,T.INativeEnvironmentService),G(3,b.ILogService),G(4,C.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(te[223],ne([0,1,32,80,15,20,104,3,2]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(f){this.uri=f,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const p=new Map,d=h=>{let v=p.get(h.scheme);return v===void 0&&(v=f.hasProvider(h)&&!this._fileService.hasCapability(h,1024),p.set(h.scheme,v)),v};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(h=>{p.delete(h.scheme)})),this.extUri=new T.ExtUri(d),this._canonicalUris=new A.SkipList((h,v)=>this.extUri.compare(h,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,T.normalizePath)(f));let p=this._canonicalUris.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new C(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((d,h)=>d[1].touch<h[1].touch?1:d[1].touch>h[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let d=0;d<p;d++)this._canonicalUris.set(f[d][0],f[d][1].touch())}};P=de([G(0,L.IFileService)],P),e.UriIdentityService=P,(0,t.registerSingleton)(k.IUriIdentityService,P,!0)}),define(te[224],ne([0,1,3,2,40,39,17]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends t.Disposable{constructor(C,P,E,f){super();this.fileSystemScheme=C,this.fileSystemProvider=P,this.userDataScheme=E,this.logService=f,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(C,P){this.watchResources.set(C,C);const E=this.fileSystemProvider.watch(this.toFileSystemResource(C),P);return(0,t.toDisposable)(()=>{this.watchResources.delete(C),E.dispose()})}stat(C){return this.fileSystemProvider.stat(this.toFileSystemResource(C))}mkdir(C){return this.fileSystemProvider.mkdir(this.toFileSystemResource(C))}rename(C,P,E){return this.fileSystemProvider.rename(this.toFileSystemResource(C),this.toFileSystemResource(P),E)}readFile(C){return this.fileSystemProvider.readFile(this.toFileSystemResource(C),{atomic:!0})}readFileStream(C,P,E){const f=(0,L.newWriteableStream)(p=>A.VSBuffer.concat(p.map(d=>A.VSBuffer.wrap(d))).buffer);return(async()=>{try{const p=await this.readFile(C);f.end(p)}catch(p){f.error(p),f.end()}})(),f}readdir(C){return this.fileSystemProvider.readdir(this.toFileSystemResource(C))}writeFile(C,P,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(C),P,E)}delete(C,P){return this.fileSystemProvider.delete(this.toFileSystemResource(C),P)}handleFileChanges(C){const P=[];for(const E of C){if(E.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(E.resource);this.watchResources.findSubstr(f)&&P.push({resource:f,type:E.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(C){return C.with({scheme:this.fileSystemScheme})}toUserDataResource(C){return C.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(te[53],ne([0,1,70]),function(K,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(A,R,b,C){const P=(0,k.setProperty)(A,R,b,C)[0];return P&&(A=A.substring(0,P.offset)+P.content+A.substring(P.offset+P.length)),A}e.edit=t;function L(A,R,b){let C=b;for(;C>=0;){if(A.charAt(C)===R.charAt(R.length-1)&&R.length===1)return C+1;if(C--,R.length===2&&C>=0&&A.charAt(C)===R.charAt(0))return C+2}return 0}e.getLineStartOffset=L;function T(A,R,b){let C=b;for(;C>=0;)if(A.charAt(C)===R.charAt(R.length-1)&&R.length===1||(C++,R.length===2&&C>=0&&A.charAt(C)===R.charAt(1)))return C;return A.length-1}e.getLineEndOffset=T}),define(te[225],ne([0,1,28,62,11]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(f,p,d,h,v){const m=[],w=[],y=[];if(!p){const M=f.filter(({identifier:F})=>v.every(D=>D.toLowerCase()!==F.id.toLowerCase()));return{local:{added:m,removed:w,updated:y},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}f=f.map(P),p=p.map(P),d=d?d.map(P):null;const S=new Map,l=M=>{M.uuid&&S.set(M.id.toLowerCase(),M.uuid)};f.forEach(({identifier:M})=>l(M)),p.forEach(({identifier:M})=>l(M)),d&&d.forEach(({identifier:M})=>l(M));const r=M=>{const F=M.identifier.uuid||S.get(M.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${M.identifier.id.toLowerCase()}`},c=(M,F)=>(M.set(r(F),F),M),i=f.reduce(c,new Map),n=p.reduce(c,new Map),o=p.reduce((M,F)=>{const D=r(F);F=(0,k.deepClone)(F);const N=i.get(D);return N&&(N.installed&&(F.installed=!0),F.version||(F.version=N.version)),c(M,F)},new Map),s=d?d.reduce(c,new Map):null,a=h.reduce(c,new Map),u=v.reduce((M,F)=>{const D=S.get(F.toLowerCase());return M.add(D?`uuid:${D}`:`id:${F.toLowerCase()}`)},new Set),g=A(i,n,u);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const M=A(s,i,u),F=A(s,n,u),D=(N,$)=>{const B=i.get(N);if(B){const Z=n.get(N),W=$?Z:B;return{...W,version:Z.version&&(!B.installed||t.gt(Z.version,B.version))?Z.version:B.version,state:R(B,Z,s?.get(N)),preRelease:(0,L.isUndefined)(W.preRelease)?B.preRelease:B.installed?W.preRelease:Z.preRelease}}};for(const N of F.removed.values()){const $=i.get(N);$&&w.push($.identifier)}for(const N of F.added.values())if(M.added.has(N)){if(g.updated.has(N)){const $=D(N,!0);$&&(y.push(E($,N)),o.set(N,$))}}else{const $=n.get(N);$.installed&&m.push(E($,N))}for(const N of F.updated.values()){const $=D(N,!0);$&&(y.push(E($,N)),o.set(N,$))}for(const N of M.added.values())F.added.has(N)||o.set(N,i.get(N));for(const N of M.updated.values())if(!F.removed.has(N)&&!F.updated.has(N)){const $=D(N,!1);$&&(o.get(N)?.installed&&($.installed=!0),o.set(N,$))}for(const N of M.removed.values())!a.has(N)&&!F.updated.has(N)&&s?.get(N)?.installed&&o.delete(N)}const I=[],_=A(n,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((M,F)=>I.push(E(M,F))),{local:{added:m,removed:w,updated:y},remote:I.length?{added:[..._.added].map(M=>o.get(M)),updated:[..._.updated].map(M=>o.get(M)),removed:[..._.removed].map(M=>n.get(M)),all:I}:null}}e.merge=T;function A(f,p,d,{checkInstalledProperty:h,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=f?[...f.keys()].filter(r=>!d.has(r)):[],w=[...p.keys()].filter(r=>!d.has(r)),y=w.filter(r=>m.indexOf(r)===-1).reduce((r,c)=>(r.add(c),r),new Set),S=m.filter(r=>w.indexOf(r)===-1).reduce((r,c)=>(r.add(c),r),new Set),l=new Set;for(const r of m){if(S.has(r))continue;const c=f.get(r),i=p.get(r);(!i||c.disabled!==i.disabled||c.installed&&i.installed&&c.preRelease!==i.preRelease||!C(c.state,i.state)||v&&c.version!==i.version||h&&c.installed!==i.installed)&&l.add(r)}return{added:y,removed:S,updated:l}}function R(f,p,d){const h=f.state,v=p.state,m=d?.state;if(!p.version||h&&t.gt(f.version,p.version))return h;if(v&&t.gt(p.version,f.version)||!h)return v;if(!v)return h;const w=(0,k.deepClone)(h),y=m?b(m,v):{added:Object.keys(v).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},S=m?b(m,h):{added:Object.keys(h).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...y.added.values(),...y.updated.values()])w[l]=v[l];for(const l of y.removed.values())S.updated.has(l)||delete w[l];return w}function b(f,p){const d=Object.keys(f),h=Object.keys(p),v=h.filter(y=>d.indexOf(y)===-1).reduce((y,S)=>(y.add(S),y),new Set),m=d.filter(y=>h.indexOf(y)===-1).reduce((y,S)=>(y.add(S),y),new Set),w=new Set;for(const y of d){if(m.has(y))continue;const S=f[y],l=p[y];(0,k.equals)(S,l)||w.add(y)}return{added:v,removed:m,updated:w}}function C(f={},p={}){const{added:d,removed:h,updated:v}=b(f,p);return d.size===0&&h.size===0&&v.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function E(f,p){const d={identifier:{id:f.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(d.version=f.version),f.disabled&&(d.disabled=!0),f.installed&&(d.installed=!0),f.state&&(d.state=f.state),d}}),define(te[98],ne([0,1,16,18,6]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return C=C.filter(P=>P!==R&&P!==`-${R}`),b&&C.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(R,b){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return C=C.filter(P=>P!==R&&P!==`-${R}`),b&&C.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(R){const b=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],E=[];if(Array.isArray(C))for(const f of C)f.startsWith("-")?E.push(f.substring(1)):P.push(f);return(0,k.distinct)([...b,...P].filter(f=>E.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};T=de([G(0,t.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[226],ne([0,1,16,35,28,160,53]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(S){return(0,t.parse)(S)||[]}e.parseKeybindings=R;async function b(S,l,r,c,i){const n=R(S),o=R(l),s=r?R(r):null,a=[...n,...o,...s||[]].map(Z=>Z.key),u=await i.resolveUserBindings(a);let g=P(n,o,s,u);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const I=f(n),_=f(o),M=s?f(s):null,F=d(I,_,u),D=M?d(M,I,u):{added:[...I.keys()].reduce((Z,W)=>(Z.add(W),Z),new Set),removed:new Set,updated:new Set},N=M?d(M,_,u):{added:[..._.keys()].reduce((Z,W)=>(Z.add(W),Z),new Set),removed:new Set,updated:new Set},$=C(F,D,N);let B=S;for(const Z of $.removed.values())$.conflicts.has(Z)||(B=w(B,Z,c));for(const Z of $.added.values()){if($.conflicts.has(Z))continue;const W=_.get(Z);if(W.some(ee=>ee.command!==`-${Z}`&&g.conflicts.has(u[ee.key]))){$.conflicts.add(Z);continue}B=m(B,W,c)}for(const Z of $.updated.values()){if($.conflicts.has(Z))continue;const W=_.get(Z);if(W.some(ee=>ee.command!==`-${Z}`&&g.conflicts.has(u[ee.key]))){$.conflicts.add(Z);continue}B=y(B,Z,W,c)}return{mergeContent:B,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=b;function C(S,l,r){const c=new Set,i=new Set,n=new Set,o=new Set;for(const s of l.removed.values())r.updated.has(s)&&o.add(s);for(const s of r.removed.values())o.has(s)||(l.updated.has(s)?o.add(s):i.add(s));for(const s of l.added.values())o.has(s)||r.added.has(s)&&S.updated.has(s)&&o.add(s);for(const s of r.added.values())o.has(s)||(l.added.has(s)?S.updated.has(s)&&o.add(s):c.add(s));for(const s of l.updated.values())o.has(s)||r.updated.has(s)&&S.updated.has(s)&&o.add(s);for(const s of r.updated.values())o.has(s)||(l.updated.has(s)?S.updated.has(s)&&o.add(s):n.add(s));return{added:c,removed:i,updated:n,conflicts:o}}function P(S,l,r,c){const i=new Set,n=E(S,c),o=E(l,c),s=r?E(r,c):null,a=p(n,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const u=s?p(s,n):{added:[...n.keys()].reduce((D,N)=>(D.add(N),D),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const g=s?p(s,o):{added:[...o.keys()].reduce((D,N)=>(D.add(N),D),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:I,removed:_,updated:M,conflicts:F}=C(a,u,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:_,updated:M,conflicts:F}}function E(S,l){const r=new Map;for(const c of S){const i=l[c.key];let n=r.get(i);n||(n=[],r.set(i,n)),n.push(c)}return r}function f(S){const l=new Map;for(const r of S){const c=r.command[0]==="-"?r.command.substring(1):r.command;let i=l.get(c);i||(i=[],l.set(c,i)),i.push(r)}return l}function p(S,l){const r=[...S.keys()],c=[...l.keys()],i=c.filter(s=>r.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),n=r.filter(s=>c.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),o=new Set;for(const s of r){if(n.has(s))continue;const a=S.get(s).map(g=>({...g,key:s})),u=l.get(s).map(g=>({...g,key:s}));(0,k.equals)(a,u,(g,I)=>v(g,I))||o.add(s)}return{added:i,removed:n,updated:o}}function d(S,l,r){const c=[...S.keys()],i=[...l.keys()],n=i.filter(a=>c.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),o=c.filter(a=>i.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),s=new Set;for(const a of c){if(o.has(a))continue;const u=S.get(a).map(I=>({...I,key:r[I.key]})),g=l.get(a).map(I=>({...I,key:r[I.key]}));h(u,g)||s.add(a)}return{added:n,removed:o,updated:s}}function h(S,l){return!(!(0,k.equals)(S.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,c)=>v(r,c))||!(0,k.equals)(S.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,c)=>v(r,c)))}function v(S,l){if(S.command!==l.command||S.key!==l.key)return!1;const r=T.ContextKeyExpr.deserialize(S.when),c=T.ContextKeyExpr.deserialize(l.when);return!(r&&!c||!r&&c||r&&c&&!r.equals(c)||!L.equals(S.args,l.args))}function m(S,l,r){for(const c of l)S=A.edit(S,[-1],c,r);return S}function w(S,l,r){const c=R(S);for(let i=c.length-1;i>=0;i--)(c[i].command===l||c[i].command===`-${l}`)&&(S=A.edit(S,[i],void 0,r));return S}function y(S,l,r,c){const i=R(S),n=i.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=i.length-1;o>=0;o--)(i[o].command===l||i[o].command===`-${l}`)&&(S=A.edit(S,[o],void 0,c));for(let o=r.length-1;o>=0;o--)S=A.edit(S,[n],r[o],c);return S}}),define(te[227],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(T,A,R){const b={},C={},P=new Set;if(!A)return{local:{added:b,updated:C,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const E=t(T,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:b,updated:C,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=t(R,T),p=t(R,A),d={},h={},v=new Set,m=new Set;for(const w of f.removed.values())p.updated.has(w)?b[w]=A[w]:v.add(w);for(const w of p.removed.values())m.has(w)||(f.updated.has(w)?m.add(w):P.add(w));for(const w of f.updated.values())m.has(w)||(p.updated.has(w)?E.updated.has(w)&&m.add(w):h[w]=T[w]);for(const w of p.updated.values())m.has(w)||(f.updated.has(w)?E.updated.has(w)&&m.add(w):T[w]!==void 0&&(C[w]=A[w]));for(const w of f.added.values())m.has(w)||(p.added.has(w)?E.updated.has(w)&&m.add(w):d[w]=T[w]);for(const w of p.added.values())m.has(w)||(f.added.has(w)?E.updated.has(w)&&m.add(w):b[w]=A[w]);return{local:{added:b,removed:[...P.values()],updated:C},remote:{added:d,removed:[...v.values()],updated:h},conflicts:[...m.values()]}}e.merge=k;function t(T,A){const R=T?Object.keys(T):[],b=A?Object.keys(A):[],C=b.filter(f=>R.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),P=R.filter(f=>b.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),E=new Set;for(const f of R){if(P.has(f))continue;const p=T[f],d=A[f];p!==d&&E.add(f)}return{added:C,removed:P,updated:E}}function L(T,A){const{added:R,removed:b,updated:C}=t(T,A);return R.size===0&&b.size===0&&C.size===0}e.areSame=L}),define(te[24],ne([0,1,16,20,11,148,42,30,6,89,38]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function f(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(I=>!!s[I].ignoreSync),u=Object.keys(s).filter(I=>s[I].scope===2||s[I].scope===6),g=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...u,...g])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const s="vscode://schemas/ignoredSettings",a=P.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=P.Registry.as(C.Extensions.JSONContribution),g=()=>{const I=E(),_=f().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),M=Object.keys(A.allSettings.properties).filter(N=>_.indexOf(N)===-1),F=_.filter(N=>I.indexOf(N)===-1),D={items:{type:"string",enum:[...M,...F.map(N=>`-${N}`)]}};u.registerSchema(s,D)};return a.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=p;function d(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=d;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function v(s,a,u){return u.joinPath(a.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=m;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(a,u,g,I){super(a);this.code=u,this.resource=g,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class S extends y{constructor(a,u,g,I,_){super(a,g,void 0,_);this.url=u,this.serverCode=I}}e.UserDataSyncStoreError=S;class l extends y{constructor(a,u){super(a,u)}}e.UserDataAutoSyncError=l,function(s){function a(u){if(u instanceof s)return u;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(g&&g[1]){const I=g[2]==="unknown"?void 0:g[2],_=g[3]==="unknown"?void 0:g[3];return new s(u.message,g[1],I,_)}return new s(u.message,"Unknown")}s.toUserDataSyncError=a}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var c;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,a){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,t.isEqualOrParent)(s,(0,t.joinPath)(a.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[45],ne([0,1,16,5,17,25,3,35,2,26,11,7,144,18,14,15,8,47,23,21,32,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=r;let c=class extends b.Disposable{constructor(a,u,g,I,_,M,F,D,N,$,B){super();this.resource=a,this.fileService=u,this.environmentService=g,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=M,this.userDataSyncEnablementService=F,this.telemetryService=D,this.logService=N,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=B.extUri,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(a,g,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(g,u,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?await this.hasRemoteChanged(a):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const u=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,u={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),u)}async preview(a,u,g={}){return this._sync(a,!1,u,g)}async apply(a,u={}){try{this.syncHeaders={...u};const g=await this.doApply(a);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,u,g,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const M=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(a,M);return _=await this.performSync(F,M,u,g),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(a){const u=await this.resolveContent(a);if(!u)return!1;const g=this.parseSyncData(u);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,I),M=await this.isRemoteDataFromCurrentMachine(_),F=await this.generateSyncPreview({ref:_.ref,syncData:g},I,M,this.getUserDataSyncConfiguration(),T.CancellationToken.None),D=[];for(const N of F){const $=await this.getAcceptResult(N,N.remoteResource,void 0,T.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(N,N.previewResource,N.remoteContent,T.CancellationToken.None);D.push([N,{...$,remoteChange:B!==0?B:2}])}await this.applyResult(_,I,D,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const u=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===u}async getLatestRemoteUserData(a,u){if(u){const g=a&&a.latest?a.latest[this.resource]:void 0;if(u.ref===g||g===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(a,u,g,I){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,u,g,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,u,g,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(a,u,g,I)}throw _}}async doSync(a,u,g,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(M=>this.doGenerateSyncResourcePreview(a,u,g,I,M)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:M})=>M==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(a){return await this.updateSyncResourcePreview(a,async u=>{const g=await this.getMergeResult(u,T.CancellationToken.None);await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(g?.content||""));const I=g&&!g.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,T.CancellationToken.None):void 0;return u.acceptResult=I,u.mergeState=g.hasConflicts?"conflict":I?"accepted":"preview",u.localChange=I?I.localChange:g.localChange,u.remoteChange=I?I.remoteChange:g.remoteChange,u}),this.syncPreviewPromise}async accept(a,u){return await this.updateSyncResourcePreview(a,async g=>{const I=await this.getAcceptResult(g,a,u,T.CancellationToken.None);return g.acceptResult=I,g.mergeState="accepted",g.localChange=I.localChange,g.remoteChange=I.remoteChange,g}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async u=>{const g=await this.getMergeResult(u,T.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(g.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=g.localChange,u.remoteChange=g.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(a,u){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const I=g.resourcePreviews.findIndex(({localResource:_,remoteResource:M,previewResource:F})=>this.extUri.isEqual(_,a)||this.extUri.isEqual(M,a)||this.extUri.isEqual(F,a));I!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const M=[...g.resourcePreviews];return M[I]=await u(M[I]),{...g,resourcePreviews:M}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(g=>[g,g.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(a){const u=a.filter(({mergeState:g})=>g==="conflict");(0,k.equals)(this._conflicts,u,(g,I)=>this.extUri.isEqual(g.previewResource,I.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(a){return E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(a){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);return g}return this.extUri.isEqual(a,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(a){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const g of u.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,a))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,a))return g.remoteContent;if(this.extUri.isEqual(g.localResource,a))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(a,u,g,I,_){const M=await this.isRemoteDataFromCurrentMachine(a),F=await this.generateSyncPreview(a,u,M,I,_),D=[];for(const N of F){const $=N.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(N.localChange===0&&N.remoteChange===0)D.push({...N,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const B=g?await this.getMergeResult(N,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(N.previewResource,L.VSBuffer.fromString(B?.content||""));const Z=B&&!B.hasConflicts?await this.getAcceptResult(N,N.previewResource,void 0,_):void 0;D.push({...N,acceptResult:Z,mergeState:B?.hasConflicts?"conflict":Z?"accepted":"preview",localChange:Z?Z.localChange:B?B.localChange:N.localChange,remoteChange:Z?Z.remoteChange:B?B.remoteChange:N.remoteChange})}}return{remoteUserData:a,lastSyncUserData:u,resourcePreviews:D,isLastSyncFromCurrentMachine:M}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(a.value.toString()),g=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&g&&u.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const I=u;if(I.content===null)return{ref:u.ref,syncData:null};const _=JSON.parse(I.content);if(r(_))return{...u,syncData:_,content:void 0}}catch(a){a instanceof h.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:g,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(a){const{ref:u,content:g}=await this.getUserData(a);let I=null;return g!==null&&(I=this.parseSyncData(g)),{ref:u,syncData:I}}parseSyncData(a){try{const u=JSON.parse(a);if(r(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,P.isString)(a)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:u}}else{const u=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(a,u){const g=await this.currentMachineIdPromise,I={version:this.version,machineId:g,content:a};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),u,this.syncHeaders),{ref:u,syncData:I}}async backupLocal(a){const u={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};c=de([G(1,h.IFileService),G(2,d.IEnvironmentService),G(3,w.IStorageService),G(4,l.IUserDataSyncStoreService),G(5,l.IUserDataSyncBackupStoreService),G(6,l.IUserDataSyncEnablementService),G(7,y.ITelemetryService),G(8,l.IUserDataSyncLogService),G(9,p.IConfigurationService),G(10,S.IUriIdentityService)],c),e.AbstractSynchroniser=c;let i=class extends c{constructor(a,u,g,I,_,M,F,D,N,$,B,Z){super(u,g,I,_,M,F,D,N,$,B,Z);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(W=>this.onFileChanges(W)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(a,u,g){try{u?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(a),g?void 0:u):await this.fileService.createFile(this.file,L.VSBuffer.fromString(a),{overwrite:g})}catch(I){throw I instanceof h.FileOperationError&&I.fileOperationResult===1||I instanceof h.FileOperationError&&I.fileOperationResult===3?new l.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};i=de([G(2,h.IFileService),G(3,d.IEnvironmentService),G(4,w.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncEnablementService),G(8,y.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,p.IConfigurationService),G(11,S.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let n=class extends i{constructor(a,u,g,I,_,M,F,D,N,$,B,Z,W){super(a,u,g,I,_,M,F,D,N,$,Z,W);this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(a){const u=[];return(0,R.parse)(a,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=de([G(2,h.IFileService),G(3,d.IEnvironmentService),G(4,w.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncEnablementService),G(8,y.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,l.IUserDataSyncUtilService),G(11,p.IConfigurationService),G(12,S.IUriIdentityService)],n),e.AbstractJsonFileSynchroniser=n;let o=class{constructor(a,u,g,I,_){this.resource=a,this.environmentService=u,this.logService=g,this.fileService=I,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:a,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(u);if(!!g)try{await this.doInitialize({ref:a,syncData:g})}catch(I){this.logService.error(I)}}parseSyncData(a){try{const u=JSON.parse(a);if(r(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,u={}){const g={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(g)))}};o=de([G(1,d.IEnvironmentService),G(2,v.ILogService),G(3,h.IFileService),G(4,S.IUriIdentityService)],o),e.AbstractInitializer=o}),define(te[228],ne([0,1,5,25,9,3,49,26,7,18,14,30,31,63,15,8,23,21,32,45,225,98,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function c(o,s){const a=JSON.parse(o.content);if(o.version===1||o.version===2){const u=(await s.getInstalled(0)).filter(g=>g.isBuiltin);for(const g of a)o.version===1&&(g.enabled===!1&&(g.disabled=!0),delete g.enabled),o.version===2&&u.every(I=>!(0,f.areSameExtensions)(I.identifier,g.identifier))&&(g.installed=!0)}return a}let i=class mt extends y.AbstractSynchroniser{constructor(s,a,u,g,I,_,M,F,D,N,$,B,Z,W,ee){super("extensions",a,s,u,g,I,B,Z,D,$,ee);this.extensionManagementService=_,this.extensionEnablementService=M,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=N,this.extensionStorageService=W,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:j})=>!!j)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,a){const u=s.syncData?await c(s.syncData,this.extensionManagementService):null,g=a?.skippedExtensions||[],I=a?.syncData?await c(a.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),M=this.getLocalExtensions(_),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);u?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:D,remote:N}=(0,S.merge)(M,u,I,g,F),$={local:D,remote:N,content:this.getPreviewContent(M,D.added,D.updated,D.removed),localChange:D.added.length>0||D.removed.length>0||D.updated.length>0?2:0,remoteChange:N!==null?2:0};return[{skippedExtensions:g,localResource:this.localResource,localContent:this.stringify(M,!1),localExtensions:M,remoteResource:this.remoteResource,remoteContent:u?this.stringify(u,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const a=s.syncData?await c(s.syncData,this.extensionManagementService):null,u=await this.extensionManagementService.getInstalled(void 0,!0),g=this.getLocalExtensions(u),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),{remote:_}=(0,S.merge)(g,a,a,s.skippedExtensions||[],I);return _!==null}getPreviewContent(s,a,u,g){const I=[...a,...u],_=new Set,M=F=>{_.add(F.id.toLowerCase()),F.uuid&&_.add(F.uuid)};I.forEach(({identifier:F})=>M(F)),g.forEach(M);for(const F of s)_.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&_.has(F.identifier.uuid)||I.push(F);return this.stringify(I,!1)}async getMergeResult(s,a){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,a,u,g){if(this.extUri.isEqual(a,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(a,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(a,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${a.toString()}`)}async acceptLocal(s){const a=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),g=(0,S.merge)(s.localExtensions,null,null,s.skippedExtensions,u),{local:I,remote:_}=g;return{content:s.localContent,local:I,remote:_,localChange:I.added.length>0||I.removed.length>0||I.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const a=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),g=s.remoteContent?JSON.parse(s.remoteContent):null;if(g!==null){const I=(0,S.merge)(s.localExtensions,g,s.localExtensions,[],u),{local:_,remote:M}=I;return{content:s.remoteContent,local:_,remote:M,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,a,u,g){let{skippedExtensions:I,localExtensions:_}=u[0][0],{local:M,remote:F,localChange:D,remoteChange:N}=u[0][1];if(D===0&&N===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),D!==0&&(await this.backupLocal(JSON.stringify(_)),I=await this.updateLocalExtensions(M.added,M.removed,M.updated,I)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const $=JSON.stringify(F.all);s=await this.updateRemoteUserData($,g?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(B=>B.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(B=>B.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(B=>B.identifier.id))}.`:""}`)}a?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:I}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${I.length?` Skipped: ${JSON.stringify(I.map($=>$.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,mt.EXTENSIONS_DATA_URI)){const u=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),I=this.getLocalExtensions(u).filter(_=>!g.some(M=>(0,f.areSameExtensions)({id:M},_.identifier)));return this.stringify(I,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const u=await this.resolvePreviewContent(s);return u&&this.stringify(JSON.parse(u),!0)}let a=await super.resolveContent(s);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(s)),a){const u=this.parseSyncData(a);if(u)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(u),!0)}}return null}stringify(s,a){return s.sort((u,g)=>!u.identifier.uuid&&g.identifier.uuid?-1:u.identifier.uuid&&!g.identifier.uuid?1:(0,R.compare)(u.identifier.id,g.identifier.id)),a?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(u=>u.installed||u.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,a,u,g){const I=[],_=[],M=await this.extensionManagementService.getInstalled();if(a.length){const D=M.filter(({identifier:N,isBuiltin:$})=>!$&&a.some(B=>(0,f.areSameExtensions)(N,B)));await k.Promises.settled(D.map(async N=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,N.identifier.id),await this.extensionManagementService.uninstall(N,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,N.identifier.id),I.push(N.identifier)}))}(s.length||u.length)&&await k.Promises.settled([...s,...u].map(async D=>{const N=M.find(B=>(0,f.areSameExtensions)(B.identifier,D.identifier));if(N&&N.isBuiltin){D.state&&N.manifest.version===D.version&&this.updateExtensionState(D.state,N,N.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(Z=>(0,f.areSameExtensions)(Z,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id),await this.extensionEnablementService.disableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id),await this.extensionEnablementService.enableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id))),I.push(D.identifier);return}const $=(await this.extensionGalleryService.getExtensions([{...D.identifier,preRelease:D.preRelease}],t.CancellationToken.None))[0];if(D.state&&(N?N.manifest.version===D.version:!!$)&&this.updateExtensionState(D.state,N||$,N?.manifest.version),$)try{this.extensionEnablementService.getDisabledExtensions().some(Z=>(0,f.areSameExtensions)(Z,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id,$.version),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id,$.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id,$.version),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id,$.version))),(!N||N.preRelease!==D.preRelease)&&(await this.extensionManagementService.canInstall($)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,D.identifier.id,$.version),await this.extensionManagementService.installFromGallery($,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:D.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,D.identifier.id,$.version),I.push($.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),_.push(D)))}catch(B){_.push(D),B instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(B.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,$.displayName||$.identifier.id):(this.logService.error(B),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,$.displayName||$.identifier.id))}else _.push(D),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}));const F=[];for(const D of g)I.some(N=>(0,f.areSameExtensions)(N,D.identifier))||F.push(D);for(const D of _)F.some(N=>(0,f.areSameExtensions)(N.identifier,D.identifier))||F.push(D);return F}updateExtensionState(s,a,u){const g=this.extensionStorageService.getExtensionState(a,!0)||{},I=u?this.extensionStorageService.getKeysForSync({id:a.identifier.id,version:u}):void 0;I?I.forEach(_=>{g[_]=s[_]}):Object.keys(s).forEach(_=>g[_]=s[_]),this.extensionStorageService.setExtensionState(a,g,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const a=this.extensionEnablementService.getDisabledExtensions();return s.map(u=>{const{identifier:g,isBuiltin:I,manifest:_,preRelease:M}=u,F={identifier:g,preRelease:M,version:_.version};a.some(D=>(0,f.areSameExtensions)(D,g))&&(F.disabled=!0),I||(F.installed=!0);try{const D=this.extensionStorageService.getKeysForSync({id:g.id,version:_.version});if(D){const N=this.extensionStorageService.getExtensionState(u,!0)||{};F.state=Object.keys(N).reduce(($,B)=>(D.includes(B)&&($[B]=N[B]),$),{})}}catch(D){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(D))}return F})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([G(0,P.IEnvironmentService),G(1,d.IFileService),G(2,v.IStorageService),G(3,r.IUserDataSyncStoreService),G(4,r.IUserDataSyncBackupStoreService),G(5,E.IExtensionManagementService),G(6,E.IGlobalExtensionEnablementService),G(7,l.IIgnoredExtensionsManagementService),G(8,r.IUserDataSyncLogService),G(9,E.IExtensionGalleryService),G(10,C.IConfigurationService),G(11,r.IUserDataSyncEnablementService),G(12,m.ITelemetryService),G(13,p.IExtensionStorageService),G(14,w.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let n=class extends y.AbstractInitializer{constructor(s,a,u,g,I,_){super("extensions",g,I,u,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=a}async parseExtensions(s){return s.syncData?await c(s.syncData,this.extensionManagementService):null}generatePreview(s,a){const u=[],g=[],I=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const M=a.find(F=>(0,f.areSameExtensions)(F.identifier,_.identifier));M?(u.push(M),_.disabled&&I.push(_.identifier)):_.installed&&(g.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&I.push(_.identifier))}return{installedExtensions:u,newExtensions:g,disabledExtensions:I,remoteExtensions:s}}};n=de([G(0,E.IExtensionManagementService),G(1,l.IIgnoredExtensionsManagementService),G(2,d.IFileService),G(3,P.IEnvironmentService),G(4,h.ILogService),G(5,w.IUriIdentityService)],n),e.AbstractExtensionsInitializer=n}),define(te[229],ne([0,1,28,24]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,b,C,P,E){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=T(R,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=C?T(C,b):{added:Object.keys(b).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},d=C?T(C,R):{added:Object.keys(R).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},v=k.deepClone(b),m=!C;for(const w of d.added.values())w!==t.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(w)||(v[w]=R[w]);for(const w of d.updated.values())v[w]=R[w];for(const w of d.removed.values())P.unregistered.includes(w)||delete v[w];for(const w of p.added.values()){const y=b[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(C&&d.added.has(w))continue;const S=R[w];S&&S.value===y.value||w===t.SYNC_SERVICE_URL_TYPE&&m&&d.added.has(w)||(S?h.updated[w]=y:h.added[w]=y)}for(const w of p.updated.values()){const y=b[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(w)||d.removed.has(w))continue;const S=R[w];S&&S.value===y.value||(h.updated[w]=y)}for(const w of p.removed.values()){if(P.machine.includes(w)){E.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}d.updated.has(w)||d.removed.has(w)||h.removed.push(w)}return{local:h,remote:A(v,b)?null:v}}e.merge=L;function T(R,b){const C=Object.keys(R),P=Object.keys(b),E=P.filter(d=>C.indexOf(d)===-1).reduce((d,h)=>(d.add(h),d),new Set),f=C.filter(d=>P.indexOf(d)===-1).reduce((d,h)=>(d.add(h),d),new Set),p=new Set;for(const d of C){if(f.has(d))continue;const h=R[d],v=b[d];k.equals(h,v)||p.add(d)}return{added:E,removed:f,updated:p}}function A(R,b){const{added:C,removed:P,updated:E}=T(R,b);return C.size===0&&P.size===0&&E.size===0}}),define(te[230],ne([0,1,17,9,3,35,49,4,7,29,18,14,15,8,47,23,21,32,45,53,229,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",c=["locale"];function i(u,g){const I=u.storage?Object.keys(u.storage).sort():[],_={};return I.forEach(M=>_[M]=u.storage[M]),u.storage=_,g?(0,A.toFormattedString)(u,{}):JSON.stringify(u)}const n=1;let o=class vt extends w.AbstractSynchroniser{constructor(g,I,_,M,F,D,N,$,B,Z){super("globalState",g,F,B,I,_,D,N,M,$,Z);this.storageService=B,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(g.onDidFilesChange,W=>W.contains(this.environmentService.argvResource)),L.Event.filter(B.onDidChangeValue,W=>W.scope===0&&W.target!==void 0?W.target===0:B.keys(0,0).includes(W.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,I,_){const M=g.syncData?JSON.parse(g.syncData.content):null;I=I===null&&_?g:I;const F=I&&I.syncData?JSON.parse(I.syncData.content):null,D=await this.getLocalGlobalState();M?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const N=this.getStorageKeys(F),{local:$,remote:B}=(0,S.merge)(D.storage,M?M.storage:null,F?F.storage:null,N,this.logService),Z={content:null,local:$,remote:B,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:B!==null?2:0};return[{localResource:this.localResource,localContent:i(D,!1),localUserData:D,remoteResource:this.remoteResource,remoteContent:M?i(M,!1):null,previewResource:this.previewResource,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:N}]}async hasRemoteChanged(g){const I=g.syncData?JSON.parse(g.syncData.content):null;if(I===null)return!0;const _=await this.getLocalGlobalState(),M=this.getStorageKeys(I),{remote:F}=(0,S.merge)(_.storage,I.storage,I.storage,M,this.logService);return F!==null}async getMergeResult(g,I){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,I,_,M){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(I,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const I=JSON.parse(g.remoteContent),{local:_,remote:M}=(0,S.merge)(g.localUserData.storage,I.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:_,remote:M,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,I,_,M){let{localUserData:F}=_[0][0],{local:D,remote:N,localChange:$,remoteChange:B}=_[0][1];if($===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(D),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const Z=JSON.stringify({storage:N});g=await this.updateRemoteUserData(Z,M?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g)){const _=await this.resolvePreviewContent(g);return _&&i(JSON.parse(_),!0)}let I=await super.resolveContent(g);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(g)),I){const _=this.parseSyncData(I);if(_)switch(this.extUri.basename(g)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const g={},I=await this.getLocalArgvContent(),_=(0,T.parse)(I);for(const M of c)_[M]!==void 0&&(g[`${r}${M}`]={version:1,value:_[M]});for(const M of this.storageService.keys(0,0)){const F=this.storageService.get(M,0);F&&(g[M]={version:1,value:F})}return{storage:g}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const g=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),g.value.toString()}catch(g){this.logService.debug((0,t.getErrorMessage)(g))}return"{}"}async writeLocalGlobalState({added:g,removed:I,updated:_}){const M={},F={},D=($,B)=>{for(const Z of $){if(Z.startsWith(r)){M[Z.substring(r.length)]=B?B[Z].value:void 0;continue}if(B){const W=B[Z];W.value!==String(this.storageService.get(Z,0))&&(F[Z]=W.value)}else this.storageService.get(Z,0)!==void 0&&(F[Z]=void 0)}};if(D(Object.keys(g),g),D(Object.keys(_),_),D(I),Object.keys(M).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(M),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(F))this.storageService.store($,F[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(g){const I=await this.getLocalArgvContent();let _=I;for(const M of Object.keys(g))_=(0,y.edit)(_,[M],g[M],{});I!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const I=this.storageService.keys(0,0),_=this.storageService.keys(0,1),M=[...I,..._],F=g?.storage?Object.keys(g.storage).filter(D=>!D.startsWith(r)&&!M.includes(D)&&this.storageService.get(D,0)!==void 0):[];if(!R.isWeb){const D=[...l.ALL_SYNC_RESOURCES.map(N=>(0,l.getEnablementKey)(N)),l.SYNC_SERVICE_URL_TYPE];F.push(...D),_.push(...D)}return{user:I,machine:_,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([G(0,f.IFileService),G(1,l.IUserDataSyncStoreService),G(2,l.IUserDataSyncBackupStoreService),G(3,l.IUserDataSyncLogService),G(4,E.IEnvironmentService),G(5,l.IUserDataSyncEnablementService),G(6,v.ITelemetryService),G(7,P.IConfigurationService),G(8,h.IStorageService),G(9,m.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(g,I,_,M,F){super("globalState",_,M,I,F);this.storageService=g}async doInitialize(g){const I=g.syncData?JSON.parse(g.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},M={};for(const F of Object.keys(I.storage))F.startsWith(r)?_[F.substring(r.length)]=I.storage[F].value:this.storageService.get(F,0)===void 0&&(M[F]=I.storage[F].value);if(Object.keys(_).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const D of Object.keys(_))F=(0,y.edit)(F,[D],_[D],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(F))}if(Object.keys(M).length)for(const F of Object.keys(M))this.storageService.store(F,M[F],0,0)}};s=de([G(0,h.IStorageService),G(1,f.IFileService),G(2,E.IEnvironmentService),G(3,l.IUserDataSyncLogService),G(4,m.IUriIdentityService)],s),e.GlobalStateInitializer=s;let a=class{constructor(g,I,_,M,F){this.userDataSyncStoreClient=g,this.storageService=I,this.environmentService=_,this.fileService=M,this.logService=F}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const I=(0,l.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(g,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,I)}throw _}}async doSync(g,I){const _=await this.userDataSyncStoreClient.read("globalState",null,I),M=this.parseGlobalState(_)||{storage:{}};M.storage[l.SYNC_SERVICE_URL_TYPE]={value:g,version:n};const F=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),D={version:n,machineId:F,content:i(M,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(D),_.ref,I)}parseGlobalState({content:g}){if(!g)return null;const I=JSON.parse(g);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};a=de([G(1,h.IStorageService),G(2,E.IEnvironmentService),G(3,f.IFileService),G(4,p.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(te[231],ne([0,1,16,17,3,35,4,11,145,18,14,15,23,21,32,45,226,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,c){try{const i=JSON.parse(l);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return c.error(i),null}}e.getKeybindingsContentFromSyncContent=w;let y=class extends h.AbstractJsonFileSynchroniser{constructor(r,c,i,n,o,s,a,u,g,I,_){super(a.keybindingsResource,"keybindings",s,a,u,r,c,o,I,i,g,n,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(n.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,c,i,n){const o=r.syncData?w(r.syncData.content,n.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;c=c===null&&i?r:c;const s=c?this.getKeybindingsContentFromLastSyncUserData(c):null,a=await this.getLocalFileContent(),u=await this.getFormattingOptions();let g=null,I=!1,_=!1,M=!1;if(o){let D=a?a.value.toString():"[]";if(D=D||"[]",this.hasErrors(D))throw new m.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==D||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const N=await(0,v.merge)(D,o,s,u,this.userDataSyncUtilService);N.hasChanges&&(g=N.mergeContent,M=N.hasConflicts,I=M||N.mergeContent!==D,_=M||N.mergeContent!==o)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=a.value.toString(),_=!0);const F={content:g,localChange:I?a?2:1:0,remoteChange:_?2:0,hasConflicts:M};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const c=this.getKeybindingsContentFromLastSyncUserData(r);if(c===null)return!0;const i=await this.getLocalFileContent(),n=i?i.value.toString():"",o=await this.getFormattingOptions(),s=await(0,v.merge)(n||"[]",c,c,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==c}async getMergeResult(r,c){return r.previewResult}async getAcceptResult(r,c,i,n){if(this.extUri.isEqual(c,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(r,c,i,n){const{fileContent:o}=i[0][0];let{content:s,localChange:a,remoteChange:u}=i[0][1];if(a===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new m.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(s||"[]",r.syncData?.content);r=await this.updateRemoteUserData(g,n?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const c=(0,T.parse)(r.value.toString());if((0,k.isNonEmptyArray)(c))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:c}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let c=await super.resolveContent(r);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(r)),c){const i=this.parseSyncData(c);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return w(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,c){let i={};try{i=JSON.parse(c||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,A.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=de([G(0,m.IUserDataSyncStoreService),G(1,m.IUserDataSyncBackupStoreService),G(2,m.IUserDataSyncLogService),G(3,C.IConfigurationService),G(4,m.IUserDataSyncEnablementService),G(5,E.IFileService),G(6,P.IEnvironmentService),G(7,f.IStorageService),G(8,m.IUserDataSyncUtilService),G(9,p.ITelemetryService),G(10,d.IUriIdentityService)],y),e.KeybindingsSynchroniser=y;let S=class extends h.AbstractInitializer{constructor(r,c,i,n){super("keybindings",c,i,r,n)}async doInitialize(r){const c=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!c){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,t.VSBuffer.fromString(c)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),c=(0,T.parse)(r.value.toString());return!(0,k.isNonEmptyArray)(c)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(c){return this.logService.error(c),null}}};S=de([G(0,E.IFileService),G(1,P.IEnvironmentService),G(2,m.IUserDataSyncLogService),G(3,d.IUriIdentityService)],S),e.KeybindingsInitializer=S}),define(te[232],ne([0,1,16,35,70,49,28,53,24]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(s,a,u){let g=[];u?g=E(u):g=P(a);const I=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(g))for(const M of g)M.startsWith("-")?_.push(M.substring(1)):I.push(M);return(0,k.distinct)([...s,...I].filter(M=>_.indexOf(M)===-1))}e.getIgnoredSettings=C;function P(s){let a=s.inspect("settingsSync.ignoredSettings").userValue;return a!==void 0||(a=s.inspect("sync.ignoredSettings").userValue,a!==void 0)?a:s.getValue("settingsSync.ignoredSettings")||[]}function E(s){const a=(0,t.parse)(s);return a?a["settingsSync.ignoredSettings"]||a["sync.ignoredSettings"]||[]:[]}function f(s,a,u,g){if(u.length){const I=o(a),_=(0,t.parse)(a),M=(0,t.parse)(s),F=[];for(const D of u){const N=_[D],$=M[D];N===void 0?s=R.edit(s,[D],void 0,g):$!==void 0?s=R.edit(s,[D],N,g):F.push(l(D,I))}F.sort((D,N)=>D.startOffset-N.startOffset),F.forEach(D=>s=m(D.setting.key,a,s,g))}return s}e.updateIgnoredSettings=f;function p(s,a,u,g,I,_){const M=f(s,a,g,_),F=u!==M,D=u!==a;if(!F&&!D)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!D)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(D&&!F)return{conflictsSettings:[],localContent:f(a,s,g,_),remoteContent:null,hasConflicts:!1};if(u===null&&h(s)){const z=d(s,a,g)?null:f(a,s,g,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let N=s,$=a;const B=(0,t.parse)(s),Z=(0,t.parse)(a),W=u?(0,t.parse)(u):null,ee=g.reduce((z,H)=>(z.add(H),z),new Set),x=v(B,Z,ee),j=v(W,B,ee),Y=v(W,Z,ee),V=new Map,J=new Set,Q=z=>{J.add(z);const H=I.filter(({key:ie})=>ie===z)[0];H?(N=R.edit(N,[z],H.value,_),$=R.edit($,[z],H.value,_)):V.set(z,{key:z,localValue:B[z],remoteValue:Z[z]})};for(const z of j.removed.values())Y.updated.has(z)?Q(z):$=R.edit($,[z],void 0,_);for(const z of Y.removed.values())J.has(z)||(j.updated.has(z)?Q(z):N=R.edit(N,[z],void 0,_));for(const z of j.updated.values())J.has(z)||(Y.updated.has(z)?x.updated.has(z)&&Q(z):$=R.edit($,[z],B[z],_));for(const z of Y.updated.values())J.has(z)||(j.updated.has(z)?x.updated.has(z)&&Q(z):N=R.edit(N,[z],Z[z],_));for(const z of j.added.values())J.has(z)||(Y.added.has(z)?x.updated.has(z)&&Q(z):$=m(z,N,$,_));for(const z of Y.added.values())J.has(z)||(j.added.has(z)?x.updated.has(z)&&Q(z):N=m(z,$,N,_));const q=V.size>0||!d(N,$,g),O=q||!d(N,s,[]),U=q||!d($,a,[]);return{localContent:O?N:null,remoteContent:U?$:null,conflictsSettings:[...V.values()],hasConflicts:q}}e.merge=p;function d(s,a,u){if(s===a)return!0;const g=(0,t.parse)(s),I=(0,t.parse)(a),_=u.reduce((D,N)=>(D.add(N),D),new Set),M=o(s).filter(D=>!(D.setting&&_.has(D.setting.key))),F=o(a).filter(D=>!(D.setting&&_.has(D.setting.key)));if(M.length!==F.length)return!1;for(let D=0;D<M.length;D++){const N=M[D],$=F[D];if(N.setting&&$.setting){if(N.setting.key!==$.setting.key||!A.equals(g[N.setting.key],I[N.setting.key]))return!1}else if(!N.setting&&!$.setting){if(N.value!==$.value)return!1}else return!1}return!0}e.areSame=d;function h(s){return s?o(s).length===0:!0}e.isEmpty=h;function v(s,a,u){const g=s?Object.keys(s).filter(D=>!u.has(D)):[],I=Object.keys(a).filter(D=>!u.has(D)),_=I.filter(D=>g.indexOf(D)===-1).reduce((D,N)=>(D.add(N),D),new Set),M=g.filter(D=>I.indexOf(D)===-1).reduce((D,N)=>(D.add(N),D),new Set),F=new Set;if(s)for(const D of g){if(M.has(D))continue;const N=s[D],$=a[D];A.equals(N,$)||F.add(D)}return{added:_,removed:M,updated:F}}function m(s,a,u,g){const I=(0,t.parse)(a),_=o(a),M=o(u),F=w(s,_,M);return y(u,s,I[s],F,M,g)}e.addSetting=m;function w(s,a,u){const g=a.findIndex(_=>_.setting?.key===s),I=a[g-1];if(I){if(I.setting){const M=l(I.setting.key,u);if(M)return{index:u.indexOf(M),insertAfter:!0}}else{const M=r(g,a);if(M){const F=l(M.setting.key,u);if(F){const D=c(u.indexOf(F),u),N=i(a,M,a[g]);if(D){const $=i(u,F,D),B=n(N,$);return B?{index:u.indexOf(B),insertAfter:!0}:{index:u.indexOf(D),insertAfter:!1}}else{const $=i(u,F,u[u.length-1]),B=n(N,$);return B?{index:u.indexOf(B),insertAfter:!0}:{index:u.length-1,insertAfter:!0}}}}}const _=a[g+1];if(_)if(_.setting){const M=l(_.setting.key,u);if(M)return{index:u.indexOf(M),insertAfter:!1}}else{const M=c(g,a);if(M){const F=l(M.setting.key,u);if(F){const D=r(u.indexOf(F),u),N=i(a,a[g],M);if(D){const $=i(u,D,F),B=n(N.reverse(),$.reverse());return B?{index:u.indexOf(B),insertAfter:!1}:{index:u.indexOf(D),insertAfter:!0}}else{const $=i(u,u[0],F),B=n(N.reverse(),$.reverse());return B?{index:u.indexOf(B),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:u.length-1,insertAfter:!0}}function y(s,a,u,g,I,_){let M;return g.index===-1?M=(0,L.setProperty)(s,[a],u,_):M=S(s,a,u,g,I,_).map(F=>(0,L.withFormatting)(s,F,_)[0]),(0,L.applyEdits)(s,M)}function S(s,a,u,g,I,_){const M=`${JSON.stringify(a)}: ${JSON.stringify(u)}`,F=(0,T.getEOL)(_,s),D=I[g.index];if(g.insertAfter){const N=[];if(D.setting)N.push({offset:D.endOffset,length:0,content:","+M});else{const $=c(g.index,I),B=r(g.index,I),Z=B?.setting?.commaOffset;B&&Z===void 0&&N.push({offset:B.endOffset,length:0,content:","});const W=Z!==void 0&&Z>D.endOffset;N.push({offset:W?Z+1:D.endOffset,length:0,content:$?F+M+",":F+M})}return N}else{if(D.setting)return[{offset:D.startOffset,length:0,content:M+","}];const N=(I[g.index-1]&&!I[g.index-1].setting?F:"")+M+(c(g.index,I)?",":"")+F;return[{offset:D.startOffset,length:0,content:N}]}}function l(s,a){return a.filter(u=>u.setting?.key===s)[0]}function r(s,a){for(let u=s-1;u>=0;u--)if(a[u].setting)return a[u]}function c(s,a){for(let u=s+1;u<a.length;u++)if(a[u].setting)return a[u]}function i(s,a,u){const g=s.indexOf(a),I=s.indexOf(u);return s.filter((_,M)=>g<M&&M<I)}function n(s,a){if(s.length&&a.length){let u=0;for(;u<a.length&&u<s.length;u++)if(s[u].value!==a[u].value)return a[u-1];return a[u-1]}}function o(s){const a=[];let u=-1,g,I;const _={onObjectBegin:M=>{u++},onObjectProperty:(M,F,D)=>{u===0&&(g=F,I=M)},onObjectEnd:(M,F)=>{u--,u===0&&a.push({startOffset:g,endOffset:M+F,value:s.substring(g,M+F),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(M,F)=>{u++},onArrayEnd:(M,F)=>{u--,u===0&&a.push({startOffset:g,endOffset:M+F,value:s.substring(g,M+F),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(M,F,D)=>{u===0&&a.push({startOffset:g,endOffset:F+D,value:s.substring(g,F+D),setting:{key:I,commaOffset:void 0}})},onSeparator:(M,F,D)=>{if(u===0&&M===","){let N=a.length-1;for(;N>=0&&!a[N].setting;N--);const $=a[N];$&&a.splice(N,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:F}})}},onComment:(M,F)=>{u===0&&a.push({startOffset:M,endOffset:M+F,value:s.substring(M,M+F)})}};return(0,t.visit)(s,_),a}}),define(te[233],ne([0,1,17,3,146,18,90,14,30,15,23,21,32,45,53,232,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const r=JSON.parse(l);return m(r)?r:{settings:l}}e.parseSettingsSyncContent=w;let y=class extends p.AbstractJsonFileSynchroniser{constructor(r,c,i,n,o,s,a,u,g,I,_,M){super(c.settingsResource,"settings",r,c,i,n,o,g,I,s,a,u,M);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const c=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,c),n=this.getSettingsSyncContent(i),o=new A.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return n?.settings&&o.parse(n.settings),o.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,c,i){const n=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(r);c=c===null&&i?r:c;const a=c?this.getSettingsSyncContent(c):null,u=await this.getIgnoredSettings();let g=null,I=!1,_=!1,M=!1;if(s){let D=n?n.value.toString().trim():"{}";D=D||"{}",this.validateContent(D),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const N=(0,h.merge)(D,s.settings,a?a.settings:null,u,[],o);g=N.localContent||N.remoteContent,I=N.localContent!==null,_=N.remoteContent!==null,M=N.hasConflicts}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),g=n.value.toString(),_=!0);const F={content:g,localChange:I?2:0,remoteChange:_?2:0,hasConflicts:M};return[{fileContent:n,localResource:this.localResource,localContent:n?n.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const c=this.getSettingsSyncContent(r);if(c===null)return!0;const i=await this.getLocalFileContent(),n=i?i.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,h.merge)(n||"{}",c.settings,c.settings,o,[],s).remoteContent!==null}async getMergeResult(r,c){const i=await this.getFormattingOptions(),n=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,h.updateIgnoredSettings)(r.previewResult.content,"{}",n,i):null}}async getAcceptResult(r,c,i,n){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(c,this.localResource))return{content:r.fileContent?(0,h.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:r.remoteContent!==null?(0,h.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,h.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(r,c,i,n){const{fileContent:o}=i[0][0];let{content:s,localChange:a,remoteChange:u}=i[0][1];if(a===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,n),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),u!==0){const g=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(s);s=(0,h.updateIgnoredSettings)(s,I?I.settings:"{}",_,g),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),n?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const c=await this.getFormattingOptions(),i=(0,d.edit)(r.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,c);return!(0,h.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:c}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let c=await super.resolveContent(r);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(r)),c){const i=this.parseSyncData(c);if(i){const n=this.parseSettingsSyncContent(i.content);if(n)switch(this.extUri.basename(r)){case"settings.json":return n.settings}}}return null}async resolvePreviewContent(r){let c=await super.resolvePreviewContent(r);if(c){const i=await this.getFormattingOptions(),n=await this.getIgnoredSettings();c=(0,h.updateIgnoredSettings)(c,"{}",n,i)}return c}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(c){this.logService.error(c)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,n=>n.some(({local:o})=>!!o)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,n=>!n.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const c=await this._defaultIgnoredSettings;return(0,h.getIgnoredSettings)(c,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new v.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};y=de([G(0,C.IFileService),G(1,R.IEnvironmentService),G(2,P.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncBackupStoreService),G(5,v.IUserDataSyncLogService),G(6,v.IUserDataSyncUtilService),G(7,T.IConfigurationService),G(8,v.IUserDataSyncEnablementService),G(9,E.ITelemetryService),G(10,b.IExtensionManagementService),G(11,f.IUriIdentityService)],y),e.SettingsSynchroniser=y;let S=class extends p.AbstractInitializer{constructor(r,c,i,n){super("settings",c,i,r,n)}async doInitialize(r){const c=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!c){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(c.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,h.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(c){this.logService.error(c)}return null}};S=de([G(0,C.IFileService),G(1,R.IEnvironmentService),G(2,v.IUserDataSyncLogService),G(3,f.IUriIdentityService)],S),e.SettingsInitializer=S}),define(te[234],ne([0,1,17,3,28,18,14,15,23,21,32,45,227,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let d=class extends E.AbstractSynchroniser{constructor(m,w,y,S,l,r,c,i,n,o){super("snippets",w,m,y,S,l,i,n,r,c,o);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,y){const S=await this.getSnippetsFileContents(),l=this.toSnippetsContents(S),r=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&y?m:w;const c=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,f.merge)(l,r,c);return this.getResourcePreviews(i,S,r||{})}async hasRemoteChanged(m){const w=m.syncData?this.parseSnippets(m.syncData):null;if(w===null)return!0;const y=await this.getSnippetsFileContents(),S=this.toSnippetsContents(y),l=(0,f.merge)(S,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,y,S){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return y===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:y,localChange:y===null?m.fileContent!==null?3:0:2,remoteChange:y===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,y,S){const l=y.map(([r,c])=>({...r,acceptResult:c}));l.every(({localChange:r,remoteChange:c})=>r===0&&c===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,S)),l.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(l,m,S)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(m,w,y){const S=new Map;for(const l of Object.keys(m.local.added)){const r={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};S.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const r={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const r={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const r={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:y[l]?2:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!S.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const y=this.parseSyncData(w);if(y){const S=this.parseSnippets(y),l=[];for(const r of Object.keys(S)){const c=this.extUri.joinPath(m,r),i=this.extUri.joinPath(this.snippetsFolder,r),n=await this.fileService.exists(i);l.push({resource:c,comparableResource:n?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const y=this.parseSyncData(w);if(y)return this.parseSnippets(y)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const w={};for(const y of m)y.fileContent&&(w[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:y,acceptResult:S,localResource:l,remoteResource:r,localChange:c}of m)if(c!==0){const i=r?this.extUri.basename(r):this.extUri.basename(l),n=this.extUri.joinPath(this.snippetsFolder,i);c===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):c===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,k.VSBuffer.fromString(S.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,k.VSBuffer.fromString(S.content),w?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(m,w,y){const S=w.syncData?this.parseSnippets(w.syncData):{},l=(0,L.deepClone)(S);for(const{acceptResult:r,localResource:c,remoteResource:i,remoteChange:n}of m)if(n!==0){const o=c?this.extUri.basename(c):this.extUri.basename(i);n===3?delete l[o]:l[o]=r.content}return(0,f.areSame)(S,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),y?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const y of Object.keys(m))w[y]=m[y].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof R.FileOperationError&&y.fileOperationResult===1)return m;throw y}for(const y of w.children||[]){const S=y.resource,l=this.extUri.extname(S);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,S),c=await this.fileService.readFile(S);m[r]=c}}return m}};d=de([G(0,A.IEnvironmentService),G(1,R.IFileService),G(2,b.IStorageService),G(3,p.IUserDataSyncStoreService),G(4,p.IUserDataSyncBackupStoreService),G(5,p.IUserDataSyncLogService),G(6,T.IConfigurationService),G(7,p.IUserDataSyncEnablementService),G(8,C.ITelemetryService),G(9,P.IUriIdentityService)],d),e.SnippetsSynchroniser=d;let h=class extends E.AbstractInitializer{constructor(m,w,y,S){super("snippets",w,y,m,S)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(w)){const l=w[S];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(r,k.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};h=de([G(0,R.IFileService),G(1,A.IEnvironmentService),G(2,p.IUserDataSyncLogService),G(3,P.IUriIdentityService)],h),e.SnippetsInitializer=h}),define(te[235],ne([0,1,17,18,14,15,23,21,32,45,24]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function E(h,v){try{return JSON.parse(h).tasks}catch(m){return v.error(m),null}}e.getTasksContentFromSyncContent=E;let f=class extends C.AbstractFileSynchroniser{constructor(v,m,w,y,S,l,r,c,i,n){super(n.extUri.joinPath(n.extUri.dirname(r.settingsResource),"tasks.json"),"tasks",l,r,c,v,m,S,i,w,y,n);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(v,m,w,y){const S=v.syncData?E(v.syncData.content,this.logService):null;m=m===null&&w?v:m;const l=m?.syncData?E(m.syncData.content,this.logService):null,r=await this.getLocalFileContent();let c=null,i=!1,n=!1,o=!1;if(S){const a=r?r.value.toString():null;if(!l||l!==a||l!==S){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const u=d(a,S,l);c=u.content,o=u.hasConflicts,i=u.hasLocalChanged,n=u.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),c=r.value.toString(),n=!0);const s={content:c,localChange:i?r?2:1:0,remoteChange:n?2:0,hasConflicts:o};return[{fileContent:r,localResource:this.localResource,localContent:r?r.value.toString():null,localChange:s.localChange,remoteResource:this.remoteResource,remoteContent:S,remoteChange:s.remoteChange,previewResource:this.previewResource,previewResult:s,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(v){const m=v?.syncData?E(v.syncData.content,this.logService):null;if(m===null)return!0;const w=await this.getLocalFileContent(),y=w?w.value.toString():null,S=d(y,m,m);return S.hasLocalChanged||S.hasRemoteChanged}async getMergeResult(v,m){return v.previewResult}async getAcceptResult(v,m,w,y){if(this.extUri.isEqual(m,this.localResource))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(m,this.remoteResource))return{content:v.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(m,this.previewResource))return w===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:w,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(v,m,w,y){const{fileContent:S}=w[0][0];let{content:l,localChange:r,remoteChange:c}=w[0][1];if(r===0&&c===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),S&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(S.value.toString()))),await this.updateLocalFileContent(l||"{}",S,y),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),c!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(l||"{}"));v=await this.updateRemoteUserData(i,y?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}m?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:v}){const m=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(v,"tasks.json"),comparableResource:m}]}async resolveContent(v){if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let m=await super.resolveContent(v);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(v)),m){const w=this.parseSyncData(m);if(w)switch(this.extUri.basename(v)){case"tasks.json":return E(w.content,this.logService)}}return null}toTasksSyncContent(v){return{tasks:v}}};f=de([G(0,P.IUserDataSyncStoreService),G(1,P.IUserDataSyncBackupStoreService),G(2,P.IUserDataSyncLogService),G(3,t.IConfigurationService),G(4,P.IUserDataSyncEnablementService),G(5,T.IFileService),G(6,L.IEnvironmentService),G(7,A.IStorageService),G(8,R.ITelemetryService),G(9,b.IUriIdentityService)],f),e.TasksSynchroniser=f;let p=class extends C.AbstractInitializer{constructor(v,m,w,y){super("tasks",m,w,v,y);this.uriIdentityService=y,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(v){const m=v.syncData?E(v.syncData.content,this.logService):null;if(!m){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(m)),await this.updateLastSyncUserData(v)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};p=de([G(0,T.IFileService),G(1,L.IEnvironmentService),G(2,P.IUserDataSyncLogService),G(3,b.IUriIdentityService)],p),e.TasksInitializer=p;function d(h,v,m){if(h===null&&v===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(h===v)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const w=m!==h,y=m!==v;return!w&&!y?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:w&&!y?{content:h,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:y&&!w?{content:v,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:h,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(te[65],ne([0,1,3,2,6,24]),function(K,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends t.Disposable{constructor(b,C){super();this.userDataSyncStoreService=b,this.logService=C,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=de([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(te[236],ne([0,1,5,17,57,2,20,18,14,15,24]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends T.Disposable{constructor(p,d,h,v){super();this.environmentService=p,this.fileService=d,this.configurationService=h,this.logService=v,P.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),h=await this.fileService.resolve(d);return h.children?h.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,d){if(!d){const h=await this.getAllRefs(p);h.length&&(d=h[h.length-1].ref)}if(d){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,p,d);return(await this.fileService.readFile(h)).value.toString()}return null}async backup(p,d){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),v=(0,A.joinPath)(h,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,t.VSBuffer.fromString(d))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch{}}async cleanUpBackup(p){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(d))return}catch{return}const h=await this.fileService.resolve(d);if(h.children){const v=h.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=v.filter(S=>Date.now()-this.getCreationTime(S)>m);const y=v.length-w.length;y<10&&(w=w.slice(10-y)),await k.Promises.settled(w.map(async S=>{this.logService.info("Deleting from backup",S.resource.path),await this.fileService.del(S.resource)}))}}catch(h){this.logService.error(h)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=de([G(0,b.IEnvironmentService),G(1,C.IFileService),G(2,R.IConfigurationService),G(3,P.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[237],ne([0,1,3,2,4,14,23,21,24]),function(K,e,k,t,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const C="sync.enable";let P=class extends t.Disposable{constructor(f,p,d,h){super();this.storageService=f,this.telemetryService=p,this.environmentService=d,this.userDataSyncStoreManagementService=h,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(C,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(C,{enabled:f}),this.storageService.store(C,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,p){if(this.isResourceEnabled(f)!==p){const d=(0,b.getEnablementKey)(f);this.storeResourceEnablement(d,p)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,p){this.storageService.store(f,p,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(C===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=b.ALL_SYNC_RESOURCES.filter(d=>(0,b.getEnablementKey)(d)===f.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};P=de([G(0,A.IStorageService),G(1,R.ITelemetryService),G(2,T.IEnvironmentService),G(3,b.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(te[238],ne([0,1,2,7]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(f,p,d){switch(p){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(f){this.service=f}listen(f,p){throw new Error(`Event not found: ${p}`)}call(f,p,d){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(f,p,d){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(f,p,d){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class C{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(f,p,d){switch(p){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class P extends k.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:t.URI.revive(f.url),type:f.type,defaultUrl:t.URI.revive(f.defaultUrl),insidersUrl:t.URI.revive(f.insidersUrl),stableUrl:t.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(te[239],ne([0,1,14,8]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends t.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};L=de([G(0,t.ILoggerService),G(1,k.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(te[66],ne([0,1,3,2,4,26,149,14,15,6,27,47,23,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",h="Safari",v="Chrome",m="Edge",w="Firefox",y="Android";function S(c){switch(c){case h:case v:case m:case w:case y:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=S;function l(){return L.isSafari?h:L.isChrome?v:L.isEdge?m:L.isFirefox?w:L.isAndroid?y:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let r=class Ze extends t.Disposable{constructor(i,n,o,s,a,u){super();this.storageService=o,this.userDataSyncStoreService=s,this.logService=a,this.productService=u,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(i,n,o)}async getMachines(i){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(s=>({...s,isCurrent:s.id===n}))}async addCurrentMachine(i){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(i);o.machines.some(({id:s})=>s===n)||(o.machines.push({id:n,name:this.computeCurrentMachineName(o.machines),platform:l()}),await this.writeMachinesData(o))}async removeCurrentMachine(i){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(i),s=o.machines.filter(({id:a})=>a!==n);s.length!==o.machines.length&&(o.machines=s,await this.writeMachinesData(o))}async renameMachine(i,n,o){const s=await this.readMachinesData(o),a=s.machines.find(({id:u})=>u===i);if(a){a.name=n,await this.writeMachinesData(s);const u=await this.currentMachineIdPromise;i===u&&this.storageService.store(d,n,0,1)}}async setEnablements(i){const n=await this.readMachinesData();for(const[o,s]of i){const a=n.machines.find(u=>u.id===o);a&&(a.disabled=s?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(i){const n=this.storageService.get(d,0);if(n)return n;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,s=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const u of i){const g=s.exec(u.name),I=g?parseInt(g[1]):0;a=I>a?I:a}return`${o} #${a+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const n=this.parse(this.userData);if(n.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(i){const n=JSON.stringify(i),o=await this.userDataSyncStoreService.write(Ze.RESOURCE,n,this.userData?.ref||null);this.userData={ref:o,content:n},this._onDidChange.fire()}async readUserData(i){if(this.userData){const n=i&&i.latest?i.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.logService.error(n)}return{version:Ze.VERSION,machines:[]}}};r.VERSION=1,r.RESOURCE="machines",r=de([G(0,R.IEnvironmentService),G(1,b.IFileService),G(2,f.IStorageService),G(3,p.IUserDataSyncStoreService),G(4,p.IUserDataSyncLogService),G(5,P.IProductService)],r),e.UserDataSyncMachinesService=r}),define(te[240],ne([0,1,5,57,37,9,3,2,4,20,7,147,27,23,21,24,65,66]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",y="sync.sessionId",S="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(n,o,s,a,u,g,I,_,M,F){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=a,this.userDataSyncService=u,this.logService=g,this.userDataSyncAccountService=I,this.telemetryService=_,this.userDataSyncMachinesService=M,this.storageService=F,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(u.onDidChangeLocal(D=>this.triggerSync([D],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,D])=>D)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const n=this.storageService.get(S,0);return n?P.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(S,n.toString(),0,1):this.storageService.remove(S,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(n){n?this.storageService.store(l,n,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:n,message:o}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(y,0),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const o=h.UserDataSyncError.toUserDataSyncError(n);o instanceof h.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?b.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(n,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};r=de([G(0,f.IProductService),G(1,h.IUserDataSyncStoreManagementService),G(2,h.IUserDataSyncStoreService),G(3,h.IUserDataSyncEnablementService),G(4,h.IUserDataSyncService),G(5,h.IUserDataSyncLogService),G(6,v.IUserDataSyncAccountService),G(7,d.ITelemetryService),G(8,m.IUserDataSyncMachinesService),G(9,p.IStorageService)],r),e.UserDataAutoSyncService=r;class c extends R.Disposable{constructor(n,o,s,a,u,g,I,_){super();this.lastSyncUrl=n,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=a,this.userDataSyncService=u,this.userDataSyncMachinesService=g,this.logService=I,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(n,o){const s=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,T.isCancellationError)(u))return}return this.doSync(n,o,a)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!n&&(!(0,C.isEqual)(o.defaultUrl,n.defaultUrl)||!(0,C.isEqual)(o.insidersUrl,n.insidersUrl)||!(0,C.isEqual)(o.stableUrl,n.stableUrl))}async doSync(n,o,s){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new h.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new h.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new h.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const u=this.storageService.get(y,0);if(u&&this.manifest&&u!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new h.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new h.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new h.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const g=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const I=g.find(_=>_.isCurrent);if(I?.disabled)throw new h.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new h.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof h.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==u&&this.storageService.store(y,this.manifest.session,0,1),s.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(u){this.logService.error(u),a=u}this._onDidFinishSync.fire(a)}register(n){return super._register(n)}}c.INTERVAL_SYNCING="Interval"}),define(te[241],ne([0,1,16,5,37,3,2,20,11,29,18,30,6,23,21,228,230,231,233,234,235,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const r="sync.lastSyncTime";let c=class extends A.Disposable{constructor(a,u,g,I,_,M,F,D){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=u,this.instantiationService=g,this.configurationService=I,this.logService=_,this.telemetryService=M,this.storageService=F,this.userDataSyncEnablementService=D,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(r,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,u){this.checkEnablement();const g=(0,C.generateUuid)();try{const D=(0,l.createSyncHeaders)(g);u&&(D["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,D)}catch(D){const N=l.UserDataSyncError.toUserDataSyncError(D);throw this.reportUserDataSyncError(N,g),N}let I=!1;const _=this,M=this.getEnabledSynchronizers();let F;return{manifest:a,async run(){if(I)throw new Error("Can run a task only once");return F=(0,t.createCancelablePromise)(D=>_.sync(M,a,g,D)),F.finally(()=>F=void 0)},async stop(){if(F&&F.cancel(),_.status!=="idle")return _.stop(M)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new l.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,C.generateUuid)(),u=(0,l.createSyncHeaders)(a);let g;try{g=await this.userDataSyncStoreService.manifest(null,u)}catch(M){const F=l.UserDataSyncError.toUserDataSyncError(M);throw this.reportUserDataSyncError(F,a),F}await this.resetLocal();const I=this.getEnabledSynchronizers(),_=async()=>{await this.stop(I),await this.resetLocal()};return new i(a,g,u,I,_,this.configurationService,this.logService)}async sync(a,u,g,I){if(I.isCancellationRequested||!a.length)return;const _=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const M=(0,l.createSyncHeaders)(g);for(const F of a){if(I.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(F.resource))return;try{await F.sync(u,M)}catch(D){let N=!1;if(D instanceof l.UserDataSyncError)switch(D.code){case"TooLarge":D=new l.UserDataSyncError(D.message,D.code,F.resource),N=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":N=!0;break}const $=l.UserDataSyncError.toUserDataSyncError(D);if(this.reportUserDataSyncError($,g),N)throw $;this.logService.error(D),this.logService.error(`${F.resource}: ${(0,L.toErrorMessage)(D)}`),this._syncErrors.push([F.resource,$])}}this.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),this.updateLastSyncTime()}catch(M){const F=l.UserDataSyncError.toUserDataSyncError(M);throw this.reportUserDataSyncError(F,g),F}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const u of a)try{u.status!=="idle"&&await u.stop()}catch(g){this.logService.error(g)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async u=>{if(await u.replace(a))return!0})}async accept(a,u,g,I){this.checkEnablement(),await this.performSynchronizerAction(async _=>{if(_.resource===a)return await _.accept(u,g),I&&await _.apply(!1,(0,l.createSyncHeaders)((0,C.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async u=>{const g=await u.resolveContent(a);if(g)return g})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async g=>{if(g.resource===a)return g.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async g=>{if(g.resource===a)return g.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,u){return await this.performSynchronizerAction(async I=>{if(I.resource===a)return I.getAssociatedResources(u)})||[]}async getMachineId(a,u){return await this.performSynchronizerAction(async I=>{if(I.resource===a)return await I.getMachineId(u)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async u=>{if(u.resource!=="globalState"&&await u.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async u=>{if(await u.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(r,0),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(u){this.logService.error(`${a.resource}: ${(0,L.toErrorMessage)(u)}`),this.logService.error(u)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const u=new A.DisposableStore;try{const g=this.synchronizers.value||u.add(this.instantiationService.createInstance(n,()=>{},()=>{},()=>{})),I=[...g.enabled,...g.disabled.map(_=>u.add(g.createSynchronizer(_)))];for(const _ of I){const M=await a(_);if(!(0,b.isUndefined)(M))return M}return null}finally{u.dispose()}}setStatus(a){const u=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),u==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const u=this.computeStatus(a);this.setStatus(u)}updateConflicts(a){const u=this.computeConflicts(a);(0,k.equals)(this._conflicts,u,([g,I],[_,M])=>g===g&&(0,k.equals)(I,M,(F,D)=>(0,R.isEqual)(F.previewResource,D.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(u))}computeConflicts(a){return a.filter(u=>u.status==="hasConflicts").map(u=>[u.resource,u.conflicts.map(o)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(u=>u.status==="hasConflicts")?"hasConflicts":a.some(u=>u.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(r,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,u){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof l.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof l.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:u,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(n,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=de([G(0,l.IUserDataSyncStoreService),G(1,l.IUserDataSyncStoreManagementService),G(2,f.IInstantiationService),G(3,P.IConfigurationService),G(4,l.IUserDataSyncLogService),G(5,d.ITelemetryService),G(6,p.IStorageService),G(7,l.IUserDataSyncEnablementService)],c),e.UserDataSyncService=c;class i extends A.Disposable{constructor(a,u,g,I,_,M,F){super();this.id=a,this.manifest=u,this.syncHeaders=g,this.synchronisers=I,this.onStop=_,this.configurationService=M,this.logService=F,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,t.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,u){try{return await this.performAction(a,g=>g.accept(a,u))}catch(g){throw this.logService.error(g),g}}async merge(a){try{return a?await this.performAction(a,u=>u.merge(a)):await this.mergeAll()}catch(u){throw this.logService.error(u),u}}async discard(a){try{return await this.performAction(a,u=>u.discard(a))}catch(u){throw this.logService.error(u),u}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,u]of this.previews)for(const g of u.resourcePreviews)g.mergeState==="conflict"&&a.push(g.previewResource);for(const u of a)await this.discard(u);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[u,g]of this.previews){this.synchronizingResources.push([u,g.resourcePreviews.map(M=>M.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const I=this.synchronisers.find(M=>M.resource===u);for(const M of g.resourcePreviews)(M.localChange!==0||M.remoteChange!==0)&&M.mergeState==="preview"&&await I.merge(M.previewResource);const _=await I.apply(!1,this.syncHeaders);_&&a.push(this.toSyncResourcePreview(I.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(M=>M[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(I=>I.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(I=>I.resource===a);for(const I of u.resourcePreviews)await g.accept(I.remoteResource);await g.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(I=>I[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(I=>I.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(I=>I.resource===a);for(const I of u.resourcePreviews)await g.accept(I.localResource);await g.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(I=>I[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,u){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const g=this.previews.findIndex(([,B])=>B.resourcePreviews.some(({localResource:Z,previewResource:W,remoteResource:ee})=>(0,R.isEqual)(a,Z)||(0,R.isEqual)(a,W)||(0,R.isEqual)(a,ee)));if(g===-1)return this.previews;const[I,_]=this.previews[g],M=_.resourcePreviews.find(({localResource:B,remoteResource:Z,previewResource:W})=>(0,R.isEqual)(B,a)||(0,R.isEqual)(Z,a)||(0,R.isEqual)(W,a));if(!M)return this.previews;let F=this.synchronizingResources.find(B=>B[0]===I);F||(F=[I,[]],this.synchronizingResources.push(F)),F[1].some(B=>(0,R.isEqual)(B,M.localResource))||(F[1].push(M.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const D=this.synchronisers.find(B=>B.resource===this.previews[g][0]),N=await u(D);N?this.previews.splice(g,1,this.toSyncResourcePreview(D.resource,N)):this.previews.splice(g,1);const $=this.synchronizingResources.findIndex(B=>B[0]===I);return this.synchronizingResources[$][1].splice(F[1].findIndex(B=>(0,R.isEqual)(B,M.localResource)),1),F[1].length||(this.synchronizingResources.splice($,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[u,g]of this.previews){this.synchronizingResources.push([u,g.resourcePreviews.map(M=>M.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const I=this.synchronisers.find(M=>M.resource===u);let _=g;for(const M of g.resourcePreviews)(M.localChange!==0||M.remoteChange!==0)&&M.mergeState==="preview"&&(_=await I.merge(M.previewResource));_&&a.push(this.toSyncResourcePreview(I.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(M=>M[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const u=[],g=await this.getUserDataSyncConfiguration();for(const I of this.synchronisers){if(a.isCancellationRequested)return[];const _=await I.preview(this.manifest,g,this.syncHeaders);_&&u.push(this.toSyncResourcePreview(I.resource,_))}return u}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE),u=this.synchronisers.find(g=>g instanceof w.SettingsSynchroniser);if(u){const g=await u.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...g}}return a}toSyncResourcePreview(a,u){return[a,{isLastSyncFromCurrentMachine:u.isLastSyncFromCurrentMachine,resourcePreviews:u.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let n=class extends A.Disposable{constructor(a,u,g,I,_,M,F){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=u,this.onDidChangeLocal=g,this.userDataSyncEnablementService=I,this.instantiationService=_,this.extensionGalleryService=M,this.logService=F,this._enabled=[],this._register(I.onDidChangeResourceEnablement(([D,N])=>this.onDidChangeResourceEnablement(D,N))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,D])=>D.dispose())));for(const D of l.ALL_SYNC_RESOURCES)I.isResourceEnabled(D)&&this.registerSynchronizer(D)}get enabled(){return this._enabled.sort((a,u)=>a[1]-u[1]).map(([a])=>a)}get disabled(){return l.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,u){u?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([_])=>_.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const u=new A.DisposableStore,g=u.add(this.createSynchronizer(a));u.add(g.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),u.add(g.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),u.add(g.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const I=this.getOrder(a);this._enabled.push([g,I,u])}deRegisterSynchronizer(a){const u=this._enabled.findIndex(([g])=>g.resource===a);if(u!==-1){const g=this._enabled.splice(u,1);for(const[I,,_]of g){if(I.status!=="idle"){const M=I.conflicts.length>0;I.stop(),M&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}_.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(y.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(S.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(v.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(h.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};n=de([G(3,l.IUserDataSyncEnablementService),G(4,f.IInstantiationService),G(5,E.IExtensionGalleryService),G(6,l.IUserDataSyncLogService)],n);function o(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[242],ne([0,1,3,2,11,7,24]),function(K,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(E,f){this.service=E,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(E,f,p){try{return await this._call(E,f,p)}catch(d){throw this.logService.error(d),d}}async _call(E,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],T.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const d=f.substring("manualSync/".length),h=p[0],v=this.getManualSyncTask(h);switch(p=p.slice(1),d){case"preview":return v.preview();case"accept":return v.accept(T.URI.revive(p[0]),p[1]);case"merge":return v.merge(T.URI.revive(p[0]));case"discard":return v.discard(T.URI.revive(p[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(E){const f=this.manualSyncTasks.get(this.createKey(E));if(!f)throw new Error(`Manual sync taks not found: ${E}`);return f.manualSyncTask}async createManualSyncTask(){const E=new t.DisposableStore,f=E.add(await this.service.createManualSyncTask());return E.add(f.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:p}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:E}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(E){E.dispose();const f=this.createKey(E.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=R;class b extends t.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,d){return E.call(f,p,d).then(null,h=>{throw A.UserDataSyncError.toUserDataSyncError(h)})},listen(f,p){return E.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,d])=>{this.updateStatus(f),this.updateConflicts(p),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([p,d])=>[p,A.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:f,status:p}=await this.channel.call("createManualSyncTask"),d=this,h=new C(E,f,p,{async call(v,m,w){return d.channel.call(`manualSync/${v}`,[E,...(0,L.isArray)(m)?m:[m]],w)},listen(v,m){return k.Event.map(k.Event.filter(d.channel.listen(`manualSync/${v}`,m),w=>!h.isDiposed()&&w.manualSyncTaskId===E),w=>w.data)}});return h}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,f,p,d){return this.channel.call("accept",[E,f,p,d])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:d})=>({created:p,uri:T.URI.revive(d)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:d})=>({created:p,uri:T.URI.revive(d)}))}async getAssociatedResources(E,f){return(await this.channel.call("getAssociatedResources",[E,f])).map(({resource:d,comparableResource:h})=>({resource:T.URI.revive(d),comparableResource:T.URI.revive(h)}))}async getMachineId(E,f){return this.channel.call("getMachineId",[E,f])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([f,p])=>[f,p.map(d=>({...d,localResource:T.URI.revive(d.localResource),remoteResource:T.URI.revive(d.remoteResource),previewResource:T.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class C extends t.Disposable{constructor(E,f,p,d){super();this.id=E,this.manifest=f,this._disposed=!1,this._status=p;const h=this;this.channel={async call(v,m,w){try{const y=await d.call(v,m,w);return h.isDiposed()||(h._status=await d.call("_getStatus")),y}catch(y){throw A.UserDataSyncError.toUserDataSyncError(y)}},listen(v,m){return d.listen(v,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,f){const p=await this.channel.call("accept",[E,f]);return this.deserializePreviews(p)}async merge(E){const f=await this.channel.call("merge",[E]);return this.deserializePreviews(f)}async discard(E){const f=await this.channel.call("discard",[E]);return this.deserializePreviews(f)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([f,p])=>[f,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(d=>({...d,localResource:T.URI.revive(d.localResource),remoteResource:T.URI.revive(d.remoteResource),previewResource:T.URI.revive(d.previewResource),acceptedResource:T.URI.revive(d.acceptedResource)}))}])}}}),define(te[243],ne([0,1,5,25,9,3,2,102,4,20,11,7,29,18,14,15,27,43,47,23,24]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",c="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let s=class extends A.Disposable{constructor(M,F,D){super();this.productService=M,this.configurationService=F,this.storageService=D,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(D.onDidChangeValue,N=>N.key===S.SYNC_SERVICE_URL_TYPE&&N.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(S.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(M){this.storageService.store(S.SYNC_SERVICE_URL_TYPE,M,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[S.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(M,F){M=b.isWeb&&M?.web?{...M,...M.web}:M;const D={...M||{},...F||{}};if(D&&(0,P.isString)(D.url)&&(0,P.isObject)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(N=>(0,P.isArray)(D.authenticationProviders[N].scopes))){const N=D,$=!!N.canSwitch&&!F?.url,B=N.url===N.insidersUrl?"insiders":"stable",Z=($?this.userDataSyncStoreType:void 0)||B,W=F?.url||(Z==="insiders"?N.insidersUrl:Z==="stable"?N.stableUrl:N.url);return{url:E.URI.parse(W),type:Z,defaultType:B,defaultUrl:E.URI.parse(N.url),stableUrl:E.URI.parse(N.stableUrl),insidersUrl:E.URI.parse(N.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(N.authenticationProviders).reduce((ee,x)=>(ee.push({id:x,scopes:N.authenticationProviders[x].scopes}),ee),[])}}}};s=de([G(0,v.IProductService),G(1,p.IConfigurationService),G(2,y.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let a=class extends s{constructor(M,F,D){super(M,F,D);const N=this.storageService.get(l,0);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const $=this.productService[S.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),0,1):this.storageService.remove(l,0)}async switch(M){M!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=M,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=de([G(0,v.IProductService),G(1,p.IConfigurationService),G(2,y.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let u=class extends A.Disposable{constructor(M,F,D,N,$,B,Z){super();this.requestService=D,this.logService=N,this.storageService=Z,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(M),this.commonHeadersPromise=(0,w.getServiceMachineId)($,B,Z).then(W=>{const ee={"X-Client-Name":`${F.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ee["X-Client-Commit"]=F.commit),ee}),this.session=new I(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(M,F){this.authToken={token:M,type:F}}updateUserDataSyncStoreUrl(M){this.userDataSyncStoreUrl=M?(0,C.joinPath)(M,"v1"):void 0}initDonotMakeRequestsUntil(){const M=this.storageService.getNumber(r,0);M&&Date.now()<M&&this.setDonotMakeRequestsUntil(new Date(M))}setDonotMakeRequestsUntil(M){this._donotMakeRequestsUntil?.getTime()!==M?.getTime()&&(this._donotMakeRequestsUntil=M,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(F=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",M),D={},N=await this.request(F.toString(),{type:"GET",headers:D},[],t.CancellationToken.None);return(await(0,m.asJson)(N)||[]).map(({url:B,created:Z})=>({ref:(0,C.relativePath)(F,F.with({path:B})),created:Z*1e3}))}async resolveContent(M,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",M,F).toString(),N={};N["Cache-Control"]="no-cache";const $=await this.request(D,{type:"GET",headers:N},[],t.CancellationToken.None);return await(0,m.asText)($)}async delete(M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",M).toString(),D={};await this.request(F,{type:"DELETE",headers:D},[],t.CancellationToken.None)}async read(M,F,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",M,"latest").toString();D={...D},D["Cache-Control"]="no-cache",F&&(D["If-None-Match"]=F.ref);const $=await this.request(N,{type:"GET",headers:D},[304],t.CancellationToken.None);let B=null;if($.res.statusCode===304&&(B=F),B===null){const Z=$.res.headers.etag;if(!Z)throw new S.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",$.res.statusCode,$.res.headers[S.HEADER_OPERATION_ID]);const W=await(0,m.asText)($);if(!W&&$.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",N,"EmptyResponse",$.res.statusCode,$.res.headers[S.HEADER_OPERATION_ID]);B={ref:Z,content:W}}return B}async write(M,F,D,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",M).toString();N={...N},N["Content-Type"]=R.Mimes.text,D&&(N["If-Match"]=D);const B=await this.request($,{type:"POST",data:F,headers:N},[],t.CancellationToken.None),Z=B.res.headers.etag;if(!Z)throw new S.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",B.res.statusCode,B.res.headers[S.HEADER_OPERATION_ID]);return Z}async manifest(M,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",M&&(F["If-None-Match"]=M.ref);const N=await this.request(D,{type:"GET",headers:F},[304],t.CancellationToken.None);let $=null;if(N.res.statusCode===304&&($=M),!$){const Z=N.res.headers.etag;if(!Z)throw new S.UserDataSyncStoreError("Server did not return the ref",D,"NoRef",N.res.statusCode,N.res.headers[S.HEADER_OPERATION_ID]);const W=await(0,m.asText)(N);if(!W&&N.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",D,"EmptyResponse",N.res.statusCode,N.res.headers[S.HEADER_OPERATION_ID]);W&&($={...JSON.parse(W),ref:Z})}const B=this.storageService.get(c,0);return B&&$&&B!==$.session&&this.clearSession(),$===null&&B&&this.clearSession(),$&&this.storageService.store(c,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.request(M,{type:"DELETE",headers:F},[],t.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(c,0),this.storageService.remove(i,0)}async request(M,F,D,N){if(!this.authToken)throw new S.UserDataSyncStoreError("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new S.UserDataSyncStoreError(`${F.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;F.headers={...F.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:M,type:F.type,headers:{...F.headers,authorization:void 0}});let B;try{B=await this.session.request(M,F,N)}catch(x){if(!(x instanceof S.UserDataSyncStoreError)){let j="RequestFailed";const Y=(0,L.getErrorMessage)(x).toLowerCase();Y.includes("xhr timeout")?j="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?j="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Y.includes("headers must be an object")?j="RequestHeadersNotObject":(0,L.isCancellationError)(x)&&(j="RequestCanceled"),x=new S.UserDataSyncStoreError(`Connection refused for the request '${M}'.`,M,j,void 0,void 0)}throw this.logService.info("Request failed",M),x}const Z=B.res.headers[S.HEADER_OPERATION_ID],W={url:M,status:B.res.statusCode,"execution-id":F.headers[S.HEADER_EXECUTION_ID],"operation-id":Z},ee=(0,m.isSuccess)(B)||B.res.statusCode&&D.indexOf(B.res.statusCode)!==-1;if(ee?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),B.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new S.UserDataSyncStoreError(`Request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",B.res.statusCode,Z);if(this._onTokenSucceed.fire(),B.res.statusCode===409)throw new S.UserDataSyncStoreError(`${F.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",B.res.statusCode,Z);if(B.res.statusCode===410)throw new S.UserDataSyncStoreError(`${F.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",B.res.statusCode,Z);if(B.res.statusCode===412)throw new S.UserDataSyncStoreError(`${F.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",B.res.statusCode,Z);if(B.res.statusCode===413)throw new S.UserDataSyncStoreError(`${F.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",B.res.statusCode,Z);if(B.res.statusCode===426)throw new S.UserDataSyncStoreError(`${F.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",B.res.statusCode,Z);if(B.res.statusCode===429){const x=B.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new S.UserDataSyncStoreError(`${F.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",B.res.statusCode,Z)):new S.UserDataSyncStoreError(`${F.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",B.res.statusCode,Z)}if(!ee)throw new S.UserDataSyncStoreError("Server returned "+B.res.statusCode,M,"Unknown",B.res.statusCode,Z);return B}addSessionHeaders(M){let F=this.storageService.get(i,0);F===void 0&&(F=(0,f.generateUuid)(),this.storageService.store(i,F,0,1)),M["X-Machine-Session-Id"]=F;const D=this.storageService.get(c,0);D!==void 0&&(M["X-User-Session-Id"]=D)}};u=de([G(1,v.IProductService),G(2,m.IRequestService),G(3,S.IUserDataSyncLogService),G(4,d.IEnvironmentService),G(5,h.IFileService),G(6,y.IStorageService)],u),e.UserDataSyncStoreClient=u;let g=class extends u{constructor(M,F,D,N,$,B,Z){super(M.userDataSyncStore?.url,F,D,N,$,B,Z);this._register(M.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(M.userDataSyncStore?.url)))}};g=de([G(0,S.IUserDataSyncStoreManagementService),G(1,v.IProductService),G(2,m.IRequestService),G(3,S.IUserDataSyncLogService),G(4,d.IEnvironmentService),G(5,h.IFileService),G(6,y.IStorageService)],g),e.UserDataSyncStoreService=g;class I{constructor(M,F,D,N){this.limit=M,this.interval=F,this.requestService=D,this.logService=N,this.requests=[],this.startTime=void 0}request(M,F,D){if(this.isExpired()&&this.reset(),F.url=M,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new S.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(M),this.requestService.request(F,D)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(te[244],ne([0,1,3,60,27,23,21,240,24,65,66]),function(K,e,k,t,L,T,A,R,b,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(p,d,h,v,m,w,y,S,l,r,c){super(p,d,h,v,m,y,S,l,r,c);this._register(k.Event.debounce(k.Event.any(k.Event.map(w.onDidFocusWindow,()=>"windowFocus"),k.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(i,n)=>i?[...i,n]:[n],1e3)(i=>this.triggerSync(i,!0,!1)))}};E=de([G(0,L.IProductService),G(1,b.IUserDataSyncStoreManagementService),G(2,b.IUserDataSyncStoreService),G(3,b.IUserDataSyncEnablementService),G(4,b.IUserDataSyncService),G(5,t.INativeHostService),G(6,b.IUserDataSyncLogService),G(7,C.IUserDataSyncAccountService),G(8,A.ITelemetryService),G(9,P.IUserDataSyncMachinesService),G(10,T.IStorageService)],E),e.UserDataAutoSyncService=E}),define(te[245],ne([0,1,5,3,2]),function(K,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:C}){super();this.disposables=this._register(new L.DisposableStore),t.Event.latch(t.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>C()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[67],ne([0,1,50,5,10,11,22,125,258,259]),function(K,e,k,t,L,T,A,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,c){let i=c.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=c}}e.ExtractError=P;function E(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(c=>r&c).reduce((c,i)=>c+i,r&61440)}function f(l){if(l instanceof P)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new P(r,l)}function p(l,r,c,i,n,o){const s=L.dirname(r),a=L.join(i,s);if(!a.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const u=L.join(i,r);let g;return o.onCancellationRequested(()=>{g&&g.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((I,_)=>{if(!o.isCancellationRequested)try{g=(0,k.createWriteStream)(u,{mode:c}),g.once("close",()=>I()),g.once("error",_),l.once("error",_),l.pipe(g)}catch(M){_(M)}}))}function d(l,r,c,i){let n=(0,t.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{n.cancel(),l.close()}),new Promise((s,a)=>{const u=new t.Sequencer,g=I=>{I.isCancellationRequested||(o++,l.readEntry())};l.once("error",a),l.once("close",()=>n.then(()=>{i.isCancellationRequested||l.entryCount===o?s():a(new P("Incomplete",new Error(R.localize(1,null,o,l.entryCount))))},a)),l.readEntry(),l.on("entry",I=>{if(i.isCancellationRequested)return;if(!c.sourcePathRegex.test(I.fileName)){g(i);return}const _=I.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(_)){const D=L.join(r,_);n=(0,t.createCancelablePromise)(N=>A.Promises.mkdir(D,{recursive:!0}).then(()=>g(N)).then(void 0,a));return}const M=v(l,I),F=E(I);n=(0,t.createCancelablePromise)(D=>u.queue(()=>M.then(N=>p(N,_,F,r,c,D).then(()=>g(D)))).then(null,a))})})}function h(l,r=!1){return new Promise((c,i)=>{(0,b.open)(l,r?{lazyEntries:!0}:void 0,(n,o)=>{n?i(f(n)):c((0,T.assertIsDefined)(o))})})}function v(l,r){return new Promise((c,i)=>{l.openReadStream(r,(n,o)=>{n?i(f(n)):c((0,T.assertIsDefined)(o))})})}function m(l,r){return new Promise((c,i)=>{const n=new C.ZipFile;r.forEach(s=>{s.contents?n.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&n.addFile(s.localPath,s.path)}),n.end();const o=(0,k.createWriteStream)(l);n.outputStream.pipe(o),n.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>c(l))})}e.zip=m;function w(l,r,c={},i){const n=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let o=h(l,!0);return c.overwrite&&(o=o.then(s=>A.Promises.rm(r).then(()=>s))),o.then(s=>d(s,r,{sourcePathRegex:n},i))}e.extract=w;function y(l,r){return h(l).then(c=>new Promise((i,n)=>{c.on("entry",o=>{o.fileName===r&&v(c,o).then(s=>i(s),s=>n(s))}),c.once("close",()=>n(new Error(R.localize(2,null,r))))}))}function S(l,r){return y(l,r).then(c=>new Promise((i,n)=>{const o=[];c.once("error",n),c.on("data",s=>o.push(s)),c.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=S}),define(te[246],ne([0,1,67,133]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,k.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=L}),define(te[247],ne([0,1,16,5,9,2,19,10,4,20,62,7,29,22,67,134,14,30,31,156,61,15,8,27]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let i=class extends T.Disposable{constructor(o,s,a,u,g){super();this.beforeRemovingExtension=o,this.fileService=s,this.logService=a,this.environmentService=u,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new t.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(o){const s=[];(o===null||o===0)&&s.push(this.scanSystemExtensions().then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal)))),(o===null||o===1)&&s.push(this.scanUserExtensions(!0).then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal))));try{const a=await Promise.all(s);return(0,k.flatten)(a)}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(o){this.logService.trace("Started scanning user extensions");let[s,a]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return a=a.filter(u=>!s[new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),o&&(a=(0,w.groupByExtension)(a,g=>g.identifier).map(g=>g.sort((I,_)=>P.rcompare(I.manifest.version,_.manifest.version))[0])),this.logService.trace("Scanned user extensions:",a.length),a}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(o,s,a,u){const g=o.key(),I=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),_=R.join(this.extensionsPath,g);try{await p.Promises.rm(_)}catch{try{await p.Promises.rm(_)}catch{}throw new m.ExtensionManagementError((0,h.localize)(0,null,_,o.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(o,s,I,u);let M=await this.scanExtension(E.URI.file(I),1);if(!M)throw new Error((0,h.localize)(1,null,I));await this.storeMetadata(M,{...a,installedTimestamp:Date.now()});try{await this.rename(o,I,_,Date.now()+2*60*1e3),this.logService.info("Renamed to",_)}catch(F){try{await p.Promises.rm(I)}catch{}if(F.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",o.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(F)}. Deleted from extracted location`,I),F}try{M=await this.scanExtension(E.URI.file(_),1)}catch{}if(M)return M;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(o,s){return this.setMetadata(o,s),await this.storeMetadata(o,{...s,installedTimestamp:o.installedTimestamp}),o}async storeMetadata(o,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const a=R.join(o.location.fsPath,"package.json"),u=await p.Promises.readFile(a,"utf8"),{manifest:g}=await this.parseManifest(u);return g.__metadata=s,await p.Promises.writeFile(a,JSON.stringify(g,null,"	")),o}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...o){const s=o.map(a=>new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version));await this.withUninstalledExtensions(a=>{s.forEach(u=>a[u.key()]=!0)})}async setInstalled(o){await this.withUninstalledExtensions(u=>delete u[o.key()]);const a=(await this.scanExtensions(1)).find(u=>new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(o))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,1)):null}async withUninstalledExtensions(o){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let a={};if(s)try{a=JSON.parse(s)}catch{}return o&&(o(a),Object.keys(a).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await p.Promises.rm(this.uninstalledPath)),a})}async removeExtension(o,s){this.logService.trace(`Deleting ${s} extension from disk`,o.identifier.id,o.location.fsPath),await p.Promises.rm(o.location.fsPath),this.logService.info("Deleted from disk",o.identifier.id,o.location.fsPath)}async removeUninstalledExtension(o){await this.removeExtension(o,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version).key()])}async extractAtLocation(o,s,a,u){this.logService.trace(`Started extracting the extension from ${s} to ${a}`);try{await p.Promises.rm(a)}catch(g){throw new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(s,a,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${a}:`,o.id)}catch(g){try{await p.Promises.rm(a)}catch{}let I=m.ExtensionManagementErrorCode.Extract;throw g instanceof d.ExtractError&&(g.type==="CorruptZip"?I=m.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(I=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(g.message,I)}}async rename(o,s,a,u){try{await p.Promises.rename(s,a)}catch(g){if(b.isWindows&&g&&g.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${s} to ${a} with 'EPERM' error. Trying again...`,o.id),this.rename(o,s,a,u);throw new m.ExtensionManagementError(g.message||(0,h.localize)(3,null,s,a),g.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const o=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return o;const s=this.scanDevSystemExtensions(),[a,u]=await Promise.all([o,s]);return[...a,...u]}async scanExtensionsInDir(o,s){const a=new t.Limiter(10),u=await this.fileService.resolve(E.URI.file(o));return u.children?(await Promise.all(u.children.filter(I=>I.isDirectory).map(I=>a.queue(async()=>s===1&&(0,C.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,s))))).filter(I=>I&&I.identifier):[]}async scanExtension(o,s){try{const a=await this.fileService.resolve(o);if(a.children){const{manifest:u,metadata:g}=await this.readManifest(o.fsPath),I=a.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D))?.resource,_=a.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D))?.resource,M={id:(0,w.getGalleryExtensionId)(u.publisher,u.name)},F={type:s,identifier:M,manifest:u,location:o,readmeUrl:I,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(F,g),F}}catch(a){s!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){const o=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",o.length),o}async scanDevSystemExtensions(){const o=this.getDevSystemExtensionsList();if(o.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(a=>o.some(u=>(0,w.areSameExtensions)(a.identifier,{id:u})))}else return[]}setMetadata(o,s){o.publisherDisplayName=s?.publisherDisplayName||null,o.publisherId=s?.publisherId||null,o.identifier.uuid=s?.id,o.isMachineScoped=!!s?.isMachineScoped,o.isPreReleaseVersion=!!s?.isPreReleaseVersion,o.preRelease=!!s?.preRelease,o.isBuiltin=o.type===0||!!s?.isBuiltin,o.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const o=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),a=new Set;for(const I of s)o[new w.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||a.add(I.identifier.id.toLowerCase());const u=(0,w.groupByExtension)(s,I=>I.identifier);await t.Promises.settled(u.map(async I=>{const _=I.sort((M,F)=>P.rcompare(M.manifest.version,F.manifest.version))[0];a.has(_.identifier.id.toLowerCase())||await this.beforeRemovingExtension(_)}));const g=s.filter(I=>o[new w.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await t.Promises.settled(g.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const o=await this.scanAllUserExtensions(),s=[],a=(0,w.groupByExtension)(o,u=>u.identifier);s.push(...(0,k.flatten)(a.map(u=>u.sort((g,I)=>P.rcompare(g.manifest.version,I.manifest.version)).slice(1)))),await t.Promises.settled(s.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(o=>o.name)}joinErrors(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((a,u)=>new Error(`${a.message}${a.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(A.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(o){const s=[p.Promises.readFile(R.join(o,"package.json"),"utf8").then(I=>this.parseManifest(I)),p.Promises.readFile(R.join(o,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:a,metadata:u},g]=await Promise.all(s);return{manifest:(0,y.localizeManifest)(a,g),metadata:u}}parseManifest(o){return new Promise((s,a)=>{try{const u=JSON.parse(o);u.publisher||(u.publisher=S.UNDEFINED_PUBLISHER);const g=u.__metadata||null;s({manifest:u,metadata:g})}catch{a(new Error((0,h.localize)(4,null)))}})}};i=de([G(1,l.IFileService),G(2,r.ILogService),G(3,v.INativeEnvironmentService),G(4,c.IProductService)],i),e.ExtensionsScanner=i}),define(te[248],ne([0,1,37,9,19,10,4,33,20,62,11,7,29,22,67,132,82,14,205,30,31,188,173,246,189,247,222,79,15,6,8,27,21,32]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l,r,c,i,n,o,s,a,u,g,I,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let F=class extends w.AbstractExtensionManagementService{constructor(W,ee,x,j,Y,V,J,Q,q){super(W,ee,x,Q);this.environmentService=j,this.downloadService=Y,this.fileService=J;const O=this._register(V.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(n.ExtensionsScanner,z=>O.postUninstall(z))),this.manifestCache=this._register(new i.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(V.createInstance(l.ExtensionsDownloader));const U=this._register(new o.ExtensionsWatcher(this,J,j,x,q));this._register(U.onDidChangeExtensionsByAnotherSource(({added:z,removed:H})=>{z.length&&this._onDidInstallExtensions.fire(z.map(ie=>({identifier:ie.identifier,operation:1,local:ie}))),H.forEach(ie=>this._onDidUninstallExtension.fire({identifier:ie}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),ee=(0,y.getTargetPlatform)(W?"alpine":A.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ee),ee})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let W;try{W=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch{try{W=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(x){this.logService.debug("Error while getting the os-release file.",(0,t.getErrorMessage)(x))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const ee=await this.collectFiles(W),x=await(0,d.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,ee);return E.URI.file(x)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const ee=await this.downloadVsix(W),x=T.resolve(ee.fsPath);return(0,c.getManifest)(x)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,ee={}){this.logService.trace("ExtensionManagementService#install",W.toString());const x=await this.downloadVsix(W),j=await(0,c.getManifest)(T.resolve(x.fsPath));if(j.engines&&j.engines.vscode&&!(0,s.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,S.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return this.installExtension(j,x,ee)}async updateMetadata(W,ee){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const x={...W.manifest.__metadata||{},...ee};return ee.isPreReleaseVersion&&(x.preRelease=!0),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,x),this.manifestCache.invalidate(),W}async updateExtensionScope(W,ee){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:ee}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===L.Schemas.file)return W;const ee=(0,b.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(W,ee),ee}createInstallExtensionTask(W,ee,x){return E.URI.isUri(ee)?new $(W,ee,x,this.galleryService,this.extensionsScanner,this.logService):new N(ee,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,ee){return new B(W,ee,this.extensionsScanner)}async collectFiles(W){const ee=async j=>{let Y=await p.Promises.readdir(j);Y=Y.map(Q=>T.join(j,Q));const V=await Promise.all(Y.map(Q=>p.Promises.stat(Q)));let J=Promise.resolve([]);return V.forEach((Q,q)=>{const O=Y[q];Q.isFile()&&(J=J.then(U=>[...U,O])),Q.isDirectory()&&(J=J.then(U=>ee(O).then(z=>[...U,...z])))}),J};return(await ee(W.location.fsPath)).map(j=>({path:`extension/${T.relative(W.location.fsPath,j)}`,localPath:j}))}};F=de([G(0,y.IExtensionGalleryService),G(1,_.ITelemetryService),G(2,g.ILogService),G(3,m.INativeEnvironmentService),G(4,v.IDownloadService),G(5,u.IInstantiationService),G(6,a.IFileService),G(7,I.IProductService),G(8,M.IUriIdentityService)],F),e.ExtensionManagementService=F;class D extends w.AbstractExtensionTask{constructor(W,ee,x,j){super();this.identifier=W,this.source=ee,this.extensionsScanner=x,this.logService=j,this._operation=2}get operation(){return this._operation}async installExtension(W,ee){try{const x=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(x)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},...W.metadata}):x}catch{throw A.isMacintosh?new y.ExtensionManagementError(h.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(h.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(W,ee)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const x=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),x}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:ee,metadata:x},j){let Y=await this.extensionsScanner.extractUserExtension(ee,W,x,j);return this.logService.info("Extracting completed.",ee.id),Y}}class N extends D{constructor(W,ee,x,j,Y){super(W.identifier,W,j,Y);this.gallery=W,this.options=ee,this.extensionsDownloader=x}async doRun(W){const x=(await this.extensionsScanner.scanExtensions(null)).find(Y=>(0,S.areSameExtensions)(Y.identifier,this.gallery.identifier));x&&(this._operation=3);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin,j.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,j.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:x?.preRelease);try{const Y=await this.installExtension(j,W);return x&&C.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x),Y}catch(Y){throw await this.deleteDownloadedVSIX(j.zipPath),Y}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(E.URI.file(W))}catch(ee){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,t.getErrorMessage)(ee))}}async downloadInstallableExtension(W,ee){const x={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",W.identifier.id),j=(await this.extensionsDownloader.downloadExtension(W,ee)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,j)}catch(Y){throw new y.ExtensionManagementError((0,w.joinErrors)(Y).message,y.ExtensionManagementErrorCode.Download)}try{const Y=await(0,c.getManifest)(j);return{zipPath:j,identifierWithVersion:new S.ExtensionIdentifierWithVersion(W.identifier,Y.version),metadata:x}}catch(Y){throw await this.deleteDownloadedVSIX(j),new y.ExtensionManagementError((0,w.joinErrors)(Y).message,y.ExtensionManagementErrorCode.Invalid)}}}class $ extends D{constructor(W,ee,x,j,Y,V){super({id:(0,S.getGalleryExtensionId)(W.publisher,W.name)},ee,Y,V);this.manifest=W,this.location=ee,this.options=x,this.galleryService=j}async doRun(W){const ee=new S.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(V=>(0,S.areSameExtensions)(this.identifier,V.identifier)),Y=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(Y.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,Y.isBuiltin=this.options.isBuiltin||j?.isBuiltin,j)if(this._operation=3,ee.equals(new S.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const V=await this.unsetUninstalledAndGetLocal(ee);if(V)try{await this.extensionsScanner.removeExtension(V,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:ee,metadata:Y},W)}async getMetadata(W,ee,x){try{let[j]=await this.galleryService.getExtensions([{id:W,version:ee}],x);if(j||([j]=await this.galleryService.getExtensions([{id:W}],x)),j)return{id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B extends w.AbstractExtensionTask{constructor(W,ee,x){super();this.extension=W,this.options=ee,this.extensionsScanner=x}async doRun(W){const ee=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new S.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ee.push(...x.filter(Y=>j.equals(new S.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version))))}else ee.push(...x.filter(j=>(0,S.areSameExtensions)(j.identifier,this.extension.identifier)));if(!ee.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ee),this.options.remove)for(const j of ee)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(Y){throw new Error(h.localize(6,null,(0,k.toErrorMessage)(Y)))}}}}),define(te[249],ne([0,1,84,56,34,17,9,3,2,10,4,29,36,74,260]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(I,_=""){this.debugLabel=_,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,A.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,_){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const _=M=>{this.traceSocketEvent("read",M),I(T.VSBuffer.wrap(M))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(I){const _=M=>{this.traceSocketEvent("close",{hadError:M}),I({type:0,hadError:M,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(I){const _=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=h;var v;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var m;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(m||(m={}));class w extends b.Disposable{constructor(I,_,M,F){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:M?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new y(this,_,M,F,this._onData,(D,N)=>this._write(D,N))),this._register(this._flowManager.onError(D=>{console.error(D),(0,A.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,_){this.socket.traceSocketEvent(I,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let M=2;I.byteLength<126?M+=0:I.byteLength<2**16?M+=2:M+=8;const F=T.VSBuffer.alloc(M);if(_?F.writeUInt8(194,0):F.writeUInt8(130,0),I.byteLength<126)F.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){F.writeUInt8(126,1);let D=1;F.writeUInt8(I.byteLength>>>8&255,++D),F.writeUInt8(I.byteLength>>>0&255,++D)}else{F.writeUInt8(127,1);let D=1;F.writeUInt8(0,++D),F.writeUInt8(0,++D),F.writeUInt8(0,++D),F.writeUInt8(0,++D),F.writeUInt8(I.byteLength>>>24&255,++D),F.writeUInt8(I.byteLength>>>16&255,++D),F.writeUInt8(I.byteLength>>>8&255,++D),F.writeUInt8(I.byteLength>>>0&255,++D)}this.socket.write(T.VSBuffer.concat([F,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),M=_.readUInt8(0),F=(M&128)>>>7,D=(M&64)>>>6,N=_.readUInt8(1),$=(N&128)>>>7,B=N&127;this._state.state=2,this._state.readLen=2+($?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(D)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),M=_.readUInt8(1),F=(M&128)>>>7;let D=M&127,N=1;D===126?D=_.readUInt8(++N)*2**8+_.readUInt8(++N):D===127&&(D=_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*2**24+_.readUInt8(++N)*2**16+_.readUInt8(++N)*2**8+_.readUInt8(++N));let $=0;F&&($=_.readUInt8(++N)*2**24+_.readUInt8(++N)*2**16+_.readUInt8(++N)*2**8+_.readUInt8(++N)),this._state.state=3,this._state.readLen=D,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class y extends b.Disposable{constructor(I,_,M,F,D,N){super();this._tracer=I,this._onData=D,this._writeFn=N,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new S(this._tracer,F,M,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(_,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,_){return new Promise((M,F)=>{I.write(_),I.flush(D=>M(D))})}acceptFrame(I,_,M){this._readQueue.push({data:I,isCompressed:_,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,_,M){return new Promise((F,D)=>{I.write(_),M&&I.write(T.VSBuffer.fromByteArray([0,0,255,255])),I.flush(N=>F(N))})}}class S extends b.Disposable{constructor(I,_,M,F){super();this._tracer=I,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(F),this._zlibInflate.on("error",D=>{this._tracer.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibInflate.on("data",D=>{this._tracer.traceSocketEvent("zlibInflateData",D),this._pendingInflateData.push(T.VSBuffer.wrap(D))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(_)})}}class l extends b.Disposable{constructor(I,_){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(T.VSBuffer.wrap(M))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),I(_)})}}function r(g,I){if(I===0)return;let _=g.byteLength>>>2;for(let B=0;B<_;B++){const Z=g.readUInt32BE(B*4);g.writeUInt32BE(Z^I,B*4)}let M=_*4,F=g.byteLength-M;const D=I>>>24&255,N=I>>>16&255,$=I>>>8&255;F>=1&&g.writeUInt8(g.readUInt8(M)^D,M),F>=2&&g.writeUInt8(g.readUInt8(M+1)^N,M+1),F>=3&&g.writeUInt8(g.readUInt8(M+2)^$,M+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function i(){const g=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):I=(0,C.join)((0,L.tmpdir)(),`vscode-ipc-${g}.sock`),o(I),I}e.createRandomIPCHandle=i;function n(g,I,_){const M=(0,k.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${_}-${I}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${_}-${I}.sock`):F=(0,C.join)(g,`${_}-${I}.sock`),o(F),F}e.createStaticIPCHandle=n;function o(g){const I=c[P.platform];typeof I=="number"&&g.length>=I&&console.warn(`WARNING: IPC handle "${g}" is longer than ${I} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(I){super(s.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const _=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(_,M=>({protocol:new p.Protocol(new h(M,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(M,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(g){return new Promise((I,_)=>{const M=(0,t.createServer)();M.on("error",_),M.listen(g,()=>{M.removeListener("error",_),I(new s(M))})})}e.serve=a;function u(g,I){return new Promise((_,M)=>{const F=(0,t.createConnection)(g,()=>{F.removeListener("error",M),_(p.Client.fromSocket(new h(F,`ipc-client${I}`),I))});F.once("error",M)})}e.connect=u}),define(te[250],ne([0,1,56,249]),function(K,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,R,b){const C=E=>b(E,void 0),P=k.createConnection({host:L,port:T},()=>{P.removeListener("error",C);const E=Buffer.alloc(16);for(let h=0;h<16;h++)E[h]=Math.round(Math.random()*256);const f=E.toString("base64"),p=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(p.join(`\r
`)+`\r
\r
`);const d=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",d),b(void 0,new t.NodeSocket(P,R)))};P.on("data",d)});P.setNoDelay(!0),P.once("error",C)}}}),define(te[251],ne([0,1,56,115,250,5,2,18,8,27,184,64,92]),function(K,e,k,t,L,T,A,R,b,C,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(w,y,S,l,r){let c;for(let i=3;i&&(c&&c.dispose(),c=await new d(w,y,S,l,r).waitForReady(),!(r&&t.BROWSER_RESTRICTED_PORTS[r]||!t.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));i--);return c}class d extends A.Disposable{constructor(y,S,l,r,c){super();this.defaultTunnelHost=S,this.suggestedLocalPort=c,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=k.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(S=>{S()})}async waitForReady(){let y=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),S=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address(),S||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address()),this.tunnelLocalPort=S.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${S.port}`,this}async _onConnection(y){y.pause();const S=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,S,this.tunnelRemotePort),r=l.getSocket().socket,c=l.readEntireBuffer();l.dispose(),c.byteLength>0&&y.write(c.buffer),y.on("end",()=>{y.localAddress&&this._socketsDispose.delete(y.localAddress),r.end()}),y.on("close",()=>r.end()),y.on("error",()=>{y.localAddress&&this._socketsDispose.delete(y.localAddress),r.destroy()}),r.on("end",()=>y.end()),r.on("close",()=>y.end()),r.on("error",()=>{y.destroy()}),y.pipe(r),r.pipe(y),y.localAddress&&this._socketsDispose.set(y.localAddress,()=>{y.end(),r.end()})}}let h=class extends E.AbstractTunnelService{constructor(y,S,l,r,c){super(S);this.socketFactory=y,this.signService=l,this.productService=r,this.configurationService=c}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,S,l,r,c,i,n){const o=this.getTunnelFromMap(S,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,S,l,r,c,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${S}:${l} on local port ${r}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},a=p(s,this.defaultTunnelHost,S,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(S,l,a),a}}};h=de([G(1,b.ILogService),G(2,f.ISignService),G(3,C.IProductService),G(4,R.IConfigurationService)],h),e.BaseTunnelService=h;let v=class extends h{constructor(y,S,l,r){super(L.nodeSocketFactory,y,S,l,r)}};v=de([G(0,b.ILogService),G(1,f.ISignService),G(2,C.IProductService),G(3,R.IConfigurationService)],v),e.TunnelService=v;let m=class extends A.Disposable{constructor(y,S,l,r){super();this.logService=y,this.productService=S,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(y,S,l,r,c,i,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${c}.`),!this._tunnelServices.has(y)){const s=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(y,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(y))})}return this._tunnelServices.get(y).openTunnel(S,l,r,c,i,n,o)}};m=de([G(0,b.ILogService),G(1,C.IProductService),G(2,f.ISignService),G(3,R.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[261],ne([0,1,75,34,37,9,2,19,20,7,36,118,178,200,179,170,171,172,159,161,18,182,81,204,82,193,14,197,199,209,30,186,206,248,83,157,15,175,177,51,6,167,86,168,169,59,190,8,87,60,88,27,192,43,23,202,203,21,93,94,95,44,210,211,96,213,220,63,98,24,65,236,238,239,66,237,241,242,243,244,245,92,198,64,251,191,221,91,196,207,32,223,4,224,162,181,180]),function(K,e,k,t,L,T,A,R,b,C,P,E,f,p,d,h,v,m,w,y,S,l,r,c,i,n,o,s,a,u,g,I,_,M,F,D,N,$,B,Z,W,ee,x,j,Y,V,J,Q,q,O,U,z,H,ie,se,ue,he,we,pe,ge,Ee,Te,Ce,De,qe,Je,He,je,re,ae,le,ye,be,Ue,Le,Oe,_e,X,oe,ce,fe,me,ke,Se,Pe,Re,Ie,Ae,Fe,ze,We,Pt,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",$e=(Ge,Ne)=>this.onDisposeWorker(Ne);k.ipcRenderer.on(Me,$e),this._register((0,A.toDisposable)(()=>k.ipcRenderer.removeListener(Me,$e)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ae.registerConfiguration)(),ve.invokeFunction(Me=>{const $e=Me.get(Q.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler($e)}),this._register((0,A.combinedDisposable)(ve.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(d.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(h.LocalizationsUpdater),ve.createInstance(p.ExtensionsCleaner)))}async initServices(){const ve=new x.ServiceCollection,Me={_serviceBrand:void 0,...U.default};ve.set(z.IProductService,Me);const $e=new P.StaticRouter(xe=>xe==="main"),Ge=new j.MessagePortMainProcessService(this.server,$e);ve.set(Y.IMainProcessService,Ge);const Ne=new s.SharedProcessEnvironmentService(this.configuration.args,Me);ve.set(o.INativeEnvironmentService,Ne);const nt=new q.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Xe=new q.LoggerChannelClient(this.configuration.logLevel,nt.onDidChangeLogLevel,Ge.getChannel("logger"));ve.set(Q.ILoggerService,Xe);const ot=this._register(new Q.MultiplexLogService([this._register(new Q.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(C.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ke=this._register(new q.FollowerLogService(nt,ot));ve.set(Q.ILogService,Ke),this.sharedProcessWorkerService=new Fe.SharedProcessWorkerService(Ke),ve.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ye=this._register(new $.FileService(Ke));ve.set(N.IFileService,Ye);const at=this._register(new B.DiskFileSystemProvider(Ke));Ye.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ge.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ke));Ye.registerProvider(R.Schemas.userData,ct);const Be=this._register(new l.ConfigurationService(Ne.settingsResource,Ye));ve.set(S.IConfigurationService,Be);const et=new ue.NativeStorageService(void 0,Ge,Ne);ve.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([Be.initialize(),et.initialize()]),ve.set(We.IUriIdentityService,new Pt.UriIdentityService(Ye)),ve.set(ie.IRequestService,new Z.SyncDescriptor(H.RequestService)),ve.set(w.IChecksumService,new Z.SyncDescriptor(y.ChecksumService)),ve.set(St.IV8InspectProfilingService,new Z.SyncDescriptor(kt.InspectProfilingService));const it=P.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(O.INativeHostService,it),ve.set(i.IDownloadService,new Z.SyncDescriptor(n.DownloadService));const lt=this._register(new fe.ActiveWindowManager(it)),ut=new P.StaticRouter(xe=>lt.getActiveClientId().then(dt=>xe===dt));ve.set(F.IExtensionRecommendationNotificationService,new D.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new ze.AssignmentService(this.configuration.machineId,Be,Me);let rt;const Qe=[];if((0,Te.supportsTelemetry)(Me,Ne)){const xe=new ge.TelemetryLogAppender(Xe,Ne);Qe.push(xe);const{installSourcePath:dt}=Ne;if(Me.aiConfig&&Me.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Me.quality!=="stable";if(ft&&st){const bt=new Ce.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,st,!0);this._register((0,A.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new Ce.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,A.toDisposable)(()=>Et.flush())),Qe.push(Et)}rt=new Ee.TelemetryService({appenders:Qe,commonProperties:(0,he.resolveCommonProperties)(Ye,(0,t.release)(),(0,t.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,dt),sendErrorTelemetry:!0,piiPaths:(0,Te.getPiiPathsFromEnvironment)(Ne)},Be)}else{rt=Te.NullTelemetryService;const xe=Te.NullAppender;Qe.push(xe)}this.server.registerChannel("telemetryAppender",new pe.TelemetryAppenderChannel(Qe)),ve.set(we.ITelemetryService,rt);const At=new De.CustomEndpointTelemetryService(Be,rt,Xe,Ne);ve.set(we.ICustomEndpointTelemetryService,At),ve.set(g.IExtensionManagementService,new Z.SyncDescriptor(M.ExtensionManagementService)),ve.set(g.IExtensionGalleryService,new Z.SyncDescriptor(u.ExtensionGalleryService)),ve.set(g.IExtensionTipsService,new Z.SyncDescriptor(_.ExtensionTipsService)),ve.set(V.ILocalizationsService,new Z.SyncDescriptor(J.LocalizationsService)),ve.set(r.IDiagnosticsService,new Z.SyncDescriptor(c.DiagnosticsService)),ve.set(le.IUserDataSyncAccountService,new Z.SyncDescriptor(le.UserDataSyncAccountService)),ve.set(ae.IUserDataSyncLogService,new Z.SyncDescriptor(Ue.UserDataSyncLogService)),ve.set(ae.IUserDataSyncUtilService,new be.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",xe=>xe.ctx!=="main"))),ve.set(g.IGlobalExtensionEnablementService,new Z.SyncDescriptor(a.GlobalExtensionEnablementService)),ve.set(re.IIgnoredExtensionsManagementService,new Z.SyncDescriptor(re.IgnoredExtensionsManagementService)),ve.set(je.IExtensionStorageService,new Z.SyncDescriptor(je.ExtensionStorageService)),ve.set(ae.IUserDataSyncStoreManagementService,new Z.SyncDescriptor(oe.UserDataSyncStoreManagementService)),ve.set(ae.IUserDataSyncStoreService,new Z.SyncDescriptor(oe.UserDataSyncStoreService)),ve.set(Le.IUserDataSyncMachinesService,new Z.SyncDescriptor(Le.UserDataSyncMachinesService)),ve.set(ae.IUserDataSyncBackupStoreService,new Z.SyncDescriptor(ye.UserDataSyncBackupStoreService)),ve.set(ae.IUserDataSyncEnablementService,new Z.SyncDescriptor(Oe.UserDataSyncEnablementService)),ve.set(ae.IUserDataSyncService,new Z.SyncDescriptor(_e.UserDataSyncService));const wt=new He.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Be.getValue("terminal.integrated.persistentSessionScrollback")??100},Be,Ne,Ke);return await wt.initialize(),ve.set(Je.ILocalPtyService,this._register(wt)),ve.set(me.ISignService,new Z.SyncDescriptor(ke.SignService)),ve.set(Se.ISharedTunnelsService,new Z.SyncDescriptor(Pe.SharedTunnelsService)),ve.set(Re.ISharedProcessTunnelService,new Z.SyncDescriptor(Ie.SharedProcessTunnelService)),new ee.InstantiationService(ve)}initChannels(ve){const Me=new I.ExtensionManagementChannel(ve.get(g.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const $e=P.ProxyChannel.fromService(ve.get(V.ILocalizationsService));this.server.registerChannel("localizations",$e);const Ge=P.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const Ne=new I.ExtensionTipsChannel(ve.get(g.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const nt=P.ProxyChannel.fromService(ve.get(w.IChecksumService));this.server.registerChannel("checksum",nt);const Xe=P.ProxyChannel.fromService(ve.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new be.UserDataSyncMachinesServiceChannel(ve.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Ke=P.ProxyChannel.fromService(ve.get(we.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ke);const Ye=new be.UserDataSyncAccountServiceChannel(ve.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ye);const at=new be.UserDataSyncStoreManagementServiceChannel(ve.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new X.UserDataSyncChannel(ve.get(ae.IUserDataSyncService),ve.get(Q.ILogService));this.server.registerChannel("userDataSync",ct);const Be=this._register(ve.get(W.IInstantiationService).createInstance(ce.UserDataAutoSyncService)),et=new be.UserDataAutoSyncChannel(Be);this.server.registerChannel("userDataAutoSync",et);const it=ve.get(Je.ILocalPtyService),lt=P.ProxyChannel.fromService(it);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(ve.get(Re.ISharedProcessTunnelService));this.server.registerChannel(Re.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(ve.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,T.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Me=>{const $e=(0,L.toErrorMessage)(Me,!0);!$e||ve.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Tt(yt){const ve=new Lt(yt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d6ecda7ef2c306253594b196b18ab74caa6016cd/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
