/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],we=function(te){for(var e=[],f=0,t=te.length;f<t;f++)e[f]=ve[te[f]];return e};define(ve[55],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(t,I){if(!t)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=f}),define(ve[72],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function f(C){return C?C.replace(/\$\((.*?)\)/g,(k,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=f;class t{constructor(k,S,R){this.id=k,this.definition=S,this.description=R,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(C,k){const S=["codicon","codicon-"+C];return k&&S.push("codicon-modifier-"+k),S}e.getClassNamesArray=I;var T;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function S(D){if(D instanceof t)return["codicon","codicon-"+D.id];const p=k.exec(D.id);if(!p)return S(t.error);let[,b,g]=p;const h=["codicon","codicon-"+b];return g&&h.push("codicon-modifier-"+g.substr(1)),h}C.asClassNameArray=S;function R(D){return S(D).join(" ")}C.asClassName=R;function F(D){return"."+S(D).join(".")}C.asCSSSelector=F})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ve[73],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function t(F){const D=[];for(let p in F)f.call(F,p)&&D.push(F[p]);return D}e.values=t;function I(F,D){for(let p in F)if(f.call(F,p)&&D({key:p,value:F[p]},function(){delete F[p]})===!1)return}e.forEach=I;function T(F,D){const p=Object.create(null);for(const b of F){const g=D(b);let h=p[g];h||(h=p[g]=[]),h.push(b)}return p}e.groupBy=T;function C(F){const D=Object.create(null);return F&&F.forEach((p,b)=>{D[b]=p}),D}e.fromMap=C;function k(F,D){const p=[],b=[];for(let g of F)D.has(g)||p.push(g);for(let g of D)F.has(g)||b.push(g);return{removed:p,added:b}}e.diffSets=k;function S(F,D){const p=[],b=[];for(let[g,h]of F)D.has(g)||p.push(h);for(let[g,h]of D)F.has(g)||b.push(h);return{removed:p,added:b}}e.diffMaps=S;class R{constructor(){this.map=new Map}add(D,p){let b=this.map.get(D);b||(b=new Set,this.map.set(D,b)),b.add(p)}delete(D,p){const b=this.map.get(D);!b||(b.delete(p),b.size===0&&this.map.delete(D))}forEach(D,p){const b=this.map.get(D);!b||b.forEach(p)}}e.SetMap=R}),define(ve[56],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(C){return(k,S,R)=>{let F=null,D=null;if(typeof R.value=="function"?(F="value",D=R.value):typeof R.get=="function"&&(F="get",D=R.get),!D)throw new Error("not supported");R[F]=C(D,S)}}e.createDecorator=f;function t(C,k,S){let R=null,F=null;if(typeof S.value=="function"?(R="value",F=S.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(R="get",F=S.get),!F)throw new Error("not supported");const D=`$memoize$${k}`;S[R]=function(...p){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,p)}),this[D]}}e.memoize=t;function I(C,k,S){return f((R,F)=>{const D=`$debounce$${F}`,p=`$debounce$result$${F}`;return function(...b){this[p]||(this[p]=S?S():void 0),clearTimeout(this[D]),k&&(this[p]=k(this[p],...b),b=[this[p]]),this[D]=setTimeout(()=>{R.apply(this,b),this[p]=S?S():void 0},C)}})}e.debounce=I;function T(C,k,S){return f((R,F)=>{const D=`$throttle$timer$${F}`,p=`$throttle$result$${F}`,b=`$throttle$lastRun$${F}`,g=`$throttle$pending$${F}`;return function(...h){if(this[p]||(this[p]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),k&&(this[p]=k(this[p],...h)),this[g])return;const v=this[b]+C;v<=Date.now()?(this[b]=Date.now(),R.apply(this,[this[p]]),this[p]=S?S():void 0):(this[g]=!0,this[D]=setTimeout(()=>{this[g]=!1,this[b]=Date.now(),R.apply(this,[this[p]]),this[p]=S?S():void 0},v-Date.now()))}})}e.throttle=T}),define(ve[15],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(c=>{c(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=f,e.errorHandler=new f;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function I(l){S(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=I;function T(l){S(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function C(l){if(l instanceof Error){let{name:u,message:c}=l;const w=l.stacktrace||l.stack;return{$isError:!0,name:u,message:c,stack:w}}return l}e.transformErrorForSerialization=C;const k="Canceled";function S(l){return l instanceof R?!0:l instanceof Error&&l.name===k&&l.message===k}e.isCancellationError=S;class R extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=R;function F(){const l=new Error(k);return l.name=l.message,l}e.canceled=F;function D(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=D;function p(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=p;function b(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function g(l){const u=new Error(`${l} has been disposed`);return u.name="DISPOSED",u}e.disposed=g;function h(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=h;class v extends Error{constructor(u){super("NotImplemented");u&&(this.message=u)}}e.NotImplementedError=v;class A extends Error{constructor(u){super("NotSupported");u&&(this.message=u)}}e.NotSupportedError=A;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;class a extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=a}),define(ve[18],we([1,0,15]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(Z,Y=0){return Z[Z.length-(1+Y)]}e.tail=t;function I(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=I;function T(Z,Y,se=(de,ge)=>de===ge){if(Z===Y)return!0;if(!Z||!Y||Z.length!==Y.length)return!1;for(let de=0,ge=Z.length;de<ge;de++)if(!se(Z[de],Y[de]))return!1;return!0}e.equals=T;function C(Z,Y,se){let de=0,ge=Z.length-1;for(;de<=ge;){const Te=(de+ge)/2|0,Ne=se(Z[Te],Y);if(Ne<0)de=Te+1;else if(Ne>0)ge=Te-1;else return Te}return-(de+1)}e.binarySearch=C;function k(Z,Y){let se=0,de=Z.length;if(de===0)return 0;for(;se<de;){const ge=Math.floor((se+de)/2);Y(Z[ge])?de=ge:se=ge+1}return se}e.findFirstInSorted=k;function S(Z,Y,se){if(Z=Z|0,Z>=Y.length)throw new TypeError("invalid index");let de=Y[Math.floor(Y.length*Math.random())],ge=[],Te=[],Ne=[];for(let be of Y){const Ee=se(be,de);Ee<0?ge.push(be):Ee>0?Te.push(be):Ne.push(be)}return Z<ge.length?S(Z,ge,se):Z<ge.length+Ne.length?Ne[0]:S(Z-(ge.length+Ne.length),Te,se)}e.quickSelect=S;function R(Z,Y){const se=[];let de;for(const ge of Z.slice(0).sort(Y))!de||Y(de[0],ge)!==0?(de=[ge],se.push(de)):de.push(ge);return se}e.groupBy=R;function F(Z,Y,se){const de=[];function ge(be,Ee,z){if(Ee===0&&z.length===0)return;const B=de[de.length-1];B&&B.start+B.deleteCount===be?(B.deleteCount+=Ee,B.toInsert.push(...z)):de.push({start:be,deleteCount:Ee,toInsert:z})}let Te=0,Ne=0;for(;;){if(Te===Z.length){ge(Te,0,Y.slice(Ne));break}if(Ne===Y.length){ge(Te,Z.length-Te,[]);break}const be=Z[Te],Ee=Y[Ne],z=se(be,Ee);z===0?(Te+=1,Ne+=1):z<0?(ge(Te,1,[]),Te+=1):z>0&&(ge(Te,0,[Ee]),Ne+=1)}return de}e.sortedDiff=F;function D(Z,Y,se){const de=F(Z,Y,se),ge=[],Te=[];for(const Ne of de)ge.push(...Z.slice(Ne.start,Ne.start+Ne.deleteCount)),Te.push(...Ne.toInsert);return{removed:ge,added:Te}}e.delta=D;function p(Z,Y,se){if(se===0)return[];const de=Z.slice(0,se).sort(Y);return g(Z,Y,de,se,Z.length),de}e.top=p;function b(Z,Y,se,de,ge){return se===0?Promise.resolve([]):new Promise((Te,Ne)=>{(async()=>{const be=Z.length,Ee=Z.slice(0,se).sort(Y);for(let z=se,B=Math.min(se+de,be);z<be;z=B,B=Math.min(B+de,be)){if(z>se&&await new Promise(N=>setTimeout(N)),ge&&ge.isCancellationRequested)throw(0,f.canceled)();g(Z,Y,Ee,z,B)}return Ee})().then(Te,Ne)})}e.topAsync=b;function g(Z,Y,se,de,ge){for(const Te=se.length;de<ge;de++){const Ne=Z[de];if(Y(Ne,se[Te-1])<0){se.pop();const be=k(se,Ee=>Y(Ne,Ee)<0);se.splice(be,0,Ne)}}}function h(Z){return Z.filter(Y=>!!Y)}e.coalesce=h;function v(Z){let Y=0;for(let se=0;se<Z.length;se++)Z[se]&&(Z[Y]=Z[se],Y+=1);Z.length=Y}e.coalesceInPlace=v;function A(Z,Y,se){Z.splice(se,0,Z.splice(Y,1)[0])}e.move=A;function _(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=_;function a(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=a;function l(Z,Y=se=>se){const se=new Set;return Z.filter(de=>{const ge=Y(de);return se.has(ge)?!1:(se.add(ge),!0)})}e.distinct=l;function u(Z){const Y=new Set;return se=>{const de=Z(se);return Y.has(de)?!1:(Y.add(de),!0)}}e.uniqueFilter=u;function c(Z,Y){const se=w(Z,Y);if(se!==-1)return Z[se]}e.findLast=c;function w(Z,Y){for(let se=Z.length-1;se>=0;se--){const de=Z[se];if(Y(de))return se}return-1}e.lastIndex=w;function s(Z,Y){return Z.length>0?Z[0]:Y}e.firstOrDefault=s;function n(Z,Y,se=(de,ge)=>de===ge){let de=0;for(let ge=0,Te=Math.min(Z.length,Y.length);ge<Te&&se(Z[ge],Y[ge]);ge++)de++;return de}e.commonPrefixLength=n;function r(Z){return[].concat(...Z)}e.flatten=r;function i(Z,Y){let se=typeof Y=="number"?Z:0;typeof Y=="number"?se=Z:(se=0,Y=Z);const de=[];if(se<=Y)for(let ge=se;ge<Y;ge++)de.push(ge);else for(let ge=se;ge>Y;ge--)de.push(ge);return de}e.range=i;function o(Z,Y,se){return Z.reduce((de,ge)=>(de[Y(ge)]=se?se(ge):ge,de),Object.create(null))}e.index=o;function m(Z,Y){return Z.push(Y),()=>d(Z,Y)}e.insert=m;function d(Z,Y){const se=Z.indexOf(Y);if(se>-1)return Z.splice(se,1),Y}e.remove=d;function E(Z,Y,se){const de=Z.slice(0,Y),ge=Z.slice(Y);return de.concat(se,ge)}e.arrayInsert=E;function P(Z,Y){let se;if(typeof Y=="number"){let de=Y;se=()=>{const ge=Math.sin(de++)*179426549;return ge-Math.floor(ge)}}else se=Math.random;for(let de=Z.length-1;de>0;de-=1){const ge=Math.floor(se()*(de+1)),Te=Z[de];Z[de]=Z[ge],Z[ge]=Te}}e.shuffle=P;function L(Z,Y){const se=Z.indexOf(Y);se>-1&&(Z.splice(se,1),Z.unshift(Y))}e.pushToStart=L;function O(Z,Y){const se=Z.indexOf(Y);se>-1&&(Z.splice(se,1),Z.push(Y))}e.pushToEnd=O;function y(Z,Y){return Array.isArray(Z)?Z.map(Y):Y(Z)}e.mapArrayOrNot=y;function H(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=H;function M(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=M;function j(Z,Y){for(const se of Z){const de=Y(se);if(de!==void 0)return de}}e.mapFind=j;function Q(Z,Y,se){const de=U(Z,Y),ge=Z.length,Te=se.length;Z.length=ge+Te;for(let Ne=ge-1;Ne>=de;Ne--)Z[Ne+Te]=Z[Ne];for(let Ne=0;Ne<Te;Ne++)Z[Ne+de]=se[Ne]}e.insertInto=Q;function $(Z,Y,se,de){const ge=U(Z,Y),Te=Z.splice(ge,se);return Q(Z,ge,de),Te}e.splice=$;function U(Z,Y){return Y<0?Math.max(Y+Z.length,0):Math.min(Y,Z.length)}function q(Z,Y){return(se,de)=>Y(Z(se),Z(de))}e.compareBy=q;const K=(Z,Y)=>Z-Y;e.numberComparator=K;function G(Z,Y){if(Z.length===0)return;let se=Z[0];for(let de=1;de<Z.length;de++){const ge=Z[de];Y(ge,se)>0&&(se=ge)}return se}e.findMaxBy=G;function ee(Z,Y){if(Z.length===0)return;let se=Z[0];for(let de=1;de<Z.length;de++){const ge=Z[de];Y(ge,se)>=0&&(se=ge)}return se}e.findLastMaxBy=ee;function oe(Z,Y){return G(Z,(se,de)=>-Y(se,de))}e.findMinBy=oe;class ue{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let se=this.firstIdx;for(;se<this.items.length&&Y(this.items[se]);)se++;const de=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,de}takeFromEndWhile(Y){let se=this.lastIdx;for(;se>=0&&Y(this.items[se]);)se--;const de=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,de}peek(){return this.items[this.firstIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}takeCount(Y){const se=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,se}}e.ArrayQueue=ue}),define(ve[74],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(t){const I=this;let T=!1,C;return function(){return T||(T=!0,C=t.apply(I,arguments)),C}}e.once=f}),define(ve[75],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(ve[76],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(t){function I(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=I;const T=Object.freeze([]);function C(){return T}t.empty=C;function*k(u){yield u}t.single=k;function S(u){return u||T}t.from=S;function R(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=R;function F(u){return u[Symbol.iterator]().next().value}t.first=F;function D(u,c){for(const w of u)if(c(w))return!0;return!1}t.some=D;function p(u,c){for(const w of u)if(c(w))return w}t.find=p;function*b(u,c){for(const w of u)c(w)&&(yield w)}t.filter=b;function*g(u,c){let w=0;for(const s of u)yield c(s,w++)}t.map=g;function*h(...u){for(const c of u)for(const w of c)yield w}t.concat=h;function*v(u){for(const c of u)for(const w of c)yield w}t.concatNested=v;function A(u,c,w){let s=w;for(const n of u)s=c(s,n);return s}t.reduce=A;function*_(u,c,w=u.length){for(c<0&&(c+=u.length),w<0?w+=u.length:w>u.length&&(w=u.length);c<w;c++)yield u[c]}t.slice=_;function a(u,c=Number.POSITIVE_INFINITY){const w=[];if(c===0)return[w,u];const s=u[Symbol.iterator]();for(let n=0;n<c;n++){const r=s.next();if(r.done)return[w,t.empty()];w.push(r.value)}return[w,{[Symbol.iterator](){return s}}]}t.consume=a;function l(u,c,w=(s,n)=>s===n){const s=u[Symbol.iterator](),n=c[Symbol.iterator]();for(;;){const r=s.next(),i=n.next();if(r.done!==i.done)return!1;if(r.done)return!0;if(!w(r.value,i.value))return!1}}t.equals=l})(f=e.Iterable||(e.Iterable={}))}),define(ve[141],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var t;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(c){c.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function C(c,w=!1){let s=0,n=c.length,r="",i=0,o=16,m=0;function d(M){let j=0,Q=0;for(;j<M;){const $=c.charCodeAt(s);if($>=48&&$<=57)Q=Q*16+$-48;else if($>=65&&$<=70)Q=Q*16+$-65+10;else if($>=97&&$<=102)Q=Q*16+$-97+10;else break;s++,j++}return j<M&&(Q=-1),Q}function E(M){s=M,r="",i=0,o=16,m=0}function P(){const M=s;if(c.charCodeAt(s)===48)s++;else for(s++;s<c.length&&R(c.charCodeAt(s));)s++;if(s<c.length&&c.charCodeAt(s)===46)if(s++,s<c.length&&R(c.charCodeAt(s)))for(s++;s<c.length&&R(c.charCodeAt(s));)s++;else return m=3,c.substring(M,s);let j=s;if(s<c.length&&(c.charCodeAt(s)===69||c.charCodeAt(s)===101))if(s++,(s<c.length&&c.charCodeAt(s)===43||c.charCodeAt(s)===45)&&s++,s<c.length&&R(c.charCodeAt(s))){for(s++;s<c.length&&R(c.charCodeAt(s));)s++;j=s}else m=3;return c.substring(M,j)}function L(){let M="",j=s;for(;;){if(s>=n){M+=c.substring(j,s),m=2;break}const Q=c.charCodeAt(s);if(Q===34){M+=c.substring(j,s),s++;break}if(Q===92){if(M+=c.substring(j,s),s++,s>=n){m=2;break}switch(c.charCodeAt(s++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const U=d(4);U>=0?M+=String.fromCharCode(U):m=4;break}default:m=5}j=s;continue}if(Q>=0&&Q<=31)if(S(Q)){M+=c.substring(j,s),m=2;break}else m=6;s++}return M}function O(){if(r="",m=0,i=s,s>=n)return i=n,o=17;let M=c.charCodeAt(s);if(k(M)){do s++,r+=String.fromCharCode(M),M=c.charCodeAt(s);while(k(M));return o=15}if(S(M))return s++,r+=String.fromCharCode(M),M===13&&c.charCodeAt(s)===10&&(s++,r+=`
`),o=14;switch(M){case 123:return s++,o=1;case 125:return s++,o=2;case 91:return s++,o=3;case 93:return s++,o=4;case 58:return s++,o=6;case 44:return s++,o=5;case 34:return s++,r=L(),o=10;case 47:{const j=s-1;if(c.charCodeAt(s+1)===47){for(s+=2;s<n&&!S(c.charCodeAt(s));)s++;return r=c.substring(j,s),o=12}if(c.charCodeAt(s+1)===42){s+=2;const Q=n-1;let $=!1;for(;s<Q;){if(c.charCodeAt(s)===42&&c.charCodeAt(s+1)===47){s+=2,$=!0;break}s++}return $||(s++,m=1),r=c.substring(j,s),o=13}return r+=String.fromCharCode(M),s++,o=16}case 45:if(r+=String.fromCharCode(M),s++,s===n||!R(c.charCodeAt(s)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=P(),o=11;default:for(;s<n&&y(M);)s++,M=c.charCodeAt(s);if(i!==s){switch(r=c.substring(i,s),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(M),s++,o=16}}function y(M){if(k(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:E,getPosition:()=>s,scan:w?H:O,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>i,getTokenLength:()=>s-i,getTokenError:()=>m}}e.createScanner=C;function k(c){return c===32||c===9||c===11||c===12||c===160||c===5760||c>=8192&&c<=8203||c===8239||c===8287||c===12288||c===65279}function S(c){return c===10||c===13||c===8232||c===8233}function R(c){return c>=48&&c<=57}var F;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(F||(F={}));function D(c,w){const s=[],n=new Object;let r;const i={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function m(d,E,P,L){i.value=d,i.offset=E,i.length=P,i.type=L,i.colonOffset=void 0,r=i}try{a(c,{onObjectBegin:(d,E)=>{if(w<=d)throw n;r=void 0,o=w>d,s.push("")},onObjectProperty:(d,E,P)=>{if(w<E||(m(d,E,P,"property"),s[s.length-1]=d,w<=E+P))throw n},onObjectEnd:(d,E)=>{if(w<=d)throw n;r=void 0,s.pop()},onArrayBegin:(d,E)=>{if(w<=d)throw n;r=void 0,s.push(0)},onArrayEnd:(d,E)=>{if(w<=d)throw n;r=void 0,s.pop()},onLiteralValue:(d,E,P)=>{if(w<E||(m(d,E,P,u(d)),w<=E+P))throw n},onSeparator:(d,E,P)=>{if(w<=E)throw n;if(d===":"&&r&&r.type==="property")r.colonOffset=E,o=!1,r=void 0;else if(d===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(o=!0,s[s.length-1]=""),r=void 0}}})}catch(d){if(d!==n)throw d}return{path:s,previousNode:r,isAtPropertyKey:o,matches:d=>{let E=0;for(let P=0;E<d.length&&P<s.length;P++)if(d[E]===s[P]||d[E]==="*")E++;else if(d[E]!=="**")return!1;return E===d.length}}}e.getLocation=D;function p(c,w=[],s=T.DEFAULT){let n=null,r=[];const i=[];function o(d){Array.isArray(r)?r.push(d):n!==null&&(r[n]=d)}return a(c,{onObjectBegin:()=>{const d={};o(d),i.push(r),r=d,n=null},onObjectProperty:d=>{n=d},onObjectEnd:()=>{r=i.pop()},onArrayBegin:()=>{const d=[];o(d),i.push(r),r=d,n=null},onArrayEnd:()=>{r=i.pop()},onLiteralValue:o,onError:(d,E,P)=>{w.push({error:d,offset:E,length:P})}},s),r[0]}e.parse=p;function b(c,w=[],s=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(d){n.type==="property"&&(n.length=d-n.offset,n=n.parent)}function i(d){return n.children.push(d),d}a(c,{onObjectBegin:d=>{n=i({type:"object",offset:d,length:-1,parent:n,children:[]})},onObjectProperty:(d,E,P)=>{n=i({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:d,offset:E,length:P,parent:n})},onObjectEnd:(d,E)=>{n.length=d+E-n.offset,n=n.parent,r(d+E)},onArrayBegin:(d,E)=>{n=i({type:"array",offset:d,length:-1,parent:n,children:[]})},onArrayEnd:(d,E)=>{n.length=d+E-n.offset,n=n.parent,r(d+E)},onLiteralValue:(d,E,P)=>{i({type:u(d),offset:E,length:P,parent:n,value:d}),r(E+P)},onSeparator:(d,E,P)=>{n.type==="property"&&(d===":"?n.colonOffset=E:d===","&&r(E))},onError:(d,E,P)=>{w.push({error:d,offset:E,length:P})}},s);const m=n.children[0];return m&&delete m.parent,m}e.parseTree=b;function g(c,w){if(!c)return;let s=c;for(let n of w)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const i of s.children)if(Array.isArray(i.children)&&i.children[0].value===n){s=i.children[1],r=!0;break}if(!r)return}else{const r=n;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=g;function h(c){if(!c.parent||!c.parent.children)return[];const w=h(c.parent);if(c.parent.type==="property"){const s=c.parent.children[0].value;w.push(s)}else if(c.parent.type==="array"){const s=c.parent.children.indexOf(c);s!==-1&&w.push(s)}return w}e.getNodePath=h;function v(c){switch(c.type){case"array":return c.children.map(v);case"object":{const w=Object.create(null);for(let s of c.children){const n=s.children[1];n&&(w[s.children[0].value]=v(n))}return w}case"null":case"string":case"number":case"boolean":return c.value;default:return}}e.getNodeValue=v;function A(c,w,s=!1){return w>=c.offset&&w<c.offset+c.length||s&&w===c.offset+c.length}e.contains=A;function _(c,w,s=!1){if(A(c,w,s)){const n=c.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=w;r++){const i=_(n[r],w,s);if(i)return i}return c}}e.findNodeAtOffset=_;function a(c,w,s=T.DEFAULT){const n=C(c,!1);function r(ue){return ue?()=>ue(n.getTokenOffset(),n.getTokenLength()):()=>!0}function i(ue){return ue?Z=>ue(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=r(w.onObjectBegin),m=i(w.onObjectProperty),d=r(w.onObjectEnd),E=r(w.onArrayBegin),P=r(w.onArrayEnd),L=i(w.onLiteralValue),O=i(w.onSeparator),y=r(w.onComment),H=i(w.onError),M=s&&s.disallowComments,j=s&&s.allowTrailingComma;function Q(){for(;;){const ue=n.scan();switch(n.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:M||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ue){case 12:case 13:M?$(10):y();break;case 16:$(1);break;case 15:case 14:break;default:return ue}}}function $(ue,Z=[],Y=[]){if(H(ue),Z.length+Y.length>0){let se=n.getToken();for(;se!==17;){if(Z.indexOf(se)!==-1){Q();break}else if(Y.indexOf(se)!==-1)break;se=Q()}}}function U(ue){const Z=n.getTokenValue();return ue?L(Z):m(Z),Q(),!0}function q(){switch(n.getToken()){case 11:{let ue=0;try{ue=JSON.parse(n.getTokenValue()),typeof ue!="number"&&($(2),ue=0)}catch{$(2)}L(ue);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return Q(),!0}function K(){return n.getToken()!==10?($(3,[],[2,5]),!1):(U(!1),n.getToken()===6?(O(":"),Q(),oe()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function G(){o(),Q();let ue=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ue||$(4,[],[]),O(","),Q(),n.getToken()===2&&j)break}else ue&&$(6,[],[]);K()||$(4,[],[2,5]),ue=!0}return d(),n.getToken()!==2?$(7,[2],[]):Q(),!0}function ee(){E(),Q();let ue=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ue||$(4,[],[]),O(","),Q(),n.getToken()===4&&j)break}else ue&&$(6,[],[]);oe()||$(4,[],[4,5]),ue=!0}return P(),n.getToken()!==4?$(8,[4],[]):Q(),!0}function oe(){switch(n.getToken()){case 3:return ee();case 1:return G();case 10:return U(!0);default:return q()}}return Q(),n.getToken()===17?s.allowEmptyContent?!0:($(4,[],[]),!1):oe()?(n.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=a;function l(c,w){let s=C(c),n=[],r,i=0,o;do switch(o=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:i!==o&&n.push(c.substring(i,o)),w!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,w)),i=s.getPosition();break}while(r!==17);return n.join("")}e.stripComments=l;function u(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ve[89],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new f(()=>I(this.getValue()))}}e.Lazy=f}),define(ve[6],we([1,0,74,76]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let T=null;function C(r){T=r}if(e.setDisposableTracker=C,I){const r="__is_disposable_tracked__";C(new class{trackDisposable(i){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(o)},3e3)}setParent(i,o){if(i&&i!==_.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==_.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function k(r){return T?.trackDisposable(r),r}function S(r){T?.markAsDisposed(r)}function R(r,i){T?.setParent(r,i)}function F(r,i){if(!!T)for(const o of r)T.setParent(o,i)}function D(r){return T?.markAsSingleton(r),r}e.markAsSingleton=D;class p extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=p;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=b;function g(r){if(t.Iterable.is(r)){let i=[];for(const o of r)if(o)try{o.dispose()}catch(m){i.push(m)}if(i.length===1)throw i[0];if(i.length>1)throw new p(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=g;function h(...r){const i=v(()=>g(r));return F(r,i),i}e.combinedDisposable=h;function v(r){const i=k({dispose:(0,f.once)(()=>{S(i),r()})});return i}e.toDisposable=v;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return R(i,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new A,k(this),R(this._store,this)}dispose(){S(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&R(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&R(i,null),i}}e.MutableDisposable=a;class l{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(i){let o=i;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,S(this))},this}}e.SafeDisposable=u;class c{constructor(){this.references=new Map}acquire(i,...o){let m=this.references.get(i);m||(m={counter:0,object:this.createReferencedObject(i,...o)},this.references.set(i,m));const{object:d}=m,E=(0,f.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(i,m.object),this.references.delete(i))});return m.counter++,{object:d,dispose:E}}}e.ReferenceCollection=c;class w{constructor(i){this.referenceCollection=i}async acquire(i,...o){const m=this.referenceCollection.acquire(i,...o);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(d){throw m.dispose(),d}}}e.AsyncReferenceCollection=w;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s;function n(r){const i=new A;try{r(i)}finally{i.dispose()}}e.disposeOnReturn=n}),define(ve[90],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(T){this.element=T,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class t{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let T=this._first;for(;T!==f.Undefined;){const C=T.next;T.prev=f.Undefined,T.next=f.Undefined,T=C}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,C){const k=new f(T);if(this._first===f.Undefined)this._first=k,this._last=k;else if(C){const R=this._last;this._last=k,k.prev=R,R.next=k}else{const R=this._first;this._first=k,k.next=R,R.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==f.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==f.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==f.Undefined&&T.next!==f.Undefined){const C=T.prev;C.next=T.next,T.next.prev=C}else T.prev===f.Undefined&&T.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):T.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):T.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==f.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[142],we([0]),e):(te=typeof globalThis!="undefined"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(be,Ee){for(var z=0;z<Ee.length;z++){var B=Ee[z];B.enumerable=B.enumerable||!1,B.configurable=!0,"value"in B&&(B.writable=!0),Object.defineProperty(be,B.key,B)}}function f(be,Ee,z){return Ee&&e(be.prototype,Ee),z&&e(be,z),Object.defineProperty(be,"prototype",{writable:!1}),be}function t(be,Ee){if(!!be){if(typeof be=="string")return I(be,Ee);var z=Object.prototype.toString.call(be).slice(8,-1);if(z==="Object"&&be.constructor&&(z=be.constructor.name),z==="Map"||z==="Set")return Array.from(be);if(z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(z))return I(be,Ee)}}function I(be,Ee){(Ee==null||Ee>be.length)&&(Ee=be.length);for(var z=0,B=new Array(Ee);z<Ee;z++)B[z]=be[z];return B}function T(be,Ee){var z=typeof Symbol!="undefined"&&be[Symbol.iterator]||be["@@iterator"];if(z)return(z=z.call(be)).next.bind(z);if(Array.isArray(be)||(z=t(be))||Ee&&be&&typeof be.length=="number"){z&&(be=z);var B=0;return function(){return B>=be.length?{done:!0}:{done:!1,value:be[B++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=C();function k(be){te.defaults=be}var S=/[&<>"']/,R=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ee){return p[Ee]};function g(be,Ee){if(Ee){if(S.test(be))return be.replace(R,b)}else if(F.test(be))return be.replace(D,b);return be}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(be){return be.replace(h,function(Ee,z){return z=z.toLowerCase(),z==="colon"?":":z.charAt(0)==="#"?z.charAt(1)==="x"?String.fromCharCode(parseInt(z.substring(2),16)):String.fromCharCode(+z.substring(1)):""})}var A=/(^|[^\[])\^/g;function _(be,Ee){be=be.source||be,Ee=Ee||"";var z={replace:function(N,W){return W=W.source||W,W=W.replace(A,"$1"),be=be.replace(N,W),z},getRegex:function(){return new RegExp(be,Ee)}};return z}var a=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(be,Ee,z){if(be){var B;try{B=decodeURIComponent(v(z)).replace(a,"").toLowerCase()}catch{return null}if(B.indexOf("javascript:")===0||B.indexOf("vbscript:")===0||B.indexOf("data:")===0)return null}Ee&&!l.test(z)&&(z=r(Ee,z));try{z=encodeURI(z).replace(/%25/g,"%")}catch{return null}return z}var c={},w=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(be,Ee){c[" "+be]||(w.test(be)?c[" "+be]=be+"/":c[" "+be]=d(be,"/",!0)),be=c[" "+be];var z=be.indexOf(":")===-1;return Ee.substring(0,2)==="//"?z?Ee:be.replace(s,"$1")+Ee:Ee.charAt(0)==="/"?z?Ee:be.replace(n,"$1")+Ee:be+Ee}var i={exec:function(){}};function o(be){for(var Ee=1,z,B;Ee<arguments.length;Ee++){z=arguments[Ee];for(B in z)Object.prototype.hasOwnProperty.call(z,B)&&(be[B]=z[B])}return be}function m(be,Ee){var z=be.replace(/\|/g,function(W,V,re){for(var he=!1,Ce=V;--Ce>=0&&re[Ce]==="\\";)he=!he;return he?"|":" |"}),B=z.split(/ \|/),N=0;if(B[0].trim()||B.shift(),B[B.length-1].trim()||B.pop(),B.length>Ee)B.splice(Ee);else for(;B.length<Ee;)B.push("");for(;N<B.length;N++)B[N]=B[N].trim().replace(/\\\|/g,"|");return B}function d(be,Ee,z){var B=be.length;if(B===0)return"";for(var N=0;N<B;){var W=be.charAt(B-N-1);if(W===Ee&&!z)N++;else if(W!==Ee&&z)N++;else break}return be.substr(0,B-N)}function E(be,Ee){if(be.indexOf(Ee[1])===-1)return-1;for(var z=be.length,B=0,N=0;N<z;N++)if(be[N]==="\\")N++;else if(be[N]===Ee[0])B++;else if(be[N]===Ee[1]&&(B--,B<0))return N;return-1}function P(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(be,Ee){if(Ee<1)return"";for(var z="";Ee>1;)Ee&1&&(z+=be),Ee>>=1,be+=be;return z+be}function O(be,Ee,z,B){var N=Ee.href,W=Ee.title?g(Ee.title):null,V=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){B.state.inLink=!0;var re={type:"link",raw:z,href:N,title:W,text:V,tokens:B.inlineTokens(V,[])};return B.state.inLink=!1,re}else return{type:"image",raw:z,href:N,title:W,text:g(V)}}function y(be,Ee){var z=be.match(/^(\s+)(?:```)/);if(z===null)return Ee;var B=z[1];return Ee.split(`
`).map(function(N){var W=N.match(/^\s+/);if(W===null)return N;var V=W[0];return V.length>=B.length?N.slice(B.length):N}).join(`
`)}var H=function(){function be(z){this.options=z||te.defaults}var Ee=be.prototype;return Ee.space=function(B){var N=this.rules.block.newline.exec(B);if(N&&N[0].length>0)return{type:"space",raw:N[0]}},Ee.code=function(B){var N=this.rules.block.code.exec(B);if(N){var W=N[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:N[0],codeBlockStyle:"indented",text:this.options.pedantic?W:d(W,`
`)}}},Ee.fences=function(B){var N=this.rules.block.fences.exec(B);if(N){var W=N[0],V=y(W,N[3]||"");return{type:"code",raw:W,lang:N[2]?N[2].trim():N[2],text:V}}},Ee.heading=function(B){var N=this.rules.block.heading.exec(B);if(N){var W=N[2].trim();if(/#$/.test(W)){var V=d(W,"#");(this.options.pedantic||!V||/ $/.test(V))&&(W=V.trim())}var re={type:"heading",raw:N[0],depth:N[1].length,text:W,tokens:[]};return this.lexer.inline(re.text,re.tokens),re}},Ee.hr=function(B){var N=this.rules.block.hr.exec(B);if(N)return{type:"hr",raw:N[0]}},Ee.blockquote=function(B){var N=this.rules.block.blockquote.exec(B);if(N){var W=N[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:N[0],tokens:this.lexer.blockTokens(W,[]),text:W}}},Ee.list=function(B){var N=this.rules.block.list.exec(B);if(N){var W,V,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et=N[1].trim(),Le=et.length>1,it={type:"list",raw:"",ordered:Le,start:Le?+et.slice(0,-1):"",loose:!1,items:[]};et=Le?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=Le?et:"[*+-]");for(var ne=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");B&&(Je=!1,!(!(N=ne.exec(B))||this.rules.block.hr.test(B)));){if(W=N[0],B=B.substring(W.length),ze=N[2].split(`
`,1)[0],qe=B.split(`
`,1)[0],this.options.pedantic?(he=2,Ue=ze.trimLeft()):(he=N[2].search(/[^ ]/),he=he>4?1:he,Ue=ze.slice(he),he+=N[1].length),Ae=!1,!ze&&/^ *$/.test(qe)&&(W+=qe+`
`,B=B.substring(qe.length+1),Je=!0),!Je)for(var ae=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])");B&&(He=B.split(`
`,1)[0],ze=He,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!ae.test(ze));){if(ze.search(/[^ ]/)>=he||!ze.trim())Ue+=`
`+ze.slice(he);else if(!Ae)Ue+=`
`+ze;else break;!Ae&&!ze.trim()&&(Ae=!0),W+=He+`
`,B=B.substring(He.length+1)}it.loose||(We?it.loose=!0:/\n *\n *$/.test(W)&&(We=!0)),this.options.gfm&&(V=/^\[[ xX]\] /.exec(Ue),V&&(re=V[0]!=="[ ] ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),it.items.push({type:"list_item",raw:W,task:!!V,checked:re,loose:!1,text:Ue}),it.raw+=W}it.items[it.items.length-1].raw=W.trimRight(),it.items[it.items.length-1].text=Ue.trimRight(),it.raw=it.raw.trimRight();var J=it.items.length;for(Ce=0;Ce<J;Ce++){this.lexer.state.top=!1,it.items[Ce].tokens=this.lexer.blockTokens(it.items[Ce].text,[]);var pe=it.items[Ce].tokens.filter(function(Me){return Me.type==="space"}),Se=pe.every(function(Me){for(var $e=Me.raw.split(""),Ye=0,lt=T($e),vt;!(vt=lt()).done;){var wt=vt.value;if(wt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!it.loose&&pe.length&&Se&&(it.loose=!0,it.items[Ce].loose=!0)}return it}},Ee.html=function(B){var N=this.rules.block.html.exec(B);if(N){var W={type:"html",raw:N[0],pre:!this.options.sanitizer&&(N[1]==="pre"||N[1]==="script"||N[1]==="style"),text:N[0]};return this.options.sanitize&&(W.type="paragraph",W.text=this.options.sanitizer?this.options.sanitizer(N[0]):g(N[0]),W.tokens=[],this.lexer.inline(W.text,W.tokens)),W}},Ee.def=function(B){var N=this.rules.block.def.exec(B);if(N){N[3]&&(N[3]=N[3].substring(1,N[3].length-1));var W=N[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:W,raw:N[0],href:N[2],title:N[3]}}},Ee.table=function(B){var N=this.rules.block.table.exec(B);if(N){var W={type:"table",header:m(N[1]).map(function(We){return{text:We}}),align:N[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:N[3]?N[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(W.header.length===W.align.length){W.raw=N[0];var V=W.align.length,re,he,Ce,Ae;for(re=0;re<V;re++)/^ *-+: *$/.test(W.align[re])?W.align[re]="right":/^ *:-+: *$/.test(W.align[re])?W.align[re]="center":/^ *:-+ *$/.test(W.align[re])?W.align[re]="left":W.align[re]=null;for(V=W.rows.length,re=0;re<V;re++)W.rows[re]=m(W.rows[re],W.header.length).map(function(We){return{text:We}});for(V=W.header.length,he=0;he<V;he++)W.header[he].tokens=[],this.lexer.inlineTokens(W.header[he].text,W.header[he].tokens);for(V=W.rows.length,he=0;he<V;he++)for(Ae=W.rows[he],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=[],this.lexer.inlineTokens(Ae[Ce].text,Ae[Ce].tokens);return W}}},Ee.lheading=function(B){var N=this.rules.block.lheading.exec(B);if(N){var W={type:"heading",raw:N[0],depth:N[2].charAt(0)==="="?1:2,text:N[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.paragraph=function(B){var N=this.rules.block.paragraph.exec(B);if(N){var W={type:"paragraph",raw:N[0],text:N[1].charAt(N[1].length-1)===`
`?N[1].slice(0,-1):N[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.text=function(B){var N=this.rules.block.text.exec(B);if(N){var W={type:"text",raw:N[0],text:N[0],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.escape=function(B){var N=this.rules.inline.escape.exec(B);if(N)return{type:"escape",raw:N[0],text:g(N[1])}},Ee.tag=function(B){var N=this.rules.inline.tag.exec(B);if(N)return!this.lexer.state.inLink&&/^<a /i.test(N[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(N[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(N[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(N[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:N[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):g(N[0]):N[0]}},Ee.link=function(B){var N=this.rules.inline.link.exec(B);if(N){var W=N[2].trim();if(!this.options.pedantic&&/^</.test(W)){if(!/>$/.test(W))return;var V=d(W.slice(0,-1),"\\");if((W.length-V.length)%2==0)return}else{var re=E(N[2],"()");if(re>-1){var he=N[0].indexOf("!")===0?5:4,Ce=he+N[1].length+re;N[2]=N[2].substring(0,re),N[0]=N[0].substring(0,Ce).trim(),N[3]=""}}var Ae=N[2],We="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);ze&&(Ae=ze[1],We=ze[3])}else We=N[3]?N[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(W)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),O(N,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},N[0],this.lexer)}},Ee.reflink=function(B,N){var W;if((W=this.rules.inline.reflink.exec(B))||(W=this.rules.inline.nolink.exec(B))){var V=(W[2]||W[1]).replace(/\s+/g," ");if(V=N[V.toLowerCase()],!V||!V.href){var re=W[0].charAt(0);return{type:"text",raw:re,text:re}}return O(W,V,W[0],this.lexer)}},Ee.emStrong=function(B,N,W){W===void 0&&(W="");var V=this.rules.inline.emStrong.lDelim.exec(B);if(!!V&&!(V[3]&&W.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=V[1]||V[2]||"";if(!re||re&&(W===""||this.rules.inline.punctuation.exec(W))){var he=V[0].length-1,Ce,Ae,We=he,ze=0,qe=V[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(qe.lastIndex=0,N=N.slice(-1*B.length+he);(V=qe.exec(N))!=null;)if(Ce=V[1]||V[2]||V[3]||V[4]||V[5]||V[6],!!Ce){if(Ae=Ce.length,V[3]||V[4]){We+=Ae;continue}else if((V[5]||V[6])&&he%3&&!((he+Ae)%3)){ze+=Ae;continue}if(We-=Ae,!(We>0)){if(Ae=Math.min(Ae,Ae+We+ze),Math.min(he,Ae)%2){var He=B.slice(1,he+V.index+Ae);return{type:"em",raw:B.slice(0,he+V.index+Ae+1),text:He,tokens:this.lexer.inlineTokens(He,[])}}var Ue=B.slice(2,he+V.index+Ae-1);return{type:"strong",raw:B.slice(0,he+V.index+Ae+1),text:Ue,tokens:this.lexer.inlineTokens(Ue,[])}}}}}},Ee.codespan=function(B){var N=this.rules.inline.code.exec(B);if(N){var W=N[2].replace(/\n/g," "),V=/[^ ]/.test(W),re=/^ /.test(W)&&/ $/.test(W);return V&&re&&(W=W.substring(1,W.length-1)),W=g(W,!0),{type:"codespan",raw:N[0],text:W}}},Ee.br=function(B){var N=this.rules.inline.br.exec(B);if(N)return{type:"br",raw:N[0]}},Ee.del=function(B){var N=this.rules.inline.del.exec(B);if(N)return{type:"del",raw:N[0],text:N[2],tokens:this.lexer.inlineTokens(N[2],[])}},Ee.autolink=function(B,N){var W=this.rules.inline.autolink.exec(B);if(W){var V,re;return W[2]==="@"?(V=g(this.options.mangle?N(W[1]):W[1]),re="mailto:"+V):(V=g(W[1]),re=V),{type:"link",raw:W[0],text:V,href:re,tokens:[{type:"text",raw:V,text:V}]}}},Ee.url=function(B,N){var W;if(W=this.rules.inline.url.exec(B)){var V,re;if(W[2]==="@")V=g(this.options.mangle?N(W[0]):W[0]),re="mailto:"+V;else{var he;do he=W[0],W[0]=this.rules.inline._backpedal.exec(W[0])[0];while(he!==W[0]);V=g(W[0]),W[1]==="www."?re="http://"+V:re=V}return{type:"link",raw:W[0],text:V,href:re,tokens:[{type:"text",raw:V,text:V}]}}},Ee.inlineText=function(B,N){var W=this.rules.inline.text.exec(B);if(W){var V;return this.lexer.state.inRawBlock?V=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):g(W[0]):W[0]:V=g(this.options.smartypants?N(W[0]):W[0]),{type:"text",raw:W[0],text:V}}},be}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:i,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=_(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=_(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=_(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=_(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=_(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=_(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=o({},M),M.gfm=o({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=_(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=_(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=o({},M.normal,{html:_(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:i,paragraph:_(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:i,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:i,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=_(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=_(M._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=_(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=_(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=_(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=_(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=_(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=_(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=_(j.reflink).replace("label",j._label).replace("ref",M._label).getRegex(),j.nolink=_(j.nolink).replace("ref",M._label).getRegex(),j.reflinkSearch=_(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=o({},j),j.pedantic=o({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:_(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:_(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=o({},j.normal,{escape:_(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=_(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=o({},j.gfm,{br:_(j.br).replace("{2,}","*").getRegex(),text:_(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Q(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(be){var Ee="",z,B,N=be.length;for(z=0;z<N;z++)B=be.charCodeAt(z),Math.random()>.5&&(B="x"+B.toString(16)),Ee+="&#"+B+";";return Ee}var U=function(){function be(z){this.tokens=[],this.tokens.links=Object.create(null),this.options=z||te.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var B={block:M.normal,inline:j.normal};this.options.pedantic?(B.block=M.pedantic,B.inline=j.pedantic):this.options.gfm&&(B.block=M.gfm,this.options.breaks?B.inline=j.breaks:B.inline=j.gfm),this.tokenizer.rules=B}be.lex=function(B,N){var W=new be(N);return W.lex(B)},be.lexInline=function(B,N){var W=new be(N);return W.inlineTokens(B)};var Ee=be.prototype;return Ee.lex=function(B){B=B.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(B,this.tokens);for(var N;N=this.inlineQueue.shift();)this.inlineTokens(N.src,N.tokens);return this.tokens},Ee.blockTokens=function(B,N){var W=this;N===void 0&&(N=[]),this.options.pedantic&&(B=B.replace(/^ +$/gm,""));for(var V,re,he,Ce;B;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(V=We.call({lexer:W},B,N))?(B=B.substring(V.raw.length),N.push(V),!0):!1}))){if(V=this.tokenizer.space(B)){B=B.substring(V.raw.length),V.raw.length===1&&N.length>0?N[N.length-1].raw+=`
`:N.push(V);continue}if(V=this.tokenizer.code(B)){B=B.substring(V.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+V.raw,re.text+=`
`+V.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(V);continue}if(V=this.tokenizer.fences(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.heading(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.hr(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.blockquote(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.list(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.html(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.def(B)){B=B.substring(V.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+V.raw,re.text+=`
`+V.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[V.tag]||(this.tokens.links[V.tag]={href:V.href,title:V.title});continue}if(V=this.tokenizer.table(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.lheading(B)){B=B.substring(V.raw.length),N.push(V);continue}if(he=B,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,ze=B.slice(1),qe=void 0;W.options.extensions.startBlock.forEach(function(He){qe=He.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(We=Math.min(We,qe))}),We<1/0&&We>=0&&(he=B.substring(0,We+1))}(),this.state.top&&(V=this.tokenizer.paragraph(he))){re=N[N.length-1],Ce&&re.type==="paragraph"?(re.raw+=`
`+V.raw,re.text+=`
`+V.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(V),Ce=he.length!==B.length,B=B.substring(V.raw.length);continue}if(V=this.tokenizer.text(B)){B=B.substring(V.raw.length),re=N[N.length-1],re&&re.type==="text"?(re.raw+=`
`+V.raw,re.text+=`
`+V.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(V);continue}if(B){var Ae="Infinite loop on byte: "+B.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,N},Ee.inline=function(B,N){this.inlineQueue.push({src:B,tokens:N})},Ee.inlineTokens=function(B,N){var W=this;N===void 0&&(N=[]);var V,re,he,Ce=B,Ae,We,ze;if(this.tokens.links){var qe=Object.keys(this.tokens.links);if(qe.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)qe.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+L("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+L("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;B;)if(We||(ze=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ue){return(V=Ue.call({lexer:W},B,N))?(B=B.substring(V.raw.length),N.push(V),!0):!1}))){if(V=this.tokenizer.escape(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.tag(B)){B=B.substring(V.raw.length),re=N[N.length-1],re&&V.type==="text"&&re.type==="text"?(re.raw+=V.raw,re.text+=V.text):N.push(V);continue}if(V=this.tokenizer.link(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.reflink(B,this.tokens.links)){B=B.substring(V.raw.length),re=N[N.length-1],re&&V.type==="text"&&re.type==="text"?(re.raw+=V.raw,re.text+=V.text):N.push(V);continue}if(V=this.tokenizer.emStrong(B,Ce,ze)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.codespan(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.br(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.del(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.autolink(B,$)){B=B.substring(V.raw.length),N.push(V);continue}if(!this.state.inLink&&(V=this.tokenizer.url(B,$))){B=B.substring(V.raw.length),N.push(V);continue}if(he=B,this.options.extensions&&this.options.extensions.startInline&&function(){var Ue=1/0,Je=B.slice(1),et=void 0;W.options.extensions.startInline.forEach(function(Le){et=Le.call({lexer:this},Je),typeof et=="number"&&et>=0&&(Ue=Math.min(Ue,et))}),Ue<1/0&&Ue>=0&&(he=B.substring(0,Ue+1))}(),V=this.tokenizer.inlineText(he,Q)){B=B.substring(V.raw.length),V.raw.slice(-1)!=="_"&&(ze=V.raw.slice(-1)),We=!0,re=N[N.length-1],re&&re.type==="text"?(re.raw+=V.raw,re.text+=V.text):N.push(V);continue}if(B){var He="Infinite loop on byte: "+B.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return N},f(be,null,[{key:"rules",get:function(){return{block:M,inline:j}}}]),be}(),q=function(){function be(z){this.options=z||te.defaults}var Ee=be.prototype;return Ee.code=function(B,N,W){var V=(N||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(B,V);re!=null&&re!==B&&(W=!0,B=re)}return B=B.replace(/\n$/,"")+`
`,V?'<pre><code class="'+this.options.langPrefix+g(V,!0)+'">'+(W?B:g(B,!0))+`</code></pre>
`:"<pre><code>"+(W?B:g(B,!0))+`</code></pre>
`},Ee.blockquote=function(B){return`<blockquote>
`+B+`</blockquote>
`},Ee.html=function(B){return B},Ee.heading=function(B,N,W,V){return this.options.headerIds?"<h"+N+' id="'+this.options.headerPrefix+V.slug(W)+'">'+B+"</h"+N+`>
`:"<h"+N+">"+B+"</h"+N+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(B,N,W){var V=N?"ol":"ul",re=N&&W!==1?' start="'+W+'"':"";return"<"+V+re+`>
`+B+"</"+V+`>
`},Ee.listitem=function(B){return"<li>"+B+`</li>
`},Ee.checkbox=function(B){return"<input "+(B?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(B){return"<p>"+B+`</p>
`},Ee.table=function(B,N){return N&&(N="<tbody>"+N+"</tbody>"),`<table>
<thead>
`+B+`</thead>
`+N+`</table>
`},Ee.tablerow=function(B){return`<tr>
`+B+`</tr>
`},Ee.tablecell=function(B,N){var W=N.header?"th":"td",V=N.align?"<"+W+' align="'+N.align+'">':"<"+W+">";return V+B+"</"+W+`>
`},Ee.strong=function(B){return"<strong>"+B+"</strong>"},Ee.em=function(B){return"<em>"+B+"</em>"},Ee.codespan=function(B){return"<code>"+B+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(B){return"<del>"+B+"</del>"},Ee.link=function(B,N,W){if(B=u(this.options.sanitize,this.options.baseUrl,B),B===null)return W;var V='<a href="'+g(B)+'"';return N&&(V+=' title="'+N+'"'),V+=">"+W+"</a>",V},Ee.image=function(B,N,W){if(B=u(this.options.sanitize,this.options.baseUrl,B),B===null)return W;var V='<img src="'+B+'" alt="'+W+'"';return N&&(V+=' title="'+N+'"'),V+=this.options.xhtml?"/>":">",V},Ee.text=function(B){return B},be}(),K=function(){function be(){}var Ee=be.prototype;return Ee.strong=function(B){return B},Ee.em=function(B){return B},Ee.codespan=function(B){return B},Ee.del=function(B){return B},Ee.html=function(B){return B},Ee.text=function(B){return B},Ee.link=function(B,N,W){return""+W},Ee.image=function(B,N,W){return""+W},Ee.br=function(){return""},be}(),G=function(){function be(){this.seen={}}var Ee=be.prototype;return Ee.serialize=function(B){return B.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(B,N){var W=B,V=0;if(this.seen.hasOwnProperty(W)){V=this.seen[B];do V++,W=B+"-"+V;while(this.seen.hasOwnProperty(W))}return N||(this.seen[B]=V,this.seen[W]=0),W},Ee.slug=function(B,N){N===void 0&&(N={});var W=this.serialize(B);return this.getNextSafeSlug(W,N.dryrun)},be}(),ee=function(){function be(z){this.options=z||te.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new G}be.parse=function(B,N){var W=new be(N);return W.parse(B)},be.parseInline=function(B,N){var W=new be(N);return W.parseInline(B)};var Ee=be.prototype;return Ee.parse=function(B,N){N===void 0&&(N=!0);var W="",V,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et,Le,it,ne,ae,J,pe,Se,Me=B.length;for(V=0;V<Me;V++){if(Ue=B[V],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ue.type]&&(Se=this.options.extensions.renderers[Ue.type].call({parser:this},Ue),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ue.type))){W+=Se||"";continue}switch(Ue.type){case"space":continue;case"hr":{W+=this.renderer.hr();continue}case"heading":{W+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,v(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{W+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(qe="",ze="",Ce=Ue.header.length,re=0;re<Ce;re++)ze+=this.renderer.tablecell(this.parseInline(Ue.header[re].tokens),{header:!0,align:Ue.align[re]});for(qe+=this.renderer.tablerow(ze),He="",Ce=Ue.rows.length,re=0;re<Ce;re++){for(We=Ue.rows[re],ze="",Ae=We.length,he=0;he<Ae;he++)ze+=this.renderer.tablecell(this.parseInline(We[he].tokens),{header:!1,align:Ue.align[he]});He+=this.renderer.tablerow(ze)}W+=this.renderer.table(qe,He);continue}case"blockquote":{He=this.parse(Ue.tokens),W+=this.renderer.blockquote(He);continue}case"list":{for(Je=Ue.ordered,et=Ue.start,Le=Ue.loose,Ce=Ue.items.length,He="",re=0;re<Ce;re++)ne=Ue.items[re],ae=ne.checked,J=ne.task,it="",ne.task&&(pe=this.renderer.checkbox(ae),Le?ne.tokens.length>0&&ne.tokens[0].type==="paragraph"?(ne.tokens[0].text=pe+" "+ne.tokens[0].text,ne.tokens[0].tokens&&ne.tokens[0].tokens.length>0&&ne.tokens[0].tokens[0].type==="text"&&(ne.tokens[0].tokens[0].text=pe+" "+ne.tokens[0].tokens[0].text)):ne.tokens.unshift({type:"text",text:pe}):it+=pe),it+=this.parse(ne.tokens,Le),He+=this.renderer.listitem(it,J,ae);W+=this.renderer.list(He,Je,et);continue}case"html":{W+=this.renderer.html(Ue.text);continue}case"paragraph":{W+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(He=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;V+1<Me&&B[V+1].type==="text";)Ue=B[++V],He+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);W+=N?this.renderer.paragraph(He):He;continue}default:{var $e='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return W},Ee.parseInline=function(B,N){N=N||this.renderer;var W="",V,re,he,Ce=B.length;for(V=0;V<Ce;V++){if(re=B[V],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(he=this.options.extensions.renderers[re.type].call({parser:this},re),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){W+=he||"";continue}switch(re.type){case"escape":{W+=N.text(re.text);break}case"html":{W+=N.html(re.text);break}case"link":{W+=N.link(re.href,re.title,this.parseInline(re.tokens,N));break}case"image":{W+=N.image(re.href,re.title,re.text);break}case"strong":{W+=N.strong(this.parseInline(re.tokens,N));break}case"em":{W+=N.em(this.parseInline(re.tokens,N));break}case"codespan":{W+=N.codespan(re.text);break}case"br":{W+=N.br();break}case"del":{W+=N.del(this.parseInline(re.tokens,N));break}case"text":{W+=N.text(re.text);break}default:{var Ae='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return W},be}();function oe(be,Ee,z){if(typeof be=="undefined"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof Ee=="function"&&(z=Ee,Ee=null),Ee=o({},oe.defaults,Ee||{}),P(Ee),z){var B=Ee.highlight,N;try{N=U.lex(be,Ee)}catch(he){return z(he)}var W=function(Ce){var Ae;if(!Ce)try{Ee.walkTokens&&oe.walkTokens(N,Ee.walkTokens),Ae=ee.parse(N,Ee)}catch(We){Ce=We}return Ee.highlight=B,Ce?z(Ce):z(null,Ae)};if(!B||B.length<3||(delete Ee.highlight,!N.length))return W();var V=0;oe.walkTokens(N,function(he){he.type==="code"&&(V++,setTimeout(function(){B(he.text,he.lang,function(Ce,Ae){if(Ce)return W(Ce);Ae!=null&&Ae!==he.text&&(he.text=Ae,he.escaped=!0),V--,V===0&&W()})},0))}),V===0&&W();return}try{var re=U.lex(be,Ee);return Ee.walkTokens&&oe.walkTokens(re,Ee.walkTokens),ee.parse(re,Ee)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+g(he.message+"",!0)+"</pre>";throw he}}oe.options=oe.setOptions=function(be){return o(oe.defaults,be),k(oe.defaults),oe},oe.getDefaults=C,oe.defaults=te.defaults,oe.use=function(){for(var be=arguments.length,Ee=new Array(be),z=0;z<be;z++)Ee[z]=arguments[z];var B=o.apply(void 0,[{}].concat(Ee)),N=oe.defaults.extensions||{renderers:{},childTokens:{}},W;Ee.forEach(function(V){if(V.extensions&&(W=!0,V.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=N.renderers?N.renderers[he.name]:null;Ce?N.renderers[he.name]=function(){for(var Ae=arguments.length,We=new Array(Ae),ze=0;ze<Ae;ze++)We[ze]=arguments[ze];var qe=he.renderer.apply(this,We);return qe===!1&&(qe=Ce.apply(this,We)),qe}:N.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");N[he.level]?N[he.level].unshift(he.tokenizer):N[he.level]=[he.tokenizer],he.start&&(he.level==="block"?N.startBlock?N.startBlock.push(he.start):N.startBlock=[he.start]:he.level==="inline"&&(N.startInline?N.startInline.push(he.start):N.startInline=[he.start]))}he.childTokens&&(N.childTokens[he.name]=he.childTokens)})),V.renderer&&function(){var he=oe.defaults.renderer||new q,Ce=function(ze){var qe=he[ze];he[ze]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var et=V.renderer[ze].apply(he,Ue);return et===!1&&(et=qe.apply(he,Ue)),et}};for(var Ae in V.renderer)Ce(Ae);B.renderer=he}(),V.tokenizer&&function(){var he=oe.defaults.tokenizer||new H,Ce=function(ze){var qe=he[ze];he[ze]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var et=V.tokenizer[ze].apply(he,Ue);return et===!1&&(et=qe.apply(he,Ue)),et}};for(var Ae in V.tokenizer)Ce(Ae);B.tokenizer=he}(),V.walkTokens){var re=oe.defaults.walkTokens;B.walkTokens=function(he){V.walkTokens.call(this,he),re&&re.call(this,he)}}W&&(B.extensions=N),oe.setOptions(B)})},oe.walkTokens=function(be,Ee){for(var z=function(){var V=N.value;switch(Ee.call(oe,V),V.type){case"table":{for(var re=T(V.header),he;!(he=re()).done;){var Ce=he.value;oe.walkTokens(Ce.tokens,Ee)}for(var Ae=T(V.rows),We;!(We=Ae()).done;)for(var ze=We.value,qe=T(ze),He;!(He=qe()).done;){var Ue=He.value;oe.walkTokens(Ue.tokens,Ee)}break}case"list":{oe.walkTokens(V.items,Ee);break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[V.type]?oe.defaults.extensions.childTokens[V.type].forEach(function(Je){oe.walkTokens(V[Je],Ee)}):V.tokens&&oe.walkTokens(V.tokens,Ee)}},B=T(be),N;!(N=B()).done;)z()},oe.parseInline=function(be,Ee){if(typeof be=="undefined"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");Ee=o({},oe.defaults,Ee||{}),P(Ee);try{var z=U.lexInline(be,Ee);return Ee.walkTokens&&oe.walkTokens(z,Ee.walkTokens),ee.parseInline(z,Ee)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+g(B.message+"",!0)+"</pre>";throw B}},oe.Parser=ee,oe.parser=ee.parse,oe.Renderer=q,oe.TextRenderer=K,oe.Lexer=U,oe.lexer=U.lex,oe.Tokenizer=H,oe.Slugger=G,oe.parse=oe;var ue=oe.options,Z=oe.setOptions,Y=oe.use,se=oe.walkTokens,de=oe.parseInline,ge=oe,Te=ee.parse,Ne=U.lex;te.Lexer=U,te.Parser=ee,te.Renderer=q,te.Slugger=G,te.TextRenderer=K,te.Tokenizer=H,te.getDefaults=C,te.lexer=Ne,te.marked=oe,te.options=ue,te.parse=ge,te.parseInline=de,te.parser=Te,te.setOptions=Z,te.use=Y,te.walkTokens=se,Object.defineProperty(te,"__esModule",{value:!0})}),define(ve[91],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(k,S,R){return Math.min(Math.max(k,S),R)}e.clamp=f;function t(k,S){return(S+k%S)%S}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class T{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=T;class C{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const R=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=R,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function te(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function C(S){T.push(S,Date.now())}function k(){const S=[];for(let R=0;R<T.length;R+=2)S.push({name:T[R],startTime:T[R+1]});return S}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const C of performance.getEntriesByType("mark"))T.push({name:C.name,startTime:Math.round(I+C.startTime)});return T}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function f(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=f(t))}(),define(ve[12],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let t=!1,I=!1,T=!1,C=!1,k=!1,S=!1,R=!1,F=!1,D=!1,p,b=f,g,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const A=typeof v?.versions?.electron=="string",_=A&&v?.type==="renderer";if(e.isElectronSandboxed=_&&v?.sandboxed,typeof navigator=="object"&&!_)h=navigator.userAgent,t=h.indexOf("Windows")>=0,I=h.indexOf("Macintosh")>=0,F=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=h.indexOf("Linux")>=0,S=!0,p=navigator.language,b=p;else if(typeof v=="object"){t=v.platform==="win32",I=v.platform==="darwin",T=v.platform==="linux",C=T&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,R=A,D=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=f,b=f;const i=v.env.VSCODE_NLS_CONFIG;if(i)try{const o=JSON.parse(i),m=o.availableLanguages["*"];p=o.locale,b=m||f,g=o._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var a;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(a=e.Platform||(e.Platform={}));function l(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let u=0;I?u=1:t?u=3:T&&(u=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=T,e.isLinuxSnap=C,e.isNative=k,e.isElectron=R,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=F,e.isCI=D,e.platform=u,e.userAgent=h,e.language=b;var c;(function(i){function o(){return e.language}i.value=o;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=m;function d(){return e.language==="en"}i.isDefault=d})(c=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=g,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let i=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let d=0,E=i.length;d<E;d++){const P=i[d];if(P.id===m.data.vscodeScheduleAsyncWork){i.splice(d,1),P.callback();return}}});let o=0;return m=>{const d=++o;i.push({id:d,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return i=>setTimeout(i)})();var w;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(w=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||F?2:t?1:3;let s=!0,n=!1;function r(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,s=new Uint16Array(i.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[41],we([1,0,12]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const I=f.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[9],we([1,0,41]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,T=90,C=122,k=46,S=47,R=92,F=58,D=63;class p extends Error{constructor(l,u,c){let w;typeof u=="string"&&u.indexOf("not ")===0?(w="must not be",u=u.replace(/^not /,"")):w="must be";const s=l.indexOf(".")!==-1?"property":"argument";let n=`The "${l}" ${s} ${w} of type ${u}`;n+=`. Received type ${typeof c}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function b(a,l){if(typeof a!="string")throw new p(l,"string",a)}function g(a){return a===S||a===R}function h(a){return a===S}function v(a){return a>=t&&a<=T||a>=I&&a<=C}function A(a,l,u,c){let w="",s=0,n=-1,r=0,i=0;for(let o=0;o<=a.length;++o){if(o<a.length)i=a.charCodeAt(o);else{if(c(i))break;i=S}if(c(i)){if(!(n===o-1||r===1))if(r===2){if(w.length<2||s!==2||w.charCodeAt(w.length-1)!==k||w.charCodeAt(w.length-2)!==k){if(w.length>2){const m=w.lastIndexOf(u);m===-1?(w="",s=0):(w=w.slice(0,m),s=w.length-1-w.lastIndexOf(u)),n=o,r=0;continue}else if(w.length!==0){w="",s=0,n=o,r=0;continue}}l&&(w+=w.length>0?`${u}..`:"..",s=2)}else w.length>0?w+=`${u}${a.slice(n+1,o)}`:w=a.slice(n+1,o),s=o-n-1;n=o,r=0}else i===k&&r!==-1?++r:r=-1}return w}function _(a,l){if(l===null||typeof l!="object")throw new p("pathObject","Object",l);const u=l.dir||l.root,c=l.base||`${l.name||""}${l.ext||""}`;return u?u===l.root?`${u}${c}`:`${u}${a}${c}`:c}e.win32={resolve(...a){let l="",u="",c=!1;for(let w=a.length-1;w>=-1;w--){let s;if(w>=0){if(s=a[w],b(s,"path"),s.length===0)continue}else l.length===0?s=f.cwd():(s=f.env[`=${l}`]||f.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===R)&&(s=`${l}\\`));const n=s.length;let r=0,i="",o=!1;const m=s.charCodeAt(0);if(n===1)g(m)&&(r=1,o=!0);else if(g(m))if(o=!0,g(s.charCodeAt(1))){let d=2,E=d;for(;d<n&&!g(s.charCodeAt(d));)d++;if(d<n&&d!==E){const P=s.slice(E,d);for(E=d;d<n&&g(s.charCodeAt(d));)d++;if(d<n&&d!==E){for(E=d;d<n&&!g(s.charCodeAt(d));)d++;(d===n||d!==E)&&(i=`\\\\${P}\\${s.slice(E,d)}`,r=d)}}}else r=1;else v(m)&&s.charCodeAt(1)===F&&(i=s.slice(0,2),r=2,n>2&&g(s.charCodeAt(2))&&(o=!0,r=3));if(i.length>0)if(l.length>0){if(i.toLowerCase()!==l.toLowerCase())continue}else l=i;if(c){if(l.length>0)break}else if(u=`${s.slice(r)}\\${u}`,c=o,o&&l.length>0)break}return u=A(u,!c,"\\",g),c?`${l}\\${u}`:`${l}${u}`||"."},normalize(a){b(a,"path");const l=a.length;if(l===0)return".";let u=0,c,w=!1;const s=a.charCodeAt(0);if(l===1)return h(s)?"\\":a;if(g(s))if(w=!0,g(a.charCodeAt(1))){let r=2,i=r;for(;r<l&&!g(a.charCodeAt(r));)r++;if(r<l&&r!==i){const o=a.slice(i,r);for(i=r;r<l&&g(a.charCodeAt(r));)r++;if(r<l&&r!==i){for(i=r;r<l&&!g(a.charCodeAt(r));)r++;if(r===l)return`\\\\${o}\\${a.slice(i)}\\`;r!==i&&(c=`\\\\${o}\\${a.slice(i,r)}`,u=r)}}}else u=1;else v(s)&&a.charCodeAt(1)===F&&(c=a.slice(0,2),u=2,l>2&&g(a.charCodeAt(2))&&(w=!0,u=3));let n=u<l?A(a.slice(u),!w,"\\",g):"";return n.length===0&&!w&&(n="."),n.length>0&&g(a.charCodeAt(l-1))&&(n+="\\"),c===void 0?w?`\\${n}`:n:w?`${c}\\${n}`:`${c}${n}`},isAbsolute(a){b(a,"path");const l=a.length;if(l===0)return!1;const u=a.charCodeAt(0);return g(u)||l>2&&v(u)&&a.charCodeAt(1)===F&&g(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let l,u;for(let s=0;s<a.length;++s){const n=a[s];b(n,"path"),n.length>0&&(l===void 0?l=u=n:l+=`\\${n}`)}if(l===void 0)return".";let c=!0,w=0;if(typeof u=="string"&&g(u.charCodeAt(0))){++w;const s=u.length;s>1&&g(u.charCodeAt(1))&&(++w,s>2&&(g(u.charCodeAt(2))?++w:c=!1))}if(c){for(;w<l.length&&g(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return e.win32.normalize(l)},relative(a,l){if(b(a,"from"),b(l,"to"),a===l)return"";const u=e.win32.resolve(a),c=e.win32.resolve(l);if(u===c||(a=u.toLowerCase(),l=c.toLowerCase(),a===l))return"";let w=0;for(;w<a.length&&a.charCodeAt(w)===R;)w++;let s=a.length;for(;s-1>w&&a.charCodeAt(s-1)===R;)s--;const n=s-w;let r=0;for(;r<l.length&&l.charCodeAt(r)===R;)r++;let i=l.length;for(;i-1>r&&l.charCodeAt(i-1)===R;)i--;const o=i-r,m=n<o?n:o;let d=-1,E=0;for(;E<m;E++){const L=a.charCodeAt(w+E);if(L!==l.charCodeAt(r+E))break;L===R&&(d=E)}if(E!==m){if(d===-1)return c}else{if(o>m){if(l.charCodeAt(r+E)===R)return c.slice(r+E+1);if(E===2)return c.slice(r+E)}n>m&&(a.charCodeAt(w+E)===R?d=E:E===2&&(d=3)),d===-1&&(d=0)}let P="";for(E=w+d+1;E<=s;++E)(E===s||a.charCodeAt(E)===R)&&(P+=P.length===0?"..":"\\..");return r+=d,P.length>0?`${P}${c.slice(r,i)}`:(c.charCodeAt(r)===R&&++r,c.slice(r,i))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const l=e.win32.resolve(a);if(l.length<=2)return a;if(l.charCodeAt(0)===R){if(l.charCodeAt(1)===R){const u=l.charCodeAt(2);if(u!==D&&u!==k)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===F&&l.charCodeAt(2)===R)return`\\\\?\\${l}`;return a},dirname(a){b(a,"path");const l=a.length;if(l===0)return".";let u=-1,c=0;const w=a.charCodeAt(0);if(l===1)return g(w)?a:".";if(g(w)){if(u=c=1,g(a.charCodeAt(1))){let r=2,i=r;for(;r<l&&!g(a.charCodeAt(r));)r++;if(r<l&&r!==i){for(i=r;r<l&&g(a.charCodeAt(r));)r++;if(r<l&&r!==i){for(i=r;r<l&&!g(a.charCodeAt(r));)r++;if(r===l)return a;r!==i&&(u=c=r+1)}}}}else v(w)&&a.charCodeAt(1)===F&&(u=l>2&&g(a.charCodeAt(2))?3:2,c=u);let s=-1,n=!0;for(let r=l-1;r>=c;--r)if(g(a.charCodeAt(r))){if(!n){s=r;break}}else n=!1;if(s===-1){if(u===-1)return".";s=u}return a.slice(0,s)},basename(a,l){l!==void 0&&b(l,"ext"),b(a,"path");let u=0,c=-1,w=!0,s;if(a.length>=2&&v(a.charCodeAt(0))&&a.charCodeAt(1)===F&&(u=2),l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let n=l.length-1,r=-1;for(s=a.length-1;s>=u;--s){const i=a.charCodeAt(s);if(g(i)){if(!w){u=s+1;break}}else r===-1&&(w=!1,r=s+1),n>=0&&(i===l.charCodeAt(n)?--n==-1&&(c=s):(n=-1,c=r))}return u===c?c=r:c===-1&&(c=a.length),a.slice(u,c)}for(s=a.length-1;s>=u;--s)if(g(a.charCodeAt(s))){if(!w){u=s+1;break}}else c===-1&&(w=!1,c=s+1);return c===-1?"":a.slice(u,c)},extname(a){b(a,"path");let l=0,u=-1,c=0,w=-1,s=!0,n=0;a.length>=2&&a.charCodeAt(1)===F&&v(a.charCodeAt(0))&&(l=c=2);for(let r=a.length-1;r>=l;--r){const i=a.charCodeAt(r);if(g(i)){if(!s){c=r+1;break}continue}w===-1&&(s=!1,w=r+1),i===k?u===-1?u=r:n!==1&&(n=1):u!==-1&&(n=-1)}return u===-1||w===-1||n===0||n===1&&u===w-1&&u===c+1?"":a.slice(u,w)},format:_.bind(null,"\\"),parse(a){b(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const u=a.length;let c=0,w=a.charCodeAt(0);if(u===1)return g(w)?(l.root=l.dir=a,l):(l.base=l.name=a,l);if(g(w)){if(c=1,g(a.charCodeAt(1))){let d=2,E=d;for(;d<u&&!g(a.charCodeAt(d));)d++;if(d<u&&d!==E){for(E=d;d<u&&g(a.charCodeAt(d));)d++;if(d<u&&d!==E){for(E=d;d<u&&!g(a.charCodeAt(d));)d++;d===u?c=d:d!==E&&(c=d+1)}}}}else if(v(w)&&a.charCodeAt(1)===F){if(u<=2)return l.root=l.dir=a,l;if(c=2,g(a.charCodeAt(2))){if(u===3)return l.root=l.dir=a,l;c=3}}c>0&&(l.root=a.slice(0,c));let s=-1,n=c,r=-1,i=!0,o=a.length-1,m=0;for(;o>=c;--o){if(w=a.charCodeAt(o),g(w)){if(!i){n=o+1;break}continue}r===-1&&(i=!1,r=o+1),w===k?s===-1?s=o:m!==1&&(m=1):s!==-1&&(m=-1)}return r!==-1&&(s===-1||m===0||m===1&&s===r-1&&s===n+1?l.base=l.name=a.slice(n,r):(l.name=a.slice(n,s),l.base=a.slice(n,r),l.ext=a.slice(s,r))),n>0&&n!==c?l.dir=a.slice(0,n-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let l="",u=!1;for(let c=a.length-1;c>=-1&&!u;c--){const w=c>=0?a[c]:f.cwd();b(w,"path"),w.length!==0&&(l=`${w}/${l}`,u=w.charCodeAt(0)===S)}return l=A(l,!u,"/",h),u?`/${l}`:l.length>0?l:"."},normalize(a){if(b(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===S,u=a.charCodeAt(a.length-1)===S;return a=A(a,!l,"/",h),a.length===0?l?"/":u?"./":".":(u&&(a+="/"),l?`/${a}`:a)},isAbsolute(a){return b(a,"path"),a.length>0&&a.charCodeAt(0)===S},join(...a){if(a.length===0)return".";let l;for(let u=0;u<a.length;++u){const c=a[u];b(c,"path"),c.length>0&&(l===void 0?l=c:l+=`/${c}`)}return l===void 0?".":e.posix.normalize(l)},relative(a,l){if(b(a,"from"),b(l,"to"),a===l||(a=e.posix.resolve(a),l=e.posix.resolve(l),a===l))return"";const u=1,c=a.length,w=c-u,s=1,n=l.length-s,r=w<n?w:n;let i=-1,o=0;for(;o<r;o++){const d=a.charCodeAt(u+o);if(d!==l.charCodeAt(s+o))break;d===S&&(i=o)}if(o===r)if(n>r){if(l.charCodeAt(s+o)===S)return l.slice(s+o+1);if(o===0)return l.slice(s+o)}else w>r&&(a.charCodeAt(u+o)===S?i=o:o===0&&(i=0));let m="";for(o=u+i+1;o<=c;++o)(o===c||a.charCodeAt(o)===S)&&(m+=m.length===0?"..":"/..");return`${m}${l.slice(s+i)}`},toNamespacedPath(a){return a},dirname(a){if(b(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===S;let u=-1,c=!0;for(let w=a.length-1;w>=1;--w)if(a.charCodeAt(w)===S){if(!c){u=w;break}}else c=!1;return u===-1?l?"/":".":l&&u===1?"//":a.slice(0,u)},basename(a,l){l!==void 0&&b(l,"ext"),b(a,"path");let u=0,c=-1,w=!0,s;if(l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let n=l.length-1,r=-1;for(s=a.length-1;s>=0;--s){const i=a.charCodeAt(s);if(i===S){if(!w){u=s+1;break}}else r===-1&&(w=!1,r=s+1),n>=0&&(i===l.charCodeAt(n)?--n==-1&&(c=s):(n=-1,c=r))}return u===c?c=r:c===-1&&(c=a.length),a.slice(u,c)}for(s=a.length-1;s>=0;--s)if(a.charCodeAt(s)===S){if(!w){u=s+1;break}}else c===-1&&(w=!1,c=s+1);return c===-1?"":a.slice(u,c)},extname(a){b(a,"path");let l=-1,u=0,c=-1,w=!0,s=0;for(let n=a.length-1;n>=0;--n){const r=a.charCodeAt(n);if(r===S){if(!w){u=n+1;break}continue}c===-1&&(w=!1,c=n+1),r===k?l===-1?l=n:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||c===-1||s===0||s===1&&l===c-1&&l===u+1?"":a.slice(l,c)},format:_.bind(null,"/"),parse(a){b(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const u=a.charCodeAt(0)===S;let c;u?(l.root="/",c=1):c=0;let w=-1,s=0,n=-1,r=!0,i=a.length-1,o=0;for(;i>=c;--i){const m=a.charCodeAt(i);if(m===S){if(!r){s=i+1;break}continue}n===-1&&(r=!1,n=i+1),m===k?w===-1?w=i:o!==1&&(o=1):w!==-1&&(o=-1)}if(n!==-1){const m=s===0&&u?1:s;w===-1||o===0||o===1&&w===n-1&&w===s+1?l.base=l.name=a.slice(m,n):(l.name=a.slice(m,w),l.base=a.slice(m,n),l.ext=a.slice(w,n))}return s>0?l.dir=a.slice(0,s-1):u&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[92],we([1,0,9]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(D){D.text="text/plain",D.binary="application/octet-stream",D.unknown="application/unknown",D.markdown="text/markdown",D.latex="text/latex",D.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(D){const p=(0,f.extname)(D),b=I[p.toLowerCase()];return b!==void 0?b:k(D)}e.getMediaOrTextMime=C;function k(D){const p=(0,f.extname)(D);return T[p.toLowerCase()]}e.getMediaMime=k;function S(D){for(const p in T)if(T[p]===D)return p}e.getExtensionForMimeType=S;const R=/^(.+)\/(.+?)(;.+)?$/;function F(D,p){const b=R.exec(D);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:p?void 0:D}e.normalizeMimeType=F}),define(ve[93],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var t;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(T,...C){const k=C.reduce((F,D)=>(F[D]=!0,F),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(F=>!k[F]).forEach(F=>{for(let D=0;D<S.length;D++)if(F.search(S[D])!==-1){delete T[F];break}})}e.sanitizeProcessEnvironment=I}),define(ve[46],we([1,0,12]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=f.globals.performance&&typeof f.globals.performance.now=="function";class I{constructor(C){this._highResolution=t&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new I(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=I}),define(ve[3],we([1,0,15,74,6,90,46]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let k=!1,S=!1;var R;(function(s){s.None=()=>I.Disposable.None;function n(ee){if(S){const{onListenerDidAdd:oe}=ee,ue=g.create();let Z=0;ee.onListenerDidAdd=()=>{++Z==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),oe?.()}}}function r(ee){return(oe,ue=null,Z)=>{let Y=!1,se;return se=ee(de=>{if(!Y)return se?se.dispose():Y=!0,oe.call(ue,de)},null,Z),Y&&se.dispose(),se}}s.once=r;function i(ee,oe,ue){return L((Z,Y=null,se)=>ee(de=>Z.call(Y,oe(de)),null,se),ue)}s.map=i;function o(ee,oe,ue){return L((Z,Y=null,se)=>ee(de=>{oe(de),Z.call(Y,de)},null,se),ue)}s.forEach=o;function m(ee,oe,ue){return L((Z,Y=null,se)=>ee(de=>oe(de)&&Z.call(Y,de),null,se),ue)}s.filter=m;function d(ee){return ee}s.signal=d;function E(...ee){return(oe,ue=null,Z)=>(0,I.combinedDisposable)(...ee.map(Y=>Y(se=>oe.call(ue,se),null,Z)))}s.any=E;function P(ee,oe,ue,Z){let Y=ue;return i(ee,se=>(Y=oe(Y,se),Y),Z)}s.reduce=P;function L(ee,oe){let ue;const Z={onFirstListenerAdd(){ue=ee(Y.fire,Y)},onLastListenerRemove(){ue.dispose()}};oe||n(Z);const Y=new v(Z);return oe&&oe.add(Y),Y.event}function O(ee,oe,ue=100,Z=!1,Y,se){let de,ge,Te,Ne=0;const be={leakWarningThreshold:Y,onFirstListenerAdd(){de=ee(z=>{Ne++,ge=oe(ge,z),Z&&!Te&&(Ee.fire(ge),ge=void 0),clearTimeout(Te),Te=setTimeout(()=>{const B=ge;ge=void 0,Te=void 0,(!Z||Ne>1)&&Ee.fire(B),Ne=0},ue)})},onLastListenerRemove(){de.dispose()}};se||n(be);const Ee=new v(be);return se&&se.add(Ee),Ee.event}s.debounce=O;function y(ee,oe=(Z,Y)=>Z===Y,ue){let Z=!0,Y;return m(ee,se=>{const de=Z||!oe(se,Y);return Z=!1,Y=se,de},ue)}s.latch=y;function H(ee,oe,ue){return[s.filter(ee,oe,ue),s.filter(ee,Z=>!oe(Z),ue)]}s.split=H;function M(ee,oe=!1,ue=[]){let Z=ue.slice(),Y=ee(ge=>{Z?Z.push(ge):de.fire(ge)});const se=()=>{Z&&Z.forEach(ge=>de.fire(ge)),Z=null},de=new v({onFirstListenerAdd(){Y||(Y=ee(ge=>de.fire(ge)))},onFirstListenerDidAdd(){Z&&(oe?setTimeout(se):se())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return de.event}s.buffer=M;class j{constructor(oe){this.event=oe}map(oe){return new j(i(this.event,oe))}forEach(oe){return new j(o(this.event,oe))}filter(oe){return new j(m(this.event,oe))}reduce(oe,ue){return new j(P(this.event,oe,ue))}latch(){return new j(y(this.event))}debounce(oe,ue=100,Z=!1,Y){return new j(O(this.event,oe,ue,Z,Y))}on(oe,ue,Z){return this.event(oe,ue,Z)}once(oe,ue,Z){return r(this.event)(oe,ue,Z)}}function Q(ee){return new j(ee)}s.chain=Q;function $(ee,oe,ue=Z=>Z){const Z=(...ge)=>de.fire(ue(...ge)),Y=()=>ee.on(oe,Z),se=()=>ee.removeListener(oe,Z),de=new v({onFirstListenerAdd:Y,onLastListenerRemove:se});return de.event}s.fromNodeEventEmitter=$;function U(ee,oe,ue=Z=>Z){const Z=(...ge)=>de.fire(ue(...ge)),Y=()=>ee.addEventListener(oe,Z),se=()=>ee.removeEventListener(oe,Z),de=new v({onFirstListenerAdd:Y,onLastListenerRemove:se});return de.event}s.fromDOMEventEmitter=U;function q(ee){return new Promise(oe=>r(ee)(oe))}s.toPromise=q;function K(ee,oe){return oe(void 0),ee(ue=>oe(ue))}s.runAndSubscribe=K;function G(ee,oe){let ue=null;function Z(se){ue?.dispose(),ue=new I.DisposableStore,oe(se,ue)}Z(void 0);const Y=ee(se=>Z(se));return(0,I.toDisposable)(()=>{Y.dispose(),ue?.dispose()})}s.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class F{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${F._idPool++}`}start(n){this._stopWatch=new C.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}F._idPool=0;let D=-1;function p(s){const n=D;return D=s,{dispose(){D=n}}}e.setGlobalLeakWarningThreshold=p;class b{constructor(n,r=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,r){let i=D;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||r<i)return;this._stacks||(this._stacks=new Map);const o=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let m,d=0;for(const[E,P]of this._stacks)(!m||d<P)&&(m=E,d=P);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${d}):`),console.warn(m)}return()=>{const m=this._stacks.get(n.value)||0;this._stacks.set(n.value,m-1)}}}class g{constructor(n){this.value=n}static create(){return new g(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(n,r,i){this.callback=n,this.callbackThis=r,this.stack=i,this.subscription=new I.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class v{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=D>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new F(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const r of n)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,r,i)=>{this._listeners||(this._listeners=new T.LinkedList);const o=this._listeners.isEmpty();o&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let m,d;this._leakageMon&&this._listeners.size>=30&&(d=g.create(),m=this._leakageMon.check(d,this._listeners.size+1)),k&&(d=d??g.create());const E=new h(n,r,d),P=this._listeners.push(E);o&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,r);const L=E.subscription.set(()=>{m&&m(),this._disposed||(P(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof I.DisposableStore?i.add(L):Array.isArray(i)&&i.push(L),L}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,n]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,i]=this._deliveryQueue.shift();try{r.invoke(i)}catch(o){(0,f.onUnexpectedError)(o)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class A extends v{async fireAsync(n,r,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const o of this._listeners)this._asyncDeliveryQueue.push([o,n]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[o,m]=this._asyncDeliveryQueue.shift(),d=[],E={...m,token:r,waitUntil:P=>{if(Object.isFrozen(d))throw new Error("waitUntil can NOT be called asynchronous");i&&(P=i(P,o.callback)),d.push(P)}};try{o.invoke(E)}catch(P){(0,f.onUnexpectedError)(P);continue}Object.freeze(d),await Promise.allSettled(d).then(P=>{for(const L of P)L.status==="rejected"&&(0,f.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=A;class _ extends v{constructor(n){super(n);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=_;class a extends _{constructor(n){super(n);this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=a;class l extends v{constructor(n){super(n);this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=l;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const r={event:n,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const i=()=>{this.hasListeners&&this.unhook(r);const o=this.events.indexOf(r);this.events.splice(o,1)};return(0,I.toDisposable)((0,t.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(r=>this.emitter.fire(r))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class c{constructor(){this.buffers=[]}wrapEvent(n){return(r,i,o)=>n(m=>{const d=this.buffers[this.buffers.length-1];d?d.push(()=>r.call(i,m)):r.call(i,m)},void 0,o)}bufferEvents(n){const r=[];this.buffers.push(r);const i=n();return this.buffers.pop(),r.forEach(o=>o()),i}}e.EventBufferer=c;class w{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=I.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(ve[21],we([1,0,3]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,S){const R=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(R)}}});var I;(function(k){function S(R){return R===k.None||R===k.Cancelled||R instanceof T?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=I.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=C}),define(ve[143],we([1,0,21]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new f.CancellationTokenSource,k=this.task(C.token);return this.result={promise:k,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=t;class I{constructor(C){this.computeFn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const k=JSON.stringify(C);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(C)),this.lastCache}}e.LRUCachedComputed=I}),define(ve[94],we([1,0,15,6]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=I;function T(a){const l=a;return l?I(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function C(a,l){return new k(a,l)}e.newWriteableStream=C;class k{constructor(l,u){this.reducer=l,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(u=>u(l))}emitError(l){this.listeners.error.length===0?(0,f.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(u=>u(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,u){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(l,u){if(this.state.destroyed)return;let c;switch(l){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const w=c.indexOf(u);w>=0&&c.splice(w,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(a,l){const u=[];let c;for(;(c=a.read())!==null;)u.push(c);return l(u)}e.consumeReadable=S;function R(a,l,u){const c=[];let w;for(;(w=a.read())!==null&&c.length<u;)c.push(w);return w===null&&c.length>0?l(c):{read:()=>{if(c.length>0)return c.shift();if(typeof w!="undefined"){const s=w;return w=void 0,s}return a.read()}}}e.peekReadable=R;function F(a,l){return new Promise((u,c)=>{const w=[];D(a,{onData:s=>{l&&w.push(s)},onError:s=>{l?c(s):u(void 0)},onEnd:()=>{u(l?l(w):void 0)}})})}e.consumeStream=F;function D(a,l){let u=!1;return a.on("error",c=>{u||l.onError(c)}),a.on("end",()=>{u||l.onEnd()}),a.on("data",c=>{u||l.onData(c)}),(0,t.toDisposable)(()=>u=!0)}e.listenStream=D;function p(a,l){return new Promise((u,c)=>{const w=new t.DisposableStore,s=[],n=o=>{if(s.push(o),s.length>l)return w.dispose(),a.pause(),u({stream:a,buffer:s,ended:!1})},r=o=>c(o),i=()=>u({stream:a,buffer:s,ended:!0});w.add((0,t.toDisposable)(()=>a.removeListener("error",r))),a.on("error",r),w.add((0,t.toDisposable)(()=>a.removeListener("end",i))),a.on("end",i),w.add((0,t.toDisposable)(()=>a.removeListener("data",n))),a.on("data",n)})}e.peekStream=p;function b(a,l){const u=C(l);return u.end(a),u}e.toStream=b;function g(){const a=C(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=g;function h(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}e.toReadable=h;function v(a,l,u){const c=C(u);return D(a,{onData:w=>c.write(l.data(w)),onError:w=>c.error(l.error?l.error(w):w),onEnd:()=>c.end()}),c}e.transform=v;function A(a,l,u){let c=!1;return{read:()=>{const w=l.read();return c?w:(c=!0,w!==null?u([a,w]):a)}}}e.prefixedReadable=A;function _(a,l,u){let c=!1;const w=C(u);return D(l,{onData:s=>c?w.write(s):(c=!0,w.write(u([a,s]))),onError:s=>w.error(s),onEnd:()=>{c||(c=!0,w.write(a)),w.end()}}),w}e.prefixedStream=_}),define(ve[22],we([1,0,94]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let I,T;class C{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return t?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return t&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,d){return!(d?.dontUseNodeBuffer||!1)&&t?new C(Buffer.from(m)):(I||(I=new TextEncoder),new C(I.encode(m)))}static fromByteArray(m){const d=C.alloc(m.length);for(let E=0,P=m.length;E<P;E++)d.buffer[E]=m[E];return d}static concat(m,d){if(typeof d=="undefined"){d=0;for(let L=0,O=m.length;L<O;L++)d+=m[L].byteLength}const E=C.alloc(d);let P=0;for(let L=0,O=m.length;L<O;L++){const y=m[L];E.set(y,P),P+=y.byteLength}return E}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(m,d){return new C(this.buffer.subarray(m,d))}set(m,d){if(m instanceof C)this.buffer.set(m.buffer,d);else if(m instanceof Uint8Array)this.buffer.set(m,d);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),d);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return R(this.buffer,m)}writeUInt32BE(m,d){F(this.buffer,m,d)}readUInt32LE(m){return D(this.buffer,m)}writeUInt32LE(m,d){p(this.buffer,m,d)}readUInt8(m){return b(this.buffer,m)}writeUInt8(m,d){g(this.buffer,m,d)}}e.VSBuffer=C;function k(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0}e.readUInt16LE=k;function S(o,m,d){o[d+0]=m&255,m=m>>>8,o[d+1]=m&255}e.writeUInt16LE=S;function R(o,m){return o[m]*2**24+o[m+1]*2**16+o[m+2]*2**8+o[m+3]}e.readUInt32BE=R;function F(o,m,d){o[d+3]=m,m=m>>>8,o[d+2]=m,m=m>>>8,o[d+1]=m,m=m>>>8,o[d]=m}e.writeUInt32BE=F;function D(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0|o[m+2]<<16>>>0|o[m+3]<<24>>>0}e.readUInt32LE=D;function p(o,m,d){o[d+0]=m&255,m=m>>>8,o[d+1]=m&255,m=m>>>8,o[d+2]=m&255,m=m>>>8,o[d+3]=m&255}e.writeUInt32LE=p;function b(o,m){return o[m]}e.readUInt8=b;function g(o,m,d){o[d]=m}e.writeUInt8=g;function h(o){return f.consumeReadable(o,m=>C.concat(m))}e.readableToBuffer=h;function v(o){return f.toReadable(o)}e.bufferToReadable=v;function A(o){return f.consumeStream(o,m=>C.concat(m))}e.streamToBuffer=A;async function _(o){return o.ended?C.concat(o.buffer):C.concat([...o.buffer,await A(o.stream)])}e.bufferedStreamToBuffer=_;function a(o){return f.toStream(o,m=>C.concat(m))}e.bufferToStream=a;function l(o){return f.transform(o,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.streamToBufferReadableStream=l;function u(o){return f.newWriteableStream(m=>C.concat(m),o)}e.newWriteableBufferStream=u;function c(o,m){return f.prefixedReadable(o,m,d=>C.concat(d))}e.prefixedBufferReadable=c;function w(o,m){return f.prefixedStream(o,m,d=>C.concat(d))}e.prefixedBufferStream=w;function s(o){let m=0,d=0,E=0;const P=new Uint8Array(Math.floor(o.length/4*3)),L=y=>{switch(d){case 3:P[E++]=m|y,d=0;break;case 2:P[E++]=m|y>>>2,m=y<<6,d=3;break;case 1:P[E++]=m|y>>>4,m=y<<4,d=2;break;default:m=y<<2,d=1}};for(let y=0;y<o.length;y++){const H=o.charCodeAt(y);if(H>=65&&H<=90)L(H-65);else if(H>=97&&H<=122)L(H-97+26);else if(H>=48&&H<=57)L(H-48+52);else if(H===43||H===45)L(62);else if(H===47||H===95)L(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${o[y]}`)}}const O=E;for(;d>0;)L(0);return C.wrap(P).slice(0,O)}e.decodeBase64=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function i({buffer:o},m=!0,d=!1){const E=d?r:n;let P="";const L=o.byteLength%3;let O=0;for(;O<o.byteLength-L;O+=3){const y=o[O+0],H=o[O+1],M=o[O+2];P+=E[y>>>2],P+=E[(y<<4|H>>>4)&63],P+=E[(H<<2|M>>>6)&63],P+=E[M&63]}if(L===1){const y=o[O+0];P+=E[y>>>2],P+=E[y<<4&63],m&&(P+="==")}else if(L===2){const y=o[O+0],H=o[O+1];P+=E[y>>>2],P+=E[(y<<4|H>>>4)&63],P+=E[H<<2&63],m&&(P+="=")}return P}e.encodeBase64=i}),define(ve[8],we([1,0,143,89]),function(te,e,f,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=T;const C=/{(\d+)}/g;function k(J,...pe){return pe.length===0?J:J.replace(C,function(Se,Me){const $e=parseInt(Me,10);return isNaN($e)||$e<0||$e>=pe.length?Se:pe[$e]})}e.format=k;const S=/{([^}]+)}/g;function R(J,pe){return J.replace(S,(Se,Me)=>pe[Me]??Se)}e.format2=R;function F(J){return J.replace(/[<>&]/g,function(pe){switch(pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return pe}})}e.escape=F;function D(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function p(J,pe){let Se=0;const Me=pe.charCodeAt(0);for(let $e=J.length-1;$e>=0;$e--)J.charCodeAt($e)===Me&&Se++;return Se}e.count=p;function b(J,pe,Se="\u2026"){return J.length<=pe?J:`${J.substr(0,pe)}${Se}`}e.truncate=b;function g(J,pe=" "){const Se=h(J,pe);return v(Se,pe)}e.trim=g;function h(J,pe){if(!J||!pe)return J;const Se=pe.length;if(Se===0||J.length===0)return J;let Me=0;for(;J.indexOf(pe,Me)===Me;)Me=Me+Se;return J.substring(Me)}e.ltrim=h;function v(J,pe){if(!J||!pe)return J;const Se=pe.length,Me=J.length;if(Se===0||Me===0)return J;let $e=Me,Ye=-1;for(;Ye=J.lastIndexOf(pe,$e-1),!(Ye===-1||Ye+Se!==$e);){if(Ye===0)return"";$e=Ye}return J.substring(0,$e)}e.rtrim=v;function A(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=A;function _(J){return J.replace(/\*/g,"")}e.stripWildcards=_;function a(J,pe,Se={}){if(!J)throw new Error("Cannot create regex from empty string");pe||(J=D(J)),Se.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Me="";return Se.global&&(Me+="g"),Se.matchCase||(Me+="i"),Se.multiline&&(Me+="m"),Se.unicode&&(Me+="u"),new RegExp(J,Me)}e.createRegExp=a;function l(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function u(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function c(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=c;function w(J){return J.split(/\r\n|\r|\n/)}e.splitLines=w;function s(J){for(let pe=0,Se=J.length;pe<Se;pe++){const Me=J.charCodeAt(pe);if(Me!==32&&Me!==9)return pe}return-1}e.firstNonWhitespaceIndex=s;function n(J,pe=0,Se=J.length){for(let Me=pe;Me<Se;Me++){const $e=J.charCodeAt(Me);if($e!==32&&$e!==9)return J.substring(pe,Me)}return J.substring(pe,Se)}e.getLeadingWhitespace=n;function r(J,pe=J.length-1){for(let Se=pe;Se>=0;Se--){const Me=J.charCodeAt(Se);if(Me!==32&&Me!==9)return Se}return-1}e.lastNonWhitespaceIndex=r;function i(J,pe){return J<pe?-1:J>pe?1:0}e.compare=i;function o(J,pe,Se=0,Me=J.length,$e=0,Ye=pe.length){for(;Se<Me&&$e<Ye;Se++,$e++){let wt=J.charCodeAt(Se),je=pe.charCodeAt($e);if(wt<je)return-1;if(wt>je)return 1}const lt=Me-Se,vt=Ye-$e;return lt<vt?-1:lt>vt?1:0}e.compareSubstring=o;function m(J,pe){return d(J,pe,0,J.length,0,pe.length)}e.compareIgnoreCase=m;function d(J,pe,Se=0,Me=J.length,$e=0,Ye=pe.length){for(;Se<Me&&$e<Ye;Se++,$e++){let wt=J.charCodeAt(Se),je=pe.charCodeAt($e);if(wt===je)continue;if(wt>=128||je>=128)return o(J.toLowerCase(),pe.toLowerCase(),Se,Me,$e,Ye);E(wt)&&(wt-=32),E(je)&&(je-=32);const st=wt-je;if(st!==0)return st}const lt=Me-Se,vt=Ye-$e;return lt<vt?-1:lt>vt?1:0}e.compareSubstringIgnoreCase=d;function E(J){return J>=97&&J<=122}e.isLowerAsciiLetter=E;function P(J){return J>=65&&J<=90}e.isUpperAsciiLetter=P;function L(J,pe){return J.length===pe.length&&d(J,pe)===0}e.equalsIgnoreCase=L;function O(J,pe){const Se=pe.length;return pe.length>J.length?!1:d(J,pe,0,Se)===0}e.startsWithIgnoreCase=O;function y(J,pe){let Se,Me=Math.min(J.length,pe.length);for(Se=0;Se<Me;Se++)if(J.charCodeAt(Se)!==pe.charCodeAt(Se))return Se;return Me}e.commonPrefixLength=y;function H(J,pe){let Se,Me=Math.min(J.length,pe.length);const $e=J.length-1,Ye=pe.length-1;for(Se=0;Se<Me;Se++)if(J.charCodeAt($e-Se)!==pe.charCodeAt(Ye-Se))return Se;return Me}e.commonSuffixLength=H;function M(J){return 55296<=J&&J<=56319}e.isHighSurrogate=M;function j(J){return 56320<=J&&J<=57343}e.isLowSurrogate=j;function Q(J,pe){return(J-55296<<10)+(pe-56320)+65536}e.computeCodePoint=Q;function $(J,pe,Se){const Me=J.charCodeAt(Se);if(M(Me)&&Se+1<pe){const $e=J.charCodeAt(Se+1);if(j($e))return Q(Me,$e)}return Me}e.getNextCodePoint=$;function U(J,pe){const Se=J.charCodeAt(pe-1);if(j(Se)&&pe>1){const Me=J.charCodeAt(pe-2);if(M(Me))return Q(Me,Se)}return Se}class q{constructor(pe,Se=0){this._str=pe,this._len=pe.length,this._offset=Se}get offset(){return this._offset}setOffset(pe){this._offset=pe}prevCodePoint(){const pe=U(this._str,this._offset);return this._offset-=pe>=65536?2:1,pe}nextCodePoint(){const pe=$(this._str,this._len,this._offset);return this._offset+=pe>=65536?2:1,pe}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class K{constructor(pe,Se=0){this._iterator=new q(pe,Se)}get offset(){return this._iterator.offset}nextGraphemeLength(){const pe=He.getInstance(),Se=this._iterator,Me=Se.offset;let $e=pe.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Ye=Se.offset,lt=pe.getGraphemeBreakType(Se.nextCodePoint());if(ze($e,lt)){Se.setOffset(Ye);break}$e=lt}return Se.offset-Me}prevGraphemeLength(){const pe=He.getInstance(),Se=this._iterator,Me=Se.offset;let $e=pe.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Ye=Se.offset,lt=pe.getGraphemeBreakType(Se.prevCodePoint());if(ze(lt,$e)){Se.setOffset(Ye);break}$e=lt}return Me-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function G(J,pe){return new K(J,pe).nextGraphemeLength()}e.nextCharLength=G;function ee(J,pe){return new K(J,pe).prevGraphemeLength()}e.prevCharLength=ee;function oe(J,pe){pe>0&&j(J.charCodeAt(pe))&&pe--;const Se=pe+G(J,pe);return[Se-ee(J,Se),Se]}e.getCharContainingOffset=oe;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(J){return ue.test(J)}e.containsRTL=Z;const Y=/^[\t\n\r\x20-\x7E]*$/;function se(J){return Y.test(J)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=de;function ge(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=ge;function Te(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=Te;function Ne(J,pe){if(J.length<pe)return J;const Se=/\b/g;let Me=0;for(;Se.test(J)&&!(J.length-Se.lastIndex<pe);)Me=Se.lastIndex,Se.lastIndex+=1;return J.substring(Me).replace(/^\s/,"")}e.lcut=Ne;const be=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,z=/\x1b\[0?m/g;function B(J){return J&&(J=J.replace(be,""),J=J.replace(Ee,""),J=J.replace(z,"")),J}e.removeAnsiEscapeCodes=B,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function W(J){return N(J)?J.substr(1):J}e.stripUTF8BOM=W;function V(J,pe){if(!J||!pe||J.length<pe.length)return!1;const Se=pe.length,Me=J.toLowerCase();let $e=0,Ye=-1;for(;$e<Se;){const lt=Me.indexOf(pe[$e],Ye+1);if(lt<0)return!1;Ye=lt,$e++}return!0}e.fuzzyContains=V;function re(J,pe=!1){return J?(pe&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=re;function he(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=he;function Ce(J,pe=1){if(pe===0)return"";let Se=-1;do Se=J.indexOf(`
`,Se+1),pe--;while(pe>0&&Se>=0);return Se===-1?J:(J[Se-1]==="\r"&&Se--,J.substr(0,Se))}e.getNLines=Ce;function Ae(J){const pe=90-65+1;return J=J%(2*pe),J<pe?String.fromCharCode(97+J):String.fromCharCode(65+J-pe)}e.singleLetterHash=Ae;function We(J){return He.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=We;function ze(J,pe){return J===0?pe!==5&&pe!==7:J===2&&pe===3?!1:J===4||J===2||J===3||pe===4||pe===2||pe===3?!0:!(J===8&&(pe===8||pe===9||pe===11||pe===12)||(J===11||J===9)&&(pe===9||pe===10)||(J===12||J===10)&&pe===10||pe===5||pe===13||pe===7||J===1||J===13&&pe===14||J===6&&pe===6)}var qe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{constructor(){this._data=Ue()}static getInstance(){return He._INSTANCE||(He._INSTANCE=new He),He._INSTANCE}getGraphemeBreakType(pe){if(pe<32)return pe===10?3:pe===13?2:4;if(pe<127)return 0;const Se=this._data,Me=Se.length/3;let $e=1;for(;$e<=Me;)if(pe<Se[3*$e])$e=2*$e;else if(pe>Se[3*$e+1])$e=2*$e+1;else return Se[3*$e+2];return 0}}He._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(J,pe){if(J===0)return 0;const Se=et(J,pe);if(Se!==void 0)return Se;const Me=new q(pe,J);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Je;function et(J,pe){const Se=new q(pe,J);let Me=Se.prevCodePoint();for(;Le(Me)||Me===65039||Me===8419;){if(Se.offset===0)return;Me=Se.prevCodePoint()}if(!Te(Me))return;let $e=Se.offset;return $e>0&&Se.prevCodePoint()===8205&&($e=Se.offset),$e}function Le(J){return 127995<=J&&J<=127999}var it;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.noBreakWhitespace="\xA0";class ne{constructor(pe){this.confusableDictionary=pe}static getInstance(pe){return ne.cache.get(Array.from(pe))}static getLocales(){return ne._locales.getValue()}isAmbiguous(pe){return this.confusableDictionary.has(pe)}getPrimaryConfusable(pe){return this.confusableDictionary.get(pe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,I=ne,ne.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new f.LRUCachedComputed(J=>{function pe(je){const st=new Map;for(let _t=0;_t<je.length;_t+=2)st.set(je[_t],je[_t+1]);return st}function Se(je,st){const _t=new Map(je);for(const[nt,ct]of st)_t.set(nt,ct);return _t}function Me(je,st){if(!je)return st;const _t=new Map;for(const[nt,ct]of je)st.has(nt)&&_t.set(nt,ct);return _t}const $e=I.ambiguousCharacterData.getValue();let Ye=J.filter(je=>!je.startsWith("_")&&je in $e);Ye.length===0&&(Ye=["_default"]);let lt;for(const je of Ye){const st=pe($e[je]);lt=Me(lt,st)}const vt=pe($e._common),wt=Se(vt,lt);return new ne(wt)}),ne._locales=new t.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(J=>!J.startsWith("_")));class ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ae.getRawData())),this._data}static isInvisibleCharacter(pe){return ae.getData().has(pe)}static get codePoints(){return ae.getData()}}e.InvisibleCharacters=ae,ae._data=void 0}),define(ve[57],we([1,0,8]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(A){return I(A,0)}e.hash=t;function I(A,_){switch(typeof A){case"object":return A===null?T(349,_):Array.isArray(A)?S(A,_):R(A,_);case"string":return k(A,_);case"boolean":return C(A,_);case"number":return T(A,_);case"undefined":return T(937,_);default:return T(617,_)}}e.doHash=I;function T(A,_){return(_<<5)-_+A|0}e.numberHash=T;function C(A,_){return T(A?433:863,_)}function k(A,_){_=T(149417,_);for(let a=0,l=A.length;a<l;a++)_=T(A.charCodeAt(a),_);return _}e.stringHash=k;function S(A,_){return _=T(104579,_),A.reduce((a,l)=>I(l,a),_)}function R(A,_){return _=T(181387,_),Object.keys(A).sort().reduce((a,l)=>(a=k(l,a),I(A[l],a)),_)}class F{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=I(_,this._value),this._value}}e.Hasher=F;var D;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function p(A,_,a=32){const l=a-_,u=~((1<<l)-1);return(A<<_|(u&A)>>>l)>>>0}function b(A,_=0,a=A.byteLength,l=0){for(let u=0;u<a;u++)A[_+u]=l}function g(A,_,a="0"){for(;A.length<_;)A=a+A;return A}function h(A,_=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(a=>a.toString(16).padStart(2,"0")).join(""):g((A>>>0).toString(16),_/4)}e.toHexString=h;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const a=_.length;if(a===0)return;const l=this._buff;let u=this._buffLen,c=this._leftoverHighSurrogate,w,s;for(c!==0?(w=c,s=-1,c=0):(w=_.charCodeAt(0),s=0);;){let n=w;if(f.isHighSurrogate(w))if(s+1<a){const r=_.charCodeAt(s+1);f.isLowSurrogate(r)?(s++,n=f.computeCodePoint(w,r)):n=65533}else{c=w;break}else f.isLowSurrogate(w)&&(n=65533);if(u=this._push(l,u,n),s++,s<a)w=_.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=c}_push(_,a,l){return l<128?_[a++]=l:l<2048?(_[a++]=192|(l&1984)>>>6,_[a++]=128|(l&63)>>>0):l<65536?(_[a++]=224|(l&61440)>>>12,_[a++]=128|(l&4032)>>>6,_[a++]=128|(l&63)>>>0):(_[a++]=240|(l&1835008)>>>18,_[a++]=128|(l&258048)>>>12,_[a++]=128|(l&4032)>>>6,_[a++]=128|(l&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=v._bigBlock32,a=this._buffDV;for(let o=0;o<64;o+=4)_.setUint32(o,a.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)_.setUint32(o,p(_.getUint32(o-12,!1)^_.getUint32(o-32,!1)^_.getUint32(o-56,!1)^_.getUint32(o-64,!1),1),!1);let l=this._h0,u=this._h1,c=this._h2,w=this._h3,s=this._h4,n,r,i;for(let o=0;o<80;o++)o<20?(n=u&c|~u&w,r=1518500249):o<40?(n=u^c^w,r=1859775393):o<60?(n=u&c|u&w|c&w,r=2400959708):(n=u^c^w,r=3395469782),i=p(l,5)+n+s+r+_.getUint32(o*4,!1)&4294967295,s=w,w=c,c=p(u,30),u=l,l=i;this._h0=this._h0+l&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+c&4294967295,this._h3=this._h3+w&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[24],we([1,0,18,8]),function(te,e,f,t){"use strict";var I,T,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(s,n,r){let i=s.get(n);return i===void 0&&(i=r,s.set(n,i)),i}e.getOrSet=k;function S(s){const n=[];return s.forEach((r,i)=>{n.push(`${i} => ${r}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=S;function R(s){const n=[];return s.forEach(r=>{n.push(r)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=R;class F{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return r-i}value(){return this._value[this._pos]}}e.StringIterator=F;class D{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class p{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let r=n.length-1;r>=0;r--,this._valueLen--){const i=this._value.charCodeAt(r);if(!(i===47||this._splitOnBackslash&&i===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var b;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(b||(b={}));class g{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(v||(v={}));class A{constructor(n){this._iter=n}static forUris(n=()=>!1){return new A(new g(n))}static forPaths(n=!1){return new A(new p(void 0,!n))}static forStrings(){return new A(new F)}static forConfigKeys(){return new A(new D)}clear(){this._root=void 0}fill(n,r){if(r){const i=r.slice(0);(0,f.shuffle)(i);for(let o of i)this.set(o,n)}else{const i=n.slice(0);(0,f.shuffle)(i);for(let o of i)this.set(o[0],o[1])}}set(n,r){const i=this._iter.reset(n);let o;this._root||(this._root=new h,this._root.segment=i.value());const m=[];for(o=this._root;;){const E=i.cmp(o.segment);if(E>0)o.left||(o.left=new h,o.left.segment=i.value()),m.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new h,o.right.segment=i.value()),m.push([1,o]),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new h,o.mid.segment=i.value()),m.push([0,o]),o=o.mid;else break}const d=o.value;o.value=r,o.key=n;for(let E=m.length-1;E>=0;E--){const P=m[E][1];P.updateHeight();const L=P.balanceFactor();if(L<-1||L>1){const O=m[E][0],y=m[E+1][0];if(O===1&&y===1)m[E][1]=P.rotateLeft();else if(O===-1&&y===-1)m[E][1]=P.rotateRight();else if(O===1&&y===-1)P.right=m[E+1][1]=m[E+1][1].rotateRight(),m[E][1]=P.rotateLeft();else if(O===-1&&y===1)P.left=m[E+1][1]=m[E+1][1].rotateLeft(),m[E][1]=P.rotateRight();else throw new Error;if(E>0)switch(m[E-1][0]){case-1:m[E-1][1].left=m[E][1];break;case 1:m[E-1][1].right=m[E][1];break;case 0:m[E-1][1].mid=m[E][1];break}else this._root=m[0][1]}}return d}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let i=this._root;for(;i;){const o=r.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else break}return i}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const i=this._iter.reset(n),o=[];let m=this._root;for(;m;){const d=i.cmp(m.segment);if(d>0)o.push([-1,m]),m=m.left;else if(d<0)o.push([1,m]),m=m.right;else if(i.hasNext())i.next(),o.push([0,m]),m=m.mid;else break}if(!!m){if(r?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const d=this._min(m.right),{key:E,value:P,segment:L}=d;this._delete(d.key,!1),m.key=E,m.value=P,m.segment=L}else{const d=m.left??m.right;if(o.length>0){const[E,P]=o[o.length-1];switch(E){case-1:P.left=d;break;case 0:P.mid=d;break;case 1:P.right=d;break}}else this._root=d}for(let d=o.length-1;d>=0;d--){const E=o[d][1];E.updateHeight();const P=E.balanceFactor();if(P>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),o[d][1]=E.rotateLeft()):P<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),o[d][1]=E.rotateRight()),d>0)switch(o[d-1][0]){case-1:o[d-1][1].left=o[d][1];break;case 1:o[d-1][1].right=o[d][1];break;case 0:o[d-1][1].mid=o[d][1];break}else this._root=o[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const r=this._iter.reset(n);let i=this._root,o;for(;i;){const m=r.cmp(i.segment);if(m>0)i=i.left;else if(m<0)i=i.right;else if(r.hasNext())r.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(n){const r=this._iter.reset(n);let i=this._root;for(;i;){const o=r.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[r,i]of this)n(i,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=r=>{if(!r)return!0;const i=r.balanceFactor();return i<-1||i>1?!1:n(r.left)&&n(r.right)};return n(this._root)}}e.TernarySearchTree=A;class _{constructor(n,r){this.uri=n,this.value=r}}class a{constructor(n,r){this[I]="ResourceMap",n instanceof a?(this.map=new Map(n.map),this.toKey=r??a.defaultToKey):(this.map=new Map,this.toKey=n??a.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),new _(n,r)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[i,o]of this.map)n(o.value,o.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=a,a.defaultToKey=s=>s.toString();var l;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class u{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const i=this._map.get(n);if(!!i)return r!==0&&this.touch(i,r),i.value}set(n,r,i=0){let o=this._map.get(n);if(o)o.value=r,i!==0&&this.touch(o,i);else{switch(o={key:n,value:r,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const i=this._state;let o=this._head;for(;o;){if(r?n.bind(r)(o.value,o.key,this):n(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:i.key,done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return o}values(){const n=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:i.value,done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return o}entries(){const n=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const m={value:[i.key,i.value],done:!1};return i=i.next,m}else return{value:void 0,done:!0}}};return o}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,i=this.size;for(;r&&i>n;)this._map.delete(r.key),r=r.next,i--;this._head=r,this._size=i,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,i=n.previous;if(!r||!i)throw new Error("Invalid list");r.previous=i,i.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const i=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const i=n.next,o=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,i)=>{n.push([i,r])}),n}fromJSON(n){this.clear();for(const[r,i]of n)this.set(r,i)}}e.LinkedMap=u;class c extends u{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class w{constructor(n){C.set(this,void 0),Xe(this,C,n,"f")}get size(){return Pe(this,C,"f").size}forEach(n,r){Pe(this,C,"f").forEach(n,r)}get(n){return Pe(this,C,"f").get(n)}has(n){return Pe(this,C,"f").has(n)}entries(){return Pe(this,C,"f").entries()}keys(){return Pe(this,C,"f").keys()}values(){return Pe(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Pe(this,C,"f").entries()}}e.ReadonlyMapView=w}),define(ve[95],we([1,0,24,8]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...N){return function(W,V){for(let re=0,he=N.length;re<he;re++){const Ce=N[re](W,V);if(Ce)return Ce}return null}}e.or=I,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(N,W,V){if(!V||V.length<W.length)return null;let re;return N?re=t.startsWithIgnoreCase(V,W):re=V.indexOf(W)===0,re?W.length>0?[{start:0,end:W.length}]:[]:null}function C(N,W){const V=W.toLowerCase().indexOf(N.toLowerCase());return V===-1?null:[{start:V,end:V+N.length}]}e.matchesContiguousSubString=C;function k(N,W){return S(N.toLowerCase(),W.toLowerCase(),0,0)}e.matchesSubString=k;function S(N,W,V,re){if(V===N.length)return[];if(re===W.length)return null;if(N[V]===W[re]){let he=null;return(he=S(N,W,V+1,re+1))?A({start:re,end:re+1},he):null}return S(N,W,V,re+1)}function R(N){return 97<=N&&N<=122}function F(N){return 65<=N&&N<=90}e.isUpper=F;function D(N){return 48<=N&&N<=57}function p(N){return N===32||N===9||N===10||N===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(N=>b.add(N.charCodeAt(0)));function g(N){return p(N)||b.has(N)}function h(N,W){return N===W||g(N)&&g(W)}function v(N){return R(N)||F(N)||D(N)}function A(N,W){return W.length===0?W=[N]:N.end===W[0].start?W[0].start=N.start:W.unshift(N),W}function _(N,W){for(let V=W;V<N.length;V++){const re=N.charCodeAt(V);if(F(re)||D(re)||V>0&&!v(N.charCodeAt(V-1)))return V}return N.length}function a(N,W,V,re){if(V===N.length)return[];if(re===W.length)return null;if(N[V]!==W[re].toLowerCase())return null;{let he=null,Ce=re+1;for(he=a(N,W,V+1,re+1);!he&&(Ce=_(W,Ce))<W.length;)he=a(N,W,V+1,Ce),Ce++;return he===null?null:A({start:re,end:re+1},he)}}function l(N){let W=0,V=0,re=0,he=0,Ce=0;for(let He=0;He<N.length;He++)Ce=N.charCodeAt(He),F(Ce)&&W++,R(Ce)&&V++,v(Ce)&&re++,D(Ce)&&he++;const Ae=W/N.length,We=V/N.length,ze=re/N.length,qe=he/N.length;return{upperPercent:Ae,lowerPercent:We,alphaPercent:ze,numericPercent:qe}}function u(N){const{upperPercent:W,lowerPercent:V}=N;return V===0&&W>.6}function c(N){const{upperPercent:W,lowerPercent:V,alphaPercent:re,numericPercent:he}=N;return V>.2&&W<.8&&re>.6&&he<.2}function w(N){let W=0,V=0,re=0,he=0;for(let Ce=0;Ce<N.length;Ce++)re=N.charCodeAt(Ce),F(re)&&W++,R(re)&&V++,p(re)&&he++;return(W===0||V===0)&&he===0?N.length<=30:W<=5}function s(N,W){if(!W||(W=W.trim(),W.length===0)||!w(N)||W.length>60)return null;const V=l(W);if(!c(V)){if(!u(V))return null;W=W.toLowerCase()}let re=null,he=0;for(N=N.toLowerCase();he<W.length&&(re=a(N,W,0,he))===null;)he=_(W,he+1);return re}e.matchesCamelCase=s;function n(N,W,V=!1){if(!W||W.length===0)return null;let re=null,he=0;for(N=N.toLowerCase(),W=W.toLowerCase();he<W.length&&(re=r(N,W,0,he,V))===null;)he=i(W,he+1);return re}e.matchesWords=n;function r(N,W,V,re,he){if(V===N.length)return[];if(re===W.length)return null;if(h(N.charCodeAt(V),W.charCodeAt(re))){let Ce=null,Ae=re+1;if(Ce=r(N,W,V+1,re+1,he),!he)for(;!Ce&&(Ae=i(W,Ae))<W.length;)Ce=r(N,W,V+1,Ae,he),Ae++;return Ce===null?null:A({start:re,end:re+1},Ce)}else return null}function i(N,W){for(let V=W;V<N.length;V++)if(g(N.charCodeAt(V))||V>0&&g(N.charCodeAt(V-1)))return V;return N.length}const o=I(e.matchesPrefix,s,C),m=I(e.matchesPrefix,s,k),d=new f.LRUCache(1e4);function E(N,W,V=!1){if(typeof N!="string"||typeof W!="string")return null;let re=d.get(N);re||(re=new RegExp(t.convertSimple2RegExpPattern(N),"i"),d.set(N,re));const he=re.exec(W);return he?[{start:he.index,end:he.index+he[0].length}]:V?m(N,W):o(N,W)}e.matchesFuzzy=E;function P(N,W){const V=ge(N,N.toLowerCase(),0,W,W.toLowerCase(),0,!0);return V?O(V):null}e.matchesFuzzy2=P;function L(N,W,V,re,he,Ce){const Ae=Math.min(13,N.length);for(;V<Ae;V++){const We=ge(N,W,V,re,he,Ce,!1);if(We)return We}return[0,Ce]}e.anyScore=L;function O(N){if(typeof N=="undefined")return[];const W=[],V=N[1];for(let re=N.length-1;re>1;re--){const he=N[re]+V,Ce=W[W.length-1];Ce&&Ce.end===he?Ce.end=he+1:W.push({start:he,end:he+1})}return W}e.createMatches=O;const y=128;function H(){const N=[],W=[];for(let V=0;V<=y;V++)W[V]=0;for(let V=0;V<=y;V++)N.push(W.slice(0));return N}function M(N){const W=[];for(let V=0;V<=N;V++)W[V]=0;return W}const j=M(2*y),Q=M(2*y),$=H(),U=H(),q=H(),K=!1;function G(N,W,V,re,he){function Ce(We,ze,qe=" "){for(;We.length<ze;)We=qe+We;return We}let Ae=` |   |${re.split("").map(We=>Ce(We,3)).join("|")}
`;for(let We=0;We<=V;We++)We===0?Ae+=" |":Ae+=`${W[We-1]}|`,Ae+=N[We].slice(0,he+1).map(ze=>Ce(ze.toString(),3)).join("|")+`
`;return Ae}function ee(N,W,V,re){N=N.substr(W),V=V.substr(re),console.log(G(U,N,N.length,V,V.length)),console.log(G(q,N,N.length,V,V.length)),console.log(G($,N,N.length,V,V.length))}function oe(N,W){if(W<0||W>=N.length)return!1;const V=N.codePointAt(W);switch(V){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(V)}}function ue(N,W){if(W<0||W>=N.length)return!1;switch(N.charCodeAt(W)){case 32:case 9:return!0;default:return!1}}function Z(N,W,V){return W[N]!==V[N]}function Y(N,W,V,re,he,Ce,Ae=!1){for(;W<V&&he<Ce;)N[W]===re[he]&&(Ae&&(j[W]=he),W+=1),he+=1;return W===V}e.isPatternInWord=Y;var se;(function(N){N[N.Diag=1]="Diag",N[N.Left=2]="Left",N[N.LeftLeft=3]="LeftLeft"})(se||(se={}));var de;(function(N){N.Default=[-100,0];function W(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}N.isDefault=W})(de=e.FuzzyScore||(e.FuzzyScore={}));function ge(N,W,V,re,he,Ce,Ae){const We=N.length>y?y:N.length,ze=re.length>y?y:re.length;if(V>=We||Ce>=ze||We-V>ze-Ce||!Y(W,V,We,he,Ce,ze,!0))return;Te(We,ze,V,Ce,W,he);let qe=1,He=1,Ue=V,Je=Ce;const et=[!1];for(qe=1,Ue=V;Ue<We;qe++,Ue++){const J=j[Ue],pe=Q[Ue],Se=Ue+1<We?Q[Ue+1]:ze;for(He=J-Ce+1,Je=J;Je<Se;He++,Je++){let Me=Number.MIN_SAFE_INTEGER,$e=!1;Je<=pe&&(Me=Ne(N,W,Ue,V,re,he,Je,ze,Ce,$[qe-1][He-1]===0,et));let Ye=0;Me!==Number.MAX_SAFE_INTEGER&&($e=!0,Ye=Me+U[qe-1][He-1]);const lt=Je>J,vt=lt?U[qe][He-1]+($[qe][He-1]>0?-5:0):0,wt=Je>J+1&&$[qe][He-1]>0,je=wt?U[qe][He-2]+($[qe][He-2]>0?-5:0):0;if(wt&&(!lt||je>=vt)&&(!$e||je>=Ye))U[qe][He]=je,q[qe][He]=3,$[qe][He]=0;else if(lt&&(!$e||vt>=Ye))U[qe][He]=vt,q[qe][He]=2,$[qe][He]=0;else if($e)U[qe][He]=Ye,q[qe][He]=1,$[qe][He]=$[qe-1][He-1]+1;else throw new Error("not possible")}}if(K&&ee(N,V,re,Ce),!et[0]&&!Ae)return;qe--,He--;const Le=[U[qe][He],Ce];let it=0,ne=0;for(;qe>=1;){let J=He;do{const pe=q[qe][J];if(pe===3)J=J-2;else if(pe===2)J=J-1;else break}while(J>=1);it>1&&W[V+qe-1]===he[Ce+He-1]&&!Z(J+Ce-1,re,he)&&it+1>$[qe][J]&&(J=He),J===He?it++:it=1,ne||(ne=J),qe--,He=J-1,Le.push(He)}ze===We&&(Le[0]+=2);const ae=ne-We;return Le[0]-=ae,Le}e.fuzzyScore=ge;function Te(N,W,V,re,he,Ce){let Ae=N-1,We=W-1;for(;Ae>=V&&We>=re;)he[Ae]===Ce[We]&&(Q[Ae]=We,Ae--),We--}function Ne(N,W,V,re,he,Ce,Ae,We,ze,qe,He){if(W[V]!==Ce[Ae])return Number.MIN_SAFE_INTEGER;let Ue=1,Je=!1;return Ae===V-re?Ue=N[V]===he[Ae]?7:5:Z(Ae,he,Ce)&&(Ae===0||!Z(Ae-1,he,Ce))?(Ue=N[V]===he[Ae]?7:5,Je=!0):oe(Ce,Ae)&&(Ae===0||!oe(Ce,Ae-1))?Ue=5:(oe(Ce,Ae-1)||ue(Ce,Ae-1))&&(Ue=5,Je=!0),Ue>1&&V===re&&(He[0]=!0),Je||(Je=Z(Ae,he,Ce)||oe(Ce,Ae-1)||ue(Ce,Ae-1)),V===re?Ae>ze&&(Ue-=Je?3:5):qe?Ue+=Je?2:0:Ue+=Je?0:1,Ae+1===We&&(Ue-=Je?3:5),Ue}function be(N,W,V,re,he,Ce,Ae){return z(N,W,V,re,he,Ce,!0,Ae)}e.fuzzyScoreGracefulAggressive=be;function Ee(N,W,V,re,he,Ce,Ae){return z(N,W,V,re,he,Ce,!1,Ae)}e.fuzzyScoreGraceful=Ee;function z(N,W,V,re,he,Ce,Ae,We){let ze=ge(N,W,V,re,he,Ce,We);if(ze&&!Ae)return ze;if(N.length>=3){const qe=Math.min(7,N.length-1);for(let He=V+1;He<qe;He++){const Ue=B(N,He);if(Ue){const Je=ge(Ue,Ue.toLowerCase(),V,re,he,Ce,We);Je&&(Je[0]-=3,(!ze||Je[0]>ze[0])&&(ze=Je))}}}return ze}function B(N,W){if(W+1>=N.length)return;const V=N[W],re=N[W+1];if(V!==re)return N.slice(0,W)+re+V+N.slice(W+2)}}),define(ve[144],we([1,0,72,95,8]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(f.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${T.source}`,"g");function S(v){return v.replace(k,(A,_)=>_?A:`\\${A}`)}e.escapeIcons=S;const R=new RegExp(`\\\\${T.source}`,"g");function F(v){return v.replace(R,A=>`\\${A}`)}e.markdownEscapeEscapedIcons=F;const D=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function p(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(D,(A,_,a,l)=>a?A:_||l||"")}e.stripIcons=p;function b(v){const A=v.indexOf(e.iconStartMarker);return A===-1?{text:v}:g(v,A)}e.parseLabelWithIcons=b;function g(v,A){const _=[];let a="";function l(o){if(o){a+=o;for(const m of o)_.push(w)}}let u=-1,c="",w=0,s,n,r=A;const i=v.length;for(l(v.substr(0,A));r<i;)s=v[r],n=v[r+1],s===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(u=r,l(c),c=e.iconStartMarker,r++):s===")"&&u!==-1?(w+=r-u+1,u=-1,c=""):u!==-1?C.test(s)?c+=s:(l(c),u=-1,c=""):l(s),r++;return l(c),{text:a,iconOffsets:_}}function h(v,A,_=!1){const{text:a,iconOffsets:l}=A;if(!l||l.length===0)return(0,t.matchesFuzzy)(v,a,_);const u=(0,I.ltrim)(a," "),c=a.length-u.length,w=(0,t.matchesFuzzy)(v,u,_);if(w)for(const s of w){const n=l[s.start+c]+c;s.start+=n,s.end+=n}return w}e.matchesFuzzyIconAware=h}),define(ve[77],we([1,0,24]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new f.LRUCache(1e4);function I(R){return S(R,"NFC",t)}e.normalizeNFC=I;const T=new f.LRUCache(1e4);function C(R){return S(R,"NFD",T)}e.normalizeNFD=C;const k=/[^\u0000-\u0080]/;function S(R,F,D){if(!R)return R;const p=D.get(R);if(p)return p;let b;return k.test(R)?b=R.normalize(F):b=R,D.set(R,b),b}e.removeAccents=function(){const R=/[\u0300-\u036f]/g;return function(F){return C(F).replace(R,"")}}()}),define(ve[47],we([1,0,8]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const T="error",C="warning",k="warn",S="info",R="ignore";function F(p){return p?f.equalsIgnoreCase(T,p)?I.Error:f.equalsIgnoreCase(C,p)||f.equalsIgnoreCase(k,p)?I.Warning:f.equalsIgnoreCase(S,p)?I.Info:I.Ignore:I.Ignore}I.fromValue=F;function D(p){switch(p){case I.Error:return T;case I.Warning:return C;case I.Info:return S;default:return R}}I.toString=D}(t||(t={})),e.default=t}),define(ve[13],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(i){return Array.isArray(i)}e.isArray=f;function t(i){return typeof i=="string"}e.isString=t;function I(i){return Array.isArray(i)&&i.every(o=>t(o))}e.isStringArray=I;function T(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=T;function C(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=C;function k(i){return!!i&&typeof i[Symbol.iterator]=="function"}e.isIterable=k;function S(i){return i===!0||i===!1}e.isBoolean=S;function R(i){return typeof i=="undefined"}e.isUndefined=R;function F(i){return!D(i)}e.isDefined=F;function D(i){return R(i)||i===null}e.isUndefinedOrNull=D;function p(i,o){if(!i)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=p;function b(i){if(D(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=b;function g(...i){const o=[];for(let m=0;m<i.length;m++){const d=i[m];if(D(d))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);o.push(d)}return o}e.assertAllDefined=g;const h=Object.prototype.hasOwnProperty;function v(i){if(!T(i))return!1;for(let o in i)if(h.call(i,o))return!1;return!0}e.isEmptyObject=v;function A(i){return typeof i=="function"}e.isFunction=A;function _(...i){return i.length>0&&i.every(A)}e.areFunctions=_;function a(i,o){const m=Math.min(i.length,o.length);for(let d=0;d<m;d++)l(i[d],o[d])}e.validateConstraints=a;function l(i,o){if(t(o)){if(typeof i!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(A(o)){try{if(i instanceof o)return}catch{}if(!D(i)&&i.constructor===o||o.length===1&&o.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function u(i){let o=[],m=Object.getPrototypeOf(i);for(;Object.prototype!==m;)o=o.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return o}e.getAllPropertyNames=u;function c(i){const o=[];for(const m of u(i))typeof i[m]=="function"&&o.push(m);return o}e.getAllMethodNames=c;function w(i,o){const m=E=>function(){const P=Array.prototype.slice.call(arguments,0);return o(E,P)};let d={};for(const E of i)d[E]=m(E);return d}e.createProxyObject=w;function s(i){return i===null?void 0:i}e.withNullAsUndefined=s;function n(i){return typeof i=="undefined"?null:i}e.withUndefinedAsNull=n;function r(i,o="Unreachable"){throw new Error(o)}e.assertNever=r}),define(ve[29],we([1,0,9,12,8,13]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function k(r){return r.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=k;function S(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function R(r,i=f.posix.sep){if(!r)return"";const o=r.length,m=r.charCodeAt(0);if(C(m)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let E=3;const P=E;for(;E<o&&!C(r.charCodeAt(E));E++);if(P!==E&&!C(r.charCodeAt(E+1))){for(E+=1;E<o;E++)if(C(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,i)}}return i}else if(A(m)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<o;d++)if(C(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=R;function F(r){if(!t.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let o=2;const m=o;for(;o<r.length&&(i=r.charCodeAt(o),i!==92);o++);return!(m===o||(i=r.charCodeAt(o+1),isNaN(i)||i===92))}e.isUNC=F;const D=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,i=t.isWindows){const o=i?D:p;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||i&&b.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function h(r,i,o){const m=r===i;return!o||m?m:!r||!i?!1:(0,I.equalsIgnoreCase)(r,i)}e.isEqual=h;function v(r,i,o,m=f.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(o){if(!(0,I.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let E=i.length;return i.charAt(i.length-1)===m&&E--,r.charAt(E)===m}return i.charAt(i.length-1)!==m&&(i+=m),r.indexOf(i)===0}e.isEqualOrParent=v;function A(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=A;function _(r,i){return t.isWindows&&r.endsWith(":")&&(r+=f.sep),(0,f.isAbsolute)(r)||(r=(0,f.join)(i,r)),r=(0,f.normalize)(r),t.isWindows?(r=(0,I.rtrim)(r,f.sep),r.endsWith(":")&&(r+=f.sep)):(r=(0,I.rtrim)(r,f.sep),r||(r=f.sep)),r}e.sanitizeFilePath=_;function a(r){const i=(0,f.normalize)(r);return t.isWindows?r.length>3?!1:l(i)&&(r.length===2||i.charCodeAt(2)===92):i===f.posix.sep}e.isRootOrDriveLetter=a;function l(r,i){return(i!==void 0?i:t.isWindows)?A(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function u(r){return l(r)?r[0]:void 0}e.getDriveLetter=u;function c(r,i,o){return i.length>r.length?-1:r===i?0:(o&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=c;function w(r){const i=r.split(":");let o,m,d;for(const E of i){const P=Number(E);(0,T.isNumber)(P)?m===void 0?m=P:d===void 0&&(d=P):o=o?[o,E].join(":"):E}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:m!==void 0?m:void 0,column:d!==void 0?d:m!==void 0?1:void 0}}e.parseLineAndColumnAware=w;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,i,o=8){let m="";for(let E=0;E<o;E++)m+=s.charAt(Math.floor(Math.random()*s.length));let d;return i?d=`${i}-${m}`:d=m,r?(0,f.join)(r,d):d}e.randomPath=n}),define(ve[25],we([1,0,13]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.keys(h).forEach(A=>{h[A]&&typeof h[A]=="object"?v[A]=t(h[A]):v[A]=h[A]}),v}e.deepClone=t;function I(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const A=v.shift();Object.freeze(A);for(const _ in A)if(T.call(A,_)){const a=A[_];typeof a=="object"&&!Object.isFrozen(a)&&v.push(a)}}return h}e.deepFreeze=I;const T=Object.prototype.hasOwnProperty;function C(h,v){return k(h,v,new Set)}e.cloneAndChange=C;function k(h,v,A){if((0,f.isUndefinedOrNull)(h))return h;const _=v(h);if(typeof _!="undefined")return _;if((0,f.isArray)(h)){const a=[];for(const l of h)a.push(k(l,v,A));return a}if((0,f.isObject)(h)){if(A.has(h))throw new Error("Cannot clone recursive data-structure");A.add(h);const a={};for(let l in h)T.call(h,l)&&(a[l]=k(h[l],v,A));return A.delete(h),a}return h}function S(h,v,A=!0){return(0,f.isObject)(h)?((0,f.isObject)(v)&&Object.keys(v).forEach(_=>{_ in h?A&&((0,f.isObject)(h[_])&&(0,f.isObject)(v[_])?S(h[_],v[_],A):h[_]=v[_]):h[_]=v[_]}),h):v}e.mixin=S;function R(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let A,_;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(A=0;A<h.length;A++)if(!R(h[A],v[A]))return!1}else{const a=[];for(_ in h)a.push(_);a.sort();const l=[];for(_ in v)l.push(_);if(l.sort(),!R(a,l))return!1;for(A=0;A<a.length;A++)if(!R(h[a[A]],v[a[A]]))return!1}return!0}e.equals=R;function F(h){const v=new Set;return JSON.stringify(h,(A,_)=>{if((0,f.isObject)(_)||Array.isArray(_)){if(v.has(_))return"[Circular]";v.add(_)}return _})}e.safeStringify=F;function D(h,v,A){const _=v(h);return typeof _=="undefined"?A:_}e.getOrDefault=D;function p(h,v){const A=Object.create(null);return!h||!v||Object.keys(v).forEach(a=>{const l=h[a],u=v[a];R(l,u)||(A[a]=u)}),A}e.distinct=p;function b(h,v){const A=v.toLowerCase(),_=Object.keys(h).find(a=>a.toLowerCase()===A);return _?h[_]:h[v]}e.getCaseInsensitive=b;function g(h,v){const A=Object.create(null);for(const[_,a]of Object.entries(h))v(_,a)&&(A[_]=a);return A}e.filter=g}),define(ve[96],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function t(T){return T<0?0:T>255?255:T|0}e.toUint8=t;function I(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=I}),define(ve[2],we([1,0,9,12]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,T=/^\//,C=/^\/\//;function k(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,n){return!s&&!n?"file":s}function R(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==D&&(n=D+n):n=D;break}return n}const F="",D="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(n,r,i,o,m,d=!1){typeof n=="object"?(this.scheme=n.scheme||F,this.authority=n.authority||F,this.path=n.path||F,this.query=n.query||F,this.fragment=n.fragment||F):(this.scheme=S(n,d),this.authority=r||F,this.path=R(this.scheme,i||F),this.query=o||F,this.fragment=m||F,k(this,d))}static isUri(n){return n instanceof b?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return a(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:i,path:o,query:m,fragment:d}=n;return r===void 0?r=this.scheme:r===null&&(r=F),i===void 0?i=this.authority:i===null&&(i=F),o===void 0?o=this.path:o===null&&(o=F),m===void 0?m=this.query:m===null&&(m=F),d===void 0?d=this.fragment:d===null&&(d=F),r===this.scheme&&i===this.authority&&o===this.path&&m===this.query&&d===this.fragment?this:new h(r,i,o,m,d)}static parse(n,r=!1){const i=p.exec(n);return i?new h(i[2]||F,w(i[4]||F),w(i[5]||F),w(i[7]||F),w(i[9]||F),r):new h(F,F,F,F,F)}static file(n){let r=F;if(t.isWindows&&(n=n.replace(/\\/g,D)),n[0]===D&&n[1]===D){const i=n.indexOf(D,2);i===-1?(r=n.substring(2),n=D):(r=n.substring(2,i),n=n.substring(i)||D)}return new h("file",r,n,F,F)}static from(n){const r=new h(n.scheme,n.authority,n.path,n.query,n.fragment);return k(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let i;return t.isWindows&&n.scheme==="file"?i=b.file(f.win32.join(a(n,!0),...r)).path:i=f.posix.join(n.path,...r),n.with({path:i})}toString(n=!1){return l(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof b)return n;{const r=new h(n);return r._formatted=n.external,r._fsPath=n._sep===g?n.fsPath:null,r}}else return n}}e.URI=b;const g=t.isWindows?1:void 0;class h extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(n=!1){return n?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=g),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(s,n){let r,i=-1;for(let o=0;o<s.length;o++){const m=s.charCodeAt(o);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||n&&m===47)i!==-1&&(r+=encodeURIComponent(s.substring(i,o)),i=-1),r!==void 0&&(r+=s.charAt(o));else{r===void 0&&(r=s.substr(0,o));const d=v[m];d!==void 0?(i!==-1&&(r+=encodeURIComponent(s.substring(i,o)),i=-1),r+=d):i===-1&&(i=o)}}return i!==-1&&(r+=encodeURIComponent(s.substring(i))),r!==void 0?r:s}function _(s){let n;for(let r=0;r<s.length;r++){const i=s.charCodeAt(r);i===35||i===63?(n===void 0&&(n=s.substr(0,r)),n+=v[i]):n!==void 0&&(n+=s[r])}return n!==void 0?n:s}function a(s,n){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=a;function l(s,n){const r=n?_:A;let i="",{scheme:o,authority:m,path:d,query:E,fragment:P}=s;if(o&&(i+=o,i+=":"),(m||o==="file")&&(i+=D,i+=D),m){let L=m.indexOf("@");if(L!==-1){const O=m.substr(0,L);m=m.substr(L+1),L=O.indexOf(":"),L===-1?i+=r(O,!1):(i+=r(O.substr(0,L),!1),i+=":",i+=r(O.substr(L+1),!1)),i+="@"}m=m.toLowerCase(),L=m.indexOf(":"),L===-1?i+=r(m,!1):(i+=r(m.substr(0,L),!1),i+=m.substr(L))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const L=d.charCodeAt(1);L>=65&&L<=90&&(d=`/${String.fromCharCode(L+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const L=d.charCodeAt(0);L>=65&&L<=90&&(d=`${String.fromCharCode(L+32)}:${d.substr(2)}`)}i+=r(d,!0)}return E&&(i+="?",i+=r(E,!1)),P&&(i+="#",i+=n?P:A(P,!1)),i}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(s){return s.match(c)?s.replace(c,n=>u(n)):s}}),define(ve[58],we([1,0,22,8,2]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(R){return JSON.stringify(R,k)}e.stringify=T;function C(R){let F=JSON.parse(R);return F=S(F),F}e.parse=C;function k(R,F){return F instanceof RegExp?{$mid:2,source:F.source,flags:(0,t.regExpFlags)(F)}:F}function S(R,F=0){if(!R||F>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return I.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof f.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let D=0;D<R.length;++D)R[D]=S(R[D],F+1);else for(const D in R)Object.hasOwnProperty.call(R,D)&&(R[D]=S(R[D],F+1))}return R}e.revive=S}),define(ve[10],we([1,0,12,2]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,R,F){this._hosts[S]=R,this._ports[S]=F}setConnectionToken(S,R){this._connectionTokens[S]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(S){if(this._delegate)return this._delegate(S);const R=S.authority;let F=this._hosts[R];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const D=this._ports[R],p=this._connectionTokens[R];let b=`path=${encodeURIComponent(S.path)}`;return typeof p=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),t.URI.from({scheme:f.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${F}:${D}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new T;class C{asBrowserUri(S,R){const F=this.toUri(S,R);return F.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===I.file&&(f.isNative||f.isWebWorker&&f.globals.origin===`${I.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?F.with({scheme:I.vscodeFileResource,authority:F.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(S,R){const F=this.toUri(S,R);return F.scheme===I.vscodeFileResource?F.with({scheme:I.file,authority:F.authority!==C.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(S,R){return t.URI.isUri(S)?S:t.URI.parse(R.toUrl(S))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(ve[23],we([1,0,29,10,9,12,8,2]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(b){return(0,k.uriToFsPath)(b,!0)}e.originalFSPath=S;class R{constructor(g){this._ignorePathCasing=g}compare(g,h,v=!1){return g===h?0:(0,C.compare)(this.getComparisonKey(g,v),this.getComparisonKey(h,v))}isEqual(g,h,v=!1){return g===h?!0:!g||!h?!1:this.getComparisonKey(g,v)===this.getComparisonKey(h,v)}getComparisonKey(g,h=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,h,v=!1){if(g.scheme===h.scheme){if(g.scheme===t.Schemas.file)return f.isEqualOrParent(S(g),S(h),this._ignorePathCasing(g))&&g.query===h.query&&(v||g.fragment===h.fragment);if((0,e.isEqualAuthority)(g.authority,h.authority))return f.isEqualOrParent(g.path,h.path,this._ignorePathCasing(g),"/")&&g.query===h.query&&(v||g.fragment===h.fragment)}return!1}joinPath(g,...h){return k.URI.joinPath(g,...h)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return I.posix.basename(g.path)}extname(g){return I.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let h;return g.scheme===t.Schemas.file?h=k.URI.file(I.dirname(S(g))).path:(h=I.posix.dirname(g.path),g.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),h="/")),g.with({path:h})}normalizePath(g){if(!g.path.length)return g;let h;return g.scheme===t.Schemas.file?h=k.URI.file(I.normalize(S(g))).path:h=I.posix.normalize(g.path),g.with({path:h})}relativePath(g,h){if(g.scheme!==h.scheme||!(0,e.isEqualAuthority)(g.authority,h.authority))return;if(g.scheme===t.Schemas.file){const _=I.relative(S(g),S(h));return T.isWindows?f.toSlashes(_):_}let v=g.path||"/",A=h.path||"/";if(this._ignorePathCasing(g)){let _=0;for(const a=Math.min(v.length,A.length);_<a&&!(v.charCodeAt(_)!==A.charCodeAt(_)&&v.charAt(_).toLowerCase()!==A.charAt(_).toLowerCase());_++);v=A.substr(0,_)+v.substr(_)}return I.posix.relative(v,A)}resolvePath(g,h){if(g.scheme===t.Schemas.file){const v=k.URI.file(I.resolve(S(g),h));return g.with({authority:v.authority,path:v.path})}return h=f.toPosixPath(h),g.with({path:I.posix.resolve(g.path,h)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,h){return g===h||g!==void 0&&h!==void 0&&(0,C.equalsIgnoreCase)(g,h)}hasTrailingPathSeparator(g,h=I.sep){if(g.scheme===t.Schemas.file){const v=S(g);return v.length>f.getRoot(v).length&&v[v.length-1]===h}else{const v=g.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,h=I.sep){return(0,e.hasTrailingPathSeparator)(g,h)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,h=I.sep){let v=!1;if(g.scheme===t.Schemas.file){const A=S(g);v=A!==void 0&&A.length===f.getRoot(A).length&&A[A.length-1]===h}else{h="/";const A=g.path;v=A.length===1&&A.charCodeAt(A.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(g,h)?g.with({path:g.path+"/"}):g}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(b=>b.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new R(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(b,g){const h=[];for(let v=0;v<b.length;v++){const A=g(b[v]);b.some((_,a)=>a===v?!1:(0,e.isEqualOrParent)(A,g(_)))||h.push(b[v])}return h}e.distinctParents=F;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function g(h){const v=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(a=>{const[l,u]=a.split(":");l&&u&&v.set(l,u)});const _=h.path.substring(0,h.path.indexOf(";"));return _&&v.set(b.META_DATA_MIME,_),v}b.parseMetaData=g})(D=e.DataUri||(e.DataUri={}));function p(b,g,h){if(g){let v=b.path;return v&&v[0]!==I.posix.sep&&(v=I.posix.sep+v),b.with({scheme:h,authority:g,path:v})}return b.with({scheme:h})}e.toLocalResource=p}),define(ve[16],we([1,0,21,15,3,6,23,12]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=S;function R(Z){const Y=new f.CancellationTokenSource,se=Z(Y.token),de=new Promise((ge,Te)=>{const Ne=Y.token.onCancellationRequested(()=>{Ne.dispose(),Y.dispose(),Te(new t.CancellationError)});Promise.resolve(se).then(be=>{Ne.dispose(),Y.dispose(),ge(be)},be=>{Ne.dispose(),Y.dispose(),Te(be)})});return new class{cancel(){Y.cancel()}then(ge,Te){return de.then(ge,Te)}catch(ge){return this.then(void 0,ge)}finally(ge){return de.finally(ge)}}}e.createCancelablePromise=R;function F(Z,Y,se){return new Promise((de,ge)=>{const Te=Y.onCancellationRequested(()=>{Te.dispose(),de(se)});Z.then(de,ge).finally(()=>Te.dispose())})}e.raceCancellation=F;function D(Z,Y){return new Promise((se,de)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),de(new t.CancellationError)});Z.then(se,de).finally(()=>ge.dispose())})}e.raceCancellationError=D;async function p(Z){let Y=-1;const se=Z.map((ge,Te)=>ge.then(Ne=>(Y=Te,Ne))),de=await Promise.race(se);return Z.forEach((ge,Te)=>{Te!==Y&&ge.cancel()}),de}e.raceCancellablePromises=p;function b(Z,Y,se){let de;const ge=setTimeout(()=>{de?.(void 0),se?.()},Y);return Promise.race([Z.finally(()=>clearTimeout(ge)),new Promise(Te=>de=Te)])}e.raceTimeout=b;function g(Z){return new Promise((Y,se)=>{const de=Z();S(de)?de.then(Y,se):Y(de)})}e.asPromise=g;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const se=()=>{this.queuedPromise=null;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(se,se).then(de)})}return new Promise((se,de)=>{this.queuedPromise.then(se,de)})}return this.activePromise=Y(),new Promise((se,de)=>{this.activePromise.then(ge=>{this.activePromise=null,se(ge)},ge=>{this.activePromise=null,de(ge)})})}}e.Throttler=h;class v{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=v;class A{constructor(){this.promiseMap=new Map}queue(Y,se){const ge=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.promiseMap.get(Y)===ge&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ge),ge}}e.SequencerByKey=A;const _=(Z,Y)=>{let se=!0;const de=setTimeout(()=>{se=!1,Y()},Z);return{isTriggered:()=>se,dispose:()=>{clearTimeout(de),se=!1}}},a=Z=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,Z())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,se=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,Te)=>{this.doResolve=ge,this.doReject=Te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=se===e.MicrotaskDelay?a(de):_(se,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class u{constructor(Y){this.delayer=new l(Y),this.throttler=new h}trigger(Y,se){return this.delayer.trigger(()=>this.throttler.queue(Y),se)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class c{constructor(){this._isOpen=!1,this._promise=new Promise((Y,se)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class w extends c{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=w;function s(Z,Y){return Y?new Promise((se,de)=>{const ge=setTimeout(()=>{Te.dispose(),se()},Z),Te=Y.onCancellationRequested(()=>{clearTimeout(ge),Te.dispose(),de(new t.CancellationError)})}):R(se=>s(Z,se))}e.timeout=s;function n(Z,Y=0){const se=setTimeout(Z,Y);return(0,T.toDisposable)(()=>clearTimeout(se))}e.disposableTimeout=n;function r(Z){const Y=[];let se=0;const de=Z.length;function ge(){return se<de?Z[se++]():null}function Te(Ne){Ne!=null&&Y.push(Ne);const be=ge();return be?be.then(Te):Promise.resolve(Y)}return Promise.resolve(null).then(Te)}e.sequence=r;function i(Z,Y=de=>!!de,se=null){let de=0;const ge=Z.length,Te=()=>{if(de>=ge)return Promise.resolve(se);const Ne=Z[de++];return Promise.resolve(Ne()).then(Ee=>Y(Ee)?Promise.resolve(Ee):Te())};return Te()}e.first=i;function o(Z,Y=de=>!!de,se=null){if(Z.length===0)return Promise.resolve(se);let de=Z.length;const ge=()=>{de=-1;for(const Te of Z)Te.cancel?.()};return new Promise((Te,Ne)=>{for(const be of Z)be.then(Ee=>{--de>=0&&Y(Ee)?(ge(),Te(Ee)):de===0&&Te(se)}).catch(Ee=>{--de>=0&&(ge(),Ne(Ee))})})}e.firstParallel=o;class m{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((se,de)=>{this.outstandingPromises.push({factory:Y,c:se,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const se=Y.factory();se.then(Y.c,Y.e),se.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class d extends m{constructor(){super(1)}}e.Queue=d;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new q;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,se=C.extUri){const de=se.getComparisonKey(Y);let ge=this.queues.get(de);return ge||(ge=new d,I.Event.once(ge.onFinished)(()=>{ge?.dispose(),this.queues.delete(de),this.onDidQueueFinish()}),this.queues.set(de,ge)),ge}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class P{constructor(Y,se){this._token=-1,typeof Y=="function"&&typeof se=="number"&&this.setIfNotSet(Y,se)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,se){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},se)}setIfNotSet(Y,se){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},se))}}e.TimeoutTimer=P;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,se){this.cancel(),this._token=setInterval(()=>{Y()},se)}}e.IntervalTimer=L;class O{constructor(Y,se){this.timeoutToken=-1,this.runner=Y,this.timeout=se,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class y{constructor(Y,se){se%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=se,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class H extends O{constructor(Y,se){super(Y,se);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class M extends T.Disposable{constructor(Y,se){super();this.options=Y,this.handler=se,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,k.setTimeout0)(()=>{if(Y)return;const se=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(Z,Y)=>{const se=requestIdleCallback(Z,typeof Y=="number"?{timeout:Y}:void 0);let de=!1;return{dispose(){de||(de=!0,cancelIdleCallback(se))}}}}();class j{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(se){this._error=se}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function Q(Z,Y,se){let de;for(let ge=0;ge<se;ge++)try{return await Z()}catch(Te){de=Te,await s(Y)}throw de}e.retry=Q;class ${hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,se,de){return this._pending={taskId:Y,cancel:()=>de?.(),promise:se},se.then(()=>this.donePending(Y),()=>this.donePending(Y)),se}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let se,de;const ge=new Promise((Te,Ne)=>{se=Te,de=Ne});this._next={run:Y,promise:ge,promiseResolve:se,promiseReject:de}}return this._next.promise}}e.TaskSequentializer=$;class U{constructor(Y,se=()=>Date.now()){this.interval=Y,this.nowFn=se,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,se)=>{this.completeCallback=Y,this.errorCallback=se})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(se=>{this.completeCallback(Y),this.resolved=!0,se()})}error(Y){return new Promise(se=>{this.errorCallback(Y),this.rejected=!0,se()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=q;var K;(function(Z){async function Y(de){let ge;const Te=await Promise.all(de.map(Ne=>Ne.then(be=>be,be=>{ge||(ge=be)})));if(typeof ge!="undefined")throw ge;return Te}Z.settled=Y;function se(de){return new Promise(async(ge,Te)=>{try{await de(ge,Te)}catch(Ne){Te(Ne)}})}Z.withAsyncBody=se})(K=e.Promises||(e.Promises={}));var G;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(G||(G={}));class ee{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const se={emitOne:de=>this.emitOne(de),emitMany:de=>this.emitMany(de),reject:de=>this.reject(de)};try{await Promise.resolve(Y(se)),this.resolve()}catch(de){this.reject(de)}finally{se.emitOne=void 0,se.emitMany=void 0,se.reject=void 0}})}static fromArray(Y){return new ee(se=>{se.emitMany(Y)})}static fromPromise(Y){return new ee(async se=>{se.emitMany(await Y)})}static fromPromises(Y){return new ee(async se=>{await Promise.all(Y.map(async de=>se.emitOne(await de)))})}static merge(Y){return new ee(async se=>{await Promise.all(Y.map(async de=>{for await(const ge of de)se.emitOne(ge)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,se){return new ee(async de=>{for await(const ge of Y)de.emitOne(se(ge))})}map(Y){return ee.map(this,Y)}static filter(Y,se){return new ee(async de=>{for await(const ge of Y)se(ge)&&de.emitOne(ge)})}filter(Y){return ee.filter(this,Y)}static coalesce(Y){return ee.filter(Y,se=>!!se)}coalesce(){return ee.coalesce(this)}static async toPromise(Y){const se=[];for await(const de of Y)se.push(de);return se}toPromise(){return ee.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class oe extends ee{constructor(Y,se){super(se);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function ue(Z){const Y=new f.CancellationTokenSource,se=Z(Y.token);return new oe(Y,async de=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),de.reject(new t.CancellationError)});try{for await(const Te of se){if(Y.token.isCancellationRequested)return;de.emitOne(Te)}ge.dispose(),Y.dispose()}catch(Te){ge.dispose(),Y.dispose(),de.reject(Te)}})}e.createCancelableAsyncIterable=ue}),define(ve[97],we([1,0,16,9]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new f.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),T=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(d,E,P=!1){const L=d||"",O=E||"",y=I.value.collator.compare(L,O);return I.value.collatorIsNumeric&&y===0&&L!==O?L<O?-1:1:y}e.compareFileNames=k;function S(d,E){const P=T.value.collator;return d=d||"",E=E||"",u(P,d,E)}e.compareFileNamesDefault=S;function R(d,E){const P=T.value.collator;return d=d||"",E=E||"",n(d,E)||u(P,d,E)}e.compareFileNamesUpper=R;function F(d,E){const P=T.value.collator;return d=d||"",E=E||"",s(d,E)||u(P,d,E)}e.compareFileNamesLower=F;function D(d,E){return d=d||"",E=E||"",d===E?0:d<E?-1:1}e.compareFileNamesUnicode=D;function p(d,E,P=!1){P||(d=d&&d.toLowerCase(),E=E&&E.toLowerCase());const[L,O]=a(d),[y,H]=a(E);return L!==y?L<y?-1:1:O===H?0:O<H?-1:1}e.noIntlCompareFileNames=p;function b(d,E){const[P,L]=a(d),[O,y]=a(E);let H=I.value.collator.compare(L,y);if(H===0){if(I.value.collatorIsNumeric&&L!==y)return L<y?-1:1;if(H=I.value.collator.compare(P,O),I.value.collatorIsNumeric&&H===0&&P!==O)return P<O?-1:1}return H}e.compareFileExtensions=b;function g(d,E){d=d||"",E=E||"";const P=l(d),L=l(E),O=T.value.collator,y=C.value.collator;return u(y,P,L)||u(O,d,E)}e.compareFileExtensionsDefault=g;function h(d,E){d=d||"",E=E||"";const P=l(d),L=l(E),O=T.value.collator,y=C.value.collator;return u(y,P,L)||n(d,E)||u(O,d,E)}e.compareFileExtensionsUpper=h;function v(d,E){d=d||"",E=E||"";const P=l(d),L=l(E),O=T.value.collator,y=C.value.collator;return u(y,P,L)||s(d,E)||u(O,d,E)}e.compareFileExtensionsLower=v;function A(d,E){d=d||"",E=E||"";const P=l(d).toLowerCase(),L=l(E).toLowerCase();return P!==L?P<L?-1:1:d!==E?d<E?-1:1:0}e.compareFileExtensionsUnicode=A;const _=/^(.*?)(\.([^.]*))?$/;function a(d,E=!1){const P=d?_.exec(d):[];let L=[P&&P[1]||"",P&&P[3]||""];return E&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function l(d){const E=d?_.exec(d):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function u(d,E,P){let L=d.compare(E,P);return L!==0?L:E.length!==P.length?E.length<P.length?-1:1:0}function c(d){const E=d.charAt(0);return E.toLocaleUpperCase()!==E}function w(d){const E=d.charAt(0);return E.toLocaleLowerCase()!==E}function s(d,E){return c(d)&&w(E)?-1:w(d)&&c(E)?1:0}function n(d,E){return w(d)&&c(E)?-1:c(d)&&w(E)?1:0}function r(d,E,P=!1){return P||(d=d&&d.toLowerCase(),E=E&&E.toLowerCase()),d===E?0:d<E?-1:1}function i(d,E,P=!1){const L=d.split(t.sep),O=E.split(t.sep),y=L.length-1,H=O.length-1;let M,j;for(let Q=0;;Q++){if(M=y===Q,j=H===Q,M&&j)return k(L[Q],O[Q],P);if(M)return-1;if(j)return 1;const $=r(L[Q],O[Q],P);if($!==0)return $}}e.comparePaths=i;function o(d,E,P){const L=d.toLowerCase(),O=E.toLowerCase(),y=m(d,E,P);if(y)return y;const H=L.endsWith(P),M=O.endsWith(P);if(H!==M)return H?-1:1;const j=k(L,O);return j!==0?j:L.localeCompare(O)}e.compareAnything=o;function m(d,E,P){const L=d.toLowerCase(),O=E.toLowerCase(),y=L.startsWith(P),H=O.startsWith(P);if(y!==H)return y?-1:1;if(y&&H){if(L.length<O.length)return-1;if(L.length>O.length)return 1}return 0}e.compareByPrefix=m}),define(ve[98],we([1,0,97,95,57,9,12,8]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,R=[S,[]];function F($,U,q,K){if(!$||!U)return R;const G=$.length,ee=U.length;if(G<ee)return R;const oe=$.toLowerCase();return D(U,q,ee,$,oe,G,K)}e.scoreFuzzy=F;function D($,U,q,K,G,ee,oe){const ue=[],Z=[];for(let ge=0;ge<q;ge++){const Te=ge*ee,Ne=Te-ee,be=ge>0,Ee=$[ge],z=U[ge];for(let B=0;B<ee;B++){const N=B>0,W=Te+B,V=W-1,re=Ne+B-1,he=N?ue[V]:0,Ce=be&&N?ue[re]:0,Ae=be&&N?Z[re]:0;let We;!Ce&&be?We=0:We=p(Ee,z,K,G,B,Ae),We&&Ce+We>=he&&(oe||be||G.startsWith(U,B))?(Z[W]=Ae+1,ue[W]=Ce+We):(Z[W]=S,ue[W]=he)}}const Y=[];let se=q-1,de=ee-1;for(;se>=0&&de>=0;){const ge=se*ee+de;Z[ge]===S||(Y.push(de),se--),de--}return[ue[q*ee-1],Y.reverse()]}function p($,U,q,K,G,ee){let oe=0;if(!b(U,K[G]))return oe;if(oe+=1,ee>0&&(oe+=ee*5),$===q[G]&&(oe+=1),G===0)oe+=8;else{const ue=g(q.charCodeAt(G-1));ue?oe+=ue:(0,t.isUpper)(q.charCodeAt(G))&&ee===0&&(oe+=2)}return oe}function b($,U){return $===U?!0:$==="/"||$==="\\"?U==="/"||U==="\\":!1}function g($){switch($){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function v($,U,q=0,K=0){const G=U;return G.values&&G.values.length>1?A($,G.values,q,K):_($,U,q,K)}e.scoreFuzzy2=v;function A($,U,q,K){let G=0;const ee=[];for(const oe of U){const[ue,Z]=_($,oe,q,K);if(typeof ue!="number")return h;G+=ue,ee.push(...Z)}return[G,m(ee)]}function _($,U,q,K){const G=(0,t.fuzzyScore)(U.original,U.originalLowercase,q,$,$.toLowerCase(),K,!0);return G?[G[0],(0,t.createMatches)(G)]:h}const a=Object.freeze({score:0}),l=1<<18,u=1<<17,c=1<<16;function w($,U,q,K){const G=K.values?K.values:[K];return(0,I.hash)({[K.normalized]:{values:G.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:$,description:U,allowNonContiguousMatches:q}})}function s($,U,q,K,G){if(!$||!U.normalized)return a;const ee=K.getItemLabel($);if(!ee)return a;const oe=K.getItemDescription($),ue=w(ee,oe,q,U),Z=G[ue];if(Z)return Z;const Y=n(ee,oe,K.getItemPath($),U,q);return G[ue]=Y,Y}e.scoreItemFuzzy=s;function n($,U,q,K,G){const ee=!q||!K.containsPathSeparator;return q&&(C.isLinux?K.pathNormalized===q:(0,k.equalsIgnoreCase)(K.pathNormalized,q))?{score:l,labelMatch:[{start:0,end:$.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:K.values&&K.values.length>1?r($,U,q,K.values,ee,G):i($,U,q,K,ee,G)}function r($,U,q,K,G,ee){let oe=0;const ue=[],Z=[];for(const Y of K){const{score:se,labelMatch:de,descriptionMatch:ge}=i($,U,q,Y,G,ee);if(se===S)return a;oe+=se,de&&ue.push(...de),ge&&Z.push(...ge)}return{score:oe,labelMatch:m(ue),descriptionMatch:m(Z)}}function i($,U,q,K,G,ee){if(G||!U){const[oe,ue]=F($,K.normalized,K.normalizedLowercase,ee&&!K.expectContiguousMatch);if(oe){const Z=(0,t.matchesPrefix)(K.normalized,$);let Y;return Z?(Y=u,Y+=Math.round(K.normalized.length/$.length*100)):Y=c,{score:Y+oe,labelMatch:Z||o(ue)}}}if(U){let oe=U;q&&(oe=`${U}${T.sep}`);const ue=oe.length,Z=`${oe}${$}`,[Y,se]=F(Z,K.normalized,K.normalizedLowercase,ee&&!K.expectContiguousMatch);if(Y){const de=o(se),ge=[],Te=[];return de.forEach(Ne=>{Ne.start<ue&&Ne.end>ue?(ge.push({start:0,end:Ne.end-ue}),Te.push({start:Ne.start,end:ue})):Ne.start>=ue?ge.push({start:Ne.start-ue,end:Ne.end-ue}):Te.push(Ne)}),{score:Y,labelMatch:ge,descriptionMatch:Te}}}return a}function o($){const U=[];if(!$)return U;let q;for(const K of $)q&&q.end===K?q.end+=1:(q={start:K,end:K+1},U.push(q));return U}function m($){const U=$.sort((G,ee)=>G.start-ee.start),q=[];let K;for(const G of U)!K||!d(K,G)?(K=G,q.push(G)):(K.start=Math.min(K.start,G.start),K.end=Math.max(K.end,G.end));return q}function d($,U){return!($.end<U.start||U.end<$.start)}function E($,U,q,K,G,ee){const oe=s($,q,K,G,ee),ue=s(U,q,K,G,ee),Z=oe.score,Y=ue.score;if((Z===l||Y===l)&&Z!==Y)return Z===l?-1:1;if(Z>c||Y>c){if(Z!==Y)return Z>Y?-1:1;if(Z<u&&Y<u){const Ee=L(oe.labelMatch,ue.labelMatch);if(Ee!==0)return Ee}const Ne=G.getItemLabel($)||"",be=G.getItemLabel(U)||"";if(Ne.length!==be.length)return Ne.length-be.length}if(Z!==Y)return Z>Y?-1:1;const se=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,de=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0;if(se&&!de)return-1;if(de&&!se)return 1;const ge=P($,oe,G),Te=P(U,ue,G);return ge&&Te&&ge!==Te?Te>ge?-1:1:O($,U,q,G)}e.compareItemsByFuzzyScore=E;function P($,U,q){let K=-1,G=-1;if(U.descriptionMatch&&U.descriptionMatch.length?K=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(K=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(G=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const ee=q.getItemDescription($);ee&&(G+=ee.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(G=U.descriptionMatch[U.descriptionMatch.length-1].end);return G-K}function L($,U){if(!$&&!U||(!$||!$.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!$||!$.length)return 1;const q=$[0].start,G=$[$.length-1].end-q,ee=U[0].start,ue=U[U.length-1].end-ee;return G===ue?0:ue<G?1:-1}function O($,U,q,K){const G=K.getItemLabel($)||"",ee=K.getItemLabel(U)||"",oe=K.getItemDescription($),ue=K.getItemDescription(U),Z=G.length+(oe?oe.length:0),Y=ee.length+(ue?ue.length:0);if(Z!==Y)return Z-Y;const se=K.getItemPath($),de=K.getItemPath(U);return se&&de&&se.length!==de.length?se.length-de.length:G!==ee?(0,f.compareAnything)(G,ee,q.normalized):oe&&ue&&oe!==ue?(0,f.compareAnything)(oe,ue,q.normalized):se&&de&&se!==de?(0,f.compareAnything)(se,de,q.normalized):0}function y($){return $.startsWith('"')&&$.endsWith('"')}const H=" ";function M($){typeof $!="string"&&($="");const U=$.toLowerCase(),{pathNormalized:q,normalized:K,normalizedLowercase:G}=j($),ee=q.indexOf(T.sep)>=0,oe=y($);let ue;const Z=$.split(H);if(Z.length>1)for(const Y of Z){const se=y(Y),{pathNormalized:de,normalized:ge,normalizedLowercase:Te}=j(Y);ge&&(ue||(ue=[]),ue.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:de,normalized:ge,normalizedLowercase:Te,expectContiguousMatch:se}))}return{original:$,originalLowercase:U,pathNormalized:q,normalized:K,normalizedLowercase:G,values:ue,containsPathSeparator:ee,expectContiguousMatch:oe}}e.prepareQuery=M;function j($){let U;C.isWindows?U=$.replace(/\//g,T.sep):U=$.replace(/\\/g,T.sep);const q=(0,k.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:q,normalizedLowercase:q.toLowerCase()}}function Q($){return Array.isArray($)?M($.map(U=>U.original).join(H)):M($.original)}e.pieceToQuery=Q}),define(ve[32],we([1,0,16,29,24,9,12,8]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",F="[^/\\\\]",D=/\//g;function p(q){switch(q){case 0:return"";case 1:return`${F}*?`;default:return`(?:${R}|${F}+${R}|${R}${F}+)*?`}}function b(q,K){if(!q)return[];const G=[];let ee=!1,oe=!1,ue="";for(const Z of q){switch(Z){case K:if(!ee&&!oe){G.push(ue),ue="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ue+=Z}return ue&&G.push(ue),G}e.splitGlobAware=b;function g(q){if(!q)return"";let K="";const G=b(q,e.GLOB_SPLIT);if(G.every(ee=>ee===e.GLOBSTAR))K=".*";else{let ee=!1;G.forEach((oe,ue)=>{if(oe===e.GLOBSTAR){ee||(K+=p(2),ee=!0);return}let Z=!1,Y="",se=!1,de="";for(const ge of oe){if(ge!=="}"&&Z){Y+=ge;continue}if(se&&(ge!=="]"||!de)){let Te;ge==="-"?Te=ge:(ge==="^"||ge==="!")&&!de?Te="^":ge===e.GLOB_SPLIT?Te="":Te=(0,k.escapeRegExpCharacters)(ge),de+=Te;continue}switch(ge){case"{":Z=!0;continue;case"[":se=!0;continue;case"}":{K+=`(?:${b(Y,",").map(be=>g(be)).join("|")})`,Z=!1,Y="";break}case"]":K+="["+de+"]",se=!1,de="";break;case"?":K+=F;continue;case"*":K+=p(1);continue;default:K+=(0,k.escapeRegExpCharacters)(ge)}}ue<G.length-1&&(G[ue+1]!==e.GLOBSTAR||ue+2<G.length)&&(K+=R),ee=!1})}return K}const h=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,A=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,_=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new I.LRUCache(1e4),c=function(){return!1},w=function(){return null};function s(q,K){if(!q)return w;let G;typeof q!="string"?G=q.pattern:G=q,G=G.trim();const ee=`${G}_${!!K.trimForExclusions}`;let oe=u.get(ee);if(oe)return n(oe,q);let ue;if(h.test(G)){const Z=G.substr(4);oe=function(Y,se){return typeof Y=="string"&&Y.endsWith(Z)?G:null}}else(ue=v.exec(r(G,K)))?oe=i(ue[1],G):(K.trimForExclusions?_:A).test(G)?oe=o(G,K):(ue=a.exec(r(G,K)))?oe=m(ue[1].substr(1),G,!0):(ue=l.exec(r(G,K)))?oe=m(ue[1],G,!1):oe=d(G);return u.set(ee,oe),n(oe,q)}function n(q,K){return typeof K=="string"?q:function(G,ee){return(0,t.isEqualOrParent)(G,K.base,!C.isLinux)?q(G.substr(K.base.length+1),ee):null}}function r(q,K){return K.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function i(q,K){const G=`/${q}`,ee=`\\${q}`,oe=function(Z,Y){return typeof Z!="string"?null:Y?Y===q?K:null:Z===q||Z.endsWith(G)||Z.endsWith(ee)?K:null},ue=[q];return oe.basenames=ue,oe.patterns=[K],oe.allBasenames=ue,oe}function o(q,K){const G=U(q.slice(1,-1).split(",").map(Y=>s(Y,K)).filter(Y=>Y!==w),q),ee=G.length;if(!ee)return w;if(ee===1)return G[0];const oe=function(Y,se){for(let de=0,ge=G.length;de<ge;de++)if(G[de](Y,se))return q;return null},ue=G.find(Y=>!!Y.allBasenames);ue&&(oe.allBasenames=ue.allBasenames);const Z=G.reduce((Y,se)=>se.allPaths?Y.concat(se.allPaths):Y,[]);return Z.length&&(oe.allPaths=Z),oe}function m(q,K,G){const ee=T.sep===T.posix.sep,oe=ee?q:q.replace(D,T.sep),ue=T.sep+oe,Z=T.posix.sep+q,Y=G?function(se,de){return typeof se=="string"&&(se===oe||se.endsWith(ue)||!ee&&(se===q||se.endsWith(Z)))?K:null}:function(se,de){return typeof se=="string"&&(se===oe||!ee&&se===q)?K:null};return Y.allPaths=[(G?"*/":"./")+q],Y}function d(q){try{const K=new RegExp(`^${g(q)}$`);return function(G){return K.lastIndex=0,typeof G=="string"&&K.test(G)?q:null}}catch{return w}}function E(q,K,G){return!q||typeof K!="string"?!1:P(q)(K,void 0,G)}e.match=E;function P(q,K={}){if(!q)return c;if(typeof q=="string"||H(q)){const G=s(q,K);if(G===w)return c;const ee=function(oe,ue){return!!G(oe,ue)};return G.allBasenames&&(ee.allBasenames=G.allBasenames),G.allPaths&&(ee.allPaths=G.allPaths),ee}return Q(q,K)}e.parse=P;function L(q){if(!q)return;let K;return G=>(K||(K=(q()||Promise.resolve([])).then(ee=>ee?y(ee):{})),K.then(ee=>!!ee[G]))}e.hasSiblingPromiseFn=L;function O(q){if(!q)return;let K;return G=>{if(!K){const ee=q();K=ee?y(ee):{}}return!!K[G]}}e.hasSiblingFn=O;function y(q){const K={};for(const G of q)K[G]=!0;return K}function H(q){const K=q;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.isRelativePattern=H;function M(q){return q.allBasenames||[]}e.getBasenameTerms=M;function j(q){return q.allPaths||[]}e.getPathTerms=j;function Q(q,K){const G=U(Object.getOwnPropertyNames(q).map(Y=>$(Y,q[Y],K)).filter(Y=>Y!==w)),ee=G.length;if(!ee)return w;if(!G.some(Y=>!!Y.requiresSiblings)){if(ee===1)return G[0];const Y=function(ge,Te){for(let Ne=0,be=G.length;Ne<be;Ne++){const Ee=G[Ne](ge,Te);if(Ee)return Ee}return null},se=G.find(ge=>!!ge.allBasenames);se&&(Y.allBasenames=se.allBasenames);const de=G.reduce((ge,Te)=>Te.allPaths?ge.concat(Te.allPaths):ge,[]);return de.length&&(Y.allPaths=de),Y}const oe=function(Y,se,de){let ge;for(let Te=0,Ne=G.length;Te<Ne;Te++){const be=G[Te];be.requiresSiblings&&de&&(se||(se=(0,T.basename)(Y)),ge||(ge=se.substr(0,se.length-(0,T.extname)(Y).length)));const Ee=be(Y,se,ge,de);if(Ee)return Ee}return null},ue=G.find(Y=>!!Y.allBasenames);ue&&(oe.allBasenames=ue.allBasenames);const Z=G.reduce((Y,se)=>se.allPaths?Y.concat(se.allPaths):Y,[]);return Z.length&&(oe.allPaths=Z),oe}function $(q,K,G){if(K===!1)return w;const ee=s(q,G);if(ee===w)return w;if(typeof K=="boolean")return ee;if(K){const oe=K.when;if(typeof oe=="string"){const ue=(Z,Y,se,de)=>{if(!de||!ee(Z,Y))return null;const ge=oe.replace("$(basename)",se),Te=de(ge);return(0,f.isThenable)(Te)?Te.then(Ne=>Ne?q:null):Te?q:null};return ue.requiresSiblings=!0,ue}}return ee}function U(q,K){const G=q.filter(Y=>!!Y.basenames);if(G.length<2)return q;const ee=G.reduce((Y,se)=>{const de=se.basenames;return de?Y.concat(de):Y},[]);let oe;if(K){oe=[];for(let Y=0,se=ee.length;Y<se;Y++)oe.push(K)}else oe=G.reduce((Y,se)=>{const de=se.patterns;return de?Y.concat(de):Y},[]);const ue=function(Y,se){if(typeof Y!="string")return null;if(!se){let ge;for(ge=Y.length;ge>0;ge--){const Te=Y.charCodeAt(ge-1);if(Te===47||Te===92)break}se=Y.substr(ge)}const de=ee.indexOf(se);return de!==-1?oe[de]:null};ue.basenames=ee,ue.patterns=oe,ue.allBasenames=ee;const Z=q.filter(Y=>!Y.basenames);return Z.push(ue),Z}}),define(ve[99],we([1,0,15,144,23,2]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(h="",v=!1){if(this.value=h,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(h,v=0){return this.value+=D(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(A,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,v){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=k;function S(g){return R(g)?!g.value:Array.isArray(g)?g.every(S):!0}e.isEmptyMarkdownString=S;function R(g){return g instanceof k?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function F(g,h){return g===h?!0:!g||!h?!1:g.value===h.value&&g.isTrusted===h.isTrusted&&g.supportThemeIcons===h.supportThemeIcons&&g.supportHtml===h.supportHtml&&(g.baseUri===h.baseUri||!!g.baseUri&&!!h.baseUri&&(0,I.isEqual)(T.URI.from(g.baseUri),T.URI.from(h.baseUri)))}e.markdownStringEqual=F;function D(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function p(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=p;function b(g){const h=[],v=g.split("|").map(_=>_.trim());g=v[0];const A=v[1];if(A){const _=/height=(\d+)/.exec(A),a=/width=(\d+)/.exec(A),l=_?_[1]:"",u=a?a[1]:"",c=isFinite(parseInt(u)),w=isFinite(parseInt(l));c&&h.push(`width="${u}"`),w&&h.push(`height="${l}"`)}return{href:g,dimensions:h}}e.parseHrefAndDimensions=b}),define(ve[100],we([1,0,29,10,9,12,23,8,2]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(n,r,i){if(typeof n=="string"&&(n=S.URI.file(n)),i){const m=i.getWorkspaceFolder(n);if(m){const d=i.getWorkspace().folders.length>1;let E;if((0,C.isEqual)(m.uri,n)?E="":E=(0,C.relativePath)(m.uri,n),d){const P=m.name?m.name:(0,C.basename)(m.uri);E=E?P+" \u2022 "+E:P}return E}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(n.fsPath))return(0,I.normalize)(D(n.fsPath));let o=(0,I.normalize)(n.fsPath);return!T.isWindows&&r?.userHome&&(o=b(o,r.userHome.fsPath)),o}e.getPathLabel=R;function F(n){if(!n)return;typeof n=="string"&&(n=S.URI.file(n));const r=(0,C.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return T.isWindows&&(0,f.isRootOrDriveLetter)(r)?D(r):r}e.getBaseLabel=F;function D(n,r){return(0,f.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=D;let p=Object.create(null);function b(n,r){if(T.isWindows||!n||!r)return n;let i=p.original===r?p.normalized:void 0;return i||(i=`${(0,k.rtrim)(r,I.posix.sep)}${I.posix.sep}`,p={original:r,normalized:i}),(T.isLinux?n.startsWith(i):(0,k.startsWithIgnoreCase)(n,i))&&(n=`~/${n.substr(i.length)}`),n}e.tildify=b;function g(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=g;const h="\u2026",v="\\\\",A="~";function _(n,r=I.sep){const i=new Array(n.length);let o=!1;for(let m=0;m<n.length;m++){let d=n[m];if(d===""){i[m]=`.${r}`;continue}if(!d){i[m]=d;continue}o=!0;let E="";d.indexOf(v)===0?(E=d.substr(0,d.indexOf(v)+v.length),d=d.substr(d.indexOf(v)+v.length)):d.indexOf(r)===0?(E=d.substr(0,d.indexOf(r)+r.length),d=d.substr(d.indexOf(r)+r.length)):d.indexOf(A)===0&&(E=d.substr(0,d.indexOf(A)+A.length),d=d.substr(d.indexOf(A)+A.length));const P=d.split(r);for(let L=1;o&&L<=P.length;L++)for(let O=P.length-L;o&&O>=0;O--){o=!1;let y=P.slice(O,O+L).join(r);for(let H=0;!o&&H<n.length;H++)if(H!==m&&n[H]&&n[H].indexOf(y)>-1){const M=O+L===P.length,j=O>0&&n[H].indexOf(r)>-1?r+y:y,Q=n[H].endsWith(j);o=!M||Q}if(!o){let H="";(P[0].endsWith(":")||E!=="")&&(O===1&&(O=0,L++,y=P[0]+r+y),O>0&&(H=P[0]+r),H=E+H),O>0&&(H=H+h+r),H=H+y,O+L<P.length&&(H=H+r+h),i[m]=H}}o&&(i[m]=d)}return i}e.shorten=_;var a;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function l(n,r=Object.create(null)){const i=[];let o=!1,m="";for(const d of n)if(d==="$"||o&&d==="{")m&&i.push({value:m,type:a.TEXT}),m="",o=!0;else if(d==="}"&&o){const E=r[m];if(typeof E=="string")E.length&&i.push({value:E,type:a.VARIABLE});else if(E){const P=i[i.length-1];(!P||P.type!==a.SEPARATOR)&&i.push({value:E.label,type:a.SEPARATOR})}m="",o=!1}else m+=d;return m&&!o&&i.push({value:m,type:a.TEXT}),i.filter((d,E)=>{if(d.type===a.SEPARATOR){const P=i[E-1],L=i[E+1];return[P,L].every(O=>O&&(O.type===a.VARIABLE||O.type===a.TEXT)&&O.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=l;function u(n,r){return T.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):n.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function c(n,r){return T.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):T.isWindows?n.replace(/&&|&/g,i=>i==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function w(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=w;function s(n){const r=n.indexOf("/")!==-1?I.posix:I.win32,i=r.basename(n),o=r.dirname(n);return i.length?{name:i,parentPath:o}:{name:o,parentPath:""}}e.splitName=s}),define(ve[101],we([1,0,2]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class I{constructor(D){this._uriTransformer=D}transformIncoming(D){const p=this._uriTransformer.transformIncoming(D);return p===D?D:t(f.URI.from(p))}transformOutgoing(D){const p=this._uriTransformer.transformOutgoing(D);return p===D?D:t(f.URI.from(p))}transformOutgoingURI(D){const p=this._uriTransformer.transformOutgoing(D);return p===D?D:f.URI.from(p)}transformOutgoingScheme(D){return this._uriTransformer.transformOutgoingScheme(D)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function T(F,D,p){if(!F||p>200)return null;if(typeof F=="object"){if(F instanceof f.URI)return D.transformOutgoing(F);for(let b in F)if(Object.hasOwnProperty.call(F,b)){const g=T(F[b],D,p+1);g!==null&&(F[b]=g)}}return null}function C(F,D){const p=T(F,D,0);return p===null?F:p}e.transformOutgoingURIs=C;function k(F,D,p,b){if(!F||b>200)return null;if(typeof F=="object"){if(F.$mid===1)return p?f.URI.revive(D.transformIncoming(F)):D.transformIncoming(F);for(let g in F)if(Object.hasOwnProperty.call(F,g)){const h=k(F[g],D,p,b+1);h!==null&&(F[g]=h)}}return null}function S(F,D){const p=k(F,D,!1,0);return p===null?F:p}e.transformIncomingURIs=S;function R(F,D){const p=k(F,D,!0,0);return p===null?F:p}e.transformAndReviveIncomingURIs=R}),define(ve[33],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(S){return f.test(S)}e.isUUID=t;const I=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(S){for(let R=0;R<S.length;R++)S[R]=Math.floor(Math.random()*256);return S};function k(){C(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let S=0,R="";return R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+="-",R+=T[I[S++]],R+=T[I[S++]],R+="-",R+=T[I[S++]],R+=T[I[S++]],R+="-",R+=T[I[S++]],R+=T[I[S++]],R+="-",R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R}e.generateUuid=k}),define(ve[145],we([1,0,102]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(T="utf8"){this.stringDecoder=new f.StringDecoder(T),this.remaining=null}write(T){const C=[],k=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(k.length<1)return C;let S=0,R,F=S;for(;F<k.length;)if(R=k.charCodeAt(F),R===13||R===10){if(C.push(k.substring(S,F)),F++,F<k.length){const D=R;R=k.charCodeAt(F),(D===13&&R===10||D===10&&R===13)&&F++}S=F}else F++;return this.remaining=S<k.length?k.substr(S):null,C}end(){return this.remaining}}e.LineDecoder=t}),define(ve[28],we([1,0,59,60,291,16,29,77,9,12,23,2]),function(te,e,f,t,I,T,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function b(M,j=p.UNLINK){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return j===p.UNLINK?h(M):g(M)}async function g(M){try{const j=(0,C.randomPath)((0,t.tmpdir)());try{await f.promises.rename(M,j)}catch{return h(M)}h(j).catch(Q=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function h(M){return(0,I.promisify)(f.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function v(M){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");f.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function A(M,j){return l(await(j?_(M):(0,I.promisify)(f.readdir)(M)))}async function _(M){try{return await(0,I.promisify)(f.readdir)(M,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const j=[],Q=await A(M);for(const $ of Q){let U=!1,q=!1,K=!1;try{const G=await e.Promises.lstat((0,S.join)(M,$));U=G.isFile(),q=G.isDirectory(),K=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}j.push({name:$,isFile:()=>U,isDirectory:()=>q,isSymbolicLink:()=>K})}return j}function a(M){return l(f.readdirSync(M))}e.readdirSync=a;function l(M){return M.map(j=>typeof j=="string"?R.isMacintosh?(0,k.normalizeNFC)(j):j:(j.name=R.isMacintosh?(0,k.normalizeNFC)(j.name):j.name,j))}async function u(M){const j=await A(M),Q=[];for(const $ of j)await w.existsDirectory((0,S.join)(M,$))&&Q.push($);return Q}function c(M,j=1e3){return new Promise(Q=>{let $=!1;const U=setInterval(()=>{$||($=!0,f.access(M,q=>{$=!1,q&&(clearInterval(U),Q(void 0))}))},j)})}e.whenDeleted=c;var w;(function(M){async function j(U){let q;try{if(q=await e.Promises.lstat(U),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(R.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw G}throw K}}M.stat=j;async function Q(U){try{const{stat:q,symbolicLink:K}=await M.stat(U);return q.isFile()&&K?.dangling!==!0}catch{}return!1}M.existsFile=Q;async function $(U){try{const{stat:q,symbolicLink:K}=await M.stat(U);return q.isDirectory()&&K?.dangling!==!0}catch{}return!1}M.existsDirectory=$})(w=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new T.ResourceQueue;function n(M,j,Q){return s.queueFor(D.URI.file(M),F.extUriBiasedIgnorePathCase).queue(()=>{const $=m(Q);return new Promise((U,q)=>i(M,j,$,K=>K?q(K):U()))})}let r=!0;function i(M,j,Q,$){if(!r)return f.writeFile(M,j,{mode:Q.mode,flag:Q.flag},$);f.open(M,Q.flag,Q.mode,(U,q)=>{if(U)return $(U);f.writeFile(q,j,K=>{if(K)return f.close(q,()=>$(K));f.fdatasync(q,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),r=!1),f.close(q,ee=>$(ee))))})})}function o(M,j,Q){const $=m(Q);if(!r)return f.writeFileSync(M,j,{mode:$.mode,flag:$.flag});const U=f.openSync(M,$.flag,$.mode);try{f.writeFileSync(U,j);try{f.fdatasyncSync(U)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r=!1}}finally{f.closeSync(U)}}e.writeFileSync=o;function m(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function d(M,j){if(M!==j)try{await e.Promises.rename(M,j)}catch(Q){if(M.toLowerCase()!==j.toLowerCase()&&Q.code==="EXDEV"||M.endsWith("."))await E(M,j,{preserveSymlinks:!1}),await b(M,p.MOVE);else throw Q}}async function E(M,j,Q){return L(M,j,{root:{source:M,target:j},options:Q,handledSourcePaths:new Set})}const P=511;async function L(M,j,Q){if(Q.handledSourcePaths.has(M))return;Q.handledSourcePaths.add(M);const{stat:$,symbolicLink:U}=await w.stat(M);if(U){if(Q.options.preserveSymlinks)try{return await H(M,j,Q)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(U.dangling)return}return $.isDirectory()?O(M,j,$.mode&P,Q):y(M,j,$.mode&P)}async function O(M,j,Q,$){await e.Promises.mkdir(j,{recursive:!0,mode:Q});const U=await A(M);for(const q of U)await L((0,S.join)(M,q),(0,S.join)(j,q),$)}async function y(M,j,Q){await e.Promises.copyFile(M,j),await e.Promises.chmod(j,Q)}async function H(M,j,Q){let $=await e.Promises.readlink(M);(0,C.isEqualOrParent)($,Q.root.source,!R.isLinux)&&($=(0,S.join)(Q.root.target,$.substr(Q.root.source.length+1))),await e.Promises.symlink($,j)}e.Promises=new class{get access(){return(0,I.promisify)(f.access)}get stat(){return(0,I.promisify)(f.stat)}get lstat(){return(0,I.promisify)(f.lstat)}get utimes(){return(0,I.promisify)(f.utimes)}get read(){return(M,j,Q,$,U)=>new Promise((q,K)=>{f.read(M,j,Q,$,U,(G,ee,oe)=>G?K(G):q({bytesRead:ee,buffer:oe}))})}get readFile(){return(0,I.promisify)(f.readFile)}get write(){return(M,j,Q,$,U)=>new Promise((q,K)=>{f.write(M,j,Q,$,U,(G,ee,oe)=>G?K(G):q({bytesWritten:ee,buffer:oe}))})}get appendFile(){return(0,I.promisify)(f.appendFile)}get fdatasync(){return(0,I.promisify)(f.fdatasync)}get truncate(){return(0,I.promisify)(f.truncate)}get rename(){return(0,I.promisify)(f.rename)}get copyFile(){return(0,I.promisify)(f.copyFile)}get open(){return(0,I.promisify)(f.open)}get close(){return(0,I.promisify)(f.close)}get symlink(){return(0,I.promisify)(f.symlink)}get readlink(){return(0,I.promisify)(f.readlink)}get chmod(){return(0,I.promisify)(f.chmod)}get mkdir(){return(0,I.promisify)(f.mkdir)}get unlink(){return(0,I.promisify)(f.unlink)}get rmdir(){return(0,I.promisify)(f.rmdir)}get realpath(){return(0,I.promisify)(f.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return A}get readDirsInDir(){return u}get writeFile(){return n}get rm(){return b}get move(){return d}get copy(){return E}}}),define(ve[103],we([1,0,59,9,12,8,28]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(p){if(I.isLinux)return p;const b=(0,t.dirname)(p);if(p===b)return p;const g=((0,t.basename)(p)||p).toLowerCase();try{const v=(0,C.readdirSync)(b).filter(A=>A.toLowerCase()===g);if(v.length===1){const A=k(b);if(A)return(0,t.join)(A,v[0])}else if(v.length>1){const A=v.indexOf(g);if(A>=0){const _=k(b);if(_)return(0,t.join)(_,v[A])}}}catch{}return null}e.realcaseSync=k;async function S(p){if(I.isLinux)return p;const b=(0,t.dirname)(p);if(p===b)return p;const g=((0,t.basename)(p)||p).toLowerCase();try{const v=(await C.Promises.readdir(b)).filter(A=>A.toLowerCase()===g);if(v.length===1){const A=await S(b);if(A)return(0,t.join)(A,v[0])}else if(v.length>1){const A=v.indexOf(g);if(A>=0){const _=await S(b);if(_)return(0,t.join)(_,v[A])}}}catch{}return null}e.realcase=S;async function R(p){try{return await C.Promises.realpath(p)}catch{const g=D(p);return await C.Promises.access(g,f.constants.R_OK),g}}e.realpath=R;function F(p){try{return f.realpathSync(p)}catch{const g=D(p);return f.accessSync(g,f.constants.R_OK),g}}e.realpathSync=F;function D(p){return(0,T.rtrim)((0,t.normalize)(p),t.sep)}});var Be=this&&this.__decorate||function(te,e,f,t){var I=arguments.length,T=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,f):t,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(te,e,f,t);else for(var k=te.length-1;k>=0;k--)(C=te[k])&&(T=(I<3?C(T):I>3?C(e,f,T):C(e,f))||T);return I>3&&T&&Object.defineProperty(e,f,T),T};define(ve[104],we([1,0,18,16,22,21,56,15,3,6,58,8,13]),function(te,e,f,t,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function g(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function v(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(A||(A={}));class _{constructor(K){this.buffer=K,this.pos=0}read(K){const G=this.buffer.slice(this.pos,this.pos+K);return this.pos+=G.byteLength,G}}class a{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}var l;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(l||(l={}));function u(q){const K=I.VSBuffer.alloc(4);return K.writeUInt32BE(q,0),K}function c(q){return q.read(4).readUInt32BE(0)}function w(q){const K=I.VSBuffer.alloc(1);return K.writeUInt8(q,0),K}const s={Undefined:w(l.Undefined),String:w(l.String),Buffer:w(l.Buffer),VSBuffer:w(l.VSBuffer),Array:w(l.Array),Object:w(l.Object)},n=typeof Buffer!="undefined";function r(q,K){if(typeof K=="undefined")q.write(s.Undefined);else if(typeof K=="string"){const G=I.VSBuffer.fromString(K);q.write(s.String),q.write(u(G.byteLength)),q.write(G)}else if(n&&Buffer.isBuffer(K)){const G=I.VSBuffer.wrap(K);q.write(s.Buffer),q.write(u(G.byteLength)),q.write(G)}else if(K instanceof I.VSBuffer)q.write(s.VSBuffer),q.write(u(K.byteLength)),q.write(K);else if(Array.isArray(K)){q.write(s.Array),q.write(u(K.length));for(const G of K)r(q,G)}else{const G=I.VSBuffer.fromString(JSON.stringify(K));q.write(s.Object),q.write(u(G.byteLength)),q.write(G)}}function i(q){switch(q.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return q.read(c(q)).toString();case l.Buffer:return q.read(c(q)).buffer;case l.VSBuffer:return q.read(c(q));case l.Array:{const G=c(q),ee=[];for(let oe=0;oe<G;oe++)ee.push(i(q));return ee}case l.Object:return JSON.parse(q.read(c(q)).toString())}}class o{constructor(K,G,ee=null,oe=1e3){this.protocol=K,this.ctx=G,this.logger=ee,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ue=>this.onRawMessage(ue)),this.sendResponse({type:200})}registerChannel(K,G){this.channels.set(K,G),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const G=this.send([K.type]);this.logger?.logOutgoing(G,0,1,v(K.type));return}case 201:case 202:case 204:case 203:{const G=this.send([K.type,K.id],K.data);this.logger?.logOutgoing(G,K.id,1,v(K.type),K.data);return}}}send(K,G=void 0){const ee=new a;return r(ee,K),r(ee,G),this.sendBuffer(ee.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onRawMessage(K){const G=new _(K),ee=i(G),oe=i(G),ue=ee[0];switch(ue){case 100:return this.logger?.logIncoming(K.byteLength,ee[1],1,`${g(ue)}: ${ee[2]}.${ee[3]}`,oe),this.onPromise({type:ue,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.logger?.logIncoming(K.byteLength,ee[1],1,`${g(ue)}: ${ee[2]}.${ee[3]}`,oe),this.onEventListen({type:ue,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.logger?.logIncoming(K.byteLength,ee[1],1,`${g(ue)}`),this.disposeActiveRequest({type:ue,id:ee[1]});case 103:return this.logger?.logIncoming(K.byteLength,ee[1],1,`${g(ue)}`),this.disposeActiveRequest({type:ue,id:ee[1]})}}onPromise(K){const G=this.channels.get(K.channelName);if(!G){this.collectPendingRequest(K);return}const ee=new T.CancellationTokenSource;let oe;try{oe=G.call(this.ctx,K.name,K.arg,ee.token)}catch(Y){oe=Promise.reject(Y)}const ue=K.id;oe.then(Y=>{this.sendResponse({id:ue,data:Y,type:201}),this.activeRequests.delete(K.id)},Y=>{Y instanceof Error?this.sendResponse({id:ue,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ue,data:Y,type:203}),this.activeRequests.delete(K.id)});const Z=(0,R.toDisposable)(()=>ee.cancel());this.activeRequests.set(K.id,Z)}onEventListen(K){const G=this.channels.get(K.channelName);if(!G){this.collectPendingRequest(K);return}const ee=K.id,ue=G.listen(this.ctx,K.name,K.arg)(Z=>this.sendResponse({id:ee,data:Z,type:204}));this.activeRequests.set(K.id,ue)}disposeActiveRequest(K){const G=this.activeRequests.get(K.id);G&&(G.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let G=this.pendingRequests.get(K.channelName);G||(G=[],this.pendingRequests.set(K.channelName,G));const ee=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:K,timeoutTimer:ee})}flushPendingRequests(K){const G=this.pendingRequests.get(K);if(G){for(const ee of G)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var m;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(K,G=null){this.protocol=K,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=G}getChannel(K){const G=this;return{call(ee,oe,ue){return G.isDisposed?Promise.reject(k.canceled()):G.requestPromise(K,ee,oe,ue)},listen(ee,oe){return G.isDisposed?S.Event.None:G.requestEvent(K,ee,oe)}}}requestPromise(K,G,ee,oe=T.CancellationToken.None){const ue=this.lastRequestId++,Y={id:ue,type:100,channelName:K,name:G,arg:ee};if(oe.isCancellationRequested)return Promise.reject(k.canceled());let se;return new Promise((ge,Te)=>{if(oe.isCancellationRequested)return Te(k.canceled());const Ne=()=>{const B=N=>{switch(N.type){case 201:this.handlers.delete(ue),ge(N.data);break;case 202:{this.handlers.delete(ue);const W=new Error(N.data.message);W.stack=N.data.stack,W.name=N.data.name,Te(W);break}case 203:this.handlers.delete(ue),Te(N.data);break}};this.handlers.set(ue,B),this.sendRequest(Y)};let be=null;this.state===A.Idle?Ne():(be=(0,t.createCancelablePromise)(B=>this.whenInitialized()),be.then(()=>{be=null,Ne()}));const Ee=()=>{be?(be.cancel(),be=null):this.sendRequest({id:ue,type:101}),Te(k.canceled())},z=oe.onCancellationRequested(Ee);se=(0,R.combinedDisposable)((0,R.toDisposable)(Ee),z),this.activeRequests.add(se)}).finally(()=>{this.activeRequests.delete(se)})}requestEvent(K,G,ee){const oe=this.lastRequestId++,Z={id:oe,type:102,channelName:K,name:G,arg:ee};let Y=null;const se=new S.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ge=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(se),this.sendRequest(Z)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(se),this.sendRequest({id:oe,type:103}))}}),de=ge=>se.fire(ge.data);return this.handlers.set(oe,de),se.event}sendRequest(K){switch(K.type){case 100:case 102:{const G=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger&&this.logger.logOutgoing(G,K.id,0,`${g(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const G=this.send([K.type,K.id]);this.logger&&this.logger.logOutgoing(G,K.id,0,g(K.type));return}}}send(K,G=void 0){const ee=new a;return r(ee,K),r(ee,G),this.sendBuffer(ee.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onBuffer(K){const G=new _(K),ee=i(G),oe=i(G),ue=ee[0];switch(ue){case 200:return this.logger&&this.logger.logIncoming(K.byteLength,0,0,v(ue)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(K.byteLength,ee[1],0,v(ue),oe),this.onResponse({type:ee[0],id:ee[1],data:oe})}}onResponse(K){if(K.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(K.id);G&&G(K)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Be([C.memoize],d.prototype,"onDidInitializePromise",null),e.ChannelClient=d;class E{constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,K(({protocol:G,onDidClientDisconnect:ee})=>{S.Event.once(G.onMessage)(ue=>{const Z=new _(ue),Y=i(Z),se=new o(G,Y),de=new d(G);this.channels.forEach((Te,Ne)=>se.registerChannel(Ne,Te));const ge={channelServer:se,channelClient:de,ctx:Y};this._connections.add(ge),this._onDidAddConnection.fire(ge),ee(()=>{se.dispose(),de.dispose(),this._connections.delete(ge),this._onDidRemoveConnection.fire(ge)})})})}get connections(){const K=[];return this._connections.forEach(G=>K.push(G)),K}getChannel(K,G){const ee=this;return{call(oe,ue,Z){let Y;if((0,p.isFunction)(G)){let de=(0,f.getRandomElement)(ee.connections.filter(G));Y=de?Promise.resolve(de):S.Event.toPromise(S.Event.filter(ee.onDidAddConnection,G))}else Y=G.routeCall(ee,oe,ue);const se=Y.then(de=>de.channelClient.getChannel(K));return L(se).call(oe,ue,Z)},listen(oe,ue){if((0,p.isFunction)(G))return ee.getMulticastEvent(K,G,oe,ue);const Z=G.routeEvent(ee,oe,ue).then(Y=>Y.channelClient.getChannel(K));return L(Z).listen(oe,ue)}}}getMulticastEvent(K,G,ee,oe){const ue=this;let Z=new R.DisposableStore;const Y=new S.Emitter({onFirstListenerAdd:()=>{Z=new R.DisposableStore;const se=new S.EventMultiplexer,de=new Map,ge=Ne=>{const Ee=Ne.channelClient.getChannel(K).listen(ee,oe),z=se.add(Ee);de.set(Ne,z)},Te=Ne=>{const be=de.get(Ne);!be||(be.dispose(),de.delete(Ne))};ue.connections.filter(G).forEach(ge),S.Event.filter(ue.onDidAddConnection,G)(ge,void 0,Z),ue.onDidRemoveConnection(Te,void 0,Z),se.event(Y.fire,Y,Z),Z.add(se)},onLastListenerRemove:()=>{Z.dispose()}});return Y.event}registerChannel(K,G){this.channels.set(K,G),this._connections.forEach(ee=>{ee.channelServer.registerChannel(K,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class P{constructor(K,G,ee=null){const oe=new a;r(oe,G),K.send(oe.buffer),this.channelClient=new d(K,ee),this.channelServer=new o(K,G,ee)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,G){this.channelServer.registerChannel(K,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function L(q){return{call(K,G,ee){return q.then(oe=>oe.call(K,G,ee))},listen(K,G){const ee=new S.Relay;return q.then(oe=>ee.input=oe.listen(K,G)),ee.event}}}e.getDelayedChannel=L;function O(q){let K=!1;return{call(G,ee,oe){return K?q.call(G,ee,oe):(0,t.timeout)(0).then(()=>K=!0).then(()=>q.call(G,ee,oe))},listen(G,ee){if(K)return q.listen(G,ee);const oe=new S.Relay;return(0,t.timeout)(0).then(()=>K=!0).then(()=>oe.input=q.listen(G,ee)),oe.event}}}e.getNextTickChannel=O;class y{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const G of K.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await S.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=y;var H;(function(q){function K(ue,Z){const Y=ue,se=Z&&Z.disableMarshalling,de=new Map;for(const ge in Y)ee(ge)&&de.set(ge,S.Event.buffer(Y[ge],!0));return new class{listen(ge,Te,Ne){const be=de.get(Te);if(be)return be;if(oe(Te)){const Ee=Y[Te];if(typeof Ee=="function")return Ee.call(Y,Ne)}throw new Error(`Event not found: ${Te}`)}call(ge,Te,Ne){const be=Y[Te];if(typeof be=="function"){if(!se&&Array.isArray(Ne))for(let Ee=0;Ee<Ne.length;Ee++)Ne[Ee]=(0,F.revive)(Ne[Ee]);return be.apply(Y,Ne)}throw new Error(`Method not found: ${Te}`)}}}q.fromService=K;function G(ue,Z){const Y=Z&&Z.disableMarshalling;return new Proxy({},{get(se,de){if(typeof de=="string")return Z?.properties?.has(de)?Z.properties.get(de):oe(de)?function(ge){return ue.listen(de,ge)}:ee(de)?ue.listen(de):async function(...ge){let Te;Z&&!(0,p.isUndefinedOrNull)(Z.context)?Te=[Z.context,...ge]:Te=ge;const Ne=await ue.call(de,Te);return Y?Ne:(0,F.revive)(Ne)};throw new Error(`Property not found: ${String(de)}`)}})}q.toService=G;function ee(ue){return ue[0]==="o"&&ue[1]==="n"&&D.isUpperAsciiLetter(ue.charCodeAt(2))}function oe(ue){return/^onDynamic/.test(ue)&&D.isUpperAsciiLetter(ue.charCodeAt(9))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let K=q.toString();if(K!=="[object Object]")return K}return q}function Q(q){return Array.isArray(q)?q.map(j):j(q)}function $(q,K,G,ee,oe,ue,Z){Z=Q(Z);const Y=M[oe],se=Y[ee%Y.length];let de=[`%c[${q}]%c[${String(K).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${se}`];/\($/.test(ue)?(de=de.concat(Z),de.push(")")):de.push(Z),console.log.apply(console,de)}e.logWithColors=$;class U{constructor(K,G){this._outgoingPrefix=K,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,G,ee,oe,ue){this._totalOutgoing+=K,$(this._outgoingPrefix,this._totalOutgoing,K,G,ee,oe,ue)}logIncoming(K,G,ee,oe,ue){this._totalIncoming+=K,$(this._incomingPrefix,this._totalIncoming,K,G,ee,oe,ue)}}e.IPCLogger=U}),define(ve[105],we([1,0,22,3,6,104]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let i=0;function o(d,E){if(!r.has(d)){const P=String(++i);r.set(d,P)}return r.get(d)}function m(d,E,P,L){if(!n.enableDiagnostics)return;const O=o(d,E);if(L instanceof f.VSBuffer||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const y=f.VSBuffer.alloc(L.byteLength);y.set(L),n.records.push({timestamp:Date.now(),id:O,label:E,type:P,buff:y})}else n.records.push({timestamp:Date.now(),id:O,label:E,type:P,data:L})}n.traceSocketEvent=m})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let R=null;function F(){return R||(R=f.VSBuffer.alloc(0)),R}class D{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,i){if(r===0)return F();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const E=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=r),E}if(this._chunks[0].byteLength>r){const E=this._chunks[0].slice(0,r);return i&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),E}let o=f.VSBuffer.alloc(r),m=0,d=0;for(;r>0;){const E=this._chunks[d];if(E.byteLength>r){const P=E.slice(0,r);o.set(P,m),m+=r,i&&(this._chunks[d]=E.slice(r),this._totalLength-=r),r-=r}else o.set(E,m),m+=E.byteLength,i?(this._chunks.shift(),this._totalLength-=E.byteLength):d++,r-=E.byteLength}return o}}e.ChunkStream=D;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(p||(p={}));function b(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var g;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(r,i,o,m){this.type=r,this.id=i,this.ack=o,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends I.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,m=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",i),this._onMessage.fire(new h(o,m,d,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class A{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=f.VSBuffer.alloc(13);i.writeUInt8(r.type,0),i.writeUInt32BE(r.id,1),i.writeUInt32BE(r.ack,5),i.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(i,r.data)}_bufferAdd(r,i){const o=this._totalLength===0;return this._data.push(r,i),this._totalLength+=r.byteLength+i.byteLength,o}_bufferTake(){const r=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,i){this._bufferAdd(r,i)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class _ extends I.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new A(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new h(1,0,0,r))}}e.Protocol=_;class a extends T.IPCClient{constructor(r,i,o=null){super(r,i,o);this.protocol=r}static fromSocket(r,i){return new a(new _(r),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=a;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class u{constructor(r){this.data=r,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],i=0,o=this._first;for(;o;)r[i++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const i=new u(r);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class w{constructor(){this.lastRuns=[];const r=Date.now();for(let i=0;i<w._HISTORY_LENGTH;i++)this.lastRuns[i]=r-1e3*i;setInterval(()=>{for(let i=w._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return w._INSTANCE||(w._INSTANCE=new w),w._INSTANCE}load(){const r=Date.now(),i=(1+w._HISTORY_LENGTH)*1e3;let o=0;for(let m=0;m<w._HISTORY_LENGTH;m++)r-this.lastRuns[m]<=i&&o++;return 1-o/w._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}w._HISTORY_LENGTH=10,w._INSTANCE=null;class s{constructor(r,i=null,o=w.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),i&&this._socketReader.acceptChunk(i)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new h(5,0,0,F());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new h(7,0,0,F());this._socketWriter.write(r)}sendResume(){const r=new h(8,0,0,F());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,i){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,F());this._socketWriter.write(r);const i=this._outgoingUnackMsg.toArray();for(let o=0,m=i.length;o<m;o++)this._socketWriter.write(i[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new h(6,0,0,F())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const i=this._outgoingUnackMsg.toArray();for(let o=0,m=i.length;o<m;o++)this._socketWriter.write(i[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new h(1,i,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const i=new h(2,0,0,r);this._socketWriter.write(i)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),i=Date.now()-r.writtenTime,o=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(i>=2e4&&o>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const d=Math.max(2e4-i,2e4-o,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},d)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,F());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(ve[106],we([1,0,96]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const S=(0,f.toUint8)(k);this._defaultValue=S,this._asciiMap=t._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){const S=new Uint8Array(256);for(let R=0;R<256;R++)S[R]=k;return S}set(k,S){const R=(0,f.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=R:this._map.set(k,R)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(I||(I={}));class T{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=T}),define(ve[48],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(I,T){this.lineNumber=I,this.column=T}with(I=this.lineNumber,T=this.column){return I===this.lineNumber&&T===this.column?this:new f(I,T)}delta(I=0,T=0){return this.with(this.lineNumber+I,this.column+T)}equals(I){return f.equals(this,I)}static equals(I,T){return!I&&!T?!0:!!I&&!!T&&I.lineNumber===T.lineNumber&&I.column===T.column}isBefore(I){return f.isBefore(this,I)}static isBefore(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<T.column}isBeforeOrEqual(I){return f.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<=T.column}static compare(I,T){const C=I.lineNumber|0,k=T.lineNumber|0;if(C===k){const S=I.column|0,R=T.column|0;return S-R}return C-k}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new f(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=f}),define(ve[35],we([1,0,48]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(T,C,k,S){T>k||T===k&&C>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=T,this.endColumn=C):(this.startLineNumber=T,this.startColumn=C,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return t.containsPosition(this,T)}static containsPosition(T,C){return!(C.lineNumber<T.startLineNumber||C.lineNumber>T.endLineNumber||C.lineNumber===T.startLineNumber&&C.column<T.startColumn||C.lineNumber===T.endLineNumber&&C.column>T.endColumn)}static strictContainsPosition(T,C){return!(C.lineNumber<T.startLineNumber||C.lineNumber>T.endLineNumber||C.lineNumber===T.startLineNumber&&C.column<=T.startColumn||C.lineNumber===T.endLineNumber&&C.column>=T.endColumn)}containsRange(T){return t.containsRange(this,T)}static containsRange(T,C){return!(C.startLineNumber<T.startLineNumber||C.endLineNumber<T.startLineNumber||C.startLineNumber>T.endLineNumber||C.endLineNumber>T.endLineNumber||C.startLineNumber===T.startLineNumber&&C.startColumn<T.startColumn||C.endLineNumber===T.endLineNumber&&C.endColumn>T.endColumn)}strictContainsRange(T){return t.strictContainsRange(this,T)}static strictContainsRange(T,C){return!(C.startLineNumber<T.startLineNumber||C.endLineNumber<T.startLineNumber||C.startLineNumber>T.endLineNumber||C.endLineNumber>T.endLineNumber||C.startLineNumber===T.startLineNumber&&C.startColumn<=T.startColumn||C.endLineNumber===T.endLineNumber&&C.endColumn>=T.endColumn)}plusRange(T){return t.plusRange(this,T)}static plusRange(T,C){let k,S,R,F;return C.startLineNumber<T.startLineNumber?(k=C.startLineNumber,S=C.startColumn):C.startLineNumber===T.startLineNumber?(k=C.startLineNumber,S=Math.min(C.startColumn,T.startColumn)):(k=T.startLineNumber,S=T.startColumn),C.endLineNumber>T.endLineNumber?(R=C.endLineNumber,F=C.endColumn):C.endLineNumber===T.endLineNumber?(R=C.endLineNumber,F=Math.max(C.endColumn,T.endColumn)):(R=T.endLineNumber,F=T.endColumn),new t(k,S,R,F)}intersectRanges(T){return t.intersectRanges(this,T)}static intersectRanges(T,C){let k=T.startLineNumber,S=T.startColumn,R=T.endLineNumber,F=T.endColumn,D=C.startLineNumber,p=C.startColumn,b=C.endLineNumber,g=C.endColumn;return k<D?(k=D,S=p):k===D&&(S=Math.max(S,p)),R>b?(R=b,F=g):R===b&&(F=Math.min(F,g)),k>R||k===R&&S>F?null:new t(k,S,R,F)}equalsRange(T){return t.equalsRange(this,T)}static equalsRange(T,C){return!!T&&!!C&&T.startLineNumber===C.startLineNumber&&T.startColumn===C.startColumn&&T.endLineNumber===C.endLineNumber&&T.endColumn===C.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(T){return new f.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(T){return new f.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,C){return new t(this.startLineNumber,this.startColumn,T,C)}setStartPosition(T,C){return new t(T,C,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(T){return new t(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,C=T){return new t(T.lineNumber,T.column,C.lineNumber,C.column)}static lift(T){return T?new t(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,C){return!(T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn||C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn)}static areIntersecting(T,C){return!(T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn||C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,C){if(T&&C){const R=T.startLineNumber|0,F=C.startLineNumber|0;if(R===F){const D=T.startColumn|0,p=C.startColumn|0;if(D===p){const b=T.endLineNumber|0,g=C.endLineNumber|0;if(b===g){const h=T.endColumn|0,v=C.endColumn|0;return h-v}return b-g}return D-p}return R-F}return(T?1:0)-(C?1:0)}static compareRangesUsingEnds(T,C){return T.endLineNumber===C.endLineNumber?T.endColumn===C.endColumn?T.startLineNumber===C.startLineNumber?T.startColumn-C.startColumn:T.startLineNumber-C.startLineNumber:T.endColumn-C.endColumn:T.endLineNumber-C.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.Range=t}),define(ve[146],we([1,0,48,35]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class T extends t.Range{constructor(k,S,R,F){super(k,S,R,F);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=R,this.positionColumn=F}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return T.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,k,S):new T(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new f.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new T(k,S,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new T(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new T(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new T(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new T(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let R=0,F=k.length;R<F;R++)if(!this.selectionsEqual(k[R],S[R]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,R,F,D){return D===0?new T(k,S,R,F):new T(R,F,k,S)}}e.Selection=T}),define(ve[147],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(ve[148],we([1,0,106]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends f.CharacterClassifier{constructor(k){super(0);for(let S=0,R=k.length;S<R;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function T(C){const k={};return S=>(k.hasOwnProperty(S)||(k[S]=C(S)),k[S])}e.getMapForWordSeparators=T(C=>new I(C))}),define(ve[107],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const R of e.USUAL_WORD_SEPARATORS)k.indexOf(R)>=0||(S+="\\"+R);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=f();function t(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let R="g";k.ignoreCase&&(R+="i"),k.multiline&&(R+="m"),k.unicode&&(R+="u"),S=new RegExp(k.source,R)}return S.lastIndex=0,S}e.ensureValidWordDefinition=t;const I={maxLen:1e3,windowSize:15,timeBudget:150};function T(k,S,R,F,D=I){if(R.length>D.maxLen){let v=k-D.maxLen/2;return v<0?v=0:F+=v,R=R.substring(v,k+D.maxLen/2),T(k,S,R,F,D)}const p=Date.now(),b=k-1-F;let g=-1,h=null;for(let v=1;!(Date.now()-p>=D.timeBudget);v++){const A=b-D.windowSize*v;S.lastIndex=Math.max(0,A);const _=C(S,R,b,g);if(!_&&h||(h=_,A<=0))break;g=A}if(h){const v={word:h[0],startColumn:F+1+h.index,endColumn:F+1+h.index+h[0].length};return S.lastIndex=0,v}return null}e.getWordAtText=T;function C(k,S,R,F){let D;for(;D=k.exec(S);){const p=D.index||0;if(p<=R&&k.lastIndex>=R)return D;if(F>0&&p>F)return null}return null}}),define(ve[108],we([1,0,32,9]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(T,C,k,S,R){if(Array.isArray(T)){let F=0;for(const D of T){const p=I(D,C,k,S,R);if(p===10)return p;p>F&&(F=p)}return F}else{if(typeof T=="string")return S?T==="*"?5:T===k?10:0:0;if(T){const{language:F,pattern:D,scheme:p,hasAccessToAllModels:b,notebookType:g}=T;if(!S&&!b)return 0;let h=0;if(p)if(p===C.scheme)h=10;else if(p==="*")h=5;else return 0;if(F)if(F===k)h=10;else if(F==="*")h=Math.max(h,5);else return 0;if(g)if(g===R)h=10;else if(g==="*")h=Math.max(h,5);else return 0;if(D){let v;if(typeof D=="string"?v=D:v={...D,base:(0,t.normalize)(D.base)},v===C.fsPath||(0,f.match)(v,C.fsPath))h=10;else return 0}return h}else return 0}}e.score=I}),define(ve[149],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let S=0,R=k.notIn.length;S<R;S++)switch(k.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const R=k.findTokenIndexAtOffset(S-2),F=k.getStandardTokenType(R);return this.isOK(F)}_findNeutralCharacterInRange(k,S){for(let R=k;R<=S;R++){const F=String.fromCharCode(R);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function T(C,k,S){C.has(k)?C.get(k).push(S):C.set(k,[S])}}),define(ve[150],we([1,0,106]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(g,h,v){const A=new Uint8Array(g*h);for(let _=0,a=g*h;_<a;_++)A[_]=v;this._data=A,this.rows=g,this.cols=h}get(g,h){return this._data[g*this.cols+h]}set(g,h,v){this._data[g*this.cols+h]=v}}e.Uint8Matrix=I;class T{constructor(g){let h=0,v=0;for(let _=0,a=g.length;_<a;_++){const[l,u,c]=g[_];u>h&&(h=u),l>v&&(v=l),c>v&&(v=c)}h++,v++;const A=new I(v,h,0);for(let _=0,a=g.length;_<a;_++){const[l,u,c]=g[_];A.set(l,u,c)}this._states=A,this._maxCharCode=h}nextState(g,h){return h<0||h>=this._maxCharCode?0:this._states.get(g,h)}}e.StateMachine=T;let C=null;function k(){return C===null&&(C=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let R=null;function F(){if(R===null){R=new f.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<b.length;h++)R.set(b.charCodeAt(h),1);const g=".,;";for(let h=0;h<g.length;h++)R.set(g.charCodeAt(h),2)}return R}class D{static _createLink(g,h,v,A,_){let a=_-1;do{const l=h.charCodeAt(a);if(g.get(l)!==2)break;a--}while(a>A);if(A>0){const l=h.charCodeAt(A-1),u=h.charCodeAt(a);(l===40&&u===41||l===91&&u===93||l===123&&u===125)&&a--}return{range:{startLineNumber:v,startColumn:A+1,endLineNumber:v,endColumn:a+2},url:h.substring(A,a+1)}}static computeLinks(g,h=k()){const v=F(),A=[];for(let _=1,a=g.getLineCount();_<=a;_++){const l=g.getLineContent(_),u=l.length;let c=0,w=0,s=0,n=1,r=!1,i=!1,o=!1,m=!1;for(;c<u;){let d=!1;const E=l.charCodeAt(c);if(n===13){let P;switch(E){case 40:r=!0,P=0;break;case 41:P=r?0:1;break;case 91:o=!0,i=!0,P=0;break;case 93:o=!1,P=i?0:1;break;case 123:m=!0,P=0;break;case 125:P=m?0:1;break;case 39:P=s===34||s===96?0:1;break;case 34:P=s===39||s===96?0:1;break;case 96:P=s===39||s===34?0:1;break;case 42:P=s===42?1:0;break;case 124:P=s===124?1:0;break;case 32:P=o?0:1;break;default:P=v.get(E)}P===1&&(A.push(D._createLink(v,l,_,w,c)),d=!0)}else if(n===12){let P;E===91?(i=!0,P=0):P=v.get(E),P===1?d=!0:n=13}else n=h.nextState(n,E),n===0&&(d=!0);d&&(n=1,r=!1,i=!1,m=!1,w=c+1,s=E),c++}n===13&&A.push(D._createLink(v,l,_,w,u))}return A}}e.LinkComputer=D;function p(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:D.computeLinks(b)}e.computeLinks=p}),define(ve[109],we([1,0,25]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(_){_[_.Left=1]="Left",_[_.Center=2]="Center",_[_.Right=4]="Right",_[_.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(_){_[_.Inline=1]="Inline",_[_.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(_){_[_.Both=0]="Both",_[_.Right=1]="Right",_[_.Left=2]="Left",_[_.None=3]="None"})(T=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(_){_[_.TextDefined=0]="TextDefined",_[_.LF=1]="LF",_[_.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(_){_[_.LF=1]="LF",_[_.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(_){_[_.LF=0]="LF",_[_.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class R{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=R;class F{constructor(a,l){this._findMatchBrand=void 0,this.range=a,this.matches=l}}e.FindMatch=F;var D;(function(_){_[_.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",_[_.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",_[_.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",_[_.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var p;(function(_){_[_.Left=0]="Left",_[_.Right=1]="Right",_[_.None=2]="None"})(p=e.PositionAffinity||(e.PositionAffinity={}));var b;(function(_){_[_.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b=e.ModelConstants||(e.ModelConstants={}));class g{constructor(a,l,u,c,w,s){this.identifier=a,this.range=l,this.text=u,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=w,this._isTracked=s}}e.ValidAnnotatedEditOperation=g;class h{constructor(a,l,u){this.regex=a,this.wordSeparators=l,this.simpleSearch=u}}e.SearchData=h;class v{constructor(a,l,u){this.reverseEdits=a,this.changes=l,this.trimAutoWhitespaceLineNumbers=u}}e.ApplyEditsResult=v;function A(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=A}),define(ve[110],we([1,0,18,96]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,R){S=(0,t.toUint32)(S);const F=this.values,D=this.prefixSum,p=R.length;return p===0?!1:(this.values=new Uint32Array(F.length+p),this.values.set(F.subarray(0,S),0),this.values.set(F.subarray(S),S+p),this.values.set(R,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,R){return S=(0,t.toUint32)(S),R=(0,t.toUint32)(R),this.values[S]===R?!1:(this.values[S]=R,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,R){S=(0,t.toUint32)(S),R=(0,t.toUint32)(R);const F=this.values,D=this.prefixSum;if(S>=F.length)return!1;const p=F.length-S;return R>=p&&(R=p),R===0?!1:(this.values=new Uint32Array(F.length-R),this.values.set(F.subarray(0,S),0),this.values.set(F.subarray(S+R),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let R=this.prefixSumValidIndex[0]+1;R===0&&(this.prefixSum[0]=this.values[0],R++),S>=this.values.length&&(S=this.values.length-1);for(let F=R;F<=S;F++)this.prefixSum[F]=this.prefixSum[F-1]+this.values[F];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let R=0,F=this.values.length-1,D=0,p=0,b=0;for(;R<=F;)if(D=R+(F-R)/2|0,p=this.prefixSum[D],b=p-this.values[D],S<b)F=D-1;else if(S>=p)R=D+1;else break;return new C(D,S-b)}}e.PrefixSumComputer=I;class T{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const R=this._indexBySum[S],F=R>0?this._prefixSum[R-1]:0;return new C(R,S-F)}removeValues(S,R){this._values.splice(S,R),this._invalidate(S)}insertValues(S,R){this._values=(0,f.arrayInsert)(this._values,S,R),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,R=this._values.length;S<R;S++){const F=this._values[S],D=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=D+F;for(let p=0;p<F;p++)this._indexBySum[D+p]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,R){this._values[S]!==R&&(this._values[S]=R,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=T;class C{constructor(S,R){this.index=S,this.remainder=R,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=R}}e.PrefixSumIndexOfResult=C}),define(ve[151],we([1,0,8,48,110]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(k,S,R,F){this._uri=k,this._lines=S,this._eol=R,this._versionId=F,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const R of S)this._acceptDeleteRange(R.range),this._acceptInsertText(new t.Position(R.range.startLineNumber,R.range.startColumn),R.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,R=new Uint32Array(S);for(let F=0;F<S;F++)R[F]=this._lines[F].length+k;this._lineStarts=new I.PrefixSumComputer(R)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;const R=(0,f.splitLines)(S);if(R.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+R[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}R[R.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+R[0]);const F=new Uint32Array(R.length-1);for(let D=1;D<R.length;D++)this._lines.splice(k.lineNumber+D-1,0,R[D]),F[D-1]=R[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,F)}}e.MirrorTextModel=T}),define(ve[152],we([1,0,8,148,48,35,109]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(_,a,l,u){this.searchString=_,this.isRegex=a,this.matchCase=l,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=R(this.searchString):_=this.searchString.indexOf(`
`)>=0;let a=null;try{a=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!a)return null;let l=!this.isRegex&&!_;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new C.SearchData(a,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}e.SearchParams=S;function R(A){if(!A||A.length===0)return!1;for(let _=0,a=A.length;_<a;_++)if(A.charCodeAt(_)===92){if(_++,_>=a)break;const u=A.charCodeAt(_);if(u===110||u===114||u===87)return!0}return!1}e.isMultilineRegexSource=R;function F(A,_,a){if(!a)return new C.FindMatch(A,null);const l=[];for(let u=0,c=_.length;u<c;u++)l[u]=_[u];return new C.FindMatch(A,l)}e.createFindMatch=F;class D{constructor(_){const a=[];let l=0;for(let u=0,c=_.length;u<c;u++)_.charCodeAt(u)===10&&(a[l++]=u);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(_){const a=this._lineFeedsOffsets;let l=0,u=a.length-1;if(u===-1||_<=a[0])return 0;for(;l<u;){const c=l+((u-l)/2>>0);a[c]>=_?u=c-1:a[c+1]>=_?(l=c,u=c):l=c+1}return l+1}}class p{static findMatches(_,a,l,u,c){const w=a.parseSearchRequest();return w?w.regex.multiline?this._doFindMatchesMultiline(_,l,new v(w.wordSeparators,w.regex),u,c):this._doFindMatchesLineByLine(_,l,w,u,c):[]}static _getMultilineMatchRange(_,a,l,u,c,w){let s,n=0;u?(n=u.findLineFeedCountBeforeOffset(c),s=a+c+n):s=a+c;let r;if(u){const d=u.findLineFeedCountBeforeOffset(c+w.length)-n;r=s+w.length+d}else r=s+w.length;const i=_.getPositionAt(s),o=_.getPositionAt(r);return new T.Range(i.lineNumber,i.column,o.lineNumber,o.column)}static _doFindMatchesMultiline(_,a,l,u,c){const w=_.getOffsetAt(a.getStartPosition()),s=_.getValueInRange(a,1),n=_.getEOL()===`\r
`?new D(s):null,r=[];let i=0,o;for(l.reset(0);o=l.next(s);)if(r[i++]=F(this._getMultilineMatchRange(_,w,s,n,o.index,o[0]),o,u),i>=c)return r;return r}static _doFindMatchesLineByLine(_,a,l,u,c){const w=[];let s=0;if(a.startLineNumber===a.endLineNumber){const r=_.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return s=this._findMatchesInLine(l,r,a.startLineNumber,a.startColumn-1,s,w,u,c),w}const n=_.getLineContent(a.startLineNumber).substring(a.startColumn-1);s=this._findMatchesInLine(l,n,a.startLineNumber,a.startColumn-1,s,w,u,c);for(let r=a.startLineNumber+1;r<a.endLineNumber&&s<c;r++)s=this._findMatchesInLine(l,_.getLineContent(r),r,0,s,w,u,c);if(s<c){const r=_.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);s=this._findMatchesInLine(l,r,a.endLineNumber,0,s,w,u,c)}return w}static _findMatchesInLine(_,a,l,u,c,w,s,n){const r=_.wordSeparators;if(!s&&_.simpleSearch){const m=_.simpleSearch,d=m.length,E=a.length;let P=-d;for(;(P=a.indexOf(m,P+d))!==-1;)if((!r||h(r,a,E,P,d))&&(w[c++]=new C.FindMatch(new T.Range(l,P+1+u,l,P+1+d+u),null),c>=n))return c;return c}const i=new v(_.wordSeparators,_.regex);let o;i.reset(0);do if(o=i.next(a),o&&(w[c++]=F(new T.Range(l,o.index+1+u,l,o.index+1+o[0].length+u),o,s),c>=n))return c;while(o);return c}static findNextMatch(_,a,l,u){const c=a.parseSearchRequest();if(!c)return null;const w=new v(c.wordSeparators,c.regex);return c.regex.multiline?this._doFindNextMatchMultiline(_,l,w,u):this._doFindNextMatchLineByLine(_,l,w,u)}static _doFindNextMatchMultiline(_,a,l,u){const c=new I.Position(a.lineNumber,1),w=_.getOffsetAt(c),s=_.getLineCount(),n=_.getValueInRange(new T.Range(c.lineNumber,c.column,s,_.getLineMaxColumn(s)),1),r=_.getEOL()===`\r
`?new D(n):null;l.reset(a.column-1);let i=l.next(n);return i?F(this._getMultilineMatchRange(_,w,n,r,i.index,i[0]),i,u):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(_,new I.Position(1,1),l,u):null}static _doFindNextMatchLineByLine(_,a,l,u){const c=_.getLineCount(),w=a.lineNumber,s=_.getLineContent(w),n=this._findFirstMatchInLine(l,s,w,a.column,u);if(n)return n;for(let r=1;r<=c;r++){const i=(w+r-1)%c,o=_.getLineContent(i+1),m=this._findFirstMatchInLine(l,o,i+1,1,u);if(m)return m}return null}static _findFirstMatchInLine(_,a,l,u,c){_.reset(u-1);const w=_.next(a);return w?F(new T.Range(l,w.index+1,l,w.index+1+w[0].length),w,c):null}static findPreviousMatch(_,a,l,u){const c=a.parseSearchRequest();if(!c)return null;const w=new v(c.wordSeparators,c.regex);return c.regex.multiline?this._doFindPreviousMatchMultiline(_,l,w,u):this._doFindPreviousMatchLineByLine(_,l,w,u)}static _doFindPreviousMatchMultiline(_,a,l,u){const c=this._doFindMatchesMultiline(_,new T.Range(1,1,a.lineNumber,a.column),l,u,10*k);if(c.length>0)return c[c.length-1];const w=_.getLineCount();return a.lineNumber!==w||a.column!==_.getLineMaxColumn(w)?this._doFindPreviousMatchMultiline(_,new I.Position(w,_.getLineMaxColumn(w)),l,u):null}static _doFindPreviousMatchLineByLine(_,a,l,u){const c=_.getLineCount(),w=a.lineNumber,s=_.getLineContent(w).substring(0,a.column-1),n=this._findLastMatchInLine(l,s,w,u);if(n)return n;for(let r=1;r<=c;r++){const i=(c+w-r-1)%c,o=_.getLineContent(i+1),m=this._findLastMatchInLine(l,o,i+1,u);if(m)return m}return null}static _findLastMatchInLine(_,a,l,u){let c=null,w;for(_.reset(0);w=_.next(a);)c=F(new T.Range(l,w.index+1,l,w.index+1+w[0].length),w,u);return c}}e.TextModelSearch=p;function b(A,_,a,l,u){if(l===0)return!0;const c=_.charCodeAt(l-1);if(A.get(c)!==0||c===13||c===10)return!0;if(u>0){const w=_.charCodeAt(l);if(A.get(w)!==0)return!0}return!1}function g(A,_,a,l,u){if(l+u===a)return!0;const c=_.charCodeAt(l+u);if(A.get(c)!==0||c===13||c===10)return!0;if(u>0){const w=_.charCodeAt(l+u-1);if(A.get(w)!==0)return!0}return!1}function h(A,_,a,l,u){return b(A,_,a,l,u)&&g(A,_,a,l,u)}e.isValidMatch=h;class v{constructor(_,a){this._wordSeparators=_,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const a=_.length;let l;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(l=this._searchRegex.exec(_),!l))return null;const u=l.index,c=l[0].length;if(u===this._prevMatchStartIndex&&c===this._prevMatchLength){if(c===0){f.getNextCodePoint(_,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=u,this._prevMatchLength=c,!this._wordSeparators||h(this._wordSeparators,_,a,u,c))return l}while(l);return null}}e.Searcher=v}),define(ve[111],we([1,0,22,12]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function T(D){for(let p=0,b=D.length;p<b;p+=4){const g=D[p+0],h=D[p+1],v=D[p+2],A=D[p+3];D[p+0]=A,D[p+1]=v,D[p+2]=h,D[p+3]=g}}function C(D){const p=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return t.isLittleEndian()||T(p),f.VSBuffer.wrap(p)}function k(D){const p=D.buffer;if(t.isLittleEndian()||T(p),p.byteOffset%4==0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const b=new Uint8Array(p.byteLength);return b.set(p),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function S(D){const p=new Uint32Array(R(D));let b=0;if(p[b++]=D.id,D.type==="full")p[b++]=1,p[b++]=D.data.length,p.set(D.data,b),b+=D.data.length;else{p[b++]=2,p[b++]=D.deltas.length;for(const g of D.deltas)p[b++]=g.start,p[b++]=g.deleteCount,g.data?(p[b++]=g.data.length,p.set(g.data,b),b+=g.data.length):p[b++]=0}return C(p)}e.encodeSemanticTokensDto=S;function R(D){let p=0;if(p+=1+1,D.type==="full")p+=1+D.data.length;else{p+=1,p+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(p+=b.data.length)}return p}function F(D){const p=k(D);let b=0;const g=p[b++];if(p[b++]===1){const _=p[b++],a=p.subarray(b,b+_);return b+=_,{id:g,type:"full",data:a}}const v=p[b++],A=[];for(let _=0;_<v;_++){const a=p[b++],l=p[b++],u=p[b++];let c;u>0&&(c=p.subarray(b,b+u),b+=u),A[_]={start:a,deleteCount:l,data:c}}return{id:g,type:"delta",deltas:A}}e.decodeSemanticTokensDto=F}),define(ve[153],we([1,0,3,6]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,S){return this._map.set(k,S),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===S&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,S){this._factories.get(k)?.dispose();const R=new T(this,k,S);return this._factories.set(k,R),(0,t.toDisposable)(()=>{const F=this._factories.get(k);!F||F!==R||(this._factories.delete(k),F.dispose())})}async getOrCreate(k){const S=this.get(k);if(S)return S;const R=this._factories.get(k);return!R||R.isResolved?null:(await R.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const R=this._factories.get(k);return!!(!R||R.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class T extends t.Disposable{constructor(k,S,R){super();this._registry=k,this._languageId=S,this._factory=R,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(ve[78],we([1,0,2,35,153,72]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(O){O[O.Null=0]="Null",O[O.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));var k;(function(O){O[O.NotSet=-1]="NotSet",O[O.None=0]="None",O[O.Italic=1]="Italic",O[O.Bold=2]="Bold",O[O.Underline=4]="Underline",O[O.Strikethrough=8]="Strikethrough"})(k=e.FontStyle||(e.FontStyle={}));var S;(function(O){O[O.None=0]="None",O[O.DefaultForeground=1]="DefaultForeground",O[O.DefaultBackground=2]="DefaultBackground"})(S=e.ColorId||(e.ColorId={}));var R;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var F;(function(O){O[O.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",O[O.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",O[O.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",O[O.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",O[O.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",O[O.ITALIC_MASK=1024]="ITALIC_MASK",O[O.BOLD_MASK=2048]="BOLD_MASK",O[O.UNDERLINE_MASK=4096]="UNDERLINE_MASK",O[O.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",O[O.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",O[O.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",O[O.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",O[O.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",O[O.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",O[O.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",O[O.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",O[O.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",O[O.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",O[O.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",O[O.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(F=e.MetadataConsts||(e.MetadataConsts={}));class D{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&768)>>>8}static getFontStyle(y){return(y&15360)>>>10}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){const H=this.getForeground(y);let M="mtk"+H;const j=this.getFontStyle(y);return j&1&&(M+=" mtki"),j&2&&(M+=" mtkb"),j&4&&(M+=" mtku"),j&8&&(M+=" mtks"),M}static getInlineStyleFromMetadata(y,H){const M=this.getForeground(y),j=this.getFontStyle(y);let Q=`color: ${H[M]};`;j&1&&(Q+="font-style: italic;"),j&2&&(Q+="font-weight: bold;");let $="";return j&4&&($+=" underline"),j&8&&($+=" line-through"),$&&(Q+=`text-decoration:${$};`),Q}static getPresentationFromMetadata(y){const H=this.getForeground(y),M=this.getFontStyle(y);return{foreground:H,italic:Boolean(M&1),bold:Boolean(M&2),underline:Boolean(M&4),strikethrough:Boolean(M&8)}}}e.TokenMetadata=D;class p{constructor(y,H,M){this._tokenBrand=void 0,this.offset=y,this.type=H,this.language=M}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=p;class b{constructor(y,H){this._tokenizationResultBrand=void 0,this.tokens=y,this.endState=H}}e.TokenizationResult=b;class g{constructor(y,H){this._encodedTokenizationResultBrand=void 0,this.tokens=y,this.endState=H}}e.EncodedTokenizationResult=g;var h;(function(O){O[O.Method=0]="Method",O[O.Function=1]="Function",O[O.Constructor=2]="Constructor",O[O.Field=3]="Field",O[O.Variable=4]="Variable",O[O.Class=5]="Class",O[O.Struct=6]="Struct",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Event=10]="Event",O[O.Operator=11]="Operator",O[O.Unit=12]="Unit",O[O.Value=13]="Value",O[O.Constant=14]="Constant",O[O.Enum=15]="Enum",O[O.EnumMember=16]="EnumMember",O[O.Keyword=17]="Keyword",O[O.Text=18]="Text",O[O.Color=19]="Color",O[O.File=20]="File",O[O.Reference=21]="Reference",O[O.Customcolor=22]="Customcolor",O[O.Folder=23]="Folder",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue",O[O.Snippet=27]="Snippet"})(h=e.CompletionItemKind||(e.CompletionItemKind={}));var v;(function(O){const y=new Map;y.set(0,T.Codicon.symbolMethod),y.set(1,T.Codicon.symbolFunction),y.set(2,T.Codicon.symbolConstructor),y.set(3,T.Codicon.symbolField),y.set(4,T.Codicon.symbolVariable),y.set(5,T.Codicon.symbolClass),y.set(6,T.Codicon.symbolStruct),y.set(7,T.Codicon.symbolInterface),y.set(8,T.Codicon.symbolModule),y.set(9,T.Codicon.symbolProperty),y.set(10,T.Codicon.symbolEvent),y.set(11,T.Codicon.symbolOperator),y.set(12,T.Codicon.symbolUnit),y.set(13,T.Codicon.symbolValue),y.set(15,T.Codicon.symbolEnum),y.set(14,T.Codicon.symbolConstant),y.set(15,T.Codicon.symbolEnum),y.set(16,T.Codicon.symbolEnumMember),y.set(17,T.Codicon.symbolKeyword),y.set(27,T.Codicon.symbolSnippet),y.set(18,T.Codicon.symbolText),y.set(19,T.Codicon.symbolColor),y.set(20,T.Codicon.symbolFile),y.set(21,T.Codicon.symbolReference),y.set(22,T.Codicon.symbolCustomColor),y.set(23,T.Codicon.symbolFolder),y.set(24,T.Codicon.symbolTypeParameter),y.set(25,T.Codicon.account),y.set(26,T.Codicon.issues);function H(Q){let $=y.get(Q);return $||(console.info("No codicon found for CompletionItemKind "+Q),$=T.Codicon.symbolProperty),$}O.toIcon=H;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function j(Q,$){let U=M.get(Q);return typeof U=="undefined"&&!$&&(U=9),U}O.fromString=j})(v=e.CompletionItemKinds||(e.CompletionItemKinds={}));var A;(function(O){O[O.Deprecated=1]="Deprecated"})(A=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(O){O[O.KeepWhitespace=1]="KeepWhitespace",O[O.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var a;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var l;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(l=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(O){O[O.Invoke=1]="Invoke",O[O.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var w;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(w=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function s(O){return O&&f.URI.isUri(O.uri)&&t.Range.isIRange(O.range)&&(t.Range.isIRange(O.originSelectionRange)||t.Range.isIRange(O.targetSelectionRange))}e.isLocationLink=s;var n;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var r;(function(O){O[O.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(O){const y=new Map;y.set(0,T.Codicon.symbolFile),y.set(1,T.Codicon.symbolModule),y.set(2,T.Codicon.symbolNamespace),y.set(3,T.Codicon.symbolPackage),y.set(4,T.Codicon.symbolClass),y.set(5,T.Codicon.symbolMethod),y.set(6,T.Codicon.symbolProperty),y.set(7,T.Codicon.symbolField),y.set(8,T.Codicon.symbolConstructor),y.set(9,T.Codicon.symbolEnum),y.set(10,T.Codicon.symbolInterface),y.set(11,T.Codicon.symbolFunction),y.set(12,T.Codicon.symbolVariable),y.set(13,T.Codicon.symbolConstant),y.set(14,T.Codicon.symbolString),y.set(15,T.Codicon.symbolNumber),y.set(16,T.Codicon.symbolBoolean),y.set(17,T.Codicon.symbolArray),y.set(18,T.Codicon.symbolObject),y.set(19,T.Codicon.symbolKey),y.set(20,T.Codicon.symbolNull),y.set(21,T.Codicon.symbolEnumMember),y.set(22,T.Codicon.symbolStruct),y.set(23,T.Codicon.symbolEvent),y.set(24,T.Codicon.symbolOperator),y.set(25,T.Codicon.symbolTypeParameter);function H(M){let j=y.get(M);return j||(console.info("No codicon found for SymbolKind "+M),j=T.Codicon.symbolProperty),j}O.toIcon=H})(i=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(y){this.value=y}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var m;(function(O){function y(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}O.is=y})(m=e.Command||(e.Command={}));var d;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var E;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(E=e.CommentMode||(e.CommentMode={}));var P;(function(O){O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(P=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var L;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(L=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[154],we([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ve[155],we([1,0,154]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,T=I*24,C=T*7,k=T*30,S=T*365;function R(D,p,b){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,f.localize)(0,null,R(new Date().getTime()+g*1e3,!1));if(g<30)return(0,f.localize)(1,null);let h;return g<t?(h=g,p?h===1?b?(0,f.localize)(2,null,h):(0,f.localize)(3,null,h):b?(0,f.localize)(4,null,h):(0,f.localize)(5,null,h):h===1?b?(0,f.localize)(6,null,h):(0,f.localize)(7,null,h):b?(0,f.localize)(8,null,h):(0,f.localize)(9,null,h)):g<I?(h=Math.floor(g/t),p?h===1?b?(0,f.localize)(10,null,h):(0,f.localize)(11,null,h):b?(0,f.localize)(12,null,h):(0,f.localize)(13,null,h):h===1?b?(0,f.localize)(14,null,h):(0,f.localize)(15,null,h):b?(0,f.localize)(16,null,h):(0,f.localize)(17,null,h)):g<T?(h=Math.floor(g/I),p?h===1?b?(0,f.localize)(18,null,h):(0,f.localize)(19,null,h):b?(0,f.localize)(20,null,h):(0,f.localize)(21,null,h):h===1?b?(0,f.localize)(22,null,h):(0,f.localize)(23,null,h):b?(0,f.localize)(24,null,h):(0,f.localize)(25,null,h)):g<C?(h=Math.floor(g/T),p?h===1?(0,f.localize)(26,null,h):(0,f.localize)(27,null,h):h===1?(0,f.localize)(28,null,h):(0,f.localize)(29,null,h)):g<k?(h=Math.floor(g/C),p?h===1?b?(0,f.localize)(30,null,h):(0,f.localize)(31,null,h):b?(0,f.localize)(32,null,h):(0,f.localize)(33,null,h):h===1?b?(0,f.localize)(34,null,h):(0,f.localize)(35,null,h):b?(0,f.localize)(36,null,h):(0,f.localize)(37,null,h)):g<S?(h=Math.floor(g/k),p?h===1?b?(0,f.localize)(38,null,h):(0,f.localize)(39,null,h):b?(0,f.localize)(40,null,h):(0,f.localize)(41,null,h):h===1?b?(0,f.localize)(42,null,h):(0,f.localize)(43,null,h):b?(0,f.localize)(44,null,h):(0,f.localize)(45,null,h)):(h=Math.floor(g/S),p?h===1?b?(0,f.localize)(46,null,h):(0,f.localize)(47,null,h):b?(0,f.localize)(48,null,h):(0,f.localize)(49,null,h):h===1?b?(0,f.localize)(50,null,h):(0,f.localize)(51,null,h):b?(0,f.localize)(52,null,h):(0,f.localize)(53,null,h))}e.fromNow=R;function F(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(ve[156],we([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ve[49],we([1,0,18,13,156]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(D,p){return p&&(D.stack||D.stacktrace)?I.localize(0,null,k(D),C(D.stack)||C(D.stacktrace)):k(D)}function C(D){return Array.isArray(D)?D.join(`
`):D}function k(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function S(D=null,p=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const b=f.coalesce(D),g=S(b[0],p);return b.length>1?I.localize(4,null,g,b.length):g}if(t.isString(D))return D;if(D.detail){const b=D.detail;if(b.error)return T(b.error,p);if(b.exception)return T(b.exception,p)}return D.stack?T(D,p):D.message?D.message:I.localize(5,null)}e.toErrorMessage=S;function R(D){const p=D;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=R;function F(D,p=Object.create(null)){const b=new Error(D);return p.actions&&(b.actions=p.actions),b}e.createErrorWithActions=F}),define(ve[157],we([19,20]),function(te,e){return te.create("vs/base/node/processes",e)}),define(ve[112],we([1,0,38,29,10,25,9,12,41,93,13,145,28,157]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function g(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(c,w){if(k.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};w&&(s.cwd=w);const n=f.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],s);return new Promise(r=>{n.once("error",i=>{r({success:!1,error:i})}),n.once("exit",(i,o)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?g(s.status):1})}else if(k.isLinux||k.isMacintosh)try{const s=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",te).fsPath;return new Promise(n=>{f.execFile(s,[c.pid.toString()],{encoding:"utf8",shell:!0},(r,i,o)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function v(c){!c||(delete c.DEBUG,k.isMacintosh&&delete c.DYLD_LIBRARY_PATH,k.isLinux&&delete c.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function A(c=S.env){return c.comspec||"cmd.exe"}e.getWindowsShell=A;class _{constructor(w,s,n,r){if(s!==void 0&&n!==void 0&&r!==void 0)this.cmd=w,this.args=s,this.shell=n,this.options=r;else{const i=w;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(S.env).forEach(o=>{i[o]=S.env[o]}),Object.keys(this.options.env).forEach(o=>{i[o]=this.options.env[o]}),this.options.env=i}}getSanitizedCommand(){let w=this.cmd.toLowerCase();const s=w.lastIndexOf(C.sep);return s!==-1&&(w=w.substring(s+1)),_.WellKnowCommands[w]?w:"other"}start(w){return k.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(S.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(s=>{let n,r;const i=new Promise((o,m)=>{n=o,r=m});if(s){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=f.exec(o,this.options,(m,d,E)=>{this.childProcess=null;const P=m;P&&P.killed?r({killed:this.terminateRequested,stdout:d.toString(),stderr:E.toString()}):this.handleExec(n,w,m,d,E)})}else{let o=null;const m=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,w,r);const E={terminated:this.terminateRequested};F.isNumber(d)&&(E.cmdCode=d),n(E)};if(this.shell&&k.isWindows){const d=T.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let E=!1,P=!1;const L=[];let O=this.ensureQuotes(this.cmd);L.push(O.value),E=O.quoted,this.args&&this.args.forEach(H=>{O=this.ensureQuotes(H),L.push(O.value),P=P&&O.quoted});const y=["/s","/c"];E?P?y.push('"'+L.join(" ")+'"'):L.length>1?y.push('"'+L[0]+'" '+L.slice(1).join(" ")):y.push('"'+L[0]+'"'):y.push(L.join(" ")),o=f.spawn(A(),y,d)}else this.cmd&&(o=f.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(F.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",d=>{this.childProcess=null,r({terminated:this.terminateRequested,error:d})}),o.pid&&(this.childProcess.on("close",m),this.handleSpawn(o,n,w,r,!0)))}return i})}handleClose(w,s,n,r){}ensureQuotes(w){return _.regexp.test(w)?{value:'"'+w+'"',quoted:!0}:{value:w,quoted:w.length>0&&w[0]==='"'&&w[w.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(w=>w.pid,w=>-1):new Promise(w=>{this.pidResolve=w})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(w=>(this.terminateRequested=!0,h(w,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),w=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(w=>{if(!this.shell||!k.isWindows)return w(!1);const s=f.spawn(A(),["/s","/c"]);s.on("error",n=>w(!0)),s.on("exit",n=>w(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class a extends _{constructor(w,s,n,r){super(w,s,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(w,s,n,r,i){[r,i].forEach((o,m)=>{const d=new D.LineDecoder;d.write(o).forEach(L=>{s({line:L,source:m===0?0:1})});const P=d.end();P&&s({line:P,source:m===0?0:1})}),w({terminated:this.terminateRequested,error:n})}handleSpawn(w,s,n,r,i){const o=new D.LineDecoder,m=new D.LineDecoder;w.stdout.on("data",d=>{o.write(d).forEach(P=>n({line:P,source:0}))}),w.stderr.on("data",d=>{m.write(d).forEach(P=>n({line:P,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=m}handleClose(w,s,n,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&n({line:i,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&n({line:o,source:1})}}e.LineProcess=a;function l(c){let w=[],s=!1;const n=function(r){if(s){w.push(r);return}(!c.send(r,o=>{if(o&&console.error(o),s=!1,w.length>0){const m=w.slice(0);w=[],m.forEach(d=>n(d))}})||k.isWindows)&&(s=!0)};return{send:n}}e.createQueuedSender=l;var u;(function(c){async function w(s,n,r){if(C.isAbsolute(s))return s;if(n===void 0&&(n=S.cwd()),C.dirname(s)!=="."||(r===void 0&&F.isString(S.env.PATH)&&(r=S.env.PATH.split(C.delimiter)),r===void 0||r.length===0))return C.join(n,s);async function o(m){if(await p.Promises.exists(m)){let d;try{d=await p.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(d=await p.Promises.lstat(m))}return d?!d.isDirectory():!1}return!1}for(let m of r){let d;if(C.isAbsolute(m)?d=C.join(m,s):d=C.join(n,m,s),await o(d))return d;let E=d+".com";if(await o(E)||(E=d+".exe",await o(E)))return E}return C.join(n,s)}c.findExecutable=w})(u=e.win32||(e.win32={}))}),define(ve[158],we([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ve[113],we([1,0,158,12,107,18,25,147]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(ae){this._values=ae}hasChanged(ae){return this._values[ae]}}e.ConfigurationChangedEvent=R;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class D{constructor(ae,J,pe,Se){this.id=ae,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(ae,J){return b(ae,J)}compute(ae,J,pe){return pe}}class p{constructor(ae,J){this.newValue=ae,this.didChange=J}}e.ApplyUpdateResult=p;function b(ne,ae){if(typeof ne!="object"||typeof ae!="object"||!ne||!ae)return new p(ae,ne!==ae);if(Array.isArray(ne)||Array.isArray(ae)){const pe=Array.isArray(ne)&&Array.isArray(ae)&&T.equals(ne,ae);return new p(ae,pe)}let J=!1;for(const pe in ae)if(ae.hasOwnProperty(pe)){const Se=b(ne[pe],ae[pe]);Se.didChange&&(ne[pe]=Se.newValue,J=!0)}return new p(ne,J)}class g{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,J){return b(ae,J)}validate(ae){return this.defaultValue}}class h{constructor(ae,J,pe,Se){this.id=ae,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(ae,J){return b(ae,J)}validate(ae){return typeof ae=="undefined"?this.defaultValue:ae}compute(ae,J,pe){return pe}}function v(ne,ae){return typeof ne=="undefined"?ae:ne==="false"?!1:Boolean(ne)}e.boolean=v;class A extends h{constructor(ae,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="boolean",Se.default=pe);super(ae,J,pe,Se)}validate(ae){return v(ae,this.defaultValue)}}function _(ne,ae,J,pe){if(typeof ne=="undefined")return ae;let Se=parseInt(ne,10);return isNaN(Se)?ae:(Se=Math.max(J,Se),Se=Math.min(pe,Se),Se|0)}e.clampedInt=_;class a extends h{constructor(ae,J,pe,Se,Me,$e=void 0){typeof $e!="undefined"&&($e.type="integer",$e.default=pe,$e.minimum=Se,$e.maximum=Me);super(ae,J,pe,$e);this.minimum=Se,this.maximum=Me}static clampedInt(ae,J,pe,Se){return _(ae,J,pe,Se)}validate(ae){return a.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}class l extends h{constructor(ae,J,pe,Se,Me){typeof Me!="undefined"&&(Me.type="number",Me.default=pe);super(ae,J,pe,Me);this.validationFn=Se}static clamp(ae,J,pe){return ae<J?J:ae>pe?pe:ae}static float(ae,J){if(typeof ae=="number")return ae;if(typeof ae=="undefined")return J;const pe=parseFloat(ae);return isNaN(pe)?J:pe}validate(ae){return this.validationFn(l.float(ae,this.defaultValue))}}class u extends h{static string(ae,J){return typeof ae!="string"?J:ae}constructor(ae,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.default=pe);super(ae,J,pe,Se)}validate(ae){return u.string(ae,this.defaultValue)}}function c(ne,ae,J){return typeof ne!="string"||J.indexOf(ne)===-1?ae:ne}e.stringSet=c;class w extends h{constructor(ae,J,pe,Se,Me=void 0){typeof Me!="undefined"&&(Me.type="string",Me.enum=Se,Me.default=pe);super(ae,J,pe,Me);this._allowedValues=Se}validate(ae){return c(ae,this.defaultValue,this._allowedValues)}}class s extends D{constructor(ae,J,pe,Se,Me,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Me,Ye.default=Se);super(ae,J,pe,Ye);this._allowedValues=Me,this._convert=$e}validate(ae){return typeof ae!="string"?this.defaultValue:this._allowedValues.indexOf(ae)===-1?this.defaultValue:this._convert(ae)}}function n(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,J,pe){return pe===0?ae.accessibilitySupport:pe}}class i extends D{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:f.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{insertSpace:v(J.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(J.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(ne){switch(ne){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function P(ne){switch(ne){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class L extends g{constructor(){super(128)}compute(ae,J,pe){const Se=["monaco-editor"];return J.get(33)&&Se.push(J.get(33)),ae.extraEditorClassName&&Se.push(ae.extraEditorClassName),J.get(66)==="default"?Se.push("mouse-default"):J.get(66)==="copy"&&Se.push("mouse-copy"),J.get(100)&&Se.push("showUnused"),J.get(126)&&Se.push("showDeprecated"),Se.join(" ")}}class O extends A{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(ae,J,pe){return pe&&ae.emptySelectionClipboard}}class y extends D{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:f.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:f.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{cursorMoveOnType:v(J.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":c(J.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":c(J.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(J.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(J.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(J.loop,this.defaultValue.loop)}}}class H extends D{constructor(){super(45,"fontLigatures",H.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(ae){return typeof ae=="undefined"?this.defaultValue:typeof ae=="string"?ae==="false"?H.OFF:ae==="true"?H.ON:ae:Boolean(ae)?H.ON:H.OFF}}e.EditorFontLigatures=H,H.OFF='"liga" off, "calt" off',H.ON='"liga" on, "calt" on';class M extends g{constructor(){super(44)}compute(ae,J,pe){return ae.fontInfo}}class j extends h{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(ae){const J=l.float(ae,this.defaultValue);return J===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(J,6,100)}compute(ae,J,pe){return ae.fontInfo.fontSize}}class Q extends D{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.MINIMUM_VALUE,maximum:Q.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(a.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.MINIMUM_VALUE,Q.MAXIMUM_VALUE))}}Q.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],Q.MINIMUM_VALUE=1,Q.MAXIMUM_VALUE=1e3;class $ extends D{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},J={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},pe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...J},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...J},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...J},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...J},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...J},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:pe,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:pe,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:pe,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:pe,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:pe,description:f.localize(38,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{multiple:c(J.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:J.multipleDefinitions??c(J.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:J.multipleTypeDefinitions??c(J.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:J.multipleDeclarations??c(J.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:J.multipleImplementations??c(J.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:J.multipleReferences??c(J.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(J.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(J.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(J.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(J.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(J.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class U extends D{constructor(){const ae={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:f.localize(41,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:f.localize(42,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),delay:a.clampedInt(J.delay,this.defaultValue.delay,0,1e4),sticky:v(J.sticky,this.defaultValue.sticky),above:v(J.above,this.defaultValue.above)}}}var q;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class K extends g{constructor(){super(131)}compute(ae,J,pe){return K.computeLayout(J,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio})}static computeContainedMinimapLineCount(ae){const J=ae.height/ae.lineHeight,pe=ae.scrollBeyondLastLine?J-1:0,Se=(ae.viewLineCount+pe)/(ae.pixelRatio*ae.height),Me=Math.floor(ae.viewLineCount/Se);return{typicalViewportLineCount:J,extraLinesBeyondLastLine:pe,desiredRatio:Se,minimapLineCount:Me}}static _computeMinimapLayout(ae,J){const pe=ae.outerWidth,Se=ae.outerHeight,Me=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Se),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Se};const $e=J.stableMinimapLayoutInput,Ye=$e&&ae.outerHeight===$e.outerHeight&&ae.lineHeight===$e.lineHeight&&ae.typicalHalfwidthCharacterWidth===$e.typicalHalfwidthCharacterWidth&&ae.pixelRatio===$e.pixelRatio&&ae.scrollBeyondLastLine===$e.scrollBeyondLastLine&&ae.minimap.enabled===$e.minimap.enabled&&ae.minimap.side===$e.minimap.side&&ae.minimap.size===$e.minimap.size&&ae.minimap.showSlider===$e.minimap.showSlider&&ae.minimap.renderCharacters===$e.minimap.renderCharacters&&ae.minimap.maxColumn===$e.minimap.maxColumn&&ae.minimap.scale===$e.minimap.scale&&ae.verticalScrollbarWidth===$e.verticalScrollbarWidth&&ae.isViewportWrapping===$e.isViewportWrapping,lt=ae.lineHeight,vt=ae.typicalHalfwidthCharacterWidth,wt=ae.scrollBeyondLastLine,je=ae.minimap.renderCharacters;let st=Me>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const _t=ae.minimap.maxColumn,nt=ae.minimap.size,ct=ae.minimap.side,Rt=ae.verticalScrollbarWidth,Tt=ae.viewLineCount,yt=ae.remainingWidth,mt=ae.isViewportWrapping,Lt=je?2:3;let Mt=Math.floor(Me*Se);const Ft=Mt/Me;let xe=!1,_e=!1,ye=Lt*st,me=st/Me,ie=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:St,extraLinesBeyondLastLine:ot,desiredRatio:dt,minimapLineCount:ut}=K.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:wt,height:Se,lineHeight:lt,pixelRatio:Me});if(Tt/ut>1)xe=!0,_e=!0,st=1,ye=1,me=st/Me;else{let pt=!1,kt=st+1;if(nt==="fit"){const Ut=Math.ceil((Tt+ot)*ye);mt&&Ye&&yt<=J.stableFitRemainingWidth?(pt=!0,kt=J.stableFitMaxMinimapScale):pt=Ut>Mt}if(nt==="fill"||pt){xe=!0;const Ut=st;ye=Math.min(lt*Me,Math.max(1,Math.floor(1/dt))),mt&&Ye&&yt<=J.stableFitRemainingWidth&&(kt=J.stableFitMaxMinimapScale),st=Math.min(kt,Math.max(1,Math.floor(ye/Lt))),st>Ut&&(ie=Math.min(2,st/Ut)),me=st/Me/ie,Mt=Math.ceil(Math.max(St,Tt+ot)*ye),mt?(J.stableMinimapLayoutInput=ae,J.stableFitRemainingWidth=yt,J.stableFitMaxMinimapScale=st):(J.stableMinimapLayoutInput=null,J.stableFitRemainingWidth=0)}}}const Ie=Math.floor(_t*me),Re=Math.min(Ie,Math.max(0,Math.floor((yt-Rt-2)*me/(vt+me)))+e.MINIMAP_GUTTER_WIDTH);let Ve=Math.floor(Me*Re);const Ke=Ve/Me;Ve=Math.floor(Ve*ie);const ht=je?1:2,Et=ct==="left"?0:pe-Re-Rt;return{renderMinimap:ht,minimapLeft:Et,minimapWidth:Re,minimapHeightIsEditorHeight:xe,minimapIsSampling:_e,minimapScale:st,minimapLineHeight:ye,minimapCanvasInnerWidth:Ve,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Ke,minimapCanvasOuterHeight:Ft}}static computeLayout(ae,J){const pe=J.outerWidth|0,Se=J.outerHeight|0,Me=J.lineHeight|0,$e=J.lineNumbersDigitCount|0,Ye=J.typicalHalfwidthCharacterWidth,lt=J.maxDigitWidth,vt=J.pixelRatio,wt=J.viewLineCount,je=ae.get(123),st=je==="inherit"?ae.get(122):je,_t=st==="inherit"?ae.get(118):st,nt=ae.get(121),ct=ae.get(2),Rt=J.isDominatedByLongLines,Tt=ae.get(50),yt=ae.get(60).renderType!==0,mt=ae.get(61),Lt=ae.get(94),Mt=ae.get(65),Ft=ae.get(92),xe=Ft.verticalScrollbarSize,_e=Ft.verticalHasArrows,ye=Ft.arrowSize,me=Ft.horizontalScrollbarSize,ie=ae.get(58),Ie=ae.get(37);let Re;if(typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)){const Ht=parseFloat(ie.substr(0,ie.length-2));Re=a.clampedInt(Ht*Ye,0,0,1e3)}else Re=a.clampedInt(ie,0,0,1e3);Ie&&(Re+=16);let Ve=0;if(yt){const Ht=Math.max($e,mt);Ve=Math.round(Ht*lt)}let Ke=0;Tt&&(Ke=Me);let ht=0,Et=ht+Ke,St=Et+Ve,ot=St+Re;const dt=pe-Ke-Ve-Re;let ut=!1,Nt=!1,pt=-1;ct!==2&&(st==="inherit"&&Rt?(ut=!0,Nt=!0):_t==="on"||_t==="bounded"?Nt=!0:_t==="wordWrapColumn"&&(pt=nt));const kt=K._computeMinimapLayout({outerWidth:pe,outerHeight:Se,lineHeight:Me,typicalHalfwidthCharacterWidth:Ye,pixelRatio:vt,scrollBeyondLastLine:Lt,minimap:Mt,verticalScrollbarWidth:xe,viewLineCount:wt,remainingWidth:dt,isViewportWrapping:Nt},J.memory||new F);kt.renderMinimap!==0&&kt.minimapLeft===0&&(ht+=kt.minimapWidth,Et+=kt.minimapWidth,St+=kt.minimapWidth,ot+=kt.minimapWidth);const Ut=dt-kt.minimapWidth,Ct=Math.max(1,Math.floor((Ut-xe-2)/Ye)),Bt=_e?ye:0;return Nt&&(pt=Math.max(1,Ct),_t==="bounded"&&(pt=Math.min(pt,nt))),{width:pe,height:Se,glyphMarginLeft:ht,glyphMarginWidth:Ke,lineNumbersLeft:Et,lineNumbersWidth:Ve,decorationsLeft:St,decorationsWidth:Re,contentLeft:ot,contentWidth:Ut,minimap:kt,viewportColumn:Ct,isWordWrapMinified:ut,isViewportWrapping:Nt,wrappingColumn:pt,verticalScrollbarWidth:xe,horizontalScrollbarHeight:me,overviewRuler:{top:Bt,width:xe,height:Se-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=K;class G extends D{constructor(){const ae={enabled:!0};super(57,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:f.localize(43,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:v(ae.enabled,this.defaultValue.enabled)}}}class ee extends D{constructor(){const ae={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"boolean",default:ae.enabled,description:f.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:f.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:f.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(J.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(J.fontFamily,this.defaultValue.fontFamily)}}}class oe extends l{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>l.clamp(ae,0,150),{markdownDescription:f.localize(47,null)})}compute(ae,J,pe){return ae.fontInfo.lineHeight}}class ue extends D{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:f.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(49,null),f.localize(50,null),f.localize(51,null)],default:ae.size,description:f.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:f.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:f.localize(54,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:f.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:f.localize(57,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),size:c(J.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(J.side,this.defaultValue.side,["right","left"]),showSlider:c(J.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(J.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(J.scale,1,1,3),maxColumn:a.clampedInt(J.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Z(ne){return ne==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends D{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(59,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{top:a.clampedInt(J.top,0,0,1e3),bottom:a.clampedInt(J.bottom,0,0,1e3)}}}class se extends D{constructor(){const ae={enabled:!0,cycle:!1};super(76,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:f.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:f.localize(61,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),cycle:v(J.cycle,this.defaultValue.cycle)}}}class de extends g{constructor(){super(129)}compute(ae,J,pe){return ae.pixelRatio}}class ge extends D{constructor(){const ae={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",ae,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ae.strings,description:f.localize(62,null)},comments:{type:"boolean",default:ae.comments,description:f.localize(63,null)},other:{type:"boolean",default:ae.other,description:f.localize(64,null)}}}],default:ae,description:f.localize(65,null)});this.defaultValue=ae}validate(ae){if(typeof ae=="boolean")return ae;if(ae&&typeof ae=="object"){const J=ae,pe={other:v(J.other,this.defaultValue.other),comments:v(J.comments,this.defaultValue.comments),strings:v(J.strings,this.defaultValue.strings)};return pe.other&&pe.comments&&pe.strings?!0:!pe.other&&!pe.comments&&!pe.strings?!1:pe}return this.defaultValue}}var Te;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends D{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(66,null),f.localize(67,null),f.localize(68,null),f.localize(69,null)],default:"on",description:f.localize(70,null)})}validate(ae){let J=this.defaultValue.renderType,pe=this.defaultValue.renderFn;return typeof ae!="undefined"&&(typeof ae=="function"?(J=4,pe=ae):ae==="interval"?J=3:ae==="relative"?J=2:ae==="on"?J=1:J=0),{renderType:J,renderFn:pe}}}function be(ne){const ae=ne.get(87);return ae==="editable"?ne.get(81):ae!=="on"}e.filterValidationDecorations=be;class Ee extends D{constructor(){const ae=[],J={type:"number",description:f.localize(71,null)};super(91,"rulers",ae,{type:"array",items:{anyOf:[J,{type:["object"],properties:{column:J,color:{type:"string",description:f.localize(72,null),format:"color-hex"}}}]},default:ae,description:f.localize(73,null)})}validate(ae){if(Array.isArray(ae)){const J=[];for(let pe of ae)if(typeof pe=="number")J.push({column:a.clampedInt(pe,0,0,1e4),color:null});else if(pe&&typeof pe=="object"){const Se=pe;J.push({column:a.clampedInt(Se.column,0,0,1e4),color:Se.color})}return J.sort((pe,Se)=>pe.column-Se.column),J}return this.defaultValue}}function z(ne,ae){if(typeof ne!="string")return ae;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends D{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(74,null),f.localize(75,null),f.localize(76,null)],default:"auto",description:f.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)],default:"auto",description:f.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:f.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:f.localize(84,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae,pe=a.clampedInt(J.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Se=a.clampedInt(J.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(J.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(J.vertical,this.defaultValue.vertical),horizontal:z(J.horizontal,this.defaultValue.horizontal),useShadows:v(J.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(J.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(J.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(J.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(J.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:pe,horizontalSliderSize:a.clampedInt(J.horizontalSliderSize,pe,0,1e3),verticalScrollbarSize:Se,verticalSliderSize:a.clampedInt(J.verticalSliderSize,Se,0,1e3),scrollByPage:v(J.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class N extends D{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:f.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:f.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:f.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:f.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:f.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:f.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:f.localize(91,null)}})}applyUpdate(ae,J){let pe=!1;J.allowedCharacters&&(C.equals(ae.allowedCharacters,J.allowedCharacters)||(ae={...ae,allowedCharacters:J.allowedCharacters},pe=!0)),J.allowedLocales&&(C.equals(ae.allowedLocales,J.allowedLocales)||(ae={...ae,allowedLocales:J.allowedLocales},pe=!0));const Se=super.applyUpdate(ae,J);return pe?new p(Se.newValue,!0):Se}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{nonBasicASCII:he(J.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(J.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(J.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(J.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(J.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ae.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ae,J){if(typeof ae!="object"||!ae)return J;const pe={};for(const[Se,Me]of Object.entries(ae))Me===!0&&(pe[Se]=!0);return pe}}class W extends D{constructor(){const ae={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:f.localize(92,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),mode:c(J.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class V extends D{constructor(){const ae={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,description:f.localize(93,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:v(ae.enabled,this.defaultValue.enabled)}}}class re extends D{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(94,null),f.localize(95,null),f.localize(96,null)],default:ae.bracketPairs,description:f.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(98,null),f.localize(99,null),f.localize(100,null)],default:ae.bracketPairsHorizontal,description:f.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:f.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:f.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ae.highlightActiveIndentation,description:f.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{bracketPairs:he(J.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(J.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(J.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(J.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(J.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function he(ne,ae,J){const pe=J.indexOf(ne);return pe===-1?ae:J[pe]}class Ce extends D{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(105,null),f.localize(106,null)],default:ae.insertMode,description:f.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:f.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:f.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:f.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:f.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:f.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:f.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:f.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:f.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(146,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{insertMode:c(J.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(J.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(J.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(J.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(J.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(J.showIcons,this.defaultValue.showIcons),showStatusBar:v(J.showStatusBar,this.defaultValue.showStatusBar),preview:v(J.preview,this.defaultValue.preview),previewMode:c(J.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(J.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(J.showMethods,this.defaultValue.showMethods),showFunctions:v(J.showFunctions,this.defaultValue.showFunctions),showConstructors:v(J.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(J.showDeprecated,this.defaultValue.showDeprecated),showFields:v(J.showFields,this.defaultValue.showFields),showVariables:v(J.showVariables,this.defaultValue.showVariables),showClasses:v(J.showClasses,this.defaultValue.showClasses),showStructs:v(J.showStructs,this.defaultValue.showStructs),showInterfaces:v(J.showInterfaces,this.defaultValue.showInterfaces),showModules:v(J.showModules,this.defaultValue.showModules),showProperties:v(J.showProperties,this.defaultValue.showProperties),showEvents:v(J.showEvents,this.defaultValue.showEvents),showOperators:v(J.showOperators,this.defaultValue.showOperators),showUnits:v(J.showUnits,this.defaultValue.showUnits),showValues:v(J.showValues,this.defaultValue.showValues),showConstants:v(J.showConstants,this.defaultValue.showConstants),showEnums:v(J.showEnums,this.defaultValue.showEnums),showEnumMembers:v(J.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(J.showKeywords,this.defaultValue.showKeywords),showWords:v(J.showWords,this.defaultValue.showWords),showColors:v(J.showColors,this.defaultValue.showColors),showFiles:v(J.showFiles,this.defaultValue.showFiles),showReferences:v(J.showReferences,this.defaultValue.showReferences),showFolders:v(J.showFolders,this.defaultValue.showFolders),showTypeParameters:v(J.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(J.showSnippets,this.defaultValue.showSnippets),showUsers:v(J.showUsers,this.defaultValue.showUsers),showIssues:v(J.showIssues,this.defaultValue.showIssues)}}}class Ae extends D{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(147,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class We extends g{constructor(){super(130)}compute(ae,J,pe){return J.get(81)?!0:ae.tabFocusMode}}var ze;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(ze=e.WrappingIndent||(e.WrappingIndent={}));function qe(ne){switch(ne){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends g{constructor(){super(132)}compute(ae,J,pe){const Se=J.get(131);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Se.isWordWrapMinified,isViewportWrapping:Se.isViewportWrapping,wrappingColumn:Se.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Je:t.isLinux?et:Ue,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var it;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.autoClosingBrackets=5]="autoClosingBrackets",ne[ne.autoClosingDelete=6]="autoClosingDelete",ne[ne.autoClosingOvertype=7]="autoClosingOvertype",ne[ne.autoClosingQuotes=8]="autoClosingQuotes",ne[ne.autoIndent=9]="autoIndent",ne[ne.automaticLayout=10]="automaticLayout",ne[ne.autoSurround=11]="autoSurround",ne[ne.bracketPairColorization=12]="bracketPairColorization",ne[ne.guides=13]="guides",ne[ne.codeLens=14]="codeLens",ne[ne.codeLensFontFamily=15]="codeLensFontFamily",ne[ne.codeLensFontSize=16]="codeLensFontSize",ne[ne.colorDecorators=17]="colorDecorators",ne[ne.columnSelection=18]="columnSelection",ne[ne.comments=19]="comments",ne[ne.contextmenu=20]="contextmenu",ne[ne.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=22]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=24]="cursorStyle",ne[ne.cursorSurroundingLines=25]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=27]="cursorWidth",ne[ne.disableLayerHinting=28]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ne[ne.domReadOnly=30]="domReadOnly",ne[ne.dragAndDrop=31]="dragAndDrop",ne[ne.emptySelectionClipboard=32]="emptySelectionClipboard",ne[ne.extraEditorClassName=33]="extraEditorClassName",ne[ne.fastScrollSensitivity=34]="fastScrollSensitivity",ne[ne.find=35]="find",ne[ne.fixedOverflowWidgets=36]="fixedOverflowWidgets",ne[ne.folding=37]="folding",ne[ne.foldingStrategy=38]="foldingStrategy",ne[ne.foldingHighlight=39]="foldingHighlight",ne[ne.foldingImportsByDefault=40]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=41]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=43]="fontFamily",ne[ne.fontInfo=44]="fontInfo",ne[ne.fontLigatures=45]="fontLigatures",ne[ne.fontSize=46]="fontSize",ne[ne.fontWeight=47]="fontWeight",ne[ne.formatOnPaste=48]="formatOnPaste",ne[ne.formatOnType=49]="formatOnType",ne[ne.glyphMargin=50]="glyphMargin",ne[ne.gotoLocation=51]="gotoLocation",ne[ne.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ne[ne.hover=53]="hover",ne[ne.inDiffEditor=54]="inDiffEditor",ne[ne.inlineSuggest=55]="inlineSuggest",ne[ne.letterSpacing=56]="letterSpacing",ne[ne.lightbulb=57]="lightbulb",ne[ne.lineDecorationsWidth=58]="lineDecorationsWidth",ne[ne.lineHeight=59]="lineHeight",ne[ne.lineNumbers=60]="lineNumbers",ne[ne.lineNumbersMinChars=61]="lineNumbersMinChars",ne[ne.linkedEditing=62]="linkedEditing",ne[ne.links=63]="links",ne[ne.matchBrackets=64]="matchBrackets",ne[ne.minimap=65]="minimap",ne[ne.mouseStyle=66]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=68]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=70]="multiCursorModifier",ne[ne.multiCursorPaste=71]="multiCursorPaste",ne[ne.occurrencesHighlight=72]="occurrencesHighlight",ne[ne.overviewRulerBorder=73]="overviewRulerBorder",ne[ne.overviewRulerLanes=74]="overviewRulerLanes",ne[ne.padding=75]="padding",ne[ne.parameterHints=76]="parameterHints",ne[ne.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=79]="quickSuggestions",ne[ne.quickSuggestionsDelay=80]="quickSuggestionsDelay",ne[ne.readOnly=81]="readOnly",ne[ne.renameOnType=82]="renameOnType",ne[ne.renderControlCharacters=83]="renderControlCharacters",ne[ne.renderFinalNewline=84]="renderFinalNewline",ne[ne.renderLineHighlight=85]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=87]="renderValidationDecorations",ne[ne.renderWhitespace=88]="renderWhitespace",ne[ne.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ne[ne.roundedSelection=90]="roundedSelection",ne[ne.rulers=91]="rulers",ne[ne.scrollbar=92]="scrollbar",ne[ne.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=94]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=95]="scrollPredominantAxis",ne[ne.selectionClipboard=96]="selectionClipboard",ne[ne.selectionHighlight=97]="selectionHighlight",ne[ne.selectOnLineNumbers=98]="selectOnLineNumbers",ne[ne.showFoldingControls=99]="showFoldingControls",ne[ne.showUnused=100]="showUnused",ne[ne.snippetSuggestions=101]="snippetSuggestions",ne[ne.smartSelect=102]="smartSelect",ne[ne.smoothScrolling=103]="smoothScrolling",ne[ne.stickyTabStops=104]="stickyTabStops",ne[ne.stopRenderingLineAfter=105]="stopRenderingLineAfter",ne[ne.suggest=106]="suggest",ne[ne.suggestFontSize=107]="suggestFontSize",ne[ne.suggestLineHeight=108]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ne[ne.suggestSelection=110]="suggestSelection",ne[ne.tabCompletion=111]="tabCompletion",ne[ne.tabIndex=112]="tabIndex",ne[ne.unicodeHighlighting=113]="unicodeHighlighting",ne[ne.unusualLineTerminators=114]="unusualLineTerminators",ne[ne.useShadowDOM=115]="useShadowDOM",ne[ne.useTabStops=116]="useTabStops",ne[ne.wordSeparators=117]="wordSeparators",ne[ne.wordWrap=118]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=121]="wordWrapColumn",ne[ne.wordWrapOverride1=122]="wordWrapOverride1",ne[ne.wordWrapOverride2=123]="wordWrapOverride2",ne[ne.wrappingIndent=124]="wrappingIndent",ne[ne.wrappingStrategy=125]="wrappingStrategy",ne[ne.showDeprecated=126]="showDeprecated",ne[ne.inlayHints=127]="inlayHints",ne[ne.editorClassName=128]="editorClassName",ne[ne.pixelRatio=129]="pixelRatio",ne[ne.tabFocusMode=130]="tabFocusMode",ne[ne.layoutInfo=131]="layoutInfo",ne[ne.wrappingInfo=132]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new A(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(148,null)})),acceptSuggestionOnEnter:Le(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(149,null),""],markdownDescription:f.localize(150,null)})),accessibilitySupport:Le(new r),accessibilityPageSize:Le(new a(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(151,null)})),ariaLabel:Le(new u(4,"ariaLabel",f.localize(152,null))),autoClosingBrackets:Le(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(153,null),f.localize(154,null),""],description:f.localize(155,null)})),autoClosingDelete:Le(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(156,null),""],description:f.localize(157,null)})),autoClosingOvertype:Le(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(158,null),""],description:f.localize(159,null)})),autoClosingQuotes:Le(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(160,null),f.localize(161,null),""],description:f.localize(162,null)})),autoIndent:Le(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[f.localize(163,null),f.localize(164,null),f.localize(165,null),f.localize(166,null),f.localize(167,null)],description:f.localize(168,null)})),automaticLayout:Le(new A(10,"automaticLayout",!1)),autoSurround:Le(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(169,null),f.localize(170,null),f.localize(171,null),""],description:f.localize(172,null)})),bracketPairColorization:Le(new V),bracketPairGuides:Le(new re),stickyTabStops:Le(new A(104,"stickyTabStops",!1,{description:f.localize(173,null)})),codeLens:Le(new A(14,"codeLens",!0,{description:f.localize(174,null)})),codeLensFontFamily:Le(new u(15,"codeLensFontFamily","",{description:f.localize(175,null)})),codeLensFontSize:Le(new a(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(176,null)})),colorDecorators:Le(new A(17,"colorDecorators",!0,{description:f.localize(177,null)})),columnSelection:Le(new A(18,"columnSelection",!1,{description:f.localize(178,null)})),comments:Le(new i),contextmenu:Le(new A(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new A(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(179,null)})),cursorBlinking:Le(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:f.localize(180,null)})),cursorSmoothCaretAnimation:Le(new A(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(181,null)})),cursorStyle:Le(new s(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:f.localize(182,null)})),cursorSurroundingLines:Le(new a(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(183,null)})),cursorSurroundingLinesStyle:Le(new w(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(184,null),f.localize(185,null)],description:f.localize(186,null)})),cursorWidth:Le(new a(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(187,null)})),disableLayerHinting:Le(new A(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new A(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new A(30,"domReadOnly",!1)),dragAndDrop:Le(new A(31,"dragAndDrop",!0,{description:f.localize(188,null)})),emptySelectionClipboard:Le(new O),extraEditorClassName:Le(new u(33,"extraEditorClassName","")),fastScrollSensitivity:Le(new l(34,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:f.localize(189,null)})),find:Le(new y),fixedOverflowWidgets:Le(new A(36,"fixedOverflowWidgets",!1)),folding:Le(new A(37,"folding",!0,{description:f.localize(190,null)})),foldingStrategy:Le(new w(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(191,null),f.localize(192,null)],description:f.localize(193,null)})),foldingHighlight:Le(new A(39,"foldingHighlight",!0,{description:f.localize(194,null)})),foldingImportsByDefault:Le(new A(40,"foldingImportsByDefault",!1,{description:f.localize(195,null)})),foldingMaximumRegions:Le(new a(41,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(196,null)})),unfoldOnClickAfterEndOfLine:Le(new A(42,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(197,null)})),fontFamily:Le(new u(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(198,null)})),fontInfo:Le(new M),fontLigatures2:Le(new H),fontSize:Le(new j),fontWeight:Le(new Q),formatOnPaste:Le(new A(48,"formatOnPaste",!1,{description:f.localize(199,null)})),formatOnType:Le(new A(49,"formatOnType",!1,{description:f.localize(200,null)})),glyphMargin:Le(new A(50,"glyphMargin",!0,{description:f.localize(201,null)})),gotoLocation:Le(new $),hideCursorInOverviewRuler:Le(new A(52,"hideCursorInOverviewRuler",!1,{description:f.localize(202,null)})),hover:Le(new U),inDiffEditor:Le(new A(54,"inDiffEditor",!1)),letterSpacing:Le(new l(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>l.clamp(ne,-5,20),{description:f.localize(203,null)})),lightbulb:Le(new G),lineDecorationsWidth:Le(new h(58,"lineDecorationsWidth",10)),lineHeight:Le(new oe),lineNumbers:Le(new Ne),lineNumbersMinChars:Le(new a(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new A(62,"linkedEditing",!1,{description:f.localize(204,null)})),links:Le(new A(63,"links",!0,{description:f.localize(205,null)})),matchBrackets:Le(new w(64,"matchBrackets","always",["always","near","never"],{description:f.localize(206,null)})),minimap:Le(new ue),mouseStyle:Le(new w(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new l(67,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:f.localize(207,null)})),mouseWheelZoom:Le(new A(68,"mouseWheelZoom",!1,{markdownDescription:f.localize(208,null)})),multiCursorMergeOverlapping:Le(new A(69,"multiCursorMergeOverlapping",!0,{description:f.localize(209,null)})),multiCursorModifier:Le(new s(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Z,{markdownEnumDescriptions:[f.localize(210,null),f.localize(211,null)],markdownDescription:f.localize(212,null)})),multiCursorPaste:Le(new w(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(213,null),f.localize(214,null)],markdownDescription:f.localize(215,null)})),occurrencesHighlight:Le(new A(72,"occurrencesHighlight",!0,{description:f.localize(216,null)})),overviewRulerBorder:Le(new A(73,"overviewRulerBorder",!0,{description:f.localize(217,null)})),overviewRulerLanes:Le(new a(74,"overviewRulerLanes",3,0,3)),padding:Le(new Y),parameterHints:Le(new se),peekWidgetDefaultFocus:Le(new w(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(218,null),f.localize(219,null)],description:f.localize(220,null)})),definitionLinkOpensInPeek:Le(new A(78,"definitionLinkOpensInPeek",!1,{description:f.localize(221,null)})),quickSuggestions:Le(new ge),quickSuggestionsDelay:Le(new a(80,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(222,null)})),readOnly:Le(new A(81,"readOnly",!1)),renameOnType:Le(new A(82,"renameOnType",!1,{description:f.localize(223,null),markdownDeprecationMessage:f.localize(224,null)})),renderControlCharacters:Le(new A(83,"renderControlCharacters",!0,{description:f.localize(225,null),restricted:!0})),renderFinalNewline:Le(new A(84,"renderFinalNewline",!0,{description:f.localize(226,null)})),renderLineHighlight:Le(new w(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(227,null)],description:f.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Le(new A(86,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(229,null)})),renderValidationDecorations:Le(new w(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new w(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(230,null),f.localize(231,null),f.localize(232,null),""],description:f.localize(233,null)})),revealHorizontalRightPadding:Le(new a(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Le(new A(90,"roundedSelection",!0,{description:f.localize(234,null)})),rulers:Le(new Ee),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new a(93,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(235,null)})),scrollBeyondLastLine:Le(new A(94,"scrollBeyondLastLine",!0,{description:f.localize(236,null)})),scrollPredominantAxis:Le(new A(95,"scrollPredominantAxis",!0,{description:f.localize(237,null)})),selectionClipboard:Le(new A(96,"selectionClipboard",!0,{description:f.localize(238,null),included:t.isLinux})),selectionHighlight:Le(new A(97,"selectionHighlight",!0,{description:f.localize(239,null)})),selectOnLineNumbers:Le(new A(98,"selectOnLineNumbers",!0)),showFoldingControls:Le(new w(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(240,null),f.localize(241,null)],description:f.localize(242,null)})),showUnused:Le(new A(100,"showUnused",!0,{description:f.localize(243,null)})),showDeprecated:Le(new A(126,"showDeprecated",!0,{description:f.localize(244,null)})),inlayHints:Le(new ee),snippetSuggestions:Le(new w(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null),f.localize(248,null)],description:f.localize(249,null)})),smartSelect:Le(new Ae),smoothScrolling:Le(new A(103,"smoothScrolling",!1,{description:f.localize(250,null)})),stopRenderingLineAfter:Le(new a(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ce),inlineSuggest:Le(new W),suggestFontSize:Le(new a(107,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(251,null)})),suggestLineHeight:Le(new a(108,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(252,null)})),suggestOnTriggerCharacters:Le(new A(109,"suggestOnTriggerCharacters",!0,{description:f.localize(253,null)})),suggestSelection:Le(new w(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(254,null),f.localize(255,null),f.localize(256,null)],description:f.localize(257,null)})),tabCompletion:Le(new w(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),tabIndex:Le(new a(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new N),unusualLineTerminators:Le(new w(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(262,null),f.localize(263,null),f.localize(264,null)],description:f.localize(265,null)})),useShadowDOM:Le(new A(115,"useShadowDOM",!0)),useTabStops:Le(new A(116,"useTabStops",!0,{description:f.localize(266,null)})),wordSeparators:Le(new u(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:f.localize(267,null)})),wordWrap:Le(new w(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(268,null),f.localize(269,null),f.localize(270,null),f.localize(271,null)],description:f.localize(272,null)})),wordWrapBreakAfterCharacters:Le(new u(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new u(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new a(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(273,null)})),wordWrapOverride1:Le(new w(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new w(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Le(new s(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],qe,{enumDescriptions:[f.localize(274,null),f.localize(275,null),f.localize(276,null),f.localize(277,null)],description:f.localize(278,null)})),wrappingStrategy:Le(new w(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(279,null),f.localize(280,null)],description:f.localize(281,null)})),editorClassName:Le(new L),pixelRatio:Le(new de),tabFocusMode:Le(new We),layoutInfo:Le(new K),wrappingInfo:Le(new He)}}),define(ve[159],we([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[160],we([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[161],we([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[162],we([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[163],we([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ve[164],we([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ve[165],we([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ve[166],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[167],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[168],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[169],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[170],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[171],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[172],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[173],we([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[174],we([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[175],we([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ve[176],we([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[177],we([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ve[178],we([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[179],we([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[180],we([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[181],we([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ve[182],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var f;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var I;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(I=e.EditorOpenSource||(e.EditorOpenSource={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var C;(function(k){k.PROGRAMMATIC="api",k.NAVIGATION="code.navigation",k.JUMP="code.jump"})(C=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(ve[183],we([1,0,161]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function T(p){return p=p.trim(),p==="*"||t.test(p)}e.isValidVersionStr=T;function C(p){if(!T(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=p.match(t);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=C;function k(p){if(!p)return null;let b=p.majorBase,g=p.majorMustEqual,h=p.minorBase,v=p.minorMustEqual,A=p.patchBase,_=p.patchMustEqual;p.hasCaret&&(b===0||(v=!1),_=!1);let a=0;if(p.preRelease){const l=I.exec(p.preRelease);if(l){const[,u,c,w]=l;a=Date.UTC(Number(u),Number(c)-1,Number(w))}}return{majorBase:b,majorMustEqual:g,minorBase:h,minorMustEqual:v,patchBase:A,patchMustEqual:_,isMinimum:p.hasGreaterEquals,notBefore:a}}e.normalizeVersion=k;function S(p,b,g){let h;typeof p=="string"?h=k(C(p)):h=p;let v;b instanceof Date?v=b.getTime():typeof b=="string"&&(v=new Date(b).getTime());let A;if(typeof g=="string"?A=k(C(g)):A=g,!h||!A)return!1;let _=h.majorBase,a=h.minorBase,l=h.patchBase,u=A.majorBase,c=A.minorBase,w=A.patchBase,s=A.notBefore,n=A.majorMustEqual,r=A.minorMustEqual,i=A.patchMustEqual;return A.isMinimum?_>u?!0:_<u?!1:a>c?!0:a<c||v&&v<s?!1:l>=w:(_===1&&u===0&&(!n||!r||!i)&&(u=1,c=0,w=0,n=!0,r=!1,i=!1),_<u?!1:_>u?!n:a<c?!1:a>c?!r:l<w?!1:l>w?!i:!(v&&v<s))}e.isValidVersion=S;function R(p,b,g,h){return g.isBuiltin||typeof g.main=="undefined"?!0:D(p,b,g.engines.vscode,h)}e.isValidExtensionVersion=R;function F(p,b,g){return p==="*"||D(b,g,p)}e.isEngineValid=F;function D(p,b,g,h=[]){let v=k(C(g));if(!v)return h.push(f.localize(0,null,g)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return h.push(f.localize(1,null,g)),!1}else if(!v.majorMustEqual)return h.push(f.localize(2,null,g)),!1;return S(p,b,v)?!0:(h.push(f.localize(3,null,p,g)),!1)}}),define(ve[114],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(I,T=[],C=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=f}),define(ve[79],we([1,0,114]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function I(C,k,S){k instanceof f.SyncDescriptor||(k=new f.SyncDescriptor(k,[],S)),t.push([C,k])}e.registerSingleton=I;function T(){return t}e.getSingletonServiceDescriptors=T}),define(ve[184],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=f;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let C of this._nodes.values())C.outgoing.size===0&&T.push(C);return T}insertEdge(T,C){const k=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(C);k.outgoing.set(this._hashFn(C),S),S.incoming.set(this._hashFn(T),k)}removeNode(T){const C=this._hashFn(T);this._nodes.delete(C);for(let k of this._nodes.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(T){const C=this._hashFn(T);let k=this._nodes.get(C);return k||(k=new f(T),this._nodes.set(C,k)),k}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[C,k]of this._nodes)T.push(`${C}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,C]of this._nodes){const k=new Set([T]),S=this._findCycle(C,k);if(S)return S}}_findCycle(T,C){for(let[k,S]of T.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const R=this._findCycle(S,C);if(R)return R;C.delete(k)}}}e.Graph=t}),define(ve[4],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(f=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(C,k,S){k[f.DI_TARGET]===k?k[f.DI_DEPENDENCIES].push({id:C,index:S}):(k[f.DI_DEPENDENCIES]=[{id:C,index:S}],k[f.DI_TARGET]=k)}function I(C){if(f.serviceIds.has(C))return f.serviceIds.get(C);const k=function(S,R,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,S,F)};return k.toString=()=>C,f.serviceIds.set(C,k),k}e.createDecorator=I;function T(C){return C}e.refineServiceDecorator=T}),define(ve[115],we([1,0,13,2,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function T(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationOverrides=T;function C(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||f.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function R(v,A){const _=Object.create(null);for(let a in v)F(_,a,v[a],A);return _}e.toValuesTree=R;function F(v,A,_,a){const l=A.split("."),u=l.pop();let c=v;for(let w=0;w<l.length;w++){let s=l[w],n=c[s];switch(typeof n){case"undefined":n=c[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${A} as ${l.slice(0,w+1).join(".")} is ${JSON.stringify(n)}`);return}c=n}if(typeof c=="object"&&c!==null)try{c[u]=_}catch{a(`Ignoring ${A} as ${l.join(".")} is ${JSON.stringify(c)}`)}else a(`Ignoring ${A} as ${l.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=F;function D(v,A){const _=A.split(".");p(v,_)}e.removeFromValueTree=D;function p(v,A){const _=A.shift();if(A.length===0){delete v[_];return}if(Object.keys(v).indexOf(_)!==-1){const a=v[_];typeof a=="object"&&!Array.isArray(a)&&(p(a,A),Object.keys(a).length===0&&delete v[_])}}function b(v,A,_){function a(c,w){let s=c;for(const n of w){if(typeof s!="object"||s===null)return;s=s[n]}return s}const l=A.split("."),u=a(v,l);return typeof u=="undefined"?_:u}e.getConfigurationValue=b;function g(v,A,_){Object.keys(A).forEach(a=>{a!=="__proto__"&&(a in v?f.isObject(v[a])&&f.isObject(A[a])?g(v[a],A[a],_):_&&(v[a]=A[a]):v[a]=A[a])})}e.merge=g;function h(v,A,_){const a=v.inspect(A),l=v.inspect(_);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:a.defaultValue}e.getMigratedSettingValue=h}),define(ve[61],we([1,0,12,8,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",f.isMacintosh),T.set("isLinux",f.isLinux),T.set("isWindows",f.isWindows),T.set("isWeb",f.isWeb),T.set("isMacNative",f.isMacintosh&&!f.isWeb),T.set("isEdge",f.isEdge),T.set("isFirefox",f.isFirefox),T.set("isChrome",f.isChrome),T.set("isSafari",f.isSafari);const C=Object.prototype.hasOwnProperty;var k;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return p.INSTANCE}static has(y){return b.create(y)}static equals(y,H){return g.create(y,H)}static notEquals(y,H){return A.create(y,H)}static regex(y,H){return s.create(y,H)}static in(y,H){return h.create(y,H)}static not(y){return _.create(y)}static and(...y){return i.create(y,null)}static or(...y){return o.create(y,null,!0)}static greater(y,H){return l.create(y,H)}static greaterEquals(y,H){return u.create(y,H)}static smaller(y,H){return c.create(y,H)}static smallerEquals(y,H){return w.create(y,H)}static deserialize(y,H=!1){if(!!y)return this._deserializeOrExpression(y,H)}static _deserializeOrExpression(y,H){let M=y.split("||");return o.create(M.map(j=>this._deserializeAndExpression(j,H)),null,!0)}static _deserializeAndExpression(y,H){let M=y.split("&&");return i.create(M.map(j=>this._deserializeOne(j,H)),null)}static _deserializeOne(y,H){if(y=y.trim(),y.indexOf("!=")>=0){let M=y.split("!=");return A.create(M[0].trim(),this._deserializeValue(M[1],H))}if(y.indexOf("==")>=0){let M=y.split("==");return g.create(M[0].trim(),this._deserializeValue(M[1],H))}if(y.indexOf("=~")>=0){let M=y.split("=~");return s.create(M[0].trim(),this._deserializeRegexValue(M[1],H))}if(y.indexOf(" in ")>=0){let M=y.split(" in ");return h.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const M=y.split(">=");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const M=y.split(">");return l.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const M=y.split("<=");return w.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const M=y.split("<");return c.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(y)?_.create(y.substr(1).trim()):b.create(y)}static _deserializeValue(y,H){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let M=/^'([^']*)'$/.exec(y);return M?M[1].trim():y}static _deserializeRegexValue(y,H){if((0,t.isFalsyOrWhitespace)(y)){if(H)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=y.indexOf("/"),j=y.lastIndexOf("/");if(M===j||M<0){if(H)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let Q=y.slice(M+1,j),$=y[j+1]==="i"?"i":"";try{return new RegExp(Q,$)}catch(U){if(H)throw new Error(`bad regexp-value '${y}', parse error: ${U}`);return console.warn(`bad regexp-value '${y}', parse error: ${U}`),null}}}e.ContextKeyExpr=S;function R(O,y){const H=O?O.substituteConstants():void 0,M=y?y.substituteConstants():void 0;return!H&&!M?!0:!H||!M?!1:H.equals(M)}e.expressionsAreEqualWithConstantSubstitution=R;function F(O,y){return O.cmp(y)}class D{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class p{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class b{constructor(y,H){this.key=y,this.negated=H,this.type=2}static create(y,H=null){const M=T.get(y);return typeof M=="boolean"?M?p.INSTANCE:D.INSTANCE:new b(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=T.get(this.key);return typeof y=="boolean"?y?p.INSTANCE:D.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class g{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=4}static create(y,H,M=null){if(typeof H=="boolean")return H?b.create(y,M):_.create(y,M);const j=T.get(y);return typeof j=="boolean"?H===(j?"true":"false")?p.INSTANCE:D.INSTANCE:new g(y,H,M)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=T.get(this.key);if(typeof y=="boolean"){const H=y?"true":"false";return this.value===H?p.INSTANCE:D.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class h{constructor(y,H){this.key=y,this.valueKey=H,this.type=10,this.negated=null}static create(y,H){return new h(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const H=y.getValue(this.valueKey),M=y.getValue(this.key);return Array.isArray(H)?H.indexOf(M)>=0:typeof M=="string"&&typeof H=="object"&&H!==null?C.call(H,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=h;class v{constructor(y){this._actual=y,this.type=11}static create(y){return new v(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new v(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class A{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=5}static create(y,H,M=null){if(typeof H=="boolean")return H?_.create(y,M):b.create(y,M);const j=T.get(y);return typeof j=="boolean"?H===(j?"true":"false")?D.INSTANCE:p.INSTANCE:new A(y,H,M)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=T.get(this.key);if(typeof y=="boolean"){const H=y?"true":"false";return this.value===H?D.INSTANCE:p.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=A;class _{constructor(y,H){this.key=y,this.negated=H,this.type=3}static create(y,H=null){const M=T.get(y);return typeof M=="boolean"?M?D.INSTANCE:p.INSTANCE:new _(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=T.get(this.key);return typeof y=="boolean"?y?D.INSTANCE:p.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function a(O,y){if(typeof O=="string"){const H=parseFloat(O);isNaN(H)||(O=H)}return typeof O=="string"||typeof O=="number"?y(O):D.INSTANCE}class l{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=12}static create(y,H,M=null){return a(H,j=>new l(y,j,M))}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class u{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=13}static create(y,H,M=null){return a(H,j=>new u(y,j,M))}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class c{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=14}static create(y,H,M=null){return a(H,j=>new c(y,j,M))}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=c;class w{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=15}static create(y,H,M=null){return a(H,j=>new w(y,j,M))}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=w;class s{constructor(y,H){this.key=y,this.regexp=H,this.type=7,this.negated=null}static create(y,H){return new s(y,H)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const H=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return H<M?-1:H>M?1:0}equals(y){if(y.type===this.type){const H=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return this.key===y.key&&H===M}return!1}substituteConstants(){return this}evaluate(y){let H=y.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(y){this._actual=y,this.type=8}static create(y){return new n(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new n(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function r(O){let y=null;for(let H=0,M=O.length;H<M;H++){const j=O[H].substituteConstants();if(O[H]!==j&&y===null){y=[];for(let Q=0;Q<H;Q++)y[Q]=O[Q]}y!==null&&(y[H]=j)}return y===null?O:y}class i{constructor(y,H){this.expr=y,this.negated=H,this.type=6}static create(y,H){return i._normalizeArr(y,H)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let H=0,M=this.expr.length;H<M;H++){const j=F(this.expr[H],y.expr[H]);if(j!==0)return j}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].equals(y.expr[H]))return!1;return!0}return!1}substituteConstants(){const y=r(this.expr);return y===this.expr?this:i.create(y,this.negated)}evaluate(y){for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].evaluate(y))return!1;return!0}static _normalizeArr(y,H){const M=[];let j=!1;for(const Q of y)if(!!Q){if(Q.type===1){j=!0;continue}if(Q.type===0)return D.INSTANCE;if(Q.type===6){M.push(...Q.expr);continue}M.push(Q)}if(M.length===0&&j)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(F);for(let Q=1;Q<M.length;Q++)M[Q-1].equals(M[Q])&&(M.splice(Q,1),Q--);if(M.length===1)return M[0];for(;M.length>1;){const Q=M[M.length-1];if(Q.type!==9)break;M.pop();const $=M.pop(),U=M.length===0,q=o.create(Q.expr.map(K=>i.create([K,$],null)),null,U);q&&(M.push(q),M.sort(F))}return M.length===1?M[0]:new i(M,H)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let H of this.expr)y.push(...H.keys());return y}map(y){return new i(this.expr.map(H=>H.map(y)),null)}negate(){if(!this.negated){const y=[];for(let H of this.expr)y.push(H.negate());this.negated=o.create(y,this,!0)}return this.negated}}class o{constructor(y,H){this.expr=y,this.negated=H,this.type=9}static create(y,H,M){return o._normalizeArr(y,H,M)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let H=0,M=this.expr.length;H<M;H++){const j=F(this.expr[H],y.expr[H]);if(j!==0)return j}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].equals(y.expr[H]))return!1;return!0}return!1}substituteConstants(){const y=r(this.expr);return y===this.expr?this:o.create(y,this.negated,!1)}evaluate(y){for(let H=0,M=this.expr.length;H<M;H++)if(this.expr[H].evaluate(y))return!0;return!1}static _normalizeArr(y,H,M){let j=[],Q=!1;if(y){for(let $=0,U=y.length;$<U;$++){const q=y[$];if(!!q){if(q.type===0){Q=!0;continue}if(q.type===1)return p.INSTANCE;if(q.type===9){j=j.concat(q.expr);continue}j.push(q)}}if(j.length===0&&Q)return D.INSTANCE;j.sort(F)}if(j.length!==0){if(j.length===1)return j[0];for(let $=1;$<j.length;$++)j[$-1].equals(j[$])&&(j.splice($,1),$--);if(j.length===1)return j[0];if(M){for(let $=0;$<j.length;$++)for(let U=$+1;U<j.length;U++)P(j[$],j[U])&&(j.splice(U,1),U--);if(j.length===1)return j[0]}return new o(j,H)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let H of this.expr)y.push(...H.keys());return y}map(y){return new o(this.expr.map(H=>H.map(y)),null)}negate(){if(!this.negated){let y=[];for(let H of this.expr)y.push(H.negate());for(;y.length>1;){const H=y.shift(),M=y.shift(),j=[];for(const $ of L(H))for(const U of L(M))j.push(i.create([$,U],null));const Q=y.length===0;y.unshift(o.create(j,null,Q))}this.negated=y[0]}return this.negated}}class m extends b{constructor(y,H,M){super(y,null);this._defaultValue=H,typeof M=="object"?m._info.push({...M,key:y}):M!==!0&&m._info.push({key:y,description:M,type:H!=null?typeof H:void 0})}static all(){return m._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return g.create(this.key,y)}notEqualsTo(y){return A.create(this.key,y)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(O,y){return O<y?-1:O>y?1:0}function E(O,y,H,M){return O<H?-1:O>H?1:y<M?-1:y>M?1:0}function P(O,y){if(y.type===6&&O.type!==9&&O.type!==6){for(const j of y.expr)if(O.equals(j))return!0}const H=O.negate(),M=L(H).concat(L(y));M.sort(F);for(let j=0;j<M.length;j++){const $=M[j].negate();for(let U=j+1;U<M.length;U++){const q=M[U];if($.equals(q))return!0}}return!1}e.implies=P;function L(O){return O.type===9?O.expr:[O]}}),define(ve[185],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[186],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(ve[187],we([1,0,38,10,9,12,93,28,112,162,186]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const D=R.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends p{openTerminal(l,u){return this.spawnTerminal(f,l,S.getWindowsShell(),u)}spawnTerminal(l,u,c,w){const s=u.windowsExec||b.getDefaultTerminalWindows();w&&w[1]===":"&&(w=w[0].toUpperCase()+w.substr(1));const n=I.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return l.spawn(s,w?[w]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(n==="wt"||n==="wt.exe")&&r.push("-d ."),new Promise((i,o)=>{const m=v(process),d=l.spawn(c,r,{cwd:w,env:m});d.on("error",o),d.on("exit",()=>i())})}runInTerminal(l,u,c,w,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:b.getDefaultTerminalWindows();return new Promise((r,i)=>{const o=`"${u} - ${D}"`,m=`""${c.join('" "')}" & pause"`,d=["/c","start",o,"/wait",n,"/c",m],E=Object.assign({},v(process),w);Object.keys(E).filter(O=>E[O]===null).forEach(O=>delete E[O]);const P={cwd:u,env:E,windowsVerbatimArguments:!0};f.spawn(b.CMD,d,P).on("error",O=>{i(A(O))}),r(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class g extends p{openTerminal(l,u){return this.spawnTerminal(f,l,u)}runInTerminal(l,u,c,w,s){const n=s.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{if(n===F.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const o=n===F.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,te).fsPath,"-t",l||D,"-w",u];for(let L of c)d.push("-a"),d.push(L);if(w){const L=Object.assign({},v(process),w);for(let O in L){const y=L[O];y===null?(d.push("-u"),d.push(O)):(d.push("-e"),d.push(`${O}=${y}`))}}let E="";const P=f.spawn(g.OSASCRIPT,d);P.on("error",L=>{i(A(L))}),P.stderr.on("data",L=>{E+=L.toString()}),P.on("exit",L=>{if(L===0)r(void 0);else if(E){const O=E.split(`
`,1);i(new Error(O[0]))}else i(new Error(R.localize(1,null,o,L)))})}else i(new Error(R.localize(2,null,n)))})}spawnTerminal(l,u,c){const w=u.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const r=["-a",w];c&&r.push(c);const i=v(process),o=l.spawn("/usr/bin/open",r,{cwd:c,env:i});o.on("error",n),o.on("exit",()=>s())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class h extends p{openTerminal(l,u){return this.spawnTerminal(f,l,u)}runInTerminal(l,u,c,w,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{let o=[];n.then(m=>{m.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const d=`${_(c)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;o.push(`''${d}''`);const E=Object.assign({},v(process),w);Object.keys(E).filter(y=>E[y]===null).forEach(y=>delete E[y]);const P={cwd:u,env:E};let L="";const O=f.spawn(m,o,P);O.on("error",y=>{i(A(y))}),O.stderr.on("data",y=>{L+=y.toString()}),O.on("exit",y=>{if(y===0)r(void 0);else if(L){const H=L.split(`
`,1);i(new Error(H[0]))}else i(new Error(R.localize(4,null,m,y)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!T.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const l=await k.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{l?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,u,c){const w=u.linuxExec?Promise.resolve(u.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{w.then(r=>{const i=v(process),o=l.spawn(r,[],{cwd:c,env:i});o.on("error",n),o.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=R.localize(3,null);function v(a){const l={...a.env};return(0,C.sanitizeProcessEnvironment)(l),l}function A(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(R.localize(5,null,a.path)):a}function _(a){let l="";for(let u of a)u.indexOf(" ")>=0?l+='"'+u+'"':l+=u,l+=" ";return l}}),define(ve[42],we([1,0,15,24,9,8,13,2,163,4]),function(te,e,f,t,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,R.createDecorator)("fileService");function F($){return $.create===!0}e.isFileOpenForWriteOptions=F;var D;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var p;(function($){$[$.Readonly=1]="Readonly"})(p=e.FilePermission||(e.FilePermission={}));var b;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g($){return!!($.capabilities&2)}e.hasReadWriteCapability=g;function h($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=h;function v($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function A($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=A;function _($){return g($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=_;var a;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(U,q){super(U);this.code=q}}e.FileSystemProviderError=l;function u($,U){const q=new l($.toString(),U);return w(q,U),q}e.createFileSystemProviderError=u;function c($){return $||u((0,S.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=c;function w($,U){return $.name=U?`${U} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=w;function s($){if(!$)return a.Unknown;if($ instanceof l)return $.code;const U=/^(.+) \(FileSystemError\)$/.exec($.name);if(!U)return a.Unknown;switch(U[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=s;function n($){if($ instanceof E)return $.fileOperationResult;switch(s($)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var r;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(U,q,K){this.resource=U,this.operation=q,this.target=K}isOperation(U){return this.operation===U}}e.FileOperationEvent=i;var o;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class m{constructor(U,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const K=new Map;for(const G of U){const ee=K.get(G.type);switch(ee?ee.push([G.resource,G]):K.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,ee]of K)switch(G){case 1:this.added=t.TernarySearchTree.forUris(()=>q),this.added.fill(ee);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>q),this.updated.fill(ee);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>q),this.deleted.fill(ee);break}}contains(U,...q){return this.doContains(U,{includeChildren:!1},...q)}affects(U,...q){return this.doContains(U,{includeChildren:!0},...q)}doContains(U,q,...K){if(!U)return!1;const G=K.length>0;return!!((!G||K.includes(1))&&(this.added?.get(U)||q.includeChildren&&this.added?.findSuperstr(U))||(!G||K.includes(0))&&(this.updated?.get(U)||q.includeChildren&&this.updated?.findSuperstr(U))||(!G||K.includes(2))&&(this.deleted?.findSubstr(U)||q.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function d($,U,q){return!$||!U||$===U||U.length>$.length?!1:(U.charAt(U.length-1)!==I.sep&&(U+=I.sep),q?(0,T.startsWithIgnoreCase)($,U):$.indexOf(U)===0)}e.isParent=d;class E extends f.ErrorNoTelemetry{constructor(U,q,K){super(U);this.fileOperationResult=q,this.options=K}}e.FileOperationError=E;class P extends E{constructor(U,q,K){super(U,2,K);this.stat=q}}e.NotModifiedSinceFileOperationError=P;var L;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(L=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function y($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=y;async function H($,U){if(!U.hasProvider(k.URI.from({scheme:$.scheme})))return new Promise(q=>{const K=U.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===$.scheme&&G.added&&(K.dispose(),q())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(U){return(0,C.isNumber)(U)||(U=0),U<M.KB?(0,S.localize)(1,null,U.toFixed(0)):U<M.MB?(0,S.localize)(2,null,(U/M.KB).toFixed(2)):U<M.GB?(0,S.localize)(3,null,(U/M.MB).toFixed(2)):U<M.TB?(0,S.localize)(4,null,(U/M.GB).toFixed(2)):(0,S.localize)(5,null,(U/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var j;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function Q($){return{maxFileSize:$===0?300*M.MB:16*M.GB,maxHeapSize:$===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=Q}),define(ve[80],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...I){this._entries=new Map;for(let[T,C]of I)this.set(T,C)}set(I,T){const C=this._entries.get(I);return this._entries.set(I,T),C}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=f}),define(ve[188],we([1,0,16,15,114,184,4,80]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class R extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class F{constructor(g=new k.ServiceCollection,h=!1,v){this._activeInstantiations=new Set,this._services=g,this._strict=h,this._parent=v,this._services.set(C.IInstantiationService,this)}createChild(g){return new F(g,this._strict,this)}invokeFunction(g,...h){let v=p.traceInvocation(g),A=!1;try{return g({get:a=>{if(A)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(a,v);if(!l)throw new Error(`[invokeFunction] unknown service '${a}'`);return l}},...h)}finally{A=!0,v.stop()}}createInstance(g,...h){let v,A;return g instanceof I.SyncDescriptor?(v=p.traceCreation(g.ctor),A=this._createInstance(g.ctor,g.staticArguments.concat(h),v)):(v=p.traceCreation(g),A=this._createInstance(g,h,v)),v.stop(),A}_createInstance(g,h=[],v){let A=C._util.getServiceDependencies(g).sort((l,u)=>l.index-u.index),_=[];for(const l of A){let u=this._getOrCreateServiceInstance(l.id,v);u||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${l.id}.`,!1),_.push(u)}let a=A.length>0?A[0].index:h.length;if(h.length!==a){console.warn(`[createInstance] First service dependency of ${g.name} at position ${a+1} conflicts with ${h.length} static arguments`);let l=a-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,a)}return new g(...[...h,..._])}_setServiceInstance(g,h){if(this._services.get(g)instanceof I.SyncDescriptor)this._services.set(g,h);else if(this._parent)this._parent._setServiceInstance(g,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let h=this._services.get(g);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):h}_getOrCreateServiceInstance(g,h){let v=this._getServiceInstanceOrDescriptor(g);return v instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,v,h.branch(g,!0)):(h.branch(g,!1),v)}_safeCreateAndCacheServiceInstance(g,h,v){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,h,v)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,h,v){const A=new T.Graph(l=>l.id.toString());let _=0;const a=[{id:g,desc:h,_trace:v}];for(;a.length;){const l=a.pop();if(A.lookupOrInsertNode(l),_++>1e3)throw new R(A);for(let u of C._util.getServiceDependencies(l.desc.ctor)){let c=this._getServiceInstanceOrDescriptor(u.id);if(c||this._throwIfStrict(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`,!0),c instanceof I.SyncDescriptor){const w={id:u.id,desc:c,_trace:l._trace.branch(u.id,!0)};A.insertEdge(l,w),a.push(w)}}}for(;;){const l=A.roots();if(l.length===0){if(!A.isEmpty())throw new R(A);break}for(const{data:u}of l){if(this._getServiceInstanceOrDescriptor(u.id)instanceof I.SyncDescriptor){const w=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,w)}A.removeNode(u)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,h,v=[],A,_){if(this._services.get(g)instanceof I.SyncDescriptor)return this._createServiceInstance(h,v,A,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,h,v,A,_);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(g,h=[],v,A){if(v){const _=new f.IdleValue(()=>this._createInstance(g,h,A));return new Proxy(Object.create(null),{get(a,l){if(l in a)return a[l];let u=_.value,c=u[l];return typeof c!="function"||(c=c.bind(u),a[l]=c),c},set(a,l,u){return _.value[l]=u,!0}})}else return this._createInstance(g,h,A)}_throwIfStrict(g,h){if(h&&console.warn(h),this._strict)throw new Error(g)}}e.InstantiationService=F;var D;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(D||(D={}));class p{constructor(g,h){this.type=g,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return S?new p(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(g){return S?new p(0,g.name):p._None}branch(g,h){let v=new p(2,g.toString());return this._dep.push([g,h,v]),v}stop(){let g=Date.now()-this._start;p._totals+=g;let h=!1;function v(_,a){let l=[],u=new Array(_+1).join("	");for(const[c,w,s]of a._dep)if(w&&s){h=!0,l.push(`${u}CREATES -> ${c}`);let n=v(_+1,s);n&&l.push(n)}else l.push(`${u}uses -> ${c}`);return l.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(g>2||h)&&console.log(A.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ve[11],we([1,0,49,3,6,12,4]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function R(w,s,n){switch(s){case S.Trace:w.trace(n);break;case S.Debug:w.debug(n);break;case S.Info:w.info(n);break;case S.Warning:w.warn(n);break;case S.Error:w.error(n);break;case S.Critical:w.critical(n);break;default:throw new Error("Invalid log level")}}e.log=R;function F(w){let s="";for(let n=0;n<w.length;n++){let r=w[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(n>0?" ":"")+r}return s}e.format=F;class D extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=D;class p extends D{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...n){this.checkLogLevel(S.Trace)&&this.log(S.Trace,F([s,...n]))}debug(s,...n){this.checkLogLevel(S.Debug)&&this.log(S.Debug,F([s,...n]))}info(s,...n){this.checkLogLevel(S.Info)&&this.log(S.Info,F([s,...n]))}warn(s,...n){this.checkLogLevel(S.Warning)&&this.log(S.Warning,F([s,...n]))}error(s,...n){if(this.checkLogLevel(S.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(S.Error,F(r))}else this.log(S.Error,F([s,...n]))}critical(s,...n){this.checkLogLevel(S.Critical)&&this.log(S.Critical,F([s,...n]))}flush(){}}e.AbstractMessageLogger=p;class b extends D{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!T.isWindows}trace(s,...n){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...n):console.log(`[main ${k()}]`,s,...n))}debug(s,...n){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...n):console.log(`[main ${k()}]`,s,...n))}info(s,...n){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...n):console.log(`[main ${k()}]`,s,...n))}warn(s,...n){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,s,...n):console.warn(`[main ${k()}]`,s,...n))}error(s,...n){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,s,...n):console.error(`[main ${k()}]`,s,...n))}critical(s,...n){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,s,...n):console.error(`[main ${k()}]`,s,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class g extends D{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...n){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",s,...n)}debug(s,...n){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...n)}info(s,...n){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",s,...n)}warn(s,...n){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",s,...n)}error(s,...n){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",s,...n)}critical(s,...n){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...n)}dispose(){}flush(){}}e.ConsoleLogger=g;class h extends D{constructor(s,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(n)}trace(s,...n){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(s),...n])}debug(s,...n){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(s),...n])}info(s,...n){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(s),...n])}warn(s,...n){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(s),...n])}error(s,...n){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(s),...n])}critical(s,...n){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(s),...n])}extractMessage(s){return typeof s=="string"?s:(0,f.toErrorMessage)(s,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class v extends D{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const n of this.logServices)n.setLevel(s);super.setLevel(s)}trace(s,...n){for(const r of this.logServices)r.trace(s,...n)}debug(s,...n){for(const r of this.logServices)r.debug(s,...n)}info(s,...n){for(const r of this.logServices)r.info(s,...n)}warn(s,...n){for(const r of this.logServices)r.warn(s,...n)}error(s,...n){for(const r of this.logServices)r.error(s,...n)}critical(s,...n){for(const r of this.logServices)r.critical(s,...n)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=v;class A extends I.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...n){this.logger.trace(s,...n)}debug(s,...n){this.logger.debug(s,...n)}info(s,...n){this.logger.info(s,...n)}warn(s,...n){this.logger.warn(s,...n)}error(s,...n){this.logger.error(s,...n)}critical(s,...n){this.logger.critical(s,...n)}flush(){this.logger.flush()}}e.LogService=A;class _ extends I.Disposable{constructor(s,n){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,n){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,n?.always?S.Trace:this.logLevel,n),this.loggers.set(s.toString(),r),n?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class a{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return S.Info}trace(s,...n){}debug(s,...n){}info(s,...n){}warn(s,...n){}error(s,...n){}critical(s,...n){}dispose(){}flush(){}}e.NullLogService=a;function l(w){if(w.verbose)return S.Trace;if(typeof w.logLevel=="string"){const s=u(w.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(w){switch(w){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=u;function c(w){switch(w){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=c}),define(ve[189],we([1,0,42,11]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,S,R,F,D){try{const p=await new Promise((g,h)=>{te(["spdlog"],g,h)});p.setFlushOn(t.LogLevel.Trace);const b=await p.createAsyncRotatingLogger(k,S,R,F);return D&&b.clearFormatters(),b}catch(p){console.error(p)}return null}function T(k,S,R){switch(S){case t.LogLevel.Trace:k.trace(R);break;case t.LogLevel.Debug:k.debug(R);break;case t.LogLevel.Info:k.info(R);break;case t.LogLevel.Warning:k.warn(R);break;case t.LogLevel.Error:k.error(R);break;case t.LogLevel.Critical:k.critical(R);break;default:throw new Error("Invalid log level")}}class C extends t.AbstractMessageLogger{constructor(S,R,F,D,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(S,R,F,D),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(S,R,F,D){const p=F?6:1,b=30/p*f.ByteSize.MB,g=await I(S,R,b,p,D);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:h,message:v}of this.buffer)T(this._logger,h,v);this.buffer=[]}}log(S,R){this._logger?T(this._logger,S,R):this.getLevel()<=S&&this.buffer.push({level:S,message:R})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(ve[116],we([1,0,47,164,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function R(g,h){return h-g}S.compare=R;const F=Object.create(null);F[S.Error]=(0,t.localize)(0,null),F[S.Warning]=(0,t.localize)(1,null),F[S.Info]=(0,t.localize)(2,null);function D(g){return F[g]||""}S.toString=D;function p(g){switch(g){case f.default.Error:return S.Error;case f.default.Warning:return S.Warning;case f.default.Info:return S.Info;case f.default.Ignore:return S.Hint}}S.fromSeverity=p;function b(g){switch(g){case S.Error:return f.default.Error;case S.Warning:return f.default.Warning;case S.Info:return f.default.Info;case S.Hint:return f.default.Ignore}}S.toSeverity=b}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const R="";function F(p){return D(p,!0)}S.makeKey=F;function D(p,b){let g=[R];return p.source?g.push(p.source.replace("\xA6","\\\xA6")):g.push(R),p.code?typeof p.code=="string"?g.push(p.code.replace("\xA6","\\\xA6")):g.push(p.code.value.replace("\xA6","\\\xA6")):g.push(R),p.severity!==void 0&&p.severity!==null?g.push(C.toString(p.severity)):g.push(R),p.message&&b?g.push(p.message.replace("\xA6","\\\xA6")):g.push(R),p.startLineNumber!==void 0&&p.startLineNumber!==null?g.push(p.startLineNumber.toString()):g.push(R),p.startColumn!==void 0&&p.startColumn!==null?g.push(p.startColumn.toString()):g.push(R),p.endLineNumber!==void 0&&p.endLineNumber!==null?g.push(p.endLineNumber.toString()):g.push(R),p.endColumn!==void 0&&p.endColumn!==null?g.push(p.endColumn.toString()):g.push(R),g.push(R),g.join("\xA6")}S.makeKeyOptionalMessage=D})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(ve[190],we([1,0,3,47,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=S}),define(ve[117],we([1,0,6,8,2,4]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(F){return{resolved:F,dispose(){}}}});function C(F,D){return I.URI.isUri(F)?(0,t.equalsIgnoreCase)(F.scheme,D):(0,t.startsWithIgnoreCase)(F,D+":")}e.matchesScheme=C;function k(F,...D){return D.some(p=>C(F,p))}e.matchesSomeScheme=k;function S(F,D){return F.with({fragment:`${D.startLineNumber},${D.startColumn}${D.endLineNumber?`-${D.endLineNumber}${D.endColumn?`,${D.endColumn}`:""}`:""}`})}e.withSelection=S;function R(F){let D;const p=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(F.fragment);return p&&(D={startLineNumber:parseInt(p[1]),startColumn:p[2]?parseInt(p[2]):1,endLineNumber:p[4]?parseInt(p[4]):void 0,endColumn:p[4]?p[5]?parseInt(p[5]):1:void 0},F=F.with({fragment:""})),{selection:D,uri:F}}e.extractSelection=R}),define(ve[191],we([1,0,10,12,41,23]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const k=t.globals.vscode.context.configuration();if(k)C=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof te?.__$__nodeRequire=="function"){const k=(0,T.dirname)(f.FileAccess.asFileUri("",te));C=te.__$__nodeRequire((0,T.joinPath)(k,"product.json").fsPath);const S=te.__$__nodeRequire((0,T.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),Object.assign(C,{version:S.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=C});var Fe=this&&this.__param||function(te,e){return function(f,t){e(f,t,te)}};define(ve[118],we([1,0,16,21,6,4]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var C;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(D){this.callback=D}get value(){return this._value}report(D){this._value=D,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(D,p){super();this.deferred=new f.DeferredPromise,p.withProgress(D,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};S=Be([Fe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class R extends I.Disposable{constructor(D){super();this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(D){this.stop();const p=++this.currentOperationId,b=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:b.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(ve[50],we([1,0,55,13]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(C,k){f.ok(t.isString(C)),f.ok(t.isObject(k)),f.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,k)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new I}),define(ve[192],we([1,0,3,50]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class T{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,R){this.schemasById[I(S)]=R,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new T;t.Registry.add(e.Extensions.JSONContribution,C)}),define(ve[119],we([1,0,18,3,13,159,192,50]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=k.Registry.as(C.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,c=!0){this.registerConfigurations([u],c)}registerConfigurations(u,c=!0){const w=this.doRegisterConfigurations(u,c);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:w})}deregisterConfigurations(u){const c=this.doDeregisterConfigurations(u);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:u,remove:c}){const w=[];w.push(...this.doDeregisterConfigurations(c)),w.push(...this.doRegisterConfigurations(u,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,f.distinct)(w)})}registerDefaultConfigurations(u){const c=[],w=[];for(const{overrides:s,source:n}of u)for(const r in s)if(c.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const i={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:n,value:i});const o={type:"object",default:i,description:T.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:i,source:I.isString(n)?void 0:n};w.push(...g(r)),this.configurationProperties[r]=o,this.defaultLanguageConfigurationOverridesNode.properties[r]=o}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:n});const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.registerOverrideIdentifiers(w),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const c=[];for(const{overrides:w,source:s}of u)for(const n in w){const r=this.configurationDefaultsOverrides.get(n),i=I.isString(s)?s:s?.id,o=I.isString(r?.source)?r?.source:r?.source?.id;if(i===o)if(c.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const m=this.configurationProperties[n];m&&(this.updatePropertyDefaultValue(n,m),this.updateSchema(n,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const c of u)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,c){const w=[];return u.forEach(s=>{w.push(...this.validateAndRegisterProperties(s,c,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),w}doDeregisterConfigurations(u){const c=[],w=s=>{if(s.properties)for(const n in s.properties)c.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,s.properties[n]);s.allOf&&s.allOf.forEach(n=>w(n))};for(const s of u){w(s);const n=this.configurationContributors.indexOf(s);n!==-1&&this.configurationContributors.splice(n,1)}return c}validateAndRegisterProperties(u,c=!0,w,s,n=3){n=I.isUndefinedOrNull(u.scope)?n:u.scope;let r=[],i=u.properties;if(i)for(let m in i){if(c&&_(m)){delete i[m];continue}const d=i[m];if(d.source=w,d.defaultDefaultValue=i[m].default,this.updatePropertyDefaultValue(m,d),e.OVERRIDE_PROPERTY_REGEX.test(m)?d.scope=void 0:(d.scope=I.isUndefinedOrNull(d.scope)?n:d.scope,d.restricted=I.isUndefinedOrNull(d.restricted)?!!s?.includes(m):d.restricted),i[m].hasOwnProperty("included")&&!i[m].included){this.excludedConfigurationProperties[m]=i[m],delete i[m];continue}else this.configurationProperties[m]=i[m];!i[m].deprecationMessage&&i[m].markdownDeprecationMessage&&(i[m].deprecationMessage=i[m].markdownDeprecationMessage),r.push(m)}let o=u.allOf;if(o)for(let m of o)r.push(...this.validateAndRegisterProperties(m,c,w,s,n));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const c=w=>{let s=w.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let n=w.allOf;n&&n.forEach(c)};c(u)}updateSchema(u,c){switch(e.allSettings.properties[u]=c,c.scope){case 1:e.applicationSettings.properties[u]=c;break;case 2:e.machineSettings.properties[u]=c;break;case 6:e.machineOverridableSettings.properties[u]=c;break;case 3:e.windowSettings.properties[u]=c;break;case 4:e.resourceSettings.properties[u]=c;break;case 5:e.resourceSettings.properties[u]=c,this.resourceLanguageSettingsSchema.properties[u]=c;break}}removeFromSchema(u,c){switch(delete e.allSettings.properties[u],c.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const c=`[${u}]`,w={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,w),e.allSettings.properties[c]=w,e.applicationSettings.properties[c]=w,e.machineSettings.properties[c]=w,e.machineOverridableSettings.properties[c]=w,e.windowSettings.properties[c]=w,e.resourceSettings.properties[c]=w}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,c){const w=this.configurationDefaultsOverrides.get(u);let s=w?.value,n=w?.source;I.isUndefined(s)&&(s=c.defaultDefaultValue,n=void 0),I.isUndefined(s)&&(s=v(c.type)),c.default=s,c.defaultValueSource=n}}const p="\\[([^\\]]+)\\]",b=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(l){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let c=b.exec(l);for(;c?.length;){const w=c[1].trim();w&&u.push(w),c=b.exec(l)}}return(0,f.distinct)(u)}e.overrideIdentifiersFromKey=g;function h(l){return l.reduce((u,c)=>`${u}[${c}]`,"")}e.keyFromOverrideIdentifiers=h;function v(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const A=new D;k.Registry.add(e.Extensions.Configuration,A);function _(l){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?T.localize(7,null,l):A.getConfigurationProperties()[l]!==void 0?T.localize(8,null,l):null:T.localize(6,null)}e.validateProperty=_;function a(){const l=[],u=A.getConfigurationProperties();for(const c of Object.keys(u))l.push([c,u[c].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=a}),define(ve[193],we([1,0,18,3,141,6,24,25,13,2,115,119,50]),function(te,e,f,t,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(s={},n=[],r=[]){this._contents=s,this._keys=n,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,F.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,n){const r=this.getContentsForOverrideIdentifer(n);return r?s?(0,F.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const r of this.overrides)r.identifiers.includes(s)&&n.push(...r.keys);return f.distinct(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return f.distinct(s)}override(s){let n=this.overrideConfigurations.get(s);return n||(n=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,n)),n}merge(...s){const n=k.deepClone(this.contents),r=k.deepClone(this.overrides),i=[...this.keys];for(const o of s){this.mergeContents(n,o.contents);for(const m of o.overrides){const[d]=r.filter(E=>f.equals(E.identifiers,m.identifiers));d?(this.mergeContents(d.contents,m.contents),d.keys.push(...m.keys),d.keys=f.distinct(d.keys)):r.push(k.deepClone(m))}for(const m of o.keys)i.indexOf(m)===-1&&i.push(m)}return new b(n,i,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const n=this.getContentsForOverrideIdentifer(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const i of f.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[i],m=n[i];m&&(typeof o=="object"&&typeof m=="object"?(o=k.deepClone(o),this.mergeContents(o,m)):o=m),r[i]=o}return new b(r,this.keys,this.overrides)}mergeContents(s,n){for(const r of Object.keys(n)){if(r in s&&S.isObject(s[r])&&S.isObject(n[r])){this.mergeContents(s[r],n[r]);continue}s[r]=k.deepClone(n[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?k.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let n=null,r=null;const i=o=>{o&&(r?this.mergeContents(r,o):r=k.deepClone(o))};for(const o of this.overrides)f.equals(o.identifiers,[s])?n=o.contents:o.identifiers.includes(s)&&i(o.contents);return i(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,n){this.addKey(s),(0,F.addToValueTree)(this.contents,s,n,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,F.removeFromValueTree)(this.contents,s)}addKey(s){let n=this.keys.length;for(let r=0;r<n;r++)s.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,s)}removeKey(s){let n=this.keys.indexOf(s);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=b;class g extends b{constructor(s={}){const n=p.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(n),i=Object.create(null),o=[];for(const m in n){const d=s[m],E=d!==void 0?d:n[m].default;(0,F.addToValueTree)(i,m,E,P=>console.error(`Conflict in default settings: ${P}`))}for(const m of Object.keys(i))D.OVERRIDE_PROPERTY_REGEX.test(m)&&o.push({identifiers:(0,D.overrideIdentifiersFromKey)(m),keys:Object.keys(i[m]),contents:(0,F.toValuesTree)(i[m],d=>console.error(`Conflict in default settings file: ${d}`))});super(i,r,o)}}e.DefaultConfigurationModel=g;class h{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,n){if(!S.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,n)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,n){this._raw=s;const{contents:r,keys:i,overrides:o,restricted:m}=this.doParseRaw(s,n);this._configurationModel=new b(r,i,o),this._restrictedConfigurations=m||[]}doParseContent(s){let n={},r=null,i=[],o=[],m=[];function d(P){Array.isArray(i)?i.push(P):r!==null&&(i[r]=P)}let E={onObjectBegin:()=>{let P={};d(P),o.push(i),i=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{let P=[];d(P),o.push(i),i=P,r=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:d,onError:(P,L,O)=>{m.push({error:P,offset:L,length:O})}};if(s)try{I.visit(s,E),n=i[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return n}doParseRaw(s,n){const r=p.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(s,r,!0,n);s=i.raw;const o=(0,F.toValuesTree)(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),m=Object.keys(s),d=this.toOverrides(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:m,overrides:d,restricted:i.restricted}}filter(s,n,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:s,restricted:[]};const o={},m=[];for(let d in s)if(D.OVERRIDE_PROPERTY_REGEX.test(d)&&r){const E=this.filter(s[d],n,!1,i);o[d]=E.raw,m.push(...E.restricted)}else{const E=n[d],P=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&m.push(d),(P===void 0||i.scopes===void 0||i.scopes.includes(P))&&(i.skipRestricted&&E?.restricted||(o[d]=s[d]))}return{raw:o,restricted:m}}toOverrides(s,n){const r=[];for(const i of Object.keys(s))if(D.OVERRIDE_PROPERTY_REGEX.test(i)){const o={};for(const m in s[i])o[m]=s[i][m];r.push({identifiers:(0,D.overrideIdentifiersFromKey)(i),keys:Object.keys(o),contents:(0,F.toValuesTree)(o,n)})}return r}}e.ConfigurationModelParser=h;class v extends T.Disposable{constructor(s,n,r,i){super();this.userSettingsResource=s,this.scopes=n,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class A{constructor(s,n,r=new b,i=new b,o=new C.ResourceMap,m=new b,d=new C.ResourceMap,E=!0){this._defaultConfiguration=s,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=o,this._memoryConfiguration=m,this._memoryConfigurationByResource=d,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(s,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(s)}updateValue(s,n,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new b,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,n===void 0?i.removeValue(s):i.setValue(s,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,n,r){const i=this.getConsolidateConfigurationModel(n,r),o=this.getFolderConfigurationModelForResource(n.resource,r),m=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,d=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),E=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),P=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),L=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),O=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,y=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(s):o.freeze().getValue(s):void 0,H=n.overrideIdentifier?m.override(n.overrideIdentifier).getValue(s):m.getValue(s),M=i.getValue(s),j=f.distinct(f.flatten(i.overrides.map(Q=>Q.identifiers))).filter(Q=>i.getOverrideValue(s,Q)!==void 0);return{defaultValue:d,userValue:E,userLocalValue:P,userRemoteValue:L,workspaceValue:O,workspaceFolderValue:y,memoryValue:H,value:M,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,userRemote:L!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,workspaceFolder:y!==void 0?{value:o?.freeze().getValue(s),override:n.overrideIdentifier?o?.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:m.getValue(s),override:n.overrideIdentifier?m.getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(s){const n=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,n){this._folderConfigurations.set(s,n),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const r=[];if(!n){const{added:i,updated:o,removed:m}=u(this._defaultConfiguration,s);n=[...i,...o,...m]}for(const i of n)for(const o of(0,D.overrideIdentifiersFromKey)(i)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(o),d=s.getKeysForOverrideIdentifier(o),E=[...d.filter(P=>m.indexOf(P)===-1),...m.filter(P=>d.indexOf(P)===-1),...m.filter(P=>!k.equals(this._defaultConfiguration.override(o).getValue(P),s.override(o).getValue(P)))];r.push([o,E])}return this.updateDefaultConfiguration(s),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:r,removed:i,overrides:o}=u(this.localUserConfiguration,s),m=[...n,...r,...i];return m.length&&this.updateLocalUserConfiguration(s),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:r,removed:i,overrides:o}=u(this.remoteUserConfiguration,s);let m=[...n,...r,...i];return m.length&&this.updateRemoteUserConfiguration(s),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:r,removed:i,overrides:o}=u(this.workspaceConfiguration,s);let m=[...n,...r,...i];return m.length&&this.updateWorkspaceConfiguration(s),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(s,n){const r=this.folderConfigurations.get(s),{added:i,updated:o,removed:m,overrides:d}=u(r,n);let E=[...i,...o,...m];return(E.length||!r)&&this.updateFolderConfiguration(s,n),{keys:E,overrides:d}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:i,removed:o,overrides:m}=u(n,void 0);return{keys:[...r,...i,...o],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,n){let r=this.getConsolidatedConfigurationModelForResource(s,n);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&s){const i=n.getFolder(s);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const o=this._memoryConfigurationByResource.get(s);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let n=this._foldersConsolidatedConfigurations.get(s);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(s);i?(n=r.merge(i),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(s,n)):n=r}return n}getFolderConfigurationModelForResource(s,n){if(n&&s){const r=n.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,n)=>{const{contents:r,overrides:i,keys:o}=this._folderConfigurations.get(n);return s.push([n,{contents:r,overrides:i,keys:o}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>s.add(n)),this.userConfiguration.freeze().keys.forEach(n=>s.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i))),[...n.values()]}static parse(s){const n=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),i=this.parseConfigurationModel(s.workspace),o=s.folders.reduce((m,d)=>(m.set(R.URI.revive(d[0]),this.parseConfigurationModel(d[1])),m),new C.ResourceMap);return new A(n,r,new b,i,o,new b,new C.ResourceMap,!1)}static parseConfigurationModel(s){return new b(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=A;function _(...w){if(w.length===0)return{keys:[],overrides:[]};if(w.length===1)return w[0];const s=new Set,n=new Map;for(const i of w)i.keys.forEach(o=>s.add(o)),i.overrides.forEach(([o,m])=>{const d=(0,C.getOrSet)(n,o,new Set);m.forEach(E=>d.add(E))});const r=[];return n.forEach((i,o)=>r.push([o,[...i.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=_;class a{constructor(s,n,r,i){this.change=s,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const o=new Set;s.keys.forEach(d=>o.add(d)),s.overrides.forEach(([,d])=>d.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const m=new b;this.affectedKeys.forEach(d=>m.setValue(d,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(s,n,this.currentWorkspace);return!k.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(s,n){let r=(0,F.toValuesTree)({[n]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(s=s[i],!s)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=a;class l extends a{constructor(s,n,r,i){super({keys:s.allKeys(),overrides:[]},void 0,s,n);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l;function u(w,s){const{added:n,removed:r,updated:i}=c(s,w),o=[],m=w?.getAllOverrideIdentifiers()||[],d=s?.getAllOverrideIdentifiers()||[];if(s){const E=d.filter(P=>!m.includes(P));for(const P of E)o.push([P,s.getKeysForOverrideIdentifier(P)])}if(w){const E=m.filter(P=>!d.includes(P));for(const P of E)o.push([P,w.getKeysForOverrideIdentifier(P)])}if(s&&w){for(const E of m)if(d.includes(E)){const P=c({contents:w.getOverrideValue(void 0,E)||{},keys:w.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});o.push([E,[...P.added,...P.removed,...P.updated]])}}return{added:n,removed:r,updated:i,overrides:o}}function c(w,s){const n=w?s?w.keys.filter(o=>s.keys.indexOf(o)===-1):[...w.keys]:[],r=s?w?s.keys.filter(o=>w.keys.indexOf(o)===-1):[...s.keys]:[],i=[];if(w&&s){for(const o of s.keys)if(w.keys.indexOf(o)!==-1){const m=(0,F.getConfigurationValue)(s.contents,o),d=(0,F.getConfigurationValue)(w.contents,o);k.equals(m,d)||i.push(o)}}return{added:n,removed:r,updated:i}}}),define(ve[120],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(C,k=t.Unknown,S){super(C);this._message=C,this._code=k,this._detail=S,this.isHandled=k===t.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(C){return C instanceof I&&C._code===t.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof I&&C._code===t.NoResolverFound}static isHandled(C){return C instanceof I&&C.isHandled}}e.RemoteAuthorityResolverError=I}),define(ve[121],we([1,0,10]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===f.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function I(T){if(!T)return;const C=T.indexOf("+");return C<0?T:T.substr(0,C)}e.getRemoteName=I}),define(ve[27],we([1,0,8,4,121]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=T;function C(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,g){if(typeof b=="undefined"||b===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof b=="string"||typeof g=="string"){let h=typeof b=="string"?b:b.value,v=typeof g=="string"?g:g.value;return f.equalsIgnoreCase(h,v)}return b._lower===g._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=S;function R(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function F(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function D(p,b){if(b){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(b)}`;return p.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[122],we([1,0,8,27]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(g,h){return g.uuid&&h.uuid?g.uuid===h.uuid:g.id===h.id?!0:(0,f.compareIgnoreCase)(g.id,h.id)===0}e.areSameExtensions=I;class T{constructor(h,v){this.version=v,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof T?I(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=T;function C(g,h){return`${g}.${h}`}e.getExtensionId=C;function k(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(g,h){return k(C(g,h))}e.getGalleryExtensionId=S;function R(g,h){const v=[],A=_=>{for(const a of v)if(a.some(l=>I(h(l),h(_))))return a;return null};for(const _ of g){const a=A(_);a?a.push(_):v.push([_])}return v}e.groupByExtension=R;function F(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function D(g){return{id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),...g.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function p(g){const h=new Set;if(g.malicious)for(const v of g.malicious)h.add(v.id);return h}e.getMaliciousExtensionsSet=p;function b(g,h){const v=[],A=h.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const _=A.shift();if(_&&v.every(a=>!I(a.identifier,{id:_}))){const a=g.filter(l=>I(l.identifier,{id:_}));a.length===1&&(v.push(a[0]),A.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=b}),define(ve[194],we([1,0,160,122,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const T=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function C(u){const c=T.exec(u);return c&&c[1]?[(0,t.adoptToGalleryExtensionId)(c[1]),c[2]]:[(0,t.adoptToGalleryExtensionId)(u),void 0]}e.getIdAndVersion=C;var k;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function S(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function F(u,c){switch(u){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=F;function D(u,c){return c==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function p(u,c,w){return D(c,w)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===w?!0:b(w).includes(u)}e.isTargetPlatformCompatible=p;function b(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function g(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=g;var h;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(h=e.SortBy||(e.SortBy={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var A;(function(u){u.Install="install",u.Uninstall="uninstall"})(A=e.StatisticType||(e.StatisticType={}));var _;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var a;(function(u){u.Unsupported="Unsupported",u.UnsupportedPreRelease="UnsupportedPreRelease",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(c,w){super(c);this.code=w,this.name=w}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,f.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,f.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ve[195],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{constructor(){this.validators=new Map}vsda(){return new Promise((I,T)=>te(["vsda"],I,T))}async createNewMessage(I){try{const T=await this.vsda(),C=new T.validator;if(C){const k=String(f._nextId++);return this.validators.set(k,C),{id:k,data:C.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,T){if(!I.id)return!0;const C=this.validators.get(I.id);if(!C)return!1;this.validators.delete(I.id);try{return C.validate(T)==="ok"}catch{return!1}}async sign(I){try{const T=await this.vsda(),C=new T.signer;if(C)return C.sign(I)}catch{}return I}}e.SignService=f,f._nextId=1}),define(ve[196],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,T,C=5){let k;return k=T(S=>{const R=typeof S=="string"?S:S.data;let F=this._terminalBufferMap.get(I);if(F){F.data.push(R);return}const D=setTimeout(()=>this.flushBuffer(I),C);F={data:[R],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,F)}),k}stopBuffering(I){const T=this._terminalBufferMap.get(I);T&&T.dispose()}flushBuffer(I){const T=this._terminalBufferMap.get(I);T&&(this._terminalBufferMap.delete(I),this._callback(I,T.data.join("")))}}e.TerminalDataBufferer=f}),define(ve[197],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(ve[81],we([1,0,72,3,6,4,50,197]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(v){function A(_){return _&&typeof _=="object"&&typeof _.id=="string"}v.isThemeColor=A})(S=e.ThemeColor||(e.ThemeColor={}));function R(v){return{id:v}}e.themeColorFromId=R;var F;(function(v){function A(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||S.isThemeColor(n.color))}v.isThemeIcon=A;const _=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function a(n){const r=_.exec(n);if(!r)return;let[,i]=r;return{id:i}}v.fromString=a;function l(n){return{id:n}}v.fromId=l;function u(n,r){let i=n.id;const o=i.lastIndexOf("~");return o!==-1&&(i=i.substring(0,o)),r&&(i=`${i}~${r}`),{id:i}}v.modify=u;function c(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}v.getModifier=c;function w(n,r){return n.id===r.id&&n.color?.id===r.color?.id}v.isEqual=w;function s(n,r){return{id:n.id,color:r?R(r):void 0}}v.asThemeIcon=s,v.asClassNameArray=f.CSSIcon.asClassNameArray,v.asClassName=f.CSSIcon.asClassName,v.asCSSSelector=f.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function D(v){switch(v){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(A);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new p;C.Registry.add(e.Extensions.ThemingContribution,b);function g(v){return b.onColorThemeChange(v)}e.registerThemingParticipant=g;class h extends I.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,_){let a=this.theme.getColor(A);return a&&_&&(a=_(a,this.theme)),a?a.toString():null}}e.Themable=h}),define(ve[123],we([1,0,3,12,4,11]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var C;(function(g){g.Http="http",g.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=D;function p(g,h){return h?h!==1&&g<1024:!t.isWindows&&g<1024}e.isPortPrivileged=p;let b=class{constructor(h){this.logService=h,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],v=Array.from(this._tunnels.values());for(let A of v){const _=Array.from(A.values());for(let a of _){const l=await a.value;l&&h.push(l)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:v}of h.values())await v.then(A=>A?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,v,A,_,a=!1,l=k.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${A} on local port ${_}.`),!h)return;v||(v="localhost");const c=this.retainOrCreateTunnel(h,v,A,_,a,l,u);return c?c.then(w=>{if(!w){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,A);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(w);return(w.tunnelRemoteHost!==v||w.tunnelRemotePort!==A)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const v=this._tunnels.get(h.tunnelRemoteHost);if(v){const A=v.get(h.tunnelRemotePort);A&&(A.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,A))}}}}async tryDisposeTunnel(h,v,A){if(A.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${v}.`);const _=A.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(v),_}}async closeTunnel(h,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${v} `);const A=this._tunnels.get(h);if(A&&A.has(v)){const _=A.get(v);_.refcount=0,await this.tryDisposeTunnel(h,v,_)}}addTunnelToMap(h,v,A){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(v,{refcount:1,value:A})}async removeEmptyTunnelFromMap(h,v){const A=this._tunnels.get(h);A&&(await A.get(v)||A.delete(v),A.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,v){let A=[h];F(h)?(A.push(...e.LOCALHOST_ADDRESSES),A.push(...e.ALL_INTERFACES_ADDRESSES)):D(h)&&A.push(...e.ALL_INTERFACES_ADDRESSES);const _=A.map(a=>this._tunnels.get(a));for(const a of _){const l=a?.get(v);if(l)return l}}canTunnel(h){return!!R(h)}createWithProvider(h,v,A,_,a,l,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${A} on local port ${_}.`);const w={elevationRequired:a?p(_===void 0?A:_):!1},s={remoteAddress:{host:v,port:A},localAddressPort:_,privacy:l,public:l!==k.Private,protocol:u},n=h.forwardPort(s,w);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(v,A,n),n}};b=Be([Fe(0,T.ILogService)],b),e.AbstractTunnelService=b}),define(ve[198],we([1,0,10]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(k){return k.scheme!==f.Schemas.file&&k.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=t;function I(k){if(k.folders.length)return k.folders.every(S=>t(S.uri))?k.folders[0].uri:void 0;if(k.configuration&&t(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=I;function T(k){return I(k)?.scheme}e.getVirtualWorkspaceScheme=T;function C(k){return I(k)!==void 0}e.isVirtualWorkspace=C}),define(ve[43],we([1,0,165,9,24,23,2,4,10]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function R(w){const s=w;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=R;function F(w){if(w.configuration)return{id:w.id,configPath:w.configuration};if(w.folders.length===1)return{id:w.id,uri:w.folders[0].uri}}e.toWorkspaceIdentifier=F;function D(w){const s=w;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=D;function p(w){const s=w;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const n=w;if(n?.configPath)return{id:n.id,configPath:C.URI.revive(n.configPath)};if(w?.id)return{id:w.id}}e.reviveIdentifier=p;var b;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function g(w){const s=w;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=g;function h(w){const s=w;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=h;class v{constructor(s,n,r,i,o){this._id=s,this._transient=r,this._configuration=i,this._ignorePathCasing=o,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=n}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s.with({scheme:s.scheme,authority:s.authority,path:s.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class A{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,T.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function _(w){return new A({uri:w,index:0,name:(0,T.basenameOrAuthority)(w)},{uri:w.toString()})}e.toWorkspaceFolder=_,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,f.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(w,s){return T.extUriBiasedIgnorePathCase.isEqualOrParent(w,s.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function u(w){let s;return C.URI.isUri(w)?s=w:s=w.configuration,s?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=u;function c(w){return(typeof w=="string"?(0,t.extname)(w):(0,T.extname)(w))===a}e.hasWorkspaceFileExtension=c}),define(ve[82],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const T=this._idPool++;return this._data.set(T,I),this.logDebugInfo(),T}get(I,T){return this._data.has(I)?this._data.get(I)[T]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(ve[44],we([1,0,10,23,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(ve[199],we([1,0,16]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(C,k,S){this._deferredPromises=new Map,this._id=C,this._shared=k,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of R.values())F.complete()}catch(F){for(const D of R.values())D.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,k){let S=this._value[C];return typeof S=="undefined"&&(S=k),S}update(C,k){this._value[C]=k;let S=this._deferredPromises.get(C);if(S!==void 0)return S.p;const R=new f.DeferredPromise;return this._deferredPromises.set(C,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{constructor(C,k){super(C.identifier.value,!0,k);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=I}),define(ve[200],we([1,0,3,2,11]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,R){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(S.value,R)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const R=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));R.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};T=Be([Fe(0,I.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(ve[17],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class t{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=t});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[201],we([1,0,27,3]),function(te,e,f,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(k,S){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(k.identifier),Xe(this,I,S,"f"),Pe(this,I,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(k){return Pe(this,I,"f").get(this._id,k)}store(k,S){return Pe(this,I,"f").store(this._id,k,S)}delete(k){return Pe(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=T,I=new WeakMap}),define(ve[124],we([1,0,4,3]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(C){this._level=C}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(ve[62],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,I=(_,a)=>{const l={controllerId:a};return t.set(_,l),l};e.createPrivateApiFor=I;const T=_=>t.get(_);e.getPrivateApiFor=T;const C=(_,a,l,u)=>{let c=l;return{enumerable:!0,configurable:!1,get(){return c},set(w){if(!u(c,w)){const s=c;c=w,_.listener?.({op:3,key:a,value:w,previous:s})}}}},k=(_,a)=>_===a,S={range:(_,a)=>_===a?!0:!_||!a?!1:_.isEqual(a),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(_,a)=>!(_.length!==a.length||_.some(l=>!a.find(u=>l.id===u.id)))},R=Object.keys(S),F=(_,a)=>({range:C(_,"range",void 0,S.range),label:C(_,"label",a,S.label),description:C(_,"description",void 0,S.description),sortText:C(_,"sortText",void 0,S.sortText),canResolveChildren:C(_,"canResolveChildren",!1,S.canResolveChildren),busy:C(_,"busy",!1,S.busy),error:C(_,"error",void 0,S.error),tags:C(_,"tags",[],S.tags)}),D=(_,a)=>{const l=new Map;for(const u of R)S[u](_[u],a[u])||l.set(u,a[u]);return l};e.diffTestItems=D;class p extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=p;class b extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class g extends Error{constructor(a,l,u){super(`TestItem with ID "${a}" is from controller "${l}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=g;const h=_=>{const a=(0,e.getPrivateApiFor)(_);let l=new Map;return{get size(){return l.size},forEach(u,c){for(const w of l.values())u.call(c,w,this)},replace(u){const c=new Map,w=new Set(l.keys()),s={op:4,ops:[]};for(const n of u){if(!(n instanceof v))throw new b(n.id);const r=(0,e.getPrivateApiFor)(n).controllerId;if(r!==a.controllerId)throw new g(n.id,r,a.controllerId);if(c.has(n.id))throw new p(n.id);c.set(n.id,n),w.delete(n.id),s.ops.push({op:0,item:n})}for(const n of w.keys())s.ops.push({op:1,id:n});a.listener?.(s),l=c},add(u){if(!(u instanceof v))throw new b(u.id);l.set(u.id,u),a.listener?.({op:0,item:u})},delete(u){l.delete(u)&&a.listener?.({op:1,id:u})},get(u){return l.get(u)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};class v{constructor(a,l,u,c){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const w=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return w.parent instanceof A?void 0:w.parent}},children:{value:h(this),enumerable:!0,writable:!1},...F(w,u)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class A extends v{constructor(a,l){super(a,a,l,void 0)}}e.TestItemRootImpl=A}),define(ve[51],we([1,0,4,123,3,17]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function R(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=R;function F(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==t.TunnelPrivacyId.ConstantPrivate&&D.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=F})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let k=class{constructor(R){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,F){}async getTunnels(){return[]}async setTunnelFactory(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,F){return{dispose:()=>{}}}async $providePortAttributes(R,F,D,p,b){return[]}async $forwardPort(R,F){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Be([Fe(0,T.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[7],we([1,0,18,15,99,24,92,8,13,2,33,42,120]),function(te,e,f,t,I,T,C,k,S,R,F,D,p){"use strict";var b,g,h,v,A,_,a,l,u,c,w,s,n,r,i,o,m,d,E,P;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L(X){function x(){return Reflect.construct(X,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(X,"name")),Object.setPrototypeOf(x,X),Object.setPrototypeOf(x.prototype,X.prototype),x}let O=A=class{constructor(x){b.set(this,void 0),Xe(this,b,x,"f")}static from(...x){let ce=x;return new A(function(){if(ce){for(const De of ce)De&&typeof De.dispose=="function"&&De.dispose();ce=void 0}})}dispose(){typeof Pe(this,b,"f")=="function"&&(Pe(this,b,"f").call(this),Xe(this,b,void 0,"f"))}};b=new WeakMap,O=A=Be([L],O),e.Disposable=O;let y=_=class{constructor(x,ce){if(x<0)throw(0,t.illegalArgument)("line must be non-negative");if(ce<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=x,this._character=ce}static Min(...x){if(x.length===0)throw new TypeError;let ce=x[0];for(let De=1;De<x.length;De++){const Ge=x[De];Ge.isBefore(ce)&&(ce=Ge)}return ce}static Max(...x){if(x.length===0)throw new TypeError;let ce=x[0];for(let De=1;De<x.length;De++){const Ge=x[De];Ge.isAfter(ce)&&(ce=Ge)}return ce}static isPosition(x){if(!x)return!1;if(x instanceof _)return!0;let{line:ce,character:De}=x;return typeof ce=="number"&&typeof De=="number"}static of(x){if(x instanceof _)return x;if(this.isPosition(x))return new _(x.line,x.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,ce=0){if(x===null||ce===null)throw(0,t.illegalArgument)();let De;return typeof x=="undefined"?De=0:typeof x=="number"?De=x:(De=typeof x.lineDelta=="number"?x.lineDelta:0,ce=typeof x.characterDelta=="number"?x.characterDelta:0),De===0&&ce===0?this:new _(this.line+De,this.character+ce)}with(x,ce=this.character){if(x===null||ce===null)throw(0,t.illegalArgument)();let De;return typeof x=="undefined"?De=this.line:typeof x=="number"?De=x:(De=typeof x.line=="number"?x.line:this.line,ce=typeof x.character=="number"?x.character:this.character),De===this.line&&ce===this.character?this:new _(De,ce)}toJSON(){return{line:this.line,character:this.character}}};y=_=Be([L],y),e.Position=y;let H=a=class{constructor(x,ce,De,Ge){let Qe,Ze;if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"?(Qe=new y(x,ce),Ze=new y(De,Ge)):y.isPosition(x)&&y.isPosition(ce)&&(Qe=y.of(x),Ze=y.of(ce)),!Qe||!Ze)throw new Error("Invalid arguments");Qe.isBefore(Ze)?(this._start=Qe,this._end=Ze):(this._start=Ze,this._end=Qe)}static isRange(x){return x instanceof a?!0:x?y.isPosition(x.start)&&y.isPosition(x.end):!1}static of(x){if(x instanceof a)return x;if(this.isRange(x))return new a(x.start,x.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(x){return a.isRange(x)?this.contains(x.start)&&this.contains(x.end):y.isPosition(x)?!(y.of(x).isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const ce=y.Max(x.start,this._start),De=y.Min(x.end,this._end);if(!ce.isAfter(De))return new a(ce,De)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const ce=y.Min(x.start,this._start),De=y.Max(x.end,this.end);return new a(ce,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,ce=this.end){if(x===null||ce===null)throw(0,t.illegalArgument)();let De;return x?y.isPosition(x)?De=x:(De=x.start||this.start,ce=x.end||this.end):De=this.start,De.isEqual(this._start)&&ce.isEqual(this.end)?this:new a(De,ce)}toJSON(){return[this.start,this.end]}};H=a=Be([L],H),e.Range=H;let M=l=class extends H{constructor(x,ce,De,Ge){let Qe,Ze;if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"?(Qe=new y(x,ce),Ze=new y(De,Ge)):y.isPosition(x)&&y.isPosition(ce)&&(Qe=y.of(x),Ze=y.of(ce)),!Qe||!Ze)throw new Error("Invalid arguments");super(Qe,Ze);this._anchor=Qe,this._active=Ze}static isSelection(x){return x instanceof l?!0:x?H.isRange(x)&&y.isPosition(x.anchor)&&y.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=l=Be([L],M),e.Selection=M;class j{constructor(x,ce,De){if(typeof x!="string"||x.length===0)throw(0,t.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,t.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,t.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(ce),this.connectionToken=De}}e.ResolvedAuthority=j;class Q extends Error{constructor(x,ce=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(x);this._message=x,this._code=ce,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}static NotAvailable(x,ce){return new Q(x,p.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(x){return new Q(x,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Q;var $;(function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var U;(function(X){X[X.Replace=1]="Replace",X[X.Append=2]="Append",X[X.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=u=class{constructor(x,ce){this._range=x,this._newText=ce}static isTextEdit(x){return x instanceof u?!0:x?H.isRange(x)&&typeof x.newText=="string":!1}static replace(x,ce){return new u(x,ce)}static insert(x,ce){return u.replace(new H(x,x),ce)}static delete(x){return u.replace(x,"")}static setEndOfLine(x){const ce=new u(new H(new y(0,0),new y(0,0)),"");return ce.newEol=x,ce}get range(){return this._range}set range(x){if(x&&!H.isRange(x))throw(0,t.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,t.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,t.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=u=Be([L],q),e.TextEdit=q;var K;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.Cell=3]="Cell",X[X.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,ce,De,Ge){this._edits.push({_type:1,from:x,to:ce,options:De,metadata:Ge})}createFile(x,ce,De){this._edits.push({_type:1,from:void 0,to:x,options:ce,metadata:De})}deleteFile(x,ce,De){this._edits.push({_type:1,from:x,to:void 0,options:ce,metadata:De})}replaceNotebookMetadata(x,ce,De){this._edits.push({_type:3,metadata:De,uri:x,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(x,ce,De,Ge,Qe){let Ze,rt,Dt=[],At;if(Kt.isNotebookRange(ce)&&Oe.isNotebookCellDataArray(De)&&!Oe.isNotebookCellDataArray(Ge)?(Ze=ce.start,rt=ce.end,Dt=De,At=Ge):typeof ce=="number"&&typeof De=="number"&&Oe.isNotebookCellDataArray(Ge)&&(Ze=ce,rt=De,Dt=Ge,At=Qe),Ze===void 0||rt===void 0)throw new Error("Invalid arguments");(Ze!==rt||Dt.length>0)&&this._edits.push({_type:5,uri:x,index:Ze,count:rt-Ze,cells:Dt,metadata:At})}replaceNotebookCellMetadata(x,ce,De,Ge){this._edits.push({_type:3,metadata:Ge,uri:x,edit:{editType:8,index:ce,metadata:De}})}replace(x,ce,De,Ge){this._edits.push({_type:2,uri:x,edit:new q(ce,De),metadata:Ge})}insert(x,ce,De,Ge){this.replace(x,new H(ce,ce),De,Ge)}delete(x,ce,De){this.replace(x,ce,"",De)}has(x){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===x.toString())}set(x,ce){if(ce)for(const De of ce)De&&this._edits.push({_type:2,uri:x,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ge=this._edits[De];Ge._type===2&&Ge.uri.toString()===x.toString()&&(this._edits[De]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(x){const ce=[];for(let De of this._edits)De._type===2&&De.uri.toString()===x.toString()&&ce.push(De.edit);return ce}entries(){const x=new T.ResourceMap;for(let ce of this._edits)if(ce._type===2){let De=x.get(ce.uri);De||(De=[ce.uri,[]],x.set(ce.uri,De)),De[1].push(ce.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Be([L],G),e.WorkspaceEdit=G;let ee=c=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof c?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=c._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,ce=this._tabstop++){if(typeof x=="function"){const De=new c;De._tabstop=this._tabstop,x(De),this._tabstop=De._tabstop,x=De.value}else x=c._escape(x);return this.value+="${",this.value+=ce,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,ce=this._tabstop++){const De=x.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(x,ce){if(typeof ce=="function"){const De=new c;De._tabstop=this._tabstop,ce(De),this._tabstop=De._tabstop,ce=De.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};ee=c=Be([L],ee),e.SnippetString=ee;var oe;(function(X){X[X.Unnecessary=1]="Unnecessary",X[X.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(X){X[X.Hint=3]="Hint",X[X.Information=2]="Information",X[X.Warning=1]="Warning",X[X.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=w=class{constructor(x,ce){if(this.uri=x,ce)if(H.isRange(ce))this.range=H.of(ce);else if(y.isPosition(ce))this.range=new H(ce,ce);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof w?!0:x?H.isRange(x.range)&&R.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=w=Be([L],Z),e.Location=Z;let Y=class{constructor(x,ce){this.location=x,this.message=ce}static is(x){return x?typeof x.message=="string"&&x.location&&H.isRange(x.location.range)&&R.URI.isUri(x.location.uri):!1}static isEqual(x,ce){return x===ce?!0:!x||!ce?!1:x.message===ce.message&&x.location.range.isEqual(ce.location.range)&&x.location.uri.toString()===ce.location.uri.toString()}};Y=Be([L],Y),e.DiagnosticRelatedInformation=Y;let se=class{constructor(x,ce,De=ue.Error){if(!H.isRange(x))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=x,this.message=ce,this.severity=De}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,ce){return x===ce?!0:!x||!ce?!1:x.message===ce.message&&x.severity===ce.severity&&x.code===ce.code&&x.severity===ce.severity&&x.source===ce.source&&x.range.isEqual(ce.range)&&(0,f.equals)(x.tags,ce.tags)&&(0,f.equals)(x.relatedInformation,ce.relatedInformation,Y.isEqual)}};se=Be([L],se),e.Diagnostic=se;let de=class{constructor(x,ce){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:this.contents=[x],this.range=ce}};de=Be([L],de),e.Hover=de;var ge;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(x,ce=ge.Text){this.range=x,this.kind=ce}toJSON(){return{range:this.range,kind:ge[this.kind]}}};Te=Be([L],Te),e.DocumentHighlight=Te;var Ne;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var be;(function(X){X[X.Deprecated=1]="Deprecated"})(be=e.SymbolTag||(e.SymbolTag={}));let Ee=s=class{constructor(x,ce,De,Ge,Qe){this.name=x,this.kind=ce,this.containerName=Qe,typeof De=="string"&&(this.containerName=De),Ge instanceof Z?this.location=Ge:De instanceof H&&(this.location=new Z(Ge,De)),s.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};Ee=s=Be([L],Ee),e.SymbolInformation=Ee;let z=n=class{constructor(x,ce,De,Ge,Qe){this.name=x,this.detail=ce,this.kind=De,this.range=Ge,this.selectionRange=Qe,this.children=[],n.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(n.validate)}};z=n=Be([L],z),e.DocumentSymbol=z;var B;(function(X){X[X.Invoke=1]="Invoke",X[X.Automatic=2]="Automatic"})(B=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let N=class{constructor(x,ce){this.title=x,this.kind=ce}};N=Be([L],N),e.CodeAction=N;let W=r=class{constructor(x){this.value=x}append(x){return new r(this.value?this.value+r.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+r.sep)}};W.sep=".",W=r=Be([L],W),e.CodeActionKind=W,W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll");let V=class{constructor(x,ce){if(this.range=x,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};V=Be([L],V),e.SelectionRange=V;class re{constructor(x,ce,De,Ge,Qe,Ze){this.kind=x,this.name=ce,this.detail=De,this.uri=Ge,this.range=Qe,this.selectionRange=Ze}}e.CallHierarchyItem=re;class he{constructor(x,ce){this.fromRanges=ce,this.from=x}}e.CallHierarchyIncomingCall=he;class Ce{constructor(x,ce){this.fromRanges=ce,this.to=x}}e.CallHierarchyOutgoingCall=Ce;var Ae;(function(X){X[X.Information=0]="Information",X[X.Warning=1]="Warning",X[X.Error=2]="Error"})(Ae=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let We=class{constructor(x,ce){this.range=x,this.command=ce}get isResolved(){return!!this.command}};We=Be([L],We),e.CodeLens=We;let ze=i=class{constructor(x,ce=!1){g.set(this,void 0),Xe(this,g,new I.MarkdownString(x,{supportThemeIcons:ce}),"f")}static isMarkdownString(x){return x instanceof i?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Pe(this,g,"f").value}set value(x){Pe(this,g,"f").value=x}get isTrusted(){return Pe(this,g,"f").isTrusted}set isTrusted(x){Pe(this,g,"f").isTrusted=x}get supportThemeIcons(){return Pe(this,g,"f").supportThemeIcons}set supportThemeIcons(x){Pe(this,g,"f").supportThemeIcons=x}get supportHtml(){return Pe(this,g,"f").supportHtml}set supportHtml(x){Pe(this,g,"f").supportHtml=x}get baseUri(){return Pe(this,g,"f").baseUri}set baseUri(x){Pe(this,g,"f").baseUri=x}appendText(x){return Pe(this,g,"f").appendText(x),this}appendMarkdown(x){return Pe(this,g,"f").appendMarkdown(x),this}appendCodeblock(x,ce){return Pe(this,g,"f").appendCodeblock(ce??"",x),this}};g=new WeakMap,ze=i=Be([L],ze),e.MarkdownString=ze;let qe=class{constructor(x,ce){this.label=x,this.documentation=ce}};qe=Be([L],qe),e.ParameterInformation=qe;let He=class{constructor(x,ce){this.label=x,this.documentation=ce,this.parameters=[]}};He=Be([L],He),e.SignatureInformation=He;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=Be([L],Ue),e.SignatureHelp=Ue;var Je;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(Je=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(X){X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(x){this.value=x}};Le=Be([L],Le),e.InlayHintLabelPart=Le;let it=class{constructor(x,ce,De){this.position=x,this.label=ce,this.kind=De}};it=Be([L],it),e.InlayHint=it;var ne;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(X){X[X.Text=0]="Text",X[X.Method=1]="Method",X[X.Function=2]="Function",X[X.Constructor=3]="Constructor",X[X.Field=4]="Field",X[X.Variable=5]="Variable",X[X.Class=6]="Class",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Unit=10]="Unit",X[X.Value=11]="Value",X[X.Enum=12]="Enum",X[X.Keyword=13]="Keyword",X[X.Snippet=14]="Snippet",X[X.Color=15]="Color",X[X.File=16]="File",X[X.Reference=17]="Reference",X[X.Folder=18]="Folder",X[X.EnumMember=19]="EnumMember",X[X.Constant=20]="Constant",X[X.Struct=21]="Struct",X[X.Event=22]="Event",X[X.Operator=23]="Operator",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue"})(ae=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(X){X[X.Deprecated=1]="Deprecated"})(J=e.CompletionItemTag||(e.CompletionItemTag={}));let pe=class{constructor(x,ce){this.label=x,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&ae[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pe=Be([L],pe),e.CompletionItem=pe;let Se=class{constructor(x=[],ce=!1){this.items=x,this.isIncomplete=ce}};Se=Be([L],Se),e.CompletionList=Se;let Me=class{constructor(x,ce,De){this.insertText=x,this.range=ce,this.command=De}};Me=Be([L],Me),e.InlineSuggestion=Me;let $e=class{constructor(x){this.items=x}};$e=Be([L],$e),e.InlineSuggestions=$e;var Ye;(function(X){X[X.Active=-1]="Active",X[X.Beside=-2]="Beside",X[X.One=1]="One",X[X.Two=2]="Two",X[X.Three=3]="Three",X[X.Four=4]="Four",X[X.Five=5]="Five",X[X.Six=6]="Six",X[X.Seven=7]="Seven",X[X.Eight=8]="Eight",X[X.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var lt;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var wt;(function(X){X[X.Manual=1]="Manual",X[X.AfterDelay=2]="AfterDelay",X[X.FocusOut=3]="FocusOut"})(wt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var je;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(je=e.TextEditorRevealType||(e.TextEditorRevealType={}));var st;(function(X){X[X.Keyboard=1]="Keyboard",X[X.Mouse=2]="Mouse",X[X.Command=3]="Command"})(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var _t;(function(X){X[X.Undo=1]="Undo",X[X.Redo=2]="Redo"})(_t=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(X){X[X.OpenOpen=0]="OpenOpen",X[X.ClosedClosed=1]="ClosedClosed",X[X.OpenClosed=2]="OpenClosed",X[X.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(X){function x(ce){switch(ce){case"keyboard":return X.Keyboard;case"mouse":return X.Mouse;case"api":return X.Command}}X.fromValue=x}(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor(x,ce){if(ce&&!R.URI.isUri(ce))throw(0,t.illegalArgument)("target");if(!H.isRange(x)||x.isEmpty)throw(0,t.illegalArgument)("range");this.range=x,this.target=ce}};ct=Be([L],ct),e.DocumentLink=ct;let Rt=class{constructor(x,ce,De,Ge){this.red=x,this.green=ce,this.blue=De,this.alpha=Ge}};Rt=Be([L],Rt),e.Color=Rt;let Tt=class{constructor(x,ce){if(ce&&!(ce instanceof Rt))throw(0,t.illegalArgument)("color");if(!H.isRange(x)||x.isEmpty)throw(0,t.illegalArgument)("range");this.range=x,this.color=ce}};Tt=Be([L],Tt),e.ColorInformation=Tt;let yt=class{constructor(x){if(!x||typeof x!="string")throw(0,t.illegalArgument)("label");this.label=x}};yt=Be([L],yt),e.ColorPresentation=yt;var mt;(function(X){X[X.RGB=0]="RGB",X[X.HEX=1]="HEX",X[X.HSL=2]="HSL"})(mt=e.ColorFormat||(e.ColorFormat={}));var Lt;(function(X){X[X.Error=0]="Error",X[X.Warning=1]="Warning",X[X.Information=2]="Information"})(Lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Mt{constructor(x,ce,De){if(this.startIndex=x,this.length=ce,this.tooltip=De,typeof x!="number"||x<0)throw(0,t.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,t.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Mt;var Ft;(function(X){X[X.Panel=1]="Panel",X[X.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class xe{constructor(x){this.options=x,typeof x!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=xe;var _e;(function(X){X[X.Always=1]="Always",X[X.Silent=2]="Silent",X[X.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var ye;(function(X){X[X.Shared=1]="Shared",X[X.Dedicated=2]="Dedicated",X[X.New=3]="New"})(ye=e.TaskPanelKind||(e.TaskPanelKind={}));let me=o=class{constructor(x,ce){if(this.label=ce,typeof x!="string"||typeof ce!="string")throw(0,t.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};me.Clean=new o("clean","Clean"),me.Build=new o("build","Build"),me.Rebuild=new o("rebuild","Rebuild"),me.Test=new o("test","Test"),me=o=Be([L],me),e.TaskGroup=me;function ie(X){let x="";for(let ce=0;ce<X.length;ce++)x+=X[ce].replace(/,/g,",,")+",";return x}let Ie=class{constructor(x,ce,De){if(typeof x!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=x,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=De):this._options=ce)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,t.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let ce of this._args)x.push(ce);return ie(x)}};Ie=Be([L],Ie),e.ProcessExecution=Ie;let Re=class{constructor(x,ce,De){if(this._args=[],Array.isArray(ce)){if(!x)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,t.illegalArgument)("command");this._command=x,this._args=ce,this._options=De}else{if(typeof x!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=x,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,t.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ce of this._args)x.push(typeof ce=="string"?ce:ce.value);return ie(x)}};Re=Be([L],Re),e.ShellExecution=Re;var Ve;(function(X){X[X.Escape=1]="Escape",X[X.Strong=2]="Strong",X[X.Weak=3]="Weak"})(Ve=e.ShellQuoting||(e.ShellQuoting={}));var Ke;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace"})(Ke=e.TaskScope||(e.TaskScope={}));class ht{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=ht;let Et=m=class{constructor(x,ce,De,Ge,Qe,Ze){this.__deprecated=!1,this._definition=this.definition=x;let rt;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=De,this.execution=Ge,rt=Qe,this.__deprecated=!0):ce===Ke.Global||ce===Ke.Workspace?(this.target=ce,this._name=this.name=De,this._source=this.source=Ge,this.execution=Qe,rt=Ze):(this.target=ce,this._name=this.name=De,this._source=this.source=Ge,this.execution=Qe,rt=Ze),typeof rt=="string"?(this._problemMatchers=[rt],this._hasDefinedMatchers=!0):Array.isArray(rt)?(this._problemMatchers=rt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Re?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const ce=this._definition.type;(m.EmptyType===ce||m.ProcessType===ce||m.ShellType===ce||m.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Et.ExtensionCallbackType="customExecution",Et.ProcessType="process",Et.ShellType="shell",Et.EmptyType="$empty",Et=m=Be([L],Et),e.Task=Et;var St;(function(X){X[X.SourceControl=1]="SourceControl",X[X.Window=10]="Window",X[X.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));let ot=class{constructor(x,ce=dt.None){this.collapsibleState=ce,R.URI.isUri(x)?this.resourceUri=x:this.label=x}};ot=Be([L],ot),e.TreeItem=ot;var dt;(function(X){X[X.None=0]="None",X[X.Collapsed=1]="Collapsed",X[X.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(x){this.value=x}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ut=Be([L],ut),e.TreeDataTransferItem=ut;let Nt=class{constructor(){this._items=new Map}get(x){return this._items.get(x)}set(x,ce){this._items.set(x,ce)}forEach(x){this._items.forEach(x)}};Nt=Be([L],Nt),e.TreeDataTransfer=Nt;let pt=class{constructor(x,ce){this.id=x,this.color=ce}};pt=Be([L],pt),e.ThemeIcon=pt,pt.File=new pt("file"),pt.Folder=new pt("folder");let kt=class{constructor(x){this.id=x}};kt=Be([L],kt),e.ThemeColor=kt;var Ut;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace",X[X.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(x,ce){if(typeof x!="string"&&(!x||!R.URI.isUri(x)&&!R.URI.isUri(x.uri)))throw(0,t.illegalArgument)("base");if(typeof ce!="string")throw(0,t.illegalArgument)("pattern");typeof x=="string"?this.baseUri=R.URI.file(x):R.URI.isUri(x)?this.baseUri=x:this.baseUri=x.uri,this.pattern=ce}get base(){return this._base}set base(x){this._base=x,this._baseUri=R.URI.file(x)}get baseUri(){return this._baseUri}set baseUri(x){this._baseUri=x,this._base=x.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ct=Be([L],Ct),e.RelativePattern=Ct;let Bt=class{constructor(x,ce,De,Ge){this.enabled=typeof x=="boolean"?x:!0,typeof ce=="string"&&(this.condition=ce),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Bt=Be([L],Bt),e.Breakpoint=Bt;let Ht=class extends Bt{constructor(x,ce,De,Ge,Qe){super(ce,De,Ge,Qe);if(x===null)throw(0,t.illegalArgument)("location");this.location=x}};Ht=Be([L],Ht),e.SourceBreakpoint=Ht;let bt=class extends Bt{constructor(x,ce,De,Ge,Qe){super(ce,De,Ge,Qe);this.functionName=x}};bt=Be([L],bt),e.FunctionBreakpoint=bt;let ei=class extends Bt{constructor(x,ce,De,Ge,Qe,Ze,rt){super(Ge,Qe,Ze,rt);if(!ce)throw(0,t.illegalArgument)("dataId");this.label=x,this.dataId=ce,this.canPersist=De}};ei=Be([L],ei),e.DataBreakpoint=ei;let Xt=class{constructor(x,ce,De){this.command=x,this.args=ce||[],this.options=De}};Xt=Be([L],Xt),e.DebugAdapterExecutable=Xt;let ti=class{constructor(x,ce){this.port=x,this.host=ce}};ti=Be([L],ti),e.DebugAdapterServer=ti;let ai=class{constructor(x){this.path=x}};ai=Be([L],ai),e.DebugAdapterNamedPipeServer=ai;let Pt=class{constructor(x){this.implementation=x}};Pt=Be([L],Pt),e.DebugAdapterInlineImplementation=Pt;let ii=class{constructor(x,ce){this.range=x,this.expression=ce}};ii=Be([L],ii),e.EvaluatableExpression=ii;var bi;(function(X){X[X.Automatic=0]="Automatic",X[X.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(x,ce){this.range=x,this.text=ce}};qt=Be([L],qt),e.InlineValueText=qt;let Gt=class{constructor(x,ce,De=!0){this.range=x,this.variableName=ce,this.caseSensitiveLookup=De}};Gt=Be([L],Gt),e.InlineValueVariableLookup=Gt;let at=class{constructor(x,ce){this.range=x,this.expression=ce}};at=Be([L],at),e.InlineValueEvaluatableExpression=at;let li=class{constructor(x,ce){this.frameId=x,this.stoppedLocation=ce}};li=Be([L],li),e.InlineValueContext=li;var $t;(function(X){X[X.Changed=1]="Changed",X[X.Created=2]="Created",X[X.Deleted=3]="Deleted"})($t=e.FileChangeType||(e.FileChangeType={}));let xt=d=class extends Error{constructor(x,ce=D.FileSystemProviderErrorCode.Unknown,De){super(R.URI.isUri(x)?x.toString(!0):x);this.code=De?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(x){return new d(x,D.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(x){return new d(x,D.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(x){return new d(x,D.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(x){return new d(x,D.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(x){return new d(x,D.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(x){return new d(x,D.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};xt=d=Be([L],xt),e.FileSystemError=xt;let ni=class{constructor(x,ce,De){this.start=x,this.end=ce,this.kind=De}};ni=Be([L],ni),e.FoldingRange=ni;var _i;(function(X){X[X.Comment=1]="Comment",X[X.Imports=2]="Imports",X[X.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Si;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(Si=e.CommentMode||(e.CommentMode={}));var mi;(function(X){X[X.Unresolved=0]="Unresolved",X[X.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ri{constructor(x,ce=[]){this.tokenTypes=x,this.tokenModifiers=ce}}e.SemanticTokensLegend=ri;function Ci(X){return typeof X=="undefined"||(0,S.isStringArray)(X)}class Qt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let ce=0,De=x.tokenTypes.length;ce<De;ce++)this._tokenTypeStrToInt.set(x.tokenTypes[ce],ce);for(let ce=0,De=x.tokenModifiers.length;ce<De;ce++)this._tokenModifierStrToInt.set(x.tokenModifiers[ce],ce)}}push(x,ce,De,Ge,Qe){if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Qe=="number"||typeof Qe=="undefined"))return typeof Qe=="undefined"&&(Qe=0),this._pushEncoded(x,ce,De,Ge,Qe);if(H.isRange(x)&&typeof ce=="string"&&Ci(De))return this._push(x,ce,De);throw(0,t.illegalArgument)()}_push(x,ce,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Ge=x.start.line,Qe=x.start.character,Ze=x.end.character-x.start.character,rt=this._tokenTypeStrToInt.get(ce);let Dt=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(At);Dt|=1<<Wt>>>0}this._pushEncoded(Ge,Qe,Ze,rt,Dt)}_pushEncoded(x,ce,De,Ge,Qe){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Wt=0;for(let zt=0;zt<Dt;zt++){let Vt=this._data[5*zt],di=this._data[5*zt+1];Vt===0?(Vt=At,di+=Wt):Vt+=At,this._data[5*zt]=Vt,this._data[5*zt+1]=di,At=Vt,Wt=di}}let Ze=x,rt=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ze-=this._prevLine,Ze===0&&(rt-=this._prevChar)),this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=rt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Qe,this._prevLine=x,this._prevChar=ce}static _sortAndDeltaEncode(x){let ce=[];const De=x.length/5|0;for(let rt=0;rt<De;rt++)ce[rt]=rt;ce.sort((rt,Dt)=>{const At=x[5*rt],Wt=x[5*Dt];if(At===Wt){const zt=x[5*rt+1],Vt=x[5*Dt+1];return zt-Vt}return At-Wt});const Ge=new Uint32Array(x.length);let Qe=0,Ze=0;for(let rt=0;rt<De;rt++){const Dt=5*ce[rt],At=x[Dt+0],Wt=x[Dt+1],zt=x[Dt+2],Vt=x[Dt+3],di=x[Dt+4],xi=At-Qe,Ji=xi===0?Wt-Ze:Wt,hi=5*rt;Ge[hi+0]=xi,Ge[hi+1]=Ji,Ge[hi+2]=zt,Ge[hi+3]=Vt,Ge[hi+4]=di,Qe=At,Ze=Wt}return Ge}build(x){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),x):new Yt(Qt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Qt;class Yt{constructor(x,ce){this.resultId=ce,this.data=x}}e.SemanticTokens=Yt;class yi{constructor(x,ce,De){this.start=x,this.deleteCount=ce,this.data=De}}e.SemanticTokensEdit=yi;class Di{constructor(x,ce){this.resultId=ce,this.edits=x}}e.SemanticTokensEdits=Di;var Jt;(function(X){X[X.Separate=0]="Separate",X[X.MergeWithParent=1]="MergeWithParent"})(Jt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new pt("arrow-left")},si=Be([L],si),e.QuickInputButtons=si;var Ii;(function(X){X[X.Separator=-1]="Separator",X[X.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(X){X[X.UI=1]="UI",X[X.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Pi{constructor(x,ce,De){this.badge=x,this.tooltip=ce,this.color=De}static validate(x){if(x.badge){let ce=(0,k.nextCharLength)(x.badge,0);if(ce<x.badge.length&&(ce+=(0,k.nextCharLength)(x.badge,ce)),x.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Pi;let Zt=class{constructor(x){this.kind=x}};Zt=Be([L],Zt),e.ColorTheme=Zt;var gi;(function(X){X[X.Light=1]="Light",X[X.Dark=2]="Dark",X[X.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{constructor(x,ce){if(x<0)throw(0,t.illegalArgument)("start must be positive");if(ce<0)throw(0,t.illegalArgument)("end must be positive");x<=ce?(this._start=x,this._end=ce):(this._start=ce,this._end=x)}static isNotebookRange(x){return x instanceof Kt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let ce=this._start,De=this._end;return x.start!==void 0&&(ce=x.start),x.end!==void 0&&(De=x.end),ce===this._start&&De===this._end?this:new Kt(ce,De)}}e.NotebookRange=Kt;class Oe{constructor(x,ce,De,Ge,Qe,Ze,rt){this.kind=x,this.value=ce,this.languageId=De,this.mime=Ge,this.outputs=Qe??[],this.metadata=Ze,this.executionSummary=rt,Oe.validate(this)}static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(ce=>Oe.isNotebookCellData(ce))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Oe;class ci{constructor(x){this.cells=x}}e.NotebookData=ci;class Ot{constructor(x,ce){this.data=x,this.mime=ce;const De=(0,C.normalizeMimeType)(ce,!0);if(!De)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(x){return x instanceof Ot?!0:x?typeof x.mime=="string"&&x.data instanceof Uint8Array:!1}static error(x){const ce={name:x.name,message:x.message,stack:x.stack};return Ot.json(ce,"application/vnd.code.notebook.error")}static stdout(x){return Ot.text(x,"application/vnd.code.notebook.stdout")}static stderr(x){return Ot.text(x,"application/vnd.code.notebook.stderr")}static bytes(x,ce="application/octet-stream"){return new Ot(x,ce)}static text(x,ce=C.Mimes.text){const De=Pe(Ot,h,"f",v).encode(String(x));return new Ot(De,ce)}static json(x,ce="application/json"){const De=JSON.stringify(x,void 0,"	");return Ot.text(De,ce)}}e.NotebookCellOutputItem=Ot,h=Ot,v={value:new TextEncoder};class ft{constructor(x,ce,De){this.items=ft.ensureUniqueMimeTypes(x,!0),typeof ce=="string"?(this.id=ce,this.metadata=De):(this.id=(0,F.generateUuid)(),this.metadata=ce??De)}static isNotebookCellOutput(x){return x instanceof ft?!0:!x||typeof x!="object"?!1:typeof x.id=="string"&&(0,S.isArray)(x.items)}static ensureUniqueMimeTypes(x,ce=!1){const De=new Set,Ge=new Set;for(let Qe=0;Qe<x.length;Qe++){const Ze=x[Qe],rt=(0,C.normalizeMimeType)(Ze.mime);if(!De.has(rt)){De.add(rt);continue}Ge.add(Qe),ce&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Ge.size===0?x:x.filter((Qe,Ze)=>!Ge.has(Ze))}}e.NotebookCellOutput=ft;var Ti;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(Ti=e.NotebookCellKind||(e.NotebookCellKind={}));var Ai;(function(X){X[X.Idle=1]="Idle",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(Ai=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pi;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(pi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ri{constructor(x,ce){this.text=x,this.alignment=ce}}e.NotebookCellStatusBarItem=Ri;var Li;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred"})(Li=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Oi{constructor(x,ce=[]){this.uri=x,this.provides=(0,f.asArray)(ce)}}e.NotebookRendererScript=Oi;let ui=class{constructor(x,ce){this.label=x,this.timestamp=ce}};ui=Be([L],ui),e.TimelineItem=ui;var wi;(function(X){X[X.Production=1]="Production",X[X.Development=2]="Development",X[X.Test=3]="Test"})(wi=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(X){X[X.Node=1]="Node",X[X.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(X){X[X.Other=0]="Other",X[X.Comment=1]="Comment",X[X.String=2]="String",X[X.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Mi{constructor(x,ce){this.ranges=x,this.wordPattern=ce}}e.LinkedEditingRanges=Mi;class Ui{constructor(x,ce){this._port=x,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ui;var Bi;(function(X){X[X.Queued=1]="Queued",X[X.Running=2]="Running",X[X.Passed=3]="Passed",X[X.Failed=4]="Failed",X[X.Skipped=5]="Skipped",X[X.Errored=6]="Errored"})(Bi=e.TestResultState||(e.TestResultState={}));var le;(function(X){X[X.Run=1]="Run",X[X.Debug=2]="Debug",X[X.Coverage=3]="Coverage"})(le=e.TestRunProfileKind||(e.TestRunProfileKind={}));let fe=class{constructor(x=void 0,ce=void 0,De=void 0){this.include=x,this.exclude=ce,this.profile=De}};fe=Be([L],fe),e.TestRunRequest=fe;let ke=E=class{constructor(x){this.message=x}static diff(x,ce,De){const Ge=new E(x);return Ge.expectedOutput=ce,Ge.actualOutput=De,Ge}};ke=E=Be([L],ke),e.TestMessage=ke;let tt=class{constructor(x){this.id=x}};tt=Be([L],tt),e.TestTag=tt;let gt=class{constructor(x,ce){this.covered=x,this.total=ce}};gt=Be([L],gt),e.CoveredCount=gt;let It=P=class{constructor(x,ce,De,Ge){this.uri=x,this.statementCoverage=ce,this.branchCoverage=De,this.functionCoverage=Ge}static fromDetails(x,ce){const De=new gt(0,0),Ge=new gt(0,0),Qe=new gt(0,0);for(const rt of ce)if("branches"in rt){De.total+=1,De.covered+=rt.executionCount>0?1:0;for(const Dt of rt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=rt.executionCount>0?1:0;const Ze=new P(x,De,Ge.total>0?Ge:void 0,Qe.total>0?Qe:void 0);return Ze.detailedCoverage=ce,Ze}};It=P=Be([L],It),e.FileCoverage=It;let Wi=class{constructor(x,ce,De=[]){this.executionCount=x,this.location=ce,this.branches=De}};Wi=Be([L],Wi),e.StatementCoverage=Wi;let zi=class{constructor(x,ce){this.executionCount=x,this.location=ce}};zi=Be([L],zi),e.BranchCoverage=zi;let Hi=class{constructor(x,ce){this.executionCount=x,this.location=ce}};Hi=Be([L],Hi),e.FunctionCoverage=Hi;var Ki;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xi;(function(X){X[X.Untrusted=0]="Untrusted",X[X.Trusted=1]="Trusted",X[X.Unspecified=2]="Unspecified"})(Xi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qi;(function(X){X[X.Notify=1]="Notify",X[X.OpenBrowser=2]="OpenBrowser",X[X.OpenPreview=3]="OpenPreview",X[X.Silent=4]="Silent",X[X.Ignore=5]="Ignore",X[X.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(x,ce,De,Ge,Qe,Ze){this.kind=x,this.name=ce,this.detail=De,this.uri=Ge,this.range=Qe,this.selectionRange=Ze}}e.TypeHierarchyItem=Yi}),define(ve[125],we([1,0,55,10,8,151,107,7,18]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function F(g,h){h?R.set(g,h):R.delete(g)}e.setWordDefinitionFor=F;function D(g){return R.get(g)}e.getWordDefinitionFor=D;class p extends T.MirrorTextModel{constructor(h,v,A,_,a,l,u,c){super(v,A,_,a);this._proxy=h,this._languageId=l,this._isDirty=u,this._notebook=c,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,S.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===t.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(v){return v?h._getTextInRange(v):h.getText()},get eol(){return h._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(v){return h._lineAt(v)},offsetAt(v){return h._offsetAt(v)},positionAt(v){return h._positionAt(v)},validateRange(v){return h._validateRange(v)},validatePosition(v){return h._validatePosition(v)},getWordRangeAtPosition(v,A){return h._getWordRangeAtPosition(v,A)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,f.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,f.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const v=this._validateRange(h);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const A=this._eol,_=v.start.line,a=v.end.line,l=[];l.push(this._lines[_].substring(v.start.character));for(let u=_+1;u<a;u++)l.push(this._lines[u]);return l.push(this._lines[a].substring(0,v.end.character)),l.join(A)}_lineAt(h){let v;if(h instanceof k.Position?v=h.line:typeof h=="number"&&(v=h),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new b(v,this._lines[v],v===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(h),A=this._lines[v.index].length;return new k.Position(v.index,Math.min(v.remainder,A))}_validateRange(h){if(!(h instanceof k.Range))throw new Error("Invalid argument");const v=this._validatePosition(h.start),A=this._validatePosition(h.end);return v===h.start&&A===h.end?h:new k.Range(v.line,v.character,A.line,A.character)}_validatePosition(h){if(!(h instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:v,character:A}=h,_=!1;if(v<0)v=0,A=0,_=!0;else if(v>=this._lines.length)v=this._lines.length-1,A=this._lines[v].length,_=!0;else{const a=this._lines[v].length;A<0?(A=0,_=!0):A>a&&(A=a,_=!0)}return _?new k.Position(v,A):h}_getWordRangeAtPosition(h,v){const A=this._validatePosition(h);if(!v)v=D(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const _=(0,C.getWordAtText)(A.character+1,(0,C.ensureValidWordDefinition)(v),this._lines[A.line],0);if(_)return new k.Range(A.line,_.startColumn-1,A.line,_.endColumn-1)}}e.ExtHostDocumentData=p;class b{constructor(h,v,A){this._line=h,this._text=v,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(ve[202],we([1,0,7,3,110,6,108,24,2,33]),function(te,e,f,t,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(p,b,g,h){this._notebook=g,this._selector=h,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(A=>{const _=this._cellUris.get(A.document.uri);_!==void 0&&(this._cellLengths.setValue(_,this._cells[_].document.getText().length+1),this._cellLines.setValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(p.onDidChangeNotebookCells(A=>v(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const p=[],b=[];for(const g of this._notebook.getCells())g.kind===f.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,g.document.uri,g.document.languageId,!0,void 0))&&(this._cellUris.set(g.document.uri,this._cells.length),this._cells.push(g),p.push(g.document.getText().length+1),b.push(g.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(p)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(p){if(!p){let _="";for(const a of this._cells)_+=a.document.getText()+`
`;return _=_.slice(0,-1),_}if(p.isEmpty)return"";const b=this.locationAt(p.start),g=this.locationAt(p.end),h=this._cellUris.get(b.uri),v=this._cellUris.get(g.uri);if(h===void 0||v===void 0)return"";if(h===v)return this._cells[h].document.getText(new f.Range(b.range.start,g.range.end));const A=[this._cells[h].document.getText(new f.Range(b.range.start,new f.Position(this._cells[h].document.lineCount,0)))];for(let _=h+1;_<v;_++)A.push(this._cells[_].document.getText());return A.push(this._cells[v].document.getText(new f.Range(new f.Position(0,0),g.range.end))),A.join(`
`)}offsetAt(p){const b=this._cellLines.getIndexOf(p.line),g=this._cellLengths.getPrefixSum(b.index-1),h=this._cells[b.index].document.offsetAt(p.with(b.remainder));return g+h}positionAt(p){if(typeof p=="number"){const g=this._cellLengths.getIndexOf(p),h=this._cellLines.getPrefixSum(g.index-1);return this._cells[g.index].document.positionAt(g.remainder).translate(h)}const b=this._cellUris.get(p.uri);if(b!==void 0){const g=this._cellLines.getPrefixSum(b-1);return new f.Position(g+p.range.start.line,p.range.start.character)}return new f.Position(0,0)}locationAt(p){f.Range.isRange(p)||(p=new f.Range(p,p));const b=this._cellLines.getIndexOf(p.start.line);let g=b;p.isEmpty||(g=this._cellLines.getIndexOf(p.end.line));const h=new f.Position(b.remainder,p.start.character),v=new f.Position(g.remainder,p.end.character),A=new f.Range(h,v),_=this._cells[b.index];return new f.Location(_.document.uri,_.document.validateRange(A))}contains(p){return this._cellUris.has(p)}validateRange(p){const b=this.validatePosition(p.start),g=this.validatePosition(p.end);return p.with(b,g)}validatePosition(p){const b=this._cellLines.getIndexOf(p.line),g=new f.Position(b.remainder,p.character),h=this._cells[b.index].document.validatePosition(g),v=this._cellLines.getPrefixSum(b.index-1);return new f.Position(v+h.line,h.character)}}e.ExtHostNotebookConcatDocument=F}),define(ve[203],we([1,0,7,17,3]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(k){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?f.ColorThemeKind.Light:k==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Be([Fe(0,t.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ve[63],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class t{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=t}),define(ve[204],we([1,0,22]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let R=this.buffers.indexOf(S);return R<0&&(R=this.buffers.length,this.buffers.push(S)),R}}function I(k,S){if(S.serializeBuffersForPostMessage){const R=new t,F=(b,g)=>{if(g instanceof ArrayBuffer){const h=R.add(g);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(g)){const h=T(g);if(h){const v=R.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:h,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},D=JSON.stringify(k,F),p=R.buffers.map(b=>{const g=new Uint8Array(b);return f.VSBuffer.wrap(g)});return{message:D,buffers:p}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function T(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(k,S){const R=S.map(p=>{const b=new ArrayBuffer(p.byteLength);return new Uint8Array(b).set(p.buffer),b}),F=S.length?(p,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const g=b,{index:h}=g,v=R[h];if(g.view)switch(g.view.type){case 1:return new Int8Array(v,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return b}:void 0;return{message:JSON.parse(k,F),arrayBuffers:R}}e.deserializeWebviewMessage=C}),define(ve[205],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(t){function I(C){const k=new Map;return C.types.forEach((S,R)=>{k.set(S,{asString:async()=>C.items[R].asString,value:void 0})}),k}t.toITreeDataTransfer=I;async function T(C){const k={types:[],items:[]},S=Array.from(C.entries());for(const R of S)k.types.push(R[0]),k.items.push({asString:await R[1].asString()});return k}t.toTreeDataTransferDTO=T})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[206],we([1,0,101]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(T){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:T,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function I(T){return new f.URITransformer(t(T))}e.createURITransformer=I}),define(ve[207],we([1,0,175,13,2,6,4,50,42,18,10]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(D=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var p;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(p=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function b(Q){const $=Q;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=b;function g(Q,$,U){for(const q of U.visibleEditorPanes)if(q.group.id===$&&Q.matches(q.input))return q.getViewState()}e.findViewStateForEditor=g;function h(Q){if(w(Q))return!1;const $=Q;return I.URI.isUri($?.resource)}e.isResourceEditorInput=h;function v(Q){if(w(Q))return!1;const $=Q;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=v;function A(Q){if(w(Q)||v(Q))return!1;const $=Q;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=A;function _(Q){if(w(Q))return!1;const $=Q;return $?$.resource===void 0||$.resource.scheme===F.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;var a;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var l;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));var u;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends T.Disposable{}e.AbstractEditorInput=c;function w(Q){return Q instanceof c}e.isEditorInput=w;function s(Q){const $=Q;return I.URI.isUri($?.preferredResource)}function n(Q){const $=Q;return w($?.primary)&&w($?.secondary)}e.isSideBySideEditorInput=n;function r(Q){const $=Q;return w($?.modified)&&w($?.original)}e.isDiffEditorInput=r;function i(Q){return w(Q?.editor)}e.isEditorInputWithOptions=i;function o(Q){const $=Q;return i(Q)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function m(Q){const $=Q;return typeof $?.groupId=="number"&&w($.editor)}e.isEditorIdentifier=m;var d;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(d=e.EditorCloseContext||(e.EditorCloseContext={}));var E;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LOCKED=2]="GROUP_LOCKED",Q[Q.EDITOR_OPEN=3]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=4]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=5]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=7]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=9]="EDITOR_PIN",Q[Q.EDITOR_STICKY=10]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=11]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(E=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var P;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(P=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri($,U){if(!$)return;if(U?.supportSideBySide){const{primary:K,secondary:G}=this.getSideEditors($);if(K&&G){if(U?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===P.ANY)return this.getOriginalUri(K,{filterByScheme:U.filterByScheme})??this.getOriginalUri(G,{filterByScheme:U.filterByScheme});$=U.supportSideBySide===P.PRIMARY?K:G}}if(v($)||A($))return;const q=s($)?$.preferredResource:$.resource;return!q||!U||!U.filterByScheme?q:this.filterUri(q,U.filterByScheme)}getSideEditors($){return n($)||A($)?{primary:$.primary,secondary:$.secondary}:r($)||v($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,U){if(!$)return;if(U?.supportSideBySide){const{primary:K,secondary:G}=this.getSideEditors($);if(K&&G){if(U?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===P.ANY)return this.getCanonicalUri(K,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:U.filterByScheme});$=U.supportSideBySide===P.PRIMARY?K:G}}if(v($)||A($))return;const q=$.resource;return!q||!U||!U.filterByScheme?q:this.filterUri(q,U.filterByScheme)}filterUri($,U){if(Array.isArray(U)){if(U.some(q=>$.scheme===q))return $}else if(U===$.scheme)return $}}e.EditorResourceAccessor=new L;var O;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(O=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const U=this.instantiationService=$.get(C.IInstantiationService);for(const[q,K]of this.editorSerializerConstructors)this.createEditorSerializer(q,K,U);this.editorSerializerConstructors.clear()}createEditorSerializer($,U,q){const K=q.createInstance(U);this.editorSerializerInstances.set($,K)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,U){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,U,this.instantiationService):this.editorSerializerConstructors.set($,U),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new y);async function H(Q,$){if(!Q||!Q.length)return[];const U=await Promise.all(Q.map(async q=>{const K=I.URI.revive(q.fileUri);if(!K||!await $.canHandleResource(K))return;let ee=q.exists,oe=q.type;if(typeof ee!="boolean"||typeof oe!="number")try{oe=(await $.stat(K)).isDirectory?S.FileType.Directory:S.FileType.Unknown,ee=!0}catch{ee=!1}if(!ee&&q.openOnlyIfExists||oe===S.FileType.Directory)return;const ue={selection:ee?q.selection:void 0,pinned:!0,override:q.editorOverrideId};let Z;return ee?Z={resource:K,options:ue}:Z={resource:K,options:ue,forceUntitled:!0},Z}));return(0,R.coalesce)(U)}e.pathsToEditors=H;var M;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}));function j(Q){const $=Q;if(!$)return!1;const U=$;if(U.modified)return j(U.modified);const q=$;return!!(q.contributionsState&&q.viewState&&Array.isArray(q.cursorState))}e.isTextEditorViewState=j}),define(ve[83],we([1,0,10,2]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,S){return k.scheme===f.Schemas.http||k.scheme===f.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===f.Schemas.file&&(k=t.URI.from({scheme:f.Schemas.vscodeRemote,authority:S.authority,path:k.path})),t.URI.from({scheme:f.Schemas.https,authority:`${k.scheme}+${T(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function T(k){return k.replace(/./g,S=>{const R=S.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?S:"-"+R.toString(16).padStart(4,"0")})}function C(k){return k.replace(/-([0-9a-f]{4})/g,(S,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=C}),define(ve[208],we([1,0,3,6,83]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(k,S,R){this._proxy=k,this._editors=S,this._initData=R,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const F=S.getVisibleTextEditors();for(const D of this._insets.values())F.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,R,F,D){let p;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===k){p=a;break}if(!p)throw new Error("not a visible editor");const b=this,g=this._handlePool++,h=new f.Emitter,v=new f.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,I.asWebviewUri)(a,b._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(a){this._options=a,b._proxy.$setOptions(g,a)}get options(){return this._options}set html(a){this._html=a,b._proxy.$setHtml(g,a)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(a){return b._proxy.$postMessage(g,a)}},_=new class{constructor(){this.editor=k,this.line=S,this.height=R,this.webview=A,this.onDidDispose=v.event}dispose(){b._insets.has(g)&&(b._insets.delete(g),b._proxy.$disposeEditorInset(g),v.fire(),v.dispose(),h.dispose())}};return this._proxy.$createEditorInset(g,p.id,p.value.document.uri,S+1,R,F||{},D.identifier,D.extensionLocation),this._insets.set(g,{editor:k,inset:_,onDidReceiveMessage:h}),_}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const R=this._insets.get(k);R&&R.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=T}),define(ve[126],we([1,0,3,16,176]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,R,F){const D={command:k};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.internalSend("request",D),typeof F=="number"){const p=setTimeout(()=>{clearTimeout(p);const b=this.pendingRequests.get(D.seq);if(b){this.pendingRequests.delete(D.seq);const g={type:"response",seq:0,request_seq:D.seq,success:!1,command:k,message:(0,I.localize)(0,null,F,k)};b(g)}},F)}return R&&this.pendingRequests.set(D.seq,R),D.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const S=k,R=this.pendingRequests.get(S.request_seq);R&&(this.pendingRequests.delete(S.request_seq),R(S));break}}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,R)=>k.set(R,S)),await(0,t.timeout)(500),k.forEach((S,R)=>{S({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ve[209],we([1,0,177,61,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:f.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:f.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:f.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:f.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:f.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:f.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:f.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:f.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:f.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:f.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:f.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:f.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:f.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:f.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:f.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:f.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:f.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:f.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:f.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:f.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:f.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:f.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:f.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:f.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:f.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:f.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:f.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:f.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:f.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:f.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:f.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:f.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:f.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:f.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:f.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:f.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:f.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:f.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:f.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:f.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:f.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:f.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:f.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:f.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:f.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:f.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:f.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:f.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:f.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:f.localize(49,null)});const T=D=>f.localize(50,null,D);e.debuggerDisabledMessage=T,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:f.localize(51,null)};var C;(function(D){D[D.Inactive=0]="Inactive",D[D.Initializing=1]="Initializing",D[D.Stopped=2]="Stopped",D[D.Running=3]="Running"})(C=e.State||(e.State={}));function k(D){switch(D){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var S;(function(D){D[D.Valid=0]="Valid",D[D.Unreadable=1]="Unreadable",D[D.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(D){D[D.Initial=1]="Initial",D[D.Dynamic=2]="Dynamic"})(R=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,I.createDecorator)(e.DEBUG_SERVICE_ID);var F;(function(D){D[D.CONDITION=0]="CONDITION",D[D.HIT_COUNT=1]="HIT_COUNT",D[D.LOG_MESSAGE=2]="LOG_MESSAGE"})(F=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ve[210],we([1,0,8,2,9,25,10]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(s,n,r){return s.replace(k,function(i,o){return n&&o.length>0&&o[0]!=="_"?i:r&&r.hasOwnProperty(o)?r[o]:i})}e.formatPII=S;function R(s){const n={};for(const r of Object.keys(s))r.startsWith("!")||(n[r]=s[r]);return n}e.filterExceptionsFromTelemetry=R;function F(s){return s.configuration.request==="attach"&&!D(s)&&(!s.parentSession||F(s.parentSession))}e.isSessionAttach=F;function D(s){let n=s.configuration.type;if(!!n)return n==="vslsShare"&&(n=s.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(n,"extensionhost")||(0,f.equalsIgnoreCase)(n,"pwa-extensionhost")?s:s.parentSession?D(s.parentSession):void 0}e.getExtensionHostDebugSession=D;function p(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=p;function b(s,n,r){let i,o=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=m.exec(s);){const E=d.index+1,P=E+d[0].length;if(E<=n&&P>=r){i=d[0],o=E;break}}if(i){const E=/\w+/g;let P=null;for(;(P=E.exec(i))&&!(P.index+1+o+P[0].length>=r););P&&(i=i.substring(0,E.lastIndex))}return i?{start:o,end:o+i.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(s){return!!(s&&s.match(g))}e.isUri=h;function v(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(h(s.path))return t.URI.parse(s.path);if((0,I.isAbsolute)(s.path))return t.URI.file(s.path)}return s.path}function A(s){if(typeof s.path=="object"){const n=t.URI.revive(s.path);if(n)return n.scheme===C.Schemas.file?n.fsPath:n.toString()}return s.path}function _(s,n){const r=n?v:A,i=(0,T.deepClone)(s);return l(i,(o,m)=>{o&&m&&(m.path=r(m))}),i}e.convertToDAPaths=_;function a(s,n){const r=n?v:A,i=(0,T.deepClone)(s);return l(i,(o,m)=>{!o&&m&&(m.path=r(m))}),i}e.convertToVSCPaths=a;function l(s,n){switch(s.type){case"event":{const r=s;switch(r.event){case"output":n(!1,r.body.source);break;case"loadedSource":n(!1,r.body.source);break;case"breakpoint":n(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=s;switch(r.command){case"setBreakpoints":n(!0,r.arguments.source);break;case"breakpointLocations":n(!0,r.arguments.source);break;case"source":n(!0,r.arguments.source);break;case"gotoTargets":n(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(i=>n(!1,i));break;default:break}break}case"response":{const r=s;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(i=>n(!1,i.source));break;case"loadedSources":r.body.sources.forEach(i=>n(!1,i));break;case"scopes":r.body.scopes.forEach(i=>n(!1,i.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(i=>n(!1,i.source));break;case"setBreakpoints":r.body.breakpoints.forEach(i=>n(!1,i.source));break;case"disassemble":{const i=r;i.body&&i.body.instructions.forEach(o=>n(!1,o.location))}break;default:break}break}}}function u(s){return s.filter(n=>!n.presentation?.hidden).sort((n,r)=>n.presentation?r.presentation?n.presentation.group?r.presentation.group?n.presentation.group!==r.presentation.group?n.presentation.group.localeCompare(r.presentation.group):c(n.presentation.order,r.presentation.order):-1:r.presentation.group?1:c(n.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=u;function c(s,n){return typeof s!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:s-n}async function w(s,n){const r=s.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(r!=="none"&&(await n.saveAll(),r==="allEditorsInActiveGroup")){const i=n.activeEditorPane;i&&i.input.resource?.scheme===C.Schemas.untitled&&await n.save({editor:i.input,groupId:i.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=w}),define(ve[211],we([1,0,28,38,178,127,9,8,25,12,194,126]),function(te,e,f,t,I,T,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class p extends D.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",l=>this.handleData(l))}sendMessage(_){if(this.outputStream){const a=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${p.TWO_CRLF}${a}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+a))}continue}}else{const a=this.rawData.indexOf(p.TWO_CRLF);if(a!==-1){const u=this.rawData.toString("utf8",0,a).split(p.HEADER_LINESEPARATOR);for(const c of u){const w=c.split(p.HEADER_FIELDSEPARATOR);w[0]==="Content-Length"&&(this.contentLength=Number(w[1]))}this.rawData=this.rawData.slice(a+p.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=p,p.TWO_CRLF=`\r
\r
`,p.HEADER_LINESEPARATOR=/\r?\n/,p.HEADER_FIELDSEPARATOR=/: */;class b extends p{startSession(){return new Promise((_,a)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",u=>{l?this._onError.fire(u):a(u)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class g extends b{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=g;class h extends b{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=h;class v extends p{constructor(_,a,l){super();this.adapterExecutable=_,this.debugType=a,this.outputService=l}async startSession(){const _=this.adapterExecutable.command,a=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(_)if(C.isAbsolute(_)){if(!await f.Promises.exists(_))throw new Error(I.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let u=process.env;if(l.env&&Object.keys(l.env).length>0&&(u=S.mixin(S.deepClone(process.env),l.env)),_==="node")if(Array.isArray(a)&&a.length>0){const w=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:u,execArgv:w?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(s.cwd=l.cwd);const n=t.fork(a[0],a.slice(1),s);if(!n.pid)throw new Error(I.localize(2,null,a[0]));this.serverProcess=n}else throw new Error(I.localize(3,null));else{const w={env:u};l.cwd&&(w.cwd=l.cwd),this.serverProcess=t.spawn(_,a,w)}this.serverProcess.on("error",w=>{this._onError.fire(w)}),this.serverProcess.on("exit",(w,s)=>{this._onExit.fire(w)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",w=>{this._onError.fire(w)}),this.serverProcess.stdin.on("error",w=>{this._onError.fire(w)});const c=this.outputService;if(c){const w=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=c.getChannel(F.ExtensionsChannelId);n&&n.append(w(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(u){this._onError.fire(u)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((_,a)=>{const l=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(u,c,w){if(u)return a(u)});l.on("exit",_),l.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,a){if(!_)return;const l=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?l.runtime=C.join(a,_.runtime):l.runtime=_.runtime),_.runtimeArgs&&(l.runtimeArgs=_.runtimeArgs),_.program&&(C.isAbsolute(_.program)?l.program=_.program:l.program=C.join(a,_.program)),_.args&&(l.args=_.args);const u=_;return u.win&&(l.win=v.extract(u.win,a)),u.winx86&&(l.winx86=v.extract(u.winx86,a)),u.windows&&(l.windows=v.extract(u.windows,a)),u.osx&&(l.osx=v.extract(u.osx,a)),u.linux&&(l.linux=v.extract(u.linux,a)),l}static platformAdapterExecutable(_,a){let l=Object.create(null);a=a.toLowerCase();for(const r of _)if(r.contributes){const i=r.contributes.debuggers;i&&i.length>0&&i.filter(o=>typeof o.type=="string"&&k.equalsIgnoreCase(o.type,a)).forEach(o=>{const m=v.extract(o,r.extensionLocation.fsPath);l=S.mixin(l,m,r.isBuiltin)})}let u;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=l.winx86||l.win||l.windows:R.isWindows?u=l.win||l.windows:R.isMacintosh?u=l.osx:R.isLinux&&(u=l.linux),u=u||l;const c=u.program||l.program,w=u.args||l.args,s=u.runtime||l.runtime,n=u.runtimeArgs||l.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof c=="string"?[c]:[]).concat(w||[])};if(c)return{type:"executable",command:c,args:w||[]}}}e.ExecutableDebugAdapter=v}),define(ve[212],we([1,0,38,29,12]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function T(R,F){return new Promise((D,p)=>{let b="";const g=f.spawn(R,F);g.pid&&g.stdout.on("data",h=>{b+=h.toString()}),g.on("error",h=>{p(h)}),g.on("close",h=>{D(b)})})}async function C(R){if(R)if(I.isWindows){const F=await new Promise((D,p)=>{te(["windows-process-tree"],D,p)});return new Promise(D=>{F.getProcessTree(R,p=>{D(p.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(R)]).then(F=>{const D=F.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},F=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var k;(function(R){R[R.cmd=0]="cmd",R[R.powershell=1]="powershell",R[R.bash=2]="bash"})(k||(k={}));function S(R,F,D,p){R=R.trim().toLowerCase();let b;R.indexOf("powershell")>=0||R.indexOf("pwsh")>=0?b=1:R.indexOf("cmd.exe")>=0?b=0:R.indexOf("bash")>=0?b=2:I.isWindows?b=0:b=2;let g,h=" ";switch(b){case 1:if(g=v=>(v=v.replace(/\'/g,"''"),v.length>0&&v.charAt(v.length-1)==="\\"?`'${v}\\'`:`'${v}'`),D){const v=(0,t.getDriveLetter)(D);v&&(h+=`${v}:; `),h+=`cd ${g(D)}; `}if(p)for(const v in p){const A=p[v];A===null?h+=`Remove-Item env:${v}; `:h+=`\${env:${v}}='${A}'; `}if(F.length>0){const v=g(F.shift());h+=v[0]==="'"?`& ${v} `:`${v} `;for(const A of F)h+=`${g(A)} `}break;case 0:if(g=v=>(v=v.replace(/\"/g,'""'),v.indexOf(" ")>=0||v.indexOf('"')>=0||v.length===0?`"${v}"`:v),D){const v=(0,t.getDriveLetter)(D);v&&(h+=`${v}: && `),h+=`cd ${g(D)} && `}if(p){h+='cmd /C "';for(const v in p){let A=p[v];A===null?h+=`set "${v}=" && `:(A=A.replace(/[\^\&\|\<\>]/g,_=>`^${_}`),h+=`set "${v}=${A}" && `)}}for(const v of F)h+=`${g(v)} `;p&&(h+='"');break;case 2:{g=A=>(A=A.replace(/(["'\\\$])/g,"\\$1"),A.indexOf(" ")>=0||A.indexOf(";")>=0||A.length===0?`"${A}"`:A);const v=A=>/[^\w@%\/+=,.:^-]/.test(A)?`'${A.replace(/'/g,"'\\''")}'`:A;if(D&&(h+=`cd ${g(D)} ; `),p){h+="/usr/bin/env";for(const A in p){const _=p[A];_===null?h+=` -u ${v(A)}`:h+=` ${v(`${A}=${_}`)}`}h+=" "}for(const A of F)h+=`${g(A)} `;break}}return h}e.prepareCommand=S}),define(ve[128],we([1,0,32,76,92,10,9,12,61]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(i){i[i.Markup=1]="Markup",i[i.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(i){i[i.Running=1]="Running",i[i.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var D;(function(i){i[i.Unconfirmed=1]="Unconfirmed",i[i.Pending=2]="Pending",i[i.Executing=3]="Executing"})(D=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(i){i[i.WithHardKernelDependency=0]="WithHardKernelDependency",i[i.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",i[i.Pure=2]="Pure",i[i.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(i){i.Always="always",i.Never="never",i.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(i){i[i.ModelChange=1]="ModelChange",i[i.Move=2]="Move",i[i.ChangeLanguage=5]="ChangeLanguage",i[i.Initialize=6]="Initialize",i[i.ChangeCellMetadata=7]="ChangeCellMetadata",i[i.Output=8]="Output",i[i.OutputItem=9]="OutputItem",i[i.ChangeCellContent=10]="ChangeCellContent",i[i.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",i[i.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",i[i.ChangeCellMime=13]="ChangeCellMime",i[i.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(i){i[i.Handle=0]="Handle",i[i.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(i){i[i.Replace=1]="Replace",i[i.Output=2]="Output",i[i.Metadata=3]="Metadata",i[i.CellLanguage=4]="CellLanguage",i[i.DocumentMetadata=5]="DocumentMetadata",i[i.Move=6]="Move",i[i.OutputItems=7]="OutputItems",i[i.PartialMetadata=8]="PartialMetadata",i[i.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var A;(function(i){i.scheme=T.Schemas.vscodeNotebookCell;const o=/^ch(\d{7,})/;function m(y,H){return y.with({scheme:i.scheme,fragment:`ch${H.toString().padStart(7,"0")}${y.scheme!==T.Schemas.file?y.scheme:""}`})}i.generate=m;function d(y){if(y.scheme!==i.scheme)return;const H=o.exec(y.fragment);return H?{handle:Number(H[1]),notebook:y.with({scheme:y.fragment.substring(H[0].length)||T.Schemas.file,fragment:null})}:void 0}i.parse=d;function E(y,H){return y.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${y.scheme!==T.Schemas.file?y.scheme:""}`})}i.generateCellOutputUri=E;function P(y){if(y.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(y.fragment);if(!H)return;const M=H[1]&&H[1]!==""?H[1]:void 0,j=H[2];return{outputId:M,notebook:y.with({scheme:j||T.Schemas.file,fragment:null})}}i.parseCellOutputUri=P;function L(y,H,M){return y.with({scheme:M,fragment:`ch${H.toString().padStart(7,"0")}${y.scheme!==T.Schemas.file?y.scheme:""}`})}i.generateCellUri=L;function O(y,H){if(y.scheme!==H)return;const M=o.exec(y.fragment);return M?{handle:Number(M[1]),notebook:y.with({scheme:y.fragment.substring(M[0].length)||T.Schemas.file,fragment:null})}:void 0}i.parseCellUri=O})(A=e.CellUri||(e.CellUri={}));const _=i=>k.isWindows?i.replace(/\//g,"\\"):i;class a{constructor(o=[],m=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=m,this.order=[...new Set(o)].map(d=>({pattern:d,matches:f.parse(_(d))}))}sort(o){const m=new Map(t.Iterable.map(o,E=>[E,_(E)]));let d=[];for(const{matches:E}of this.order)for(const[P,L]of m)if(E(L)){d.push(P),m.delete(P);break}return m.size&&(d=d.concat([...m.keys()].sort((E,P)=>this.defaultOrder.indexOf(E)-this.defaultOrder.indexOf(P)))),d}prioritize(o,m){const d=this.findIndex(o);if(d===-1){this.order.unshift({pattern:o,matches:f.parse(_(o))});return}const E=new Set(m.map(L=>this.findIndex(L,d)));E.delete(-1);const P=Array.from(E).sort();this.order.splice(d+1,0,...P.map(L=>this.order[L]));for(let L=P.length-1;L>=0;L--)this.order.splice(P[L],1)}toArray(){return this.order.map(o=>o.pattern)}findIndex(o,m=this.order.length){const d=_(o);for(let E=0;E<m;E++)if(this.order[E].matches(d))return E;return-1}}e.MimeTypeDisplayOrder=a;function l(i,o,m,d=(E,P)=>E===P){const E=[];function P(y,H,M){if(H===0&&M.length===0)return;const j=E[E.length-1];j&&j.start+j.deleteCount===y?(j.deleteCount+=H,j.toInsert.push(...M)):E.push({start:y,deleteCount:H,toInsert:M})}let L=0,O=0;for(;;){if(L===i.length){P(L,0,o.slice(O));break}if(O===o.length){P(L,i.length-L,[]);break}const y=i[L],H=o[O];if(d(y,H)){L+=1,O+=1;continue}m(H)?(P(L,1,[]),L+=1):(P(L,0,[H]),O+=1)}return E}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(i){i.default="default",i.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(i){const o=i;return!!((typeof o.include=="string"||f.isRelativePattern(o.include))&&(typeof o.exclude=="string"||f.isRelativePattern(o.exclude)))}e.isDocumentExcludePattern=c;function w(i,o,m){if(Array.isArray(i.viewType)&&i.viewType.indexOf(o)>=0||i.viewType===o)return!0;if(i.filenamePattern){const d=c(i.filenamePattern)?i.filenamePattern.include:i.filenamePattern,E=c(i.filenamePattern)?i.filenamePattern.exclude:void 0;if(f.match(d,(0,C.basename)(m.fsPath).toLowerCase()))return!(E&&f.match(E,(0,C.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=w;class s{constructor(o){this.textModel=o}getElements(){const o=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)o[m]=this.textModel.cells[m].getHashValue();return o}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var n;(function(i){i[i.Left=1]="Left",i[i.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(o){return`${r._prefix}${o}`}static parse(o){if(o.startsWith(r._prefix))return o.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(ve[213],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(ve[214],we([1,0,4,61]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,f.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[215],we([1,0,179,4,61]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[216],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=f;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t}),define(ve[84],we([1,0,2,35]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var T;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(T=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(r){r.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),r.deserialize=i=>({range:t.Range.lift(i.range),uri:f.URI.revive(i.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var k;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var S;(function(r){r.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&C.serialize(i.location)}),r.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&C.deserialize(i.location)})})(S=e.ITestErrorMessage||(e.ITestErrorMessage={}));var R;(function(r){r.serialize=i=>({message:i.message,type:1,offset:i.offset,location:i.location&&C.serialize(i.location)}),r.deserialize=i=>({message:i.message,type:1,offset:i.offset,location:i.location&&C.deserialize(i.location)})})(R=e.ITestOutputMessage||(e.ITestOutputMessage={}));var F;(function(r){r.serialize=i=>i.type===0?S.serialize(i):R.serialize(i),r.deserialize=i=>i.type===0?S.deserialize(i):R.deserialize(i)})(F=e.ITestMessage||(e.ITestMessage={}));var D;(function(r){r.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(F.serialize)}),r.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(F.deserialize)})})(D=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",b=(r,i)=>r+p+i;e.namespaceTestTag=b;const g=r=>{const i=r.indexOf(p);return{ctrlId:r.slice(0,i),tagId:r.slice(i+1)}};e.denamespaceTestTag=g;var h;(function(r){r.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),r.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?f.URI.revive(i.uri):void 0,range:i.range?t.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(h=e.ITestItem||(e.ITestItem={}));var v;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var A;(function(r){r.serialize=i=>({controllerId:i.controllerId,expand:i.expand,parent:i.parent,item:h.serialize(i.item)}),r.deserialize=i=>({controllerId:i.controllerId,expand:i.expand,parent:i.parent,item:h.deserialize(i.item)})})(A=e.InternalTestItem||(e.InternalTestItem={}));var _;(function(r){r.serialize=i=>{let o;return i.item&&(o={},i.item.label!==void 0&&(o.label=i.item.label),i.item.tags!==void 0&&(o.tags=i.item.tags),i.item.busy!==void 0&&(o.busy=i.item.busy),i.item.uri!==void 0&&(o.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(o.range=i.item.range?.toJSON()),i.item.description!==void 0&&(o.description=i.item.description),i.item.error!==void 0&&(o.error=i.item.error),i.item.sortText!==void 0&&(o.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:o}},r.deserialize=i=>{let o;return i.item&&(o={},i.item.label!==void 0&&(o.label=i.item.label),i.item.tags!==void 0&&(o.tags=i.item.tags),i.item.busy!==void 0&&(o.busy=i.item.busy),i.item.range!==void 0&&(o.range=i.item.range?t.Range.lift(i.item.range):null),i.item.description!==void 0&&(o.description=i.item.description),i.item.error!==void 0&&(o.error=i.item.error),i.item.sortText!==void 0&&(o.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:o}}})(_=e.ITestItemUpdate||(e.ITestItemUpdate={}));const a=(r,i)=>{i.expand!==void 0&&(r.expand=i.expand),i.item!==void 0&&(r.item=r.item?Object.assign(r.item,i.item):i.item)};e.applyTestItemUpdate=a;var l;(function(r){r.serialize=(i,o)=>({...A.serialize(i),children:o,ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(D.serialize)})})(l=e.TestResultItem||(e.TestResultItem={}));var u;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var c;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var w;(function(r){r.deserialize=i=>i.op===0?{op:i.op,item:A.deserialize(i.item)}:i.op===1?{op:i.op,item:_.deserialize(i.item)}:i,r.serialize=i=>i.op===0?{op:i.op,item:A.serialize(i.item)}:i.op===1?{op:i.op,item:_.serialize(i.item)}:i})(w=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(i){}update(i){}remove(i,o){}complete(){}}e.IncrementalChangeCollector=s;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const o=this.createChangeCollector();for(const m of i)switch(m.op){case 0:{const d=A.deserialize(m.item);if(d.parent){if(this.items.has(d.parent)){const E=this.items.get(d.parent);E.children.add(d.item.extId);const P=this.createItem(d,E);this.items.set(d.item.extId,P),o.add(P)}}else{const E=this.createItem(d);this.roots.add(E),this.items.set(d.item.extId,E),o.add(E)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=_.deserialize(m.item),E=this.items.get(d.extId);if(!E)break;d.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,d),o.update(E);break}case 2:{const d=this.items.get(m.itemId);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const E=[[m.itemId]];for(;E.length;)for(const P of E.pop()){const L=this.items.get(P);L&&(E.push(L.children),this.items.delete(P),o.remove(L,L!==d),L.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}o.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=n}),define(ve[85],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(T){T.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{constructor(C,k=C.length){if(this.path=C,this.viewEnd=k,C.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,k,S=C.parent){if(C.id===k)return new I([k]);let R=[C.id];for(let F=S;F&&F.id!==k;F=F.parent)R.push(F.id);return R.push(k),new I(R.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const k=C.indexOf("\0");return k===-1?C:C.slice(0,k)}static fromString(C){return new I(C.split("\0"))}static join(C,k){return new I([...C.path,k])}static joinToString(C,k){return C.toString()+"\0"+k}static compare(C,k){return C===k?0:k.startsWith(C+"\0")?2:C.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new I(this.path,C)}compare(C){if(typeof C=="string")return I.compare(this.toString(),C);for(let k=0;k<C.viewEnd&&k<this.viewEnd;k++)if(C.path[k]!==this.path[k])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=I}),define(ve[217],we([1,0,9,41,13,25,12,100,180]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(D,p,b,g){this._contributedVariables=new Map,this._context=D,this._labelService=p,this._userHomePromise=b,g&&(this._envVariablesPromise=g.then(h=>this.prepareEnv(h)))}prepareEnv(D){if(C.isWindows){const p=Object.create(null);return Object.keys(D).forEach(b=>{p[b.toLowerCase()]=D[b]}),p}return D}resolveWithEnvironment(D,p,b){return this.recursiveResolve(this.prepareEnv(D),p?p.uri:void 0,b)}async resolveAsync(D,p){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,D?D.uri:void 0,p)}async resolveAnyBase(D,p,b,g){const h=T.deepClone(p);C.isWindows&&h.windows?Object.keys(h.windows).forEach(A=>h[A]=h.windows[A]):C.isMacintosh&&h.osx?Object.keys(h.osx).forEach(A=>h[A]=h.osx[A]):C.isLinux&&h.linux&&Object.keys(h.linux).forEach(A=>h[A]=h.linux[A]),delete h.windows,delete h.osx,delete h.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,D?D.uri:void 0,h,b,g)}async resolveAnyAsync(D,p,b){return this.resolveAnyBase(D,p,b)}async resolveAnyMap(D,p,b){const g=new Map;return{newConfig:await this.resolveAnyBase(D,p,b,g),resolvedVariables:g}}resolveWithInteractionReplace(D,p,b,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,p,b,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,p){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,p)}recursiveResolve(D,p,b,g,h){if(I.isString(b))return this.resolveString(D,p,b,g,h);if(I.isArray(b))return b.map(v=>this.recursiveResolve(D,p,v,g,h));if(I.isObject(b)){let v=Object.create(null);return Object.keys(b).forEach(A=>{const _=this.resolveString(D,p,A,g,h);v[_]=this.recursiveResolve(D,p,b[A],g,h)}),v}return b}resolveString(D,p,b,g,h){return b.replace(R.VARIABLE_REGEXP,(A,_)=>{if(_.includes(R.VARIABLE_LHS))return A;let a=this.evaluateSingleVariable(D,A,_,p,g);return h&&h.set(_,a),a!==A&&I.isString(a)&&a.match(R.VARIABLE_REGEXP)&&(a=this.resolveString(D,p,a,g,h)),a})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}evaluateSingleVariable(D,p,b,g,h){let v;const A=b.split(":");A.length>1&&(b=A[0],v=A[1]);const _=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,S.localize)(0,null,p))},a=()=>{const u=_();if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return c}throw new Error((0,S.localize)(1,null,p,f.basename(u)))},l=()=>{if(v){const u=this._context.getFolderUri(v);if(u)return u;throw new Error((0,S.localize)(2,null,p,v))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,p)):new Error((0,S.localize)(4,null,p))};switch(b){case"env":if(v){if(D.env){const u=D.env[C.isWindows?v.toLowerCase():v];if(I.isString(u))return u}return""}throw new Error((0,S.localize)(5,null,p));case"config":if(v){const u=this._context.getConfigurationValue(g,v);if(I.isUndefinedOrNull(u))throw new Error((0,S.localize)(6,null,p,v));if(I.isObject(u))throw new Error((0,S.localize)(7,null,p,v));return u}throw new Error((0,S.localize)(8,null,p));case"command":return this.resolveFromMap(p,v,h,"command");case"input":return this.resolveFromMap(p,v,h,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return g||v?(0,k.normalizeDriveLetter)(this.fsPath(l())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(l()));case"userHome":{if(D.userHome)return D.userHome;throw new Error((0,S.localize)(9,null,p))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new Error((0,S.localize)(10,null,p))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new Error((0,S.localize)(11,null,p))}case"file":return _();case"fileWorkspaceFolder":return a();case"relativeFile":return g||v?f.relative(this.fsPath(l()),_()):_();case"relativeFileDirname":{const u=f.dirname(_());if(g||v){const c=f.relative(this.fsPath(l()),u);return c.length===0?".":c}return u}case"fileDirname":return f.dirname(_());case"fileExtname":return f.extname(_());case"fileBasename":return f.basename(_());case"fileBasenameNoExtension":{const u=f.basename(_());return u.slice(0,u.length-f.extname(u).length)}case"fileDirnameBasename":return f.basename(f.dirname(_()));case"execPath":{const u=this._context.getExecPath();return u||p}case"execInstallFolder":{const u=this._context.getAppRoot();return u||p}case"pathSeparator":return f.sep;default:try{const u=v?`${b}:${v}`:b;return this.resolveFromMap(p,u,h,void 0)}catch{return p}}}}resolveFromMap(D,p,b,g){if(p&&b){const h=g===void 0?b[p]:b[g+":"+p];if(typeof h=="string")return h;throw new Error((0,S.localize)(12,null,D))}return D}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[129],we([1,0,4,207]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var k;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function R(g){const h=g;return(0,t.isEditorInput)(h?.editor)&&(0,t.isEditorInput)(h?.replacement)}e.isEditorReplacement=R;var F;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function p(g){const h=g;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=p;function b(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ve[218],we([1,0,4,129]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(T){const C=T;return typeof T=="number"||(0,t.isEditorGroup)(C)}e.isPreferredGroup=I}),define(ve[14],we([1,0,18,22,99,142,58,25,13,2,35,78,182,116,62,128,84,85,218,7]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(_e){function ye(ie){const{selectionStartLineNumber:Ie,selectionStartColumn:Re,positionLineNumber:Ve,positionColumn:Ke}=ie,ht=new a.Position(Ie-1,Re-1),Et=new a.Position(Ve-1,Ke-1);return new a.Selection(ht,Et)}_e.to=ye;function me(ie){const{anchor:Ie,active:Re}=ie;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}_e.from=me})(l=e.Selection||(e.Selection={}));var u;(function(_e){function ye(ie){if(!ie)return;const{start:Ie,end:Re}=ie;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}_e.from=ye;function me(ie){if(!ie)return;const{startLineNumber:Ie,startColumn:Re,endLineNumber:Ve,endColumn:Ke}=ie;return new a.Range(Ie-1,Re-1,Ve-1,Ke-1)}_e.to=me})(u=e.Range||(e.Range={}));var c;(function(_e){function ye(me){switch(me){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}_e.to=ye})(c=e.TokenType||(e.TokenType={}));var w;(function(_e){function ye(ie){return new a.Position(ie.lineNumber-1,ie.column-1)}_e.to=ye;function me(ie){return{lineNumber:ie.line+1,column:ie.character+1}}_e.from=me})(w=e.Position||(e.Position={}));var s;(function(_e){function ye(Ie,Re){return(0,f.coalesce)((0,f.asArray)(Ie).map(Ve=>me(Ve,Re)))}_e.from=ye;function me(Ie,Re){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:ie(Ie.scheme,Re),pattern:J.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType}}function ie(Ie,Re){return Re&&typeof Ie=="string"?Re.transformOutgoingScheme(Ie):Ie}})(s=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(_e){function ye(ie){switch(ie){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}_e.from=ye;function me(ie){switch(ie){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}_e.to=me})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ye(ie){let Ie;return ie.code&&((0,S.isString)(ie.code)||(0,S.isNumber)(ie.code)?Ie=String(ie.code):Ie={value:String(ie.code.value),target:ie.code.target}),{...u.from(ie.range),message:ie.message,source:ie.source,code:Ie,severity:o.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(i.from),tags:Array.isArray(ie.tags)?(0,f.coalesce)(ie.tags.map(n.from)):void 0}}_e.from=ye;function me(ie){const Ie=new a.Diagnostic(u.to(ie),ie.message,o.to(ie.severity));return Ie.source=ie.source,Ie.code=(0,S.isString)(ie.code)?ie.code:ie.code?.value,Ie.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(i.to),Ie.tags=ie.tags&&(0,f.coalesce)(ie.tags.map(n.to)),Ie}_e.to=me})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(_e){function ye(ie){return{...u.from(ie.location.range),message:ie.message,resource:ie.location.uri}}_e.from=ye;function me(ie){return new a.DiagnosticRelatedInformation(new a.Location(ie.resource,u.to(ie)),ie.message)}_e.to=me})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(_e){function ye(ie){switch(ie){case a.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}_e.from=ye;function me(ie){switch(ie){case b.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}_e.to=me})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(_e){function ye(ie){return typeof ie=="number"&&ie>=a.ViewColumn.One?ie-1:ie===a.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}_e.from=ye;function me(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=me})(m=e.ViewColumn||(e.ViewColumn={}));function d(_e){return typeof _e.range!="undefined"}function E(_e){return _e.length===0?!0:!!d(_e[0])}e.isDecorationOptionsArr=E;var P;(function(_e){function ye(Ke){return Ke.map(_e.from)}_e.fromMany=ye;function me(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function ie(Ke){let ht;if(me(Ke)){const{language:dt,value:ut}=Ke;ht={value:"```"+dt+`
`+ut+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ke)?ht={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ht={value:Ke}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const St=dt=>{try{let ut=R.URI.parse(dt,!0);ut=ut.with({query:Ie(ut.query,Et)}),Et[dt]=ut}catch{}return""},ot=new T.marked.Renderer;return ot.link=St,ot.image=dt=>typeof dt=="string"?St(I.parseHrefAndDimensions(dt).href):"",(0,T.marked)(ht.value,{renderer:ot}),ht}_e.from=ie;function Ie(Ke,ht){if(!Ke)return Ke;let Et;try{Et=(0,C.parse)(Ke)}catch{}if(!Et)return Ke;let St=!1;return Et=(0,k.cloneAndChange)(Et,ot=>{if(R.URI.isUri(ot)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[dt]=ot,St=!0,dt}else return}),St?JSON.stringify(Et):Ke}function Re(Ke){const ht=new a.MarkdownString(Ke.value,Ke.supportThemeIcons);return ht.isTrusted=Ke.isTrusted,ht.supportHtml=Ke.supportHtml,ht.baseUri=Ke.baseUri?R.URI.from(Ke.baseUri):void 0,ht}_e.to=Re;function Ve(Ke){if(!!Ke)return typeof Ke=="string"?Ke:_e.from(Ke)}_e.fromStrict=Ve})(P=e.MarkdownString||(e.MarkdownString={}));function L(_e){return E(_e)?_e.map(ye=>({range:u.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?P.fromMany(ye.hoverMessage):ye.hoverMessage?P.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):_e.map(ye=>({range:u.from(ye)}))}e.fromRangeOrRangeWithMessage=L;function O(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?R.URI.file(_e):_e}e.pathOrURIToURI=O;var y;(function(_e){function ye(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}_e.from=ye})(y=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(_e){function ye(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?y.from(me.before):void 0,after:me.after?y.from(me.after):void 0}}_e.from=ye})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(_e){function ye(me){if(typeof me=="undefined")return me;switch(me){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ye})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(_e){function ye(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?M.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?H.from(me.light):void 0,dark:me.dark?H.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?y.from(me.before):void 0,after:me.after?y.from(me.after):void 0}}_e.from=ye})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Q;(function(_e){function ye(ie){return{text:ie.newText,eol:ie.newEol&&et.from(ie.newEol),range:u.from(ie.range)}}_e.from=ye;function me(ie){const Ie=new a.TextEdit(u.to(ie.range),ie.text);return Ie.newEol=typeof ie.eol=="undefined"?void 0:et.to(ie.eol),Ie}_e.to=me})(Q=e.TextEdit||(e.TextEdit={}));var $;(function(_e){function ye(ie,Ie){const Re={edits:[]};if(ie instanceof a.WorkspaceEdit)for(let Ve of ie._allEntries())Ve._type===1?Re.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata}):Ve._type===2?Re.edits.push({_type:2,resource:Ve.uri,edit:Q.from(Ve.edit),modelVersionId:Ie?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Re.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Re.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri),edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(vt.from)}});return Re}_e.from=ye;function me(ie){const Ie=new a.WorkspaceEdit;for(const Re of ie.edits)Re.edit?Ie.replace(R.URI.revive(Re.resource),u.to(Re.edit.range),Re.edit.text):Ie.renameFile(R.URI.revive(Re.oldUri),R.URI.revive(Re.newUri),Re.options);return Ie}_e.to=me})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(_e){const ye=Object.create(null);ye[a.SymbolKind.File]=0,ye[a.SymbolKind.Module]=1,ye[a.SymbolKind.Namespace]=2,ye[a.SymbolKind.Package]=3,ye[a.SymbolKind.Class]=4,ye[a.SymbolKind.Method]=5,ye[a.SymbolKind.Property]=6,ye[a.SymbolKind.Field]=7,ye[a.SymbolKind.Constructor]=8,ye[a.SymbolKind.Enum]=9,ye[a.SymbolKind.Interface]=10,ye[a.SymbolKind.Function]=11,ye[a.SymbolKind.Variable]=12,ye[a.SymbolKind.Constant]=13,ye[a.SymbolKind.String]=14,ye[a.SymbolKind.Number]=15,ye[a.SymbolKind.Boolean]=16,ye[a.SymbolKind.Array]=17,ye[a.SymbolKind.Object]=18,ye[a.SymbolKind.Key]=19,ye[a.SymbolKind.Null]=20,ye[a.SymbolKind.EnumMember]=21,ye[a.SymbolKind.Struct]=22,ye[a.SymbolKind.Event]=23,ye[a.SymbolKind.Operator]=24,ye[a.SymbolKind.TypeParameter]=25;function me(Ie){return typeof ye[Ie]=="number"?ye[Ie]:6}_e.from=me;function ie(Ie){for(const Re in ye)if(ye[Re]===Ie)return Number(Re);return a.SymbolKind.Property}_e.to=ie})(U=e.SymbolKind||(e.SymbolKind={}));var q;(function(_e){function ye(ie){switch(ie){case a.SymbolTag.Deprecated:return 1}}_e.from=ye;function me(ie){switch(ie){case 1:return a.SymbolTag.Deprecated}}_e.to=me})(q=e.SymbolTag||(e.SymbolTag={}));var K;(function(_e){function ye(ie){return{name:ie.name,kind:U.from(ie.kind),tags:ie.tags&&ie.tags.map(q.from),containerName:ie.containerName,location:Z.from(ie.location)}}_e.from=ye;function me(ie){const Ie=new a.SymbolInformation(ie.name,U.to(ie.kind),ie.containerName,Z.to(ie.location));return Ie.tags=ie.tags&&ie.tags.map(q.to),Ie}_e.to=me})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(_e){function ye(ie){const Ie={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),kind:U.from(ie.kind),tags:ie.tags?.map(q.from)??[]};return ie.children&&(Ie.children=ie.children.map(ye)),Ie}_e.from=ye;function me(ie){const Ie=new a.DocumentSymbol(ie.name,ie.detail,U.to(ie.kind),u.to(ie.range),u.to(ie.selectionRange));return(0,f.isNonEmptyArray)(ie.tags)&&(Ie.tags=ie.tags.map(q.to)),ie.children&&(Ie.children=ie.children.map(me)),Ie}_e.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(_e){function ye(ie){const Ie=new a.CallHierarchyItem(U.to(ie.kind),ie.name,ie.detail||"",R.URI.revive(ie.uri),u.to(ie.range),u.to(ie.selectionRange));return Ie._sessionId=ie._sessionId,Ie._itemId=ie._itemId,Ie}_e.to=ye;function me(ie,Ie,Re){if(Ie=Ie??ie._sessionId,Re=Re??ie._itemId,Ie===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Re,name:ie.name,detail:ie.detail,kind:U.from(ie.kind),uri:ie.uri,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),tags:ie.tags?.map(q.from)}}_e.from=me})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(_e){function ye(me){return new a.CallHierarchyIncomingCall(ee.to(me.from),me.fromRanges.map(ie=>u.to(ie)))}_e.to=ye})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ue;(function(_e){function ye(me){return new a.CallHierarchyOutgoingCall(ee.to(me.to),me.fromRanges.map(ie=>u.to(ie)))}_e.to=ye})(ue=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Z;(function(_e){function ye(ie){return{range:ie.range&&u.from(ie.range),uri:ie.uri}}_e.from=ye;function me(ie){return new a.Location(R.URI.revive(ie.uri),u.to(ie.range))}_e.to=me})(Z=e.location||(e.location={}));var Y;(function(_e){function ye(ie){const Ie=ie,Re=ie;return{originSelectionRange:Ie.originSelectionRange?u.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Re.uri,range:u.from(Ie.targetRange?Ie.targetRange:Re.range),targetSelectionRange:Ie.targetSelectionRange?u.from(Ie.targetSelectionRange):void 0}}_e.from=ye;function me(ie){return{targetUri:R.URI.revive(ie.uri),targetRange:u.to(ie.range),targetSelectionRange:ie.targetSelectionRange?u.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?u.to(ie.originSelectionRange):void 0}}_e.to=me})(Y=e.DefinitionLink||(e.DefinitionLink={}));var se;(function(_e){function ye(ie){return{range:u.from(ie.range),contents:P.fromMany(ie.contents)}}_e.from=ye;function me(ie){return new a.Hover(ie.contents.map(P.to),u.to(ie.range))}_e.to=me})(se=e.Hover||(e.Hover={}));var de;(function(_e){function ye(ie){return{range:u.from(ie.range),expression:ie.expression}}_e.from=ye;function me(ie){return new a.EvaluatableExpression(u.to(ie.range),ie.expression)}_e.to=me})(de=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(_e){function ye(ie){if(ie instanceof a.InlineValueText)return{type:"text",range:u.from(ie.range),text:ie.text};if(ie instanceof a.InlineValueVariableLookup)return{type:"variable",range:u.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ye;function me(ie){switch(ie.type){case"text":return{range:u.to(ie.range),text:ie.text};case"variable":return{range:u.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:u.to(ie.range),expression:ie.expression}}}_e.to=me})(ge=e.InlineValue||(e.InlineValue={}));var Te;(function(_e){function ye(ie){return{frameId:ie.frameId,stoppedLocation:u.from(ie.stoppedLocation)}}_e.from=ye;function me(ie){return new a.InlineValueContext(ie.frameId,u.to(ie.stoppedLocation))}_e.to=me})(Te=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(_e){function ye(ie){return{range:u.from(ie.range),kind:ie.kind}}_e.from=ye;function me(ie){return new a.DocumentHighlight(u.to(ie.range),ie.kind)}_e.to=me})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var be;(function(_e){function ye(me){switch(me){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}_e.to=ye})(be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(_e){function ye(me){return{triggerKind:be.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}_e.to=ye})(Ee=e.CompletionContext||(e.CompletionContext={}));var z;(function(_e){function ye(ie){switch(ie){case a.CompletionItemTag.Deprecated:return 1}}_e.from=ye;function me(ie){switch(ie){case 1:return a.CompletionItemTag.Deprecated}}_e.to=me})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(_e){const ye=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function me(Re){return ye.get(Re)??9}_e.from=me;const ie=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Ie(Re){return ie.get(Re)??a.CompletionItemKind.Property}_e.to=Ie})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var N;(function(_e){function ye(me,ie){const Ie=new a.CompletionItem(me.label);return Ie.insertText=me.insertText,Ie.kind=B.to(me.kind),Ie.tags=me.tags?.map(z.to),Ie.detail=me.detail,Ie.documentation=I.isMarkdownString(me.documentation)?P.to(me.documentation):me.documentation,Ie.sortText=me.sortText,Ie.filterText=me.filterText,Ie.preselect=me.preselect,Ie.commitCharacters=me.commitCharacters,F.Range.isIRange(me.range)?Ie.range=u.to(me.range):typeof me.range=="object"&&(Ie.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Ie.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?Ie.insertText=new a.SnippetString(me.insertText):(Ie.insertText=me.insertText,Ie.textEdit=Ie.range instanceof a.Range?new a.TextEdit(Ie.range,Ie.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ie.additionalTextEdits=me.additionalTextEdits.map(Re=>Q.to(Re))),Ie.command=ie&&me.command?ie.fromInternal(me.command):void 0,Ie}_e.to=ye})(N=e.CompletionItem||(e.CompletionItem={}));var W;(function(_e){function ye(ie){return{label:ie.label,documentation:P.fromStrict(ie.documentation)}}_e.from=ye;function me(ie){return{label:ie.label,documentation:I.isMarkdownString(ie.documentation)?P.to(ie.documentation):ie.documentation}}_e.to=me})(W=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(_e){function ye(ie){return{label:ie.label,documentation:P.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(W.from):[],activeParameter:ie.activeParameter}}_e.from=ye;function me(ie){return{label:ie.label,documentation:I.isMarkdownString(ie.documentation)?P.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(W.to):[],activeParameter:ie.activeParameter}}_e.to=me})(V=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(_e){function ye(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(V.from):[]}}_e.from=ye;function me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(V.to):[]}}_e.to=me})(re=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(_e){function ye(me,ie){const Ie=new a.InlayHint(w.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(Ce.to.bind(void 0,me)),ie.kind&&Ae.to(ie.kind));return Ie.tooltip=I.isMarkdownString(ie.tooltip)?P.to(ie.tooltip):ie.tooltip,Ie.paddingLeft=ie.paddingLeft,Ie.paddingRight=ie.paddingRight,Ie}_e.to=ye})(he=e.InlayHint||(e.InlayHint={}));var Ce;(function(_e){function ye(me,ie){const Ie=new a.InlayHintLabelPart(ie.label);return Ie.tooltip=I.isMarkdownString(ie.tooltip)?P.to(ie.tooltip):ie.tooltip,D.Command.is(ie.command)&&(Ie.command=me.fromInternal(ie.command)),ie.location&&(Ie.location=Z.to(ie.location)),Ie}_e.to=ye})(Ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ae;(function(_e){function ye(ie){return ie}_e.from=ye;function me(ie){return ie}_e.to=me})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(_e){function ye(ie){return{range:u.from(ie.range),url:ie.target,tooltip:ie.tooltip}}_e.from=ye;function me(ie){let Ie;if(ie.url)try{Ie=typeof ie.url=="string"?R.URI.parse(ie.url,!0):R.URI.revive(ie.url)}catch{}return new a.DocumentLink(u.to(ie.range),Ie)}_e.to=me})(We=e.DocumentLink||(e.DocumentLink={}));var ze;(function(_e){function ye(ie){const Ie=new a.ColorPresentation(ie.label);return ie.textEdit&&(Ie.textEdit=Q.to(ie.textEdit)),ie.additionalTextEdits&&(Ie.additionalTextEdits=ie.additionalTextEdits.map(Re=>Q.to(Re))),Ie}_e.to=ye;function me(ie){return{label:ie.label,textEdit:ie.textEdit?Q.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ie=>Q.from(Ie)):void 0}}_e.from=me})(ze=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(_e){function ye(ie){return new a.Color(ie[0],ie[1],ie[2],ie[3])}_e.to=ye;function me(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}_e.from=me})(qe=e.Color||(e.Color={}));var He;(function(_e){function ye(ie){return{range:u.from(ie.range)}}_e.from=ye;function me(ie){return new a.SelectionRange(u.to(ie.range))}_e.to=me})(He=e.SelectionRange||(e.SelectionRange={}));var Ue;(function(_e){function ye(me){switch(me){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}_e.to=ye})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(_e){function ye(ie){switch(ie){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ye;function me(ie){switch(ie){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}_e.to=me})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(_e){function ye(ie){if(ie===a.EndOfLine.CRLF)return 1;if(ie===a.EndOfLine.LF)return 0}_e.from=ye;function me(ie){if(ie===1)return a.EndOfLine.CRLF;if(ie===0)return a.EndOfLine.LF}_e.to=me})(et=e.EndOfLine||(e.EndOfLine={}));var Le;(function(_e){function ye(me){if(typeof me=="object")return me.viewId;switch(me){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ye})(Le=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(_e){function ye(me){const ie={start:me.start+1,end:me.end+1};return me.kind&&(ie.kind=ne.from(me.kind)),ie}_e.from=ye})(it=e.FoldingRange||(e.FoldingRange={}));var ne;(function(_e){function ye(me){if(me)switch(me){case a.FoldingRangeKind.Comment:return D.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return D.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return D.FoldingRangeKind.Region}}_e.from=ye})(ne=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(_e){function ye(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?p.EditorResolution.DISABLED:void 0}}_e.from=ye})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var J;(function(_e){function ye(Re){return Re instanceof a.RelativePattern?Re.toJSON():typeof Re=="string"?Re:me(Re)||ie(Re)?new a.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}_e.from=ye;function me(Re){const Ve=Re;return Ve?R.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function ie(Re){const Ve=Re;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Ie(Re){return typeof Re=="string"?Re:new a.RelativePattern(R.URI.revive(Re.baseUri),Re.pattern)}_e.to=Ie})(J=e.GlobPattern||(e.GlobPattern={}));var pe;(function(_e){function ye(me){if(me){if(Array.isArray(me))return me.map(ye);if(typeof me=="string")return me;{const ie=me;return{language:ie.language,scheme:ie.scheme,pattern:J.from(ie.pattern),exclusive:ie.exclusive}}}else return}_e.from=ye})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(_e){function ye(ie){return{start:ie.start,end:ie.end}}_e.from=ye;function me(ie){return new a.NotebookRange(ie.start,ie.end)}_e.to=me})(Se=e.NotebookRange||(e.NotebookRange={}));var Me;(function(_e){function ye(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}_e.to=ye;function me(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}_e.from=me})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(_e){function ye(me){if(me===h.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(me===h.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(me===h.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${me}`)}_e.to=ye})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(_e){function ye(ie){switch(ie){case a.NotebookCellKind.Markup:return h.CellKind.Markup;case a.NotebookCellKind.Code:default:return h.CellKind.Code}}_e.from=ye;function me(ie){switch(ie){case h.CellKind.Markup:return a.NotebookCellKind.Markup;case h.CellKind.Code:default:return a.NotebookCellKind.Code}}_e.to=me})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var lt;(function(_e){function ye(ie){const Ie={metadata:ie.metadata??Object.create(null),cells:[]};for(let Re of ie.cells)a.NotebookCellData.validate(Re),Ie.cells.push(vt.from(Re));return Ie}_e.from=ye;function me(ie){const Ie=new a.NotebookData(ie.cells.map(vt.to));return(0,S.isEmptyObject)(ie.metadata)||(Ie.metadata=ie.metadata),Ie}_e.to=me})(lt=e.NotebookData||(e.NotebookData={}));var vt;(function(_e){function ye(ie){return{cellKind:Ye.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Me.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(je.from):[]}}_e.from=ye;function me(ie){return new a.NotebookCellData(Ye.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(je.to):void 0,ie.metadata,ie.internalMetadata?Me.to(ie.internalMetadata):void 0)}_e.to=me})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(_e){function ye(ie){return{mime:ie.mime,valueBytes:t.VSBuffer.wrap(ie.data)}}_e.from=ye;function me(ie){return new a.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}_e.to=me})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(_e){function ye(ie){return{outputId:ie.id,items:ie.items.map(wt.from),metadata:ie.metadata}}_e.from=ye;function me(ie){const Ie=ie.items.map(wt.to);return new a.NotebookCellOutput(Ie,ie.outputId,ie.metadata)}_e.to=me})(je=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(_e){function ye(Ie){return ie(Ie)?{include:(0,S.withNullAsUndefined)(J.from(Ie.include)),exclude:(0,S.withNullAsUndefined)(J.from(Ie.exclude))}:(0,S.withNullAsUndefined)(J.from(Ie))}_e.from=ye;function me(Ie){return ie(Ie)?{include:J.to(Ie.include),exclude:J.to(Ie.exclude)}:J.to(Ie)}_e.to=me;function ie(Ie){const Re=Ie;return Re?!!Re.include&&!!Re.exclude:!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(_e){function ye(me){return{backgroundColor:me.backgroundColor,borderColor:me.borderColor,top:me.top?y.from(me.top):void 0}}_e.from=ye})(_t=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var nt;(function(_e){function ye(me,ie,Ie){const Re=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Re,Ie),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}_e.from=ye})(nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ct;(function(_e){function ye(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}_e.from=ye})(ct=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Rt;(function(_e){function ye(ie){return{uri:ie.uri,provides:ie.provides}}_e.from=ye;function me(ie){return new a.NotebookRendererScript(R.URI.revive(ie.uri),ie.provides)}_e.to=me})(Rt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(_e){function ye(ie){return{message:P.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,location:ie.location&&{range:u.from(ie.location.range),uri:ie.location.uri}}}_e.from=ye;function me(ie){const Ie=new a.TestMessage(typeof ie.message=="string"?ie.message:P.to(ie.message));return Ie.actualOutput=ie.actual,Ie.expectedOutput=ie.expected,Ie.location=ie.location?Z.to(ie.location):void 0,Ie}_e.to=me})(Tt=e.TestMessage||(e.TestMessage={}));var yt;(function(_e){_e.namespace=v.namespaceTestTag,_e.denamespace=v.denamespaceTestTag})(yt=e.TestTag||(e.TestTag={}));var mt;(function(_e){function ye(Re){const Ve=(0,g.getPrivateApiFor)(Re).controllerId;return{extId:A.TestId.fromExtHostTestItem(Re,Ve).toString(),label:Re.label,uri:R.URI.revive(Re.uri),busy:!1,tags:Re.tags.map(Ke=>yt.namespace(Ve,Ke.id)),range:F.Range.lift(u.from(Re.range)),description:Re.description||null,sortText:Re.sortText||null,error:Re.error&&P.fromStrict(Re.error)||null}}_e.from=ye;function me(Re){return{parent:void 0,error:void 0,id:A.TestId.fromString(Re.extId).localId,label:Re.label,uri:R.URI.revive(Re.uri),tags:(Re.tags||[]).map(Ve=>{const{tagId:Ke}=yt.denamespace(Ve);return new a.TestTag(Ke)}),range:u.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0,sortText:Re.sortText||void 0}}_e.toPlain=me;function ie(Re){const Ve=A.TestId.fromString(Re.extId),Ke=new g.TestItemImpl(Ve.controllerId,Ve.localId,Re.label,R.URI.revive(Re.uri)||void 0);return Ke.range=u.to(Re.range||void 0),Ke.description=Re.description||void 0,Ke.sortText=Re.sortText||void 0,Ke}function Ie(Re){let Ve;for(const Ke of Re.tests){const ht=ie(Ke.item);(0,g.getPrivateApiFor)(ht).parent=Ve,Ve=ht}return Ve}_e.toItemFromContext=Ie})(mt=e.TestItem||(e.TestItem={})),function(_e){function ye(ie){return{id:ie.id}}_e.from=ye;function me(ie){return new a.TestTag(ie.id)}_e.to=me}(yt=e.TestTag||(e.TestTag={}));var Lt;(function(_e){const ye=(ie,Ie)=>{const Re={...mt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(Ke=>Ke.type===0).map(Tt.to)})),children:ie.children.map(Ve=>Ie.get(Ve)).filter(S.isDefined).map(Ve=>ye(Ve,Ie))};for(const Ve of Re.children)Ve.parent=Re;return Re};function me(ie){const Ie=[],Re=new Map;for(const Ve of ie.items)Re.set(Ve.item.extId,Ve),ie.request.targets.some(Ke=>Ke.controllerId===Ve.controllerId&&Ke.testIds.includes(Ve.item.extId))&&Ie.push(Ve);return{completedAt:ie.completedAt,results:Ie.map(Ve=>ye(Ve,Re))}}_e.to=me})(Lt=e.TestResults||(e.TestResults={}));var Mt;(function(_e){function ye(Re){return{covered:Re.covered,total:Re.covered}}function me(Re){return"line"in Re?w.from(Re):u.from(Re)}function ie(Re){return"branches"in Re?{count:Re.executionCount,location:me(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&me(Ve.location)})):void 0}:{type:0,count:Re.executionCount,location:me(Re.location)}}_e.fromDetailed=ie;function Ie(Re){return{uri:Re.uri,statement:ye(Re.statementCoverage),branch:Re.branchCoverage&&ye(Re.branchCoverage),function:Re.functionCoverage&&ye(Re.functionCoverage),details:Re.detailedCoverage?.map(ie)}}_e.fromFile=Ie})(Mt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(_e){function ye(me){switch(me){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}_e.to=ye})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(_e){function ye(ie){const Ie=new a.TypeHierarchyItem(U.to(ie.kind),ie.name,ie.detail||"",R.URI.revive(ie.uri),u.to(ie.range),u.to(ie.selectionRange));return Ie._sessionId=ie._sessionId,Ie._itemId=ie._itemId,Ie}_e.to=ye;function me(ie,Ie,Re){if(Ie=Ie??ie._sessionId,Re=Re??ie._itemId,Ie===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Re,kind:U.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),tags:ie.tags?.map(q.from)}}_e.from=me})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[219],we([1,0,2,15,7,14,90]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(R,F,D,p={timeout:1500,errors:3}){this._logService=R,this._documents=F,this._mainThreadBulkEdits=D,this._thresholds=p,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(F,D,p)=>{const g={dispose:this._callbacks.push([F,D,R])};return Array.isArray(p)&&p.push(g),g}}async $participateInSave(R,F){const D=f.URI.revive(R);let p=!1;const b=setTimeout(()=>p=!0,this._thresholds.timeout),g=[];try{for(let h of[...this._callbacks]){if(p)break;const v=this._documents.getDocument(D),A=await this._deliverEventAsyncAndBlameBadListeners(h,{document:v,reason:T.TextDocumentSaveReason.to(F)});g.push(A)}}finally{clearTimeout(b)}return g}_deliverEventAsyncAndBlameBadListeners([R,F,D],p){const b=this._badListeners.get(R);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,R,F,p).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const h=this._badListeners.get(R);this._badListeners.set(R,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,F,D,p){const b=[],g=Date.now(),{document:h,reason:v}=p,{version:A}=h,_=Object.freeze({document:h,reason:v,waitUntil(a){if(Object.isFrozen(b))throw(0,t.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(a))}});try{F.apply(D,[_])}catch(a){return Promise.reject(a)}return Object.freeze(b),new Promise((a,l)=>{const u=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(c=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(u),a(c)}).catch(c=>{clearTimeout(u),l(c)})}).then(a=>{const l={edits:[]};for(const u of a)if(Array.isArray(u)&&u.every(c=>c instanceof I.TextEdit))for(const{newText:c,newEol:w,range:s}of u)l.edits.push({_type:2,resource:h.uri,edit:{range:s&&T.Range.from(s),text:c,eol:w&&T.EndOfLine.from(w)}});if(l.edits.length!==0)return A===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ve[220],we([1,0,10,25,2,14,128]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(D,p,b,g){this.start=D,this.deletedCount=p,this.deletedItems=b,this.items=g}static asApiEvents(D){return D.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(b=>b.apiCell)}))}}class S{constructor(D,p,b){this.notebook=D,this._extHostDocument=p,this._cellData=b,this.handle=b.handle,this.uri=I.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(D,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:D}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return D._mime},set mime(b){D._mime=b},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}})}return this._apiCell}setOutputs(D){this._outputs=D.map(T.NotebookCellOutput.to)}setOutputItems(D,p,b){const g=b.map(T.NotebookCellOutputItem.to),h=this._outputs.find(v=>v.id===D);h&&(p||(h.items.length=0),h.items.push(...g))}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class R{constructor(D,p,b,g,h,v){this._proxy=D,this._textDocumentsAndEditors=p,this._textDocuments=b,this._emitter=g,this.uri=h,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=v.viewType,this._metadata=Object.freeze(v.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,v.cells]],!0),this._versionId=v.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const D=this;this._notebook={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===f.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(p){return p=D._validateIndex(p),D._cells[p].apiCell},getCells(p){return(p?D._getCells(p):D._cells).map(g=>g.apiCell)},save(){return D._save()}}}return this._notebook}updateBackup(D){this._backup?.delete(),this._backup=D}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,p){this._versionId=D.versionId,this._isDirty=p;for(const b of D.rawEvents)b.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===C.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let p=D.start|0,b=D.end|0;return p<0&&(p=0),b>this._cells.length&&(b=this._cells.length),D.with({start:p,end:b})}_getCells(D){D=this._validateRange(D);const p=[];for(let b=D.start;b<D.end;b++)p.push(this._cells[b]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,p){if(this._disposed)return;const b=[],g=[],h=[];D.reverse().forEach(v=>{const _=v[2].map(u=>{const c=new S(this,this._textDocumentsAndEditors,u);return p||g.push(S.asModelAddData(this.apiNotebook,u)),c}),a=new k(v[0],v[1],[],_),l=this._cells.splice(v[0],v[1],..._);for(const u of l)h.push(u.uri),a.deletedItems.push(u.apiCell);b.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:h}),p||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(b)}))}_moveCell(D,p){const b=this._cells.splice(D,1);this._cells.splice(p,0,...b);const g=[new k(D,1,b.map(h=>h.apiCell),[]),new k(p,0,[],b)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(g)}))}_setCellOutputs(D,p){const b=this._cells[D];b.setOutputs(p),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(D,p,b,g){const h=this._cells[D];h.setOutputItems(p,b,g),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_changeCellLanguage(D,p){const b=this._cells[D];b.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(b.uri,p)}_changeCellMime(D,p){const b=this._cells[D];b.apiCell.mime=p}_changeCellMetadata(D,p){const b=this._cells[D],g=b.apiCell.metadata;b.setMetadata(p);const h=b.apiCell.metadata;(0,t.equals)(g,h)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(D,p){this._cells[D].setInternalMetadata(p)}getCellFromApiCell(D){return this._cells.find(p=>p.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(p=>p.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(ve[130],we([1,0,7,14,15]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:R})}replaceCells(S,R,F){this._throwIfFinalized(),!(S===R&&F.length===0)&&this._collectedEdits.push({editType:1,index:S,count:R-S,cells:F.map(t.NotebookCellData.from)})}}class C{constructor(S,R,F,D,p,b){this.id=S,this._proxy=R,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._visibleRanges=D,this._viewColumn=b}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(R){if(!Array.isArray(R)||!R.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");S._selections=R,S._trySetSelections(R)},get visibleRanges(){return S._visibleRanges},revealRange(R,F){S._proxy.$tryRevealRange(S.id,t.NotebookRange.from(R),F??f.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(R){const F=new T(this.document.version);return R(F),S._applyEdit(F.finalize())},setDecorations(R,F){return S.setDecorations(R,F)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(t.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const R=[];let F=-1;for(let D=0;D<S.cellEdits.length;D++){if(F<0){R.push(S.cellEdits[D]),F++;continue}const b=R[F],g=S.cellEdits[D];if(b.editType===1&&g.editType===1&&b.index===g.index){b.cells.push(...S.cellEdits[D].cells),b.count+=S.cellEdits[D].count;continue}R.push(S.cellEdits[D]),F++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,R)}setDecorations(S,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return R.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(R),S.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(ve[221],we([1,0,14,118,168,21,56,15]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(p){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=p}async withProgress(p,b,g){const h=this._handles++,{title:v,location:A,cancellable:_}=b,a={label:(0,I.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this._proxy.$startProgress(h,{location:f.ProgressLocation.from(A),title:v,source:a,cancellable:_},p.isUnderDevelopment?void 0:p.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(h,g,!!_)}_withProgress(p,b,g){let h;g&&(h=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(p,h));const v=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),h&&h.dispose()};let A;try{A=b(new F(this._proxy,p),g&&h?h.token:T.CancellationToken.None)}catch(_){throw v(p),_}return A.then(_=>v(p),_=>v(p)),A}$acceptProgressCanceled(p){const b=this._mapHandleToCancellationSource.get(p);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(p))}}e.ExtHostProgress=S;function R(D,p){return D.message=p.message,typeof p.increment=="number"&&(typeof D.increment=="number"?D.increment+=p.increment:D.increment=p.increment),D}class F extends t.Progress{constructor(p,b){super(g=>this.throttledReport(g));this._proxy=p,this._handle=b}throttledReport(p){this._proxy.$progressReport(this._handle,p)}}Be([(0,C.throttle)(100,(D,p)=>R(D,p),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(ve[131],we([1,0,55,15,75,14,7]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(p,b,g){const h=k._Keys.nextId();p.$registerTextEditorDecorationType(b.identifier,h,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:h,dispose(){p.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class S{constructor(p,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,b){this._throwIfFinalized();let g=null;if(p instanceof C.Position)g=new C.Range(p,p);else if(p instanceof C.Range)g=p;else throw new Error("Unrecognized location");this._pushEdit(g,b,!1)}insert(p,b){this._throwIfFinalized(),this._pushEdit(new C.Range(p,p),b,!0)}delete(p){this._throwIfFinalized();let b=null;if(p instanceof C.Range)b=p;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(p,b,g){const h=this._document.validateRange(p);this._collectedEdits.push({range:h,text:b,forceMoveMarkers:g})}setEndOfLine(p){if(this._throwIfFinalized(),p!==C.EndOfLine.LF&&p!==C.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=p}}e.TextEditorEdit=S;class R{constructor(p,b,g,h){this._proxy=p,this._id=b,this._accept(g),this._logService=h;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(A){v._setTabSize(A)},get insertSpaces(){return v._insertSpaces},set insertSpaces(A){v._setInsertSpaces(A)},get cursorStyle(){return v._cursorStyle},set cursorStyle(A){v._setCursorStyle(A)},get lineNumbers(){return v._lineNumbers},set lineNumbers(A){v._setLineNumbers(A)}}}_accept(p){this._tabSize=p.tabSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const b=Math.floor(p);return b>0?b:null}if(typeof p=="string"){const b=parseInt(p,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(p){const b=this._validateTabSize(p);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:Boolean(p)}_setInsertSpaces(p){const b=this._validateInsertSpaces(p);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(p)})))}assign(p){const b={};let g=!1;if(typeof p.tabSize!="undefined"){const h=this._validateTabSize(p.tabSize);h==="auto"?(g=!0,b.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,g=!0,b.tabSize=h)}if(typeof p.insertSpaces!="undefined"){const h=this._validateInsertSpaces(p.insertSpaces);h==="auto"?(g=!0,b.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,g=!0,b.insertSpaces=h)}typeof p.cursorStyle!="undefined"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,g=!0,b.cursorStyle=p.cursorStyle),typeof p.lineNumbers!="undefined"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,g=!0,b.lineNumbers=T.TextEditorLineNumbersStyle.from(p.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(p,b){b.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=R;class F{constructor(p,b,g,h,v,A,_,a){this.id=p,this._proxy=b,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new R(this._proxy,this.id,A,g),this._visibleRanges=_,this._viewColumn=a;const l=this;this.value=Object.freeze({get document(){return h.getValue()},set document(u){throw(0,t.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(u){if(!(u instanceof C.Selection))throw(0,t.illegalArgument)("selection");l._selections=[u],l._trySetSelection()},get selections(){return l._selections},set selections(u){if(!Array.isArray(u)||u.some(c=>!(c instanceof C.Selection)))throw(0,t.illegalArgument)("selections");l._selections=u,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(u){throw(0,t.readonly)("visibleRanges")},get options(){return l._options.value},set options(u){l._disposed||l._options.assign(u)},get viewColumn(){return l._viewColumn},set viewColumn(u){throw(0,t.readonly)("viewColumn")},edit(u,c={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const w=new S(h.getValue(),c);return u(w),l._applyEdit(w)},insertSnippet(u,c,w={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!c||Array.isArray(c)&&c.length===0)s=l._selections.map(n=>T.Range.from(n));else if(c instanceof C.Position){const{lineNumber:n,column:r}=T.Position.from(c);s=[{startLineNumber:n,startColumn:r,endLineNumber:n,endColumn:r}]}else if(c instanceof C.Range)s=[T.Range.from(c)];else{s=[];for(const n of c)if(n instanceof C.Range)s.push(T.Range.from(n));else{const{lineNumber:r,column:i}=T.Position.from(n);s.push({startLineNumber:r,startColumn:i,endLineNumber:r,endColumn:i})}}return b.$tryInsertSnippet(p,u.value,s,w)},setDecorations(u,c){const w=c.length===0;w&&!l._hasDecorationsForKey.has(u.key)||(w?l._hasDecorationsForKey.delete(u.key):l._hasDecorationsForKey.add(u.key),l._runOnProxy(()=>{if(T.isDecorationOptionsArr(c))return b.$trySetDecorations(p,u.key,T.fromRangeOrRangeWithMessage(c));{const s=new Array(4*c.length);for(let n=0,r=c.length;n<r;n++){const i=c[n];s[4*n]=i.start.line+1,s[4*n+1]=i.start.character+1,s[4*n+2]=i.end.line+1,s[4*n+3]=i.end.character+1}return b.$trySetDecorationsFast(p,u.key,s)}}))},revealRange(u,c){l._runOnProxy(()=>b.$tryRevealRange(p,T.Range.from(u),c||C.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(p,T.ViewColumn.from(u))},hide(){b.$tryHideEditor(p)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,f.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,f.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,f.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,f.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const b=p.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const g=b.edits.map(v=>v.range);g.sort((v,A)=>v.end.line===A.end.line?v.end.character===A.end.character?v.start.line===A.start.line?v.start.character-A.start.character:v.start.line-A.start.line:v.end.character-A.end.character:v.end.line-A.end.line);for(let v=0,A=g.length-1;v<A;v++){const _=g[v].end;if(g[v+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=b.edits.map(v=>({range:T.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,h,{setEndOfLine:typeof b.setEndOfLine=="number"?T.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=F}),define(ve[222],we([1,0,16,3,6,13,62,14,84,85,35]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class D extends I.Disposable{constructor(b){super();this.controllerId=b,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new C.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){const g=this.diff[this.diff.length-1];if(g&&b.op===1){if(g.op===1&&g.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(g.item,b.item);return}if(g.op===0&&g.item.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(g.item,b.item);return}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,g){const h=this.tree.get(b);if(!!h){if((h.expandLevels===void 0||g>h.expandLevels)&&(h.expandLevels=g),h.expand===1){const v=this.resolveChildren(h);return v.isOpen()?this.expandChildren(h,g-1):v.wait().then(()=>this.expandChildren(h,g-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,g-1)):this.expandChildren(h,g-1)}}dispose(){for(const b of this.tree.values())(0,C.getPrivateApiFor)(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,g){switch(g.op){case 2:this.pushDiff({op:4,itemId:b.fullId.toString()});break;case 1:this.removeItem(R.TestId.joinToString(b.fullId,g.id));break;case 0:this.upsertItem(g.item,b);break;case 4:for(const h of g.ops)this.onTestItemEvent(b,h);break;case 3:{const{key:h,value:v,previous:A}=g,_=b.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(b);break;case"tags":this.diffTagRefs(v,A,_);break;case"range":this.pushDiff({op:1,item:{extId:_,item:{range:F.Range.lift(k.Range.from(v))}}});break;case"error":this.pushDiff({op:1,item:{extId:_,item:{error:k.MarkdownString.fromStrict(v)||null}}});break;default:this.pushDiff({op:1,item:{extId:_,item:{[h]:v??null}}});break}break}default:(0,T.assertNever)(g)}}upsertItem(b,g){if(!(b instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${b.id} did not`);const h=R.TestId.fromExtHostTestItem(b,this.root.id,g?.actual),v=(0,C.getPrivateApiFor)(b);v.parent&&v.parent!==g?.actual&&v.parent.children.delete(b.id);let A=this.tree.get(h.toString());if(!A){A={fullId:h,actual:b,parent:g?h.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(A.fullId.toString(),A),this.setItemParent(b,g),this.pushDiff({op:0,item:{parent:A.parent&&A.parent.toString(),controllerId:this.controllerId,expand:A.expand,item:k.TestItem.from(b)}}),this.connectItemAndChildren(b,A,g);return}if(A.actual===b){this.connectItem(b,A,g);return}const _=A.actual.children,a=A.actual,l=(0,C.diffTestItems)(a,b);(0,C.getPrivateApiFor)(a).listener=void 0,A.actual=b,A.expand=0;for(const[u,c]of l)this.onTestItemEvent(A,{op:3,key:u,value:c,previous:a[u]});this.connectItemAndChildren(b,A,g);for(const u of _)b.children.get(u.id)||this.removeItem(R.TestId.joinToString(h,u.id))}diffTagRefs(b,g,h){const v=new Set(g.map(A=>A.id));for(const A of b)v.delete(A.id)||this.incrementTagRefs(A);this.pushDiff({op:1,item:{extId:h,item:{tags:b.map(A=>k.TestTag.namespace(this.controllerId,A.id))}}}),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const g=this.tags.get(b.id);g?g.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:5,tag:{id:k.TestTag.namespace(this.controllerId,b.id),ctrlLabel:this.root.label}}))}decrementTagRefs(b){const g=this.tags.get(b);g&&!--g.refCount&&(this.tags.delete(b),this.pushDiff({op:6,id:(0,S.namespaceTestTag)(this.controllerId,b)}))}setItemParent(b,g){(0,C.getPrivateApiFor)(b).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(b,g,h){this.setItemParent(b,h);const v=(0,C.getPrivateApiFor)(b);v.parent=h?.actual,v.listener=A=>this.onTestItemEvent(g,A),this.updateExpandability(g)}connectItemAndChildren(b,g,h){this.connectItem(b,g,h);for(const v of b.children)this.upsertItem(v,g)}updateExpandability(b){let g;this._resolveHandler?b.resolveBarrier?g=b.resolveBarrier.isOpen()?3:2:g=b.actual.canResolveChildren?1:0:g=0,g!==b.expand&&(b.expand=g,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:g}}),g===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,g){if(g<0)return;const h=[];for(const v of b.actual.children){const A=this.expand(R.TestId.joinToString(b.fullId,v.id),g);(0,f.isThenable)(A)&&h.push(A)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const A=new f.Barrier;return A.open(),A}b.expand=2,this.pushExpandStateUpdate(b);const g=b.resolveBarrier=new f.Barrier,h=A=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),b.actual!==this.root&&(b.actual.error=A.stack||A.message||String(A))};let v;try{v=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(A){h(A)}return(0,f.isThenable)(v)?v.catch(h).then(()=>{g.open(),this.updateExpandability(b)}):(g.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const g=this.tree.get(b);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:b});const h=[g];for(;h.length;){const v=h.pop();if(!!v){(0,C.getPrivateApiFor)(v.actual).listener=void 0;for(const A of v.actual.tags)this.decrementTagRefs(A.id);this.tree.delete(v.fullId.toString());for(const A of v.actual.children)h.push(this.tree.get(R.TestId.joinToString(v.fullId,A.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.SingleUseTestCollection=D}),define(ve[223],we([1,0,4,185]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(t.IEnvironmentService)}),define(ve[224],we([1,0,27,3,9]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=T;class C{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let D of F.activationEvents)D==="onUri"&&(D=`onUri:${f.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(D)||this._activationMap.set(D,[]),this._activationMap.get(D).push(F)}}keepOnly(F){const D=new Set;F.forEach(p=>D.add(f.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>D.has(f.ExtensionIdentifier.toKey(p.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,D){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const p=C._findLoopingExtensions(this._extensionDescriptions);if(D=D.concat(p.map(b=>b.identifier)),D.length>0){const b=new Set;D.forEach(g=>b.add(f.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>!b.has(f.ExtensionIdentifier.toKey(g.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(p)}static _findLoopingExtensions(F){const D=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,A){this.addNode(v),this.addNode(A),this._arcs.has(v)?this._arcs.get(v).push(A):this._arcs.set(v,[A])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,A){const _=D.getArcs(v);for(let a=0;a<_.length;a++)if(!A.has(_[a]))return!1;return!0}getNodes(){return this._nodesArr}};let p=new Map;for(let v of F){const A=f.ExtensionIdentifier.toKey(v.identifier);if(p.set(A,v),v.extensionDependencies)for(let _ of v.extensionDependencies){const a=f.ExtensionIdentifier.toKey(_);D.addArc(A,a)}}let b=new Set;D.getNodes().filter(v=>D.getArcs(v).length===0).forEach(v=>b.add(v));let g=D.getNodes().filter(v=>!b.has(v)),h;do{h=!1;for(let v=0;v<g.length;v++){const A=g[v];D.hasOnlyGoodArcs(A,b)&&(g.splice(v,1),v--,b.add(A),h=!0)}}while(h);return g.map(v=>p.get(v))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const D=this._activationMap.get(F);return D?D.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const D=this._extensionsMap.get(f.ExtensionIdentifier.toKey(F));return D||void 0}}e.ExtensionDescriptionRegistry=C;var k;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(k||(k={}));function S(R,F){const D=R.isBuiltin?0:R.isUnderDevelopment?2:1,p=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(D!==p)return D-p;const b=I.posix.basename(R.extensionLocation.path),g=I.posix.basename(F.extensionLocation.path);return b<g?-1:b>g?1:0}}),define(ve[132],we([1,0,22]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function C(S){const R=f.VSBuffer.alloc(1);switch(S){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=C;function k(S,R){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=k}),define(ve[30],we([1,0,3,2,4,27,122]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(l){l[l.None=0]="None",l[l.LocalProcess=1]="LocalProcess",l[l.LocalWebWorker=2]="LocalWebWorker",l[l.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(l){switch(l){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class R{constructor(u){this.dependency=u}}e.MissingExtensionDependency=R;var F;(function(l){l[l.LocalProcess=0]="LocalProcess",l[l.LocalWebWorker=1]="LocalWebWorker",l[l.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(l){switch(l){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=D;function p(l,u){return l.enabledApiProposals?l.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=p;function b(l,u){if(!p(l,u))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}e.checkProposedApiEnabled=b;class g{constructor(u,c,w,s){this.codeLoadingTime=u,this.activateCallTime=c,this.activateResolvedTime=w,this.activationReason=s}}e.ActivationTimes=g;class h{constructor(u,c){this.description=u,this.value=c}}e.ExtensionPointContribution=h,e.ExtensionHostLogFileName="exthost";var v;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(v=e.ActivationKind||(e.ActivationKind={}));function A(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation}}e.toExtension=A;function _(l,u){return{identifier:new T.ExtensionIdentifier((0,C.getExtensionId)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!u,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid}}e.toExtensionDescription=_;class a{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,c){return Promise.resolve()}}e.NullExtensionService=a}),define(ve[225],we([1,0,15,27,30,11]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class k{constructor(h,v,A,_){this.startup=h,this.codeLoadingTime=v,this.activateCallTime=A,this.activateResolvedTime=_}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,v){return h===-1||v===-1?-1:v-h}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class R{constructor(h,v,A,_,a,l){this.activationFailed=h,this.activationFailedError=v,this.activationTimes=A,this.module=_,this.exports=a,this.subscriptions=l}}e.ActivatedExtension=R;class F extends R{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class D extends R{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class p extends R{constructor(h){super(!0,h,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=p;let b=class{constructor(h,v,A,_,a){this._logService=a,this._isDisposed=!1,this._registry=h,this._resolvedExtensionsSet=new Set,v.forEach(l=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,A.forEach(l=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(l),l)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(h){const v=t.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(v)}getActivatedExtension(h){const v=t.ExtensionIdentifier.toKey(h),A=this._activatedExtensions.get(v);if(!A)throw new Error("Extension `"+h.value+"` is not known or not activated");return A}activateByEvent(h,v){if(this._alreadyActivatedEvents[h])return C;const A=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(A.map(_=>({id:_.identifier,reason:{startup:v,extensionId:_.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,v){const A=this._registry.getExtensionDescription(h);if(!A)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:A.identifier,reason:v}])}_handleActivateRequest(h,v,A){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(h.id))){v[t.ExtensionIdentifier.toKey(h.id)]=h;return}const _=this._registry.getExtensionDescription(h.id);if(!_){const u=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,u,new I.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(h.id),new p(u));return}const a=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let l=!0;for(let u=0,c=a.length;u<c;u++){const w=a[u];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(w)))continue;const s=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(w));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const o=_.displayName||_.identifier.value,m=this._registry.getExtensionDescription(w),d=m&&m.displayName||w,E=new Error(`Cannot activate the '${o}' extension because its dependency '${d}' failed to activate`);E.detail=s.activationFailedError,this._host.onExtensionActivationError(_.identifier,E,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new p(E));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(w))){l=!1,v[t.ExtensionIdentifier.toKey(w)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(w)),reason:h.reason};continue}const n=this._registry.getExtensionDescription(w);if(n){if(!n.main&&!n.browser)continue;l=!1,v[t.ExtensionIdentifier.toKey(w)]={id:n.identifier,reason:h.reason};continue}const r=_.displayName||_.identifier.value,i=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${w}'`);this._host.onExtensionActivationError(_.identifier,i,new I.MissingExtensionDependency(w)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new p(i));return}l?v[t.ExtensionIdentifier.toKey(_.identifier)]=h:A.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(a=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(a.id))),h.length===0))return Promise.resolve(void 0);const v=Object.create(null),A=[];for(let a=0,l=h.length;a<l;a++)this._handleActivateRequest(h[a],v,A);for(let a=0,l=A.length;a<l;a++){const u=t.ExtensionIdentifier.toKey(A[a].id);v[u]&&delete v[u]}const _=Object.keys(v).map(a=>v[a]);return A.length===0?Promise.all(_.map(a=>this._activateExtension(a.id,a.reason))).then(a=>{}):this._activateExtensions(_).then(a=>this._activateExtensions(A))}_activateExtension(h,v){const A=t.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(A))return Promise.resolve(void 0);const _=this._activatingExtensions.get(A);if(_)return _;const a=this._host.actualActivateExtension(h,v).then(void 0,l=>{const u=new Error;return l&&l.name&&(u.name=l.name),l&&l.message?u.message=`Activating extension '${h.value}' failed: ${l.message}.`:u.message=`Activating extension '${h.value}' failed: ${l}.`,l&&l.stack&&(u.stack=l.stack),this._isDisposed&&f.isCancellationError(l)?new p(l):(this._host.onExtensionActivationError(h,u,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(l),new p(l))}).then(l=>{this._activatedExtensions.set(A,l),this._activatingExtensions.delete(A)});return this._activatingExtensions.set(A,a),a}};b=Be([Fe(4,T.ILogService)],b),e.ExtensionsActivator=b}),define(ve[226],we([1,0,11,26,30]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends f.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};T=Be([Fe(0,f.ILoggerService),Fe(1,t.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(ve[227],we([1,0,15]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,C)=>{this._actualOk=T,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,f.onUnexpectedError)(T))}then(T,C){return this._ensureActual().then(T,C)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=t}),define(ve[52],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const t=[];function I(k){const S=new f(k);return t[S.nid]=S,S}e.createProxyIdentifier=I;function T(k){return t[k].sid}e.getStringIdentifierForProxy=T;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(ve[5],we([1,0,58,2,52]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var T;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(_){_[_.Singular=0]="Singular",_[_.Diff=1]="Diff",_[_.SidebySide=2]="SidebySide",_[_.Other=3]="Other"})(C=e.TabKind||(e.TabKind={}));var k;(function(_){_[_.Editable=0]="Editable",_[_.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(_){_[_.Int8Array=1]="Int8Array",_[_.Uint8Array=2]="Uint8Array",_[_.Uint8ClampedArray=3]="Uint8ClampedArray",_[_.Int16Array=4]="Int16Array",_[_.Uint16Array=5]="Uint16Array",_[_.Int32Array=6]="Int32Array",_[_.Uint32Array=7]="Uint32Array",_[_.Float32Array=8]="Float32Array",_[_.Float64Array=9]="Float64Array",_[_.BigInt64Array=10]="BigInt64Array",_[_.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(_){_[_.Text=1]="Text",_[_.Error=2]="Error",_[_.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var D;(function(_){_[_.None=0]="None",_[_.Process=1]="Process",_[_.Output=2]="Output"})(D=e.CandidatePortSource||(e.CandidatePortSource={}));class p{static mixin(a){return a._id=p._n++,a}}e.IdObject=p,p._n=0;var b;(function(_){_.label="a",_.kind="b",_.detail="c",_.documentation="d",_.sortText="e",_.filterText="f",_.preselect="g",_.insertText="h",_.insertTextRules="i",_.range="j",_.commitCharacters="k",_.additionalTextEdits="l",_.command="m",_.kindModifier="n"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(_){_.defaultRanges="a",_.completions="b",_.isIncomplete="c",_.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(_){if(_&&_.edits)for(const a of _.edits)typeof a.resource=="object"?a.resource=t.URI.revive(a.resource):(a.newUri=t.URI.revive(a.newUri),a.oldUri=t.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,f.revive)(a.metadata));return _}e.reviveWorkspaceEditDto=v;var A;(function(_){_[_.Workspace=0]="Workspace",_[_.TextDocument=1]="TextDocument"})(A=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(ve[86],we([1,0,5,3,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,R){return this._proxy.$setPassword(k,S,R)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(ve[64],we([1,0,4,11,5,17]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,R,F){const D=this.getUsageKey(S,R);this._reportedUsages.has(D)||(this._reportedUsages.add(D),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:S}))}getUsageKey(S,R){return`${S}-${R.identifier.value}`}};C=Be([Fe(0,T.IExtHostRpcService),Fe(1,t.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,R){}})}),define(ve[228],we([1,0,3,5,7,27]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,R,F,D={}){const p=T.ExtensionIdentifier.toKey(S.identifier),b=this._inFlightRequests.get(p)||[],g=[...F].sort().join(" ");let h=b.find(v=>v.scopes===g);if(h)return h.result;{const v=this._getSession(S,p,R,F,D);h={scopes:g,result:v},b.push(h),this._inFlightRequests.set(p,b);try{await v}finally{const A=b.findIndex(_=>_.scopes===g);A>-1&&(b.splice(A),this._inFlightRequests.set(p,b))}return v}}async _getSession(S,R,F,D,p={}){await this._proxy.$ensureProvider(F);const b=S.displayName||S.name;return this._proxy.$getSession(F,D,R,b,p)}async removeSession(S,R){const F=this._authenticationProviders.get(S);return F?F.provider.removeSession(R):this._proxy.$removeSession(S,R)}registerAuthenticationProvider(S,R,F,D){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:R,provider:F,options:D??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===S)||this._providers.push({id:S,label:R});const p=F.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(S,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,R,D?.supportsMultipleAccounts??!1),new I.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(S);const b=this._providers.findIndex(g=>g.id===S);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,R){return this._onDidChangeSessions.fire({provider:{id:S,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ve[229],we([1,0,5,17,14]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(k,S){this._proxy=k.getProxy(f.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>S.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k){const S=I.WorkspaceEdit.from(k,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=Be([Fe(0,t.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ve[230],we([1,0,5]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(T){const C=T.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(k){return C.$writeText(k)}})}}e.ExtHostClipboard=t});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[39],we([1,0,13,7,14,25,5,18,11,58,35,48,2,6,4,17,62,22,52,49]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(i,o){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Xe(this,l,i.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=o,this.converter=new c(this,m=>{const d=this._apiCommands.get(m);return d?.result===s.Void?d:void 0},o),this._argumentProcessors=[{processArgument(m){return(0,R.revive)(m)}},{processArgument(m){return(0,T.cloneAndChange)(m,function(d){if(F.Range.isIRange(d))return I.Range.to(d);if(D.Position.isIPosition(d))return I.Position.to(d);if(F.Range.isIRange(d.range)&&p.URI.isUri(d.uri))return I.location.to(d);if(d instanceof A.VSBuffer)return d.buffer.buffer;if(!Array.isArray(d))return d})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const o=this.registerCommand(!1,i.id,async(...m)=>{const d=i.args.map((P,L)=>{if(!P.validate(m[L]))throw new Error(`Invalid argument '${P.name}' when running '${i.id}', received: ${m[L]}`);return P.convert(m[L])}),E=await this.executeCommand(i.internalId,...d);return i.result.convert(E,m,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new t.Disposable(()=>{o.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,o,m,d,E,P){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:m,thisArg:d,description:E,extension:P}),i&&Pe(this,l,"f").$registerCommand(o),new t.Disposable(()=>{this._commands.delete(o)&&i&&Pe(this,l,"f").$unregisterCommand(o)})}executeCommand(i,...o){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,o,!0)}async _doExecuteCommand(i,o,m){if(this._commands.has(i))return this._executeContributedCommand(i,o,!1);{let d=!1;const E=(0,T.cloneAndChange)(o,function(P){if(P instanceof t.Position)return I.Position.from(P);if(P instanceof t.Range)return I.Range.from(P);if(P instanceof t.Location)return I.location.from(P);if(t.NotebookRange.isNotebookRange(P))return I.NotebookRange.from(P);if(P instanceof ArrayBuffer)return d=!0,A.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return d=!0,A.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await Pe(this,l,"f").$executeCommand(i,d?new _.SerializableObjectWithBuffers(E):E,m);return(0,R.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(i,o,!1);throw P}}}async _executeContributedCommand(i,o,m){const d=this._commands.get(i);if(!d)throw new Error("Unknown command");let{callback:E,thisArg:P,description:L}=d;if(L)for(let O=0;O<L.args.length;O++)try{(0,f.validateConstraint)(o[O],L.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${L.args[O].name}' - ${L.args[O].description}`)}try{return await E.apply(P,o)}catch(O){if(i===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...o);y&&(i=y.command)}throw this._logService.error(O,i,d.extension?.identifier),m?new class extends Error{constructor(){super((0,a.toErrorMessage)(O));this.id=i,this.source=d.extension?.displayName??d.extension?.name}}:O}}$executeContributedCommand(i,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(o=o.map(m=>this._argumentProcessors.reduce((d,E)=>E.processArgument(d),m)),this._executeContributedCommand(i,o,!0)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),Pe(this,l,"f").$getCommands().then(o=>(i&&(o=o.filter(m=>m[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[o,m]of this._commands){let{description:d}=m;d&&(i[o]=d)}return Promise.resolve(i)}};l=new WeakMap,u=Be([Fe(0,h.IExtHostRpcService),Fe(1,S.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class c{constructor(i,o,m){this._commands=i,this._lookupApiCommand=o,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,o){if(!i)return;const m={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return m;const d=this._lookupApiCommand(i.command);if(d)m.id=d.internalId,m.arguments=d.args.map((E,P)=>E.convert(i.arguments&&i.arguments[P]));else if((0,k.isNonEmptyArray)(i.arguments)){const E=++this._cachIdPool;this._cache.set(E,i),o.add((0,b.toDisposable)(()=>{this._cache.delete(E),this._logService.trace("CommandsConverter#DISPOSE",E)})),m.$ident=E,m.id=this.delegatingCommandId,m.arguments=[E],this._logService.trace("CommandsConverter#CREATE",i.command,E)}return m}fromInternal(i){return typeof i.$ident=="number"?this._cache.get(i.$ident):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const o=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=c;class w{constructor(i,o,m,d){this.name=i,this.description=o,this.validate=m,this.convert=d}optional(){return new w(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,o){return new w(i??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",r=>p.URI.isUri(r),r=>r),w.Position=new w("position","A position in a text document",r=>t.Position.isPosition(r),I.Position.from),w.Range=new w("range","A range in a text document",r=>t.Range.isRange(r),I.Range.from),w.Selection=new w("selection","A selection in a text document",r=>t.Selection.isSelection(r),I.Selection.from),w.Number=new w("number","",r=>typeof r=="number",r=>r),w.String=new w("string","",r=>typeof r=="string",r=>r),w.CallHierarchyItem=new w("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),w.TypeHierarchyItem=new w("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),w.TestItem=new w("testItem","A VS Code TestItem",r=>r instanceof v.TestItemImpl,I.TestItem.from);class s{constructor(i,o){this.description=i,this.convert=o}}e.ApiCommandResult=s,s.Void=new s("no result",r=>r);class n{constructor(i,o,m,d,E){this.id=i,this.internalId=o,this.description=m,this.args=d,this.result=E}}e.ApiCommand=n}),define(ve[231],we([1,0,2,14,7,78,39,18,111,117,10]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(t.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,v)=>{if((0,k.isFalsyOrEmpty)(h))return;class A extends I.SymbolInformation{static to(a){const l=new A(a.name,t.SymbolKind.to(a.kind),a.containerName||"",new I.Location(v[0],t.Range.to(a.range)));return l.detail=a.detail,l.range=l.location.range,l.selectionRange=t.Range.to(a.selectionRange),l.children=a.children?a.children.map(A.to):[],l}}return h.map(A.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(t.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(t.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(t.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(t.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(t.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(v=>I.Position.isPosition(v)),h=>h.map(t.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(v=>{let A;for(const _ of v.reverse())A=new I.SelectionRange(t.Range.to(_),A);return A}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(t.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:t.Range.to(h.range),placeholder:h.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return t.WorkspaceEdit.to(h)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(t.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new I.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const v=(0,S.decodeSemanticTokensDto)(h);if(v.type==="full")return new I.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new I.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const v=(0,S.decodeSemanticTokensDto)(h);if(v.type==="full")return new I.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,v,A)=>{if(!h)return new I.CompletionList([]);const _=h.suggestions.map(a=>t.CompletionItem.to(a,A));return new I.CompletionList(_,h.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return t.SignatureHelp.to(h)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,v,A)=>b(_=>new I.CodeLens(t.Range.to(_.range),_.command&&A.fromInternal(_.command)))(h))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>I.Range.isRange(h),h=>I.Selection.isSelection(h)?t.Selection.from(h):t.Range.from(h)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,v,A)=>b(_=>{if(_._isSynthetic){if(!_.command)throw new Error("Synthetic code actions must have a command");return A.fromInternal(_.command)}else{const a=new I.CodeAction(_.title,_.kind?new I.CodeActionKind(_.kind):void 0);return _.edit&&(a.edit=t.WorkspaceEdit.to(_.edit)),_.command&&(a.command=A.fromInternal(_.command)),a.isPreferred=_.isPreferred,a}})(h))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(v=>new I.ColorInformation(t.Range.to(v.range),t.Color.to(v.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",h=>h instanceof I.Color,t.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:t.Range.from(h.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(t.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,v,A)=>h.map(t.InlayHint.to.bind(void 0,A)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(v=>t.NotebookExclusiveDocumentPattern.to(v))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(t.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>f.URI.isUri(h)||typeof h=="string"&&(0,R.matchesSomeScheme)(h,F.Schemas.http,F.Schemas.https),h=>h),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[t.ViewColumn.from(h),void 0]:[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[t.ViewColumn.from(h),void 0]:[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class p{static register(v){D.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=p;function b(h){return v=>{if(Array.isArray(v))return v.map(h)}}function g(h){if(!Array.isArray(h))return;const v=[];for(const A of h)T.isLocationLink(A)?v.push(t.DefinitionLink.to(A)):v.push(t.location.to(A));return v}}),define(ve[232],we([1,0,16,56,3,6,2,78,27,14,7,5]),function(te,e,f,t,I,T,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(b,g,h){const v=b.getProxy(D.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const r=this._commentControllers.get(n.handle);return r||n}else if(n&&n.$mid===7){const r=this._commentControllers.get(n.commentControlHandle);if(!r)return n;const i=r.getCommentThread(n.commentThreadHandle);return i||n}else if(n&&n.$mid===8){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const i=r.getCommentThread(n.thread.commentThreadHandle);return i?{thread:i,text:n.text}:n}else if(n&&n.$mid===9){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const i=r.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let o=n.commentUniqueId,m=i.getCommentByUniqueId(o);return m||n}else if(n&&n.$mid===10){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const i=r.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let o=n.text,m=n.commentUniqueId,d=i.getCommentByUniqueId(m);return d?(d.body=o,d):n}return n}})}createCommentController(n,r,i){const o=A.handlePool++,m=new a(n,o,r,i);this._commentControllers.set(m.handle,m);const d=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(n.identifier))||[];return d.push(m),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(n.identifier),d),m.value}$createCommentThreadTemplate(n,r,i){const o=this._commentControllers.get(n);!o||o.$createCommentThreadTemplate(r,i)}async $updateCommentThreadTemplate(n,r,i){const o=this._commentControllers.get(n);!o||o.$updateCommentThreadTemplate(r,i)}$deleteCommentThread(n,r){const i=this._commentControllers.get(n);i&&i.$deleteCommentThread(r)}$provideCommentingRanges(n,r,i){const o=this._commentControllers.get(n);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const m=h.getDocument(C.URI.revive(r));return(0,f.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(m,i)).then(d=>d?d.map(E=>R.Range.from(E)):void 0)}$toggleReaction(n,r,i,o,m){const d=this._commentControllers.get(n);return!d||!d.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const E=d.getCommentThread(r);if(E){const P=E.getCommentByUniqueId(o.uniqueIdInThread);if(d!==void 0&&P&&d.reactionHandler)return d.reactionHandler(P,c(m))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class _{constructor(n,r,i,o,m,d,E){this._commentControllerHandle=r,this._id=i,this._uri=o,this._range=m,this._comments=d,this.extensionDescription=E,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),v.$createCommentThread(r,this.handle,this._id,this._uri,R.Range.from(this._range),E.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=d,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(r,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(L){P.range=L},get comments(){return P.comments},set comments(L){P.comments=L},get collapsibleState(){return P.collapsibleState},set collapsibleState(L){P.collapsibleState=L},get canReply(){return P.canReply},set canReply(L){P.canReply=L},get contextValue(){return P.contextValue},set contextValue(L){P.contextValue=L},get label(){return P.label},set label(L){P.label=L},dispose:()=>{P.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const n=i=>Object.prototype.hasOwnProperty.call(this.modifications,i),r={};n("range")&&(r.range=R.Range.from(this._range)),n("label")&&(r.label=this.label),n("contextValue")&&(r.contextValue=this.contextValue??null),n("comments")&&(r.comments=this._comments.map(i=>l(this,i,this._commentsMap))),n("collapsibleState")&&(r.collapseState=w(this._collapseState)),n("canReply")&&(r.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(n){for(let r of this._commentsMap){let i=r[0],o=r[1];if(n===o)return i}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}_._handlePool=0,Be([(0,t.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(n,r,i,o){this._extension=n,this._handle=r,this._id=i,this._label=o,this._threads=new Map,v.$registerCommentController(this.handle,i,o);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(d){m.options=d},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(d){m.commentingRangeProvider=d},get reactionHandler(){return m.reactionHandler},set reactionHandler(d){m.reactionHandler=d},createCommentThread(d,E,P){return m.createCommentThread(d,E,P).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,v.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,r,i,o){if(typeof n=="string"){const m=new _(this.id,this.handle,n,r,i,o,this._extension);return this._threads.set(m.handle,m),m}else{const m=new _(this.id,this.handle,void 0,n,r,i,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(n,r){const i=new _(this.id,this.handle,void 0,C.URI.revive(n),R.Range.to(r),[],this._extension);return i.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(i.handle,i),i}$updateCommentThreadTemplate(n,r){let i=this._threads.get(n);i&&(i.range=R.Range.to(r))}$deleteCommentThread(n){let r=this._threads.get(n);r&&r.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function l(s,n,r){let i=r.get(n);i||(i=++s.commentHandle,r.set(n,i));const o=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:i,body:typeof n.body=="string"?n.body:R.MarkdownString.from(n.body),userName:n.author.name,userIconPath:o,label:n.label,commentReactions:n.reactions?n.reactions.map(m=>u(m)):void 0,timestamp:n.timestamp?.toJSON()}}function u(s){return{label:s.label,iconPath:s.iconPath?R.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function c(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?C.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function w(s){if(s!==void 0)switch(s){case F.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=p}),define(ve[133],we([1,0,2,5,7,4,17,11,18,8,9]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let D=class Ei{constructor(b,g){this._logService=g,this._provider=new Map,this._proxy=b.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,g){const h=Ei._handlePool++;this._provider.set(h,{provider:b,extensionId:g}),this._proxy.$registerDecorationProvider(h,g.value);const v=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(h,null);return}let _=(0,S.asArray)(A);if(_.length<=Ei._maxEventSize){this._proxy.$onDidChange(h,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",g.value,_.length);const a=_.map(c=>({uri:c,rank:(0,R.count)(c.path,"/")})),l=(0,S.groupBy)(a,(c,w)=>c.rank-w.rank||(0,R.compare)(c.uri.path,w.uri.path));let u=[];e:for(let c of l){let w;for(let s of c){let n=(0,F.dirname)(s.uri.path);if(w!==n&&(w=n,u.push(s.uri)>=Ei._maxEventSize))break e}}this._proxy.$onDidChange(h,u)});return new I.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(b,g,h){if(!this._provider.has(b))return Object.create(null);const v=Object.create(null),{provider:A,extensionId:_}=this._provider.get(b);return await Promise.all(g.map(async a=>{try{const{uri:l,id:u}=a,c=await Promise.resolve(A.provideFileDecoration(f.URI.revive(l),h));if(!c)return;try{I.FileDecoration.validate(c),v[u]=[c.propagate,c.tooltip,c.badge,c.color]}catch(w){this._logService.warn(`INVALID decoration from extension '${_.value}': ${w}`)}}catch(l){this._logService.error(l)}})),v}};D._handlePool=0,D._maxEventSize=250,D=Be([Fe(0,C.IExtHostRpcService),Fe(1,k.ILogService)],D),e.ExtHostDecorations=D,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[233],we([1,0,166,116,2,5,7,14,3,11,24,44]),function(te,e,f,t,I,T,C,k,S,R,F,D){"use strict";var p,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(_,a,l,u,c,w){this._name=_,this._owner=a,this._maxDiagnosticsPerFile=l,p.set(this,void 0),b.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Xe(this,g,new F.ResourceMap(s=>u.getComparisonKey(s)),"f"),Xe(this,p,c,"f"),Xe(this,b,w,"f")}dispose(){this._isDisposed||(Pe(this,b,"f").fire([...Pe(this,g,"f").keys()]),Pe(this,p,"f")&&Pe(this,p,"f").$clear(this._owner),Pe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(_,a){if(!_){this.clear();return}this._checkDisposed();let l=[];if(I.URI.isUri(_)){if(!a){this.delete(_);return}Pe(this,g,"f").set(_,a.slice()),l=[_]}else if(Array.isArray(_)){l=[];let c;_=[..._].sort(h._compareIndexedTuplesByUri);for(const w of _){const[s,n]=w;if((!c||s.toString()!==c.toString())&&(c&&Pe(this,g,"f").get(c).length===0&&Pe(this,g,"f").delete(c),c=s,l.push(s),Pe(this,g,"f").set(s,[])),n){const r=Pe(this,g,"f").get(s);r&&r.push(...n)}else{const r=Pe(this,g,"f").get(s);r&&(r.length=0)}}}if(Pe(this,b,"f").fire(l),!Pe(this,p,"f"))return;const u=[];for(let c of l){let w=[];const s=Pe(this,g,"f").get(c);if(s)if(s.length>this._maxDiagnosticsPerFile){w=[];const n=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let i of s)if(i.severity===n[r]&&w.push(k.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;w.push({severity:t.MarkerSeverity.Info,message:(0,f.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:w[w.length-1].startLineNumber,startColumn:w[w.length-1].startColumn,endLineNumber:w[w.length-1].endLineNumber,endColumn:w[w.length-1].endColumn})}else w=s.map(n=>k.Diagnostic.from(n));u.push([c,w])}Pe(this,p,"f").$changeMany(this._owner,u)}delete(_){this._checkDisposed(),Pe(this,b,"f").fire([_]),Pe(this,g,"f").delete(_),Pe(this,p,"f")&&Pe(this,p,"f").$changeMany(this._owner,[[_,void 0]])}clear(){this._checkDisposed(),Pe(this,b,"f").fire([...Pe(this,g,"f").keys()]),Pe(this,g,"f").clear(),Pe(this,p,"f")&&Pe(this,p,"f").$clear(this._owner)}forEach(_,a){this._checkDisposed();for(let l of Pe(this,g,"f").keys())_.apply(a,[l,this.get(l),this])}get(_){this._checkDisposed();const a=Pe(this,g,"f").get(_);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(_){return this._checkDisposed(),Array.isArray(Pe(this,g,"f").get(_))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(_,a){return _[0].toString()<a[0].toString()?-1:_[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=h,p=new WeakMap,b=new WeakMap,g=new WeakMap;let v=class oi{constructor(_,a,l){this._logService=a,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=_.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(_){const a=new F.ResourceMap;for(const l of _)a.set(l,l);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(_,a){const{_collections:l,_proxy:u,_onDidChangeDiagnostics:c,_logService:w,_fileSystemInfoService:s}=this,n=new class{$changeMany(o,m){u.$changeMany(o,m),w.trace("[DiagnosticCollection] change many (extension, owner, uris)",_.value,o,m.length===0?"CLEARING":m)}$clear(o){u.$clear(o),w.trace("[DiagnosticCollection] remove all (extension, owner)",_.value,o)}dispose(){u.dispose()}};let r;if(!a)a="_generated_diagnostic_collection_name_#"+oi._idPool++,r=a;else if(!l.has(a))r=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do r=a+oi._idPool++;while(l.has(r))}return new class extends h{constructor(){super(a,r,oi._maxDiagnosticsPerFile,s.extUri,n,c);l.set(r,this)}dispose(){super.dispose(),l.delete(r)}}}getDiagnostics(_){if(_)return this._getDiagnostics(_);{const a=new Map,l=[];for(const u of this._collections.values())u.forEach((c,w)=>{let s=a.get(c.toString());typeof s=="undefined"&&(s=l.length,a.set(c.toString(),s),l.push([c,[]])),l[s][1]=l[s][1].concat(...w)});return l}}_getDiagnostics(_){let a=[];for(let l of this._collections.values())l.has(_)&&(a=a.concat(l.get(_)));return a}$acceptMarkersChange(_){if(!this._mirrorCollection){const a="_generated_mirror",l=new h(a,a,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,l),this._mirrorCollection=l}for(const[a,l]of _)this._mirrorCollection.set(I.URI.revive(a),l.map(k.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=Be([Fe(1,R.ILogService),Fe(2,D.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(ve[234],we([1,0,2,5]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(C){this._proxy=C.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(k=>k?k.map(S=>f.URI.revive(S)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(k=>k?f.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(ve[235],we([1,0,15,2,7,5,10,21,8]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(D,p,b){this._documentsAndEditors=p,this._logService=b,this._documentContentProviders=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,p){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=R._handlePool++;this._documentContentProviders.set(b,p),this._proxy.$registerTextContentProvider(b,D);let g;return typeof p.onDidChange=="function"&&(g=p.onDidChange(h=>{if(h.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(b,h).then(v=>{if(!v&&typeof v!="string")return;const A=this._documentsAndEditors.getDocument(h);if(!A)return;const _=(0,S.splitLines)(v);if(!A.equalLines(_))return this._proxy.$onVirtualDocumentChange(h,v)},f.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(D,p){const b=this._documentContentProviders.get(D);return b?Promise.resolve(b.provideTextDocumentContent(t.URI.revive(p),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(ve[236],we([1,0,3,6,2,5,125,14,13,25,7]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(b,g){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const v of h)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const v of h)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const g=this._documentsAndEditors.getDocument(b);if(g)return g}getDocument(b){const g=this.getDocumentData(b);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return g.document}ensureDocumentData(b){const g=this._documentsAndEditors.getDocument(b);if(g)return Promise.resolve(g);let h=this._documentLoader.get(b.toString());return h||(h=this._proxy.$tryOpenDocument(b).then(v=>{this._documentLoader.delete(b.toString());const A=I.URI.revive(v);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(A))},v=>(this._documentLoader.delete(b.toString()),Promise.reject(v))),this._documentLoader.set(b.toString(),h)),h}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(g=>I.URI.revive(g))}$acceptModelLanguageChanged(b,g){const h=I.URI.revive(b),v=this._documentsAndEditors.getDocument(h);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(g),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(b){const g=I.URI.revive(b),h=this._documentsAndEditors.getDocument(g);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(b,g){const h=I.URI.revive(b),v=this._documentsAndEditors.getDocument(h);if(!v)throw new Error("unknown document");v._acceptIsDirty(g),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,g,h){const v=I.URI.revive(b),A=this._documentsAndEditors.getDocument(v);if(!A)throw new Error("unknown document");A._acceptIsDirty(h),A.onEvents(g);let _;g.isUndoing?_=F.TextDocumentChangeReason.Undo:g.isRedoing&&(_=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:A.document,contentChanges:g.changes.map(a=>({range:k.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:_}))}setWordDefinitionFor(b,g){(0,C.setWordDefinitionFor)(b,g)}}e.ExtHostDocuments=D}),define(ve[45],we([1,0,55,3,6,2,4,5,125,17,131,14,11,24,10,76,89]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(l,u){this._extHostRpc=l,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const u=[],c=[],w=[];if(l.removedDocuments)for(const s of l.removedDocuments){const n=T.URI.revive(s),r=this._documents.get(n);r?.unref()&&(this._documents.delete(n),u.push(r.value))}if(l.addedDocuments)for(const s of l.addedDocuments){const n=T.URI.revive(s.uri);let r=this._documents.get(n);if(r&&n.scheme!==g.Schemas.vscodeNotebookCell&&n.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);r||(r=new A(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(n,r),c.push(r.value)),r.ref()}if(l.removedEditors)for(const s of l.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&w.push(n)}if(l.addedEditors)for(const s of l.addedEditors){const n=T.URI.revive(s.documentUri);f.ok(this._documents.has(n),`document '${n}' does not exist`),f.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(n).value,i=new F.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>r.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(o=>D.Range.to(o)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,i)}l.newActiveEditor!==void 0&&(f.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,I.dispose)(u),(0,I.dispose)(w),l.removedDocuments&&this._onDidRemoveDocuments.fire(u),l.addedDocuments&&this._onDidAddDocuments.fire(c),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const u=this._editors.get(this._activeEditorId);return l?u:u?.value}allEditors(){return[...this._editors.values()]}};_=Be([Fe(0,R.IExtHostRpcService),Fe(1,p.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[53],we([1,0,14,5,2,3,4,17]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");let S=class{constructor(F){this._onDidChangeTabGroup=new T.Emitter,this.onDidChangeTabGroup=this._onDidChangeTabGroup.event,this._tabGroups={all:[],onDidChangeTabGroup:this._onDidChangeTabGroup.event},this._proxy=F.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){return this._tabGroups}$acceptEditorTabModel(F){this._tabGroups.all.length=0;for(const D of F){let p;const b=D.tabs.map(g=>{const h=this.createExtHostTabObject(g);return g.isActive&&(p=h),h});this._tabGroups.all.push(Object.freeze({isActive:D.isActive,viewColumn:f.ViewColumn.to(D.viewColumn),activeTab:p,tabs:b}))}this._onDidChangeTabGroup.fire()}createExtHostTabObject(F){return Object.freeze({label:F.label,viewColumn:f.ViewColumn.to(F.viewColumn),resource:I.URI.revive(F.resource),additionalResourcesAndViewIds:F.additionalResourcesAndViewIds.map(({resource:D,viewId:p})=>({resource:I.URI.revive(D),viewId:p})),viewId:F.editorId,isActive:F.isActive,kind:F.kind,isDirty:F.isDirty,isPinned:F.isPinned,move:async(D,p)=>{this._proxy.$moveTab(F,D,f.ViewColumn.from(p))},close:async()=>{await this._proxy.$closeTab(F)}})}};S=Be([Fe(0,k.IExtHostRpcService)],S),e.ExtHostEditorTabs=S}),define(ve[237],we([1,0,2,5,6,7,14,150,8,22,30]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const h=this._schemes.indexOf(g);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),h=[];let v,A,_=14,a=14;for(const l of g){let u=v?(0,S.commonPrefixLength)(v,l):0;for(u===0?A=1:A=a;u<l.length;u++)u+1===l.length?(_=a,a=9):a+=1,h.push([A,l.toUpperCase().charCodeAt(u),a]),h.push([A,l.toLowerCase().charCodeAt(u),a]),A=a;v=l,a=_}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new k.StateMachine(h)}}provideDocumentLinks(g){this._initStateMachine();const h=[],v=k.LinkComputer.computeLinks({getLineContent(A){return g.lineAt(A-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const A of v){const _=C.DocumentLink.to(A);_.target&&h.push(_)}return h}}class p{constructor(g,h){this._extHostLanguageFeatures=h,this._linkProvider=new D,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,h,v,A={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const _=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(_,v);let a=2;A.isCaseSensitive&&(a+=1024),A.isReadonly&&(a+=2048),typeof v.copy=="function"&&(a+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,F.checkProposedApiEnabled)(g,"fsChunks"),a+=4),this._proxy.$registerFileSystemProvider(_,h,a).catch(u=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${h}`),console.error(u)});const l=v.onDidChangeFile(u=>{const c=[];for(const w of u){let{uri:s,type:n}=w;if(s.scheme!==h)continue;let r;switch(n){case T.FileChangeType.Changed:r=0;break;case T.FileChangeType.Created:r=1;break;case T.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:s,type:r})}this._proxy.$onFileSystemChange(_,c)});return(0,I.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(g){const{type:h,ctime:v,mtime:A,size:_,permissions:a}=g;return{type:h,ctime:v,mtime:A,size:_,permissions:a}}$stat(g,h){return Promise.resolve(this._getFsProvider(g).stat(f.URI.revive(h))).then(v=>p._asIStat(v))}$readdir(g,h){return Promise.resolve(this._getFsProvider(g).readDirectory(f.URI.revive(h)))}$readFile(g,h){return Promise.resolve(this._getFsProvider(g).readFile(f.URI.revive(h))).then(v=>R.VSBuffer.wrap(v))}$writeFile(g,h,v,A){return Promise.resolve(this._getFsProvider(g).writeFile(f.URI.revive(h),v.buffer,A))}$delete(g,h,v){return Promise.resolve(this._getFsProvider(g).delete(f.URI.revive(h),v))}$rename(g,h,v,A){return Promise.resolve(this._getFsProvider(g).rename(f.URI.revive(h),f.URI.revive(v),A))}$copy(g,h,v,A){const _=this._getFsProvider(g);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(f.URI.revive(h),f.URI.revive(v),A))}$mkdir(g,h){return Promise.resolve(this._getFsProvider(g).createDirectory(f.URI.revive(h)))}$watch(g,h,v,A){const _=this._getFsProvider(g).watch(f.URI.revive(v),A);this._watches.set(h,_)}$unwatch(g,h){const v=this._watches.get(h);v&&(v.dispose(),this._watches.delete(h))}$open(g,h,v){const A=this._getFsProvider(g);if(!A.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(A.open(f.URI.revive(h),v))}$close(g,h){const v=this._getFsProvider(g);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(h))}$read(g,h,v,A){const _=this._getFsProvider(g);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const a=R.VSBuffer.alloc(A);return Promise.resolve(_.read(h,v,a.buffer,0,A)).then(l=>a.slice(0,l))}$write(g,h,v,A){const _=this._getFsProvider(g);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(h,v,A.buffer,0,A.byteLength))}_getFsProvider(g){const h=this._fsProvider.get(g);if(!h){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return h}}e.ExtHostFileSystem=p}),define(ve[65],we([1,0,5,42,7,22,4,17,44,6]),function(te,e,f,t,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class jt{constructor(p,b){this._fileSystemProvider=new Map,this._proxy=p.getProxy(f.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(h){try{const v=g._fileSystemProvider.get(h.scheme);if(!v)return await g._proxy.$stat(h);await g._proxy.$ensureActivation(h.scheme);const A=await v.stat(h);return{type:A.type,ctime:A.ctime,mtime:A.mtime,size:A.size,permissions:A.permissions}}catch(v){jt._handleError(v)}},async readDirectory(h){try{const v=g._fileSystemProvider.get(h.scheme);return v?(await g._proxy.$ensureActivation(h.scheme),(await v.readDirectory(h)).slice()):await g._proxy.$readdir(h)}catch(v){return jt._handleError(v)}},async createDirectory(h){try{return await g._proxy.$mkdir(h)}catch(v){return jt._handleError(v)}},async readFile(h){try{const v=g._fileSystemProvider.get(h.scheme);return v?(await g._proxy.$ensureActivation(h.scheme),(await v.readFile(h)).slice()):(await g._proxy.$readFile(h)).buffer}catch(v){return jt._handleError(v)}},async writeFile(h,v){try{return await g._proxy.$writeFile(h,T.VSBuffer.wrap(v))}catch(A){return jt._handleError(A)}},async delete(h,v){try{const A=g._fileSystemProvider.get(h.scheme);return A?(await g._proxy.$ensureActivation(h.scheme),await A.delete(h,{recursive:!1,...v})):await g._proxy.$delete(h,{recursive:!1,useTrash:!1,...v})}catch(A){return jt._handleError(A)}},async rename(h,v,A){try{return await g._proxy.$rename(h,v,{overwrite:!1,...A})}catch(_){return jt._handleError(_)}},async copy(h,v,A){try{return await g._proxy.$copy(h,v,{overwrite:!1,...A})}catch(_){return jt._handleError(_)}},isWritableFileSystem(h){const v=b.getCapabilities(h);if(typeof v=="number")return!(v&2048)}})}static _handleError(p){if(p instanceof I.FileSystemError)throw p;if(!(p instanceof Error))throw new I.FileSystemError(String(p));if(p.name==="ENOPRO")throw I.FileSystemError.Unavailable(p.message);switch(p.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(p.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(p.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(p.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(p.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(p.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(p.message);default:throw new I.FileSystemError(p.message,p.name)}}addFileSystemProvider(p,b){return this._fileSystemProvider.set(p,b),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(p))}};F=Be([Fe(0,k.IExtHostRpcService),Fe(1,S.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[238],we([1,0,3,32,2,5,14,7]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(D,p,b,g,h,v,A,_){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter;const a=this.ensureWatching(D,b,h);this._config=0,v&&(this._config+=1),A&&(this._config+=2),_&&(this._config+=4);const l=(0,t.parse)(h),u=typeof h=="string",c=g(w=>{if(!v)for(let s of w.created){const n=I.URI.revive(s);l(n.fsPath)&&(!u||p.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!A)for(let s of w.changed){const n=I.URI.revive(s);l(n.fsPath)&&(!u||p.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!_)for(let s of w.deleted){const n=I.URI.revive(s);l(n.fsPath)&&(!u||p.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=k.Disposable.from(a,this._onDidCreate,this._onDidChange,this._onDidDelete,c)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(D,p,b){let g=k.Disposable.from();if(typeof b=="string")return g;const h=D.getProxy(T.MainContext.MainThreadFileSystem);let v=!1;(b.pattern.includes(t.GLOBSTAR)||b.pattern.includes(t.GLOB_SPLIT))&&(v=!0);const A=Math.random();return h.$watch(p.identifier.value,A,b.baseUri,{recursive:v,excludes:[]}),k.Disposable.from({dispose:()=>h.$unwatch(A)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(D,p,b){this._mainContext=D,this._logService=p,this._extHostDocumentsAndEditors=b,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(D,p,b,g,h,v){return new S(this._mainContext,D,p,this._onFileSystemEvent.event,C.GlobPattern.from(b),g,h,v)}$onFileEvent(D){this._onFileSystemEvent.fire(D)}$onDidRunFileOperation(D,p){switch(D){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(b=>({oldUri:I.URI.revive(b.source),newUri:I.URI.revive(b.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(b=>I.URI.revive(b.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:p.map(b=>I.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this._createWillExecuteEvent(D,this._onWillRenameFile)}getOnWillCreateFileEvent(D){return this._createWillExecuteEvent(D,this._onWillCreateFile)}getOnWillDeleteFileEvent(D){return this._createWillExecuteEvent(D,this._onWillDeleteFile)}_createWillExecuteEvent(D,p){return(b,g,h)=>{const v=function(_){b.call(g,_)};return v.extension=D,p.event(v,void 0,h)}}async $onWillRunFileOperation(D,p,b,g){switch(D){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(h=>({oldUri:I.URI.revive(h.source),newUri:I.URI.revive(h.target)}))},b,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(h=>I.URI.revive(h.target))},b,g);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(h=>I.URI.revive(h.target))},b,g)}}async _fireWillEvent(D,p,b,g){const h=new Set,v=[];if(await D.fireAsync(p,g,async(_,a)=>{const l=Date.now(),u=await Promise.resolve(_);u instanceof k.WorkspaceEdit&&(v.push(u),h.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-l>b&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),g.isCancellationRequested||v.length===0)return;const A={edits:[]};for(let _ of v){let{edits:a}=C.WorkspaceEdit.from(_,{getTextDocumentVersion:l=>this._extHostDocumentsAndEditors.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});A.edits=A.edits.concat(a)}return{edit:A,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=R}),define(ve[239],we([1,0,2,39]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(C,k,S,R){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=R;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",D=>!0,D=>D),new t.ApiCommandArgument("resource","Interactive resource Uri",D=>!0,D=>D),new t.ApiCommandArgument("controllerId","Notebook controller Id",D=>!0,D=>D),new t.ApiCommandArgument("title","Interactive editor title",D=>!0,D=>D)],new t.ApiCommandResult("Notebook and input URI",D=>{if(D.notebookEditorId!==void 0){const p=this._extHostNotebooks.getEditorById(D.notebookEditorId);return{notebookUri:f.URI.revive(D.notebookUri),inputUri:f.URI.revive(D.inputUri),notebookEditor:p.apiEditor}}return{notebookUri:f.URI.revive(D.notebookUri),inputUri:f.URI.revive(D.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(C,k,S,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=I}),define(ve[240],we([1,0,6,5]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(C){this._handlePool=0,this._proxy=C.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,C),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(ve[241],we([1,0,2,25,14,7,5,8,35,18,13,146,21,6,111,75,82,46,15,3,16]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentSymbols(z,B){const N=this._documents.getDocument(z),W=await this._provider.provideDocumentSymbols(N,B);if(!(0,R.isFalsyOrEmpty)(W))return W[0]instanceof T.DocumentSymbol?W.map(I.DocumentSymbol.from):u._asDocumentSymbolTree(W)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((W,V)=>{let re=W.location.range.start.compareTo(V.location.range.start);return re===0&&(re=V.location.range.end.compareTo(W.location.range.end)),re});const B=[],N=[];for(const W of z){const V={name:W.name||"!!MISSING: name!!",kind:I.SymbolKind.from(W.kind),tags:W.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:I.Range.from(W.location.range),selectionRange:I.Range.from(W.location.range),children:[]};for(;;){if(N.length===0){N.push(V),B.push(V);break}const re=N[N.length-1];if(S.Range.containsRange(re.range,V.range)&&!S.Range.equalsRange(re.range,V.range)){re.children&&re.children.push(V),N.push(V);break}N.pop()}}return B}}class c{constructor(z,B,N){this._documents=z,this._commands=B,this._provider=N,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,B){const N=this._documents.getDocument(z),W=await this._provider.provideCodeLenses(N,B);if(!W||B.isCancellationRequested)return;const V=this._cache.add(W),re=new b.DisposableStore;this._disposables.set(V,re);const he={cacheId:V,lenses:[]};for(let Ce=0;Ce<W.length;Ce++)he.lenses.push({cacheId:[V,Ce],range:I.Range.from(W[Ce].range),command:this._commands.toInternal(W[Ce].command,re)});return he}async resolveCodeLens(z,B){const N=z.cacheId&&this._cache.get(...z.cacheId);if(!N)return;let W;if(typeof this._provider.resolveCodeLens!="function"||N.isResolved?W=N:W=await this._provider.resolveCodeLens(N,B),W||(W=N),B.isCancellationRequested)return;const V=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!V)return z.command=this._commands.toInternal(W.command??c._badCmd,V),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function w(Ee){return Array.isArray(Ee)?Ee.map(I.DefinitionLink.from):Ee?[I.DefinitionLink.from(Ee)]:[]}class s{constructor(z,B){this._documents=z,this._provider=B}async provideDefinition(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideDefinition(W,V,N);return w(re)}}class n{constructor(z,B){this._documents=z,this._provider=B}async provideDeclaration(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideDeclaration(W,V,N);return w(re)}}class r{constructor(z,B){this._documents=z,this._provider=B}async provideImplementation(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideImplementation(W,V,N);return w(re)}}class i{constructor(z,B){this._documents=z,this._provider=B}async provideTypeDefinition(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideTypeDefinition(W,V,N);return w(re)}}class o{constructor(z,B){this._documents=z,this._provider=B}async provideHover(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideHover(W,V,N);if(!(!re||(0,R.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=W.getWordRangeAtPosition(V)),re.range||(re.range=new T.Range(V,V)),I.Hover.from(re)}}class m{constructor(z,B){this._documents=z,this._provider=B}async provideEvaluatableExpression(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideEvaluatableExpression(W,V,N);if(re)return I.EvaluatableExpression.from(re)}}class d{constructor(z,B){this._documents=z,this._provider=B}async provideInlineValues(z,B,N,W){const V=this._documents.getDocument(z),re=await this._provider.provideInlineValues(V,I.Range.to(B),I.InlineValueContext.to(N),W);if(Array.isArray(re))return re.map(he=>I.InlineValue.from(he))}}class E{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentHighlights(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideDocumentHighlights(W,V,N);if(Array.isArray(re))return re.map(I.DocumentHighlight.from)}}class P{constructor(z,B){this._documents=z,this._provider=B}async provideLinkedEditingRanges(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideLinkedEditingRanges(W,V,N);if(re&&Array.isArray(re.ranges))return{ranges:(0,R.coalesce)(re.ranges.map(I.Range.from)),wordPattern:re.wordPattern}}}class L{constructor(z,B){this._documents=z,this._provider=B}async provideReferences(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B),he=await this._provider.provideReferences(V,re,N,W);if(Array.isArray(he))return he.map(I.location.from)}}class O{constructor(z,B,N,W,V,re,he){this._documents=z,this._commands=B,this._diagnostics=N,this._provider=W,this._logService=V,this._extension=re,this._apiDeprecation=he,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,B,N,W){const V=this._documents.getDocument(z),re=D.Selection.isISelection(B)?I.Selection.to(B):I.Range.to(B),he=[];for(const He of this._diagnostics.getDiagnostics(z))if(re.intersection(He.range)&&he.push(He)>O._maxCodeActionsPerFile)break;const Ce={diagnostics:he,only:N.only?new T.CodeActionKind(N.only):void 0,triggerKind:I.CodeActionTriggerKind.to(N.trigger)},Ae=await this._provider.provideCodeActions(V,re,Ce,W);if(!(0,R.isNonEmptyArray)(Ae)||W.isCancellationRequested)return;const We=this._cache.add(Ae),ze=new b.DisposableStore;this._disposables.set(We,ze);const qe=[];for(let He=0;He<Ae.length;He++){const Ue=Ae[He];!Ue||(O._isCommand(Ue)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Ue.title,command:this._commands.toInternal(Ue,ze)})):(Ce.only&&(Ue.kind?Ce.only.contains(Ue.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Ue.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[We,He],title:Ue.title,command:Ue.command&&this._commands.toInternal(Ue.command,ze),diagnostics:Ue.diagnostics&&Ue.diagnostics.map(I.Diagnostic.from),edit:Ue.edit&&I.WorkspaceEdit.from(Ue.edit),kind:Ue.kind&&Ue.kind.value,isPreferred:Ue.isPreferred,disabled:Ue.disabled?.reason})))}return{cacheId:We,actions:qe}}async resolveCodeAction(z,B){const[N,W]=z,V=this._cache.get(N,W);if(!V||O._isCommand(V)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(V,B)??V;return re?.edit?I.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}O._maxCodeActionsPerFile=1e3;class y{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentFormattingEdits(z,B,N){const W=this._documents.getDocument(z),V=await this._provider.provideDocumentFormattingEdits(W,B,N);if(Array.isArray(V))return V.map(I.TextEdit.from)}}class H{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentRangeFormattingEdits(z,B,N,W){const V=this._documents.getDocument(z),re=I.Range.to(B),he=await this._provider.provideDocumentRangeFormattingEdits(V,re,N,W);if(Array.isArray(he))return he.map(I.TextEdit.from)}}class M{constructor(z,B){this._documents=z,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,B,N,W,V){const re=this._documents.getDocument(z),he=I.Position.to(B),Ce=await this._provider.provideOnTypeFormattingEdits(re,he,N,W,V);if(Array.isArray(Ce))return Ce.map(I.TextEdit.from)}}class j{constructor(z,B){this._provider=z,this._logService=B,this._cache=new v.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(z,B){const N=await this._provider.provideWorkspaceSymbols(z,B);if(!(0,R.isNonEmptyArray)(N))return{symbols:[]};const W=this._cache.add(N),V={cacheId:W,symbols:[]};for(let re=0;re<N.length;re++){const he=N[re];if(!he||!he.name){this._logService.warn("INVALID SymbolInformation",he);continue}V.symbols.push({...I.WorkspaceSymbol.from(he),cacheId:[W,re]})}return V}async resolveWorkspaceSymbol(z,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const N=this._cache.get(...z.cacheId);if(N){const W=await this._provider.resolveWorkspaceSymbol(N,B);return W&&(0,t.mixin)(z,I.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols(z){this._cache.delete(z)}}class Q{constructor(z,B,N){this._documents=z,this._provider=B,this._logService=N}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B);try{const he=await this._provider.provideRenameEdits(V,re,N,W);return he?I.WorkspaceEdit.from(he):void 0}catch(he){const Ce=Q._asMessage(he);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(z,B,N){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const W=this._documents.getDocument(z),V=I.Position.to(B);try{const re=await this._provider.prepareRename(W,V,N);let he,Ce;if(T.Range.isRange(re)?(he=re,Ce=W.getText(re)):(0,F.isObject)(re)&&(he=re.range,Ce=re.placeholder),!he||!Ce)return;if(he.start.line>V.line||he.end.line<V.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(he),text:Ce}}catch(re){const he=Q._asMessage(re);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,B){this.resultId=z,this.tokens=B}}class U{constructor(z,B){this._documents=z,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,B,N){const W=this._documents.getDocument(z),V=B!==0?this._previousResults.get(B):null;let re=typeof V?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(W,V.resultId,N):await this._provider.provideDocumentSemanticTokens(W,N);return V&&this._previousResults.delete(B),re?(re=U._fixProvidedSemanticTokens(re),this._send(U._convertToEdits(V,re),re)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new T.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new T.SemanticTokensEdits(z.edits.map(B=>new T.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const B of z.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,B){if(!U._isSemanticTokens(B)||!z||!z.tokens)return B;const N=z.tokens,W=N.length,V=B.data,re=V.length;let he=0;const Ce=Math.min(W,re);for(;he<Ce&&N[he]===V[he];)he++;if(he===W&&he===re)return new T.SemanticTokensEdits([],B.resultId);let Ae=0;const We=Ce-he;for(;Ae<We&&N[W-Ae-1]===V[re-Ae-1];)Ae++;return new T.SemanticTokensEdits([{start:he,deleteCount:W-he-Ae,data:V.subarray(he,re-Ae)}],B.resultId)}_send(z,B){if(U._isSemanticTokens(z)){const N=this._nextResultId++;return this._previousResults.set(N,new $(z.resultId,z.data)),(0,g.encodeSemanticTokensDto)({id:N,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const N=this._nextResultId++;return U._isSemanticTokens(B)?this._previousResults.set(N,new $(B.resultId,B.data)):this._previousResults.set(N,new $(z.resultId)),(0,g.encodeSemanticTokensDto)({id:N,type:"delta",deltas:(z.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class q{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentRangeSemanticTokens(z,B,N){const W=this._documents.getDocument(z),V=await this._provider.provideDocumentRangeSemanticTokens(W,I.Range.to(B),N);return V?this._send(V):null}_send(z){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=q;class K{constructor(z,B,N,W,V){this._documents=z,this._commands=B,this._provider=N,this._apiDeprecation=W,this._extension=V,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B),he=V.getWordRangeAtPosition(re)||new T.Range(re,re),Ce=he.with({end:re}),Ae=new A.StopWatch(!0),We=await this._provider.provideCompletionItems(V,re,W,I.CompletionContext.to(N));if(!We||W.isCancellationRequested)return;const ze=Array.isArray(We)?new T.CompletionList(We):We,qe=K.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),He=new b.DisposableStore;this._disposables.set(qe,He);const Ue=[],Je={x:qe,b:Ue,a:{replace:I.Range.from(he),insert:I.Range.from(Ce)},c:ze.isIncomplete||void 0,d:Ae.elapsed()};for(let et=0;et<ze.items.length;et++){const Le=ze.items[et],it=this._convertCompletionItem(Le,[qe,et],Ce,he);Ue.push(it)}return Je}async resolveCompletionItem(z,B){if(typeof this._provider.resolveCompletionItem!="function")return;const N=this._cache.get(...z);if(!N)return;const W=await this._provider.resolveCompletionItem(N,B);if(!!W)return this._convertCompletionItem(W,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,B,N,W){const V=this._disposables.get(B[0]);if(!V)throw Error("DisposableStore is missing...");const re={x:B,a:z.label,b:z.kind!==void 0?I.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(I.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(z.command,V)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=z.textEdit.newText):typeof z.insertText=="string"?re.h=z.insertText:z.insertText instanceof T.SnippetString&&(re.h=z.insertText.value,re.i|=4);let he;return z.textEdit?he=z.textEdit.range:z.range&&(he=z.range),T.Range.isRange(he)?re.j=I.Range.from(he):he&&(!N?.isEqual(he.inserting)||!W?.isEqual(he.replacing))&&(re.j={insert:I.Range.from(he.inserting),replace:I.Range.from(he.replacing)}),re}}class G{constructor(z,B,N){this._documents=z,this._provider=B,this._commands=N,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B),he=await this._provider.provideInlineCompletionItems(V,re,{selectedCompletionInfo:N.selectedSuggestionInfo?{range:I.Range.to(N.selectedSuggestionInfo.range),text:N.selectedSuggestionInfo.text,isSnippetText:N.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(N.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:N.triggerKind},W);if(!he||W.isCancellationRequested)return;const Ce=(0,F.isArray)(he)?he:he.items,Ae=this._cache.add(Ce);let We;return{pid:Ae,items:Ce.map((ze,qe)=>{let He;ze.command&&(We||(We=new b.DisposableStore,this._disposables.set(Ae,We)),He=this._commands.toInternal(ze.command,We));const Ue=ze.insertText??ze.text;if(Ue===void 0)throw new Error("text or insertText must be defined");return{text:Ue,range:ze.range?I.Range.from(ze.range):void 0,command:He,idx:qe,completeBracketPairs:ze.completeBracketPairs}})}}disposeCompletions(z){this._cache.delete(z);const B=this._disposables.get(z);B&&B.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,B){const N=this._cache.get(z,B);N&&ee.get(this._provider).fireOnDidShowCompletionItem({completionItem:N})}}class ee{constructor(){this._onDidShowCompletionItemEmitter=new a.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let B=ee.map.get(z);return B||(B=new ee,ee.map.set(z,B)),B}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=ee,ee.map=new WeakMap;class oe{constructor(z,B){this._documents=z,this._provider=B,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B),he=this.reviveContext(N),Ce=await this._provider.provideSignatureHelp(V,re,W,he);if(Ce){const Ae=this._cache.add([Ce]);return{...I.SignatureHelp.from(Ce),id:Ae}}}reviveContext(z){let B;if(z.activeSignatureHelp){const N=I.SignatureHelp.to(z.activeSignatureHelp),W=this._cache.get(z.activeSignatureHelp.id,0);W?(B=W,B.activeSignature=N.activeSignature,B.activeParameter=N.activeParameter):B=N}return{...z,activeSignatureHelp:B}}releaseSignatureHelp(z){this._cache.delete(z)}}class ue{constructor(z,B,N,W,V){this._documents=z,this._commands=B,this._provider=N,this._logService=W,this._extension=V,this._cache=new v.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(z,B,N){const W=this._documents.getDocument(z),V=I.Range.to(B),re=await this._provider.provideInlayHints(W,V,N);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(N.isCancellationRequested)return;const he=this._cache.add(re);this._disposables.set(he,new b.DisposableStore);const Ce={hints:[],cacheId:he};for(let Ae=0;Ae<re.length;Ae++)this._isValidInlayHint(re[Ae],V)&&Ce.hints.push(this._convertInlayHint(re[Ae],[he,Ae]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),Ce}async resolveInlayHint(z,B){if(typeof this._provider.resolveInlayHint!="function")return;const N=this._cache.get(...z);if(!N)return;const W=await this._provider.resolveInlayHint(N,B);if(!!W&&!!this._isValidInlayHint(W))return this._convertInlayHint(W,z)}releaseHints(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_isValidInlayHint(z,B){return z.label.length===0||Array.isArray(z.label)&&z.label.every(N=>N.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(B&&!B.contains(z.position))}_convertInlayHint(z,B){const N=this._disposables.get(B[0]);if(!N)throw Error("DisposableStore is missing...");const W={label:"",cacheId:B,tooltip:I.MarkdownString.fromStrict(z.tooltip),position:I.Position.from(z.position),kind:z.kind&&I.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?W.label=z.label:W.label=z.label.map(V=>{let re={label:V.value};return re.tooltip=I.MarkdownString.fromStrict(V.tooltip),T.Location.isLocation(V.location)&&(re.location=I.location.from(V.location)),V.command&&(re.command=this._commands.toInternal(V.command,N)),re}),W}}class Z{constructor(z,B){this._documents=z,this._provider=B,this._cache=new v.Cache("DocumentLink")}async provideLinks(z,B){const N=this._documents.getDocument(z),W=await this._provider.provideDocumentLinks(N,B);if(!(!Array.isArray(W)||W.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:W.filter(Z._validateLink).map(I.DocumentLink.from)};{const V=this._cache.add(W),re={links:[],cacheId:V};for(let he=0;he<W.length;he++){if(!Z._validateLink(W[he]))continue;const Ce=I.DocumentLink.from(W[he]);Ce.cacheId=[V,he],re.links.push(Ce)}return re}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,B){if(typeof this._provider.resolveDocumentLink!="function")return;const N=this._cache.get(...z);if(!N)return;const W=await this._provider.resolveDocumentLink(N,B);if(!(!W||!Z._validateLink(W)))return I.DocumentLink.from(W)}releaseLinks(z){this._cache.delete(z)}}class Y{constructor(z,B){this._documents=z,this._provider=B}async provideColors(z,B){const N=this._documents.getDocument(z),W=await this._provider.provideDocumentColors(N,B);return Array.isArray(W)?W.map(re=>({color:I.Color.from(re.color),range:I.Range.from(re.range)})):[]}async provideColorPresentations(z,B,N){const W=this._documents.getDocument(z),V=I.Range.to(B.range),re=I.Color.to(B.color),he=await this._provider.provideColorPresentations(re,{document:W,range:V},N);if(!!Array.isArray(he))return he.map(I.ColorPresentation.from)}}class se{constructor(z,B){this._documents=z,this._provider=B}async provideFoldingRanges(z,B,N){const W=this._documents.getDocument(z),V=await this._provider.provideFoldingRanges(W,B,N);if(!!Array.isArray(V))return V.map(I.FoldingRange.from)}}class de{constructor(z,B,N){this._documents=z,this._provider=B,this._logService=N}async provideSelectionRanges(z,B,N){const W=this._documents.getDocument(z),V=B.map(I.Position.to),re=await this._provider.provideSelectionRanges(W,V,N);if(!(0,R.isNonEmptyArray)(re))return[];if(re.length!==V.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ce=0;Ce<V.length;Ce++){const Ae=[];he.push(Ae);let We=V[Ce],ze=re[Ce];for(;;){if(!ze.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ae.push(I.SelectionRange.from(ze)),!ze.parent)break;We=ze.range,ze=ze.parent}}return he}}class ge{constructor(z,B){this._documents=z,this._provider=B,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.prepareCallHierarchy(W,V,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideCallsTo(z,B,N){const W=this._itemFromCache(z,B);if(!W)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyIncomingCalls(W,N);if(!!V)return V.map(re=>({from:this._cacheAndConvertItem(z,re.from),fromRanges:re.fromRanges.map(he=>I.Range.from(he))}))}async provideCallsFrom(z,B,N){const W=this._itemFromCache(z,B);if(!W)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyOutgoingCalls(W,N);if(!!V)return V.map(re=>({to:this._cacheAndConvertItem(z,re.to),fromRanges:re.fromRanges.map(he=>I.Range.from(he))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,B){const N=this._cache.get(z),W=I.CallHierarchyItem.from(B,z,N.size.toString(36));return N.set(W._itemId,B),W}_itemFromCache(z,B){return this._cache.get(z)?.get(B)}}class Te{constructor(z,B){this._documents=z,this._provider=B,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.prepareTypeHierarchy(W,V,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideSupertypes(z,B,N){const W=this._itemFromCache(z,B);if(!W)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySupertypes(W,N);if(!!V)return V.map(re=>this._cacheAndConvertItem(z,re))}async provideSubtypes(z,B,N){const W=this._itemFromCache(z,B);if(!W)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySubtypes(W,N);if(!!V)return V.map(re=>this._cacheAndConvertItem(z,re))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,B){const N=this._cache.get(z),W=I.TypeHierarchyItem.from(B,z,N.size.toString(36));return N.set(W._itemId,B),W}_itemFromCache(z,B){return this._cache.get(z)?.get(B)}}class Ne{constructor(z,B){this.adapter=z,this.extension=B}}class be{constructor(z,B,N,W,V,re,he){this._adapter=new Map,this._uriTransformer=B,this._proxy=z.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=N,this._commands=W,this._diagnostics=V,this._logService=re,this._apiDeprecation=he}_transformDocumentSelector(z){return I.DocumentSelector.from(z,this._uriTransformer)}_createDisposable(z){return new T.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return be._handlePool++}async _withAdapter(z,B,N,W,V){const re=this._adapter.get(z);if(!re||!(re.adapter instanceof B))return W;const he=Date.now();this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${N.toString().replace(/[\r\n]/g,"")}'`);const Ce=N(re.adapter,re.extension);return Promise.resolve(Ce).catch(Ae=>{(0,_.isCancellationError)(Ae)||(this._logService.error(`[${re.extension.identifier.value}] provider FAILED`),this._logService.error(Ae))}).finally(()=>{this._logService.trace(`[${re.extension.identifier.value}] provider DONE after ${Date.now()-he}ms`)}),p.CancellationToken.isCancellationToken(V)?(0,l.raceCancellationError)(Ce,V):Ce}_addNewAdapter(z,B){const N=this._nextHandle();return this._adapter.set(N,new Ne(z,B)),N}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,B,N,W){const V=this._addNewAdapter(new u(this._documents,N),z),re=W&&W.label||be._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(V,this._transformDocumentSelector(B),re),this._createDisposable(V)}$provideDocumentSymbols(z,B,N){return this._withAdapter(z,u,W=>W.provideDocumentSymbols(f.URI.revive(B),N),void 0,N)}registerCodeLensProvider(z,B,N){const W=this._nextHandle(),V=typeof N.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(W,new Ne(new c(this._documents,this._commands.converter,N),z)),this._proxy.$registerCodeLensSupport(W,this._transformDocumentSelector(B),V);let re=this._createDisposable(W);if(V!==void 0){const he=N.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(V));re=T.Disposable.from(re,he)}return re}$provideCodeLenses(z,B,N){return this._withAdapter(z,c,W=>W.provideCodeLenses(f.URI.revive(B),N),void 0,N)}$resolveCodeLens(z,B,N){return this._withAdapter(z,c,W=>W.resolveCodeLens(B,N),void 0,void 0)}$releaseCodeLenses(z,B){this._withAdapter(z,c,N=>Promise.resolve(N.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(z,B,N){const W=this._addNewAdapter(new s(this._documents,N),z);return this._proxy.$registerDefinitionSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideDefinition(z,B,N,W){return this._withAdapter(z,s,V=>V.provideDefinition(f.URI.revive(B),N,W),[],W)}registerDeclarationProvider(z,B,N){const W=this._addNewAdapter(new n(this._documents,N),z);return this._proxy.$registerDeclarationSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideDeclaration(z,B,N,W){return this._withAdapter(z,n,V=>V.provideDeclaration(f.URI.revive(B),N,W),[],W)}registerImplementationProvider(z,B,N){const W=this._addNewAdapter(new r(this._documents,N),z);return this._proxy.$registerImplementationSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideImplementation(z,B,N,W){return this._withAdapter(z,r,V=>V.provideImplementation(f.URI.revive(B),N,W),[],W)}registerTypeDefinitionProvider(z,B,N){const W=this._addNewAdapter(new i(this._documents,N),z);return this._proxy.$registerTypeDefinitionSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideTypeDefinition(z,B,N,W){return this._withAdapter(z,i,V=>V.provideTypeDefinition(f.URI.revive(B),N,W),[],W)}registerHoverProvider(z,B,N,W){const V=this._addNewAdapter(new o(this._documents,N),z);return this._proxy.$registerHoverProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideHover(z,B,N,W){return this._withAdapter(z,o,V=>V.provideHover(f.URI.revive(B),N,W),void 0,W)}registerEvaluatableExpressionProvider(z,B,N,W){const V=this._addNewAdapter(new m(this._documents,N),z);return this._proxy.$registerEvaluatableExpressionProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideEvaluatableExpression(z,B,N,W){return this._withAdapter(z,m,V=>V.provideEvaluatableExpression(f.URI.revive(B),N,W),void 0,W)}registerInlineValuesProvider(z,B,N,W){const V=typeof N.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new d(this._documents,N),z);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(B),V);let he=this._createDisposable(re);if(V!==void 0){const Ce=N.onDidChangeInlineValues(Ae=>this._proxy.$emitInlineValuesEvent(V));he=T.Disposable.from(he,Ce)}return he}$provideInlineValues(z,B,N,W,V){return this._withAdapter(z,d,re=>re.provideInlineValues(f.URI.revive(B),N,W,V),void 0,V)}registerDocumentHighlightProvider(z,B,N){const W=this._addNewAdapter(new E(this._documents,N),z);return this._proxy.$registerDocumentHighlightProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideDocumentHighlights(z,B,N,W){return this._withAdapter(z,E,V=>V.provideDocumentHighlights(f.URI.revive(B),N,W),void 0,W)}registerLinkedEditingRangeProvider(z,B,N){const W=this._addNewAdapter(new P(this._documents,N),z);return this._proxy.$registerLinkedEditingRangeProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideLinkedEditingRanges(z,B,N,W){return this._withAdapter(z,P,async V=>{const re=await V.provideLinkedEditingRanges(f.URI.revive(B),N,W);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?be._serializeRegExp(re.wordPattern):void 0}},void 0,W)}registerReferenceProvider(z,B,N){const W=this._addNewAdapter(new L(this._documents,N),z);return this._proxy.$registerReferenceSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideReferences(z,B,N,W,V){return this._withAdapter(z,L,re=>re.provideReferences(f.URI.revive(B),N,W,V),void 0,V)}registerCodeActionProvider(z,B,N,W){const V=new b.DisposableStore,re=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,N,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(B),{providedKinds:W?.providedCodeActionKinds?.map(he=>he.value),documentation:W?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,V)}))},be._extLabel(z),Boolean(N.resolveCodeAction)),V.add(this._createDisposable(re)),V}$provideCodeActions(z,B,N,W,V){return this._withAdapter(z,O,re=>re.provideCodeActions(f.URI.revive(B),N,W,V),void 0,V)}$resolveCodeAction(z,B,N){return this._withAdapter(z,O,W=>W.resolveCodeAction(B,N),void 0,void 0)}$releaseCodeActions(z,B){this._withAdapter(z,O,N=>Promise.resolve(N.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(z,B,N){const W=this._addNewAdapter(new y(this._documents,N),z);return this._proxy.$registerDocumentFormattingSupport(W,this._transformDocumentSelector(B),z.identifier,z.displayName||z.name),this._createDisposable(W)}$provideDocumentFormattingEdits(z,B,N,W){return this._withAdapter(z,y,V=>V.provideDocumentFormattingEdits(f.URI.revive(B),N,W),void 0,W)}registerDocumentRangeFormattingEditProvider(z,B,N){const W=this._addNewAdapter(new H(this._documents,N),z);return this._proxy.$registerRangeFormattingSupport(W,this._transformDocumentSelector(B),z.identifier,z.displayName||z.name),this._createDisposable(W)}$provideDocumentRangeFormattingEdits(z,B,N,W,V){return this._withAdapter(z,H,re=>re.provideDocumentRangeFormattingEdits(f.URI.revive(B),N,W,V),void 0,V)}registerOnTypeFormattingEditProvider(z,B,N,W){const V=this._addNewAdapter(new M(this._documents,N),z);return this._proxy.$registerOnTypeFormattingSupport(V,this._transformDocumentSelector(B),W,z.identifier),this._createDisposable(V)}$provideOnTypeFormattingEdits(z,B,N,W,V,re){return this._withAdapter(z,M,he=>he.provideOnTypeFormattingEdits(f.URI.revive(B),N,W,V,re),void 0,re)}registerWorkspaceSymbolProvider(z,B){const N=this._addNewAdapter(new j(B,this._logService),z);return this._proxy.$registerNavigateTypeSupport(N,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(N)}$provideWorkspaceSymbols(z,B,N){return this._withAdapter(z,j,W=>W.provideWorkspaceSymbols(B,N),{symbols:[]},N)}$resolveWorkspaceSymbol(z,B,N){return this._withAdapter(z,j,W=>W.resolveWorkspaceSymbol(B,N),void 0,void 0)}$releaseWorkspaceSymbols(z,B){this._withAdapter(z,j,N=>N.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(z,B,N){const W=this._addNewAdapter(new Q(this._documents,N,this._logService),z);return this._proxy.$registerRenameSupport(W,this._transformDocumentSelector(B),Q.supportsResolving(N)),this._createDisposable(W)}$provideRenameEdits(z,B,N,W,V){return this._withAdapter(z,Q,re=>re.provideRenameEdits(f.URI.revive(B),N,W,V),void 0,V)}$resolveRenameLocation(z,B,N,W){return this._withAdapter(z,Q,V=>V.resolveRenameLocation(f.URI.revive(B),N,W),void 0,W)}registerDocumentSemanticTokensProvider(z,B,N,W){const V=this._addNewAdapter(new U(this._documents,N),z),re=typeof N.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(V,this._transformDocumentSelector(B),W,re);let he=this._createDisposable(V);if(re){const Ce=N.onDidChangeSemanticTokens(Ae=>this._proxy.$emitDocumentSemanticTokensEvent(re));he=T.Disposable.from(he,Ce)}return he}$provideDocumentSemanticTokens(z,B,N,W){return this._withAdapter(z,U,V=>V.provideDocumentSemanticTokens(f.URI.revive(B),N,W),null,W)}$releaseDocumentSemanticTokens(z,B){this._withAdapter(z,U,N=>N.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,B,N,W){const V=this._addNewAdapter(new q(this._documents,N),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(V,this._transformDocumentSelector(B),W),this._createDisposable(V)}$provideDocumentRangeSemanticTokens(z,B,N,W){return this._withAdapter(z,q,V=>V.provideDocumentRangeSemanticTokens(f.URI.revive(B),N,W),null,W)}registerCompletionItemProvider(z,B,N,W){const V=this._addNewAdapter(new K(this._documents,this._commands.converter,N,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(V,this._transformDocumentSelector(B),W,K.supportsResolving(N),`${z.identifier.value}(${W.join("")})`),this._createDisposable(V)}$provideCompletionItems(z,B,N,W,V){return this._withAdapter(z,K,re=>re.provideCompletionItems(f.URI.revive(B),N,W,V),void 0,V)}$resolveCompletionItem(z,B,N){return this._withAdapter(z,K,W=>W.resolveCompletionItem(B,N),void 0,N)}$releaseCompletionItems(z,B){this._withAdapter(z,K,N=>N.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(z,B,N){const W=this._addNewAdapter(new G(this._documents,N,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideInlineCompletions(z,B,N,W,V){return this._withAdapter(z,G,re=>re.provideInlineCompletions(f.URI.revive(B),N,W,V),void 0,V)}$handleInlineCompletionDidShow(z,B,N){this._withAdapter(z,G,async W=>{W.handleDidShowCompletionItem(B,N)},void 0,void 0)}$freeInlineCompletionsList(z,B){this._withAdapter(z,G,async N=>{N.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(z,B,N,W){const V=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,re=this._addNewAdapter(new oe(this._documents,N),z);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(B),V),this._createDisposable(re)}$provideSignatureHelp(z,B,N,W,V){return this._withAdapter(z,oe,re=>re.provideSignatureHelp(f.URI.revive(B),N,W,V),void 0,V)}$releaseSignatureHelp(z,B){this._withAdapter(z,oe,N=>N.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(z,B,N){const W=typeof N.onDidChangeInlayHints=="function"?this._nextHandle():void 0,V=this._addNewAdapter(new ue(this._documents,this._commands.converter,N,this._logService,z),z);this._proxy.$registerInlayHintsProvider(V,this._transformDocumentSelector(B),typeof N.resolveInlayHint=="function",W,be._extLabel(z));let re=this._createDisposable(V);if(W!==void 0){const he=N.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(W));re=T.Disposable.from(re,he)}return re}$provideInlayHints(z,B,N,W){return this._withAdapter(z,ue,V=>V.provideInlayHints(f.URI.revive(B),N,W),void 0,W)}$resolveInlayHint(z,B,N){return this._withAdapter(z,ue,W=>W.resolveInlayHint(B,N),void 0,N)}$releaseInlayHints(z,B){this._withAdapter(z,ue,N=>N.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(z,B,N){const W=this._addNewAdapter(new Z(this._documents,N),z);return this._proxy.$registerDocumentLinkProvider(W,this._transformDocumentSelector(B),typeof N.resolveDocumentLink=="function"),this._createDisposable(W)}$provideDocumentLinks(z,B,N){return this._withAdapter(z,Z,W=>W.provideLinks(f.URI.revive(B),N),void 0,N)}$resolveDocumentLink(z,B,N){return this._withAdapter(z,Z,W=>W.resolveLink(B,N),void 0,void 0)}$releaseDocumentLinks(z,B){this._withAdapter(z,Z,N=>N.releaseLinks(B),void 0,void 0)}registerColorProvider(z,B,N){const W=this._addNewAdapter(new Y(this._documents,N),z);return this._proxy.$registerDocumentColorProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideDocumentColors(z,B,N){return this._withAdapter(z,Y,W=>W.provideColors(f.URI.revive(B),N),[],N)}$provideColorPresentations(z,B,N,W){return this._withAdapter(z,Y,V=>V.provideColorPresentations(f.URI.revive(B),N,W),void 0,W)}registerFoldingRangeProvider(z,B,N){const W=this._nextHandle(),V=typeof N.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(W,new Ne(new se(this._documents,N),z)),this._proxy.$registerFoldingRangeProvider(W,this._transformDocumentSelector(B),V);let re=this._createDisposable(W);if(V!==void 0){const he=N.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(V));re=T.Disposable.from(re,he)}return re}$provideFoldingRanges(z,B,N,W){return this._withAdapter(z,se,V=>V.provideFoldingRanges(f.URI.revive(B),N,W),void 0,W)}registerSelectionRangeProvider(z,B,N){const W=this._addNewAdapter(new de(this._documents,N,this._logService),z);return this._proxy.$registerSelectionRangeProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideSelectionRanges(z,B,N,W){return this._withAdapter(z,de,V=>V.provideSelectionRanges(f.URI.revive(B),N,W),[],W)}registerCallHierarchyProvider(z,B,N){const W=this._addNewAdapter(new ge(this._documents,N),z);return this._proxy.$registerCallHierarchyProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$prepareCallHierarchy(z,B,N,W){return this._withAdapter(z,ge,V=>Promise.resolve(V.prepareSession(f.URI.revive(B),N,W)),void 0,W)}$provideCallHierarchyIncomingCalls(z,B,N,W){return this._withAdapter(z,ge,V=>V.provideCallsTo(B,N,W),void 0,W)}$provideCallHierarchyOutgoingCalls(z,B,N,W){return this._withAdapter(z,ge,V=>V.provideCallsFrom(B,N,W),void 0,W)}$releaseCallHierarchy(z,B){this._withAdapter(z,ge,N=>Promise.resolve(N.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(z,B,N){const W=this._addNewAdapter(new Te(this._documents,N),z);return this._proxy.$registerTypeHierarchyProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$prepareTypeHierarchy(z,B,N,W){return this._withAdapter(z,Te,V=>Promise.resolve(V.prepareSession(f.URI.revive(B),N,W)),void 0,W)}$provideTypeHierarchySupertypes(z,B,N,W){return this._withAdapter(z,Te,V=>V.provideSupertypes(B,N,W),void 0,W)}$provideTypeHierarchySubtypes(z,B,N,W){return this._withAdapter(z,Te,V=>V.provideSubtypes(B,N,W),void 0,W)}$releaseTypeHierarchy(z,B){this._withAdapter(z,Te,N=>Promise.resolve(N.releaseSession(B)),void 0,void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,k.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:be._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:be._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:be._serializeRegExp(z.beforeText),afterText:z.afterText?be._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?be._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(be._serializeOnEnterRule)}setLanguageConfiguration(z,B,N){let{wordPattern:W}=N;if(W&&(0,k.regExpLeadsToEndlessLoop)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this._documents.setWordDefinitionFor(B,W):this._documents.setWordDefinitionFor(B,void 0),N.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),N.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const V=this._nextHandle(),re={comments:N.comments,brackets:N.brackets,wordPattern:N.wordPattern?be._serializeRegExp(N.wordPattern):void 0,indentationRules:N.indentationRules?be._serializeIndentationRule(N.indentationRules):void 0,onEnterRules:N.onEnterRules?be._serializeOnEnterRules(N.onEnterRules):void 0,__electricCharacterSupport:N.__electricCharacterSupport,__characterPairSupport:N.__characterPairSupport};return this._proxy.$setLanguageConfiguration(V,B,re),this._createDisposable(V)}$setWordDefinitions(z){for(const B of z)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=be,be._handlePool=0}),define(ve[242],we([1,0,5,14,7,47,16,6]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(F,D,p,b){this._documents=D,this._commands=p,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,D){await this._proxy.$changeLanguage(F,D);const p=this._documents.getDocumentData(F);if(!p)throw new Error(`document '${F.toString()}' NOT found`);return p.document}async tokenAtPosition(F,D){const p=F.version,b=t.Position.from(D),g=await this._proxy.$tokensAtPosition(F.uri,b),h={type:I.StandardTokenType.Other,range:F.getWordRangeAtPosition(D)??new I.Range(D.line,D.character,D.line,D.character)};if(!g)return h;const v={range:t.Range.to(g.range),type:t.TokenType.to(g.type)};return!v.range.contains(D)||p!==F.version?h:v}createLanguageStatusItem(F,D,p){const b=this._handlePool++,g=this._proxy,h=this._ids,v=`${F.identifier.value}/${D}`;if(h.has(v))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);h.add(v);const A={selector:p,id:D,name:F.displayName??F.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,a=new k.DisposableStore;const l=()=>{_?.dispose(),_=(0,C.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(b,{id:v,name:A.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(A.selector,this._uriTransformer),label:A.text,detail:A.detail??"",severity:A.severity===I.LanguageStatusSeverity.Error?T.default.Error:A.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:A.command&&this._commands.toInternal(A.command,a),accessibilityInfo:A.accessibilityInformation,busy:A.busy})},0)},u={dispose(){a.dispose(),_?.dispose(),g.$removeLanguageStatus(b),h.delete(v)},get id(){return A.id},get name(){return A.name},set name(c){A.name=c,l()},get selector(){return A.selector},set selector(c){A.selector=c,l()},get text(){return A.text},set text(c){A.text=c,l()},get detail(){return A.detail},set detail(c){A.detail=c,l()},get severity(){return A.severity},set severity(c){A.severity=c,l()},get accessibilityInformation(){return A.accessibilityInformation},set accessibilityInformation(c){A.accessibilityInformation=c,l()},get command(){return A.command},set command(c){A.command=c,l()},get busy(){return A.busy},set busy(c){A.busy=c,l()}};return l(),u}}e.ExtHostLanguages=S}),define(ve[134],we([1,0,11,5,26,17,3]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends f.AbstractLoggerService{constructor(F,D){const p=new C.Emitter;super(D.logLevel,p.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(p)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,D,p){return new S(this._proxy,F,D,p)}};k=Be([Fe(0,T.IExtHostRpcService),Fe(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends f.AbstractMessageLogger{constructor(F,D,p,b){super(b?.always);this.proxy=F,this.file=D,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(D,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,D){const p=[[F,D]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(F){this.proxy.$log(this.file,F)}}}),define(ve[243],we([1,0,5,11,30]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(k){return k&&k.title}let C=class{constructor(S,R){this._logService=R,this._proxy=S.getProxy(f.MainContext.MainThreadMessageService)}showMessage(S,R,F,D,p){const b={source:{identifier:S.identifier,label:S.displayName||S.name}};let g;typeof D=="string"||T(D)?g=[D,...p]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,g=p),b.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const h=[];for(let v=0;v<g.length;v++){const A=g[v];if(typeof A=="string")h.push({title:A,handle:v,isCloseAffordance:!1});else if(typeof A=="object"){let{title:_,isCloseAffordance:a}=A;h.push({title:_,isCloseAffordance:!!a,handle:v})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(R,F,b,h).then(v=>{if(typeof v=="number")return g[v]})}};C=Be([Fe(1,t.ILogService)],C),e.ExtHostMessageService=C}),define(ve[244],we([1,0,22,3,57,6,24,8,13,2,82,5,14,7,52,220,130]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(a,l,u,c,w){this._textDocumentsAndEditors=u,this._textDocuments=c,this._extensionStoragePaths=w,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,r=s.cell.handle,o=this._documents.get(n)?.getCell(r);if(o)return o.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const l=this._editors.get(a);if(!l)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(a){for(const[l,u]of this._editors)if(u.apiEditor===a)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,l){const u=this._documents.get(a);if(!u&&!l)throw new Error(`NO notebook document for '${a}'`);return u}_getProviderData(a){const l=this._notebookContentProviders.get(a);if(!l)throw new Error(`NO provider for '${a}'`);return l}registerNotebookContentProvider(a,l,u,c,w){if((0,k.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:a,provider:u});let s;return u.onDidChangeNotebookContentOptions&&(s=u.onDidChangeNotebookContentOptions(()=>{const n=p.NotebookDocumentContentOptions.from(u.options);this._notebookProxy.$updateNotebookProviderOptions(l,n)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},l,p.NotebookDocumentContentOptions.from(c),A._convertNotebookRegistrationData(a,w)),new b.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(a,l){if(!l)return;const u=l.filenamePattern.map(c=>p.NotebookExclusiveDocumentPattern.from(c)).filter(c=>c!==void 0);if(l.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:l.displayName,filenamePattern:u,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,l,u){const c=A._notebookStatusBarItemProviderHandlePool++,w=typeof u.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(c,u),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(c,w,l);let s;return w!==void 0&&(s=u.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(w))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(c),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(c,w),s&&s.dispose()})}async createNotebookDocument(a){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&p.NotebookData.from(a.content)});return R.URI.revive(l)}async openNotebookDocument(a){const l=this._documents.get(a);if(l)return l.apiNotebook;const u=await this._notebookDocumentsProxy.$tryOpenNotebook(a),c=this._documents.get(R.URI.revive(u));return(0,S.assertIsDefined)(c?.apiNotebook)}async showNotebookDocument(a,l){R.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let u;typeof l=="object"?u={position:p.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(p.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:u={preserveFocus:!1};const c=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,u),w=c&&this._editors.get(c)?.apiEditor;if(w)return w;throw c?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,l,u,c){const w=this._notebookStatusBarItemProviders.get(a),s=R.URI.revive(l),n=this._documents.get(s);if(!n||!w)return;const r=n.getCellFromIndex(u);if(!r)return;const i=await w.provideCellStatusBarItems(r.apiCell,c);if(!i)return;const o=new T.DisposableStore,m=this._statusBarCache.add([o]),E=(Array.isArray(i)?i:[i]).map(P=>p.NotebookStatusBarItem.from(P,this._commandsConverter,o));return{cacheId:m,items:E}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,l,u,c,w){if((0,k.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,u),this._notebookProxy.$registerNotebookSerializer(s,{id:a.identifier,location:a.extensionLocation},l,p.NotebookDocumentContentOptions.from(c),A._convertNotebookRegistrationData(a,w)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(a,l,u){const c=this._notebookSerializer.get(a);if(!c)throw new Error("NO serializer found");const w=await c.deserializeNotebook(l.buffer,u);return new g.SerializableObjectWithBuffers(p.NotebookData.from(w))}async $notebookToData(a,l,u){const c=this._notebookSerializer.get(a);if(!c)throw new Error("NO serializer found");const w=await c.serializeNotebook(p.NotebookData.to(l.value),u);return f.VSBuffer.wrap(w)}async $openNotebook(a,l,u,c,w){const{provider:s}=this._getProviderData(a),n=await s.openNotebook(R.URI.revive(l),{backupId:u,untitledDocumentData:c?.buffer},w);return new g.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(p.NotebookCellData.from)})}async $saveNotebook(a,l,u){const c=this.getNotebookDocument(R.URI.revive(l)),{provider:w}=this._getProviderData(a);return await w.saveNotebook(c.apiNotebook,u),!0}async $saveNotebookAs(a,l,u,c){const w=this.getNotebookDocument(R.URI.revive(l)),{provider:s}=this._getProviderData(a);return await s.saveNotebookAs(R.URI.revive(u),w.apiNotebook,c),!0}async $backupNotebook(a,l,u){const c=this.getNotebookDocument(R.URI.revive(l)),w=this._getProviderData(a),s=this._extensionStoragePaths.workspaceValue(w.extension)??this._extensionStoragePaths.globalValue(w.extension),n=String((0,I.hash)([c.uri.toString(),this._backupIdPool++])),r=R.URI.joinPath(s,n),i=await w.provider.backupNotebook(c.apiNotebook,{destination:r},u);return c.updateBackup(i),i.id}_createExtHostEditor(a,l,u){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const c=new v.ExtHostNotebookEditor(l,this._notebookEditorsProxy,a,u.visibleRanges.map(p.NotebookRange.to),u.selections.map(p.NotebookRange.to),typeof u.viewColumn=="number"?p.ViewColumn.to(u.viewColumn):void 0);this._editors.set(l,c)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const u of a.value.removedDocuments){const c=R.URI.revive(u),w=this._documents.get(c);w&&(w.dispose(),this._documents.delete(c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(w.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===c.toString()&&this._editors.delete(s.id)}if(a.value.addedDocuments){const u=[];for(const c of a.value.addedDocuments){const w=R.URI.revive(c.uri);if(this._documents.has(w))throw new Error(`adding EXISTING notebook ${w} `);const s=this,n=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){s._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){s._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){s._onDidChangeCellMetadata.fire(r)}},w,c);u.push(...c.cells.map(r=>h.ExtHostCell.asModelAddData(n.apiNotebook,r))),this._documents.get(w)?.dispose(),this._documents.set(w,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(a.value.addedEditors)for(const u of a.value.addedEditors){if(this._editors.has(u.id))return;const c=R.URI.revive(u.documentUri),w=this._documents.get(c);w&&this._createExtHostEditor(w,u.id,u)}const l=[];if(a.value.removedEditors)for(const u of a.value.removedEditors){const c=this._editors.get(u);c&&(this._editors.delete(u),this._activeNotebookEditor?.id===c.id&&(this._activeNotebookEditor=void 0),l.push(c))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(c=>this._editors.get(c)).filter(c=>!!c);const u=new Set;this._visibleNotebookEditors.forEach(c=>u.add(c.id));for(const c of this._editors.values()){const w=u.has(c.id);c._acceptVisibility(w)}this._visibleNotebookEditors=[...this._editors.values()].map(c=>c).filter(c=>c.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(ve[245],we([1,0,3,75,11,5,17,14]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(D,p){const b=S._Keys.nextId();D.$registerNotebookEditorDecorationType(b,k.NotebookDecorationRenderOptions.from(p)),this.value={key:b,dispose(){D.$removeNotebookEditorDecorationType(b)}}}}S._Keys=new t.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(D,p,b){this._logService=D,this._extHostRpc=p,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(D){return new S(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),D).value}$acceptEditorPropertiesChanged(D,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,p);const b=this._notebooksAndEditors.getEditorById(D);p.visibleRanges&&b._acceptVisibleRanges(p.visibleRanges.ranges.map(k.NotebookRange.to)),p.selections&&b._acceptSelections(p.selections.selections.map(k.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const p in D)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(k.ViewColumn.to(D[p]))}};R=Be([Fe(0,I.ILogService),Fe(1,C.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(ve[246],we([1,0,18,16,21,3,6,24,2,27,11,5,39,14,7,83,213,30,52]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(n,r,i,o,m){this._initData=r,this._extHostNotebook=i,this._commands=o,this._logService=m,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(D.MainContext.MainThreadNotebookKernels);const d=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const P=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:P}}else if(E&&"notebookEditor"in E){const P=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(P===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.document.uri.toString()}`);return{notebookEditorId:P}}return E})],p.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(n,r,i,o,m,d){for(const ee of this._kernelData.values())if(ee.controller.id===r&&R.ExtensionIdentifier.equals(n.identifier,ee.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const E=this._handlePool++,P=this;this._logService.trace(`NotebookController[${E}], CREATED by ${n.identifier.value}, ${r}`);const L=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${n.identifier}'`);let O=!1;const y=new C.DisposableStore,H=new T.Emitter,M=new T.Emitter,j={id:w(n,r),notebookType:i,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:o||n.identifier.value,preloads:d?d.map(b.NotebookRendererScript.from):[]};let Q=m??L,$;this._proxy.$addKernel(E,j).catch(ee=>{console.log(ee),O=!0});let U=0;const q=()=>{if(O)return;const ee=++U;Promise.resolve().then(()=>{ee===U&&this._proxy.$updateKernel(E,j)})},K=new k.ResourceMap,G={get id(){return r},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return j.label},set label(ee){j.label=ee??n.displayName??n.name,q()},get detail(){return j.detail??""},set detail(ee){j.detail=ee,q()},get description(){return j.description??""},set description(ee){j.description=ee,q()},get kind(){return(0,A.checkProposedApiEnabled)(n,"notebookControllerKind"),j.kind??""},set kind(ee){(0,A.checkProposedApiEnabled)(n,"notebookControllerKind"),j.kind=ee,q()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(ee){j.supportedLanguages=ee,q()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(ee){j.supportsExecutionOrder=ee,q()},get rendererScripts(){return j.preloads?j.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(ee){Q=ee??L},get interruptHandler(){return $},set interruptHandler(ee){$=ee,j.supportsInterrupt=Boolean(ee),q()},createNotebookCellExecution(ee){if(O)throw new Error("notebook controller is DISPOSED");if(!K.has(ee.notebook.uri))throw P._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(K.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.notebook.uri.toString()}`);return P._createNotebookCellExecution(ee,w(n,this.id))},dispose:()=>{O||(this._logService.trace(`NotebookController[${E}], DISPOSED`),O=!0,this._kernelData.delete(E),y.dispose(),H.dispose(),M.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity(ee,oe){P._proxy.$updateNotebookPriority(E,ee.uri,oe)},onDidReceiveMessage:M.event,postMessage(ee,oe){return(0,A.checkProposedApiEnabled)(n,"notebookMessaging"),P._proxy.$postMessage(E,oe&&P._extHostNotebook.getIdByEditor(oe),ee)},asWebviewUri(ee){return(0,A.checkProposedApiEnabled)(n,"notebookMessaging"),(0,h.asWebviewUri)(ee,P._initData.remote)}};return this._kernelData.set(E,{extensionId:n.identifier,controller:G,onDidReceiveMessage:M,onDidChangeSelection:H,associatedNotebooks:K}),G}$acceptNotebookAssociation(n,r,i){const o=this._kernelData.get(n);if(o){const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));i?o.associatedNotebooks.set(m.uri,!0):o.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,m.uri.toString(),i),o.onDidChangeSelection.fire({selected:i,notebook:m.apiNotebook})}}async $executeCells(n,r,i){const o=this._kernelData.get(n);if(!o)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),d=[];for(const E of i){const P=m.getCell(E);P&&d.push(P.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,m.uri.toString(),d.length),await o.controller.executeHandler.call(o.controller,d,m.apiNotebook,o.controller)}catch(E){this._logService.error(`NotebookController[${n}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(n,r,i){const o=this._kernelData.get(n);if(!o)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,m.apiNotebook);else for(const d of i){const E=m.getCell(d);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,r,i){const o=this._kernelData.get(n);if(!o)return;const m=this._extHostNotebook.getEditorById(r);o.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:i}))}$cellExecutionChanged(n,r,i){const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(n)).getCell(r);m&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:i?b.NotebookCellExecutionState.to(i):g.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(n,r){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const m=new u(r,o,this._proxy);this._activeExecutions.set(o.uri,m);const d=m.onDidChangeState(()=>{m.state===l.Resolved&&(m.dispose(),d.dispose(),this._activeExecutions.delete(o.uri))});return m.asApiObject()}};a=Be([Fe(4,F.ILogService)],a),e.ExtHostNotebookKernels=a;var l;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(l||(l={}));class u extends C.Disposable{constructor(n,r,i){super();this._cell=r,this._proxy=i,this._handle=u.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new c(10,o=>this.update(o)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const r=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new _.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(n){return n.map(r=>{const i=g.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return i===r.items?b.NotebookCellOutput.from(r):b.NotebookCellOutput.from({items:i,id:r.id,metadata:r.metadata})})}async updateOutputs(n,r,i){const o=this.validateAndConvertOutputs((0,f.asArray)(n));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,append:i,outputs:o})}async updateOutputItems(n,r,i){return n=g.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(n),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:n.map(b.NotebookCellOutputItem.from),outputId:r.id,append:i})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(i){n._executionOrder=i,n.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(i){if(n._state===l.Resolved||n._state===l.Started)throw new Error("Cannot call start again");n._state=l.Started,n._onDidChangeState.fire(),n.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,o){if(n._state===l.Resolved)throw new Error("Cannot call resolve twice");n._state=l.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new _.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:i}))},clearOutput(i){return n.verifyStateForOutput(),n.updateOutputs([],i,!1)},appendOutput(i,o){return n.verifyStateForOutput(),n.updateOutputs(i,o,!0)},replaceOutput(i,o){return n.verifyStateForOutput(),n.updateOutputs(i,o,!1)},appendOutputItems(i,o){return n.verifyStateForOutput(),n.updateOutputItems(i,o,!0)},replaceOutputItems(i,o){return n.verifyStateForOutput(),n.updateOutputItems(i,o,!1)}})}}u.HANDLE=0;class c{constructor(n,r){this.delay=n,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>n.complete())}}function w(s,n){return`${s.identifier.value}/${n}`}}),define(ve[247],we([1,0,3,5,130,30]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(S,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,R,F){const D=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(R)?.fire({editor:D.apiEditor,message:F})}createRendererMessaging(S,R){if(!S.contributes?.notebookRenderer?.some(b=>b.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const F=(0,T.isProposedApiEnabled)(S,"notebookEditor"),D=new WeakMap;return{onDidReceiveMessage:(b,g,h)=>{const v=F?b:A=>{const _={};D.set(_,A.editor),b({editor:_,message:A.message})};return this.getOrCreateEmitterFor(R).event(v,g,h)},postMessage:(b,g)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,g]=[g,b]);const h=F?g:D.get(g),v=h&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(v?.id,R,b)}}}getOrCreateEmitterFor(S){let R=this._rendererMessageEmitters.get(S);return R||(R=new f.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,R),R)}}e.ExtHostNotebookRenderers=C}),define(ve[135],we([1,0,5,6,4,17,11,214,65,26,44,155,22,13]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends t.Disposable{constructor(A,_,a,l){super();this.id=A,this.name=_,this.logger=a,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(A){this.append(A+`
`)}append(A){this.write(A),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const A=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,A)}replace(A){const _=this.offset;this.write(A),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,_),this.visible&&this.logger.flush()}show(A,_){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof A=="boolean"?A:_))}hide(){this.proxy.$close(this.id)}write(A){this.offset+=p.VSBuffer.fromString(A).byteLength,this.logger.info(A)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let h=class{constructor(A,_,a,l,u){this.extHostFileSystem=a,this.extHostFileSystemInfo=l,this.loggerService=u,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=A.getProxy(f.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(_.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(A){this.visibleChannelId=A;for(const[_,a]of this.channels)a.visible=_===this.visibleChannelId}createOutputChannel(A,_,a){if(A=A.trim(),!A)throw new Error("illegal argument `name`. must not be falsy");if((0,b.isString)(_)&&!_.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(A,_,a);return l.then(u=>{this.channels.set(u.id,u),u.visible=u.id===this.visibleChannelId}),this.createExtHostOutputChannel(A,l)}async doCreateOutputChannel(A,_,a){const l=await this.createOutputDirectory(),u=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${A.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),w=await this.proxy.$register(A,!1,u,_,a.identifier.value);return new g(w,A,c,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(A,_){let a=!1;const l=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return A},append(u){l(),_.then(c=>c.append(u))},appendLine(u){l(),_.then(c=>c.appendLine(u))},clear(){l(),_.then(u=>u.clear())},replace(u){l(),_.then(c=>c.replace(u))},show(u,c){l(),_.then(w=>w.show(u,c))},hide(){l(),_.then(u=>u.hide())},dispose(){a=!0,_.then(u=>u.dispose())}}}};h=Be([Fe(0,T.IExtHostRpcService),Fe(1,R.IExtHostInitDataService),Fe(2,S.IExtHostConsumerFileSystem),Fe(3,F.IExtHostFileSystemInfo),Fe(4,C.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(ve[248],we([1,0,16,21,3,6,5,2,7,15,18,47,81]),function(te,e,f,t,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(g,h,v){const A=g.getProxy(C.MainContext.MainThreadQuickOpen);class _{constructor(i,o){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=o}showQuickPick(i,o,m=t.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(i),E=++this._instances,P=A.$show(E,{title:o?.title,placeHolder:o?.placeHolder,matchOnDescription:o?.matchOnDescription,matchOnDetail:o?.matchOnDetail,ignoreFocusLost:o?.ignoreFocusOut,canPickMany:o?.canPickMany},m),L={},O=P.then(()=>L);return Promise.race([O,d]).then(y=>{if(y!==L)return d.then(H=>{const M=[];for(let j=0;j<H.length;j++){const Q=H[j];typeof Q=="string"?M.push({label:Q,handle:j}):Q.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:Q.label}):M.push({label:Q.label,description:Q.description,detail:Q.detail,picked:Q.picked,alwaysShow:Q.alwaysShow,handle:j})}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{o.onDidSelectItem(H[j])}),A.$setItems(E,M),P.then(j=>{if(typeof j=="number")return H[j];if(Array.isArray(j))return j.map(Q=>H[Q])})})}).then(void 0,y=>{if(!(0,R.isCancellationError)(y))return A.$setError(E,y),Promise.reject(y)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,o=t.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,A.$input(i,typeof this._validateInput=="function",o).then(void 0,m=>{if(!(0,R.isCancellationError)(m))return Promise.reject(m)})}$validateInput(i){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,o=t.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!m)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(E=>E.uri.toString()===m.uri.toString())}createQuickPick(i){const o=new s(i,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}createInputBox(i){const o=new n(i,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(i,o){const m=this._sessions.get(i);m&&m._fireDidChangeValue(o)}$onDidAccept(i){const o=this._sessions.get(i);o&&o._fireDidAccept()}$onDidChangeActive(i,o){const m=this._sessions.get(i);m instanceof s&&m._fireDidChangeActive(o)}$onDidChangeSelection(i,o){const m=this._sessions.get(i);m instanceof s&&m._fireDidChangeSelection(o)}$onDidTriggerButton(i,o){const m=this._sessions.get(i);m&&m._fireDidTriggerButton(o)}$onDidTriggerItemButton(i,o,m){const d=this._sessions.get(i);d instanceof s&&d._fireDidTriggerItemButton(o,m)}$onDidHide(i){const o=this._sessions.get(i);o&&o._fireDidHide()}}class a{constructor(i,o){this._extensionId=i,this._onDidDispose=o,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((o,m)=>{const d=o===S.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(d,o)}),this.update({buttons:i.map((o,m)=>({...w(o),tooltip:o.tooltip,handle:o===S.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const o=this._handlesToButtons.get(i);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),A.$dispose(this._id))}update(i){if(!this._disposed){for(const o of Object.keys(i)){const m=i[o];this._pendingUpdate[o]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){A.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function l(r){if(r instanceof S.ThemeIcon)return{id:r.id};const i=c(r),o=u(r);return{dark:typeof i=="string"?k.URI.file(i):i,light:typeof o=="string"?k.URI.file(o):o}}function u(r){return typeof r=="object"&&"light"in r?r.light:r}function c(r){return typeof r=="object"&&"dark"in r?r.dark:r}function w(r){const i=l(r.iconPath);let o,m;return"id"in i?m=p.ThemeIcon.asClassName(i):o=i,{iconPath:o,iconClass:m}}class s extends a{constructor(i,o){super(i.identifier,o);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((m,d)=>{this._handlesToItems.set(d,m),this._itemsToHandles.set(m,d)});const o=[];for(let m=0;m<i.length;m++){const d=i[m];d.kind===S.QuickPickItemKind.Separator?o.push({type:"separator",label:d.label}):o.push({handle:m,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((E,P)=>({...w(E),tooltip:E.tooltip,handle:P}))})}this.update({items:o})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(i){this._keepScrollPosition=i,this.update({keepScrollPosition:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(i){const o=(0,F.coalesce)(i.map(m=>this._handlesToItems.get(m)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(i){const o=(0,F.coalesce)(i.map(m=>this._handlesToItems.get(m)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}_fireDidTriggerItemButton(i,o){const m=this._handlesToItems.get(i);if(!m||!m.buttons||!m.buttons.length)return;const d=m.buttons[o];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:m})}}class n extends a{constructor(i,o){super(i,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?D.default.Error:D.default.Ignore})}}return new _(h,v)}e.createExtHostQuickOpen=b});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[249],we([1,0,2,3,56,6,16,5,18,97,11,27,81,14,30]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g){"use strict";var h,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function A(m){if(m)return typeof m.iconPath=="string"?f.URI.file(m.iconPath):f.URI.isUri(m.iconPath)||p.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function _(m,d){if(!m.iconPath&&!d.iconPath)return 0;if(m.iconPath){if(!d.iconPath)return 1}else return-1;const E=typeof m.iconPath=="string"?m.iconPath:f.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,P=typeof d.iconPath=="string"?d.iconPath:f.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,R.comparePaths)(E,P)}function a(m,d){let E=0;if(m.strikeThrough!==d.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==d.faded)return m.faded?1:-1;if(m.tooltip!==d.tooltip)return(m.tooltip||"").localeCompare(d.tooltip||"");if(E=_(m,d),E!==0)return E;if(m.light&&d.light)E=_(m.light,d.light);else{if(m.light)return 1;if(d.light)return-1}if(E!==0)return E;if(m.dark&&d.dark)E=_(m.dark,d.dark);else{if(m.dark)return 1;if(d.dark)return-1}return E}function l(m,d){if(m.command!==d.command)return m.command<d.command?-1:1;if(m.title!==d.title)return m.title<d.title?-1:1;if(m.tooltip!==d.tooltip){if(m.tooltip!==void 0&&d.tooltip!==void 0)return m.tooltip<d.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(m.arguments===d.arguments)return 0;if(m.arguments)if(d.arguments){if(m.arguments.length!==d.arguments.length)return m.arguments.length-d.arguments.length}else return 1;else return-1;for(let E=0;E<m.arguments.length;E++){const P=m.arguments[E],L=d.arguments[E];if(P!==L)return P<L?-1:1}return 0}function u(m,d){let E=(0,R.comparePaths)(m.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(E!==0)return E;if(m.command&&d.command)E=l(m.command,d.command);else{if(m.command)return 1;if(d.command)return-1}if(E!==0)return E;if(m.decorations&&d.decorations)E=a(m.decorations,d.decorations);else{if(m.decorations)return 1;if(d.decorations)return-1}return E}function c(m,d){for(let E=0;E<m.length;E++)if(m[E]!==d[E])return!1;return!0}function w(m,d){return m.command===d.command&&m.title===d.title&&m.tooltip===d.tooltip&&(m.arguments&&d.arguments?c(m.arguments,d.arguments):m.arguments===d.arguments)}function s(m,d){return(0,S.equals)(m,d,w)}class n{constructor(d,E,P){this._extension=d,this._sourceControlHandle=P,h.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Xe(this,h,E,"f")}get value(){return this._value}set value(d){d=d??"",Pe(this,h,"f").$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){Pe(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,Pe(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,Pe(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,d))}showValidationMessage(d,E){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Pe(this,h,"f").$showValidationMessage(this._sourceControlHandle,d,E)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=n,h=new WeakMap;class r{constructor(d,E,P,L,O){this._proxy=d,this._commands=E,this._sourceControlHandle=P,this._id=L,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,E){const P=this._resourceStatesCommandsMap.get(d);return P?(0,C.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(u),P=(0,S.sortedDiff)(this._resourceSnapshot,d,u).map(y=>{const H=y.toInsert.map(M=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,M);const Q=M.resourceUri;let $;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const se=new T.DisposableStore;$=this._commands.converter.toInternal(M.command,se),this._resourceStatesDisposablesMap.set(j,se)}else this._resourceStatesCommandsMap.set(j,M.command);const U=A(M.decorations),q=M.decorations&&A(M.decorations.light)||U,K=M.decorations&&A(M.decorations.dark)||U,G=[q,K],ee=M.decorations&&M.decorations.tooltip||"",oe=M.decorations&&!!M.decorations.strikeThrough,ue=M.decorations&&!!M.decorations.faded,Z=M.contextValue||"";return{rawResource:[j,Q,G,ee,oe,ue,Z,$],handle:j}});return{start:y.start,deleteCount:y.deleteCount,toInsert:H}}),L=P.map(({start:y,deleteCount:H,toInsert:M})=>[y,H,M.map(j=>j.rawResource)]),O=P.reverse();for(const{start:y,deleteCount:H,toInsert:M}of O){const j=M.map($=>$.handle),Q=this._handlesSnapshot.splice(y,H,...j);for(const $ of Q)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=d,L}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(d,E,P,L,O,y){this._extension=d,this._commands=P,this._id=L,this._label=O,this._rootUri=y,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Xe(this,v,E,"f"),this._inputBox=new n(d,Pe(this,v,"f"),this.handle),Pe(this,v,"f").$registerSourceControl(this.handle,L,O,y)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,Pe(this,v,"f").$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,Pe(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,Pe(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=d;const E=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);Pe(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:E})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=d;const E=d!==void 0?{command:this._commands.converter.toInternal(d.command,this._actionButtonDisposables.value),description:d.description}:void 0;Pe(this,v,"f").$updateSourceControl(this.handle,{actionButton:E??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&s(this._statusBarCommands,d))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=d;const E=(d||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));Pe(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}createResourceGroup(d,E){const P=new r(Pe(this,v,"f"),this._commands,this.handle,d,E),L=t.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,L),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const d=[],E=[];for(const[P,L]of this.createdResourceGroups){L.dispose();const O=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});t.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),O.dispose(),this._groups.delete(P.handle),Pe(this,v,"f").$unregisterGroup(this.handle,P.handle)}),d.push([P.handle,P.id,P.label,P.features]);const y=P._takeResourceStateSnapshot();y.length>0&&E.push([P.handle,y]),this._groups.set(P.handle,P)}Pe(this,v,"f").$registerGroups(this.handle,d,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(E=>{const P=E._takeResourceStateSnapshot();P.length!==0&&d.push([E.handle,P])}),d.length>0&&Pe(this,v,"f").$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),Pe(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,i._handlePool=0,Be([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Be([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let o=class Vi{constructor(d,E,P){this._commands=E,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=d.getProxy(k.MainContext.MainThreadSCM),this._telemetry=d.getProxy(k.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const O=this._sourceControls.get(L.sourceControlHandle);if(!O)return L;const y=O.getResourceGroup(L.groupHandle);return y?y.getResourceState(L.handle):L}else if(L&&L.$mid===4){const O=this._sourceControls.get(L.sourceControlHandle);return O?O.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const O=this._sourceControls.get(L.handle);return O||L}return L}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,E,P,L){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,E,P,L),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const O=Vi._handlePool++,y=new i(d,this._proxy,this._commands,E,P,L);this._sourceControls.set(O,y);const H=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(d.identifier))||[];return H.push(y),this._sourceControlsByExtension.set(D.ExtensionIdentifier.toKey(d.identifier),H),y}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const E=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(d.identifier)),P=E&&E[E.length-1];return P&&P.inputBox}$provideOriginalResource(d,E,P){const L=f.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,L.toString());const O=this._sourceControls.get(d);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(L,P)).then(y=>y||null)}$onInputBoxValueChange(d,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const P=this._sourceControls.get(d);return P&&P.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(d,E,P,L){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,E,P);const O=this._sourceControls.get(d);if(!O)return Promise.resolve(void 0);const y=O.getResourceGroup(E);return y?y.$executeResourceCommand(P,L):Promise.resolve(void 0)}$validateInput(d,E,P){this.logService.trace("ExtHostSCM#$validateInput",d);const L=this._sourceControls.get(d);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>L.inputBox.validateInput(E,P)).then(O=>{if(!O)return Promise.resolve(void 0);const y=b.MarkdownString.fromStrict(O.message);return y?Promise.resolve([y,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};o._handlePool=0,o=Be([Fe(2,F.ILogService)],o),e.ExtHostSCM=o});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[250],we([1,0,7,5,169,6,14,13]),function(te,e,f,t,I,T,C,k){"use strict";var S,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(g,h,v,A,_=f.StatusBarAlignment.Left,a){S.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Xe(this,S,g,"f"),Xe(this,R,h,"f"),this._entryId=F.ID_GEN++,this._extension=v,this._id=A,this._alignment=_,this._priority=this.validatePriority(a)}validatePriority(g){if(!!(0,k.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!F.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Pe(this,R,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Pe(this,R,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Pe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let h;this._name?h=this._name:h=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const A=C.MarkdownString.fromStrict(this._tooltip);Pe(this,S,"f").$setEntry(this._entryId,g,h,this._text,A,this._command?.internal,v,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,S=new WeakMap,R=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const h={message:g};return this._messages.unshift(h),this._update(),new f.Disposable(()=>{const v=this._messages.indexOf(h);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class p{constructor(g,h){this._proxy=g.getProxy(t.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new D(this)}createStatusBarEntry(g,h,v,A){return new F(this._proxy,this._commands,g,h,v,A)}setStatusBarMessage(g,h){const v=this._statusMessage.setMessage(g);let A;return typeof h=="number"?A=setTimeout(()=>v.dispose(),h):typeof h!="undefined"&&h.then(()=>v.dispose(),()=>v.dispose()),new f.Disposable(()=>{v.dispose(),clearTimeout(A)})}}e.ExtHostStatusBar=p}),define(ve[87],we([1,0,5,3,4]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}initializeExtensionStorage(k,S,R){return this._proxy.$initializeExtensionStorage(k,S).then(F=>F||R)}setValue(k,S,R){return this._proxy.$setValue(k,S,R)}$acceptValue(k,S,R){this._onDidChangeStorage.fire({shared:k,key:S,value:R})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(ve[66],we([1,0,4,26,11,65,2]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let k=class{constructor(R,F,D){this._logService=F,this._extHostFileSystem=D,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(R){return C.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,F=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(R){if(this._value)return C.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return C.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Be([Fe(0,t.IExtHostInitDataService),Fe(1,I.ILogService),Fe(2,T.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ve[34],we([1,0,3,5,4,2,17,6,7,170,15,216,21,33,196,81,13,16]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class _{constructor(i,o,m,d){this._proxy=i,this._id=o,this._creationOptions=m,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(P,L=!0){E._checkDisposed(),E._proxy.$sendText(E._id,P,L)},show(P){E._checkDisposed(),E._proxy.$show(E._id,P)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(i,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,v.withNullAsUndefined)(i.shellPath),shellArgs:(0,v.withNullAsUndefined)(i.shellArgs),cwd:(0,v.withNullAsUndefined)(i.cwd),env:(0,v.withNullAsUndefined)(i.env),icon:(0,v.withNullAsUndefined)(s(i.iconPath)),color:h.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,v.withNullAsUndefined)(i.message),strictEnv:(0,v.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(i.location,o?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,o,m,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:h.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(i,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(i,o){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in i?{viewColumn:i.viewColumn,preserveFocus:i.preserveFocus}:void 0:i}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,o){return i===this._cols&&o===this._rows||i===0||o===0?!1:(this._cols=i,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=_;class a{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new f.Emitter,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput?.(i)}resize(i,o){this._pty.setDimensions?.({columns:i,rows:o})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(i||void 0),i&&this._pty.setDimensions?.(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let l=1,u=class extends k.Disposable{constructor(i,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[m,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,o){const m=new _(this._proxy,(0,b.generateUuid)(),i,i.name),d=new a(i.pty);return m.createExtensionTerminal(i.location,this._serializeParentTerminal(i,o).resolvedExtHostIdentifier,s(i.iconPath),n(i.color)).then(E=>{const P=this._setupExtHostProcessListeners(E,d);this._terminalProcessDisposables[E]=P}),this._terminals.push(m),m.value}_serializeParentTerminal(i,o){if(o=o||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const m=i.location.parentTerminal;if(m){const d=this._terminals.find(E=>E.value===m);d&&(o.resolvedExtHostIdentifier=d._id)}}else i.location&&typeof i.location!="object"?o.location=i.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(i,o){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const d=new a(o),E=this._setupExtHostProcessListeners(i,d);this._terminalProcessDisposables[i]=E}async $acceptActiveTerminalChanged(i){const o=this._activeTerminal;if(i===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(i);m&&(this._activeTerminal=m,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,o){const m=this._getTerminalById(i);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:o})}async $acceptTerminalDimensions(i,o,m){const d=this._getTerminalById(i);d&&d.setDimensions(o,m)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(i,o,m){this._terminalProcesses.get(i)?.resize(o,m)}async $acceptTerminalTitleChange(i,o){const m=this._getTerminalById(i);m&&(m.name=o)}async $acceptTerminalClosed(i,o){const m=this._getTerminalObjectIndexById(this._terminals,i);if(m!==null){const d=this._terminals.splice(m,1)[0];d.setExitCode(o),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(i,o,m,d){if(o){const L=this._getTerminalObjectIndexById(this._terminals,o);if(L!==null){this._terminals[L]._id=i,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const E={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:T.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},P=new _(this._proxy,i,E,m);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(i,o){const m=this._getTerminalById(i);m&&m._setProcessId(o)}async $startExtensionTerminal(i,o){const m=this._getTerminalById(i);if(!m)return{message:(0,R.localize)(0,null,i)};m.isOpen||await new Promise(E=>{const P=this.onDidOpenTerminal(async L=>{L===m.value&&(P.dispose(),E())})});const d=this._terminalProcesses.get(i);d?d.startSendingEvents(o):this._extensionTerminalAwaitingStart[i]={initialDimensions:o}}_setupExtHostProcessListeners(i,o){const m=new k.DisposableStore;m.add(o.onProcessReady(E=>this._proxy.$sendProcessReady(i,E.pid,E.cwd))),m.add(o.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(i,E))),this._bufferer.startBuffering(i,o.onProcessData),m.add(o.onProcessExit(E=>this._onProcessExit(i,E))),this._terminalProcesses.set(i,o);const d=this._extensionTerminalAwaitingStart[i];return d&&o instanceof a&&(o.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),m}$acceptProcessAckDataEvent(i,o){this._terminalProcesses.get(i)?.acknowledgeDataEvent(o)}$acceptProcessInput(i,o){this._terminalProcesses.get(i)?.input(o)}$acceptTerminalInteraction(i){const o=this._getTerminalById(i);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(i,o,m){try{this._terminalProcesses.get(i)?.resize(o,m)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(i,o){this._terminalProcesses.get(i)?.shutdown(o)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(i,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(o=>this._proxy.$sendProcessProperty(i,{type:"cwd",value:o}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,o,m){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,m),this._proxy.$registerProfileProvider(o,i.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(i,o){const m=new p.CancellationTokenSource().token;let d=await this._profileProviders.get(i)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,o);return}this.createTerminalFromOptions(d.options,o)}}async $provideLinks(i,o){const m=this._getTerminalById(i);if(!m)return[];this._terminalLinkCache.delete(i);const d=this._terminalLinkCancellationSource.get(i);d&&d.dispose(!0);const E=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,E);const P=[],L={terminal:m.value,line:o},O=[];for(const M of this._linkProviders)O.push(A.Promises.withAsyncBody(async j=>{E.token.onCancellationRequested(()=>j({provider:M,links:[]}));const Q=await M.provideTerminalLinks(L,E.token)||[];E.token.isCancellationRequested||j({provider:M,links:Q})}));const y=await Promise.all(O);if(E.token.isCancellationRequested)return[];const H=new Map;for(const M of y)M&&M.links.length>0&&P.push(...M.links.map(j=>{const Q={id:l++,startIndex:j.startIndex,length:j.length,label:j.tooltip};return H.set(Q.id,{provider:M.provider,link:j}),Q}));return this._terminalLinkCache.set(i,H),P}$activateLink(i,o){const m=this._terminalLinkCache.get(i)?.get(o);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(i,o){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const m=this._terminalProcessDisposables[i];m&&(m.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,o)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,o){const m=this._getTerminalObjectIndexById(i,o);return m!==null?i[m]:null}_getTerminalObjectIndexById(i,o){let m=null;return i.some((d,E)=>d._id===o?(m=E,!0):!1),m}getEnvironmentVariableCollection(i){let o=this._environmentVariableCollections.get(i.identifier.value);return o||(o=new c,this._setEnvironmentVariableCollection(i.identifier.value,o)),o}_syncEnvironmentVariableCollection(i,o){const m=(0,D.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(i,o.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(i){i.forEach(o=>{const m=o[0],d=new c(o[1]);this._setEnvironmentVariableCollection(m,d)})}$acceptDefaultProfile(i,o){this._defaultProfile=i,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(i,o){this._environmentVariableCollections.set(i,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,o)})}};u=Be([Fe(1,C.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class c{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,o){this._setIfDiffers(i,{value:o,type:S.EnvironmentVariableMutatorType.Replace})}append(i,o){this._setIfDiffers(i,{value:o,type:S.EnvironmentVariableMutatorType.Append})}prepend(i,o){this._setIfDiffers(i,{value:o,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,o){const m=this.map.get(i);(!m||m.value!==o.value||m.type!==o.type)&&(this.map.set(i,o),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,o){this.map.forEach((m,d)=>i.call(o,d,m,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let w=class extends u{constructor(i){super(!1,i)}createTerminal(i,o,m){throw new F.NotSupportedError}createTerminalFromOptions(i,o){throw new F.NotSupportedError}};w=Be([Fe(0,C.IExtHostRpcService)],w),e.WorkerExtHostTerminalService=w;function s(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function n(r){return h.ThemeColor.isThemeColor(r)?r:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[251],we([1,0,18,22,21,3,74,57,6,25,13,33,5,17,62,14,7,222,84,85]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let u=class{constructor(L,O){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(p.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new w(this.proxy),O.registerArgumentProcessor({processArgument:y=>y?.$mid===13?h.TestItem.toItemFromContext(y):y})}createTestController(L,O,y){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const H=new S.DisposableStore,M=H.add(new A.SingleUseTestCollection(L));M.root.label=O;const j=new Map,Q=this.proxy,$={items:M.root.children,get label(){return O},set label(q){O=q,M.root.label=q,Q.$updateController(L,{label:O})},get refreshHandler(){return y},set refreshHandler(q){y=q,Q.$updateController(L,{canRefresh:!!q})},get id(){return L},createRunProfile:(q,K,G,ee,oe)=>{let ue=(0,k.hash)(q);for(;j.has(ue);)ue++;const Z=new d(this.proxy,L,ue,q,K,G,ee,oe);return j.set(ue,Z),Z},createTestItem(q,K,G){return new g.TestItemImpl(L,q,K,G)},createTestRun:(q,K,G=!0)=>this.runTracker.createTestRun(L,M,q,K,G),set resolveHandler(q){M.resolveHandler=q},get resolveHandler(){return M.resolveHandler},dispose:()=>{H.dispose()}};Q.$registerTestController(L,O,!!y),H.add((0,S.toDisposable)(()=>Q.$unregisterTestController(L)));const U={controller:$,collection:M,profiles:j};return this.controllers.set(L,U),H.add((0,S.toDisposable)(()=>this.controllers.delete(L))),H.add(M.onDidGenerateDiff(q=>Q.$publishDiff(L,q.map(_.TestsDiffOp.serialize)))),$}createTestObserver(){return this.observer.checkout()}async runTests(L,O=I.CancellationToken.None){const y=s(L);if(!y)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(y.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(M=>M.id)??[H.collection.root.id],profileGroup:E[y.kind],profileId:y.profileId,controllerId:y.controllerId}],exclude:L.exclude?.map(M=>M.id)},O)}$provideFileCoverage(L,O,y){return(0,f.mapFind)(this.runTracker.trackers,M=>M.id===L?M.getCoverage(O):void 0)?.provideFileCoverage(y)??Promise.resolve([])}$resolveFileCoverage(L,O,y,H){return(0,f.mapFind)(this.runTracker.trackers,j=>j.id===L?j.getCoverage(O):void 0)?.resolveFileCoverage(y,H)??Promise.resolve([])}$configureRunProfile(L,O){this.controllers.get(L)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(L,O){await this.controllers.get(L)?.controller.refreshHandler?.(O)}$publishTestResults(L){this.results=Object.freeze(L.map(O=>(0,R.deepFreeze)(h.TestResults.to(O))).concat(this.results).sort((O,y)=>y.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,O){const y=this.controllers.get(a.TestId.fromString(L).controllerId)?.collection;y&&(await y.expand(L,O<0?1/0:O),y.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(_.TestsDiffOp.deserialize))}async $runControllerTests(L,O){const y=this.controllers.get(L.controllerId);if(!y)return;const{collection:H,profiles:M}=y,j=M.get(L.profileId);if(!j)return;const Q=L.testIds.map(K=>H.tree.get(K)).filter(F.isDefined),$=L.excludeExtIds.map(K=>y.collection.tree.get(K)).filter(F.isDefined).filter(K=>Q.some(G=>G.fullId.compare(K.fullId)===2));if(!Q.length)return;const U=new v.TestRunRequest(Q.some(K=>K.actual instanceof g.TestItemRootImpl)?void 0:Q.map(K=>K.actual),$.map(K=>K.actual),j),q=this.runTracker.prepareForMainThreadTestRun(U,n.fromInternal(L,y.collection),O);try{await j.runHandler(U,O)}finally{q.isRunning&&!O.isCancellationRequested&&await T.Event.toPromise(q.onEnd),q.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};u=Be([Fe(0,b.IExtHostRpcService)],u),e.ExtHostTesting=u;class c extends S.Disposable{constructor(L,O,y){super();this.dto=L,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(y)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const O=this.dto.id,y=this.dto.controllerId,H=(0,D.generateUuid)(),M=new r(this.proxy,O,H),j=q=>(K,...G)=>{if($){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),q(K,...G))},Q=(q,K)=>{const G=K instanceof Array?K.map(h.TestMessage.from):[h.TestMessage.from(K)];if(q.uri&&q.range){const ee={range:h.Range.from(q.range),uri:q.uri};for(const oe of G)oe.location=oe.location||ee}this.proxy.$appendTestMessagesInRun(O,H,a.TestId.fromExtHostTestItem(q,y).toString(),G)};let $=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return M.coverageProvider},set coverageProvider(q){M.coverageProvider=q},enqueued:j(q=>{this.proxy.$updateTestStateInRun(O,H,a.TestId.fromExtHostTestItem(q,y).toString(),1)}),skipped:j(q=>{this.proxy.$updateTestStateInRun(O,H,a.TestId.fromExtHostTestItem(q,y).toString(),5)}),started:j(q=>{this.proxy.$updateTestStateInRun(O,H,a.TestId.fromExtHostTestItem(q,y).toString(),2)}),errored:j((q,K,G)=>{Q(q,K),this.proxy.$updateTestStateInRun(O,H,a.TestId.fromExtHostTestItem(q,y).toString(),6,G)}),failed:j((q,K,G)=>{Q(q,K),this.proxy.$updateTestStateInRun(O,H,a.TestId.fromExtHostTestItem(q,y).toString(),4,G)}),passed:j((q,K)=>{this.proxy.$updateTestStateInRun(O,H,a.TestId.fromExtHostTestItem(q,this.dto.controllerId).toString(),3,K)}),appendOutput:(q,K,G)=>{$||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(O,H,t.VSBuffer.fromString(q),K&&h.location.from(K),G&&a.TestId.fromExtHostTestItem(G,y).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(O,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:U,coverage:M}),this.proxy.$startedTestRunTask(O,{id:H,name:L,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof g.TestItemImpl))throw new g.InvalidTestItemError(L.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const O=[],y=this.dto.colllection.root;for(;;){const H=h.TestItem.from(L);if(O.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),L===y))break;L=L.parent||y}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class w{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,O,y){return this.getTracker(L,O,y)}cancelRunById(L){for(const O of this.tracked.values())if(O.id===L){O.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,O,y,H,M){const j=this.tracked.get(y);if(j)return j.createRun(H);const Q=n.fromPublic(L,O,y,M),$=s(y);this.proxy.$startedExtensionTestRun({controllerId:L,profile:$&&{group:E[$.kind],id:$.profileId},exclude:y.exclude?.map(q=>q.id)??[],id:Q.id,include:y.include?.map(q=>q.id)??[O.root.id],persist:M});const U=this.getTracker(y,Q);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(Q.id)),U.createRun(H)}getTracker(L,O,y){const H=new c(O,this.proxy,y);return this.tracked.set(L,H),H.onEnd(()=>this.tracked.delete(L)),H}}e.TestRunCoordinator=w;const s=P=>{if(!!P.profile){if(!(P.profile instanceof d))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class n{constructor(L,O,y,H,M,j){this.controllerId=L,this.id=O,this.isPersisted=M,this.colllection=j,this.includePrefix=y.map(Q=>Q+"\0"),this.excludePrefix=H.map(Q=>Q+"\0")}static fromPublic(L,O,y,H){return new n(L,(0,D.generateUuid)(),y.include?.map(M=>a.TestId.fromExtHostTestItem(M,L).toString())??[L],y.exclude?.map(M=>a.TestId.fromExtHostTestItem(M,L).toString())??[],H,O)}static fromInternal(L,O){return new n(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,O)}isIncluded(L){const O=a.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const y of this.excludePrefix)if(O===y||O.startsWith(y))return!1;for(const y of this.includePrefix)if(O===y||O.startsWith(y))return!0;return!1}}e.TestRunDto=n;class r{constructor(L,O,y){this.proxy=L,this.runId=O,this.taskId=y}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(L,O){const y=await this.fileCoverage;let H=y?.[L];return!this._coverageProvider||!y||!H?[]:(H.detailedCoverage||(H=y[L]=await this._coverageProvider.resolveFileCoverage?.(H,O)??H),H.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class i extends _.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,h.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:O,removed:y}=this;return{get added(){return[...L].map(H=>H.revived)},get updated(){return[...O].map(H=>H.revived)},get removed(){return[...y].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,O){return{...L,revived:h.TestItem.toPlain(L.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new i(this.changeEmitter)}}e.MirroredTestCollection=o;class m{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(O=>O.revived)},dispose:(0,C.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class d{constructor(L,O,y,H,M,j,Q=!1,$=void 0){this.controllerId=O,this.profileId=y,this._label=H,this.kind=M,this.runHandler=j,this._isDefault=Q,this._tag=$,l.set(this,void 0),Xe(this,l,L,"f");const U=E[M];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Pe(this,l,"f").$publishTestRunProfile({profileId:y,controllerId:O,tag:$?h.TestTag.namespace(this.controllerId,$.id):null,label:H,group:U,isDefault:Q,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Pe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Pe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Pe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?h.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Pe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Pe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=d,l=new WeakMap;const E={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(ve[252],we([1,0,3,18,5,131,14,7]),function(te,e,f,t,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(F,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const D=this._extHostDocumentsAndEditors.allEditors();return F?D:D.map(p=>p.value)}async showTextDocument(F,D,p){let b;typeof D=="number"?b={position:C.ViewColumn.from(D),preserveFocus:p}:typeof D=="object"?b={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:b={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(F.uri,b),h=g&&this._extHostDocumentsAndEditors.getEditor(g);if(h)return h.value;throw g?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,D){return new T.TextEditorDecorationType(this._proxy,F,D).value}$acceptEditorPropertiesChanged(F,D){const p=this._extHostDocumentsAndEditors.getEditor(F);if(!p)throw new Error("unknown text editor");if(D.options&&p._acceptOptions(D.options),D.selections){const b=D.selections.selections.map(C.Selection.to);p._acceptSelections(b)}if(D.visibleRanges){const b=t.coalesce(D.visibleRanges.map(C.Range.to));p._acceptVisibleRanges(b)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...D.options,lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const b=k.TextEditorSelectionChangeKind.fromValue(D.selections.source),g=D.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:g,kind:b})}if(D.visibleRanges){const b=t.coalesce(D.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:b})}}$acceptEditorPositionData(F){for(const D in F){const p=this._extHostDocumentsAndEditors.getEditor(D);if(!p)throw new Error("Unknown text editor");const b=C.ViewColumn.to(F[D]);p.value.viewColumn!==b&&(p._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:b}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=S}),define(ve[253],we([1,0,2,4,5,6,7,14,13]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class R{constructor(p,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=p.getProxy(I.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===11){const h=g.uri===void 0?void 0:f.URI.revive(g.uri);return this._itemsBySourceAndUriMap.get(g.source)?.get(F(h))?.get(g.handle)}return g}})}async $getTimeline(p,b,g,h,v){return this._providers.get(p)?.provideTimeline(f.URI.revive(b),g,h,v)}registerTimelineProvider(p,b,g,h){const v=new T.DisposableStore,A=this.convertTimelineItem(b.id,h,v).bind(this);let _;b.onDidChange&&(_=b.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:b.id}),this));const a=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:p,onDidChange:void 0,async provideTimeline(l,u,c,w){w?.resetCache&&(v.clear(),a.get(b.id)?.clear());const s=await b.provideTimeline(l,u,c);if(s==null)return;const n=A(l,w);return{...s,source:b.id,items:s.items.map(n)}},dispose(){for(const l of a.values())l.get(b.id)?.clear();_?.dispose(),v.dispose()}})}convertTimelineItem(p,b,g){return(h,v)=>{let A;if(v?.cacheResults){let _=this._itemsBySourceAndUriMap.get(p);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(p,_));const a=F(h);A=_.get(a),A===void 0&&(A=new Map,_.set(a,A))}return _=>{const{iconPath:a,...l}=_,u=`${p}|${_.id??_.timestamp}`;A?.set(u,_);let c,w,s;_.iconPath&&(a instanceof C.ThemeIcon?s={id:a.id,color:a.color}:f.URI.isUri(a)?(c=a,w=a):{light:c,dark:w}=a);let n;return C.MarkdownString.isMarkdownString(l.detail)?n=k.MarkdownString.from(l.detail):(0,S.isString)(l.detail)&&(n=l.detail),{...l,id:l.id??void 0,handle:u,source:p,command:_.command?b.toInternal(_.command,g):void 0,icon:c,iconDark:w,themeIcon:s,detail:n,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(p){if(this._providers.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this._proxy.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this._providers.set(p.id,p),(0,T.toDisposable)(()=>{for(const g of this._itemsBySourceAndUriMap.values())g.get(p.id)?.clear();this._providers.delete(p.id),this._proxy.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=R;function F(D){return D?.toString()}}),define(ve[254],we([1,0,6,10,2,5]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,R,F,D){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const p=D.schemes.find(b=>!C.supportedSchemes.has(b));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,F),this._proxy.$registerUriOpener(R,D.schemes,S,D.label),(0,f.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(S,R,F){const D=this._openers.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const p=I.URI.revive(R);return D.canOpenExternalUri(p,F)}async $openUri(S,R,F){const D=this._openers.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(I.URI.revive(R.resolvedUri),{sourceUri:I.URI.revive(R.sourceUri)},F)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ve[255],we([1,0,5,2,6,15,27]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(R,F){if(this.handles.has(C.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const D=k.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(R)),this.handlers.set(D,F),this._proxy.$registerUriHandler(D,R),(0,I.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(R)),this.handlers.delete(D),this._proxy.$unregisterUriHandler(D)})}$handleExternalUri(R,F){const D=this.handlers.get(R);if(!D)return Promise.resolve(void 0);try{D.handleUri(t.URI.revive(F))}catch(p){(0,T.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(R){return t.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=k,k.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[67],we([1,0,3,10,2,183,204,83,5]),function(te,e,f,t,I,T,C,k,S){"use strict";var R,F,D,p,b,g,h,v,A,_,a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(m,d,E,P,L,O,y){R.set(this,void 0),F.set(this,void 0),D.set(this,void 0),p.set(this,void 0),b.set(this,void 0),g.set(this,void 0),h.set(this,""),v.set(this,void 0),A.set(this,!1),_.set(this,!1),a.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new f.Emitter),this._onDidDispose=Pe(this,l,"f").event,Xe(this,R,m,"f"),Xe(this,F,d,"f"),Xe(this,v,E,"f"),Xe(this,p,P,"f"),Xe(this,b,L,"f"),Xe(this,g,O,"f"),Xe(this,a,c(O),"f"),Xe(this,D,y,"f")}dispose(){Xe(this,A,!0,"f"),Pe(this,l,"f").fire(),Pe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Xe(this,_,!0,"f"),(0,k.asWebviewUri)(m,Pe(this,p,"f").remote)}get cspSource(){const m=Pe(this,g,"f").extensionLocation;if(m.scheme===t.Schemas.https||m.scheme===t.Schemas.http){let d=m.toString();return d.endsWith("/")||(d+="/"),d+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Pe(this,h,"f")}set html(m){this.assertNotDisposed(),Pe(this,h,"f")!==m&&(Xe(this,h,m,"f"),!Pe(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Xe(this,_,!0,"f"),Pe(this,D,"f").report("Webview vscode-resource: uris",Pe(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Pe(this,F,"f").$setHtml(Pe(this,R,"f"),m))}get options(){return this.assertNotDisposed(),Pe(this,v,"f")}set options(m){this.assertNotDisposed(),Pe(this,F,"f").$setOptions(Pe(this,R,"f"),n(Pe(this,g,"f"),Pe(this,b,"f"),m)),Xe(this,v,m,"f")}async postMessage(m){if(Pe(this,A,"f"))return!1;const d=(0,C.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Pe(this,a,"f")});return Pe(this,F,"f").$postMessage(Pe(this,R,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Pe(this,A,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,R=new WeakMap,F=new WeakMap,D=new WeakMap,p=new WeakMap,b=new WeakMap,g=new WeakMap,h=new WeakMap,v=new WeakMap,A=new WeakMap,_=new WeakMap,a=new WeakMap,l=new WeakMap;function c(o){try{const m=(0,T.normalizeVersion)((0,T.parseVersion)(o.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;class w{constructor(m,d,E,P,L){this.initData=d,this.workspace=E,this._logService=P,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=m.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(m,d,E){const P=this.getWebview(m);if(P){const{message:L}=(0,C.deserializeWebviewMessage)(d,E.value);P._onMessageEmitter.fire(L)}}$onMissingCsp(m,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,d,E){const P=new u(m,this._webviewProxy,r(d),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(m,P),P._onDidDispose(()=>{this._webviews.delete(m)}),P}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=w;function s(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=s;function n(o,m,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||i(o,m)}}e.serializeWebviewOptions=n;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(m=>I.URI.from(m))}}e.reviveOptions=r;function i(o,m){return[...(m?.getWorkspaceFolders()||[]).map(d=>d.uri),o.extensionLocation]}}),define(ve[256],we([1,0,21,57,6,10,23,2,14,67,82,5,7]),function(te,e,f,t,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(c,w){this.document=c,this._storagePath=w,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,w){await this.getEdit(c).undo(),w||this.disposeBackup()}async redo(c,w){await this.getEdit(c).redo(),w||this.disposeBackup()}disposeEdits(c){for(const w of c)this._edits.delete(w)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=l(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const w=this._edits.get(c,0);if(!w)throw new Error("No edit found");return w}}class g{constructor(){this._documents=new Map}get(c,w){return this._documents.get(this.key(c,w))}add(c,w,s){const n=this.key(c,w.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${c} resource:${w.uri}`);const r=new b(w,s);return this._documents.set(n,r),r}delete(c,w){const s=this.key(c,w.uri);this._documents.delete(s)}key(c,w){return`${c}@@@${w}`}}var h;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(h||(h={}));class v{constructor(){this._providers=new Map}addTextProvider(c,w,s){return this.add(0,c,w,s)}addCustomProvider(c,w,s){return this.add(1,c,w,s)}get(c){return this._providers.get(c)}add(c,w,s,n){if(this._providers.has(w))throw new Error(`Provider for viewType:${w} already registered`);return this._providers.set(w,{type:c,extension:s,provider:n}),new p.Disposable(()=>this._providers.delete(w))}}class A{constructor(c,w,s,n,r){this._extHostDocuments=w,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=r,this._editorProviders=new v,this._documents=new g,this._proxy=c.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,w,s,n){const r=new I.DisposableStore;return _(s)?(r.add(this._editorProviders.addTextProvider(w,c,s)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(c),w,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(c))):(r.add(this._editorProviders.addCustomProvider(w,c,s)),this.supportEditing(s)&&r.add(s.onDidChangeCustomDocument(i=>{const o=this.getCustomDocumentEntry(w,i.document.uri);if(a(i)){const m=o.addEdit(i);this._proxy.$onDidEdit(i.document.uri,w,m,i.label)}else this._proxy.$onContentChange(i.document.uri,w)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(c),w,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(c))),p.Disposable.from(r,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(w)}))}async $createCustomDocument(c,w,s,n,r){const i=this._editorProviders.get(w);if(!i)throw new Error(`No provider found for '${w}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${w}'`);const o=k.URI.revive(c),m=await i.provider.openCustomDocument(o,{backupId:s,untitledDocumentData:n?.buffer},r);let d;return this.supportEditing(i.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension)),this._documents.add(w,m,d),{editable:this.supportEditing(i.provider)}}async $disposeCustomDocument(c,w){const s=this._editorProviders.get(w);if(!s)throw new Error(`No provider found for '${w}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${w}'`);const n=k.URI.revive(c),{document:r}=this.getCustomDocumentEntry(w,n);this._documents.delete(w,r),r.dispose()}async $resolveWebviewEditor(c,w,s,n,r,i){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);const m=S.ViewColumn.to(r),d=this._extHostWebview.createNewWebview(w,n.webviewOptions,o.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(w,s,n.title,m,n.panelOptions,d),P=k.URI.revive(c);switch(o.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,P);return o.provider.resolveCustomEditor(L,E,i)}case 0:{const L=this._extHostDocuments.getDocument(P);return o.provider.resolveCustomTextEditor(L,E,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,w,s){this.getCustomDocumentEntry(w,c).disposeEdits(s)}async $onMoveCustomEditor(c,w,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const r=this._extHostWebviewPanels.getWebviewPanel(c);if(!r)throw new Error("No webview found");const i=k.URI.revive(w),o=this._extHostDocuments.getDocument(i);await n.provider.moveCustomTextEditor(o,r,f.CancellationToken.None)}async $undo(c,w,s,n){return this.getCustomDocumentEntry(w,c).undo(s,n)}async $redo(c,w,s,n){return this.getCustomDocumentEntry(w,c).redo(s,n)}async $revert(c,w,s){const n=this.getCustomDocumentEntry(w,c);await this.getCustomEditorProvider(w).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(c,w,s){const n=this.getCustomDocumentEntry(w,c);await this.getCustomEditorProvider(w).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(c,w,s,n){const r=this.getCustomDocumentEntry(w,c);return this.getCustomEditorProvider(w).saveCustomDocumentAs(r.document,k.URI.revive(s),n)}async $backup(c,w,s){const n=this.getCustomDocumentEntry(w,c),i=await this.getCustomEditorProvider(w).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(i),i.id}getCustomDocumentEntry(c,w){const s=this._documents.get(c,k.URI.revive(w));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(c){const s=this._editorProviders.get(c)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(c){return!!c.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function _(u){return typeof u.resolveCustomTextEditor=="function"}function a(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function l(u){const c=u.scheme===T.Schemas.file||u.scheme===T.Schemas.untitled?u.fsPath:u.toString();return(0,t.hash)(c)+""}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[257],we([1,0,3,6,2,33,14,67,5,7]),function(te,e,f,t,I,T,C,k,S,R){"use strict";var F,D,p,b,g,h,v,A,_,a,l,u,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class w extends t.Disposable{constructor(i,o,m,d,E,P,L){super();F.set(this,void 0),D.set(this,void 0),p.set(this,void 0),b.set(this,void 0),g.set(this,void 0),h.set(this,void 0),v.set(this,void 0),A.set(this,void 0),_.set(this,!0),a.set(this,!0),l.set(this,!1),u.set(this,this._register(new f.Emitter)),this.onDidDispose=Pe(this,u,"f").event,c.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Pe(this,c,"f").event,Xe(this,F,i,"f"),Xe(this,D,o,"f"),Xe(this,p,m,"f"),Xe(this,g,P,"f"),Xe(this,A,E,"f"),Xe(this,h,d,"f"),Xe(this,b,L,"f")}dispose(){Pe(this,l,"f")||(Xe(this,l,!0,"f"),Pe(this,u,"f").fire(),Pe(this,D,"f").$disposeWebview(Pe(this,F,"f")),Pe(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Pe(this,b,"f")}get viewType(){return this.assertNotDisposed(),Pe(this,p,"f")}get title(){return this.assertNotDisposed(),Pe(this,h,"f")}set title(i){this.assertNotDisposed(),Pe(this,h,"f")!==i&&(Xe(this,h,i,"f"),Pe(this,D,"f").$setTitle(Pe(this,F,"f"),i))}get iconPath(){return this.assertNotDisposed(),Pe(this,v,"f")}set iconPath(i){this.assertNotDisposed(),Pe(this,v,"f")!==i&&(Xe(this,v,i,"f"),Pe(this,D,"f").$setIconPath(Pe(this,F,"f"),I.URI.isUri(i)?{light:i,dark:i}:i))}get options(){return Pe(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Pe(this,A,"f")=="number"&&Pe(this,A,"f")<0))return Pe(this,A,"f")}get active(){return this.assertNotDisposed(),Pe(this,a,"f")}get visible(){return this.assertNotDisposed(),Pe(this,_,"f")}_updateViewState(i){Pe(this,l,"f")||(this.active!==i.active||this.visible!==i.visible||this.viewColumn!==i.viewColumn)&&(Xe(this,a,i.active,"f"),Xe(this,_,i.visible,"f"),Xe(this,A,i.viewColumn,"f"),Pe(this,c,"f").fire({webviewPanel:this}))}reveal(i,o){this.assertNotDisposed(),Pe(this,D,"f").$reveal(Pe(this,F,"f"),{viewColumn:typeof i=="undefined"?void 0:C.ViewColumn.from(i),preserveFocus:!!o})}assertNotDisposed(){if(Pe(this,l,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,D=new WeakMap,p=new WeakMap,b=new WeakMap,g=new WeakMap,h=new WeakMap,v=new WeakMap,A=new WeakMap,_=new WeakMap,a=new WeakMap,l=new WeakMap,u=new WeakMap,c=new WeakMap;class s{constructor(i,o,m){this.webviews=o,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=i.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(i,o,m,d,E={}){const P=typeof d=="object"?d.viewColumn:d,L={viewColumn:C.ViewColumn.from(P),preserveFocus:typeof d=="object"&&!!d.preserveFocus},O=(0,k.shouldSerializeBuffersForPostMessage)(i),y=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(i),y,o,{title:m,panelOptions:n(E),webviewOptions:(0,k.serializeWebviewOptions)(i,this.workspace,E),serializeBuffersForPostMessage:O},L);const H=this.webviews.createNewWebview(y,E,i);return this.createNewWebviewPanel(y,o,m,P,E,H)}$onDidChangeWebviewPanelViewStates(i){const o=Object.keys(i);o.sort((m,d)=>{const E=i[m],P=i[d];return E.active?1:P.active?-1:+E.visible-+P.visible});for(const m of o){const d=this.getWebviewPanel(m);if(!d)continue;const E=i[m];d._updateViewState({active:E.active,visible:E.visible,viewColumn:C.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(i){this.getWebviewPanel(i)?.dispose(),this._webviewPanels.delete(i),this.webviews.deleteWebview(i)}registerWebviewPanelSerializer(i,o,m){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:m,extension:i}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(i)}),new R.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(i,o,m,d){const E=this._serializers.get(o);if(!E)throw new Error(`No serializer found for '${o}'`);const{serializer:P,extension:L}=E,O=this.webviews.createNewWebview(i,m.webviewOptions,L),y=this.createNewWebviewPanel(i,o,m.title,d,m.panelOptions,O);await P.deserializeWebviewPanel(y,m.state)}createNewWebviewPanel(i,o,m,d,E,P){const L=new w(i,this._proxy,o,m,d,E,P);return this._webviewPanels.set(i,L),L}getWebviewPanel(i){return this._webviewPanels.get(i)}}e.ExtHostWebviewPanels=s;function n(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[258],we([1,0,3,6,67,5,7]),function(te,e,f,t,I,T,C){"use strict";var k,S,R,F,D,p,b,g,h,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends t.Disposable{constructor(l,u,c,w,s,n){super();k.set(this,void 0),S.set(this,void 0),R.set(this,void 0),F.set(this,void 0),D.set(this,!1),p.set(this,void 0),b.set(this,void 0),g.set(this,void 0),h.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Pe(this,h,"f").event,v.set(this,this._register(new f.Emitter)),this.onDidDispose=Pe(this,v,"f").event,Xe(this,R,c,"f"),Xe(this,b,w,"f"),Xe(this,k,l,"f"),Xe(this,S,u,"f"),Xe(this,F,s,"f"),Xe(this,p,n,"f")}dispose(){Pe(this,D,"f")||(Xe(this,D,!0,"f"),Pe(this,v,"f").fire(),Pe(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Pe(this,b,"f")}set title(l){this.assertNotDisposed(),Pe(this,b,"f")!==l&&(Xe(this,b,l,"f"),Pe(this,S,"f").$setWebviewViewTitle(Pe(this,k,"f"),l))}get description(){return this.assertNotDisposed(),Pe(this,g,"f")}set description(l){this.assertNotDisposed(),Pe(this,g,"f")!==l&&(Xe(this,g,l,"f"),Pe(this,S,"f").$setWebviewViewDescription(Pe(this,k,"f"),l))}get visible(){return Pe(this,p,"f")}get webview(){return Pe(this,F,"f")}get viewType(){return Pe(this,R,"f")}_setVisible(l){l===Pe(this,p,"f")||Pe(this,D,"f")||(Xe(this,p,l,"f"),Pe(this,h,"f").fire())}show(l){this.assertNotDisposed(),Pe(this,S,"f").$show(Pe(this,k,"f"),!!l)}assertNotDisposed(){if(Pe(this,D,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,R=new WeakMap,F=new WeakMap,D=new WeakMap,p=new WeakMap,b=new WeakMap,g=new WeakMap,h=new WeakMap,v=new WeakMap;class _{constructor(l,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,u,c,w){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:c,extension:l}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(l),u,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(l,u,c,w,s){const n=this._viewProviders.get(u);if(!n)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:i}=n,o=this._extHostWebview.createNewWebview(l,{},i),m=new A(l,this._proxy,u,c,o,!0);this._webviewViews.set(l,m),await r.resolveWebviewView(m,{state:w},s)}async $onDidChangeWebviewViewVisibility(l,u){this.getWebviewView(l)._setVisible(u)}async $disposeWebviewView(l){const u=this.getWebviewView(l);this._webviewViews.delete(l),u.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const u=this._webviewViews.get(l);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=_}),define(ve[136],we([1,0,3,5,2,10,8,4,17]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class ji{constructor(D){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=D.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(p=>this.$onDidChangeWindowFocus(p))}get state(){return this._state}$onDidChangeWindowFocus(D){D!==this._state.focused&&(this._state={...this._state,focused:D},this._onDidChangeWindowState.fire(this._state))}openUri(D,p){let b;if(typeof D=="string"){b=D;try{D=I.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this._proxy.$openUri(D,b,p)}async asExternalUri(D,p){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(D,p);return I.URI.from(b)}};R.InitialState={focused:!0},R=Be([Fe(0,S.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ve[259],we([1,0,9,60,33,39,6,5,2,17]),function(te,e,f,t,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let F=class extends C.Disposable{constructor(p,b){super();const g=p.getProxy(k.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async h=>{const v=S.URI.file((0,f.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await g.$download(h,v),v})}};F=Be([Fe(0,R.IExtHostRpcService),Fe(1,T.IExtHostCommands)],F),e.ExtHostDownloadService=F}),define(ve[260],we([1,0,134,10,189,33]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends f.ExtHostLoggerService{doCreateLogger(S,R,F){return S.scheme===t.Schemas.file?new I.SpdLogLogger(F?.name||(0,T.generateUuid)(),S.fsPath,!F?.donotRotate,!!F?.donotUseFormatters,R):super.doCreateLogger(S,R,F)}}e.ExtHostLoggerService=C}),define(ve[261],we([1,0,59,9,2,66,6,10,16,28]),function(te,e,f,t,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class F extends T.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(c){const w=await super._getWorkspaceStorageURI(c);if(w.scheme!==k.Schemas.file)return w;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${w.fsPath}.`),w;const s=w.fsPath;let n=0;do{let r;n===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${n}`:`${s}-${n}`,await D(r);const i=t.join(r,"vscode.lock"),o=await h(this._logService,i,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),I.URI.file(r);n++}while(n<10);return w}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=F;async function D(u){try{await R.Promises.stat(u);return}catch{}try{await R.Promises.mkdir(u,{recursive:!0})}catch{}}const p=1e3,b=10*60*1e3;class g extends C.Disposable{constructor(c,w){super();this.logService=c,this.filename=w,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await v(c,w);(!s||s.pid!==process.pid)&&(c.info(`Lock '${w}': The lock was lost unexpectedly.`),this._timer.cancel());try{await R.Promises.utimes(w,new Date,new Date)}catch(n){c.error(n),c.info(`Lock '${w}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch{}}async setWillRelease(c){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${c} ms.`);try{const w={pid:process.pid,willReleaseAt:Date.now()+c};await R.Promises.writeFile(this.filename,JSON.stringify(w),{flag:"w"})}catch(w){this.logService.error(w)}}}async function h(u,c,w){try{const n={pid:process.pid,willReleaseAt:0};await R.Promises.writeFile(c,JSON.stringify(n),{flag:"wx"})}catch(n){u.error(n)}const s=await v(u,c);return!s||s.pid!==process.pid?w?(u.info(`Lock '${c}': Could not acquire lock, giving up.`),null):(u.info(`Lock '${c}': Could not acquire lock, checking if the file is stale.`),a(u,c)):(u.info(`Lock '${c}': Lock acquired.`),new g(u,c))}async function v(u,c){let w;try{w=await R.Promises.readFile(c)}catch(s){return u.error(s),null}try{return JSON.parse(String(w))}catch(s){return u.error(s),null}}async function A(u,c){let w;try{w=await R.Promises.stat(c)}catch(s){return u.error(s),0}return w.mtime.getTime()}function _(u){try{return process.kill(u,0),!0}catch{return!1}}async function a(u,c){const w=await v(u,c);if(!w)return u.info(`Lock '${c}': Could not read pid of lock holder.`),l(u,c);if(w.willReleaseAt){let o=w.willReleaseAt-Date.now();if(o<5e3){for(o>0?u.info(`Lock '${c}': The lockfile is scheduled to be released in ${o} ms.`):u.info(`Lock '${c}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,S.timeout)(Math.min(100,o)),await A(u,c)===0)return l(u,c);o=w.willReleaseAt-Date.now()}return l(u,c)}}if(!_(w.pid))return u.info(`Lock '${c}': The pid ${w.pid} appears to be gone.`),l(u,c);const s=await A(u,c),n=Date.now()-s;if(n<=b)return u.info(`Lock '${c}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;u.info(`Lock '${c}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await A(u,c),i=Date.now()-r;return i<=b?(u.info(`Lock '${c}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null):(u.info(`Lock '${c}': The lock looks stale even after waiting for 2s.`),l(u,c))}async function l(u,c){u.info(`Lock '${c}': Deleting a stale lock.`);try{await R.Promises.unlink(c)}catch{}return h(u,c,!0)}}),define(ve[262],we([1,0,33,17,34]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let T=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,R){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:R})}createTerminalFromOptions(k,S){const R=new I.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),k,k.name);return this._terminals.push(R),R.create(k,this._serializeParentTerminal(k,S)),R.value}};T=Be([Fe(0,t.IExtHostRpcService)],T),e.ExtHostTerminalService=T}),define(ve[263],we([1,0,5,17,174,6,26,2,38,23,28,7,12,51,3,123,91,11]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(m,d,E){this.remoteAddress=m,this.localAddress=d,this._dispose=E,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function a(o){const m=o.trim().split(`
`),d=[];return m.forEach(P=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(P);L&&L.length>=3&&d.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),d.reduce((P,L)=>(P[L.socket]=L,P),{})}e.getSockets=a;function l(...o){const m=[].concat(...o.map(c));return[...new Map(m.filter(d=>d.st==="0A").map(d=>{const E=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:u(E[0]),port:parseInt(E[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=l;function u(o){let m="";if(o.length===8)for(let d=o.length-2;d>=0;d-=2)m+=parseInt(o.substr(d,2),16),d!==0&&(m+=".");else for(let d=o.length-4;d>=0;d-=4)m+=parseInt(o.substr(d,4),16).toString(16),d!==0&&(m+=":");return m}e.parseIpAddress=u;function c(o){const m=o.trim().split(`
`),d=m.shift().trim().split(/\s+/).filter(P=>P!=="rx_queue"&&P!=="tm->when");return m.map(P=>P.trim().split(/\s+/).reduce((L,O,y)=>(L[d[y]||y]=O,L),{}))}e.loadConnectionTable=c;function w(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/server-main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function s(o){const m=o.trim().split(`
`),d=[];return m.forEach(E=>{const P=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);P&&P.length>=4&&d.push({pid:parseInt(P[1],10),ppid:parseInt(P[2]),cmd:P[3]})}),d}e.getRootProcesses=s;async function n(o,m,d){const E=d.reduce((L,O)=>(L[O.pid]=O,L),{}),P=[];return o.forEach(({socket:L,ip:O,port:y})=>{const H=m[L]?m[L].pid:void 0,M=H?E[H]?.cmd:void 0;H&&M&&!w(M)&&P.push({host:O,port:y,detail:M,pid:H})}),P}e.findPorts=n;function r(o,m,d){const E=new Map,P=s(m);for(const L of o){const O=d.get(L.port);if(O){E.set(L.port,O);continue}const y=P.find(H=>H.cmd.includes(`${L.port}`));if(y){let H=y,M;do M=P.find(j=>j.ppid===H.pid),M&&(H=M);while(M);E.set(L.port,{host:L.ip,port:L.port,pid:H.pid,detail:H.cmd,ppid:H.ppid})}else E.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=r;let i=class extends T.Disposable{constructor(m,d,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(f.MainContext.MainThreadTunnelService),p.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(d,m.displayName);if(E){const P=new _(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(P),P}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,d){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:m,provider:d}),this._proxy.$registerPortsAttributesProvider(m,E),new D.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(m,d,E,P,L){const O=[];for(const H of m){const M=this._portAttributesProviders.get(H);if(!M)return[];O.push(...await Promise.all(d.map(async j=>M.provider.providePortAttributes(j,E,P,L))))}const y=O.filter(H=>!!H);return y.length>0?y.map(H=>({autoForwardAction:H.autoForwardAction,port:H.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let d=new v.MovingAverage,E;for(;this._candidateFindingEnabled;){const P=new Date().getTime(),L=(await this.findCandidatePorts()).filter(y=>(0,h.isLocalhost)(y.host)||(0,h.isAllInterfaces)(y.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(y=>y.port).join(", ")}`);const O=new Date().getTime()-P;d.update(O),(!E||JSON.stringify(E)!==JSON.stringify(L))&&(E=L,await this._proxy.$onFoundNewCandidates(E)),await new Promise(y=>setTimeout(()=>y(),this.calculateDelay(d.value)))}}async setTunnelFactory(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let d=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const E=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:d}:void 0;this._proxy.$setTunnelProvider(E)}}else this._forwardPortProvider=void 0;return(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,d){if(this._extensionTunnels.has(m.host)){const E=this._extensionTunnels.get(m.host);E.has(m.port)&&(d&&E.get(m.port).disposeListener.dispose(),await E.get(m.port).tunnel.dispose(),E.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(m,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const P=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const L=this._register(P.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(P.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:P,disposeListener:L}),b.TunnelDtoConverter.fromApiTunnel(P)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const d=await Promise.all(m.map(P=>this._showCandidatePort(P.host,P.port,P.detail??""))),E=m.filter((P,L)=>d[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(P=>P.port).join(", ")} to ${E.map(P=>P.port).join(", ")}`),E}async findCandidatePorts(){let m="",d="";try{m=await F.Promises.readFile("/proc/net/tcp","utf8"),d=await F.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=l(m,d),P=await new Promise($=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,q,K)=>{$(q)})}),L=a(P),O=await F.Promises.readdir("/proc"),y=[];for(let $ of O)try{const U=Number($),q=R.joinPath(k.URI.file("/proc"),$);if((await F.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(U)){const G=await F.Promises.readlink(R.joinPath(q,"cwd").fsPath),ee=await F.Promises.readFile(R.joinPath(q,"cmdline").fsPath,"utf8");y.push({pid:U,cwd:G,cmd:ee})}}catch{}const H=[],M=E.filter($=>{const U=L[$.socket];return U||H.push($),U}),j=n(M,L,y);let Q;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${H.length}`),H.length>0){const $=await new Promise(U=>{(0,S.exec)("ps -F -A -l | grep root",(q,K,G)=>{U(K)})});this._foundRootPorts=r(H,$,this._foundRootPorts),Q=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Q.join(", ")}`)}return j.then($=>Q?$.concat(Q):$)}};i=Be([Fe(0,t.IExtHostRpcService),Fe(1,C.IExtHostInitDataService),Fe(2,A.ILogService)],i),e.ExtHostTunnelService=i}),define(ve[264],we([1,0,16,22,21,15,3,6,101,227,52]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function p(E,P){try{return JSON.stringify(E,P)}catch{return"null"}}const b="$$ref$$",g={[b]:-1};class h{constructor(P,L){this.jsonString=P,this.referencedBuffers=L}}function v(E,P=null,L=!1){const O=[];return{jsonString:(L?p:JSON.stringify)(E,(H,M)=>{if(typeof M=="undefined")return g;if(typeof M=="object"){if(M instanceof t.VSBuffer){const j=O.push(M)-1;return{[b]:j}}if(P)return P(H,M)}return M}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=v;function A(E,P,L){return JSON.parse(E,(O,y)=>{if(y){const H=y[b];if(typeof H=="number")return P[H];if(L&&y.$mid===1)return L.transformIncoming(y)}return y})}e.parseJsonAndRestoreBufferRefs=A;function _(E,P){return JSON.stringify(E,P)}function a(E){return E?(P,L)=>L&&L.$mid===1?E.transformOutgoing(L):L:null}var l;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var u;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(u=e.ResponsiveState||(e.ResponsiveState={}));const c=()=>{},w=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class n extends k.Disposable{constructor(P,L=null,O=null){super();this[D]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=L,this._uriTransformer=O,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let y=0,H=F.ProxyIdentifier.count;y<H;y++)this._locals[y]=null,this._proxies[y]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(y=>this._receiveOneMessage(y))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,S.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:L,sid:O}=P;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,O)),this._proxies[L]}_createProxy(P,L){let O={get:(y,H)=>(typeof H=="string"&&!y[H]&&H.charCodeAt(0)===36&&(y[H]=(...M)=>this._remoteCall(P,H,M)),H===s?L:y[H])};return new Proxy(Object.create(null),O)}set(P,L){return this._locals[P.nid]=L,L}assertRegistered(P){for(let L=0,O=P.length;L<O;L++){const y=P[L];if(!this._locals[y.nid])throw new Error(`Missing proxy instance ${y.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const L=P.byteLength,O=r.read(P,0),y=O.readUInt8(),H=O.readUInt32();switch(y){case 1:case 2:{let{rpcId:M,method:j,args:Q}=o.deserializeRequestJSONArgs(O);this._uriTransformer&&(Q=(0,S.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(L,H,M,j,Q,y===2);break}case 3:case 4:{let{rpcId:M,method:j,args:Q}=o.deserializeRequestMixedArgs(O);this._uriTransformer&&(Q=(0,S.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(L,H,M,j,Q,y===4);break}case 5:{this._logger&&this._logger.logIncoming(L,H,0,"ack"),this._onDidReceiveAcknowledge(H);break}case 6:{this._receiveCancel(L,H);break}case 7:{this._receiveReply(L,H,void 0);break}case 9:{let M=o.deserializeReplyOKJSON(O);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(L,H,M);break}case 10:{const M=o.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(L,H,M);break}case 8:{let M=o.deserializeReplyOKVSBuffer(O);this._receiveReply(L,H,M);break}case 11:{let M=o.deserializeReplyErrError(O);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(L,H,M);break}case 12:{this._receiveReplyErr(L,H,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,L,O,y,H,M){this._logger&&this._logger.logIncoming(P,L,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(O)}.${y}(`,H);const j=String(L);let Q,$;if(M){const q=new I.CancellationTokenSource;H.push(q.token),Q=this._invokeHandler(O,y,H),$=()=>q.cancel()}else Q=this._invokeHandler(O,y,H),$=c;this._cancelInvokedHandlers[j]=$;const U=o.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(U.byteLength,L,1,"ack"),this._protocol.send(U),Q.then(q=>{delete this._cancelInvokedHandlers[j];const K=o.serializeReplyOK(L,q,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,L,1,"reply:",q),this._protocol.send(K)},q=>{delete this._cancelInvokedHandlers[j];const K=o.serializeReplyErr(L,q);this._logger&&this._logger.logOutgoing(K.byteLength,L,1,"replyErr:",q),this._protocol.send(K)})}_receiveCancel(P,L){this._logger&&this._logger.logIncoming(P,L,1,"receiveCancel");const O=String(L);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(P,L,O){this._logger&&this._logger.logIncoming(P,L,0,"receiveReply:",O);const y=String(L);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const H=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y],H.resolveOk(O)}_receiveReplyErr(P,L,O){this._logger&&this._logger.logIncoming(P,L,0,"receiveReplyErr:",O);const y=String(L);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const H=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y];let M;O&&(O.$isError?(M=new Error,M.name=O.name,M.message=O.message,M.stack=O.stack):M=O),H.resolveErr(M)}_invokeHandler(P,L,O){try{return Promise.resolve(this._doInvokeHandler(P,L,O))}catch(y){return Promise.reject(y)}}_doInvokeHandler(P,L,O){const y=this._locals[P];if(!y)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(P));let H=y[L];if(typeof H!="function")throw new Error("Unknown method "+L+" on actor "+(0,F.getStringIdentifierForProxy)(P));return H.apply(y,O)}_remoteCall(P,L,O){if(this._isDisposed)return Promise.reject(T.canceled());let y=null;if(O.length>0&&I.CancellationToken.isCancellationToken(O[O.length-1])&&(y=O.pop()),y&&y.isCancellationRequested)return Promise.reject(T.canceled());const H=o.serializeRequestArguments(O,this._uriReplacer),M=++this._lastMessageId,j=String(M),Q=new R.LazyPromise;y&&y.onCancellationRequested(()=>{const U=o.serializeCancel(M);this._logger&&this._logger.logOutgoing(U.byteLength,M,0,"cancel"),this._protocol.send(o.serializeCancel(M))}),this._pendingRPCReplies[j]=Q,this._onWillSendRequest(M);const $=o.serializeRequest(M,P,L,H,!!y);return this._logger&&this._logger.logOutgoing($.byteLength,M,0,`request: ${(0,F.getStringIdentifierForProxy)(P)}.${L}(`,O),this._protocol.send($),Q}}e.RPCProtocol=n,D=w,n.UNRESPONSIVE_TIME=3*1e3;class r{constructor(P,L){this._buff=P,this._offset=L}static alloc(P,L,O){let y=new r(t.VSBuffer.alloc(O+1+4),0);return y.writeUInt8(P),y.writeUInt32(L),y}static read(P,L){return new r(P,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,O}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,O}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,L}static sizeMixedArray(P){let L=0;L+=1;for(let O=0,y=P.length;O<y;O++){const H=P[O];switch(L+=1,H.type){case 1:L+=this.sizeLongString(H.value);break;case 2:L+=this.sizeVSBuffer(H.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(H.value);for(let M=0;M<H.buffers.length;++M)L+=this.sizeVSBuffer(H.buffers[M]);break;case 4:break}}return L}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let L=0,O=P.length;L<O;L++){const y=P[L];switch(y.type){case 1:this.writeUInt8(1),this.writeLongString(y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(y.buffers.length),this.writeLongString(y.value);for(let H=0;H<y.buffers.length;++H)this.writeBuffer(y.buffers[H]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(P);for(let O=0;O<P;O++)switch(this.readUInt8()){case 1:L[O]=this.readLongString();break;case 2:L[O]=this.readVSBuffer();break;case 3:{const H=this.readUInt32(),M=this.readLongString(),j=[];for(let Q=0;Q<H;++Q)j.push(this.readVSBuffer());L[O]=new F.SerializableObjectWithBuffers(A(M,j,null));break}case 4:L[O]=void 0;break}return L}}r.sizeUInt32=4;var i;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(i||(i={}));class o{static _useMixedArgSerialization(P){for(let L=0,O=P.length;L<O;L++)if(P[L]instanceof t.VSBuffer||P[L]instanceof F.SerializableObjectWithBuffers||typeof P[L]=="undefined")return!0;return!1}static serializeRequestArguments(P,L){if(this._useMixedArgSerialization(P)){const O=[];for(let y=0,H=P.length;y<H;y++){const M=P[y];if(M instanceof t.VSBuffer)O[y]={type:2,value:M};else if(typeof M=="undefined")O[y]={type:4};else if(M instanceof F.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:Q}=v(M.value,L);O[y]={type:3,value:t.VSBuffer.fromString(j),buffers:Q}}else O[y]={type:1,value:t.VSBuffer.fromString(_(M,L))}}return{type:1,args:O}}return{type:0,args:_(P,L)}}static serializeRequest(P,L,O,y,H){switch(y.type){case 0:return this._requestJSONArgs(P,L,O,y.args,H);case 1:return this._requestMixedArgs(P,L,O,y.args,H)}}static _requestJSONArgs(P,L,O,y,H){const M=t.VSBuffer.fromString(O),j=t.VSBuffer.fromString(y);let Q=0;Q+=r.sizeUInt8(),Q+=r.sizeShortString(M),Q+=r.sizeLongString(j);let $=r.alloc(H?2:1,P,Q);return $.writeUInt8(L),$.writeShortString(M),$.writeLongString(j),$.buffer}static deserializeRequestJSONArgs(P){const L=P.readUInt8(),O=P.readShortString(),y=P.readLongString();return{rpcId:L,method:O,args:JSON.parse(y)}}static _requestMixedArgs(P,L,O,y,H){const M=t.VSBuffer.fromString(O);let j=0;j+=r.sizeUInt8(),j+=r.sizeShortString(M),j+=r.sizeMixedArray(y);let Q=r.alloc(H?4:3,P,j);return Q.writeUInt8(L),Q.writeShortString(M),Q.writeMixedArray(y),Q.buffer}static deserializeRequestMixedArgs(P){const L=P.readUInt8(),O=P.readShortString(),y=P.readMixedArray(),H=new Array(y.length);for(let M=0,j=y.length;M<j;M++){const Q=y[M];typeof Q=="string"?H[M]=JSON.parse(Q):H[M]=Q}return{rpcId:L,method:O,args:H}}static serializeAcknowledged(P){return r.alloc(5,P,0).buffer}static serializeCancel(P){return r.alloc(6,P,0).buffer}static serializeReplyOK(P,L,O){if(typeof L=="undefined")return this._serializeReplyOKEmpty(P);if(L instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(P,L);if(L instanceof F.SerializableObjectWithBuffers){const{jsonString:y,referencedBuffers:H}=v(L.value,O,!0);return this._serializeReplyOKJSONWithBuffers(P,y,H)}else return this._serializeReplyOKJSON(P,p(L,O))}static _serializeReplyOKEmpty(P){return r.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,L){let O=0;O+=r.sizeVSBuffer(L);let y=r.alloc(8,P,O);return y.writeVSBuffer(L),y.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,L){const O=t.VSBuffer.fromString(L);let y=0;y+=r.sizeLongString(O);let H=r.alloc(9,P,y);return H.writeLongString(O),H.buffer}static _serializeReplyOKJSONWithBuffers(P,L,O){const y=t.VSBuffer.fromString(L);let H=0;H+=r.sizeUInt32,H+=r.sizeLongString(y);for(const j of O)H+=r.sizeVSBuffer(j);let M=r.alloc(10,P,H);M.writeUInt32(O.length),M.writeLongString(y);for(const j of O)M.writeBuffer(j);return M.buffer}static deserializeReplyOKJSON(P){const L=P.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(P,L){const O=P.readUInt32(),y=P.readLongString(),H=[];for(let M=0;M<O;++M)H.push(P.readVSBuffer());return new F.SerializableObjectWithBuffers(A(y,H,L))}static serializeReplyErr(P,L){return L?this._serializeReplyErrEror(P,L):this._serializeReplyErrEmpty(P)}static _serializeReplyErrEror(P,L){const O=t.VSBuffer.fromString(p(T.transformErrorForSerialization(L),null));let y=0;y+=r.sizeLongString(O);let H=r.alloc(11,P,y);return H.writeLongString(O),H.buffer}static deserializeReplyErrError(P){const L=P.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(P){return r.alloc(12,P,0).buffer}}var m;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var d;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(d||(d={}))}),define(ve[265],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(ve[266],we([1,0,29,10,9,12,23,2,4,198,43,223,265]),function(te,e,f,t,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let b=class qi{constructor(h,v,A,_){this.localUserHome=h,this.remoteAgentService=v,this.environmentService=A,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome||h})()}hasValidBasename(h,v,A){return typeof v=="string"||typeof v=="undefined"?this.resolveOS.then(_=>this.doHasValidBasename(h,_,v)):this.doHasValidBasename(h,v,A)}doHasValidBasename(h,v,A){return h.scheme===t.Schemas.file||h.scheme===t.Schemas.vscodeRemote?(0,f.isValidBasename)(A??(0,C.basename)(h),v===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,v){if(h.remoteAuthority)return t.Schemas.vscodeRemote;const A=(0,R.getVirtualWorkspaceScheme)(v.getWorkspace());if(A)return A;const _=v.getWorkspace().folders[0];if(_)return _.uri.scheme;const a=v.getWorkspace().configuration;return a?a.scheme:t.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?I.win32:I.posix)}async fileURI(h){let v="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const _=h.indexOf("/",2);_===-1?(v=h.substring(2),h="/"):(v=h.substring(2,_),h=h.substring(_)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:v,path:h,query:"",fragment:""})}};b=Be([Fe(1,p.IRemoteAgentService),Fe(2,D.IWorkbenchEnvironmentService),Fe(3,F.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(ve[68],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(C,k){this.line=C,this.character=k}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,k){return new f(0,0)}with(C){return new f(0,0)}}e.Position=f;class t{constructor(C,k,S,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(C,k),this.end=new f(S,R)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new t(0,0,0,0)}with(C){return new t(0,0,0,0)}}e.Range=t;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],we([1,0,18,32,25,29,8,4,9,15,68,16]),function(te,e,f,t,I,T,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",b=" characters skipped \u27EB",g=(p.length+b.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var h;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function A(U){return!!U.preview}e.resultIsMatch=A;function _(U){return!!U.resource}e.isFileMatch=_;function a(U){return!!U.message}e.isProgressMessage=a;var l;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=u;class c{constructor(q,K,G){this.ranges=K;const ee=Array.isArray(K)?K:[K];if(G&&G.matchLines===1&&w(ee)){q=(0,C.getNLines)(q,G.matchLines);let oe="",ue=0,Z=0;const Y=Math.floor(G.charsPerLine/5),se=[];for(const de of ee){const ge=Math.max(de.startColumn-Y,0),Te=de.startColumn+G.charsPerLine;if(ge>Z+Y+g){const Ne=p+(ge-Z)+b;oe+=Ne+q.slice(ge,Te),ue+=ge-(Z+Ne.length)}else oe+=q.slice(Z,Te);se.push(new n(0,de.startColumn-ue,de.endColumn-ue)),Z=Te}this.preview={text:oe,matches:Array.isArray(this.ranges)?se:se[0]}}else{const oe=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:q,matches:(0,f.mapArrayOrNot)(K,ue=>new s(ue.startLineNumber-oe,ue.startColumn,ue.endLineNumber-oe,ue.endColumn))}}}}e.TextSearchMatch=c;function w(U){const q=U[0].startLineNumber;for(const K of U)if(K.startLineNumber!==q||K.endLineNumber!==q)return!1;return!0}class s{constructor(q,K,G,ee){this.startLineNumber=q,this.startColumn=K,this.endLineNumber=G,this.endColumn=ee}}e.SearchRange=s;class n extends s{constructor(q,K,G){super(q,K,q,G)}}e.OneLineRange=n;var r;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function i(U,q=!0){const K=U&&U.files&&U.files.exclude,G=q&&U&&U.search&&U.search.exclude;if(!K&&!G)return;if(!K||!G)return K||G;let ee=Object.create(null);return ee=I.mixin(ee,I.deepClone(K)),ee=I.mixin(ee,I.deepClone(G),!0),ee}e.getExcludes=i;function o(U,q){return U.excludePattern&&t.match(U.excludePattern,q)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&t.match(U.includePattern,q)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(K=>{const G=K.folder.fsPath;if(T.isEqualOrParent(q,G)){const ee=S.relative(G,q);return!K.includePattern||!!t.match(K.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var m;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(q,K){super(q);this.code=K}}e.SearchError=d;function E(U){const q=U.message;if((0,R.isCancellationError)(U))return new d(q,m.canceled);try{const K=JSON.parse(q);return new d(K.message,K.code)}catch{return new d(q,m.other)}}e.deserializeSearchError=E;function P(U){const q={message:U.message,code:U.code};return new Error(JSON.stringify(q))}e.serializeSearchError=P;function L(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=L;function O(U){return U.type==="success"}e.isSerializedSearchSuccess=O;function y(U){return!!U.path}e.isSerializedFileMatch=y;function H(U,q){const K=U.searchPath?U.searchPath:U.relativePath;return(0,C.fuzzyContains)(K,q)}e.isFilePatternMatch=H;class M{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function j(U,q){const K={...U||{},...q||{}};return Object.keys(K).filter(G=>{const ee=K[G];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=j;class Q{constructor(q,K){this._parsedIncludeExpression=null,this._excludeExpression={...q.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let G=q.includePattern;K.includePattern&&(G?G={...G,...K.includePattern}:G=K.includePattern),G&&(this._parsedIncludeExpression=t.parse(G))}matchesExcludesSync(q,K,G){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,K,G))}includedInQuerySync(q,K,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,K,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,K,G))}includedInQuery(q,K,G){const ee=this._parsedExcludeExpression(q,K,G),oe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(q,K,G):!0;return(0,D.isThenable)(ee)?ee.then(ue=>ue?!1:oe()):oe()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=Q;function $(U){for(const q in U)if(typeof U[q]!="boolean")return!0;return!1}}),define(ve[36],we([1,0,18,16,21,3,24,10,91,23,8,13,2,172,4,11,190,43,44,26,17,14,7,31,5]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a,l,u,c,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(L,O,y){return new R.ExtUri(H=>m(H,y)).isEqual(L,O)}function r(L,O,y){return n(L.uri,O.uri,y)?0:(0,F.compare)(L.uri.toString(),O.uri.toString())}function i(L,O,y){return L.index!==O.index?L.index<O.index?-1:1:n(L.uri,O.uri,y)?(0,F.compare)(L.name,O.name):(0,F.compare)(L.uri.toString(),O.uri.toString())}function o(L,O,y,H){const M=L.slice(0).sort((Q,$)=>y(Q,$,H)),j=O.slice(0).sort((Q,$)=>y(Q,$,H));return(0,f.delta)(M,j,(Q,$)=>y(Q,$,H))}function m(L,O){const y=O.getCapabilities(L.scheme);return!(y&&y&1024)}class d extends A.Workspace{constructor(O,y,H,M,j,Q,$){super(O,H.map(U=>new A.WorkspaceFolder(U)),M,j,$);this._name=y,this._isUntitled=Q,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris($),H.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(O,y,H,M){if(!O)return{workspace:null,added:[],removed:[]};const{id:j,name:Q,folders:$,configuration:U,transient:q,isUntitled:K}=O,G=[],ee=y;y?$.forEach((Y,se)=>{const de=p.URI.revive(Y.uri),ge=d._findFolder(H||y,de,M);ge?(ge.name=Y.name,ge.index=Y.index,G.push(ge)):G.push({uri:de,name:Y.name,index:se})}):G.push(...$.map(({uri:Y,name:se,index:de})=>({uri:p.URI.revive(Y),name:se,index:de}))),G.sort((Y,se)=>Y.index<se.index?-1:1);const oe=new d(j,Q,G,!!q,U?p.URI.revive(U):null,!!K,Y=>m(Y,M)),{added:ue,removed:Z}=o(ee?ee.workspaceFolders:[],oe.workspaceFolders,r,M);return{workspace:oe,added:ue,removed:Z}}static _findFolder(O,y,H){for(let M=0;M<O.folders.length;M++){const j=O.workspaceFolders[M];if(n(j.uri,y,H))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,y){return y&&this._structure.get(O)&&(O=(0,R.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let E=class{constructor(O,y,H,M){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=H,this._requestIdProvider=new S.Counter,this._barrier=new t.Barrier,this._proxy=O.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(s.MainContext.MainThreadMessageService);const j=y.workspace;this._confirmedWorkspace=j?new d(j.id,j.name,[],!!j.transient,j.configuration?p.URI.revive(j.configuration):null,!!j.isUntitled,Q=>m(Q,H)):void 0}$initializeWorkspace(O,y){this._trusted=y,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:k.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,y,H,...M){const j=[];if(Array.isArray(M)&&M.forEach(K=>{p.URI.isUri(K.uri)&&!j.some(G=>n(G.uri,K.uri,this._extHostFileSystemInfo))&&j.push({uri:K.uri,name:K.name||(0,R.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[y,H].some(K=>typeof K!="number"||K<0)||H===0&&j.length===0)return!1;const Q=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(y+H>Q.length)return!1;const $=Q.slice(0);$.splice(y,H,...j.map(K=>({uri:K.uri,name:K.name||(0,R.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<$.length;K++){const G=$[K];if($.some((ee,oe)=>oe!==K&&n(G.uri,ee.uri,this._extHostFileSystemInfo)))return!1}$.forEach((K,G)=>K.index=G);const{added:U,removed:q}=o(Q,$,i,this._extHostFileSystemInfo);if(U.length===0&&q.length===0)return!1;if(this._proxy){const K=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(K,y,H,j).then(void 0,G=>{this._unconfirmedWorkspace=void 0;const ee={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(v.Severity.Error,(0,b.localize)(0,null,K,G.toString()),ee,[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(O,y){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,y)}async getWorkspaceFolder2(O,y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,y)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,y){let H,M="";if(typeof O=="string"?(H=p.URI.file(O),M=O):typeof O!="undefined"&&(H=O,M=O.fsPath),!H)return M;const j=this.getWorkspaceFolder(H,!0);if(!j)return M;typeof y=="undefined"&&this._actualWorkspace&&(y=this._actualWorkspace.folders.length>1);let Q=(0,R.relativePath)(j.uri,H);return y&&j.name&&(Q=`${j.name}/${Q}`),Q}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:y,added:H,removed:M}=d.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=y||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:M}))}findFiles(O,y,H,M,j=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let Q;if(y===null?Q=!1:y&&(typeof y=="string"?Q=y:Q=y.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:U}=P(u.GlobPattern.from(O));return this._proxy.$startFileSearch((0,D.withUndefinedAsNull)($),(0,D.withUndefinedAsNull)(U),(0,D.withUndefinedAsNull)(Q),(0,D.withUndefinedAsNull)(H),j).then(q=>Array.isArray(q)?q.map(K=>p.URI.revive(K)):[])}async findTextInFiles(O,y,H,M,j=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const Q=this._requestIdProvider.getNext(),$=typeof y.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:y.previewOptions,{includePattern:U,folder:q}=P(u.GlobPattern.from(y.include)),K=typeof y.exclude=="string"?y.exclude:y.exclude?y.exclude.pattern:void 0,G={ignoreSymlinks:typeof y.followSymlinks=="boolean"?!y.followSymlinks:void 0,disregardIgnoreFiles:typeof y.useIgnoreFiles=="boolean"?!y.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof y.useGlobalIgnoreFiles=="boolean"?!y.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof y.useParentIgnoreFiles=="boolean"?!y.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof y.useDefaultExcludes=="boolean"?!y.useDefaultExcludes:!0,fileEncoding:y.encoding,maxResults:y.maxResults,previewOptions:$,afterContext:y.afterContext,beforeContext:y.beforeContext,includePattern:U,excludePattern:K},ee=!1;if(this._activeSearchCallbacks[Q]=oe=>{if(ee)return;const ue=p.URI.revive(oe.resource);oe.results.forEach(Z=>{(0,w.resultIsMatch)(Z)?H({uri:ue,preview:{text:Z.preview.text,matches:(0,f.mapArrayOrNot)(Z.preview.matches,Y=>new c.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,f.mapArrayOrNot)(Z.ranges,Y=>new c.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):H({uri:ue,text:Z.text,lineNumber:Z.lineNumber})})},j.isCancellationRequested)return{};try{const oe=await this._proxy.$startTextSearch(O,(0,D.withUndefinedAsNull)(q),G,Q,j);return delete this._activeSearchCallbacks[Q],oe||{}}catch(oe){throw delete this._activeSearchCallbacks[Q],oe}}$handleTextSearchResult(O,y){this._activeSearchCallbacks[y]&&this._activeSearchCallbacks[y](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Be([Fe(0,l.IExtHostRpcService),Fe(1,a.IExtHostInitDataService),Fe(2,_.IExtHostFileSystemInfo),Fe(3,h.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function P(L){let O,y;return L&&(typeof L=="string"?O=L:(O=L.pattern,y=p.URI.revive(L.baseUri))),{includePattern:O,folder:y}}}),define(ve[37],we([1,0,25,3,36,5,7,193,119,13,16,4,17,11,2]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(w,s){if(s){const n=s.split(".");let r=w;for(let i=0;r&&i<n.length;i++)r=r[n[i]];return r}}function v(w){return w instanceof g.URI}function A(w){return w&&w.uri instanceof g.URI&&w.languageId&&typeof w.languageId=="string"}function _(w){return w&&!w.uri&&w.languageId&&typeof w.languageId=="string"}function a(w){return w&&w.uri instanceof g.URI&&(!w.name||typeof w.name=="string")&&(!w.index||typeof w.index=="number")}function l(w){if(v(w))return{resource:w};if(A(w))return{resource:w.uri,overrideIdentifier:w.languageId};if(_(w))return{overrideIdentifier:w.languageId};if(a(w))return{resource:w.uri};if(w===null)return{resource:null}}let u=class{constructor(s,n,r){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=r,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new c(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,n))}};u=Be([Fe(0,p.IExtHostRpcService),Fe(1,I.IExtHostWorkspace),Fe(2,b.ILogService)],u),e.ExtHostConfiguration=u;class c{constructor(s,n,r,i){this._onDidChangeConfiguration=new t.Emitter,this._proxy=s,this._logService=i,this._extHostWorkspace=n,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,r))}getConfiguration(s,n,r){const i=l(n)||{},o=this._toReadonlyValue(s?h(this._configuration.getValue(void 0,i,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,i,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,i,r?.identifier);function m(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(E){return typeof h(o,E)!="undefined"},get:(E,P)=>{this._validateConfigurationAccess(s?`${s}.${E}`:E,i,r?.identifier);let L=h(o,E);if(typeof L=="undefined")L=P;else{let O;const y=(H,M)=>{let j;const Q=()=>{O=O||(0,f.deepClone)(o),j=j||h(O,M)};return(0,R.isObject)(H)?new Proxy(H,{get:($,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return Q(),()=>j;if(O)return j=j||h(O,M),j[U];const q=$[U];return typeof U=="string"?y(q,`${M}.${U}`):q},set:($,U,q)=>(Q(),j&&(j[U]=q),!0),deleteProperty:($,U)=>(Q(),j&&delete j[U],!0),defineProperty:($,U,q)=>(Q(),j&&Object.defineProperty(j,U,q),!0)}):H};L=y(L,E)}return L},update:(E,P,L,O)=>{E=s?`${s}.${E}`:E;const y=m(L);return P!==void 0?this._proxy.$updateConfigurationOption(y,E,P,i,O):this._proxy.$removeConfigurationOption(y,E,i,O)},inspect:E=>{E=s?`${s}.${E}`:E;const P=(0,f.deepClone)(this._configuration.inspect(E,i,this._extHostWorkspace.workspace));if(P)return{key:E,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof o=="object"&&(0,f.mixin)(d,o,!1),Object.freeze(d)}_toReadonlyValue(s){const n=r=>(0,R.isObject)(r)?new Proxy(r,{get:(i,o)=>n(i[o]),set:(i,o,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(i,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(i,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:i=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return n(s)}_validateConfigurationAccess(s,n,r){const i=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),o=r?`[${r.value}] `:"";if(i===4){typeof n?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(i===3){n?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const r=new k.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(i,o)=>r.affectsConfiguration(i,l(o))})}_toMap(s){return s.reduce((n,r)=>(n.set(r[0],r[1]),n),new Map)}}e.ExtHostConfigProvider=c,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[69],we([1,0,2,16,3,5,7,36,45,37,21,34,17,26,4,10,12,11,64,215,15]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a,l){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var c;(function(M){function j($){if($!=null)return $}M.from=j;function Q($){if($!=null)return $}M.to=Q})(c=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var w;(function(M){function j($){if($!=null)return $}M.from=j;function Q($){if($!=null)return $}M.to=Q})(w=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(M){function j($){if($!=null)return $}M.from=j;function Q($){if($!=null)return $}M.to=Q})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(M){function j(U){if(U){const q=U;return q&&!!q.process}else return!1}M.is=j;function Q(U){if(U==null)return;const q={process:U.process,args:U.args};return U.options&&(q.options=s.from(U.options)),q}M.from=Q;function $(U){if(U!=null)return new C.ProcessExecution(U.process,U.args,U.options)}M.to=$})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(M){function j($){if($!=null)return $}M.from=j;function Q($){if($!=null)return $}M.to=Q})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var i;(function(M){function j(U){if(U){const q=U;return q&&(!!q.commandLine||!!q.command)}else return!1}M.is=j;function Q(U){if(U==null)return;const q={};return U.commandLine!==void 0?q.commandLine=U.commandLine:(q.command=U.command,q.args=U.args),U.options&&(q.options=r.from(U.options)),q}M.from=Q;function $(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new C.ShellExecution(U.commandLine,U.options):new C.ShellExecution(U.command,U.args?U.args:[],U.options)}M.to=$})(i=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(M){function j(U){if(U){let q=U;return q&&q.customExecution==="customExecution"}else return!1}M.is=j;function Q(U){return{customExecution:"customExecution"}}M.from=Q;function $(U,q){return q.get(U)}M.to=$})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(M){function j(Q,$){let U;return Q.scope!==void 0&&typeof Q.scope!="number"?U=Q.scope.uri:Q.scope!==void 0&&typeof Q.scope=="number"&&(Q.scope===C.TaskScope.Workspace&&$&&$.workspaceFile?U=$.workspaceFile:U=a.USER_TASKS_GROUP_KEY),{id:Q._id,workspaceFolder:U}}M.from=j})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(M){function j(Q){if(Q!=null)return{_id:Q.id,isDefault:Q.isDefault}}M.from=j})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(M){function j(U,q){if(U==null)return[];const K=[];for(let G of U){const ee=Q(G,q);ee&&K.push(ee)}return K}M.fromMany=j;function Q(U,q){if(U==null)return;let K;U.execution instanceof C.ProcessExecution?K=n.from(U.execution):U.execution instanceof C.ShellExecution?K=i.from(U.execution):U.execution&&U.execution instanceof C.CustomExecution&&(K=o.from(U.execution));const G=c.from(U.definition);let ee;return U.scope?typeof U.scope=="number"?ee=U.scope:ee=U.scope.uri:ee=C.TaskScope.Workspace,!G||!ee?void 0:{_id:U._id,definition:G,name:U.name,source:{extensionId:q.identifier.value,label:U.source,scope:ee},execution:K,isBackground:U.isBackground,group:d.from(U.group),presentationOptions:w.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}M.from=Q;async function $(U,q,K){if(U==null)return;let G;n.is(U.execution)?G=n.to(U.execution):i.is(U.execution)?G=i.to(U.execution):o.is(U.execution)&&(G=o.to(U._id,K));const ee=c.to(U.definition);let oe;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?oe=U.source.scope:oe=await q.resolveWorkspaceFolder(f.URI.revive(U.source.scope)):oe=C.TaskScope.Workspace),!ee||!oe)return;const ue=new C.Task(ee,oe,U.name,U.source.label,G,U.problemMatchers);return U.isBackground!==void 0&&(ue.isBackground=U.isBackground),U.group!==void 0&&(ue.group=C.TaskGroup.from(U.group._id),ue.group&&U.group.isDefault&&(ue.group=new C.TaskGroup(ue.group.id,ue.group.label),U.group.isDefault&&(ue.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ue.presentationOptions=w.to(U.presentationOptions)),U._id&&(ue._id=U._id),U.detail&&(ue.detail=U.detail),ue}M.to=$})(E=e.TaskDTO||(e.TaskDTO={}));var P;(function(M){function j($){return $}M.from=j;function Q($){if(!!$)return Object.assign(Object.create(null),$)}M.to=Q})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(j,Q,$){this._id=Q,this._task=$,u.set(this,void 0),Xe(this,u,j,"f")}get task(){return this._task}terminate(){Pe(this,u,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}u=new WeakMap;var O;(function(M){function j(Q){return{id:Q._id,task:void 0}}M.from=j})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let y=class{constructor(j,Q,$,U,q,K,G,ee){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=j.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=U,this._configurationService=q,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=G,this._deprecationService=ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,Q,$){if(!$)return new C.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:Q,provider:$,extension:j}),this._proxy.$registerTaskProvider(U,Q),new C.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(j,Q){this._proxy.$registerTaskSystem(j,Q)}fetchTasks(j){return this._proxy.$fetchTasks(P.from(j)).then(async Q=>{const $=[];for(let U of Q){const q=await E.to(U,this._workspaceProvider,this._providedCustomExecutions2);q&&$.push(q)}return $})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(Q=>j.push(Q)),j}terminateTask(j){if(!(j instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,Q,$){const U=this._providedCustomExecutions2.get(j.id);U&&(this._activeCustomExecutions2.set(j.id,U),this._terminalService.attachPtyToTerminal(Q,await U.callback($))),this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const Q=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:Q})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const Q=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:Q,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const Q=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:Q,exitCode:j.exitCode})}$provideTasks(j,Q){const $=this._handlers.get(j);if(!$)return Promise.reject(new Error("no handler found"));const U=[],q=(0,t.asPromise)(()=>$.provider.provideTasks(F.CancellationToken.None)).then(K=>this.provideTasksInternal(Q,U,$,K));return new Promise(K=>{q.then(G=>{Promise.all(U).then(()=>{K(G)})})})}async $resolveTask(j,Q){const $=this._handlers.get(j);if(!$)return Promise.reject(new Error("no handler found"));if(Q.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${Q.definition.type}] cannot be resolved by provider of type [${$.type}].`);const U=await E.to(Q,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const q=await $.provider.resolveTask(U,F.CancellationToken.None);if(!q)return;this.checkDeprecation(q,$);const K=E.from(q,$.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(K.execution)&&await this.addCustomExecution(K,q,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,Q,$){const U=await this._proxy.$createTaskId(j);!$&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,Q.execution)),this._providedCustomExecutions2.set(U,Q.execution)}async getTaskExecution(j,Q){if(typeof j=="string"){const q=this._taskExecutionPromises.get(j);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let $=this._taskExecutionPromises.get(j.id);if($)return $;const U=new Promise((q,K)=>{function G(ee,oe,ue){ue?q(new L(ee,oe.id,ue)):K("Unexpected: Task does not exist.")}Q?G(this,j,Q):E.to(j.task,this._workspaceProvider,this._providedCustomExecutions2).then(ee=>G(this,j,ee))});return this._taskExecutionPromises.set(j.id,U),U.then(q=>(this._taskExecutions.set(j.id,q),q),q=>Promise.reject(q))}checkDeprecation(j,Q){j._deprecated&&this._deprecationService.report("Task.constructor",Q.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let $=this._notProvidedCustomExecutions.values(),U=$.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=$.next()}};y=Be([Fe(0,p.IExtHostRpcService),Fe(1,b.IExtHostInitDataService),Fe(2,k.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,R.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,A.ILogService),Fe(7,_.IExtHostApiDeprecationService)],y),e.ExtHostTaskBase=y;let H=class extends y{constructor(j,Q,$,U,q,K,G,ee){super(j,Q,$,U,q,K,G,ee);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(j,Q){if(!Q.execution)throw new Error("Tasks to execute must include an execution");const $=E.from(Q,j);if($===void 0)throw new Error("Task is not valid");if(o.is($.execution))await this.addCustomExecution($,Q,!1);else throw new l.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution($),Q);return this._proxy.$executeTask($).catch(q=>{throw new Error(q)}),U}provideTasksInternal(j,Q,$,U){const q=[];if(U)for(let K of U){this.checkDeprecation(K,$),(!K.definition||!j[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const G=E.from(K,$.extension);G&&o.is(G.execution)?(q.push(G),Q.push(this.addCustomExecution(G,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:$.extension}}async resolveTaskInternal(j){if(o.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,Q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,Q,$){}};H=Be([Fe(0,p.IExtHostRpcService),Fe(1,b.IExtHostInitDataService),Fe(2,k.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,R.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,A.ILogService),Fe(7,_.IExtHostApiDeprecationService)],H),e.WorkerExtHostTask=H,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(ve[267],we([1,0,9,21,49,32,23,46,31]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(p,b,g){this.config=p,this.provider=b,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&T.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&T.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const b=this.config.folderQueries||[];return new Promise((g,h)=>{const v=A=>{this.resultCount++,p(A)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const _=A.toString(),a=f.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,a)||this.matchFile(v,{base:A,basename:a})}),Promise.all(b.map(A=>this.searchInFolder(A,v))).then(A=>{g({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{h(new Error((0,I.toErrorMessage)(A)))})})}async searchInFolder(p,b){const g=new t.CancellationTokenSource,h=this.getSearchOptionsForFolder(p),v=this.initDirectoryTree(),A=new S.QueryGlobTester(this.config,p),_=!A.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(g),a=k.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,g.token),u=a.elapsed(),c=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(w=>{const s=f.posix.relative(p.folder.path,w.path);if(_){const n=f.basename(w.path);this.matchFile(b,{base:p.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(v,p.folder,s,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,A,b),{providerTime:u,postProcessTime:c.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(p){const b=(0,S.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),g=(0,S.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:g,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},b,g,h){if(g===this.filePattern){const A=f.basename(this.filePattern);this.matchFile(h,{base:b,relativePath:this.filePattern,basename:A})}function v(A){const _=f.basename(A),a=f.dirname(A);let l=p[a];l||(l=p[a]=[],v(a)),l.push({base:b,relativePath:A,basename:_})}v(g)}matchDirectoryTree({rootEntries:p,pathToEntries:b},g,h){const v=this,A=this.filePattern;function _(a){const l=T.hasSiblingFn(()=>a.map(u=>u.basename));for(let u=0,c=a.length;u<c;u++){const w=a[u],{relativePath:s,basename:n}=w;if(g.matchesExcludesSync(s,n,A!==n?l:void 0))continue;const r=b[s];if(r)_(r);else{if(s===A)continue;v.matchFile(h,w)}if(v.isLimitHit)break}}_(p)}matchFile(p,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(b))}}class F{constructor(){this.sessions=new Map}fileSearch(p,b,g,h){const v=this.getSessionTokenSource(p.cacheKey),A=new R(p,b,v&&v.token);let _=0;const a=l=>{_+=l.length,g(l.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(A,F.BATCH_SIZE,a,h).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:l.stats}}))}clearCache(p){const b=this.getSessionTokenSource(p);b&&b.cancel()}getSessionTokenSource(p){if(!!p)return this.sessions.has(p)||this.sessions.set(p,new t.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:C.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,b,g,h){h.onCancellationRequested(()=>{p.cancel()});const v=_=>{_&&(A.push(_),b>0&&A.length>=b&&(g(A),A=[]))};let A=[];return p.search(v).then(_=>(A.length&&g(A),_),_=>(A.length&&g(A),Promise.reject(_)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(ve[268],we([1,0,18,73,32,100,24,10,9,23,8,13,2,152,181,115,11,43,129,266,31]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(d,E,P,L,O){this.configurationService=d,this.workspaceContextService=E,this.editorGroupsService=P,this.logService=L,this.pathService=O}text(d,E,P={}){d=this.getContentPattern(d,P);const L=this.configurationService.getValue(),O=E&&E.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(E?.map(A.toWorkspaceFolder),P),type:2,contentPattern:d,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(d,E){const P=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const L={...d,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(d,E)&&(L.isCaseSensitive=!0),this.isMultiline(d)&&(L.isMultiline=!0),L}file(d,E={}){return{...this.commonQuery(d,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(d,E){return d?(d=Array.isArray(d)?d.map(r):r(d),E?this.parseSearchPaths(d):{pattern:w(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],E={}){const P=this.handleIncludeExclude(E.includePattern,E.expandPatterns),L=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),O=d.length>1,y=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(j=>this.getFolderQueryForSearchPath(j,E,L)):d.map(j=>this.getFolderQueryForRoot(j,E,L,O))).filter(j=>!!j),H={_reason:E._reason,folderQueries:y,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:L.pattern,includePattern:P.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const j=f.coalesce(f.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(q=>q.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const Q=j.filter(U=>(0,l.pathIncludedInQuery)(H,U.fsPath)),$=this.commonQueryFromFileList(Q);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify($)),{...H,...$}}const M=E.extraFileResources&&E.extraFileResources.filter(j=>(0,l.pathIncludedInQuery)(H,j.fsPath));return H.extraFileResources=M&&M.length?M:void 0,H}commonQueryFromFileList(d){const E=[],P=new C.ResourceMap,L={};let O=!1;return d.forEach(y=>{if(y.scheme===k.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(y)){const M=this.workspaceContextService.getWorkspaceFolder(y)?.uri??y.with({path:S.dirname(y.fsPath)});let j=P.get(M);j||(O=!0,j={folder:M,includePattern:{}},E.push(j),P.set(M,j));const Q=S.relative(M.fsPath,y.fsPath);(0,D.assertIsDefined)(j.includePattern)[Q.replace(/\\/g,"/")]=!0}else y.fsPath&&(O=!0,L[y.fsPath]=!0)}),{folderQueries:E,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(d,E){if(E.isSmartCase){if(d.isRegExp){if(F.containsUppercaseCharacter(d.pattern,!0))return!0}else if(F.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,b.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const E=$=>S.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),L=(Array.isArray(d)?d:s(d)).map($=>{const U=this.pathService.resolvedUserHome;return U?(0,T.untildify)($,U.scheme===k.Schemas.file?U.fsPath:U.path):$}),O=t.groupBy(L,$=>E($)?"searchPaths":"exprSegments"),y=(O.exprSegments||[]).map($=>F.rtrim($,"/")).map($=>F.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),n($))),H={},M=this.expandSearchPathPatterns(O.searchPaths||[]);M&&M.length&&(H.searchPaths=M);const j=f.flatten(y),Q=w(...j);return Q&&(H.pattern=Q),H}getExcludesForFolder(d,E){return E.disregardExcludeSettings?void 0:(0,l.getExcludes)(d,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const E=f.flatten(d.map(L=>{let{pathPortion:O,globPortion:y}=c(L);y&&(y=i(y));const H=this.expandOneSearchPath(O);return f.flatten(H.map(M=>this.resolveOneSearchPathPattern(M,y)))})),P=new Map;return E.forEach(L=>{const O=L.searchPath.toString(),y=P.get(O);y?L.pattern&&(y.pattern=y.pattern||{},y.pattern[L.pattern]=!0):P.set(O,{searchPath:L.searchPath,pattern:L.pattern?w(L.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(d){if(S.isAbsolute(d)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==k.Schemas.file?[{searchPath:E[0].uri.with({path:d})}]:[{searchPath:p.URI.file(S.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=r(d),d.startsWith("../")||d===".."){const L=S.posix.resolve(E.path,d);return[{searchPath:E.with({path:L})}]}const P=i(d);return[{searchPath:E,pattern:P}]}else{if(d==="./"||d===".\\")return[];{const E=d.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const y=E.match(new RegExp(`^${F.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return y?{match:y,folder:O}:null}).filter(D.isDefined);if(L.length)return L.map(O=>{const y=O.match[1];return{searchPath:O.folder.uri,pattern:y&&i(y)}});{const O=d.match(/\.[\/\\](.+)[\/\\]?/),y=O?O[1]:d,H=g.localize(0,null,y);throw new Error(H)}}}}resolveOneSearchPathPattern(d,E){const P=d.pattern&&E?`${d.pattern}/${E}`:d.pattern||E,L=[{searchPath:d.searchPath,pattern:P}];return P&&!P.endsWith("**")&&L.push({searchPath:d.searchPath,pattern:P+"/**"}),L}getFolderQueryForSearchPath(d,E,P){const L=this.getFolderQueryForRoot((0,A.toWorkspaceFolder)(d.searchPath),E,P,!1);return L?{...L,includePattern:d.pattern}:null}getFolderQueryForRoot(d,E,P,L){let O;const y=p.URI.isUri(d)?d:d.uri;if(P.searchPaths){const $=P.searchPaths.filter(U=>(0,R.isEqual)(U.searchPath,y))[0];if($&&!$.pattern)return null;$&&(O=$.pattern)}const H=this.configurationService.getValue({resource:y}),j={...this.getExcludesForFolder(H,E)||{},...O||{}},Q=p.URI.isUri(d)?(0,R.basename)(d):d.name;return{folder:y,folderName:L?Q:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!H.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!H.search.followSymlinks}}};u=Be([Fe(0,h.IConfigurationService),Fe(1,A.IWorkspaceContextService),Fe(2,_.IEditorGroupsService),Fe(3,v.ILogService),Fe(4,a.IPathService)],u),e.QueryBuilder=u;function c(m){const d=m.match(/[\*\{\}\(\)\[\]\?]/);if(d){const E=d.index,P=m.substr(0,E).match(/[/|\\][^/\\]*$/);if(P){let L=m.substr(0,P.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:m.substr((P.index||0)+1)}}}return{pathPortion:m}}function w(...m){return m.length?m.reduce((d,E)=>(d[E]=!0,d),Object.create(null)):void 0}function s(m){return I.splitGlobAware(m,",").map(d=>d.trim()).filter(d=>!!d.length)}function n(m){return[`**/${m}/**`,`**/${m}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function i(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(m,d){m=f.distinct(m,L=>L.toString());const E=[],P=d.getWorkspace();return m&&m.forEach(L=>{let O;if(d.getWorkbenchState()===2)O=(0,R.relativePath)(P.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const y=d.getWorkspaceFolder(L);if(y){const H=y.name;if(P.folders.filter(j=>j.name===H).length===1){const j=(0,R.relativePath)(y.uri,L);j===""?O=`./${y.name}`:O=`./${y.name}/${j}`}else O=L.fsPath}}O&&E.push(O)}),E}e.resolveResourcesForSearchIncludes=o}),define(ve[269],we([1,0,23,2,21,15,4,268,31,43]),function(te,e,f,t,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function D(h,v){const A=v.activationEvents;if(!A)return Promise.resolve(void 0);const _=[],a=[];for(const n of A)if(/^workspaceContains:/.test(n)){const r=n.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||h.forceUsingSearch?a.push(r):_.push(r)}if(_.length===0&&a.length===0)return Promise.resolve(void 0);let l;const u=new Promise((n,r)=>{l=n}),c=n=>l({activationEvent:n}),w=Promise.all(_.map(n=>p(h,n,c))).then(()=>{}),s=b(h,v.identifier,a,c);return Promise.all([w,s]).then(()=>{l(void 0)}),u}e.checkActivateWorkspaceContainsExtension=D;async function p(h,v,A){for(const _ of h.folders)if(await h.exists(f.joinPath(t.URI.revive(_),v))){A(`workspaceContains:${v}`);return}}async function b(h,v,A,_){if(A.length===0)return Promise.resolve(void 0);const a=new I.CancellationTokenSource,l=h.checkExists(h.folders,A,a.token),u=setTimeout(async()=>{a.cancel(),h.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${A.join(",")}`)},F);let c=!1;try{c=await l}catch(w){T.isCancellationError(w)||T.onUnexpectedError(w)}a.dispose(),clearTimeout(u),c&&_(`workspaceContains:${A.join(",")}`)}function g(h,v,A,_){const a=h.get(C.IInstantiationService),l=h.get(S.ISearchService),c=a.createInstance(k.QueryBuilder).file(v.map(w=>(0,R.toWorkspaceFolder)(t.URI.revive(w))),{_reason:"checkExists",includePattern:A,exists:!0});return l.fileSearch(c,_).then(w=>!!w.limitHit,w=>T.isCancellationError(w)?!1:Promise.reject(w))}e.checkGlobFileExists=g});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(te):t?t.value:e.get(te)};define(ve[40],we([1,0,167,9,70,23,16,6,24,2,11,5,37,225,87,36,30,224,15,27,22,199,7,120,4,26,66,17,80,51,34,3,269,86,201,10]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a,l,u,c,w,s,n,r,i,o,m,d,E,P,L,O,y){"use strict";var H,M,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let Q=class Gi extends k.Disposable{constructor(G,ee,oe,ue,Z,Y,se,de,ge,Te){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ee,this._extHostContext=oe,this._initData=se,this._extHostWorkspace=ue,this._extHostConfiguration=Z,this._logService=Y,this._extHostTunnelService=ge,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new g.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=de,this._instaService=G.createChild(new o.ServiceCollection([g.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ne=new Set;this._initData.hostExtensions.forEach(be=>Ne.add(a.ExtensionIdentifier.toKey(be))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(be,Ee,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(be,_.transformErrorForSerialization(Ee),z)},actualActivateExtension:async(be,Ee)=>{if(Ne.has(a.ExtensionIdentifier.toKey(be)))return await this._mainThreadExtensionsProxy.$activateExtension(be,Ee),new b.HostExtension;const z=this._registry.getExtensionDescription(be);return this._activateExtension(z,Ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){_.onUnexpectedError(G)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._registry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all(G)}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}_activateByEvent(G,ee){return this._activator.activateByEvent(G,ee)}_activateById(G,ee){return this._activator.activateById(G,ee)}activateByIdWithErrors(G,ee){return this._activateById(G,ee).then(()=>{const oe=this._activator.getActivatedExtension(G);if(oe.activationFailed)return Promise.reject(oe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._registry)}getExtensionExports(G){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(G).exports:null}async _realPathExtensionUri(G){if(G.scheme!==y.Schemas.file)return G;const ee=await this._hostUtils.realpath(G.fsPath);return R.URI.file(ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const G=S.TernarySearchTree.forUris(ee=>T.extUriBiasedIgnorePathCase.ignorePathCasing(ee));for(const ee of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ee)){const oe=await this._realPathExtensionUri(ee.extensionLocation);G.set(oe,ee)}return G})()),this._extensionPathIndex}_deactivate(G){let ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return ee;const oe=this._activator.getActivatedExtension(G);if(!oe)return ee;try{typeof oe.module.deactivate=="function"&&(ee=Promise.resolve(oe.module.deactivate()).then(void 0,ue=>(this._logService.error(ue),Promise.resolve(void 0))))}catch(ue){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(ue)}try{(0,k.dispose)(oe.subscriptions)}catch(ue){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(ue)}return ee}async _activateExtension(G,ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,ee).then(oe=>{const ue=oe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,ee),this._logExtensionActivationTimes(G,ee,"success",ue),oe},oe=>{throw this._logExtensionActivationTimes(G,ee,"failure"),oe})}_logExtensionActivationTimes(G,ee,oe,ue){const Z=$(G,ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...ue||{},outcome:oe})}_doActivateExtension(G,ee){const oe=$(G,ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",oe);const ue=this._getEntryPoint(G);if(!ue)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${G.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this._logService.flush();const Z=new b.ExtensionActivationTimesBuilder(ee.startup);return Promise.all([this._loadCommonJSModule(G.identifier,(0,T.joinPath)(G.extensionLocation,ue),Z),this._loadExtensionContext(G)]).then(Y=>(I.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),Gi._callActivate(this._logService,G.identifier,Y[0],Y[1],Z))).then(Y=>(I.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),Y))}_loadExtensionContext(G){const ee=new u.ExtensionGlobalMemento(G,this._storage),oe=new u.ExtensionMemento(G.identifier.value,!1,this._storage),ue=new O.ExtensionSecrets(G,this._secretState),Z=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,Y=this._initData.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([ee.whenReady,oe.whenReady,this._storagePath.whenReady]).then(()=>{const se=this;let de,ge;const Te=(0,v.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(a.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:ee,workspaceState:oe,secrets:ue,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(Ne){return t.join(G.extensionLocation.fsPath,Ne)},get storagePath(){return se._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return se._storagePath.globalValue(G).fsPath},get logPath(){return t.join(se._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return R.URI.joinPath(se._initData.logsLocation,G.identifier.value)},get storageUri(){return se._storagePath.workspaceValue(G)},get globalStorageUri(){return se._storagePath.globalValue(G)},get extensionMode(){return Z},get extension(){return de===void 0&&(de=new U(se,G.identifier,G,Y)),de},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(G,"extensionRuntime"),se.extensionRuntime},get environmentVariableCollection(){return se._extHostTerminalService.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!ge){if(!Te)return;const Ne=E.Event.buffer(E.Event.fromDOMEventEmitter(Te,"message",be=>be.data));Te.start(),ge={onDidReceiveMessage:Ne,postMessage:Te.postMessage.bind(Te)}}return ge}})})}static _callActivate(G,ee,oe,ue,Z){return oe=oe||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,ee,oe,ue,Z).then(Y=>new b.ActivatedExtension(!1,null,Z.build(),oe,Y,ue.subscriptions))}static _callActivateOptional(G,ee,oe,ue,Z){if(typeof oe.activate=="function")try{Z.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const Y=typeof global=="object"?global:self,se=oe.activate.apply(Y,[ue]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(se).then(de=>(Z.activateResolveStop(),de))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(oe)}_activateOneStartupFinished(G,ee){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:ee}).then(void 0,oe=>{this._logService.error(oe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const G of this._registry.getAllExtensionDescriptions())if(G.activationEvents)for(const ee of G.activationEvents)ee==="onStartupFinished"&&this._activateOneStartupFinished(G,ee)}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],oe=this._handleWorkspaceContainsEagerExtensions(ee),ue=Promise.all([G,oe]).then(()=>{});return Promise.race([ue,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ue}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ee=>this._handleWorkspaceContainsEagerExtension(G,ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,ee){if(this.isActivated(ee.identifier))return;const oe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ue={logService:this._logService,folders:G.map(Y=>Y.uri),forceUsingSearch:oe,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,se,de)=>this._mainThreadWorkspaceProxy.$checkExists(Y,se,de)},Z=await(0,P.checkActivateWorkspaceContainsExtension)(ue,ee);if(!!Z)return this._activateById(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:Z.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:ee}=this._initData.environment;if(!G||!ee)throw new Error(f.localize(0,null));const oe=await this._loadCommonJSModule(null,ee,new b.ExtensionActivationTimesBuilder(!1));if(!oe||typeof oe.run!="function")throw new Error(f.localize(1,null,ee.toString()));return new Promise((ue,Z)=>{const Y=(ge,Te)=>{ge?Z(ge):ue(typeof Te=="number"&&Te>0?1:0)},se=(0,T.originalFSPath)(ee),de=oe.run(se,Y);de&&de.then&&de.then(()=>{ue(0)}).catch(ge=>{Z(ge instanceof Error&&ge.stack?ge.stack:String(ge))})})}async $extensionTestsExit(G){this._logService.info(`Extension host terminating: test runner requested exit with code ${G}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${G}`),this._logService.flush(),this._hostUtils.exit(G)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,ee){return this._resolvers[G]=ee,(0,k.toDisposable)(()=>{delete this._resolvers[G]})}async _activateAndGetResolver(G){const ee=G.indexOf("+");if(ee===-1)throw new Error("Not an authority that can be resolved!");const oe=G.substr(0,ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${oe}`,!1),{authorityPrefix:oe,resolver:this._resolvers[oe]}}async $resolveAuthority(G,ee){this._logService.info(`$resolveAuthority invoked for authority (${q(G)})`);const{authorityPrefix:oe,resolver:ue}=await this._activateAndGetResolver(G);if(!ue)return{type:"error",error:{code:w.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${oe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ue)),I.mark(`code/extHost/willResolveAuthority/${oe}`);const Z=await ue.resolve(G,{resolveAttempt:ee});I.mark(`code/extHost/didResolveAuthorityOK/${oe}`);const Y={authority:G,host:Z.host,port:Z.port,connectionToken:Z.connectionToken},se={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted,authenticationSession:Z.authenticationSessionForInitializingExtensions?{id:Z.authenticationSessionForInitializingExtensions.id,providerId:Z.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Y,options:se,tunnelInformation:{environmentTunnels:Z.environmentTunnels,features:Z.tunnelFeatures}}}}catch(Z){if(I.mark(`code/extHost/didResolveAuthorityError/${oe}`),Z instanceof c.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(G,ee){this._logService.info(`$getCanonicalURI invoked for authority (${q(G)})`);const{authorityPrefix:oe,resolver:ue}=await this._activateAndGetResolver(G);if(!ue)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${oe}`);const Z=R.URI.revive(ee);if(typeof ue.getCanonicalURI=="undefined")return Z;const Y=await(0,C.asPromise)(()=>ue.getCanonicalURI(Z));return Y||Z}$startExtensionHost(G){return this._registry.keepOnly(G),this._startExtensionHost()}$activateByEvent(G,ee){return ee===1?this._activateByEvent(G,!1):this._readyToRunExtensions.wait().then(oe=>this._activateByEvent(G,!1))}async $activate(G,ee){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(G)?(await this._activateById(G,ee),!0):!1}async $deltaExtensions(G,ee){G.forEach(ue=>ue.extensionLocation=R.URI.revive(ue.extensionLocation));const oe=await this.getExtensionPathIndex();return await Promise.all(ee.map(async ue=>{const Z=this._registry.getExtensionDescription(ue);Z&&oe.delete(await this._realPathExtensionUri(Z.extensionLocation))})),await Promise.all(G.map(async ue=>{const Z=await this._realPathExtensionUri(ue.extensionLocation);oe.set(Z,ue)})),this._registry.deltaExtensions(G,ee),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){let ee=l.VSBuffer.alloc(G),oe=Math.random()%256;for(let ue=0;ue<G;ue++)ee.writeUInt8(oe,ue);return ee}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};Q=Be([Fe(0,s.IInstantiationService),Fe(1,e.IHostUtils),Fe(2,i.IExtHostRpcService),Fe(3,h.IExtHostWorkspace),Fe(4,p.IExtHostConfiguration),Fe(5,F.ILogService),Fe(6,n.IExtHostInitDataService),Fe(7,r.IExtensionStoragePaths),Fe(8,m.IExtHostTunnelService),Fe(9,d.IExtHostTerminalService)],Q),e.AbstractExtHostExtensionService=Q;function $(K,G){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class U{constructor(G,ee,oe,ue){H.set(this,void 0),M.set(this,void 0),j.set(this,void 0),Xe(this,H,G,"f"),Xe(this,M,ee,"f"),Xe(this,j,oe.identifier,"f"),this.id=oe.identifier.value,this.extensionUri=oe.extensionLocation,this.extensionPath=t.normalize((0,T.originalFSPath)(oe.extensionLocation)),this.packageJSON=oe,this.extensionKind=ue}get isActive(){return Pe(this,H,"f").isActivated(Pe(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return Pe(this,H,"f").getExtensionExports(Pe(this,j,"f"))}activate(){return Pe(this,H,"f").activateByIdWithErrors(Pe(this,j,"f"),{startup:!1,extensionId:Pe(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=U,H=new WeakMap,M=new WeakMap,j=new WeakMap;function q(K){const G=K.indexOf("+");return G===-1?K:K.substring(0,G)}}),define(ve[54],we([1,0,9,2,3,16,5,7,126,36,40,45,217,37,210,17,4,13,41,53]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let l=class{constructor(o,m,d,E,P,L){this._workspaceService=m,this._extensionService=d,this._editorsService=E,this._configurationService=P,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=o.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(y=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,m){const d=o;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let E=`debug:${encodeURIComponent(d.path||"")}`,P="?";return m&&(E+=`${P}session=${encodeURIComponent(m.id)}`,P="&"),E+=`${P}ref=${d.sourceReference}`,t.URI.parse(E)}else{if(d.path)return t.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const m=[];for(const d of o.getAllExtensionDescriptions())if(d.contributes){const E=d.contributes.debuggers;if(E&&E.length>0)for(const P of E)(0,g.isDebuggerMainContribution)(P)&&m.push(P.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(m=>o.push(m)),o}addBreakpoints(o){this.startBreakpoints();const m=o.filter(P=>{const L=P.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,P),!0)});this.fireBreakpointChanges(m,[],[]);const d=[],E=new Map;for(const P of m)if(P instanceof k.SourceBreakpoint){let L=E.get(P.location.uri.toString());L||(L={type:"sourceMulti",uri:P.location.uri,lines:[]},E.set(P.location.uri.toString(),L),d.push(L)),L.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof k.FunctionBreakpoint&&d.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(d)}removeBreakpoints(o){this.startBreakpoints();const m=o.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],m,[]);const d=m.filter(L=>L instanceof k.SourceBreakpoint).map(L=>L.id),E=m.filter(L=>L instanceof k.FunctionBreakpoint).map(L=>L.id),P=m.filter(L=>L instanceof k.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(d,E,P)}startDebugging(o,m,d){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,m,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,debugUI:d.debugUI,suppressSaveBeforeStart:d.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,m,d){if(!m)return new k.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:E,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,d,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,E),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(o,m,d){if(!d)return new k.Disposable(()=>{});if(!this.definesDebugType(o,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:E,factory:d}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,E),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==d),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(o,m){if(!m)return new k.Disposable(()=>{});const d=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:d,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==m)})}async $runInTerminal(o,m){return Promise.resolve(void 0)}async $substituteVariables(o,m){if(!this._variableResolver){const[P,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,L)}let d;const E=await this.getFolder(o);return E&&(d={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(d,m)}createDebugAdapter(o,m){if(o.type==="implementation")return new n(o.implementation)}createSignService(){}async $startDASession(o,m){const d=this,E=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const L=this.convertToDto(P),O=this.createDebugAdapter(L,E);if(!O)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const y=O;return this._debugAdapters.set(o,y),this.getDebugAdapterTrackers(E).then(H=>(H&&this._debugAdaptersTrackers.set(o,H),y.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const j=M,Q={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(j.arguments.value);Q.body={signature:$},y.sendResponse(Q)}else throw new Error("no signer")}catch($){Q.success=!1,Q.message=$.message,y.sendResponse(Q)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(M),M=(0,g.convertToVSCPaths)(M,!0),d._debugServiceProxy.$acceptDAMessage(o,M)}),y.onError(M=>{H&&H.onError&&H.onError(M),this._debugServiceProxy.$acceptDAError(o,M.name,M.message,M.stack)}),y.onExit(M=>{H&&H.onExit&&H.onExit((0,A.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,A.withNullAsUndefined)(M),void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),y.startSession()))})}$sendDAMessage(o,m){m=(0,g.convertToDAPaths)(m,!1);const d=this._debugAdaptersTrackers.get(o);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(m);const E=this._debugAdapters.get(o);E&&E.sendMessage(m)}$stopDASession(o){const m=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),m&&m.onWillStopSession&&m.onWillStopSession();const d=this._debugAdapters.get(o);return this._debugAdapters.delete(o),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const m=[],d=[],E=[];if(o.added)for(const P of o.added){const L=P.id;if(L&&!this._breakpoints.has(L)){let O;if(P.type==="function")O=new k.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")O=new k.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const y=t.URI.revive(P.uri);O=new k.SourceBreakpoint(new k.Location(y,new k.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}O._id=L,this._breakpoints.set(L,O),m.push(O)}}if(o.removed)for(const P of o.removed){const L=this._breakpoints.get(P);L&&(this._breakpoints.delete(P),d.push(L))}if(o.changed){for(const P of o.changed)if(P.id){const L=this._breakpoints.get(P.id);if(L){if(L instanceof k.FunctionBreakpoint&&P.type==="function"){const O=L;O.enabled=P.enabled,O.condition=P.condition,O.hitCondition=P.hitCondition,O.logMessage=P.logMessage,O.functionName=P.functionName}else if(L instanceof k.SourceBreakpoint&&P.type==="source"){const O=L;O.enabled=P.enabled,O.condition=P.condition,O.hitCondition=P.hitCondition,O.logMessage=P.logMessage,O.location=new k.Location(t.URI.revive(P.uri),new k.Position(P.line,P.character))}E.push(L)}}}this.fireBreakpointChanges(m,d,E)}$provideDebugConfigurations(o,m,d){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(o);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(m);return E.provideDebugConfigurations(P,d)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(o,m,d,E){return(0,T.asPromise)(async()=>{const P=this.getConfigProviderByHandle(o);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(m);return P.resolveDebugConfiguration(L,d,E)})}$resolveDebugConfigurationWithSubstitutedVariables(o,m,d,E){return(0,T.asPromise)(async()=>{const P=this.getConfigProviderByHandle(o);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(m);return P.resolveDebugConfigurationWithSubstitutedVariables(L,d,E)})}async $provideDebugAdapter(o,m){const d=this.getAdapterDescriptorFactoryByHandle(o);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(m);return this.getAdapterDescriptor(d,E).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(o){const m=await this.getSession(o);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(o){const m=await this.getSession(o);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,m){const d=await this.getSession(o);d&&d._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(o,m){const E={session:await this.getSession(o),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const m=this._adapterFactories.filter(d=>d.type===o);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(o){const m=this._adapterFactories.filter(d=>d.handle===o);if(m.length>0)return m[0].factory}getConfigProviderByHandle(o){const m=this._configProviders.filter(d=>d.handle===o);if(m.length>0)return m[0].provider}definesDebugType(o,m){if(o.contributes){const d=o.contributes.debuggers;if(d&&d.length>0){for(const E of d)if(E.label&&E.type&&E.type===m)return!0}}return!1}getDebugAdapterTrackers(o){const d=o.configuration.type,E=this._trackerFactories.filter(P=>P.type===d||P.type==="*").map(P=>(0,T.asPromise)(()=>P.factory.createDebugAdapterTracker(o)).then(L=>L,L=>null));return Promise.race([Promise.all(E).then(P=>{const L=P.filter(O=>!!O);if(L.length>0)return new s(L)}),new Promise((P,L)=>{const O=setTimeout(()=>{clearTimeout(O),L(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(o,m){const d=m.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new k.DebugAdapterServer(d));if(o){const P=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>o.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,P))).then(L=>{if(L)return L})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,E))}daExecutableFromPackage(o,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,m,d){(o.length>0||m.length>0||d.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:m,changed:d}))}async getSession(o){if(o)if(typeof o=="string"){const m=this._debugSessions.get(o);if(m)return m}else{let m=this._debugSessions.get(o.id);if(!m){const d=await this.getFolder(o.folderUri),E=o.parent?this._debugSessions.get(o.parent):void 0;m=new u(this._debugServiceProxy,o.id,o.type,o.name,d,o.configuration,E),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(o){if(o){const m=t.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};l=Be([Fe(0,h.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,b.IExtHostConfiguration),Fe(5,a.IExtHostEditorTabs)],l),e.ExtHostDebugServiceBase=l;class u{constructor(o,m,d,E,P,L,O){this._debugServiceProxy=o,this._id=m,this._type=d,this._name=E,this._workspaceFolder=P,this._configuration=L,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,m)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=u;class c{constructor(o){this.value=Object.freeze({append(m){o.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=c;class w extends p.AbstractVariableResolverService{constructor(o,m,d,E,P,L){function O(){if(m){const y=m.activeEditor();if(y)return y.document.uri;const H=E.tabGroups.all.find(M=>M.isActive)?.activeTab;if(H!==void 0){const M=H.resource;return M&&(M.primary||M.secondary)?M.primary??M.secondary:H.resource}}}super({getFolderUri:y=>{const H=o.filter(M=>M.name===y);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(y,H)=>d.getConfiguration(void 0,y).get(H),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const y=O();if(y)return f.normalize(y.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const y=O();if(y){const H=P.getWorkspaceFolder(y);if(H)return f.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(m){const y=m.activeEditor();if(y&&!y.selection.isEmpty)return y.document.getText(y.selection)}},getLineNumber:()=>{if(m){const y=m.activeEditor();if(y)return String(y.selection.end.line+1)}}},void 0,L?Promise.resolve(L):void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=w;class s{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(m=>m.onError?m.onError(o):void 0)}onExit(o,m){this.trackers.forEach(d=>d.onExit?d.onExit(o,m):void 0)}}class n extends S.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends l{constructor(o,m,d,E,P,L){super(o,m,d,E,P,L)}createVariableResolver(o,m,d){return new w(o,m,d,this._editorTabs)}};r=Be([Fe(0,h.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,b.IExtHostConfiguration),Fe(5,a.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(ve[270],we([1,0,70,2,5,37,30,27,17,26,4,40,41,11,8]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(u,c,w,s,n,r,i){this._apiFactory=u,this._extensionRegistry=c,this._instaService=w,this._extHostConfiguration=s,this._extHostExtensionService=n,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new A(this._apiFactory,c,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(_,c)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(a,c,this._initData.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(let c of u.nodeModuleName)this._factories.set(c,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(c=>u.alternativeModuleName(c))}};h=Be([Fe(2,F.IInstantiationService),Fe(3,T.IExtHostConfiguration),Fe(4,D.IExtHostExtensionService),Fe(5,R.IExtHostInitDataService),Fe(6,b.ILogService)],h),e.RequireInterceptor=h;let v=class $i{constructor(u){if(u.environment.appRoot&&$i.aliased.size){const c=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(u.environment.appRoot.fsPath)),w="[a-z0-9_.-]",s=`@${w}+\\/${w}+|${w}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${c}/${n}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(u){if(!this.re)return;const c=this.re.exec(this.forceForwardSlashes(u));if(!c)return;const[,w,s,n]=c,r=$i.aliased.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),w+r+n}forceForwardSlashes(u){return u.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=Be([Fe(0,R.IExtHostInitDataService)],v);class A{constructor(u,c,w,s,n){this._apiFactory=u,this._extensionPaths=c,this._extensionRegistry=w,this._configProvider=s,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,c){const w=this._extensionPaths.findSubstr(c);if(w){let s=this._extApiImpl.get(k.ExtensionIdentifier.toKey(w.identifier));return s||(s=this._apiFactory(w,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(w.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((n,r)=>s+=`	${r} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(u,c,w){this._extensionPaths=u,this.nodeModuleName="keytar",this._mainThreadTelemetry=c.getProxy(I.MainContext.MainThreadTelemetry);const{environment:s}=w,n=c.getProxy(I.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;p.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>n.$getPassword(r,i),setPassword:(r,i,o)=>n.$setPassword(r,i,o),deletePassword:(r,i)=>n.$deletePassword(r,i),findPassword:r=>n.$findPassword(r),findCredentials(r){return n.$findCredentials(r)}}}load(u,c){const w=this._extensionPaths.findSubstr(c);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:w?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(u){const c=u.length;if(c<=7||!this.alternativeNames)return;const w=c-7;if((u.charAt(w)==="/"||u.charAt(w)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};_=Be([Fe(1,S.IExtHostRpcService),Fe(2,R.IExtHostInitDataService)],_);let a=class{constructor(u,c,w){this._extensionPaths=u,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=w.getProxy(I.MainContext.MainThreadTelemetry);const s=w.getProxy(I.MainContext.MainThreadWindow);this._impl=(n,r)=>{const i=t.URI.parse(n);return r?this.callOriginal(n,r):i.scheme==="http"||i.scheme==="https"?s.$openUri(i,n,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?s.$openUri(i,n,{}):this.callOriginal(n,r)}}load(u,c,w){const s=this._extensionPaths.findSubstr(c);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=w(u),this._impl}callOriginal(u,c){return this.sendNoForwardTelemetry(),this._original(u,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};a=Be([Fe(2,S.IExtHostRpcService)],a)}),define(ve[271],we([1,0,16,15,70,6,2,5,264,11,79,80,26,188,17,63,40,34]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(l,u,c,w,s){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=c,this._rpcProtocol=new S.RPCProtocol(l,null,w),u=_._transform(u,this._rpcProtocol);const n=new D.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());n.set(p.IExtHostInitDataService,{_serviceBrand:void 0,...u,messagePorts:s}),n.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),n.set(h.IURITransformerService,new h.URITransformerService(w)),n.set(v.IHostUtils,c);const r=new b.InstantiationService(n,!0);this._disposables.add(r.invokeFunction(d=>d.get(A.IExtHostTerminalService))),this._disposables.add(r.invokeFunction(d=>d.get(v.IExtHostExtensionService))),this._logService=r.invokeFunction(d=>d.get(R.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",u),this._extensionService=r.invokeFunction(d=>d.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(E,P)=>{let L="",O,y;for(const H of P)L+=`
	at ${H.toString()}`,y=H.getFileName(),!O&&y&&(O=d.findSubstr(C.URI.file(y)));return i.set(E,O),`${E.name||"Error"}: ${E.message||""}${L}`}});const o=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(d=>{const E=t.transformErrorForSerialization(d),P=i.get(d);P?o.$onExtensionRuntimeError(P.identifier,E):m.$onUnexpectedError(E)})}async asBrowserUri(l){const u=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService);return C.URI.revive(await u.$asBrowserUri(l))}terminate(l){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(c=>{this._logService.error(c)}),this._rpcProtocol.dispose();const u=this._extensionService.deactivateAll();Promise.race([(0,f.timeout)(5e3),u]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(l,u){l.extensions.forEach(w=>w.extensionLocation=C.URI.revive(u.transformIncomingURIs(w.extensionLocation))),l.environment.appRoot=C.URI.revive(u.transformIncomingURIs(l.environment.appRoot));const c=l.environment.extensionDevelopmentLocationURI;return c&&(l.environment.extensionDevelopmentLocationURI=c.map(w=>C.URI.revive(u.transformIncomingURIs(w)))),l.environment.extensionTestsLocationURI=C.URI.revive(u.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=C.URI.revive(u.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=C.URI.revive(u.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=C.URI.revive(u.transformIncomingURIs(l.logsLocation)),l.logFile=C.URI.revive(u.transformIncomingURIs(l.logFile)),l.workspace=u.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=_}),define(ve[272],we([1,0,173,60,12,7,211,36,40,45,37,34,17,54,195,16,212,53,187]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let a=class extends b.ExtHostDebugServiceBase{constructor(s,n,r,i,o,m,d){super(s,n,r,i,o,d);this._terminalService=m,this._integratedTerminalInstances=new c}createDebugAdapter(s,n){switch(s.type){case"server":return new C.SocketDebugAdapter(s);case"pipeServer":return new C.NamedPipeDebugAdapter(s);case"executable":return new C.ExecutableDebugAdapter(s,n.type)}return super.createDebugAdapter(s,n)}daExecutableFromPackage(s,n){const r=C.ExecutableDebugAdapter.platformAdapterExecutable(n.getAllExtensionDescriptions(),s.type);if(r)return new T.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new g.SignService}async $runInTerminal(s,n){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const r=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),m=s.title||f.localize(0,null),d=JSON.stringify({shell:i,shellArgs:o});let E=await this._integratedTerminalInstances.checkout(d,m),P,L=!1;if(E)P=s.cwd;else{const M={shellPath:i,shellArgs:o,cwd:s.cwd,name:m,iconPath:new T.ThemeIcon("debug")};L=!0,E=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(E,d)}E.show(!0);const O=await E.processId;L?await new Promise(M=>setTimeout(M,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?E.sendText("cls"):i.indexOf("bash")>=0?E.sendText("clear"):I.isWindows?E.sendText("cls"):E.sendText("clear"));const y=(0,v.prepareCommand)(i,s.args,P,s.env);E.sendText(y);const H=this.onDidTerminateDebugSession(M=>{M.id===n&&(this._integratedTerminalInstances.free(E),H.dispose())});return O}else if(s.kind==="external")return u(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,n)}createVariableResolver(s,n,r){return new b.ExtHostVariableResolverService(s,n,r,this._editorTabs,this._workspaceService,(0,t.homedir)())}};a=Be([Fe(0,p.IExtHostRpcService),Fe(1,k.IExtHostWorkspace),Fe(2,S.IExtHostExtensionService),Fe(3,R.IExtHostDocumentsAndEditors),Fe(4,F.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,A.IExtHostEditorTabs)],a),e.ExtHostDebugService=a;let l;function u(w,s){if(!l)if(I.isWindows)l=new _.WindowsExternalTerminalService;else if(I.isMacintosh)l=new _.MacExternalTerminalService;else if(I.isLinux)l=new _.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const n=s.getConfiguration("terminal");return l.runInTerminal(w.title,w.cwd,w.args,w.env||{},n.external||{})}e.runInExternalTerminal=u;class c{constructor(){this._terminalInstances=new Map}async checkout(s,n){const i=[...this._terminalInstances.entries()].map(([o,m])=>(0,h.createCancelablePromise)(async d=>{if(o.name!==n||m.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await o.processId))return null;const E=Date.now();return m.lastUsedAt+c.minUseDelay>E||d.isCancellationRequested||m.config!==s?null:(m.lastUsedAt=E,o)}));return await(0,h.firstParallel)(i,o=>!!o)}insert(s,n){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:n})}free(s){const n=this._terminalInstances.get(s);n&&(n.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}c.minUseDelay=1e3}),define(ve[273],we([1,0,9,2,112,36,54,45,37,43,34,17,26,69,10,11,64,53,23,60]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let l=class extends b.ExtHostTaskBase{constructor(c,w,s,n,r,i,o,m,d){super(c,w,s,n,r,i,o,m);this.workspaceService=s,this.editorTabs=d,w.remote.isRemote&&w.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:w.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,w){const s=w;if(!w.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const n=b.TaskHandleDTO.from(s,this.workspaceService),r=await this._proxy.$getTaskExecution(n);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(r,w);return this._proxy.$executeTask(n).catch(()=>{}),i}else{const n=b.TaskDTO.from(w,c);if(n===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,w,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),w);return this._proxy.$executeTask(n).catch(()=>{}),r}}provideTasksInternal(c,w,s,n){const r=[];if(n)for(let i of n){this.checkDeprecation(i,s),(!i.definition||!c[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const o=b.TaskDTO.from(i,s.extension);o&&(r.push(o),b.CustomExecutionDTO.is(o.execution)&&w.push(this.addCustomExecution(o,i,!0)))}return{tasks:r,extension:s.extension}}async resolveTaskInternal(c){return c}async getVariableResolver(c){if(this._variableResolver===void 0){const w=await this._configurationService.getConfigProvider();this._variableResolver=new C.ExtHostVariableResolverService(c,this._editorService,w,this.editorTabs,this.workspaceService,(0,a.homedir)())}return this._variableResolver}async getAFolder(c){let w=c&&c.length>0?c[0]:void 0;if(!w){const s=t.URI.file((0,a.homedir)());w=new R.WorkspaceFolder({uri:s,name:_.basename(s),index:0})}return{uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,w){const s=t.URI.revive(c),n={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(s),i=await this._workspaceProvider.getWorkspaceFolders2()??[],o=await this.getVariableResolver(i),m=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(i);for(let d of w.variables)n.variables[d]=await o.resolveAsync(m,d);if(w.process!==void 0){let d;if(w.process.path!==void 0){d=w.process.path.split(f.delimiter);for(let E=0;E<d.length;E++)d[E]=await o.resolveAsync(m,d[E])}n.process=await I.win32.findExecutable(await o.resolveAsync(m,w.process.name),w.process.cwd!==void 0?await o.resolveAsync(m,w.process.cwd):void 0,d)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(c,w,s){return I.win32.findExecutable(c,w,s)}};l=Be([Fe(0,D.IExtHostRpcService),Fe(1,p.IExtHostInitDataService),Fe(2,T.IExtHostWorkspace),Fe(3,k.IExtHostDocumentsAndEditors),Fe(4,S.IExtHostConfiguration),Fe(5,F.IExtHostTerminalService),Fe(6,h.ILogService),Fe(7,v.IExtHostApiDeprecationService),Fe(8,A.IExtHostEditorTabs)],l),e.ExtHostTask=l}),define(ve[137],we([1,0,18,16,21,49,32,10,9,23,13,2,31]),function(te,e,f,t,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(l,u,c,w){this.query=l,this.provider=u,this.fileUtils=c,this.processType=w,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,u){const c=this.query.folderQueries||[],w=new I.CancellationTokenSource;return u.onCancellationRequested(()=>w.cancel()),new Promise((s,n)=>{this.collector=new h(l);let r=!1;const i=(o,m)=>{if(!r&&!this.isLimitHit){const d=this.resultSize(o);A(o)&&typeof this.query.maxResults=="number"&&this.resultCount+d>this.query.maxResults&&(this.isLimitHit=!0,r=!0,w.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const E=this.resultSize(o);this.resultCount+=E,(E>0||!A(o))&&this.collector.add(o,m)}};Promise.all(c.map((o,m)=>this.searchInFolder(o,d=>i(d,m),w.token))).then(o=>{w.dispose(),this.collector.flush();const m=o.some(d=>!!d&&!!d.limitHit);s({limitHit:this.isLimitHit||m,messages:(0,f.flatten)(o.map(d=>d?.message?(0,F.isArray)(d.message)?d.message:[d.message]:[])),stats:{type:this.processType}})},o=>{w.dispose();const m=(0,T.toErrorMessage)(o);n(new Error(m))})})}resultSize(l){return A(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,u){const c=Array.isArray(l.ranges)?l.ranges:[l.ranges],w=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:c.slice(0,u),preview:{matches:w.slice(0,u),text:l.preview.text},uri:l.uri}}async searchInFolder(l,u,c){const w=new p.QueryGlobTester(this.query,l),s=[],n={report:o=>{if(!this.validateProviderResult(o))return;const m=l.folder.scheme===k.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(R.dirname(o.uri))):void 0,d=R.relativePath(l.folder,o.uri);if(d){const E=w.includedInQuery(d,S.basename(d),m);(0,t.isThenable)(E)?s.push(E.then(P=>{P&&u(o)})):E&&u(o)}}},r=this.getSearchOptionsForFolder(l),i=await this.provider.provideTextSearchResults(g(this.query.contentPattern),r,n,c);return s.length&&await Promise.all(s),i}validateProviderResult(l){if(A(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const u=(0,p.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),c=(0,p.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),w={folder:D.URI.from(l.folder),excludes:c,includes:u,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return w.usePCRE2=this.query.usePCRE2,w}}e.TextSearchManager=b;function g(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class h{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,u=>this.sendItems(u))}add(l,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!R.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(v(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=h;function v(a){return A(a)?{preview:{matches:(0,f.mapArrayOrNot)(a.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:a.preview.text},ranges:(0,f.mapArrayOrNot)(a.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function A(a){return!!a.preview}e.extensionResultIsMatch=A;class _{constructor(l,u){this.maxBatchSize=l,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,u){!l||this.addItemToBatch(l,u)}addItems(l,u){!l||this.addItemsToBatch(l,u)}addItemToBatch(l,u){this.batch.push(l),this.batchSize+=u,this.onUpdate()}addItemsToBatch(l,u){this.batch=this.batch.concat(l),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(ve[71],we([1,0,6,5,4,267,17,63,11,2,137]),function(te,e,f,t,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let D=class{constructor(h,v,A){this.extHostRpc=h,this._uriTransformer=v,this._logService=A,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,v){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const A=this._handlePool++;return this._textSearchProvider.set(A,v),this._proxy.$registerTextSearchProvider(A,this._transformScheme(h)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(h,v){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const A=this._handlePool++;return this._fileSearchProvider.set(A,v),this._proxy.$registerFileSearchProvider(A,this._transformScheme(h)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(h,v,A,_){const a=p(A),l=this._fileSearchProvider.get(h);if(l)return this._fileSearchManager.fileSearch(a,l,u=>{this._proxy.$handleFileMatch(h,v,u.map(c=>c.resource))},_);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,v,A,_){const a=this._textSearchProvider.get(h);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const l=p(A);return this.createTextSearchManager(l,a).search(c=>this._proxy.$handleTextMatch(h,v,c),_)}$enableExtensionHostSearch(){}createTextSearchManager(h,v){return new F.TextSearchManager(h,v,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};D=Be([Fe(0,C.IExtHostRpcService),Fe(1,k.IURITransformerService),Fe(2,S.ILogService)],D),e.ExtHostSearch=D;function p(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(h=>R.URI.revive(h))}}e.reviveQuery=p;function b(g){return{...g,folder:R.URI.revive(g.folder)}}}),define(ve[274],we([1,0,79,135,36,133,37,39,45,34,69,54,71,87,51,64,136,65,44,86,124,53,134,11,226]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a,l,u,c,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(w.ILoggerService,c.ExtHostLoggerService),(0,f.registerSingleton)(w.ILogService,s.ExtHostLogService),(0,f.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService),(0,f.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,f.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,f.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,f.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService),(0,f.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,f.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,f.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,f.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch),(0,f.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,f.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,f.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,f.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService),(0,f.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,f.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,f.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,f.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,f.registerSingleton)(u.IExtHostEditorTabs,u.ExtHostEditorTabs)}),define(ve[88],we([1,0,18,11,31,68]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.anchorGlob=C;function k(D,p,b,g){const h=(0,f.mapArrayOrNot)(b,S),v=new I.TextSearchMatch(p,h,g),A=v.preview.matches;return{ranges:(0,f.mapArrayOrNot)(h,R),uri:D,preview:{text:v.preview.text,matches:(0,f.mapArrayOrNot)(A,R)}}}e.createTextSearchResult=k;function S(D){return new I.SearchRange(D.start.line,D.start.character,D.end.line,D.end.character)}function R(D){return new T.Range(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let F=class{constructor(p,b){this.prefix=p,this.logService=b}appendLine(p){this.logService.debug(`${this.prefix}#search`,p)}};F=Be([Fe(1,t.ILogService)],F),e.OutputChannel=F}),define(ve[275],we([1,0,38,9,77,29,12,8,88,276]),function(te,e,f,t,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const F=R.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(a,l,u,c){const w=p(a,l,u,c),s=l.folder.fsPath;return{cmd:f.spawn(F,w.args,{cwd:s}),rgDiskPath:F,siblingClauses:w.siblingClauses,rgArgs:w,cwd:s}}e.spawnRipgrepCmd=D;function p(a,l,u,c){const w=["--files","--hidden","--case-sensitive"];g([l],u,!1).forEach(n=>{const r=(0,S.anchorGlob)(n);if(w.push("-g",r),C.isMacintosh){const i=(0,I.normalizeNFD)(r);i!==r&&w.push("-g",i)}});const s=b([l],c,void 0,!1);return s.globArgs.forEach(n=>{const r=`!${(0,S.anchorGlob)(n)}`;if(w.push("-g",r),C.isMacintosh){const i=(0,I.normalizeNFD)(r);i!==r&&w.push("-g",i)}}),l.disregardIgnoreFiles!==!1?w.push("--no-ignore"):l.disregardParentIgnoreFiles!==!1&&w.push("--no-ignore-parent"),l.ignoreSymlinks||w.push("--follow"),a.exists&&w.push("--quiet"),w.push("--no-config"),l.disregardGlobalIgnoreFiles&&w.push("--no-ignore-global"),{args:w,siblingClauses:s.siblingClauses}}function b(a,l,u,c=!0){const w=[];let s={};return a.forEach(n=>{const r=Object.assign({},n.excludePattern||{},l||{}),i=h(r,c?n.folder.fsPath:void 0,u);w.push(...i.globArgs),i.siblingClauses&&(s=Object.assign(s,i.siblingClauses))}),{globArgs:w,siblingClauses:s}}e.foldersToRgExcludeGlobs=b;function g(a,l,u=!0){const c=[];return a.forEach(w=>{const s=Object.assign({},l||{},w.includePattern||{}),n=h(s,u?w.folder.fsPath:void 0);c.push(...n.globArgs)}),c}e.foldersToIncludeGlobs=g;function h(a,l,u){const c=[],w={};return Object.keys(a).forEach(s=>{if(u&&u.has(s)||!s)return;const n=a[s];s=A(l?v(l,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),c.push(_(s))):n&&n.when&&(w[s]=n)}),{globArgs:c,siblingClauses:w}}function v(a,l){return t.isAbsolute(l)?l:t.join(a,l)}e.getAbsoluteGlob=v;function A(a){return a=k.rtrim(a,"\\"),k.rtrim(a,"/")}function _(a){return T.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=_}),define(ve[277],we([1,0,38,59,9,102,18,49,32,77,29,12,46,8,13,28,31,275,98]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(s=>s())});class l{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&S.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&S.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(r=>{const i=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),o=r.folder.fsPath;n.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==o).forEach(m=>{(0,F.isEqualOrParent)(m,o)&&(i[I.relative(o,m)]=!0)}),this.folderExcludePatterns.set(o,new c(i,o))})}cancel(){this.isCanceled=!0,a.forEach(n=>n())}walk(n,r,i,o,m){if(this.fileWalkSW=p.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);r.forEach(d=>{const E=I.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,E)||this.matchFile(i,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=p.StopWatch.create(!1),this.parallel(n,(d,E)=>{this.call(this.cmdTraversal,this,d,i,o,P=>{if(P){const L=(0,k.toErrorMessage)(P);console.error(L),this.errors.push(L),E(P,void 0)}else E(null,void 0)})},(d,E)=>{this.fileWalkSW.stop();const P=d?C.coalesce(d)[0]:null;m(P,this.isLimitHit)})}parallel(n,r,i){const o=new Array(n.length),m=new Array(n.length);let d=!1,E=0;if(n.length===0)return i(null,[]);n.forEach((P,L)=>{r(P,(O,y)=>{if(O?(d=!0,o[L]=null,m[L]=O):(o[L]=y,m[L]=null),++E===n.length)return i(d?m:null,o)})})}call(n,r,...i){try{n.apply(r,i)}catch(o){i[i.length-1](o)}}cmdTraversal(n,r,i,o){const m=n.folder.fsPath,d=D.isMacintosh;let E;const P=()=>E&&E.kill();a.add(P);let L=$=>{a.delete(P),L=()=>{},o($)},O="";const y=this.initDirectoryTree();let H;const M=(0,A.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);E=M.cmd,H=!Object.keys(M.siblingClauses).length;const j=M.rgArgs.args.map($=>$.match(/^-/)?$:`'${$}'`).join(" ");let Q=`${M.rgDiskPath} ${j}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(Q+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),i({message:Q}),this.cmdResultCount=0,this.collectStdout(E,"utf8",i,($,U,q)=>{if($){L($);return}if(this.isLimitHit){L();return}const G=(O+(d?R.normalizeNFC(U||""):U)).split(`
`);if(q){const ee=G.length;G[ee-1]=G[ee-1].trim(),G[ee-1]||G.pop()}else O=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=G.length,H){for(const ee of G)if(this.matchFile(r,{base:m,relativePath:ee,searchPath:this.getSearchPath(n,ee)}),this.isLimitHit){P();break}(q||this.isLimitHit)&&L();return}this.addDirectoryEntries(n,y,m,G,r),q&&(this.matchDirectoryTree(y,m,r),L())})}spawnFindCmd(n){const r=this.folderExcludePatterns.get(n.folder.fsPath),i=r.getBasenameTerms(),o=r.getPathTerms(),m=["-L","."];if(i.length||o.length){m.push("-not","(","(");for(const d of i)m.push("-name",d),m.push("-o");for(const d of o)m.push("-path",d),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),f.spawn("find",m,{cwd:n.folder.fsPath})}readStdout(n,r,i){let o="";this.collectStdout(n,r,()=>{},(m,d,E)=>{if(m){i(m);return}o+=d,E&&i(null,o)})}collectStdout(n,r,i,o){let m=(P,L,O)=>{(P||O)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),o(P,L,O)},d=!1;n.stdout?(this.forwardData(n.stdout,r,m),n.stdout.once("data",()=>d=!0)):i({message:"stdout is null"});let E;n.stderr?E=this.collectData(n.stderr):i({message:"stderr is null"}),n.on("error",P=>{m(P)}),n.on("close",P=>{let L;!d&&(L=this.decodeData(E,r))&&w(L)?m(new Error(`command failed with error code ${P}: ${this.decodeData(E,r)}`)):(this.exists&&P===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(n,r,i){const o=new T.StringDecoder(r);return n.on("data",m=>{i(null,o.write(m))}),o}collectData(n){const r=[];return n.on("data",i=>{r.push(i)}),r}decodeData(n,r){const i=new T.StringDecoder(r);return n.map(o=>i.write(o)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:r},i,o,m){o.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:i,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const d=E=>{const P=I.basename(E),L=I.dirname(E);let O=r[L];O||(O=r[L]=[],d(L)),O.push({base:i,relativePath:E,basename:P,searchPath:this.getSearchPath(n,E)})};o.forEach(d)}matchDirectoryTree({rootEntries:n,pathToEntries:r},i,o){const m=this,d=this.folderExcludePatterns.get(i),E=this.filePattern;function P(L){m.directoriesWalked++;const O=S.hasSiblingFn(()=>L.map(y=>y.basename));for(let y=0,H=L.length;y<H;y++){const M=L[y],{relativePath:j,basename:Q}=M;if(d.test(j,Q,E!==Q?O:void 0))continue;const $=r[j];if($)P($);else{if(m.filesWalked++,j===E)continue;m.matchFile(o,M)}if(m.isLimitHit)break}}P(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,r,i,o,m){const d=n.folder,E=S.hasSiblingFn(()=>i);this.parallel(i,(P,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const O=r?[r,P].join(I.sep):P;if(this.folderExcludePatterns.get(n.folder.fsPath).test(O,P,this.config.filePattern!==P?E:void 0))return L(null);const y=[d.fsPath,O].join(I.sep);t.lstat(y,(H,M)=>{if(H||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(y,M,(j,Q)=>j||this.isCanceled||this.isLimitHit?L(null):Q.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(y,M,($,U)=>$||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?L(null):(this.walkedPaths[U]=!0,h.Promises.readdir(y).then(q=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(n,O,q,o,K=>L(K||null))},q=>{L(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&g.isNumber(Q.size)&&Q.size>this.maxFilesize||this.matchFile(o,{base:d.fsPath,relativePath:O,searchPath:this.getSearchPath(n,O)}),L(null,void 0)))})},P=>{const L=P&&C.coalesce(P);return m(L&&L.length>0?L[0]:void 0)})}matchFile(n,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,I.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(r))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,r,i){return r.isSymbolicLink()?t.stat(n,i):i(null,r)}realPathIfNeeded(n,r,i){return r.isSymbolicLink()?t.realpath(n,(o,m)=>o?i(o):i(null,m)):i(null,n)}getSearchPath(n,r){return n.folderName?I.join(n.folderName,r):r}}e.FileWalker=l;class u{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new l(n)}search(n,r,i){this.walker.walk(this.folderQueries,this.extraFiles,n,r,(o,m)=>{i(o,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=u;class c{constructor(n,r){this.expression=n,this.root=r,this.init(n)}init(n){let r,i;Object.keys(n).filter(o=>n[o]).forEach(o=>{I.isAbsolute(o)?(r=r||S.getEmptyExpression(),r[o]=n[o]):(i=i||S.getEmptyExpression(),i[o]=n[o])}),this.absoluteParsedExpr=r&&S.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=i&&S.parse(i,{trimForExclusions:!0})}test(n,r,i){return this.relativeParsedExpr&&this.relativeParsedExpr(n,r,i)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,n),r,i)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getPathTerms(this.relativeParsedExpr)),n}}function w(s){const n=s.trim().split(`
`),r=n[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return b.uppercaseFirstLetter(n[n.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=w}),define(ve[278],we([1,0,94,22]),function(te,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===s)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,C=512,k=512*8,S=512*128;var R;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(R=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class F extends Error{constructor(n,r){super(n);this.decodeStreamErrorKind=r}}e.DecodeStreamError=F;class D{constructor(n){this.iconvLiteDecoder=n}static async create(n){let r;if(n!==e.UTF8)r=(await new Promise((o,m)=>{te(["@vscode/iconv-lite-umd"],o,m)})).getDecoder(h(n));else{const i=new TextDecoder;r={write(o){return i.decode(o,{stream:!0})},end(){return i.decode()}}}return new D(r)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function p(s,n){const r=n.minBytesRequiredForDetection??n.guessEncoding?k:C;return new Promise((i,o)=>{const m=(0,f.newWriteableStream)(y=>y.join("")),d=[];let E=0,P,L;const O=async()=>{try{const y=await w({buffer:t.VSBuffer.concat(d),bytesRead:E},n.guessEncoding);if(y.seemsBinary&&n.acceptTextOnly)throw new F("Stream is binary but only text is accepted for decoding",1);y.encoding=await n.overwriteEncoding(y.encoding),P=await D.create(y.encoding);const H=P.write(t.VSBuffer.concat(d).buffer);m.write(H),d.length=0,E=0,i({stream:m,detected:y})}catch(y){L?.dispose(),m.destroy(),o(y)}};L=(0,f.listenStream)(s,{onData:async y=>{P?m.write(P.write(y.buffer)):(d.push(y),E+=y.byteLength,E>=r&&(s.pause(),await O(),setTimeout(()=>s.resume())))},onError:y=>m.error(y),onEnd:async()=>{P||await O(),m.end(P?.end())}})})}e.toDecodeStream=p;async function b(s,n,r){const o=(await new Promise((E,P)=>{te(["@vscode/iconv-lite-umd"],E,P)})).getEncoder(h(n),r);let m=!1,d=!1;return{read(){if(d)return null;const E=s.read();if(typeof E!="string"){if(d=!0,!m&&r?.addBOM)switch(n){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const P=o.end();return P&&P.length>0?(m=!0,t.VSBuffer.wrap(P)):null}return m=!0,t.VSBuffer.wrap(o.write(E))}}}e.toEncodeReadable=b;async function g(s){return(await new Promise((r,i)=>{te(["@vscode/iconv-lite-umd"],r,i)})).encodingExists(h(s))}e.encodingExists=g;function h(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=h;function v(s,n){if(!s||n<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),i=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=s.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const A=["ascii","utf-16","utf-32"];async function _(s){const n=await new Promise((d,E)=>{te(["jschardet"],d,E)}),r=s.slice(0,S),i=u(r.buffer),o=n.detect(i);if(!o||!o.encoding)return null;const m=o.encoding.toLowerCase();return 0<=A.indexOf(m)?null:l(o.encoding)}const a={ibm866:"cp866",big5:"cp950"};function l(s){const n=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[n]||n}function u(s){let n="";for(let r=0;r<s.length;r++)n+=String.fromCharCode(s[r]);return n}function c(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const n=s.match(/windows(\d+)/);return n?"windows-"+n[1]:s}}}e.toCanonicalName=c;function w({buffer:s,bytesRead:n},r){let i=v(s,n),o=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&s){let m=!0,d=!0,E=!1;for(let P=0;P<n&&P<T;P++){const L=P%2==1,O=s.readUInt8(P)===0;if(O&&(E=!0),m&&(L&&!O||!L&&O)&&(m=!1),d&&(L&&O||!L&&!O)&&(d=!1),O&&!m&&!d)break}E&&(m?i=e.UTF16le:d?i=e.UTF16be:o=!0)}return r&&!o&&!i&&s?_(s.slice(0,n)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:o,encoding:i}}e.detectEncodingFromBuffer=w,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[138],we([1,0,278,28,137]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends I.TextSearchManager{constructor(k,S,R=t,F="searchProcess"){super(k,S,{readdir:D=>R.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,f.toCanonicalName)(D)},F)}}e.NativeTextSearchManager=T}),define(ve[279],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class f{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const T=this._dragOperations.get(I);return this._dragOperations.delete(I),T}}addDragOperationTransfer(I,T){this._dragOperations.set(I,T)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,T){this._renderedElements.set(I,T)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=f}),define(ve[280],we([1,0,171,23,2,3,6,16,7,13,18,14,21,205,279]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(_,a){if((0,R.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let l;return Array.isArray(_.highlights)&&(l=_.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),l=l.length?l:void 0),{label:_.label,highlights:l}}}class v{constructor(a,l,u){this._proxy=a,this.commands=l,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new g.TreeviewsService;function c(w){return w&&w.$treeViewId&&w.$treeItemHandle}l.registerArgumentProcessor({processArgument:w=>c(w)?this.convertArgument(w):Array.isArray(w)&&w.length>0?w.map(s=>c(s)?this.convertArgument(s):s):w})}registerTreeDataProvider(a,l,u){const c=this.createTreeView(a,{treeDataProvider:l},u);return{dispose:()=>c.dispose()}}createTreeView(a,l,u){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=l.dragAndDropController?.dropMimeTypes??[],w=l.dragAndDropController?.dragMimeTypes??[],s=!!l.dragAndDropController?.handleDrag,n=!!l.dragAndDropController?.handleDrop,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,dropMimeTypes:c,dragMimeTypes:w,hasHandleDrag:s,hasHandleDrop:n}),i=this.createExtHostTreeView(a,l,u);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(o){i.message=o},get title(){return i.title},set title(o){i.title=o},get description(){return i.description},set description(o){i.description=o},reveal:(o,m)=>i.reveal(o,m),dispose:async()=>{await r,this.treeViews.delete(a),i.dispose()}}}$getChildren(a,l){const u=this.treeViews.get(a);return u?u.getChildren(l):Promise.reject(new Error((0,f.localize)(0,null,a)))}async $handleDrop(a,l,u,c,w,s,n){const r=this.treeViews.get(a);if(!r)return Promise.reject(new Error((0,f.localize)(1,null,a)));const i=b.TreeDataTransferConverter.toITreeDataTransfer(l);return s===a&&n&&await this.addAdditionalTransferItems(i,r,n,c,w),r.onDrop(i,u,c)}async addAdditionalTransferItems(a,l,u,c,w){const s=this.treeDragAndDropService.removeDragOperationTransfer(w);if(s)(await s)?.forEach((n,r)=>{n&&a.set(r,n)});else if(w&&l.handleDrag){const n=l.handleDrag(u,a,c);this.treeDragAndDropService.addDragOperationTransfer(w,n),await n}return a}async $handleDrag(a,l,u,c){const w=this.treeViews.get(a);if(!w)return Promise.reject(new Error((0,f.localize)(2,null,a)));const s=await this.addAdditionalTransferItems(new Map,w,l,c,u);if(!!s)return b.TreeDataTransferConverter.toTreeDataTransferDTO(s)}async $hasResolve(a){const l=this.treeViews.get(a);if(!l)throw new Error((0,f.localize)(3,null,a));return l.hasResolve}$resolve(a,l,u){const c=this.treeViews.get(a);if(!c)throw new Error((0,f.localize)(4,null,a));return c.resolveTreeItem(l,u)}$setExpanded(a,l,u){const c=this.treeViews.get(a);if(!c)throw new Error((0,f.localize)(5,null,a));c.setExpanded(l,u)}$setSelection(a,l){const u=this.treeViews.get(a);if(!u)throw new Error((0,f.localize)(6,null,a));u.setSelection(l)}$setVisible(a,l){const u=this.treeViews.get(a);if(!u)throw new Error((0,f.localize)(7,null,a));u.setVisible(l)}createExtHostTreeView(a,l,u){const c=new A(a,l,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(a,c),c}convertArgument(a){const l=this.treeViews.get(a.$treeViewId);return l?l.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=v;class A extends C.Disposable{constructor(a,l,u,c,w,s){super();if(this.viewId=a,this.proxy=u,this.commands=c,this.logService=w,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,s.contributes&&s.contributes.views)for(const i in s.contributes.views)for(const o of s.contributes.views[i])o.id===a&&(this._title=o.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(i=>this._onDidChangeData.fire({message:!1,element:i}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let n,r;this._register(T.Event.debounce(this._onDidChangeData.event,(i,o)=>(i||(i={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(m=>r=m),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(o.element)?i.elements.push(...o.element):i.elements.push(o.element)),o.message&&(i.message=!0),i),200,!0)(({message:i,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=r;return n=null,this.refresh(o).then(()=>m())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.isUndefinedOrNull)(a))}async getChildren(a){const l=a?this.getExtensionElement(a):void 0;if(a&&!l)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(a);return u||(u=await this.fetchChildrenNodes(l)),u?u.map(c=>c.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,l){l=l||{select:!0,focus:!1};const u=(0,R.isUndefinedOrNull)(l.select)?!0:l.select,c=(0,R.isUndefinedOrNull)(l.focus)?!1:l.focus,w=(0,R.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(r=>r.item)},{select:u,focus:c,expand:w})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:c,expand:w})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,l){const u=this.getExtensionElement(a);u&&(l?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(a){(0,F.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,l,u){const c=[];for(const w of a){const s=this.getExtensionElement(w);s&&c.push(s)}if(!(!this.dndController?.handleDrag||c.length===0))return await this.dndController.handleDrag(c,l,u),l}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,l,u){const c=this.getExtensionElement(l);if(!(!c||!this.dndController?.handleDrop))return(0,k.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(c,a,u):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,l){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(a);if(u){const c=this.nodes.get(u);if(c){const w=await this.dataProvider.resolveTreeItem(c.extensionItem,u,l)??c.extensionItem;return c.item.tooltip=this.getTooltip(w.tooltip),c.item.command=this.getCommand(c.disposableStore,w.command),c.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(l=>l?this.resolveUnknownParentChain(l).then(u=>this.resolveTreeNode(l,u[u.length-1]).then(c=>(u.push(c),u))):Promise.resolve([]))}resolveParent(a){const l=this.nodes.get(a);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,l){const u=this.nodes.get(a);return u?Promise.resolve(u):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(c=>this.createHandle(a,c,l,!0)).then(c=>this.getChildren(l?l.item.handle:void 0).then(()=>{const w=this.getExtensionElement(c);if(w){const s=this.nodes.get(w);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(a){if(a){let l;if(typeof a=="string"){const u=this.getExtensionElement(a);l=u?this.nodes.get(u):void 0}else l=a;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const l=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=a?this.nodes.get(a):void 0,c=await this.dataProvider.getChildren(a);if(l.token.isCancellationRequested)return;const w=await Promise.all((0,F.coalesce)(c||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!l.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,u):null}));return l.token.isCancellationRequested?void 0:(0,F.coalesce)(w)}finally{l.dispose()}}refresh(a){if(a.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(a);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const l=new Set,u=a.map(w=>this.nodes.get(w));for(const w of u)if(w&&!l.has(w.item.handle)){let s=w;for(;s&&s.parent&&u.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&l.add(w.item.handle)}const c=[];return l.forEach(w=>{const s=this.elements.get(w);if(s){const n=this.nodes.get(s);n&&(!n.parent||!l.has(n.parent.item.handle))&&c.push(w)}}),c}refreshHandles(a){const l={};return Promise.all(a.map(u=>this.refreshNode(u).then(c=>{c&&(l[u]=c.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(a){const l=this.getExtensionElement(a);if(l){const u=this.nodes.get(l);if(u)return this.clearChildren(l),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(c=>{if(c){const w=this.createTreeNode(l,c,u.parent);return this.updateNodeCache(l,w,u,u.parent),u.dispose(),w}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,l,u){const c=this.createTreeNode(a,l,u);if(l.id&&this.elements.has(c.item.handle))throw new Error((0,f.localize)(8,null,l.id));return this.addNodeToCache(a,c),this.addNodeToParentCache(c,u),c}getTooltip(a){return S.MarkdownString.isMarkdownString(a)?D.MarkdownString.from(a):a}getCommand(a,l){return l?this.commands.toInternal(l,a):void 0}createTreeNode(a,l,u){const c=new C.DisposableStore,w=this.createHandle(a,l,u),s=this.getLightIconPath(l);return{item:{handle:w,parentHandle:u?u.item.handle:void 0,label:h(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(c,l.command),contextValue:l.contextValue,icon:s,iconDark:this.getDarkIconPath(l)||s,themeIcon:this.getThemeIcon(l),collapsibleState:(0,R.isUndefinedOrNull)(l.collapsibleState)?S.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation},extensionItem:l,parent:u,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(a){return a.iconPath instanceof S.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:l,label:u,resourceUri:c},w,s){if(l)return`${A.ID_HANDLE_PREFIX}/${l}`;const n=h(u,this.extension),r=w?w.item.handle:A.LABEL_HANDLE_PREFIX;let i=n?n.label:c?(0,t.basename)(c):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const o=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,m=this.getChildrenNodes(w)||[];let d,E=0;do{if(d=`${r}/${E}:${i}`,s||!this.elements.has(d)||o===d)break;E++}while(E<=m.length);return d}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof S.ThemeIcon))return typeof a.iconPath=="string"||I.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof S.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return I.URI.isUri(a)?a:I.URI.file(a)}addNodeToCache(a,l){this.elements.set(l.item.handle,a),this.nodes.set(a,l)}updateNodeCache(a,l,u,c){this.elements.delete(l.item.handle),this.nodes.delete(a),l.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(a,l);const w=this.getChildrenNodes(c)||[],s=w.filter(n=>n.item.handle===u.item.handle)[0];s&&w.splice(w.indexOf(s),1,l)}addNodeToParentCache(a,l){l?(l.children||(l.children=[]),l.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const l=this.nodes.get(a);if(l){if(l.children)for(const u of l.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}l.children=void 0}}else this.clearAll()}clear(a){const l=this.nodes.get(a);if(l){if(l.children)for(const u of l.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}this.nodes.delete(a),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}A.LABEL_HANDLE_PREFIX="0",A.ID_HANDLE_PREFIX="1"}),define(ve[281],we([1,0,21,15,3,47,2,113,109,149,108,42,5,132,231,230,39,232,37,233,234,235,219,236,45,40,237,238,241,242,243,135,221,248,249,250,87,34,252,280,14,7,255,67,136,36,73,208,240,121,133,69,54,71,11,63,17,26,244,203,51,64,228,253,202,66,65,258,256,257,229,44,251,254,86,53,124,246,68,247,10,117,245,200,239,6,30,209]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_,a,l,u,c,w,s,n,r,i,o,m,d,E,P,L,O,y,H,M,j,Q,$,U,q,K,G,ee,oe,ue,Z,Y,se,de,ge,Te,Ne,be,Ee,z,B,N,W,V,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et,Le,it,ne,ae,J,pe,Se,Me,$e,Ye,lt,vt,wt,je,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function _t(nt){const ct=nt.get(z.IExtHostInitDataService),Rt=nt.get(Je.IExtHostFileSystemInfo),Tt=nt.get(We.IExtHostConsumerFileSystem),yt=nt.get(n.IExtHostExtensionService),mt=nt.get(ee.IExtHostWorkspace),Lt=nt.get(ae.IExtHostTelemetry),Mt=nt.get(_.IExtHostConfiguration),Ft=nt.get(be.IURITransformerService),xe=nt.get(Ee.IExtHostRpcService),_e=nt.get(H.IExtHostStorage),ye=nt.get(Ae.IExtensionStoragePaths),me=nt.get(Ne.ILoggerService),ie=nt.get(Ne.ILogService),Ie=nt.get(W.IExtHostTunnelService),Re=nt.get(V.IExtHostApiDeprecationService),Ve=nt.get(G.IExtHostWindow),Ke=nt.get(it.IExtHostSecretState),ht=nt.get(ne.IExtHostEditorTabs);xe.set(p.ExtHostContext.ExtHostFileSystemInfo,Rt),xe.set(p.ExtHostContext.ExtHostLogLevelServiceShape,me),xe.set(p.ExtHostContext.ExtHostWorkspace,mt),xe.set(p.ExtHostContext.ExtHostConfiguration,Mt),xe.set(p.ExtHostContext.ExtHostExtensionService,yt),xe.set(p.ExtHostContext.ExtHostStorage,_e),xe.set(p.ExtHostContext.ExtHostTunnelService,Ie),xe.set(p.ExtHostContext.ExtHostWindow,Ve),xe.set(p.ExtHostContext.ExtHostSecretState,Ke),xe.set(p.ExtHostContext.ExtHostTelemetry,Lt),xe.set(p.ExtHostContext.ExtHostEditorTabs,ht);const Et=xe.set(p.ExtHostContext.ExtHostDecorations,nt.get(se.IExtHostDecorations)),St=xe.set(p.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(s.IExtHostDocumentsAndEditors)),ot=xe.set(p.ExtHostContext.ExtHostCommands,nt.get(v.IExtHostCommands)),dt=xe.set(p.ExtHostContext.ExtHostTerminalService,nt.get(M.IExtHostTerminalService)),ut=xe.set(p.ExtHostContext.ExtHostDebugService,nt.get(ge.IExtHostDebugService)),Nt=xe.set(p.ExtHostContext.ExtHostSearch,nt.get(Te.IExtHostSearch)),pt=xe.set(p.ExtHostContext.ExtHostTask,nt.get(de.IExtHostTask)),kt=xe.set(p.ExtHostContext.ExtHostOutputService,nt.get(E.IExtHostOutputService)),Ut=xe.set(p.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(xe)),Ct=xe.set(p.ExtHostContext.ExtHostDocuments,new w.ExtHostDocuments(xe,St)),Bt=xe.set(p.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(xe,St,ie)),Ht=xe.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new c.ExtHostDocumentSaveParticipant(ie,Ct,xe.getProxy(p.MainContext.MainThreadBulkEdits))),bt=xe.set(p.ExtHostContext.ExtHostNotebook,new B.ExtHostNotebookController(xe,ot,St,Ct,ye)),ei=xe.set(p.ExtHostContext.ExtHostNotebookDocuments,new lt.ExtHostNotebookDocuments(ie,bt)),Xt=xe.set(p.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(ie,xe,bt)),ti=xe.set(p.ExtHostContext.ExtHostNotebookKernels,new J.ExtHostNotebookKernels(xe,ct,bt,ot,ie)),ai=xe.set(p.ExtHostContext.ExtHostNotebookRenderers,new Se.ExtHostNotebookRenderers(xe,bt)),Pt=xe.set(p.ExtHostContext.ExtHostEditors,new j.ExtHostEditors(xe,St)),ii=xe.set(p.ExtHostContext.ExtHostTreeViews,new Q.ExtHostTreeViews(xe.getProxy(p.MainContext.MainThreadTreeViews),ot,ie)),bi=xe.set(p.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(xe.getProxy(p.MainContext.MainThreadEditorInsets),Pt,ct)),qt=xe.set(p.ExtHostContext.ExtHostDiagnostics,new a.ExtHostDiagnostics(xe,ie,Rt)),Gt=xe.set(p.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(xe,Ct,ot.converter,Ft)),at=xe.set(p.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(xe,Ft,Ct,ot,qt,ie,Re)),li=xe.set(p.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(xe,at)),$t=xe.set(p.ExtHostContext.ExtHostFileSystemEventService,new i.ExtHostFileSystemEventService(xe,ie,St)),xt=xe.set(p.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(xe,mt,ot)),ni=xe.set(p.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(xe,ot,ie)),_i=xe.set(p.ExtHostContext.ExtHostComments,(0,A.createExtHostComments)(xe,ot,Ct)),fi=xe.set(p.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(xe.getProxy(p.MainContext.MainThreadProgress))),Si=xe.set(p.ExtHostContext.ExtHosLabelService,new Z.ExtHostLabelService(xe)),mi=xe.set(p.ExtHostContext.ExtHostTheming,new N.ExtHostTheming(xe)),ri=xe.set(p.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(xe)),Ci=xe.set(p.ExtHostContext.ExtHostTimeline,new he.ExtHostTimeline(xe,ot)),Qt=xe.set(p.ExtHostContext.ExtHostWebviews,new K.ExtHostWebviews(xe,{remote:ct.remote},mt,ie,Re)),Yt=xe.set(p.ExtHostContext.ExtHostWebviewPanels,new He.ExtHostWebviewPanels(xe,Qt,mt)),yi=xe.set(p.ExtHostContext.ExtHostCustomEditors,new qe.ExtHostCustomEditors(xe,Ct,ye,Qt,Yt)),Di=xe.set(p.ExtHostContext.ExtHostWebviewViews,new ze.ExtHostWebviewViews(xe,Qt)),Jt=xe.set(p.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(xe,ot)),si=xe.set(p.ExtHostContext.ExtHostUriOpeners,new Le.ExtHostUriOpeners(xe));xe.set(p.ExtHostContext.ExtHostInteractive,new vt.ExtHostInteractive(xe,bt,St,ot));const Ii=(0,oe.values)(p.ExtHostContext);xe.assertRegistered(Ii);const ki=new Ue.ExtHostBulkEdits(xe,St),Pi=new h.ExtHostClipboard(xe),Zt=new d.ExtHostMessageService(xe,ie),gi=new l.ExtHostDialogs(xe),Kt=new y.ExtHostStatusBar(xe,ot.converter);return g.ExtHostApiCommands.register(ot),function(Oe,ci,Ot){const ft=function(){let le=!Oe.isUnderDevelopment;function fe(){le||(ie.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function ke(tt){if(Array.isArray(tt))tt.forEach(ke);else if(typeof tt=="string")fe();else{const gt=tt;typeof gt.scheme=="undefined"&&fe(),typeof gt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Oe,"documentFiltersExclusive"),typeof gt.notebookType=="string"&&(0,je.checkProposedApiEnabled)(Oe,"notebookDocumentSelector")}return tt}}(),Ti={getSession(le,fe,ke){return ri.getSession(Oe,le,fe,ke)},async hasSession(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"authSession"),!!await ri.getSession(Oe,le,fe,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(le,fe,ke,tt){return ri.registerAuthenticationProvider(le,fe,ke,tt)}},Ai={registerCommand(le,fe,ke){return ot.registerCommand(!0,le,fe,ke,void 0,Oe)},registerTextEditorCommand(le,fe,ke){return ot.registerCommand(!0,le,(...tt)=>{const gt=Pt.getActiveTextEditor();if(!gt){ie.warn("Cannot execute "+le+" because there is no active text editor.");return}return gt.edit(It=>{fe.apply(ke,[gt,It,...tt])}).then(It=>{It||ie.warn("Edits from command "+le+" were not applied.")},It=>{ie.warn("An error occurred while running command "+le,It)})},void 0,void 0,Oe)},registerDiffInformationCommand:(le,fe,ke)=>((0,je.checkProposedApiEnabled)(Oe,"diffCommand"),ot.registerCommand(!0,le,async(...tt)=>{const gt=St.activeEditor(!0);if(!gt){ie.warn("Cannot execute "+le+" because there is no active text editor.");return}const It=await Pt.getDiffInformation(gt.id);fe.apply(ke,[It,...tt])},void 0,void 0,Oe)),executeCommand(le,...fe){return ot.executeCommand(le,...fe)},getCommands(le=!1){return ot.getCommands(le)}},pi={get machineId(){return ct.telemetryInfo.machineId},get sessionId(){return ct.telemetryInfo.sessionId},get language(){return ct.environment.appLanguage},get appName(){return ct.environment.appName},get appRoot(){return ct.environment.appRoot?.fsPath??""},get appHost(){return ct.environment.appHost},get uriScheme(){return ct.environment.appUriScheme},get clipboard(){return Pi.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Lt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Oe,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Oe,"telemetry"),Lt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const le=Date.now()-new Date(ct.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,fe){return Ve.openUri(le,{allowTunneling:!!ct.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===ct.environment.appUriScheme)return Ut.createAppUri(le);try{return await Ve.asExternalUri(le,{allowTunneling:!!ct.remote.authority})}catch(fe){if((0,$e.matchesScheme)(le,Me.Schemas.http)||(0,$e.matchesScheme)(le,Me.Schemas.https))return le;throw fe}},get remoteName(){return(0,Y.getRemoteName)(ct.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Oe,"resolvers"),ct.remote.authority},get uiKind(){return ct.uiKind}};ct.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ct.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Ri={createTestController(le,fe,ke){return Jt.createTestController(le,fe,ke)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.createTestObserver()},runTests(le){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.runTests(le)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.results}},Li={getExtension(le){const fe=ci.getExtensionDescription(le);if(fe)return new n.Extension(yt,Oe.identifier,fe,vi)},get all(){return ci.getAllExtensionDescriptions().map(le=>new n.Extension(yt,Oe.identifier,le,vi))},get onDidChange(){return ci.onDidChange}},Oi={createDiagnosticCollection(le){return qt.createDiagnosticCollection(Oe.identifier,le)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:le=>qt.getDiagnostics(le),getLanguages(){return Gt.getLanguages()},setTextDocumentLanguage(le,fe){return Gt.changeLanguage(le.uri,fe)},match(le,fe){return(0,F.score)($.LanguageSelector.from(le),fe.uri,fe.languageId,!0,fe.notebook?.notebookType)},registerCodeActionsProvider(le,fe,ke){return at.registerCodeActionProvider(Oe,ft(le),fe,ke)},registerCodeLensProvider(le,fe){return at.registerCodeLensProvider(Oe,ft(le),fe)},registerDefinitionProvider(le,fe){return at.registerDefinitionProvider(Oe,ft(le),fe)},registerDeclarationProvider(le,fe){return at.registerDeclarationProvider(Oe,ft(le),fe)},registerImplementationProvider(le,fe){return at.registerImplementationProvider(Oe,ft(le),fe)},registerTypeDefinitionProvider(le,fe){return at.registerTypeDefinitionProvider(Oe,ft(le),fe)},registerHoverProvider(le,fe){return at.registerHoverProvider(Oe,ft(le),fe,Oe.identifier)},registerEvaluatableExpressionProvider(le,fe){return at.registerEvaluatableExpressionProvider(Oe,ft(le),fe,Oe.identifier)},registerInlineValuesProvider(le,fe){return at.registerInlineValuesProvider(Oe,ft(le),fe,Oe.identifier)},registerDocumentHighlightProvider(le,fe){return at.registerDocumentHighlightProvider(Oe,ft(le),fe)},registerLinkedEditingRangeProvider(le,fe){return at.registerLinkedEditingRangeProvider(Oe,ft(le),fe)},registerReferenceProvider(le,fe){return at.registerReferenceProvider(Oe,ft(le),fe)},registerRenameProvider(le,fe){return at.registerRenameProvider(Oe,ft(le),fe)},registerDocumentSymbolProvider(le,fe,ke){return at.registerDocumentSymbolProvider(Oe,ft(le),fe,ke)},registerWorkspaceSymbolProvider(le){return at.registerWorkspaceSymbolProvider(Oe,le)},registerDocumentFormattingEditProvider(le,fe){return at.registerDocumentFormattingEditProvider(Oe,ft(le),fe)},registerDocumentRangeFormattingEditProvider(le,fe){return at.registerDocumentRangeFormattingEditProvider(Oe,ft(le),fe)},registerOnTypeFormattingEditProvider(le,fe,ke,...tt){return at.registerOnTypeFormattingEditProvider(Oe,ft(le),fe,[ke].concat(tt))},registerDocumentSemanticTokensProvider(le,fe,ke){return at.registerDocumentSemanticTokensProvider(Oe,ft(le),fe,ke)},registerDocumentRangeSemanticTokensProvider(le,fe,ke){return at.registerDocumentRangeSemanticTokensProvider(Oe,ft(le),fe,ke)},registerSignatureHelpProvider(le,fe,ke,...tt){return typeof ke=="object"?at.registerSignatureHelpProvider(Oe,ft(le),fe,ke):at.registerSignatureHelpProvider(Oe,ft(le),fe,typeof ke=="undefined"?[]:[ke,...tt])},registerCompletionItemProvider(le,fe,...ke){return at.registerCompletionItemProvider(Oe,ft(le),fe,ke)},registerInlineCompletionItemProvider(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"inlineCompletions"),at.registerInlineCompletionsProvider(Oe,ft(le),fe)},registerDocumentLinkProvider(le,fe){return at.registerDocumentLinkProvider(Oe,ft(le),fe)},registerColorProvider(le,fe){return at.registerColorProvider(Oe,ft(le),fe)},registerFoldingRangeProvider(le,fe){return at.registerFoldingRangeProvider(Oe,ft(le),fe)},registerSelectionRangeProvider(le,fe){return at.registerSelectionRangeProvider(Oe,le,fe)},registerCallHierarchyProvider(le,fe){return at.registerCallHierarchyProvider(Oe,le,fe)},registerTypeHierarchyProvider(le,fe){return at.registerTypeHierarchyProvider(Oe,le,fe)},setLanguageConfiguration:(le,fe)=>at.setLanguageConfiguration(Oe,le,fe),getTokenInformationAtPosition(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"tokenInformation"),Gt.tokenAtPosition(le,fe)},registerInlayHintsProvider(le,fe){return at.registerInlayHintsProvider(Oe,le,fe)},createLanguageStatusItem(le,fe){return Gt.createLanguageStatusItem(Oe,le,fe)}},ui={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(le,fe,ke){const tt=await(C.URI.isUri(le)?Promise.resolve(wi.openTextDocument(le)):Promise.resolve(le));return Pt.showTextDocument(tt,fe,ke)},createTextEditorDecorationType(le){return Pt.createTextEditorDecorationType(Oe,le)},onDidChangeActiveTextEditor(le,fe,ke){return Pt.onDidChangeActiveTextEditor(le,fe,ke)},onDidChangeVisibleTextEditors(le,fe,ke){return Pt.onDidChangeVisibleTextEditors(le,fe,ke)},onDidChangeTextEditorSelection(le,fe,ke){return Pt.onDidChangeTextEditorSelection(le,fe,ke)},onDidChangeTextEditorOptions(le,fe,ke){return Pt.onDidChangeTextEditorOptions(le,fe,ke)},onDidChangeTextEditorVisibleRanges(le,fe,ke){return Pt.onDidChangeTextEditorVisibleRanges(le,fe,ke)},onDidChangeTextEditorViewColumn(le,fe,ke){return Pt.onDidChangeTextEditorViewColumn(le,fe,ke)},onDidCloseTerminal(le,fe,ke){return dt.onDidCloseTerminal(le,fe,ke)},onDidOpenTerminal(le,fe,ke){return dt.onDidOpenTerminal(le,fe,ke)},onDidChangeActiveTerminal(le,fe,ke){return dt.onDidChangeActiveTerminal(le,fe,ke)},onDidChangeTerminalDimensions(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"terminalDimensions"),dt.onDidChangeTerminalDimensions(le,fe,ke)},onDidChangeTerminalState(le,fe,ke){return dt.onDidChangeTerminalState(le,fe,ke)},onDidWriteTerminalData(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(le,fe,ke)},get state(){return Ve.state},onDidChangeWindowState(le,fe,ke){return Ve.onDidChangeWindowState(le,fe,ke)},showInformationMessage(le,...fe){return Zt.showMessage(Oe,T.default.Info,le,fe[0],fe.slice(1))},showWarningMessage(le,...fe){return Zt.showMessage(Oe,T.default.Warning,le,fe[0],fe.slice(1))},showErrorMessage(le,...fe){return Zt.showMessage(Oe,T.default.Error,le,fe[0],fe.slice(1))},showQuickPick(le,fe,ke){return xt.showQuickPick(le,fe,ke)},showWorkspaceFolderPick(le){return xt.showWorkspaceFolderPick(le)},showInputBox(le,fe){return xt.showInput(le,fe)},showOpenDialog(le){return gi.showOpenDialog(le)},showSaveDialog(le){return gi.showSaveDialog(le)},createStatusBarItem(le,fe,ke){let tt,gt,It;return typeof le=="string"?(tt=le,gt=fe,It=ke):(gt=le,It=fe),Kt.createStatusBarEntry(Oe,tt,gt,It)},setStatusBarMessage(le,fe){return Kt.setStatusBarMessage(le,fe)},withScmProgress(le){return Re.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),fi.withProgress(Oe,{location:U.ProgressLocation.SourceControl},(fe,ke)=>le({report(tt){}}))},withProgress(le,fe){return fi.withProgress(Oe,le,fe)},createOutputChannel(le,fe){return fe&&(0,je.checkProposedApiEnabled)(Oe,"outputChannelLanguage"),kt.createOutputChannel(le,fe,Oe)},createWebviewPanel(le,fe,ke,tt){return Yt.createWebviewPanel(Oe,le,fe,ke,tt)},createWebviewTextEditorInset(le,fe,ke,tt){return(0,je.checkProposedApiEnabled)(Oe,"editorInsets"),bi.createWebviewEditorInset(le,fe,ke,tt,Oe)},createTerminal(le,fe,ke){return typeof le=="object"?"pty"in le?dt.createExtensionTerminal(le):dt.createTerminalFromOptions(le):dt.createTerminal(le,fe,ke)},registerTerminalLinkProvider(le){return dt.registerLinkProvider(le)},registerTerminalProfileProvider(le,fe){return dt.registerProfileProvider(Oe,le,fe)},registerTreeDataProvider(le,fe){return ii.registerTreeDataProvider(le,fe,Oe)},createTreeView(le,fe){return ii.createTreeView(le,fe,Oe)},registerWebviewPanelSerializer:(le,fe)=>Yt.registerWebviewPanelSerializer(Oe,le,fe),registerCustomEditorProvider:(le,fe,ke={})=>yi.registerCustomEditorProvider(Oe,le,fe,ke),registerFileDecorationProvider(le){return Et.registerFileDecorationProvider(le,Oe.identifier)},registerUriHandler(le){return Ut.registerUriHandler(Oe.identifier,le)},createQuickPick(){return xt.createQuickPick(Oe)},createInputBox(){return xt.createInputBox(Oe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(le,fe,ke){return mi.onDidChangeActiveColorTheme(le,fe,ke)},registerWebviewViewProvider(le,fe,ke){return Di.registerWebviewViewProvider(Oe,le,fe,ke?.webviewOptions)},get activeNotebookEditor(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(le,fe,ke)},get visibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(le,fe,ke)},onDidChangeNotebookEditorVisibleRanges(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(le,fe,ke)},showNotebookDocument(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.showNotebookDocument(le,fe)},registerExternalUriOpener(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"externalUriOpener"),si.registerExternalUriOpener(Oe.identifier,le,fe,ke)},get tabGroups(){return(0,je.checkProposedApiEnabled)(Oe,"tabs"),ht.tabGroups},getInlineCompletionItemController(le){return(0,je.checkProposedApiEnabled)(Oe,"inlineCompletions"),o.InlineCompletionController.get(le)}},wi={get rootPath(){return Re.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return mt.getWorkspaceFolder(le)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(le){throw t.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,fe,...ke)=>mt.updateWorkspaceFolders(Oe,le,fe||0,...ke),onDidChangeWorkspaceFolders:function(le,fe,ke){return mt.onDidChangeWorkspace(le,fe,ke)},asRelativePath:(le,fe)=>mt.getRelativePath(le,fe),findFiles:(le,fe,ke,tt)=>mt.findFiles(le,fe,ke,Oe.identifier,tt),findTextInFiles:(le,fe,ke,tt)=>{(0,je.checkProposedApiEnabled)(Oe,"findTextInFiles");let gt,It;return typeof fe=="object"?(gt=fe,It=ke):(gt={},It=fe,tt=ke),mt.findTextInFiles(le,gt||{},It,Oe.identifier,tt)},saveAll:le=>mt.saveAll(le),applyEdit(le){return ki.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,fe,ke,tt)=>$t.createFileSystemWatcher(mt,Oe,le,fe,ke,tt),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let fe;const ke=le;if(typeof le=="string")fe=Promise.resolve(C.URI.file(le));else if(C.URI.isUri(le))fe=Promise.resolve(le);else if(!ke||typeof ke=="object")fe=Ct.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(tt=>Ct.ensureDocumentData(tt).then(gt=>gt.document))},onDidOpenTextDocument:(le,fe,ke)=>Ct.onDidAddDocument(le,fe,ke),onDidCloseTextDocument:(le,fe,ke)=>Ct.onDidRemoveDocument(le,fe,ke),onDidChangeTextDocument:(le,fe,ke)=>Ct.onDidChangeDocument(le,fe,ke),onDidSaveTextDocument:(le,fe,ke)=>Ct.onDidSaveDocument(le,fe,ke),onWillSaveTextDocument:(le,fe,ke)=>Ht.getOnWillSaveTextDocumentEvent(Oe)(le,fe,ke),get notebookDocuments(){return bt.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,fe){let ke;if(C.URI.isUri(le))ke=le,await bt.openNotebookDocument(le);else if(typeof le=="string")ke=C.URI.revive(await bt.createNotebookDocument({viewType:le,content:fe}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(le,fe,ke,tt){return bt.registerNotebookSerializer(Oe,le,fe,ke,(0,je.isProposedApiEnabled)(Oe,"notebookLiveShare")?tt:void 0)},registerNotebookContentProvider:(le,fe,ke,tt)=>((0,je.checkProposedApiEnabled)(Oe,"notebookContentProvider"),bt.registerNotebookContentProvider(Oe,le,fe,ke,(0,je.isProposedApiEnabled)(Oe,"notebookLiveShare")?tt:void 0)),onDidChangeConfiguration:(le,fe,ke)=>Ot.onDidChangeConfiguration(le,fe,ke),getConfiguration(le,fe){return fe=arguments.length===1?void 0:fe,Ot.getConfiguration(le,fe,Oe)},registerTextDocumentContentProvider(le,fe){return Bt.registerTextDocumentContentProvider(le,fe)},registerTaskProvider:(le,fe)=>(Re.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Oe,le,fe)),registerFileSystemProvider(le,fe,ke){return(0,wt.combinedDisposable)(li.registerFileSystemProvider(Oe,le,fe,ke),Tt.addFileSystemProvider(le,fe))},get fs(){return Tt.value},registerFileSearchProvider:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Nt.registerFileSearchProvider(le,fe)),registerTextSearchProvider:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"textSearchProvider"),Nt.registerTextSearchProvider(le,fe)),registerRemoteAuthorityResolver:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),yt.registerRemoteAuthorityResolver(le,fe)),registerResourceLabelFormatter:le=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Si.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,fe,ke)=>$t.onDidCreateFile(le,fe,ke),onDidDeleteFiles:(le,fe,ke)=>$t.onDidDeleteFile(le,fe,ke),onDidRenameFiles:(le,fe,ke)=>$t.onDidRenameFile(le,fe,ke),onWillCreateFiles:(le,fe,ke)=>$t.getOnWillCreateFileEvent(Oe)(le,fe,ke),onWillDeleteFiles:(le,fe,ke)=>$t.getOnWillDeleteFileEvent(Oe)(le,fe,ke),onWillRenameFiles:(le,fe,ke)=>$t.getOnWillRenameFileEvent(Oe)(le,fe,ke),openTunnel:le=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.openTunnel(Oe,le).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.getTunnels()},onDidChangeTunnels:(le,fe,ke)=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.onDidChangeTunnels(le,fe,ke)),registerPortAttributesProvider:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"portsAttributes"),Ie.registerPortsAttributesProvider(le,fe)),registerTimelineProvider:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"timeline"),Ci.registerTimelineProvider(le,fe,Oe.identifier,ot.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:le=>((0,je.checkProposedApiEnabled)(Oe,"workspaceTrust"),mt.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,fe,ke)=>mt.onDidGrantWorkspaceTrust(le,fe,ke)},Fi={get inputBox(){return Re.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Oe)},createSourceControl(le,fe,ke){return ni.createSourceControl(Oe,le,fe,ke)}},Ni={createCommentController(le,fe){return _i.createCommentController(Oe,le,fe)}},Mi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(le,fe,ke){return ut.onDidStartDebugSession(le,fe,ke)},onDidTerminateDebugSession(le,fe,ke){return ut.onDidTerminateDebugSession(le,fe,ke)},onDidChangeActiveDebugSession(le,fe,ke){return ut.onDidChangeActiveDebugSession(le,fe,ke)},onDidReceiveDebugSessionCustomEvent(le,fe,ke){return ut.onDidReceiveDebugSessionCustomEvent(le,fe,ke)},onDidChangeBreakpoints(le,fe,ke){return ut.onDidChangeBreakpoints(le,fe,ke)},registerDebugConfigurationProvider(le,fe,ke){return ut.registerDebugConfigurationProvider(le,fe,ke||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,fe){return ut.registerDebugAdapterDescriptorFactory(Oe,le,fe)},registerDebugAdapterTrackerFactory(le,fe){return ut.registerDebugAdapterTrackerFactory(le,fe)},startDebugging(le,fe,ke){return!ke||typeof ke=="object"&&"configuration"in ke?ut.startDebugging(le,fe,{parentSession:ke}):ut.startDebugging(le,fe,ke||{})},stopDebugging(le){return ut.stopDebugging(le)},addBreakpoints(le){return ut.addBreakpoints(le)},removeBreakpoints(le){return ut.removeBreakpoints(le)},asDebugSourceUri(le,fe){return ut.asDebugSourceUri(le,fe)}},Ui={registerTaskProvider:(le,fe)=>pt.registerTaskProvider(Oe,le,fe),fetchTasks:le=>pt.fetchTasks(le),executeTask:le=>pt.executeTask(Oe,le),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(le,fe,ke)=>pt.onDidStartTask(le,fe,ke),onDidEndTask:(le,fe,ke)=>pt.onDidEndTask(le,fe,ke),onDidStartTaskProcess:(le,fe,ke)=>pt.onDidStartTaskProcess(le,fe,ke),onDidEndTaskProcess:(le,fe,ke)=>pt.onDidEndTaskProcess(le,fe,ke)},Bi={createNotebookController(le,fe,ke,tt,gt){return ti.createNotebookController(Oe,le,fe,ke,tt,(0,je.isProposedApiEnabled)(Oe,"notebookMessaging")?gt:void 0)},registerNotebookCellStatusBarItemProvider:(le,fe)=>bt.registerNotebookCellStatusBarItemProvider(Oe,le,fe),get onDidSaveNotebookDocument(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return ai.createRendererMessaging(Oe,le)},onDidChangeNotebookDocumentMetadata(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(le,fe,ke)},onDidChangeNotebookCells(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeNotebookCells(le,fe,ke)},onDidChangeNotebookCellExecutionState(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(le,fe,ke)},onDidChangeCellOutputs(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeCellOutputs(le,fe,ke)},onDidChangeCellMetadata(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeCellMetadata(le,fe,ke)},createConcatTextDocument(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new Ce.ExtHostNotebookConcatDocument(bt,Ct,le,fe)}};return{version:ct.version,authentication:Ti,commands:Ai,comments:Ni,debug:Mi,env:pi,extensions:Li,languages:Oi,notebooks:Bi,scm:Fi,tasks:Ui,tests:Ri,window:ui,workspace:wi,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CommentThreadState:U.CommentThreadState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:R.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,TabKind:p.TabKind,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:b.UIKind,Uri:C.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TreeDataTransfer:U.TreeDataTransfer,TreeDataTransferItem:U.TreeDataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=_t}),define(ve[282],we([1,0,283,292,293,2,294]),function(te,e,f,t,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(D,p,b,g,h,v){const A=v.environment.useHostProxy,_=typeof A=="boolean"?A:!v.remote.isRemote,a=(0,C.createProxyResolver)({resolveProxy:u=>D.resolveProxy(u),getHttpProxySetting:()=>p.getConfiguration("http").get("proxy"),log:(u,c,...w)=>{switch(u){case C.LogLevel.Trace:g.trace(c,...w);break;case C.LogLevel.Debug:g.debug(c,...w);break;case C.LogLevel.Info:g.info(c,...w);break;case C.LogLevel.Warning:g.warn(c,...w);break;case C.LogLevel.Error:g.error(c,...w);break;case C.LogLevel.Critical:g.critical(c,...w);break;case C.LogLevel.Off:break;default:s(u,c,w);break}function s(n,r,...i){g.error("Unknown log level",n),g.error(r,...i)}},getLogLevel:()=>g.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:_,env:process.env}),l=S(p,a);return F(b,l)}e.connectProxyResolver=k;function S(D,p){const b={config:D.getConfiguration("http").get("proxySupport")||"off"};D.onDidChangeConfiguration(h=>{b.config=D.getConfiguration("http").get("proxySupport")||"off"});const g={config:!!D.getConfiguration("http").get("systemCertificates")};return D.onDidChangeConfiguration(h=>{g.config=!!D.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,C.createHttpPatch)(f,p,{config:"off"},g,!0)),on:Object.assign({},f,(0,C.createHttpPatch)(f,p,{config:"on"},g,!0)),override:Object.assign({},f,(0,C.createHttpPatch)(f,p,{config:"override"},g,!0)),onRequest:Object.assign({},f,(0,C.createHttpPatch)(f,p,b,g,!0)),default:Object.assign(f,(0,C.createHttpPatch)(f,p,b,g,!1))},https:{off:Object.assign({},t,(0,C.createHttpPatch)(t,p,{config:"off"},g,!0)),on:Object.assign({},t,(0,C.createHttpPatch)(t,p,{config:"on"},g,!0)),override:Object.assign({},t,(0,C.createHttpPatch)(t,p,{config:"override"},g,!0)),onRequest:Object.assign({},t,(0,C.createHttpPatch)(t,p,b,g,!0)),default:Object.assign(t,(0,C.createHttpPatch)(t,p,b,g,!1))},tls:Object.assign(I,(0,C.createTlsPatch)(I))}}const R=new Map;function F(D,p){return D.getExtensionPathIndex().then(b=>{const g=te.__$__nodeRequire("module"),h=g._load;g._load=function(A,_,a){if(A==="tls")return p.tls;if(A!=="http"&&A!=="https")return h.apply(this,arguments);const l=p[A],u=b.findSubstr(T.URI.file(_.filename));let c=R.get(u);if(c||R.set(u,c={}),!c[A]){let w=l.default;c[A]={...w}}return c[A]}})}}),define(ve[139],we([1,0,38,295,102,18,73,32,9,8,2,31,68,296,276,88]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(d){this.outputChannel=d}provideTextSearchResults(d,E,P,L){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((O,y)=>{L.onCancellationRequested(()=>K());const H=w(d,E),M=E.folder.fsPath,j=H.map(Z=>Z.match(/^-/)?Z:`'${Z}'`).join(" ");this.outputChannel.appendLine(`${v} ${j}
 - cwd: ${M}`);let Q=f.spawn(v,H,{cwd:M});Q.on("error",Z=>{console.error(Z),this.outputChannel.appendLine("Error: "+(Z&&Z.message)),y((0,D.serializeSearchError)(new D.SearchError(Z&&Z.message,D.SearchErrorCode.rgProcessError)))});let $=!1;const U=new l(E.maxResults,M,E.previewOptions);U.on("result",Z=>{$=!0,ee="",P.report(Z)});let q=!1;const K=()=>{q=!0,Q&&Q.kill(),U&&U.cancel()};let G=!1;U.on("hitLimit",()=>{G=!0,K()});let ee="";Q.stdout.on("data",Z=>{U.handleData(Z),$||(ee+=Z)});let oe=!1;Q.stdout.once("data",()=>oe=!0);let ue="";Q.stderr.on("data",Z=>{const Y=Z.toString();this.outputChannel.appendLine(Y),ue+=Y}),Q.on("close",()=>{if(this.outputChannel.appendLine(oe?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine($?"Got result from parser":"No result from parser"),ee&&this.outputChannel.appendLine(`Got data without result: ${ee}`),this.outputChannel.appendLine(""),q)O({limitHit:G});else{U.flush(),Q=null;let Z;ue&&!oe&&(Z=_(ue))?y((0,D.serializeSearchError)(new D.SearchError(Z.message,Z.code))):O({limitHit:G})}})})}}e.RipgrepTextSearchEngine=A;function _(m){const d=m.split(`
`),E=d[0].trim();if(d.some(L=>L.startsWith("regex parse error")))return new D.SearchError(a(d),D.SearchErrorCode.regexParseError);const P=E.match(/grep config error: unknown encoding: (.*)/);if(P)return new D.SearchError(`Unknown encoding: ${P[1]}`,D.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new D.SearchError(E.charAt(0).toUpperCase()+E.substr(1),D.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new D.SearchError(E.charAt(0).toUpperCase()+E.substr(1),D.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new D.SearchError(E,D.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function a(m){const d=["Regex parse error"],E=m.filter(P=>P.startsWith("PCRE2:"));if(E.length>=1){const P=E[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const L=P.split(":")[1];d.push(":"+L)}}return d.join("")}e.buildRegexParseError=a;class l extends t.EventEmitter{constructor(d,E,P){super();this.maxResults=d,this.rootFolder=E,this.previewOptions=P,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,E){return super.on(d,E),this}handleData(d){if(this.isDone)return;const E=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(E)}handleDecodedData(d){let E=d.indexOf(`
`);const P=this.remainder+d;if(E>=0)E+=this.remainder.length;else{this.remainder=P;return}let L=0;for(;E>=0;)this.handleLine(P.substring(L,E).trim()),L=E+1,E=P.indexOf(`
`,L);this.remainder=P.substring(L)}handleLine(d){if(this.isDone||!d)return;let E;try{E=JSON.parse(d)}catch{throw new Error(`malformed line from rg: ${d}`)}if(E.type==="match"){const P=u(E.data.path),L=F.URI.file(S.join(this.rootFolder,P)),O=this.createTextSearchMatch(E.data,L);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const P=u(E.data.path),L=F.URI.file(S.join(this.rootFolder,P));this.createTextSearchContext(E.data,L).forEach(y=>this.onResult(y))}}createTextSearchMatch(d,E){const P=d.line_number-1,L=u(d.lines),O=Buffer.from(L);let y=0,H=0,M=P;d.submatches.length===0&&d.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const j=(0,T.coalesce)(d.submatches.map((Q,$)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=u(Q.match),q=O.slice(y,Q.start).toString().length,K=H+q,G=c(U),ee=M,oe=G.numLines+ee,ue=G.numLines>0?G.lastLineLength:G.lastLineLength+K;return y=Q.end,H=ue,M=oe,new p.Range(ee,K,oe,ue)}));return(0,h.createTextSearchResult)(E,L,j,this.previewOptions)}createTextSearchContext(d,E){const P=u(d.lines),L=d.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((O,y)=>({text:O,uri:E,lineNumber:L+y}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=l;function u(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function c(m){const d=/\n/g;let E=0,P=-1,L;for(;L=d.exec(m);)E++,P=L.index;const O=P>=0?m.length-P-1:m.length;return{numLines:E,lastLineLength:O}}function w(m,d){const E=["--hidden"];E.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:L}=(0,C.groupBy)(d.includes,y=>y.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const y=new Set;L.forEach(H=>{y.add(H)}),E.push("-g","!*"),y.forEach(H=>{s(H).map(h.anchorGlob).forEach(M=>{E.push("-g",M)})})}P&&P.length&&P.forEach(y=>{E.push("-g",y)}),d.excludes.map(h.anchorGlob).forEach(y=>E.push("-g",`!${y}`)),d.maxFileSize&&E.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?d.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),d.followSymlinks&&E.push("--follow"),d.encoding&&d.encoding!=="utf8"&&E.push("--encoding",d.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,R.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),d.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),m.isRegExp&&(m.pattern=n(m.pattern),E.push("--engine","auto"));let O;if(m.isWordMatch){const H=(0,R.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",H)}else if(m.isRegExp){let y=i(m.pattern);y=o(y),E.push("--regexp",y)}else O=m.pattern,E.push("--fixed-strings");return E.push("--no-config"),d.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),m.isMultiline&&E.push("--multiline"),d.beforeContext&&E.push("--before-context",d.beforeContext+""),d.afterContext&&E.push("--after-context",d.afterContext+""),E.push("--"),O&&E.push(O),E.push("."),E}function s(m){const d=(0,k.splitGlobAware)(m,"/");return d.map((E,P)=>d.slice(0,P+1).join("/"))}e.spreadGlobComponents=s;function n(m){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(d);)m=m.replace(d,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(E);)m=m.replace(E,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=n;const r=m=>m.type==="Assertion"&&m.kind==="lookbehind";function i(m){let d;try{d=new b.RegExpParser().parsePattern(m)}catch{return m}let E="",P=0;const L=(H,M,j)=>{E+=m.slice(P,H)+j,P=M},O=[];return new b.RegExpVisitor({onCharacterEnter(H){if(H.raw!=="\\n")return;const M=O[0];if(!M)L(H.start,H.end,"\\r?\\n");else if(!O.some(r))if(M.type==="CharacterClass")if(M.negate){const j=m.slice(M.start+2,H.start)+m.slice(H.end,M.end-1);M.parent?.type==="Quantifier"?L(M.start,M.end,j?`[^${j}]`:"."):L(M.start,M.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=m.slice(M.start+1,H.start)+m.slice(H.end,M.end-1);L(M.start,M.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else M.type==="Quantifier"&&L(H.start,H.end,"(?:\\r?\\n)")},onQuantifierEnter(H){O.unshift(H)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(H){O.unshift(H)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(H){O.unshift(H)},onCharacterClassLeave(){O.shift()},onAssertionEnter(H){r(H)&&O.push(H)},onAssertionLeave(H){O[0]===H&&O.shift()}}).visit(d),E+=m.slice(P),E}e.fixRegexNewline=i;function o(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(ve[284],we([1,0,21,139,118,10]),function(te,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(R){this.outputChannel=R,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(R,F,D,p){const b=new t.RipgrepTextSearchEngine(this.outputChannel);if(F.folder.scheme===T.Schemas.userData){const g={...F,folder:F.folder.with({scheme:T.Schemas.file})},h=new I.Progress(v=>D.report({...v,uri:v.uri.with({scheme:F.folder.scheme})}));return this.withToken(p,v=>b.provideTextSearchResults(R,g,h,v))}else return this.withToken(p,g=>b.provideTextSearchResults(R,F,D,g))}async withToken(R,F){const D=k(R);this.inProgress.add(D);const p=await F(D.token);return this.inProgress.delete(D),p}dispose(){this.inProgress.forEach(R=>R.cancel())}}e.RipgrepSearchProvider=C;function k(S){const R=new f.CancellationTokenSource;return S.onCancellationRequested(()=>R.cancel()),R}}),define(ve[285],we([1,0,28,139,138]),function(te,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(S){this.query=S}search(S,R,F){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(b){F({message:b})}},p=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(D),f);return new Promise((b,g)=>p.search(h=>{R(h.map(C))},S).then(h=>b({limitHit:h.limitHit,type:"success",stats:h.stats}),g))}}e.TextSearchEngineAdapter=T;function C(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,R)=>{if(R.ranges){const F=R;return S+(Array.isArray(F.ranges)?F.ranges.length:1)}else return S+1},0)}}}),define(ve[286],we([1,0,18,16,15,3,98,9,46,2,42,31,277,285]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class g{constructor(l="searchProcess"){this.processType=l,this.caches=Object.create(null)}fileSearch(l){let u;const c=A(l),w=new T.Emitter({onFirstListenerDidAdd:()=>{u=(0,t.createCancelablePromise)(s=>this.doFileSearchWithEngine(p.Engine,c,n=>w.fire(n),s)),u.then(s=>w.fire(s),s=>w.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return w.event}textSearch(l){let u;const c=A(l),w=new T.Emitter({onFirstListenerDidAdd:()=>{u=(0,t.createCancelablePromise)(s=>this.ripgrepTextSearch(c,n=>w.fire(n),s)),u.then(s=>w.fire(s),s=>w.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return w.event}ripgrepTextSearch(l,u,c){return l.maxFileSize=(0,F.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(l).search(c,u,u)}doFileSearch(l,u,c){return this.doFileSearchWithEngine(p.Engine,l,u,c)}doFileSearchWithEngine(l,u,c,w,s=g.BATCH_SIZE){let n=0;const r=o=>{Array.isArray(o)?(n+=o.length,c(o.map(m=>this.rawMatchToSearchItem(m)))):o.relativePath?(n++,c(this.rawMatchToSearchItem(o))):c(o)};if(u.sortByScore){let o=this.trySortedSearchFromCache(u,r,w);if(!o){const m=u.maxResults?Object.assign({},u,{maxResults:null}):u,d=new l(m);o=this.doSortedSearch(d,u,c,r,w)}return new Promise((m,d)=>{o.then(([E,P])=>{const L=P.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(L,c,s),m(E)},d)})}const i=new l(u);return this.doSearch(i,r,s,w).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:n,sortingTime:void 0}}))}rawMatchToSearchItem(l){return{path:l.base?(0,k.join)(l.base,l.relativePath):l.relativePath}}doSortedSearch(l,u,c,w,s){const n=new T.Emitter;let r=(0,t.createCancelablePromise)(o=>{let m=[];const d=E=>{Array.isArray(E)?m=E:(w(E),n.fire(E))};return this.doSearch(l,d,-1,o).then(E=>[E,m])}),i;if(u.cacheKey){i=this.getOrCreateCache(u.cacheKey);const o={promise:r,event:n.event,resolved:!1};i.resultsToSearchCache[u.filePattern||""]=o,r.then(()=>{o.resolved=!0},m=>{delete i.resultsToSearchCache[u.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([o,m])=>{const d=i?i.scorerCache:Object.create(null),E=(typeof u.maxResults!="number"||u.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(u,m,d,s).then(P=>{const L=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:L,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:P.length},messages:o.messages,limitHit:o.limitHit||typeof u.maxResults=="number"&&m.length>u.maxResults},P]})})}getOrCreateCache(l){const u=this.caches[l];return u||(this.caches[l]=new h)}trySortedSearchFromCache(l,u,c){const w=l.cacheKey&&this.caches[l.cacheKey];if(!w)return;const s=this.getResultsFromCache(w,l.filePattern||"",u,c);if(s)return s.then(([n,r,i])=>{const o=S.StopWatch.create(!1);return this.sortResults(l,r,w.scorerCache,c).then(m=>{const d=o.elapsed(),E={fromCache:!0,detailStats:i,type:this.processType,resultCount:r.length,sortingTime:d};return[{type:"success",limitHit:n.limitHit||typeof l.maxResults=="number"&&r.length>l.maxResults,stats:E},m]})})}sortResults(l,u,c,w){const s=(0,C.prepareQuery)(l.filePattern||""),n=(i,o)=>(0,C.compareItemsByFuzzyScore)(i,o,s,!0,v,c),r=typeof l.maxResults=="number"?l.maxResults:Number.MAX_VALUE;return f.topAsync(u,n,r,1e4,w)}sendProgress(l,u,c){if(c&&c>0)for(let w=0;w<l.length;w+=c)u(l.slice(w,w+c));else u(l)}getResultsFromCache(l,u,c,w){const s=S.StopWatch.create(!1),n=u.indexOf(k.sep)>=0;let r;for(const d in l.resultsToSearchCache)if(u.startsWith(d)){if(n&&d.indexOf(k.sep)<0&&d!=="")continue;const E=l.resultsToSearchCache[d];r={promise:this.preventCancellation(E.promise),event:E.event,resolved:E.resolved};break}if(!r)return null;const i=s.elapsed(),o=S.StopWatch.create(!1),m=r.event(c);return w&&w.onCancellationRequested(()=>{m.dispose()}),r.promise.then(([d,E])=>{if(w&&w.isCancellationRequested)throw(0,I.canceled)();const P=[],L=(0,C.prepareQuery)(u).normalizedLowercase;for(const O of E)!(0,D.isFilePatternMatch)(O,L)||P.push(O);return[d,P,{cacheWasResolved:r.resolved,cacheLookupTime:i,cacheFilterTime:o.elapsed(),cacheEntryCount:E.length}]})}doSearch(l,u,c,w){return new Promise((s,n)=>{let r=[];w&&w.onCancellationRequested(()=>l.cancel()),l.search(i=>{i&&(c?(r.push(i),c>0&&r.length>=c&&(u(r),r=[])):u(i))},i=>{u(i)},(i,o)=>{r.length&&u(r),i?n(i):s(o)})})}clearCache(l){return delete this.caches[l],Promise.resolve(void 0)}preventCancellation(l){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,c){return l.then(u,c)}catch(u){return this.then(void 0,u)}finally(u){return l.finally(u)}}}}e.SearchService=g,g.BATCH_SIZE=512;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(a){return(0,k.basename)(a.relativePath)}getItemDescription(a){return(0,k.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function A(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(_),extraFileResources:a.extraFileResources&&a.extraFileResources.map(l=>R.URI.revive(l))}}function _(a){return{...a,folder:R.URI.revive(a.folder)}}}),define(ve[287],we([1,0,6,10,2,28,11,26,17,71,63,31,286,284,88,138]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends R.ExtHostSearch{constructor(_,a,l,u){super(_,l,u);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const c=new g.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new b.RipgrepSearchProvider(c)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const _=new g.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new b.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(t.Schemas.file,new p.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(_,a){const l=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(_)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(_,a,l,u){const c=(0,R.reviveQuery)(l);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,a,c,u):super.$provideFileSearchResults(_,a,l,u)}doInternalFileSearch(_,a,l,u){const c=w=>{if((0,D.isSerializedFileMatch)(w)&&(w=[w]),Array.isArray(w)){this._proxy.$handleFileMatch(_,a,w.map(s=>I.URI.file(s.path)));return}w.message&&this._logService.debug("ExtHostSearch",w.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,c,u)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,a){return new h.NativeTextSearchManager(_,a,void 0,"textSearchProvider")}};v=Be([Fe(0,S.IExtHostRpcService),Fe(1,k.IExtHostInitDataService),Fe(2,F.IURITransformerService),Fe(3,C.ILogService)],v),e.NativeExtHostSearch=v}),define(ve[140],we([1,0,297,127,60,22,15,3,6,9,12,33,104,105,298]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(E,P=""){this.debugLabel=P,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,C.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}traceSocketEvent(E,P){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(E){const P=L=>{this.traceSocketEvent("read",L),E(T.VSBuffer.wrap(L))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(E){const P=L=>{this.traceSocketEvent("close",{hadError:L}),E({type:0,hadError:L,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(E){const P=()=>{this.traceSocketEvent("nodeEndReceived"),E()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(E){if(!this.socket.destroyed)try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,C.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,C.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=h;var v;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var A;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(A||(A={}));class _ extends S.Disposable{constructor(E,P,L,O){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:L?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new a(this,P,L,O,this._onData,(y,H)=>this._write(y,H))),this._register(this._flowManager.onError(y=>{console.error(y),(0,C.onUnexpectedError)(y),this._onClose.fire({type:0,hadError:!0,error:y})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(y=>this._acceptChunk(y))),this._register(this.socket.onClose(y=>this._onClose.fire(y)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(E,P){this.socket.traceSocketEvent(E,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){this._flowManager.writeMessage(E)}_write(E,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let L=2;E.byteLength<126?L+=0:E.byteLength<2**16?L+=2:L+=8;const O=T.VSBuffer.alloc(L);if(P?O.writeUInt8(194,0):O.writeUInt8(130,0),E.byteLength<126)O.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){O.writeUInt8(126,1);let y=1;O.writeUInt8(E.byteLength>>>8&255,++y),O.writeUInt8(E.byteLength>>>0&255,++y)}else{O.writeUInt8(127,1);let y=1;O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(E.byteLength>>>24&255,++y),O.writeUInt8(E.byteLength>>>16&255,++y),O.writeUInt8(E.byteLength>>>8&255,++y),O.writeUInt8(E.byteLength>>>0&255,++y)}this.socket.write(T.VSBuffer.concat([O,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),L=P.readUInt8(0),O=(L&128)>>>7,y=(L&64)>>>6,H=P.readUInt8(1),M=(H&128)>>>7,j=H&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(y)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),L=P.readUInt8(1),O=(L&128)>>>7;let y=L&127,H=1;y===126?y=P.readUInt8(++H)*2**8+P.readUInt8(++H):y===127&&(y=P.readUInt8(++H)*0+P.readUInt8(++H)*0+P.readUInt8(++H)*0+P.readUInt8(++H)*0+P.readUInt8(++H)*2**24+P.readUInt8(++H)*2**16+P.readUInt8(++H)*2**8+P.readUInt8(++H));let M=0;O&&(M=P.readUInt8(++H)*2**24+P.readUInt8(++H)*2**16+P.readUInt8(++H)*2**8+P.readUInt8(++H)),this._state.state=3,this._state.readLen=y,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),c(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=_;class a extends S.Disposable{constructor(E,P,L,O,y,H){super();this._tracer=E,this._onData=y,this._writeFn=H,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new l(this._tracer,O,L,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(E){this._writeQueue.push(E),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const E=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,E);this._writeFn(P,!0)}else this._writeFn(E,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(E,P){return new Promise((L,O)=>{E.write(P),E.flush(y=>L(y))})}acceptFrame(E,P,L){this._readQueue.push({data:E,isCompressed:P,isLastFrameOfMessage:L}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const E=this._readQueue.shift();if(this._zlibInflateStream&&E.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,E.data,E.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(E.data)}this._isProcessingReadQueue=!1}}_inflateFrame(E,P,L){return new Promise((O,y)=>{E.write(P),L&&E.write(T.VSBuffer.fromByteArray([0,0,255,255])),E.flush(H=>O(H))})}}class l extends S.Disposable{constructor(E,P,L,O){super();this._tracer=E,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=g.createInflateRaw(O),this._zlibInflate.on("error",y=>{this._tracer.traceSocketEvent("zlibInflateError",{message:y?.message,code:y?.code}),this._onError.fire(y)}),this._zlibInflate.on("data",y=>{this._tracer.traceSocketEvent("zlibInflateData",y),this._pendingInflateData.push(T.VSBuffer.wrap(y))}),L&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(E){this._recordInflateBytes&&this._recordedInflateBytes.push(E.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",E),this._zlibInflate.write(E.buffer)}flush(E){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,E(P)})}}class u extends S.Disposable{constructor(E,P){super();this._tracer=E,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibDeflate.on("data",L=>{this._tracer.traceSocketEvent("zlibDeflateData",L),this._pendingDeflateData.push(T.VSBuffer.wrap(L))})}write(E){this._tracer.traceSocketEvent("zlibDeflateWrite",E.buffer),this._zlibDeflate.write(E.buffer)}flush(E){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),E(P)})}}function c(d,E){if(E===0)return;let P=d.byteLength>>>2;for(let j=0;j<P;j++){const Q=d.readUInt32BE(j*4);d.writeUInt32BE(Q^E,j*4)}let L=P*4,O=d.byteLength-L;const y=E>>>24&255,H=E>>>16&255,M=E>>>8&255;O>=1&&d.writeUInt8(d.readUInt8(L)^y,L),O>=2&&d.writeUInt8(d.readUInt8(L+1)^H,L+1),O>=3&&d.writeUInt8(d.readUInt8(L+2)^M,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const w={[2]:107,[1]:103};function s(){const d=(0,D.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let E;return e.XDG_RUNTIME_DIR?E=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):E=(0,R.join)((0,I.tmpdir)(),`vscode-ipc-${d}.sock`),r(E),E}e.createRandomIPCHandle=s;function n(d,E,P){const L=(0,f.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${P}-${E}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${P}-${E}.sock`):O=(0,R.join)(d,`${P}-${E}.sock`),r(O),O}e.createStaticIPCHandle=n;function r(d){const E=w[F.platform];typeof E=="number"&&d.length>=E&&console.warn(`WARNING: IPC handle "${d}" is longer than ${E} chars, try a shorter --user-data-dir`)}class i extends p.IPCServer{constructor(E){super(i.toClientConnectionEvent(E));this.server=E}static toClientConnectionEvent(E){const P=k.Event.fromNodeEventEmitter(E,"connection");return k.Event.map(P,L=>({protocol:new b.Protocol(new h(L,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function o(d){return new Promise((E,P)=>{const L=(0,t.createServer)();L.on("error",P),L.listen(d,()=>{L.removeListener("error",P),E(new i(L))})})}e.serve=o;function m(d,E){return new Promise((P,L)=>{const O=(0,t.createConnection)(d,()=>{O.removeListener("error",L),P(b.Client.fromSocket(new h(O,`ipc-client${E}`),E))});O.once("error",L)})}e.connect=m}),define(ve[288],we([1,0,140,283,59,39,2,11,43]),function(te,e,f,t,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class R{constructor(p,b,g){this._commands=p,this.logService=b,this._ipcHandlePath=g,this._server=t.createServer((h,v)=>this.onRequest(h,v)),this.setup().catch(h=>(b.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",p=>this.logService.error(p))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(p,b){const g=(v,A)=>{b.writeHead(v,{"content-type":"application/json"}),b.end(JSON.stringify(A),_=>_&&this.logService.error(_))},h=[];p.setEncoding("utf8"),p.on("data",v=>h.push(v)),p.on("end",async()=>{try{const v=JSON.parse(h.join(""));let A;switch(v.type){case"open":A=await this.open(v);break;case"openExternal":A=await this.openExternal(v);break;case"status":A=await this.getStatus(v);break;case"extensionManagement":A=await this.manageExtensions(v);break;default:g(404,`Unknown message type: ${v.type}`);break}g(200,A)}catch(v){const A=v instanceof Error?v.message:JSON.stringify(v);g(500,A),this.logService.error("Error while processing pipe request",v)}})}async open(p){const{fileURIs:b,folderURIs:g,forceNewWindow:h,diffMode:v,addMode:A,forceReuseWindow:_,gotoLineMode:a,waitMarkerFilePath:l,remoteAuthority:u}=p,c=[];if(Array.isArray(g))for(const r of g)try{c.push({folderUri:C.URI.parse(r)})}catch{}if(Array.isArray(b))for(const r of b)try{(0,S.hasWorkspaceFileExtension)(r)?c.push({workspaceUri:C.URI.parse(r)}):c.push({fileUri:C.URI.parse(r)})}catch{}const w=l?C.URI.file(l):void 0,n={forceNewWindow:h,diffMode:v,addMode:A,gotoLineMode:a,forceReuseWindow:_,preferNewWindow:!_&&!w&&!A,waitMarkerFileURI:w,remoteAuthority:u};return this._commands.executeCommand("_remoteCLI.windowOpen",c,n),""}async openExternal(p){for(const b of p.uris){const g=C.URI.parse(b),h=g.scheme==="file"?g:b;await this._commands.executeCommand("_remoteCLI.openExternal",h)}}async manageExtensions(p){const b=h=>h?.map(v=>/\.vsix$/i.test(v)?C.URI.parse(v):v),g={list:p.list,install:b(p.install),uninstall:b(p.uninstall),force:p.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",g)}async getStatus(p){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=R;let F=class extends R{constructor(p,b){super(p,b,(0,f.createRandomIPCHandle)())}};F=Be([Fe(0,T.IExtHostCommands),Fe(1,k.ILogService)],F),e.CLIServer=F}),define(ve[289],we([1,0,70,281,270,5,282,40,259,2,10,7,288,103]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class g extends I.RequireInterceptor{_installInterceptor(){const A=this,_=te.__$__nodeRequire("module"),a=_._load;_._load=function(w,s,n){return w=u(w),A._factories.has(w)?A._factories.get(w).load(w,R.URI.file((0,b.realpathSync)(s.filename)),r=>a.apply(this,[r,s,n])):a.apply(this,arguments)};const l=_._resolveLookupPaths;_._resolveLookupPaths=(c,w)=>l.call(this,u(c),w);const u=c=>{for(let w of A._alternatives){let s=w(c);if(s){c=s;break}}return c}}}class h extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(p.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(g,A,this._registry).install(),f.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const l=process.send,u=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...c)=>c.length===0||!c[0]||c[0].type!=="__$console"?l.apply(process,c):(u.$logExtensionHostMessage(c[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,_,a){if(_.scheme!==F.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let l=null;a.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{A&&f.mark(`code/extHost/willLoadExtensionCode/${A.value}`),l=te.__$__nodeRequire(_.fsPath)}catch(u){return Promise.reject(u)}finally{A&&f.mark(`code/extHost/didLoadExtensionCode/${A.value}`),a.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const _ in A){const a=A[_];a===null?delete process.env[_]:process.env[_]=a}}}e.ExtHostExtensionService=h}),define(ve[290],we([1,0,79,262,273,272,287,289,263,54,40,71,69,34,51,66,261,260,11]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(F.IExtHostExtensionService,k.ExtHostExtensionService),(0,f.registerSingleton)(_.ILoggerService,A.ExtHostLoggerService),(0,f.registerSingleton)(h.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,f.registerSingleton)(R.IExtHostDebugService,T.ExtHostDebugService),(0,f.registerSingleton)(D.IExtHostSearch,C.NativeExtHostSearch),(0,f.registerSingleton)(p.IExtHostTask,I.ExtHostTask),(0,f.registerSingleton)(b.IExtHostTerminalService,t.ExtHostTerminalService),(0,f.registerSingleton)(g.IExtHostTunnelService,S.ExtHostTunnelService)}),define(ve[299],we([1,0,127,300,70,15,105,140,191,132,271,22,28,103,16,113,206,274,290]),function(te,e,f,t,I,T,C,k,S,R,F,D,p,b,g,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const A=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const n=te.__$__nodeRequire("module"),r=n._load;n._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return r.apply(this,arguments)}})();const _=process.exit.bind(process);function a(n){process.exit=function(r){if(n)_(r);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let l=function(n){_()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,r)=>{let i=null,o=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,d=3e5,E=new g.ProcessTimeRunOnceScheduler(()=>l("renderer disconnected for too long (1)"),m),P=new g.ProcessTimeRunOnceScheduler(()=>l("renderer disconnected for too long (2)"),d);process.on("message",(O,y)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){y.setNoDelay(!0);const H=D.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let M;if(O.skipWebSocketFrames)M=new k.NodeSocket(y,"extHost-socket");else{const j=D.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));M=new k.WebSocketNodeSocket(new k.NodeSocket(y,"extHost-socket"),O.permessageDeflate,j,!1)}i?(E.cancel(),P.cancel(),i.beginAcceptReconnection(M,H),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(o),i=new C.PersistentProtocol(M,H),i.sendResume(),i.onDidDispose(()=>l("renderer disconnected")),n(i),i.onSocketClose(()=>{E.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(P.isScheduled())return;E.isScheduled()&&P.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,i)=>{const o=f.createConnection(n,()=>{o.removeListener("error",i),r(new C.PersistentProtocol(new k.NodeSocket(o,"extHost-renderer")))});o.once("error",i),o.on("close",()=>{l("renderer closed the socket")})})}}async function c(){const n=await u();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(r=>{(0,R.isMessageOfType)(r,2)?(this._terminating=!0,l("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||n.send(r)}drain(){return n.drain()}}}function w(n){return new Promise(r=>{const i=n.onMessage(o=>{i.dispose();const m=JSON.parse(o.toString()),d=m.commit,E=S.default.commit;d&&E&&d!==E&&_(55);let P=0;setInterval(function(){try{process.kill(m.parentPid,0),P=0}catch(O){O&&O.code==="EPERM"?(P++,P>=3&&l(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):l(`parent process ${m.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let L;try{L=te.__$__nodeRequire("native-watchdog"),L.start(m.parentPid)}catch(O){(0,T.onUnexpectedError)(O)}n.send((0,R.createMessageOfType)(0)),r({protocol:n,initData:m})});n.send((0,R.createMessageOfType)(1))})}async function s(){const n=[];process.on("unhandledRejection",(P,L)=>{n.push(L),setTimeout(()=>{const O=n.indexOf(L);O>=0&&L.catch(y=>{n.splice(O,1),(0,T.isCancellationError)(y)||(console.warn(`rejected promise not handled within 1 second: ${y}`),y&&y.stack&&console.warn(`stack trace: ${y.stack}`),P&&(0,T.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const L=n.indexOf(P);L>=0&&n.splice(L,1)}),process.on("uncaughtException",function(P){(0,T.onUnexpectedError)(P)}),I.mark("code/extHost/willConnectToRenderer");const r=await c();I.mark("code/extHost/didConnectToRenderer");const i=await w(r);I.mark("code/extHost/didWaitForInitData");const{initData:o}=i;a(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,o.environment.skipWorkspaceStorageLock=(0,h.boolean)(A.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(L){_(L)}exists(L){return p.Promises.exists(L)}realpath(L){return(0,b.realpath)(L)}};let d=null;o.remote.authority&&A.transformURIs&&(d=(0,v.createURITransformer)(o.remote.authority));const E=new F.ExtensionHostMain(i.protocol,o,m,d);l=P=>E.terminate(P)}e.startExtensionHostProcess=s,s().catch(n=>console.log(n))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d6ecda7ef2c306253594b196b18ab74caa6016cd/core/vs/workbench/api/node/extensionHostProcess.js.map
